
/****************************************************************************************************//**
 * @file     K1921BK01T.h
 *
 * @brief    CMSIS Cortex-M4 Peripheral Access Layer Header File for
 *           K1921BK01T from NIIET.
 *
 * @version  V1.0
 * @date     15. March 2016
 *
 * @note     Generated with SVDConv V2.85b 
 *           from CMSIS SVD File 'K1921BK01T.xml' Version 1.0,
 *
 * @par      ARM Limited (ARM) is supplying this software for use with Cortex-M
 *           processor based microcontroller, but can be equally used for other
 *           suitable processor architectures. This file can be freely distributed.
 *           Modifications to this file shall be clearly marked.
 *           
 *           THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 *           OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 *           MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 *           ARM SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
 *           CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER. 
 *
 *******************************************************************************************************/



/** @addtogroup NIIET
  * @{
  */

/** @addtogroup K1921BK01T
  * @{
  */

#ifndef K1921BK01T_H
#define K1921BK01T_H

#ifdef __cplusplus
extern "C" {
#endif


/* -------------------------  Interrupt Number Definition  ------------------------ */

typedef enum {
/* -------------------  Cortex-M4 Processor Exceptions Numbers  ------------------- */
  Reset_IRQn                    = -15,              /*!<   1  Reset Vector, invoked on Power up and warm reset                 */
  NonMaskableInt_IRQn           = -14,              /*!<   2  Non maskable Interrupt, cannot be stopped or preempted           */
  HardFault_IRQn                = -13,              /*!<   3  Hard Fault, all classes of Fault                                 */
  MemoryManagement_IRQn         = -12,              /*!<   4  Memory Management, MPU mismatch, including Access Violation
                                                         and No Match                                                          */
  BusFault_IRQn                 = -11,              /*!<   5  Bus Fault, Pre-Fetch-, Memory Access Fault, other address/memory
                                                         related Fault                                                         */
  UsageFault_IRQn               = -10,              /*!<   6  Usage Fault, i.e. Undef Instruction, Illegal State Transition    */
  SVCall_IRQn                   =  -5,              /*!<  11  System Service Call via SVC instruction                          */
  DebugMonitor_IRQn             =  -4,              /*!<  12  Debug Monitor                                                    */
  PendSV_IRQn                   =  -2,              /*!<  14  Pendable request for system service                              */
  SysTick_IRQn                  =  -1,              /*!<  15  System Tick Timer                                                */
/* --------------------  K1921BK01T Specific Interrupt Numbers  ------------------- */
  WWDG_IRQn                     =   0,              /*!<   0  WWDG                                                             */
  I2C0_IRQn                     =   1,              /*!<   1  I2C0                                                             */
  I2C1_IRQn                     =   2,              /*!<   2  I2C1                                                             */
  TIM0_IRQn                     =   3,              /*!<   3  TIM0                                                             */
  TIM1_IRQn                     =   4,              /*!<   4  TIM1                                                             */
  TIM2_IRQn                     =   5,              /*!<   5  TIM2                                                             */
  DMA_Stream0_IRQn              =   6,              /*!<   6  DMA_Stream0                                                      */
  DMA_Stream1_IRQn              =   7,              /*!<   7  DMA_Stream1                                                      */
  DMA_Stream2_IRQn              =   8,              /*!<   8  DMA_Stream2                                                      */
  DMA_Stream3_IRQn              =   9,              /*!<   9  DMA_Stream3                                                      */
  DMA_Stream4_IRQn              =  10,              /*!<  10  DMA_Stream4                                                      */
  DMA_Stream5_IRQn              =  11,              /*!<  11  DMA_Stream5                                                      */
  DMA_Stream6_IRQn              =  12,              /*!<  12  DMA_Stream6                                                      */
  DMA_Stream7_IRQn              =  13,              /*!<  13  DMA_Stream7                                                      */
  DMA_Stream8_IRQn              =  14,              /*!<  14  DMA_Stream8                                                      */
  DMA_Stream9_IRQn              =  15,              /*!<  15  DMA_Stream9                                                      */
  DMA_Stream10_IRQn             =  16,              /*!<  16  DMA_Stream10                                                     */
  DMA_Stream11_IRQn             =  17,              /*!<  17  DMA_Stream11                                                     */
  DMA_Stream12_IRQn             =  18,              /*!<  18  DMA_Stream12                                                     */
  DMA_Stream13_IRQn             =  19,              /*!<  19  DMA_Stream13                                                     */
  DMA_Stream14_IRQn             =  20,              /*!<  20  DMA_Stream14                                                     */
  DMA_Stream15_IRQn             =  21,              /*!<  21  DMA_Stream15                                                     */
  DMA_Stream16_IRQn             =  22,              /*!<  22  DMA_Stream16                                                     */
  DMA_Stream17_IRQn             =  23,              /*!<  23  DMA_Stream17                                                     */
  DMA_Stream18_IRQn             =  24,              /*!<  24  DMA_Stream18                                                     */
  DMA_Stream19_IRQn             =  25,              /*!<  25  DMA_Stream19                                                     */
  DMA_Stream20_IRQn             =  26,              /*!<  26  DMA_Stream20                                                     */
  DMA_Stream21_IRQn             =  27,              /*!<  27  DMA_Stream21                                                     */
  DMA_Stream22_IRQn             =  28,              /*!<  28  DMA_Stream22                                                     */
  DMA_Stream23_IRQn             =  29,              /*!<  29  DMA_Stream23                                                     */
  UART0_MX_IRQn                 =  30,              /*!<  30  UART0_MX                                                         */
  UART0_RX_IRQn                 =  31,              /*!<  31  UART0_RX                                                         */
  UART0_TX_IRQn                 =  32,              /*!<  32  UART0_TX                                                         */
  UART0_RT_IRQn                 =  33,              /*!<  33  UART0_RT                                                         */
  UART0_E_IRQn                  =  34,              /*!<  34  UART0_E                                                          */
  UART0_IRQn                    =  35,              /*!<  35  UART0                                                            */
  UART1_MX_IRQn                 =  36,              /*!<  36  UART1_MX                                                         */
  UART1_RX_IRQn                 =  37,              /*!<  37  UART1_RX                                                         */
  UART1_TX_IRQn                 =  38,              /*!<  38  UART1_TX                                                         */
  UART1_RT_IRQn                 =  39,              /*!<  39  UART1_RT                                                         */
  UART1_E_IRQn                  =  40,              /*!<  40  UART1_E                                                          */
  UART1_IRQn                    =  41,              /*!<  41  UART1                                                            */
  UART2_MX_IRQn                 =  42,              /*!<  42  UART2_MX                                                         */
  UART2_RX_IRQn                 =  43,              /*!<  43  UART2_RX                                                         */
  UART2_TX_IRQn                 =  44,              /*!<  44  UART2_TX                                                         */
  UART2_RT_IRQn                 =  45,              /*!<  45  UART2_RT                                                         */
  UART2_E_IRQn                  =  46,              /*!<  46  UART2_E                                                          */
  UART2_IRQn                    =  47,              /*!<  47  UART2                                                            */
  UART3_MX_IRQn                 =  48,              /*!<  48  UART3_MX                                                         */
  UART3_RX_IRQn                 =  49,              /*!<  49  UART3_RX                                                         */
  UART3_TX_IRQn                 =  50,              /*!<  50  UART3_TX                                                         */
  UART3_RT_IRQn                 =  51,              /*!<  51  UART3_RT                                                         */
  UART3_E_IRQn                  =  52,              /*!<  52  UART3_E                                                          */
  UART3_IRQn                    =  53,              /*!<  53  UART3                                                            */
  PWM0_IRQn                     =  54,              /*!<  54  PWM0                                                             */
  PWM0_HD_IRQn                  =  55,              /*!<  55  PWM0_HD                                                          */
  PWM0_TZ_IRQn                  =  56,              /*!<  56  PWM0_TZ                                                          */
  PWM1_IRQn                     =  57,              /*!<  57  PWM1                                                             */
  PWM1_HD_IRQn                  =  58,              /*!<  58  PWM1_HD                                                          */
  PWM1_TZ_IRQn                  =  59,              /*!<  59  PWM1_TZ                                                          */
  PWM2_IRQn                     =  60,              /*!<  60  PWM2                                                             */
  PWM2_HD_IRQn                  =  61,              /*!<  61  PWM2_HD                                                          */
  PWM2_TZ_IRQn                  =  62,              /*!<  62  PWM2_TZ                                                          */
  PWM3_IRQn                     =  63,              /*!<  63  PWM3                                                             */
  PWM3_HD_IRQn                  =  64,              /*!<  64  PWM3_HD                                                          */
  PWM3_TZ_IRQn                  =  65,              /*!<  65  PWM3_TZ                                                          */
  PWM4_IRQn                     =  66,              /*!<  66  PWM4                                                             */
  PWM4_HD_IRQn                  =  67,              /*!<  67  PWM4_HD                                                          */
  PWM4_TZ_IRQn                  =  68,              /*!<  68  PWM4_TZ                                                          */
  PWM5_IRQn                     =  69,              /*!<  69  PWM5                                                             */
  PWM5_HD_IRQn                  =  70,              /*!<  70  PWM5_HD                                                          */
  PWM5_TZ_IRQn                  =  71,              /*!<  71  PWM5_TZ                                                          */
  PWM6_IRQn                     =  72,              /*!<  72  PWM6                                                             */
  PWM6_HD_IRQn                  =  73,              /*!<  73  PWM6_HD                                                          */
  PWM6_TZ_IRQn                  =  74,              /*!<  74  PWM6_TZ                                                          */
  PWM7_IRQn                     =  75,              /*!<  75  PWM7                                                             */
  PWM7_HD_IRQn                  =  76,              /*!<  76  PWM7_HD                                                          */
  PWM7_TZ_IRQn                  =  77,              /*!<  77  PWM7_TZ                                                          */
  PWM8_IRQn                     =  78,              /*!<  78  PWM8                                                             */
  PWM8_HD_IRQn                  =  79,              /*!<  79  PWM8_HD                                                          */
  PWM8_TZ_IRQn                  =  80,              /*!<  80  PWM8_TZ                                                          */
  ADC_SEQ0_IRQn                 =  81,              /*!<  81  ADC_SEQ0                                                         */
  ADC_SEQ1_IRQn                 =  82,              /*!<  82  ADC_SEQ1                                                         */
  ADC_SEQ2_IRQn                 =  83,              /*!<  83  ADC_SEQ2                                                         */
  ADC_SEQ3_IRQn                 =  84,              /*!<  84  ADC_SEQ3                                                         */
  ADC_SEQ4_IRQn                 =  85,              /*!<  85  ADC_SEQ4                                                         */
  ADC_SEQ5_IRQn                 =  86,              /*!<  86  ADC_SEQ5                                                         */
  ADC_SEQ6_IRQn                 =  87,              /*!<  87  ADC_SEQ6                                                         */
  ADC_SEQ7_IRQn                 =  88,              /*!<  88  ADC_SEQ7                                                         */
  ADC_CompInt_IRQn              =  89,              /*!<  89  ADC_CompInt                                                      */
  CAP0_IRQn                     =  90,              /*!<  90  CAP0                                                             */
  CAP1_IRQn                     =  91,              /*!<  91  CAP1                                                             */
  CAP2_IRQn                     =  92,              /*!<  92  CAP2                                                             */
  CAP3_IRQn                     =  93,              /*!<  93  CAP3                                                             */
  CAP4_IRQn                     =  94,              /*!<  94  CAP4                                                             */
  CAP5_IRQn                     =  95,              /*!<  95  CAP5                                                             */
  QEP0_IRQn                     =  96,              /*!<  96  QEP0                                                             */
  QEP1_IRQn                     =  97,              /*!<  97  QEP1                                                             */
  BootFlash_IRQn                =  98,              /*!<  98  BootFlash                                                        */
  CMP0_IRQn                     =  99,              /*!<  99  CMP0                                                             */
  CMP1_IRQn                     = 100,              /*!< 100  CMP1                                                             */
  CMP2_IRQn                     = 101,              /*!< 101  CMP2                                                             */
  SPI0_IRQn                     = 102,              /*!< 102  SPI0                                                             */
  SPI1_IRQn                     = 103,              /*!< 103  SPI1                                                             */
  SPI2_IRQn                     = 104,              /*!< 104  SPI2                                                             */
  SPI3_IRQn                     = 105,              /*!< 105  SPI3                                                             */
  UserFlash_IRQn                = 106,              /*!< 106  UserFlash                                                        */
  GPIOA_IRQn                    = 107,              /*!< 107  GPIOA                                                            */
  GPIOB_IRQn                    = 108,              /*!< 108  GPIOB                                                            */
  GPIOC_IRQn                    = 109,              /*!< 109  GPIOC                                                            */
  GPIOD_IRQn                    = 110,              /*!< 110  GPIOD                                                            */
  GPIOE_IRQn                    = 111,              /*!< 111  GPIOE                                                            */
  GPIOF_IRQn                    = 112,              /*!< 112  GPIOF                                                            */
  GPIOG_IRQn                    = 113,              /*!< 113  GPIOG                                                            */
  GPIOH_IRQn                    = 114,              /*!< 114  GPIOH                                                            */
  Ethernet_IRQn                 = 115,              /*!< 115  Ethernet                                                         */
  CAN0_IRQn                     = 116,              /*!< 116  CAN0                                                             */
  CAN1_IRQn                     = 117,              /*!< 117  CAN1                                                             */
  CAN2_IRQn                     = 118,              /*!< 118  CAN2                                                             */
  CAN3_IRQn                     = 119,              /*!< 119  CAN3                                                             */
  CAN4_IRQn                     = 120,              /*!< 120  CAN4                                                             */
  CAN5_IRQn                     = 121,              /*!< 121  CAN5                                                             */
  CAN6_IRQn                     = 122,              /*!< 122  CAN6                                                             */
  CAN7_IRQn                     = 123,              /*!< 123  CAN7                                                             */
  CAN8_IRQn                     = 124,              /*!< 124  CAN8                                                             */
  CAN9_IRQn                     = 125,              /*!< 125  CAN9                                                             */
  CAN10_IRQn                    = 126,              /*!< 126  CAN10                                                            */
  CAN11_IRQn                    = 127,              /*!< 127  CAN11                                                            */
  CAN12_IRQn                    = 128,              /*!< 128  CAN12                                                            */
  CAN13_IRQn                    = 129,              /*!< 129  CAN13                                                            */
  CAN14_IRQn                    = 130,              /*!< 130  CAN14                                                            */
  CAN15_IRQn                    = 131,              /*!< 131  CAN15                                                            */
  RTC_IRQn                      = 132,              /*!< 132  RTC                                                              */
  USBOTG_IRQn                   = 133               /*!< 133  USBOTG                                                           */
} IRQn_Type;


/** @addtogroup Configuration_of_CMSIS
  * @{
  */


/* ================================================================================ */
/* ================      Processor and Core Peripheral Section     ================ */
/* ================================================================================ */

/* ----------------Configuration of the Cortex-M4 Processor and Core Peripherals---------------- */
#define __CM4_REV                 0x0001            /*!< Cortex-M4 Core Revision                                               */
#define __MPU_PRESENT                  1            /*!< MPU present or not                                                    */
#define __NVIC_PRIO_BITS               4            /*!< Number of Bits used for Priority Levels                               */
#define __Vendor_SysTickConfig         0            /*!< Set to 1 if different SysTick Config is used                          */
#define __FPU_PRESENT                  1            /*!< FPU present or not                                                    */
/** @} */ /* End of group Configuration_of_CMSIS */

#include "core_cm4.h"                               /*!< Cortex-M4 processor and core peripherals                              */
//#include "system_M4F1.h"                            /*!< K1921BK01T System                                                     */


/* ================================================================================ */
/* ================       Device Specific Peripheral Section       ================ */
/* ================================================================================ */


/** @addtogroup Device_Peripheral_Registers
  * @{
  */


/* -------------------  Start of section using anonymous unions  ------------------ */
#if defined(__CC_ARM)
  #pragma push
  #pragma anon_unions
#elif defined(__ICCARM__)
  #pragma language=extended
#elif defined(__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined(__TMS470__)
/* anonymous unions are enabled by default */
#elif defined(__TASKING__)
  #pragma warning 586
#else
  #warning Not supported compiler type
#endif


typedef struct {
  union {
    __IO uint32_t  MUX;                             /*!< Select register triggering events sequencer 0                         */
    
    struct {
      __IO uint32_t  CH0        :  1;               /*!< enable measure chn00                                                  */
      __IO uint32_t  CH1        :  1;               /*!< enable measure chn10                                                  */
      __IO uint32_t  CH2        :  1;               /*!< enable measure chn20                                                  */
      __IO uint32_t  CH3        :  1;               /*!< enable measure chn30                                                  */
      __IO uint32_t  CH4        :  1;               /*!< enable measure chn40                                                  */
      __IO uint32_t  CH5        :  1;               /*!< enable measure chn50                                                  */
      __IO uint32_t  CH6        :  1;               /*!< enable measure chn60                                                  */
      __IO uint32_t  CH7        :  1;               /*!< enable measure chn70                                                  */
      __IO uint32_t  CH8        :  1;               /*!< enable measure chn80                                                  */
      __IO uint32_t  CH9        :  1;               /*!< enable measure chn90                                                  */
      __IO uint32_t  CH10       :  1;               /*!< enable measure chn100                                                 */
      __IO uint32_t  CH11       :  1;               /*!< enable measure chn110                                                 */
      __IO uint32_t  CH12       :  1;               /*!< enable measure chn120                                                 */
      __IO uint32_t  CH13       :  1;               /*!< enable measure chn130                                                 */
      __IO uint32_t  CH14       :  1;               /*!< enable measure chn140                                                 */
      __IO uint32_t  CH15       :  1;               /*!< enable measure chn150                                                 */
      __IO uint32_t  CH16       :  1;               /*!< enable measure chn160                                                 */
      __IO uint32_t  CH17       :  1;               /*!< enable measure chn170                                                 */
      __IO uint32_t  CH18       :  1;               /*!< enable measure chn180                                                 */
      __IO uint32_t  CH19       :  1;               /*!< enable measure chn190                                                 */
      __IO uint32_t  CH20       :  1;               /*!< enable measure chn200                                                 */
      __IO uint32_t  CH21       :  1;               /*!< enable measure chn210                                                 */
      __IO uint32_t  CH22       :  1;               /*!< enable measure chn220                                                 */
      __IO uint32_t  CH23       :  1;               /*!< enable measure chn230                                                 */
    } MUX_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CTL;                             /*!< Register control0                                                     */
    
    struct {
      __IO uint32_t  RCNT       :  8;               /*!< Number restart seqensor ADC0                                          */
           uint32_t             :  8;
      __IO uint32_t  ICNT       :  8;               /*!< Cyclical generation interrupt0                                        */
      __IO uint32_t  WMARK      :  3;               /*!< number meas., writing in FIFO0                                        */
           uint32_t             :  1;
      __IO uint32_t  DMAEN      :  1;               /*!< Enable uses DMA0                                                      */
    } CTL_b;                                        /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED;
  
  union {
    __I  uint32_t  FSTAT;                           /*!< Register flags FIFO overflow0                                         */
    
    struct {
      __I  uint32_t  FLOAD      :  6;               /*!< Value of count FIFO sequencer 0                                       */
    } FSTAT_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  OP;                              /*!< Register flags measurements0                                          */
    
    struct {
      __I  uint32_t  RCNT       :  8;               /*!< Number realize measuring by sequencer 0                               */
           uint32_t             :  8;
      __IO uint32_t  ICNT       :  8;               /*!< Value interrupt count 0                                               */
    } OP_b;                                         /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DCP;                             /*!< Register selection of comparator0                                     */
    
    struct {
      __IO uint32_t  CMP0       :  1;               /*!< enable cmp10                                                          */
      __IO uint32_t  CMP1       :  1;               /*!< enable cmp10                                                          */
      __IO uint32_t  CMP2       :  1;               /*!< enable cmp20                                                          */
      __IO uint32_t  CMP3       :  1;               /*!< enable cmp30                                                          */
      __IO uint32_t  CMP4       :  1;               /*!< enable cmp40                                                          */
      __IO uint32_t  CMP5       :  1;               /*!< enable cmp50                                                          */
      __IO uint32_t  CMP6       :  1;               /*!< enable cmp60                                                          */
      __IO uint32_t  CMP7       :  1;               /*!< enable cmp70                                                          */
      __IO uint32_t  CMP8       :  1;               /*!< enable cmp80                                                          */
      __IO uint32_t  CMP9       :  1;               /*!< enable cmp90                                                          */
      __IO uint32_t  CMP10      :  1;               /*!< enable cmp100                                                         */
      __IO uint32_t  CMP11      :  1;               /*!< enable cmp110                                                         */
      __IO uint32_t  CMP12      :  1;               /*!< enable cmp120                                                         */
      __IO uint32_t  CMP13      :  1;               /*!< enable cmp130                                                         */
      __IO uint32_t  CMP14      :  1;               /*!< enable cmp140                                                         */
      __IO uint32_t  CMP15      :  1;               /*!< enable cmp150                                                         */
      __IO uint32_t  CMP16      :  1;               /*!< enable cmp160                                                         */
      __IO uint32_t  CMP17      :  1;               /*!< enable cmp170                                                         */
      __IO uint32_t  CMP18      :  1;               /*!< enable cmp180                                                         */
      __IO uint32_t  CMP19      :  1;               /*!< enable cmp190                                                         */
      __IO uint32_t  CMP20      :  1;               /*!< enable cmp200                                                         */
      __IO uint32_t  CMP21      :  1;               /*!< enable cmp210                                                         */
      __IO uint32_t  CMP22      :  1;               /*!< enable cmp220                                                         */
      __IO uint32_t  CMP23      :  1;               /*!< enable cmp230                                                         */
    } DCP_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  TMR;                             /*!< Register restart timer sequencer modules ADC0                         */
    
    struct {
      __IO uint32_t  TMR        : 24;               /*!< Maximum value of the timer counter restarts sequencer modules
                                                         ADC0                                                                  */
    } TMR_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  FIFO;                            /*!< Register FIFO result of seqensor0                                     */
    
    struct {
      __I  uint32_t  DATA       : 16;               /*!< Value of AD conversion0                                               */
    } FIFO_b;                                       /*!< BitSize                                                               */
  };
} NT_ADC_SEQ_Type;

typedef struct {
  union {
    __IO uint32_t  DCCTL;                           /*!< Register control comparator 0                                         */
    
    struct {
      __IO uint32_t  CIM        :  2;               /*!< 0                                                                     */
      __IO uint32_t  CIC        :  2;               /*!< 0                                                                     */
      __IO uint32_t  CIE        :  1;               /*!< Enable generating measurement interrupt channel0                      */
           uint32_t             :  3;
      __IO uint32_t  CTM        :  2;               /*!< 0                                                                     */
      __IO uint32_t  CTC        :  2;               /*!< 0                                                                     */
      __IO uint32_t  CTE        :  1;               /*!< Start trigger0                                                        */
           uint32_t             :  3;
      __IO uint32_t  CHNL       :  5;               /*!< 0                                                                     */
    } DCCTL_b;                                      /*!< BitSize                                                               */
  };
} NT_ADC_DCCTL_Type;

typedef struct {
  union {
    __IO uint32_t  DCCMP;                           /*!< Register range comparator0                                            */
    
    struct {
      __IO uint32_t  COMP0      : 12;               /*!< lower range0                                                          */
           uint32_t             :  4;
      __IO uint32_t  COMP1      : 12;               /*!< upper range 0                                                         */
    } DCCMP_b;                                      /*!< BitSize                                                               */
  };
} NT_ADC_DCCMP_Type;

typedef struct {
  union {
    __I  uint32_t  DCVAL;                           /*!< Register measurement comparator0                                      */
    
    struct {
      __I  uint32_t  VAL        : 12;               /*!< Last measurement that was used in the comparison0                     */
    } DCVAL_b;                                      /*!< BitSize                                                               */
  };
} NT_ADC_DCVAL_Type;

typedef struct {
  union {
    __IO uint32_t  PP;                              /*!< Register ADC settings0                                                */
    
    struct {
           uint32_t             : 16;
      __IO uint32_t  OM         :  8;               /*!< Mode ADC0                                                             */
           uint32_t             :  7;
      __IO uint32_t  ENA        :  1;               /*!< Enable ADC0                                                           */
    } PP_b;                                         /*!< BitSize                                                               */
  };
} NT_ADC_PP_Type;

typedef struct {
  union {
    __IO uint32_t  MASKLOWBYTE;                     /*!< Mask register low byte of port0                                       */
    
    struct {
      __IO uint32_t  MASKLB     :  8;               /*!< 0                                                                     */
    } MASKLOWBYTE_b;                                /*!< BitSize                                                               */
  };
} NT_GPIOA_MASKLOWBYTE_Type;

typedef struct {
  union {
    __IO uint32_t  MASKHIGHBYTE;                    /*!< Mask register High byte of port0                                      */
    
    struct {
           uint32_t             :  8;
      __IO uint32_t  MASKHB     :  8;               /*!< Mask high byte0                                                       */
    } MASKHIGHBYTE_b;                               /*!< BitSize                                                               */
  };
} NT_GPIOA_MASKHIGHBYTE_Type;

typedef struct {
  union {
    __I  uint32_t  LIST;                            /*!< Register list0                                                        */
    
    struct {
      __I  uint32_t  BEGIN      :  8;               /*!< 0                                                                     */
      __I  uint32_t  END        :  8;               /*!< 0                                                                     */
      __I  uint32_t  SIZE       :  8;               /*!< List size0                                                            */
      __I  uint32_t  EMPTY      :  1;               /*!< Indicate empty list0                                                  */
    } LIST_b;                                       /*!< BitSize                                                               */
  };
} NT_CAN_LIST_Type;

typedef struct {
  union {
    __IO uint32_t  MSPND;                           /*!< Register waiting interrupts0                                          */
    
    struct {
      __IO uint32_t  PND        : 32;               /*!< 0                                                                     */
    } MSPND_b;                                      /*!< BitSize                                                               */
  };
} NT_CAN_MSPND_Type;

typedef struct {
  union {
    __I  uint32_t  MSID;                            /*!< Register messages index0                                              */
    
    struct {
      __I  uint32_t  INDEX      :  8;               /*!< 0                                                                     */
    } MSID_b;                                       /*!< BitSize                                                               */
  };
} NT_CAN_MSID_Type;

typedef struct {
  union {
    __IO uint32_t  NCR;                             /*!< Register control node0                                                */
    
    struct {
      __IO uint32_t  INIT       :  1;               /*!< Node initialization0                                                  */
      __IO uint32_t  TRIE       :  1;               /*!< Interrupt enable bit of the assembly at the end of the transmission
                                                         / reception0                                                          */
      __IO uint32_t  LECIE      :  1;               /*!< Interrupt enable bit of the assembly when it detects the last
                                                         error code0                                                           */
      __IO uint32_t  ALIE       :  1;               /*!< Enable interrupt ALERT from node0                                     */
      __IO uint32_t  CANDIS     :  1;               /*!< Off node0                                                             */
           uint32_t             :  1;
      __IO uint32_t  CCE        :  1;               /*!< Permission node configuration changes0                                */
      __IO uint32_t  CALM       :  1;               /*!< Activate the node analysis0                                           */
      __IO uint32_t  SUSEN      :  1;               /*!< Enable mode suspension of the node0                                   */
    } NCR_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  NSR;                             /*!< Register state node0                                                  */
    
    struct {
      __IO uint32_t  LEC        :  3;               /*!< 0                                                                     */
      __IO uint32_t  TXOK       :  1;               /*!< Flag successful message transmission0                                 */
      __IO uint32_t  RXOK       :  1;               /*!< Flag successful reception of messages0                                */
      __IO uint32_t  ALERT      :  1;               /*!< Warning flag ALERT0                                                   */
      __I  uint32_t  EWRN       :  1;               /*!< Flag critical errors0                                                 */
      __I  uint32_t  BOFF       :  1;               /*!< Status flag 'is disconnected from the bus'0                           */
      __IO uint32_t  LLE        :  1;               /*!< Error flag list0                                                      */
      __IO uint32_t  LOE        :  1;               /*!< Error Flag Room list0                                                 */
      __I  uint32_t  SUSACK     :  1;               /*!< Indicator cluster node suspend mode0                                  */
    } NSR_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  NIPR;                            /*!< Interrupt pointer register node0                                      */
    
    struct {
      __IO uint32_t  ALINP      :  4;               /*!< 0                                                                     */
      __IO uint32_t  LECINP     :  4;               /*!< 0                                                                     */
      __IO uint32_t  TRINP      :  4;               /*!< 0                                                                     */
      __IO uint32_t  CFCINP     :  4;               /*!< 0                                                                     */
    } NIPR_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  NPCR;                            /*!< Port control register node0                                           */
    
    struct {
      __IO uint32_t  RXSEL      :  3;               /*!< 0                                                                     */
           uint32_t             :  5;
      __IO uint32_t  LBM        :  1;               /*!< Enable mode Loop-Back0                                                */
    } NPCR_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  NBTR;                            /*!< Timing register bits 0                                                */
    
    struct {
      __IO uint32_t  BRP        :  6;               /*!< 0                                                                     */
      __IO uint32_t  SJW        :  2;               /*!< 0                                                                     */
      __IO uint32_t  TSEG1      :  4;               /*!< 0                                                                     */
      __IO uint32_t  TSEG2      :  3;               /*!< 0                                                                     */
      __IO uint32_t  DIV8       :  1;               /*!< Frequency divider by 80                                               */
    } NBTR_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  NECNT;                           /*!< Counter error register node0                                          */
    
    struct {
      __IO uint32_t  REC        :  8;               /*!< 0                                                                     */
      __IO uint32_t  TEC        :  8;               /*!< 0                                                                     */
      __IO uint32_t  EWRNLVL    :  8;               /*!< 0                                                                     */
      __I  uint32_t  LETD       :  1;               /*!< Flag last transmission errors0                                        */
      __I  uint32_t  LEINC      :  1;               /*!< Indicator increment at the last error0                                */
    } NECNT_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  NFCR;                            /*!< Register message counter node0                                        */
    
    struct {
      __IO uint32_t  CFC        : 16;               /*!< 0                                                                     */
      __IO uint32_t  CFSEL      :  3;               /*!< 0                                                                     */
      __IO uint32_t  CFMOD      :  2;               /*!< 0                                                                     */
           uint32_t             :  1;
      __IO uint32_t  CFCIE      :  1;               /*!< Interrupt enable bit of the message counter0                          */
      __IO uint32_t  CFCOV      :  1;               /*!< Counter overflow flag messages0                                       */
    } NFCR_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED1[57];
} NT_CAN_CAN_Node_Type;

typedef struct {
  union {
    __IO uint32_t  MOFCR;                           /*!< Register control the operation of the message object 0                */
    
    struct {
      __IO uint32_t  MMC        :  4;               /*!< 0                                                                     */
           uint32_t             :  4;
      __IO uint32_t  GDFS       :  1;               /*!< 0                                                                     */
      __IO uint32_t  IDC        :  1;               /*!< 0                                                                     */
      __IO uint32_t  DLCC       :  1;               /*!< 0                                                                     */
      __IO uint32_t  DATC       :  1;               /*!< 0                                                                     */
           uint32_t             :  4;
      __IO uint32_t  RXIE       :  1;               /*!< Interrupt enable after taking the messages0                           */
      __IO uint32_t  TXIE       :  1;               /*!< Interrupt enable at the end of the message0                           */
      __IO uint32_t  OVIE       :  1;               /*!< Interrupt enable FIFO to fill the message object 0                    */
           uint32_t             :  1;
      __IO uint32_t  FRREN      :  1;               /*!< Enable remote request0                                                */
      __IO uint32_t  RMM        :  1;               /*!< Enable remote monitoring of the communication object0                 */
      __IO uint32_t  SDT        :  1;               /*!< Bit single of the message object 0 participation in shipment          */
      __IO uint32_t  STT        :  1;               /*!< Bit single data transfer0                                             */
      __IO uint32_t  DLC        :  4;               /*!< 0                                                                     */
    } MOFCR_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MOFGPR;                          /*!< Pointer register FIFO / gateway message object 0                      */
    
    struct {
      __IO uint32_t  BOT        :  8;               /*!< 0                                                                     */
      __IO uint32_t  TOP        :  8;               /*!< 0                                                                     */
      __IO uint32_t  CUR        :  8;               /*!< 0                                                                     */
      __IO uint32_t  SEL        :  8;               /*!< 0                                                                     */
    } MOFGPR_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MOIPR;                           /*!< Pointer register interrupt message object 0                           */
    
    struct {
      __IO uint32_t  RXINP      :  4;               /*!< 0                                                                     */
      __IO uint32_t  TXINP      :  4;               /*!< 0                                                                     */
      __IO uint32_t  MPN        :  8;               /*!< 0                                                                     */
      __IO uint32_t  CFCVAL     : 16;               /*!< 0                                                                     */
    } MOIPR_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MOAMR;                           /*!< Mask register message object 0                                        */
    
    struct {
      __IO uint32_t  AM         : 29;               /*!< 0                                                                     */
      __IO uint32_t  MIDE       :  1;               /*!< Mask bit IDE message0                                                 */
    } MOAMR_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MODATAL;                         /*!< Low data registers of the message object 0                            */
    
    struct {
      __IO uint32_t  DB0        :  8;               /*!< 0                                                                     */
      __IO uint32_t  DB1        :  8;               /*!< 0                                                                     */
      __IO uint32_t  DB2        :  8;               /*!< 0                                                                     */
      __IO uint32_t  DB3        :  8;               /*!< 0                                                                     */
    } MODATAL_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MODATAH;                         /*!< High data registers of the message object 0                           */
    
    struct {
      __IO uint32_t  DB4        :  8;               /*!< 0                                                                     */
      __IO uint32_t  DB5        :  8;               /*!< 0                                                                     */
      __IO uint32_t  DB6        :  8;               /*!< 0                                                                     */
      __IO uint32_t  DB7        :  8;               /*!< 0                                                                     */
    } MODATAH_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MOAR;                            /*!< Register arbitration message object 0                                 */
    
    struct {
      __IO uint32_t  ID         : 29;               /*!< 0                                                                     */
      __IO uint32_t  IDE        :  1;               /*!< Bit extension identifier of the message object 0                      */
      __IO uint32_t  PRI        :  2;               /*!< 0                                                                     */
    } MOAR_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  MOCTR;                           /*!< Control register Message object 0                                     */
    
    struct {
      __O  uint32_t  RESRXPND   :  1;               /*!< Reset bit RXPND0                                                      */
      __O  uint32_t  RESTXPND   :  1;               /*!< Reset bit TXPND0                                                      */
      __O  uint32_t  RESRXUPD   :  1;               /*!< Reset bit RXUPD0                                                      */
      __O  uint32_t  RESNEWDAT  :  1;               /*!< Reset bit NEWDAT0                                                     */
      __O  uint32_t  RESMSGLST  :  1;               /*!< Reset bit MSGLST0                                                     */
      __O  uint32_t  RESMSGVAL  :  1;               /*!< Reset bit MSGVAL0                                                     */
      __O  uint32_t  RESRTSEL   :  1;               /*!< Reset bit RTSEL0                                                      */
      __O  uint32_t  RESRXEN    :  1;               /*!< Reset bit RXEN0                                                       */
      __O  uint32_t  RESTXRQ    :  1;               /*!< Reset bit TXRQ0                                                       */
      __O  uint32_t  RESTXEN0   :  1;               /*!< Reset bit TXEN00                                                      */
      __O  uint32_t  RESTXEN1   :  1;               /*!< Reset bit TXEN10                                                      */
      __O  uint32_t  RESDIR     :  1;               /*!< Reset bit DIR0                                                        */
           uint32_t             :  4;
      __O  uint32_t  SETRXPND   :  1;               /*!< Set bit RXPND0                                                        */
      __O  uint32_t  SETTXPND   :  1;               /*!< Set bit TXPND0                                                        */
      __O  uint32_t  SETRXUPD   :  1;               /*!< Set bit RXUPD0                                                        */
      __O  uint32_t  SETNEWDAT  :  1;               /*!< Set bit NEWDAT0                                                       */
      __O  uint32_t  SETMSGLST  :  1;               /*!< Set bit MSGLST0                                                       */
      __O  uint32_t  SETMSGVAL  :  1;               /*!< Set bit MSGVAL0                                                       */
      __O  uint32_t  SETRTSEL   :  1;               /*!< Set bit RTSEL0                                                        */
      __O  uint32_t  SETRXEN    :  1;               /*!< Set bit RXEN0                                                         */
      __O  uint32_t  SETTXRQ    :  1;               /*!< Set bit TXRQ0                                                         */
      __O  uint32_t  SETTXEN0   :  1;               /*!< Set bit TXEN00                                                        */
      __O  uint32_t  SETTXEN1   :  1;               /*!< Set bit TXEN10                                                        */
      __O  uint32_t  SETDIR     :  1;               /*!< Set bit DIR0                                                          */
    } MOCTR_b;                                      /*!< BitSize                                                               */
  };
} NT_CAN_CAN_Msg_Type;

typedef struct {
  union {
    __IO uint32_t  DATA_BUF;                        /*!< EndPoint Data Register0                                               */
    
    struct {
      __IO uint32_t  DATA       : 16;               /*!< 0                                                                     */
    } DATA_BUF_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  IRQ_STAT;                        /*!< Interrupt flag register no control buffer0                            */
    
    struct {
      __I  uint32_t  BUFFFULLINT:  1;               /*!< Flag buffer fill0                                                     */
      __I  uint32_t  BUFFEMPTYINT:  1;              /*!< Buffer empty flag0                                                    */
      __IO uint32_t  SHORTPKTTRINT:  1;             /*!< Flag size of the last packet0                                         */
      __IO uint32_t  DATAPKTTRINT:  1;              /*!< Flag to send a data packet from the buffer to the host0               */
      __IO uint32_t  DATAPKTRECINT:  1;             /*!< Flag successful reception of a data packet from a host0               */
      __IO uint32_t  OUTTOKENINT:  1;               /*!< Receiving flag tags OUT from the host0                                */
      __IO uint32_t  INTOKENINT :  1;               /*!< Receiving flag tags IN from the host0                                 */
      __IO uint32_t  PINGTOKENINT:  1;              /*!< Receiving flag tags PING from the host0                               */
      __IO uint32_t  NACKSENTINT:  1;               /*!< Flag unsent last packet0                                              */
      __IO uint32_t  STALLSENTINT:  1;              /*!< Flag Uncommitted last packet0                                         */
      __IO uint32_t  NYETSENTINT:  1;               /*!< Flag lack of free memory to receive the next data packet0             */
      __IO uint32_t  ERRSENTINT :  1;               /*!< Flag of any error during the operation0                               */
    } IRQ_STAT_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  IRQ_ENB;                         /*!< Enable register Interrupt no control buffer0                          */
    
    struct {
      __IO uint32_t  BUFFFULLINTEN:  1;             /*!< Enable flag buffer fill0                                              */
      __IO uint32_t  BUFFEMPTYINTEN:  1;            /*!< Enable buffer empty flag0                                             */
      __IO uint32_t  SHORTPKTTRINTEN:  1;           /*!< Enable flag size of the last packet0                                  */
      __IO uint32_t  DATAPKTTRINTEN:  1;            /*!< Enable flag to send a data packet from the buffer to the host0        */
      __IO uint32_t  DATAPKTRECINTEN:  1;           /*!< Enable flag successful reception of a data packet from a host0        */
      __IO uint32_t  OUTTOKENINTEN:  1;             /*!< Enable receiving flag tags OUT from the host0                         */
      __IO uint32_t  INTOKENINTEN:  1;              /*!< Enable receiving flag tags IN from the host0                          */
      __IO uint32_t  PINGTOKENINTEN:  1;            /*!< Enable receiving flag tags PING from the host0                        */
      __IO uint32_t  NACKSENTINTEN:  1;             /*!< Enable flag unsent last packet0                                       */
      __IO uint32_t  STALLSENTINTEN:  1;            /*!< Enable flag Uncommitted last packet0                                  */
      __IO uint32_t  NYETSENTINTEN:  1;             /*!< Enable flag lack of free memory to receive the next data packet0      */
      __IO uint32_t  ERRSENTINTEN:  1;              /*!< Enable flag of any error during the operation0                        */
    } IRQ_ENB_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  AVAIL_CNT;                       /*!< EndPoint Available count register0                                    */
    
    struct {
      __I  uint32_t  BUFFBYTENUM: 12;               /*!< Number of bytes in the buffer0                                        */
    } AVAIL_CNT_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  RSP_SC;                          /*!< EndPoint Response Set/Clear register0                                 */
    
    struct {
      __IO uint32_t  BUFFFLUSH  :  1;               /*!< Reset bit in the buffer and register EP_AVAIL_CNT0                    */
      __IO uint32_t  MODE       :  2;               /*!< 0                                                                     */
      __IO uint32_t  ENDPOINTTOGGL:  1;             /*!< Control bit by bit DATATOGGLE0                                        */
      __IO uint32_t  ENDPOINTHALT:  1;              /*!< Select bit answer to any label from the host0                         */
      __IO uint32_t  ZEROLENIN  :  1;               /*!< Select bit answer to mark IN0                                         */
      __IO uint32_t  PKTEND     :  1;               /*!< Indicator number of bytes0                                            */
    } RSP_SC_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MPS;                             /*!< EndPoint maximum packet size register0                                */
    
    struct {
      __IO uint32_t  MAXPKTSIZE : 16;               /*!< 0                                                                     */
    } MPS_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CNT;                             /*!< EndPoint Transfer count register0                                     */
    
    struct {
      __IO uint32_t  EP_TFR_CNT :  8;               /*!< 0                                                                     */
    } CNT_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  USB_EP_CFG;                      /*!< EndPoint configuration register0                                      */
    
    struct {
      __IO uint32_t  EP_VALID   :  1;               /*!< Resolution of buffer0                                                 */
      __IO uint32_t  EP_TYPE    :  2;               /*!< 0                                                                     */
      __IO uint32_t  EP_DIR     :  1;               /*!< Field of type (direction) buffer0                                     */
      __IO uint32_t  EP_NUM     :  4;               /*!< Number field buffer0                                                  */
      __IO uint32_t  MULT       :  2;               /*!< 0                                                                     */
    } USB_EP_CFG_b;                                 /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  START_ADDR;                      /*!< EndPoint RAM start addres register0                                   */
    
    struct {
      __IO uint32_t  STARTADDR  : 16;               /*!< 0                                                                     */
    } START_ADDR_b;                                 /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  END_ADDR;                        /*!< EndPoint RAM end addres register0                                     */
    
    struct {
      __IO uint32_t  ENDADDR    : 16;               /*!< 0                                                                     */
    } END_ADDR_b;                                   /*!< BitSize                                                               */
  };
} NT_USBDevice_USB_EP_Type;


/* ================================================================================ */
/* ================                     NT_ADC                     ================ */
/* ================================================================================ */


/**
  * @brief ADC controller registers (NT_ADC)
  */

typedef struct {                                    /*!< NT_ADC Structure                                                      */
  
  union {
    __IO uint32_t  ACTSS;                           /*!< Configuration secvensors register                                     */
    
    struct {
      __IO uint32_t  ASEN0      :  1;               /*!< enable secvensor 0                                                    */
      __IO uint32_t  ASEN1      :  1;               /*!< enable secvensor 1                                                    */
      __IO uint32_t  ASEN2      :  1;               /*!< enable secvensor 2                                                    */
      __IO uint32_t  ASEN3      :  1;               /*!< enable secvensor 3                                                    */
      __IO uint32_t  ASEN4      :  1;               /*!< enable secvensor 4                                                    */
      __IO uint32_t  ASEN5      :  1;               /*!< enable secvensor 5                                                    */
      __IO uint32_t  ASEN6      :  1;               /*!< enable secvensor 6                                                    */
      __IO uint32_t  ASEN7      :  1;               /*!< enable secvensor 7                                                    */
    } ACTSS_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  RIS;                             /*!< Register unmasked interrupt                                           */
    
    struct {
      __I  uint32_t  INR0       :  1;               /*!< ADC complete msr                                                      */
      __I  uint32_t  INR1       :  1;               /*!< ADC complete msr                                                      */
      __I  uint32_t  INR2       :  1;               /*!< ADC complete msr                                                      */
      __I  uint32_t  INR3       :  1;               /*!< ADC complete msr                                                      */
      __I  uint32_t  INR4       :  1;               /*!< ADC complete msr                                                      */
      __I  uint32_t  INR5       :  1;               /*!< ADC complete msr                                                      */
      __I  uint32_t  INR6       :  1;               /*!< ADC complete msr                                                      */
      __I  uint32_t  INR7       :  1;               /*!< ADC complete msr                                                      */
      __I  uint32_t  INRDC0     :  1;               /*!< Received interrupt from CMP 0                                         */
      __I  uint32_t  INRDC1     :  1;               /*!< Received interrupt from CMP 1                                         */
      __I  uint32_t  INRDC2     :  1;               /*!< Received interrupt from CMP 2                                         */
      __I  uint32_t  INRDC3     :  1;               /*!< Received interrupt from CMP 3                                         */
      __I  uint32_t  INRDC4     :  1;               /*!< Received interrupt from CMP 4                                         */
      __I  uint32_t  INRDC5     :  1;               /*!< Received interrupt from CMP 5                                         */
      __I  uint32_t  INRDC6     :  1;               /*!< Received interrupt from CMP 6                                         */
      __I  uint32_t  INRDC7     :  1;               /*!< Received interrupt from CMP 7                                         */
      __I  uint32_t  INRDC8     :  1;               /*!< Received interrupt from CMP 8                                         */
      __I  uint32_t  INRDC9     :  1;               /*!< Received interrupt from CMP 9                                         */
      __I  uint32_t  INRDC10    :  1;               /*!< Received interrupt from CMP 10                                        */
      __I  uint32_t  INRDC11    :  1;               /*!< Received interrupt from CMP 11                                        */
      __I  uint32_t  INRDC12    :  1;               /*!< Received interrupt from CMP 12                                        */
      __I  uint32_t  INRDC13    :  1;               /*!< Received interrupt from CMP 13                                        */
      __I  uint32_t  INRDC14    :  1;               /*!< Received interrupt from CMP 14                                        */
      __I  uint32_t  INRDC15    :  1;               /*!< Received interrupt from CMP 15                                        */
      __I  uint32_t  INRDC16    :  1;               /*!< Received interrupt from CMP 16                                        */
      __I  uint32_t  INRDC17    :  1;               /*!< Received interrupt from CMP 17                                        */
      __I  uint32_t  INRDC18    :  1;               /*!< Received interrupt from CMP 18                                        */
      __I  uint32_t  INRDC19    :  1;               /*!< Received interrupt from CMP 19                                        */
      __I  uint32_t  INRDC20    :  1;               /*!< Received interrupt from CMP 20                                        */
      __I  uint32_t  INRDC21    :  1;               /*!< Received interrupt from CMP 21                                        */
      __I  uint32_t  INRDC22    :  1;               /*!< Received interrupt from CMP 22                                        */
      __I  uint32_t  INRDC23    :  1;               /*!< Received interrupt from CMP 23                                        */
    } RIS_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  IM;                              /*!< Register mask interrupt                                               */
    
    struct {
      __IO uint32_t  MASK0      :  1;               /*!< Enable transmission interrupt line IS0                                */
      __IO uint32_t  MASK1      :  1;               /*!< Enable transmission interrupt line IS1                                */
      __IO uint32_t  MASK2      :  1;               /*!< Enable transmission interrupt line IS2                                */
      __IO uint32_t  MASK3      :  1;               /*!< Enable transmission interrupt line IS3                                */
      __IO uint32_t  MASK4      :  1;               /*!< Enable transmission interrupt line IS4                                */
      __IO uint32_t  MASK5      :  1;               /*!< Enable transmission interrupt line IS5                                */
      __IO uint32_t  MASK6      :  1;               /*!< Enable transmission interrupt line IS6                                */
      __IO uint32_t  MASK7      :  1;               /*!< Enable transmission interrupt line IS7                                */
      __IO uint32_t  MIDC0      :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC0              */
      __IO uint32_t  MIDC1      :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC1              */
      __IO uint32_t  MIDC2      :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC2              */
      __IO uint32_t  MIDC3      :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC3              */
      __IO uint32_t  MIDC4      :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC4              */
      __IO uint32_t  MIDC5      :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC5              */
      __IO uint32_t  MIDC6      :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC6              */
      __IO uint32_t  MIDC7      :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC7              */
      __IO uint32_t  MIDC8      :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC8              */
      __IO uint32_t  MIDC9      :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC9              */
      __IO uint32_t  MIDC10     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC10             */
      __IO uint32_t  MIDC11     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC11             */
      __IO uint32_t  MIDC12     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC12             */
      __IO uint32_t  MIDC13     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC13             */
      __IO uint32_t  MIDC14     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC14             */
      __IO uint32_t  MIDC15     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC15             */
      __IO uint32_t  MIDC16     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC16             */
      __IO uint32_t  MIDC17     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC17             */
      __IO uint32_t  MIDC18     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC18             */
      __IO uint32_t  MIDC19     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC19             */
      __IO uint32_t  MIDC20     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC20             */
      __IO uint32_t  MIDC21     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC21             */
      __IO uint32_t  MIDC22     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC22             */
      __IO uint32_t  MIDC23     :  1;               /*!< Transmit to controller by line IDC flag interrupt INRDC23             */
    } IM_b;                                         /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ISC;                             /*!< Register reset interrupt                                              */
    
    struct {
      __IO uint32_t  IN0        :  1;               /*!< Status Indicator flag don`t reset interrupt INR0                      */
      __IO uint32_t  IN1        :  1;               /*!< Status Indicator flag don`t reset interrupt INR1                      */
      __IO uint32_t  IN2        :  1;               /*!< Status Indicator flag don`t reset interrupt INR2                      */
      __IO uint32_t  IN3        :  1;               /*!< Status Indicator flag don`t reset interrupt INR3                      */
      __IO uint32_t  IN4        :  1;               /*!< Status Indicator flag don`t reset interrupt INR4                      */
      __IO uint32_t  IN5        :  1;               /*!< Status Indicator flag don`t reset interrupt INR5                      */
      __IO uint32_t  IN6        :  1;               /*!< Status Indicator flag don`t reset interrupt INR6                      */
      __IO uint32_t  IN7        :  1;               /*!< Status Indicator flag don`t reset interrupt INR7                      */
      __IO uint32_t  DCIN0      :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC0            */
      __IO uint32_t  DCIN1      :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC1            */
      __IO uint32_t  DCIN2      :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC2            */
      __IO uint32_t  DCIN3      :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC3            */
      __IO uint32_t  DCIN4      :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC4            */
      __IO uint32_t  DCIN5      :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC5            */
      __IO uint32_t  DCIN6      :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC6            */
      __IO uint32_t  DCIN7      :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC7            */
      __IO uint32_t  DCIN8      :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC8            */
      __IO uint32_t  DCIN9      :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC9            */
      __IO uint32_t  DCIN10     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC10           */
      __IO uint32_t  DCIN11     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC11           */
      __IO uint32_t  DCIN12     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC12           */
      __IO uint32_t  DCIN13     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC13           */
      __IO uint32_t  DCIN14     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC14           */
      __IO uint32_t  DCIN15     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC15           */
      __IO uint32_t  DCIN16     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC16           */
      __IO uint32_t  DCIN17     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC17           */
      __IO uint32_t  DCIN18     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC18           */
      __IO uint32_t  DCIN19     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC19           */
      __IO uint32_t  DCIN20     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC20           */
      __IO uint32_t  DCIN21     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC21           */
      __IO uint32_t  DCIN22     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC22           */
      __IO uint32_t  DCIN23     :  1;               /*!< Status Indicator flag don`t reset interrupt on line INRDC23           */
    } ISC_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  OSTAT;                           /*!< Register flags FIFO overflow                                          */
    
    struct {
      __IO uint32_t  OV0        :  1;               /*!< FIFO secvensor0 overflow                                              */
      __IO uint32_t  OV1        :  1;               /*!< FIFO secvensor1 overflow                                              */
      __IO uint32_t  OV2        :  1;               /*!< FIFO secvensor2 overflow                                              */
      __IO uint32_t  OV3        :  1;               /*!< FIFO secvensor3 overflow                                              */
      __IO uint32_t  OV4        :  1;               /*!< FIFO secvensor4 overflow                                              */
      __IO uint32_t  OV5        :  1;               /*!< FIFO secvensor5 overflow                                              */
      __IO uint32_t  OV6        :  1;               /*!< FIFO secvensor6 overflow                                              */
      __IO uint32_t  OV7        :  1;               /*!< FIFO secvensor7 overflow                                              */
           uint32_t             :  8;
      __IO uint32_t  DOV0       :  1;               /*!< Error DMA FIFFO0                                                      */
      __IO uint32_t  DOV1       :  1;               /*!< Error DMA FIFFO1                                                      */
      __IO uint32_t  DOV2       :  1;               /*!< Error DMA FIFFO2                                                      */
      __IO uint32_t  DOV3       :  1;               /*!< Error DMA FIFFO3                                                      */
      __IO uint32_t  DOV4       :  1;               /*!< Error DMA FIFFO4                                                      */
      __IO uint32_t  DOV5       :  1;               /*!< Error DMA FIFFO5                                                      */
      __IO uint32_t  DOV6       :  1;               /*!< Error DMA FIFFO6                                                      */
      __IO uint32_t  DOV7       :  1;               /*!< Error DMA FIFFO7                                                      */
    } OSTAT_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  EMUX;                            /*!< Select register triggering events sequencer                           */
    
    struct {
      __IO uint32_t  EM0        :  4;               /*!< select event for seqensor SS0                                         */
      __IO uint32_t  EM1        :  4;               /*!< select event for SS1                                                  */
      __IO uint32_t  EM2        :  4;               /*!< select event for SS2                                                  */
      __IO uint32_t  EM3        :  4;               /*!< select event for SS3                                                  */
      __IO uint32_t  EM4        :  4;               /*!< select event for SS4                                                  */
      __IO uint32_t  EM5        :  4;               /*!< select event for SS5                                                  */
      __IO uint32_t  EM6        :  4;               /*!< select event for SS6                                                  */
      __IO uint32_t  EM7        :  4;               /*!< select event for SS7                                                  */
    } EMUX_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  USTAT;                           /*!< Register FIFO empty                                                   */
    
    struct {
      __IO uint32_t  UV0        :  1;               /*!< fifo0 underflow                                                       */
      __IO uint32_t  UV1        :  1;               /*!< fifo1 underflow                                                       */
      __IO uint32_t  UV2        :  1;               /*!< fifo2 underflow                                                       */
      __IO uint32_t  UV3        :  1;               /*!< fifo3 underflow                                                       */
      __IO uint32_t  UV4        :  1;               /*!< fifo4 underflow                                                       */
      __IO uint32_t  UV5        :  1;               /*!< fifo5 underflow                                                       */
      __IO uint32_t  UV6        :  1;               /*!< fifo6 underflow                                                       */
      __IO uint32_t  UV7        :  1;               /*!< fifo7 underflow                                                       */
    } USTAT_b;                                      /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED;
  
  union {
    __IO uint32_t  SPC0;                            /*!< Register delay start ADC0, ADC1                                       */
    
    struct {
      __IO uint32_t  PHASE0     : 12;               /*!< Delay start ADC0 (Channel 0,1)                                        */
           uint32_t             :  4;
      __IO uint32_t  PHASE1     : 12;               /*!< Delay start ADC1 (Channel 2,3)                                        */
    } SPC0_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SPC1;                            /*!< Register delay start ADC2, ADC3                                       */
    
    struct {
      __IO uint32_t  PHASE2     : 12;               /*!< Delay start ADC2 (Channel 4,5)                                        */
           uint32_t             :  4;
      __IO uint32_t  PHASE3     : 12;               /*!< Delay start ADC3 (Channel 6,7)                                        */
    } SPC1_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SPC2;                            /*!< Register delay start ADC4, ADC5                                       */
    
    struct {
      __IO uint32_t  PHASE4     : 12;               /*!< Delay start ADC4(Channel 8,9)                                         */
           uint32_t             :  4;
      __IO uint32_t  PHASE5     : 12;               /*!< Delay start ADC5 (Channel 10,11)                                      */
    } SPC2_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SPC3;                            /*!< Register delay start ADC6, ADC7                                       */
    
    struct {
      __IO uint32_t  PHASE6     : 12;               /*!< Delay start ADC6 (Channel 12,13)                                      */
           uint32_t             :  4;
      __IO uint32_t  PHASE7     : 12;               /*!< Delay start ADC7 (Channel 14,15)                                      */
    } SPC3_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SPC4;                            /*!< Register delay start ADC8, ADC9                                       */
    
    struct {
      __IO uint32_t  PHASE8     : 12;               /*!< Delay start ADC8 (Channel 16,17)                                      */
           uint32_t             :  4;
      __IO uint32_t  PHASE9     : 12;               /*!< Delay start ADC9 (Channel 18,19)                                      */
    } SPC4_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SPC5;                            /*!< Register delay start ADC10, ADC11                                     */
    
    struct {
      __IO uint32_t  PHASE10    : 12;               /*!< Delay start ADC10 (Channel 20,21)                                     */
           uint32_t             :  4;
      __IO uint32_t  PHASE11    : 12;               /*!< Delay start ADC11 (Channel 22,23)                                     */
    } SPC5_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SAC;                             /*!< Register averagel control                                             */
    
    struct {
      __IO uint32_t  AVG0       :  3;               /*!< Averaging value0                                                      */
           uint32_t             :  1;
      __IO uint32_t  AVG1       :  3;               /*!< Averaging value1                                                      */
           uint32_t             :  1;
      __IO uint32_t  AVG2       :  3;               /*!< Averaging value2                                                      */
           uint32_t             :  1;
      __IO uint32_t  AVG3       :  3;               /*!< Averaging value3                                                      */
           uint32_t             :  1;
      __IO uint32_t  AVG4       :  3;               /*!< Averaging value4                                                      */
           uint32_t             :  1;
      __IO uint32_t  AVG5       :  3;               /*!< Averaging value5                                                      */
           uint32_t             :  1;
      __IO uint32_t  AVG6       :  3;               /*!< Averaging value6                                                      */
           uint32_t             :  1;
      __IO uint32_t  AVG7       :  3;               /*!< Averaging value7                                                      */
    } SAC_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  RICNT;                           /*!< Counter interrupt reset register                                      */
    
    struct {
      __IO uint32_t  AVG8       :  3;               /*!< Averaging value8                                                      */
           uint32_t             :  1;
      __IO uint32_t  AVG9       :  3;               /*!< Averaging value9                                                      */
           uint32_t             :  1;
      __IO uint32_t  AVG10      :  3;               /*!< Averaging value10                                                     */
           uint32_t             :  1;
      __IO uint32_t  AVG11      :  3;               /*!< Averaging value11                                                     */
           uint32_t             :  1;
      __IO uint32_t  RICNT0     :  1;               /*!< Disable reset counter interrupt on start seqensor                     */
      __IO uint32_t  RICNT1     :  1;               /*!< Disable reset counter interrupt on start seqensor                     */
      __IO uint32_t  RICNT2     :  1;               /*!< Disable reset counter interrupt on start seqensor                     */
      __IO uint32_t  RICNT3     :  1;               /*!< Disable reset counter interrupt on start seqensor                     */
      __IO uint32_t  RICNT4     :  1;               /*!< Disable reset counter interrupt on start seqensor                     */
      __IO uint32_t  RICNT5     :  1;               /*!< Disable reset counter interrupt on start seqensor                     */
      __IO uint32_t  RICNT6     :  1;               /*!< Disable reset counter interrupt on start seqensor                     */
      __IO uint32_t  RICNT7     :  1;               /*!< Disable reset counter interrupt on start seqensor                     */
    } RICNT_b;                                      /*!< BitSize                                                               */
  };
  NT_ADC_SEQ_Type SEQ[8];                           /*!< SEQ                                                                   */
  NT_ADC_DCCTL_Type DCCTL[24];                      /*!< DCCTL                                                                 */
  NT_ADC_DCCMP_Type DCCMP[24];                      /*!< DCCMP                                                                 */
  NT_ADC_DCVAL_Type DCVAL[24];                      /*!< DCVAL                                                                 */
  __I  uint32_t  RESERVED1[35];
  
  union {
    __O  uint32_t  DCRTC;                           /*!< High register reset comparators                                       */
    
    struct {
      __O  uint32_t  DCTRIG0    :  1;               /*!< Reset trigger comp0                                                   */
      __O  uint32_t  DCTRIG1    :  1;               /*!< Reset trigger comp1                                                   */
      __O  uint32_t  DCTRIG2    :  1;               /*!< Reset trigger comp2                                                   */
      __O  uint32_t  DCTRIG3    :  1;               /*!< Reset trigger comp3                                                   */
      __O  uint32_t  DCTRIG4    :  1;               /*!< Reset trigger comp4                                                   */
      __O  uint32_t  DCTRIG5    :  1;               /*!< Reset trigger comp5                                                   */
      __O  uint32_t  DCTRIG6    :  1;               /*!< Reset trigger comp6                                                   */
      __O  uint32_t  DCTRIG7    :  1;               /*!< Reset trigger comp7                                                   */
      __O  uint32_t  DCTRIG8    :  1;               /*!< Reset trigger comp8                                                   */
      __O  uint32_t  DCTRIG9    :  1;               /*!< Reset trigger comp9                                                   */
      __O  uint32_t  DCTRIG10   :  1;               /*!< Reset trigger comp10                                                  */
      __O  uint32_t  DCTRIG11   :  1;               /*!< Reset trigger comp11                                                  */
      __O  uint32_t  DCTRIG12   :  1;               /*!< Reset trigger comp12                                                  */
      __O  uint32_t  DCTRIG13   :  1;               /*!< Reset trigger comp13                                                  */
      __O  uint32_t  DCTRIG14   :  1;               /*!< Reset trigger comp14                                                  */
      __O  uint32_t  DCTRIG15   :  1;               /*!< Reset trigger comp15                                                  */
      __O  uint32_t  DCTRIG16   :  1;               /*!< Reset trigger comp16                                                  */
      __O  uint32_t  DCTRIG17   :  1;               /*!< Reset trigger comp17                                                  */
      __O  uint32_t  DCTRIG18   :  1;               /*!< Reset trigger comp18                                                  */
      __O  uint32_t  DCTRIG19   :  1;               /*!< Reset trigger comp19                                                  */
      __O  uint32_t  DCTRIG20   :  1;               /*!< Reset trigger comp20                                                  */
      __O  uint32_t  DCTRIG21   :  1;               /*!< Reset trigger comp21                                                  */
      __O  uint32_t  DCTRIG22   :  1;               /*!< Reset trigger comp22                                                  */
      __O  uint32_t  DCTRIG23   :  1;               /*!< Reset trigger comp23                                                  */
    } DCRTC_b;                                      /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED2[4];
  NT_ADC_PP_Type PP[12];                            /*!< PP                                                                    */
  __I  uint32_t  RESERVED3[50];
  
  union {
    __IO uint32_t  PSSI;                            /*!< Register synchronizing sequencers                                     */
    
    struct {
      __O  uint32_t  SS0        :  1;               /*!< Enable run sequencer0                                                 */
      __O  uint32_t  SS1        :  1;               /*!< Enable run sequencer1                                                 */
      __O  uint32_t  SS2        :  1;               /*!< Enable run sequencer2                                                 */
      __O  uint32_t  SS3        :  1;               /*!< Enable run sequencer3                                                 */
      __O  uint32_t  SS4        :  1;               /*!< Enable run sequencer4                                                 */
      __O  uint32_t  SS5        :  1;               /*!< Enable run sequencer5                                                 */
      __O  uint32_t  SS6        :  1;               /*!< Enable run sequencer6                                                 */
      __O  uint32_t  SS7        :  1;               /*!< Enable run sequencer7                                                 */
           uint32_t             : 23;
      __IO uint32_t  GSYNC      :  1;               /*!< Enable run all secvensors                                             */
    } PSSI_b;                                       /*!< BitSize                                                               */
  };
} NT_ADC_Type;


/* ================================================================================ */
/* ================                    NT_GPIOA                    ================ */
/* ================================================================================ */


/**
  * @brief GPIO controller regisres (NT_GPIOA)
  */

typedef struct {                                    /*!< NT_GPIOA Structure                                                    */
  
  union {
    __IO uint32_t  DATA;                            /*!< Data Input register                                                   */
    
    struct {
      __IO uint32_t  DATA       : 16;               /*!< (null)                                                                */
    } DATA_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DATAOUT;                         /*!< Data output register                                                  */
    
    struct {
      __IO uint32_t  DATAOUT    : 16;               /*!< (null)                                                                */
    } DATAOUT_b;                                    /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED[2];
  
  union {
    __IO uint32_t  OUTENSET;                        /*!< Enable output for port register                                       */
    
    struct {
      __IO uint32_t  OUTENSET   : 16;               /*!< (null)                                                                */
    } OUTENSET_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  OUTENCLR;                        /*!< Enable output for port                                                */
    
    struct {
      __IO uint32_t  OUTENCLR   : 16;               /*!< (null)                                                                */
    } OUTENCLR_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ALTFUNCSET;                      /*!< Enable alternate function port register                               */
    
    struct {
      __IO uint32_t  ALTFUNCSET : 16;               /*!< (null)                                                                */
    } ALTFUNCSET_b;                                 /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ALTFUNCCLR;                      /*!< Disable alternate function port register                              */
    
    struct {
      __IO uint32_t  ALTFUNCCLR : 16;               /*!< (null)                                                                */
    } ALTFUNCCLR_b;                                 /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  INTENSET;                        /*!< Enable interrupt on Pin of PORT register                              */
    
    struct {
      __IO uint32_t  INTENSET   : 16;               /*!< (null)                                                                */
    } INTENSET_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  INTENCLR;                        /*!< Disable interrupt on Pin of PORT register                             */
    
    struct {
      __IO uint32_t  INTENCLR   : 16;               /*!< (null)                                                                */
    } INTENCLR_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  INTTYPESET;                      /*!< Setup type of interrupt register                                      */
    
    struct {
      __IO uint32_t  INTTYPESET : 16;               /*!< (null)                                                                */
    } INTTYPESET_b;                                 /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  INTTYPECLR;                      /*!< Reset type of interrupt register                                      */
    
    struct {
      __IO uint32_t  INTTYPECLR : 16;               /*!< (null)                                                                */
    } INTTYPECLR_b;                                 /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  INTPOLSET;                       /*!< Setup polarity interrupt register                                     */
    
    struct {
      __IO uint32_t  INTPOLSET  : 16;               /*!< (null)                                                                */
    } INTPOLSET_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  INTPOLCLR;                       /*!< Reset polarity interrupt register                                     */
    
    struct {
      __IO uint32_t  INTPOLCLR  : 16;               /*!< (null)                                                                */
    } INTPOLCLR_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  INTSTATUS;                       /*!< State interrupt register Register transfer ports A and B output
                                                         open collector                                                        */
    
    struct {
      __IO uint32_t  INTSTATUS  : 16;               /*!< (null)                                                                */
    } INTSTATUS_b;                                  /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED1[241];
  NT_GPIOA_MASKLOWBYTE_Type MASKLOWBYTE[256];       /*!< MASKLOWBYTE                                                           */
  NT_GPIOA_MASKHIGHBYTE_Type MASKHIGHBYTE[256];     /*!< MASKHIGHBYTE                                                          */
} NT_GPIOA_Type;


/* ================================================================================ */
/* ================                  NT_COMMON_REG                 ================ */
/* ================================================================================ */


/**
  * @brief Common block registers (NT_COMMON_REG)
  */

typedef struct {                                    /*!< NT_COMMON_REG Structure                                               */
  
  union {
    union {
      __IO uint32_t  GPIODEN0;                      /*!< Enable output PORT A,B register                                       */
      
      struct {
        __IO uint32_t  PORTA    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTB    : 16;               /*!< (null)                                                                */
      } GPIODEN0_b;                                 /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIODENA;                    /*!< Enable output PORT A register                                         */
        
        struct {
          __IO uint16_t  PORTA  : 16;               /*!< (null)                                                                */
        } GPIODENA_b;                               /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIODENB;                    /*!< Enable output PORT B register                                         */
        
        struct {
          __IO uint16_t  PORTB  : 16;               /*!< (null)                                                                */
        } GPIODENB_b;                               /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIODEN1;                      /*!< Enable output PORT C,D register                                       */
      
      struct {
        __IO uint32_t  PORTC    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTD    : 16;               /*!< (null)                                                                */
      } GPIODEN1_b;                                 /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIODENC;                    /*!< Enable output PORT C register                                         */
        
        struct {
          __IO uint16_t  PORTC  : 16;               /*!< (null)                                                                */
        } GPIODENC_b;                               /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIODEND;                    /*!< Enable output PORT D register                                         */
        
        struct {
          __IO uint16_t  PORTD  : 16;               /*!< (null)                                                                */
        } GPIODEND_b;                               /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIODEN2;                      /*!< Enable output PORT E,F register                                       */
      
      struct {
        __IO uint32_t  PORTE    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTF    : 16;               /*!< (null)                                                                */
      } GPIODEN2_b;                                 /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIODENE;                    /*!< Enable output PORT E register                                         */
        
        struct {
          __IO uint16_t  PORTE  : 16;               /*!< (null)                                                                */
        } GPIODENE_b;                               /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIODENF;                    /*!< Enable output PORT F register                                         */
        
        struct {
          __IO uint16_t  PORTF  : 16;               /*!< (null)                                                                */
        } GPIODENF_b;                               /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIODEN3;                      /*!< Enable output PORT G,H register                                       */
      
      struct {
        __IO uint32_t  PORTG    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTH    : 16;               /*!< (null)                                                                */
      } GPIODEN3_b;                                 /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIODENG;                    /*!< Enable output PORT G register                                         */
        
        struct {
          __IO uint16_t  PORTG  : 16;               /*!< (null)                                                                */
        } GPIODENG_b;                               /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIODENH;                    /*!< Enable output PORT H register                                         */
        
        struct {
          __IO uint16_t  PORTH  : 16;               /*!< (null)                                                                */
        } GPIODENH_b;                               /*!< BitSize                                                               */
      };
    };
  };
  __I  uint32_t  RESERVED[2];
  
  union {
    __IO uint32_t  GPIOPCTLA;                       /*!< Alternate function PORTA register                                     */
    
    struct {
      __IO uint32_t  PIN0       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN1       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN2       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN3       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN4       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN5       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN6       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN7       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN8       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN9       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN10      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN11      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN12      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN13      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN14      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN15      :  2;               /*!< Select alternative function on PIN                                    */
    } GPIOPCTLA_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOPCTLB;                       /*!< Alternate function PORTB register                                     */
    
    struct {
      __IO uint32_t  PIN0       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN1       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN2       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN3       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN4       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN5       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN6       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN7       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN8       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN9       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN10      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN11      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN12      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN13      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN14      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN15      :  2;               /*!< Select alternative function on PIN                                    */
    } GPIOPCTLB_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOPCTLC;                       /*!< Alternate function PORTC register                                     */
    
    struct {
      __IO uint32_t  PIN0       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN1       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN2       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN3       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN4       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN5       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN6       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN7       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN8       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN9       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN10      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN11      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN12      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN13      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN14      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN15      :  2;               /*!< Select alternative function on PIN                                    */
    } GPIOPCTLC_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOPCTLD;                       /*!< Alternate function PORTD register                                     */
    
    struct {
      __IO uint32_t  PIN0       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN1       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN2       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN3       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN4       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN5       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN6       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN7       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN8       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN9       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN10      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN11      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN12      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN13      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN14      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN15      :  2;               /*!< Select alternative function on PIN                                    */
    } GPIOPCTLD_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOPCTLE;                       /*!< Alternate function PORTE register                                     */
    
    struct {
      __IO uint32_t  PIN0       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN1       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN2       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN3       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN4       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN5       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN6       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN7       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN8       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN9       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN10      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN11      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN12      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN13      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN14      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN15      :  2;               /*!< Select alternative function on PIN                                    */
    } GPIOPCTLE_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOPCTLF;                       /*!< Alternate function PORTF register                                     */
    
    struct {
      __IO uint32_t  PIN0       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN1       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN2       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN3       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN4       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN5       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN6       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN7       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN8       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN9       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN10      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN11      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN12      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN13      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN14      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN15      :  2;               /*!< Select alternative function on PIN                                    */
    } GPIOPCTLF_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOPCTLG;                       /*!< Alternate function PORTG register                                     */
    
    struct {
      __IO uint32_t  PIN0       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN1       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN2       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN3       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN4       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN5       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN6       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN7       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN8       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN9       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN10      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN11      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN12      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN13      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN14      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN15      :  2;               /*!< Select alternative function on PIN                                    */
    } GPIOPCTLG_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOPCTLH;                       /*!< Alternate function PORTH register                                     */
    
    struct {
      __IO uint32_t  PIN0       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN1       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN2       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN3       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN4       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN5       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN6       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN7       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN8       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN9       :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN10      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN11      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN12      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN13      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN14      :  2;               /*!< Select alternative function on PIN                                    */
      __IO uint32_t  PIN15      :  2;               /*!< Select alternative function on PIN                                    */
    } GPIOPCTLH_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  RESERVED1[4];
    
    union {
      __IO uint32_t  GPIOODCTL0;                    /*!< Control register circuit 'Pull-up' ports A, B                         */
      
      struct {
        __IO uint32_t  PORTA    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTB    : 16;               /*!< (null)                                                                */
      } GPIOODCTL0_b;                               /*!< BitSize                                                               */
    };
    
    struct {
      __I  uint32_t  RESERVED2[4];
      
      union {
        __IO uint16_t  GPIOODCTLA;                  /*!< Control register circuit 'Pull-up' Port A                             */
        
        struct {
          __IO uint16_t  PORTA  : 16;               /*!< (null)                                                                */
        } GPIOODCTLA_b;                             /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOODCTLB;                  /*!< Control register circuit 'Pull-up' Port B                             */
        
        struct {
          __IO uint16_t  PORTB  : 16;               /*!< (null)                                                                */
        } GPIOODCTLB_b;                             /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIOODCTL1;                    /*!< Control register circuit 'Pull-up' ports C, D                         */
      
      struct {
        __IO uint32_t  PORTC    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTD    : 16;               /*!< (null)                                                                */
      } GPIOODCTL1_b;                               /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIOODCTLC;                  /*!< Control register circuit 'Pull-up' Port C                             */
        
        struct {
          __IO uint16_t  PORTC  : 16;               /*!< (null)                                                                */
        } GPIOODCTLC_b;                             /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOODCTLD;                  /*!< Control register circuit 'Pull-up' Port D                             */
        
        struct {
          __IO uint16_t  PORTD  : 16;               /*!< (null)                                                                */
        } GPIOODCTLD_b;                             /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIOODCTL2;                    /*!< Control register circuit 'Pull-up' ports E, F                         */
      
      struct {
        __IO uint32_t  PORTE    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTF    : 16;               /*!< (null)                                                                */
      } GPIOODCTL2_b;                               /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIOODCTLE;                  /*!< Control register circuit 'Pull-up' Port E                             */
        
        struct {
          __IO uint16_t  PORTE  : 16;               /*!< (null)                                                                */
        } GPIOODCTLE_b;                             /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOODCTLF;                  /*!< Control register circuit 'Pull-up' Port F                             */
        
        struct {
          __IO uint16_t  PORTF  : 16;               /*!< (null)                                                                */
        } GPIOODCTLF_b;                             /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIOODCTL3;                    /*!< Control register circuit 'Pull-up' ports G, H                         */
      
      struct {
        __IO uint32_t  PORTG    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTH    : 16;               /*!< (null)                                                                */
      } GPIOODCTL3_b;                               /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIOODCTLG;                  /*!< Control register circuit 'Pull-up' Port G                             */
        
        struct {
          __IO uint16_t  PORTG  : 16;               /*!< (null)                                                                */
        } GPIOODCTLG_b;                             /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOODCTLH;                  /*!< Control register circuit 'Pull-up' Ports H                            */
        
        struct {
          __IO uint16_t  PORTH  : 16;               /*!< (null)                                                                */
        } GPIOODCTLH_b;                             /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    __I  uint32_t  RESERVED3[2];
    
    union {
      __IO uint32_t  GPIOODSCTL0;                   /*!< Control register output capability ports A,B                          */
      
      struct {
        __IO uint32_t  PORTA    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTB    : 16;               /*!< (null)                                                                */
      } GPIOODSCTL0_b;                              /*!< BitSize                                                               */
    };
    
    struct {
      __I  uint32_t  RESERVED4[2];
      
      union {
        __IO uint16_t  GPIOODSCTLA;                 /*!< Control register output capability Port A                             */
        
        struct {
          __IO uint16_t  PORTA  : 16;               /*!< (null)                                                                */
        } GPIOODSCTLA_b;                            /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOODSCTLB;                 /*!< Control register output capability Port B                             */
        
        struct {
          __IO uint16_t  PORTB  : 16;               /*!< (null)                                                                */
        } GPIOODSCTLB_b;                            /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIOODSCTL1;                   /*!< Control register output capability ports C,D                          */
      
      struct {
        __IO uint32_t  PORTC    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTD    : 16;               /*!< (null)                                                                */
      } GPIOODSCTL1_b;                              /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIOODSCTLC;                 /*!< Control register output capability Port C                             */
        
        struct {
          __IO uint16_t  PORTC  : 16;               /*!< (null)                                                                */
        } GPIOODSCTLC_b;                            /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOODSCTLD;                 /*!< Control register output capability Port D                             */
        
        struct {
          __IO uint16_t  PORTD  : 16;               /*!< (null)                                                                */
        } GPIOODSCTLD_b;                            /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIOODSCTL2;                   /*!< Control register output capability ports E,F                          */
      
      struct {
        __IO uint32_t  PORTE    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTF    : 16;               /*!< (null)                                                                */
      } GPIOODSCTL2_b;                              /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIOODSCTLE;                 /*!< Control register output capability Port E                             */
        
        struct {
          __IO uint16_t  PORTE  : 16;               /*!< (null)                                                                */
        } GPIOODSCTLE_b;                            /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOODSCTLF;                 /*!< Control register output capability Port F                             */
        
        struct {
          __IO uint16_t  PORTF  : 16;               /*!< (null)                                                                */
        } GPIOODSCTLF_b;                            /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIOODSCTL3;                   /*!< Control register output capability ports G,H                          */
      
      struct {
        __IO uint32_t  PORTG    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTH    : 16;               /*!< (null)                                                                */
      } GPIOODSCTL3_b;                              /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIOODSCTLG;                 /*!< Control register output capability Port G                             */
        
        struct {
          __IO uint16_t  PORTG  : 16;               /*!< (null)                                                                */
        } GPIOODSCTLG_b;                            /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOODSCTLH;                 /*!< Control register output capability Port H                             */
        
        struct {
          __IO uint16_t  PORTH  : 16;               /*!< (null)                                                                */
        } GPIOODSCTLH_b;                            /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    __I  uint32_t  RESERVED5[2];
    
    union {
      __IO uint32_t  GPIOPUCTL0;                    /*!< Control register circuit 'Pull-up' ports A, B                         */
      
      struct {
        __IO uint32_t  PORTA    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTB    : 16;               /*!< (null)                                                                */
      } GPIOPUCTL0_b;                               /*!< BitSize                                                               */
    };
    
    struct {
      __I  uint32_t  RESERVED6[2];
      
      union {
        __IO uint16_t  GPIOPUCTLA;                  /*!< Control register circuit 'Pull-up' Port A                             */
        
        struct {
          __IO uint16_t  PORTA  : 16;               /*!< (null)                                                                */
        } GPIOPUCTLA_b;                             /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOPUCTLB;                  /*!< Control register circuit 'Pull-up' Port B                             */
        
        struct {
          __IO uint16_t  PORTB  : 16;               /*!< (null)                                                                */
        } GPIOPUCTLB_b;                             /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIOPUCTL1;                    /*!< Control register circuit 'Pull-up' ports C, D                         */
      
      struct {
        __IO uint32_t  PORTC    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTD    : 16;               /*!< (null)                                                                */
      } GPIOPUCTL1_b;                               /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIOPUCTLC;                  /*!< Control register circuit 'Pull-up' Port C                             */
        
        struct {
          __IO uint16_t  PORTC  : 16;               /*!< (null)                                                                */
        } GPIOPUCTLC_b;                             /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOPUCTLD;                  /*!< Control register circuit 'Pull-up' Port D                             */
        
        struct {
          __IO uint16_t  PORTD  : 16;               /*!< (null)                                                                */
        } GPIOPUCTLD_b;                             /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIOPUCTL2;                    /*!< Control register circuit 'Pull-up' ports E, F                         */
      
      struct {
        __IO uint32_t  PORTE    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTF    : 16;               /*!< (null)                                                                */
      } GPIOPUCTL2_b;                               /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIOPUCTLE;                  /*!< Control register circuit 'Pull-up' Port E                             */
        
        struct {
          __IO uint16_t  PORTE  : 16;               /*!< (null)                                                                */
        } GPIOPUCTLE_b;                             /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOPUCTLF;                  /*!< Control register circuit 'Pull-up' Port F                             */
        
        struct {
          __IO uint16_t  PORTF  : 16;               /*!< (null)                                                                */
        } GPIOPUCTLF_b;                             /*!< BitSize                                                               */
      };
    };
  };
  
  union {
    union {
      __IO uint32_t  GPIOPUCTL3;                    /*!< Control register circuit 'Pull-up' ports G, H                         */
      
      struct {
        __IO uint32_t  PORTG    : 16;               /*!< (null)                                                                */
        __IO uint32_t  PORTH    : 16;               /*!< (null)                                                                */
      } GPIOPUCTL3_b;                               /*!< BitSize                                                               */
    };
    
    struct {
      union {
        __IO uint16_t  GPIOPUCTLG;                  /*!< Control register circuit 'Pull-up' Port G                             */
        
        struct {
          __IO uint16_t  PORTG  : 16;               /*!< (null)                                                                */
        } GPIOPUCTLG_b;                             /*!< BitSize                                                               */
      };
      
      union {
        __IO uint16_t  GPIOPUCTLH;                  /*!< Control register circuit 'Pull-up' Port H                             */
        
        struct {
          __IO uint16_t  PORTH  : 16;               /*!< (null)                                                                */
        } GPIOPUCTLH_b;                             /*!< BitSize                                                               */
      };
    };
  };
  __I  uint32_t  RESERVED7[3];
  
  union {
    __IO uint32_t  PLL_CTRL;                        /*!< PLL control register settings                                         */
    
    struct {
      __IO uint32_t  REFSEL     :  2;               /*!< Reference source PLL                                                  */
           uint32_t             :  6;
      __IO uint32_t  PLL_DIV    :  8;               /*!< Devider clk PLL                                                       */
           uint32_t             : 15;
      __IO uint32_t  PD         :  1;               /*!< Enable mode PowerDown                                                 */
    } PLL_CTRL_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  PLL_OD;                          /*!< Select output divider PLL                                             */
    
    struct {
      __IO uint32_t  PLL_OD     :  2;               /*!< (null)                                                                */
    } PLL_OD_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  PLL_NR;                          /*!< Setting the reference divider PLL                                     */
    
    struct {
      __IO uint32_t  R_PLL      :  5;               /*!< (null)                                                                */
    } PLL_NR_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  PLL_NF;                          /*!< Setting the PLL feedback divider                                      */
    
    struct {
      __IO uint32_t  F_PLL      :  9;               /*!< (null)                                                                */
    } PLL_NF_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  EXT_MEM_CFG;                     /*!< Setting up an external memory controller                              */
    
    struct {
      __IO uint32_t  ReadWS     :  3;               /*!< (null)                                                                */
      __IO uint32_t  WriteWS    :  3;               /*!< (null)                                                                */
      __IO uint32_t  RWWS       :  3;               /*!< (null)                                                                */
      __IO uint32_t  CE_MASK    :  9;               /*!< (null)                                                                */
           uint32_t             : 13;
      __IO uint32_t  BV         :  1;               /*!< Bit of Bus Width                                                      */
    } EXT_MEM_CFG_b;                                /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ADC_CTRL0;                       /*!< ADC control register 0                                                */
    
    struct {
      __IO uint32_t  CLKEN_ADC0 :  1;               /*!< Enable clk ADC0                                                       */
      __IO uint32_t  DIVEN_ADC0 :  1;               /*!< Enable devider clk ADC0                                               */
      __IO uint32_t  DIV_ADC0   :  6;               /*!< Devider clk ADC0                                                      */
      __IO uint32_t  CLKEN_ADC1 :  1;               /*!< Enable clk ADC1                                                       */
      __IO uint32_t  DIVEN_ADC1 :  1;               /*!< Enable devider clk ADC1                                               */
      __IO uint32_t  DIV_ADC1   :  6;               /*!< Devider clk ADC1                                                      */
      __IO uint32_t  CLKEN_ADC2 :  1;               /*!< Enable clk ADC2                                                       */
      __IO uint32_t  DIVEN_ADC2 :  1;               /*!< Enable devider clk ADC2                                               */
      __IO uint32_t  DIV_ADC2   :  6;               /*!< Devider clk ADC2                                                      */
      __IO uint32_t  CLKEN_ADC3 :  1;               /*!< Enable clk ADC3                                                       */
      __IO uint32_t  DIVEN_ADC3 :  1;               /*!< Enable devider clk ADC3                                               */
      __IO uint32_t  DIV_ADC3   :  6;               /*!< Devider clk ADC3                                                      */
    } ADC_CTRL0_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ADC_CTRL1;                       /*!< ADC control register 1                                                */
    
    struct {
      __IO uint32_t  CLKEN_ADC4 :  1;               /*!< Enable clk ADC4                                                       */
      __IO uint32_t  DIVEN_ADC4 :  1;               /*!< Enable devider clk ADC4                                               */
      __IO uint32_t  DIV_ADC4   :  6;               /*!< Devider clk ADC4                                                      */
      __IO uint32_t  CLKEN_ADC5 :  1;               /*!< Enable clk ADC5                                                       */
      __IO uint32_t  DIVEN_ADC5 :  1;               /*!< Enable devider clk ADC5                                               */
      __IO uint32_t  DIV_ADC5   :  6;               /*!< Devider clk ADC5                                                      */
      __IO uint32_t  CLKEN_ADC6 :  1;               /*!< Enable clk ADC6                                                       */
      __IO uint32_t  DIVEN_ADC6 :  1;               /*!< Enable devider clk ADC6                                               */
      __IO uint32_t  DIV_ADC6   :  6;               /*!< Devider clk ADC6                                                      */
      __IO uint32_t  CLKEN_ADC7 :  1;               /*!< Enable clk ADC7                                                       */
      __IO uint32_t  DIVEN_ADC7 :  1;               /*!< Enable devider clk ADC7                                               */
      __IO uint32_t  DIV_ADC7   :  6;               /*!< Devider clk ADC7                                                      */
    } ADC_CTRL1_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  PWM_SYNC;                        /*!< Syncronize register PWM blocks                                        */
    
    struct {
      __IO uint32_t  TBCLKSYNC  :  9;               /*!< Enable mode counter PWM0                                              */
    } PWM_SYNC_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  PWM_CTRL;                        /*!< Register control of synchronization blocks of PWM                     */
    
    struct {
      __IO uint32_t  SYNCSELECT :  2;               /*!< Select PWM synchronization mode                                       */
      __IO uint32_t  CAPSYNCSEL :  1;               /*!< Select synchronization of block PWM, 0 - synchronization from
                                                         CAP3; 1 - synchronization from PWM0.                                  */
      __IO uint32_t  SYNCREG    :  1;               /*!< Enable output pulse synchronization SYNCI on input of PWM0            */
    } PWM_CTRL_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SYS_CLK;                         /*!< Setting the system clock controller                                   */
    
    struct {
      __IO uint32_t  SEL_SRC    :  3;               /*!< Select source clk                                                     */
           uint32_t             :  5;
      __I  uint32_t  CURR_SRC   :  3;               /*!< Indicate chanched source clk                                          */
    } SYS_CLK_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  APB_CLK;                         /*!< Setting the resolution peripheral clocks                              */
    
    struct {
           uint32_t             :  1;
      __IO uint32_t  QEPEN0     :  1;               /*!< Enable clocking QEP0                                                  */
      __IO uint32_t  QEPEN1     :  1;               /*!< Enable clocking QEP1                                                  */
           uint32_t             :  6;
      __IO uint32_t  CMPEN      :  1;               /*!< Enable clocking analog comparator                                     */
      __IO uint32_t  PWMEN0     :  1;               /*!< Enable clocking PWM0                                                  */
      __IO uint32_t  PWMEN1     :  1;               /*!< Enable clocking PWM1                                                  */
      __IO uint32_t  PWMEN2     :  1;               /*!< Enable clocking PWM2                                                  */
      __IO uint32_t  PWMEN3     :  1;               /*!< Enable clocking PWM3                                                  */
      __IO uint32_t  PWMEN4     :  1;               /*!< Enable clocking PWM4                                                  */
      __IO uint32_t  PWMEN5     :  1;               /*!< Enable clocking PWM5                                                  */
      __IO uint32_t  PWMEN6     :  1;               /*!< Enable clocking PWM6                                                  */
      __IO uint32_t  PWMEN7     :  1;               /*!< Enable clocking PWM7                                                  */
      __IO uint32_t  PWMEN8     :  1;               /*!< Enable clocking PWM8                                                  */
      __IO uint32_t  WDEN       :  1;               /*!< Enable clocking WDT                                                   */
      __IO uint32_t  I2CEN0     :  1;               /*!< Enable clocking I2C0                                                  */
      __IO uint32_t  I2CEN1     :  1;               /*!< Enable clocking I2C1                                                  */
           uint32_t             :  2;
      __IO uint32_t  ADCEN      :  1;               /*!< Enable clk ADC                                                        */
    } APB_CLK_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  UART_CLK;                        /*!< Setting the clock UART blocks                                         */
    
    struct {
      __IO uint32_t  CLKEN_UART0:  1;               /*!< Enable clk UART0                                                      */
      __IO uint32_t  DIVEN_UART0:  1;               /*!< Enable devider clk UART0                                              */
      __IO uint32_t  DIV_UART0  :  6;               /*!< Devider clk UART0                                                     */
      __IO uint32_t  CLKEN_UART1:  1;               /*!< Enable clk UART1                                                      */
      __IO uint32_t  DIVEN_UART1:  1;               /*!< Enable devider clk UART1                                              */
      __IO uint32_t  DIV_UART1  :  6;               /*!< Devider clk UART1                                                     */
      __IO uint32_t  CLKEN_UART2:  1;               /*!< Enable clk UART2                                                      */
      __IO uint32_t  DIVEN_UART2:  1;               /*!< Enable devider clk UART2                                              */
      __IO uint32_t  DIV_UART2  :  6;               /*!< Devider clk UART2                                                     */
      __IO uint32_t  CLKEN_UART3:  1;               /*!< Enable clk UART3                                                      */
      __IO uint32_t  DIVEN_UART3:  1;               /*!< Enable devider clk UART3                                              */
      __IO uint32_t  DIV_UART3  :  6;               /*!< Devider clk UART3                                                     */
    } UART_CLK_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SPI_CLK;                         /*!< Setting the clock blocks SPI                                          */
    
    struct {
      __IO uint32_t  CLKEN_SPI0 :  1;               /*!< Enable clk SPI0                                                       */
      __IO uint32_t  DIVEN_SPI0 :  1;               /*!< Enable devider clk SPI0                                               */
      __IO uint32_t  DIV_SPI0   :  6;               /*!< Devider clk SPI0                                                      */
      __IO uint32_t  CLKEN_SPI1 :  1;               /*!< Enable clk SPI1                                                       */
      __IO uint32_t  DIVEN_SPI1 :  1;               /*!< Enable devider clk SPI1                                               */
      __IO uint32_t  DIV_SPI1   :  6;               /*!< Devider clk SPI1                                                      */
      __IO uint32_t  CLKEN_SPI2 :  1;               /*!< Enable clk SPI2                                                       */
      __IO uint32_t  DIVEN_SPI2 :  1;               /*!< Enable devider clk SPI2                                               */
      __IO uint32_t  DIV_SPI2   :  6;               /*!< Devider clk SPI2                                                      */
      __IO uint32_t  CLKEN_SPI3 :  1;               /*!< Enable clk SPI3                                                       */
      __IO uint32_t  DIVEN_SPI3 :  1;               /*!< Enable devider clk SPI3                                               */
      __IO uint32_t  DIV_SPI3   :  6;               /*!< Devider clk SPI3                                                      */
    } SPI_CLK_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  PER_RST0;                        /*!< Peripheral reset register 0                                           */
    
    struct {
      __IO uint32_t  WDRST      :  1;               /*!< Reset WatchDog                                                        */
      __IO uint32_t  I2CRST0    :  1;               /*!< Reset I2C0                                                            */
      __IO uint32_t  I2CRST1    :  1;               /*!< Reset I2C1                                                            */
      __IO uint32_t  USBPHYRST  :  1;               /*!< Reset USB_PHY                                                         */
      __IO uint32_t  TIMERRST0  :  1;               /*!< Reset TIMER0                                                          */
      __IO uint32_t  TIMERRST1  :  1;               /*!< Reset TIMER1                                                          */
      __IO uint32_t  TIMERRST2  :  1;               /*!< Reset TIMER2                                                          */
      __IO uint32_t  UARTRST0   :  1;               /*!< Reset UART0                                                           */
      __IO uint32_t  UARTRST1   :  1;               /*!< Reset UART1                                                           */
      __IO uint32_t  UARTRST2   :  1;               /*!< Reset UART2                                                           */
      __IO uint32_t  UARTRST3   :  1;               /*!< Reset UART3                                                           */
      __IO uint32_t  SPIRST0    :  1;               /*!< Reset SPI0                                                            */
      __IO uint32_t  SPIRST1    :  1;               /*!< Reset SPI1                                                            */
      __IO uint32_t  SPIRST2    :  1;               /*!< Reset SPI2                                                            */
      __IO uint32_t  SPIRST3    :  1;               /*!< Reset SPI3                                                            */
      __IO uint32_t  ETHRST     :  1;               /*!< Reset Ethernet                                                        */
    } PER_RST0_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  PER_RST1;                        /*!< Peripheral reset register 1                                           */
    
    struct {
      __IO uint32_t  QEPRST0    :  1;               /*!< Reset QEPR0                                                           */
      __IO uint32_t  QEPRST1    :  1;               /*!< Reset QEPR0                                                           */
      __IO uint32_t  PWMRST0    :  1;               /*!< Reset module PWM0                                                     */
      __IO uint32_t  PWMRST1    :  1;               /*!< Reset module PWM1                                                     */
      __IO uint32_t  PWMRST2    :  1;               /*!< Reset module PWM2                                                     */
      __IO uint32_t  PWMRST3    :  1;               /*!< Reset module PWM3                                                     */
      __IO uint32_t  PWMRST4    :  1;               /*!< Reset module PWM4                                                     */
      __IO uint32_t  PWMRST5    :  1;               /*!< Reset module PWM5                                                     */
      __IO uint32_t  PWMRST6    :  1;               /*!< Reset module PWM6                                                     */
      __IO uint32_t  PWMRST7    :  1;               /*!< Reset module PWM7                                                     */
      __IO uint32_t  PWMRST8    :  1;               /*!< Reset module PWM8                                                     */
      __IO uint32_t  CAPRST0    :  1;               /*!< Reset module CAP0                                                     */
      __IO uint32_t  CAPRST1    :  1;               /*!< Reset module CAP1                                                     */
      __IO uint32_t  CAPRST2    :  1;               /*!< Reset module CAP2                                                     */
      __IO uint32_t  CAPRST3    :  1;               /*!< Reset module CAP3                                                     */
      __IO uint32_t  CAPRST4    :  1;               /*!< Reset module CAP4                                                     */
      __IO uint32_t  CAPRST5    :  1;               /*!< Reset module CAP5                                                     */
      __IO uint32_t  ECMPRST    :  1;               /*!< Reset of analog comparator                                            */
    } PER_RST1_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOSE0;                         /*!< Control register resynchronization input ports A, B                   */
    
    struct {
      __IO uint32_t  PORTA      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTB      : 16;               /*!< (null)                                                                */
    } GPIOSE0_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOSE1;                         /*!< Control register resynchronization input ports C, D                   */
    
    struct {
      __IO uint32_t  PORTC      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTD      : 16;               /*!< (null)                                                                */
    } GPIOSE1_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOSE2;                         /*!< Control register resynchronization input ports E, F                   */
    
    struct {
      __IO uint32_t  PORTE      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTF      : 16;               /*!< (null)                                                                */
    } GPIOSE2_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOSE3;                         /*!< Control register resynchronization input ports G, H                   */
    
    struct {
      __IO uint32_t  PORTG      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTH      : 16;               /*!< (null)                                                                */
    } GPIOSE3_b;                                    /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED8[4];
  
  union {
    __IO uint32_t  GPIOQE0;                         /*!< Register filter settings input ports A, B                             */
    
    struct {
      __IO uint32_t  PORTA      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTB      : 16;               /*!< (null)                                                                */
    } GPIOQE0_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOQE1;                         /*!< Register filter settings input ports C, D                             */
    
    struct {
      __IO uint32_t  PORTC      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTD      : 16;               /*!< (null)                                                                */
    } GPIOQE1_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOQE2;                         /*!< Register filter settings input ports E, F                             */
    
    struct {
      __IO uint32_t  PORTE      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTF      : 16;               /*!< (null)                                                                */
    } GPIOQE2_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOQE3;                         /*!< Register filter settings input ports G, H                             */
    
    struct {
      __IO uint32_t  PORTG      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTH      : 16;               /*!< (null)                                                                */
    } GPIOQE3_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOQM0;                         /*!< Register filter settings input ports A, B                             */
    
    struct {
      __IO uint32_t  PORTA      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTB      : 16;               /*!< (null)                                                                */
    } GPIOQM0_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOQM1;                         /*!< Register filter settings input ports C, D                             */
    
    struct {
      __IO uint32_t  PORTC      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTD      : 16;               /*!< (null)                                                                */
    } GPIOQM1_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOQM2;                         /*!< Register filter settings input ports E, F                             */
    
    struct {
      __IO uint32_t  PORTE      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTF      : 16;               /*!< (null)                                                                */
    } GPIOQM2_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOQM3;                         /*!< Register filter settings input ports G, H                             */
    
    struct {
      __IO uint32_t  PORTG      : 16;               /*!< (null)                                                                */
      __IO uint32_t  PORTH      : 16;               /*!< (null)                                                                */
    } GPIOQM3_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOQPAD;                        /*!< Register filter settings input ports A, B, C, D                       */
    
    struct {
      __IO uint32_t  SPRDA      :  8;               /*!< (null)                                                                */
      __IO uint32_t  SPRDB      :  8;               /*!< (null)                                                                */
      __IO uint32_t  SPRDC      :  8;               /*!< (null)                                                                */
      __IO uint32_t  SPRDD      :  8;               /*!< (null)                                                                */
    } GPIOQPAD_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  GPIOQPEH;                        /*!< Register filter settings input ports E, F, G, H                       */
    
    struct {
      __IO uint32_t  SPRDE      :  8;               /*!< (null)                                                                */
      __IO uint32_t  SPRDF      :  8;               /*!< (null)                                                                */
      __IO uint32_t  SPRDG      :  8;               /*!< (null)                                                                */
      __IO uint32_t  SPRDH      :  8;               /*!< (null)                                                                */
    } GPIOQPEH_b;                                   /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED9[6];
  
  union {
    __IO uint32_t  USB_CTRL;                        /*!< Customize the USB PHY                                                 */
    
    struct {
      __IO uint32_t  FSEL       :  1;               /*!< Frequency selection reference signal USBPHY (0- 12MHz; 1- 24MHz)      */
      __O  uint32_t  CLKSEL     :  1;               /*!< Select of reference source USBPHY                                     */
      __O  uint32_t  CLKEN      :  1;               /*!< Enable clk signal USBPHY                                              */
    } USB_CTRL_b;                                   /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED10;
  
  union {
    __IO uint32_t  UART_SPI_CLK_SEL;                /*!< Select source clk UART and SSP register                               */
    
    struct {
      __IO uint32_t  SEL_UART0  :  2;               /*!< Select source clk UART0                                               */
      __IO uint32_t  SEL_UART1  :  2;               /*!< Select source clk UART1                                               */
      __IO uint32_t  SEL_UART2  :  2;               /*!< Select source clk UART2                                               */
      __IO uint32_t  SEL_UART3  :  2;               /*!< Select source clk UART3                                               */
      __IO uint32_t  SEL_SPI0   :  2;               /*!< Select source clk SPI0                                                */
      __IO uint32_t  SEL_SPI1   :  2;               /*!< Select source clk SPI1                                                */
      __IO uint32_t  SEL_SPI2   :  2;               /*!< Select source clk SPI2                                                */
      __IO uint32_t  SEL_SPI3   :  2;               /*!< Select source clk SPI3                                                */
    } UART_SPI_CLK_SEL_b;                           /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ADC_CTRL2;                       /*!< ADC control register 2                                                */
    
    struct {
      __IO uint32_t  CLKEN_ADC8 :  1;               /*!< Enable clk ADC8                                                       */
      __IO uint32_t  DIVEN_ADC8 :  1;               /*!< Enable devider clk ADC8                                               */
      __IO uint32_t  DIV_ADC8   :  6;               /*!< Devider clk ADC8                                                      */
      __IO uint32_t  CLKEN_ADC9 :  1;               /*!< Enable clk ADC9                                                       */
      __IO uint32_t  DIVEN_ADC9 :  1;               /*!< Enable devider clk ADC9                                               */
      __IO uint32_t  DIV_ADC9   :  6;               /*!< Devider clk ADC9                                                      */
      __IO uint32_t  CLKEN_ADC10:  1;               /*!< Enable clk ADC10                                                      */
      __IO uint32_t  DIVEN_ADC10:  1;               /*!< Enable devider clk ADC10                                              */
      __IO uint32_t  DIV_ADC10  :  6;               /*!< Devider clk ADC10                                                     */
      __IO uint32_t  CLKEN_ADC11:  1;               /*!< Enable clk ADC11                                                      */
      __IO uint32_t  DIVEN_ADC11:  1;               /*!< Enable devider clk ADC11                                              */
      __IO uint32_t  DIV_ADC11  :  6;               /*!< Devider clk ADC11                                                     */
    } ADC_CTRL2_b;                                  /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED11[9];
  
  union {
    __IO uint32_t  FLASH_FULL_ERASE;                /*!< Full erase flash (user and boot) register                             */
    
    struct {
      __IO uint32_t  ERASE_FLASH:  1;               /*!< (null)                                                                */
    } FLASH_FULL_ERASE_b;                           /*!< BitSize                                                               */
  };
} NT_COMMON_REG_Type;


/* ================================================================================ */
/* ================                     NT_CAN                     ================ */
/* ================================================================================ */


/**
  * @brief CAN controller registers (NT_CAN)
  */

typedef struct {                                    /*!< NT_CAN Structure                                                      */
  
  union {
    __IO uint32_t  CLC;                             /*!< Frequency control register                                            */
    
    struct {
      __IO uint32_t  DISR       :  1;               /*!< OFF module CAN                                                        */
      __I  uint32_t  DISS       :  1;               /*!< State CAN                                                             */
      __IO uint32_t  SPEN       :  1;               /*!< Activate suspend mode for system debugging                            */
           uint32_t             :  1;
      __O  uint32_t  SBWE       :  1;               /*!< Enable write in FSOE and SPEN for system debugging                    */
      __IO uint32_t  FSOE       :  1;               /*!< activation quickly turn off the CAN for system debugging              */
    } CLC_b;                                        /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED;
  
  union {
    __IO uint32_t  ID;                              /*!< Identity register                                                     */
    
    struct {
      __IO uint32_t  MOD_REV    :  8;               /*!< (null)                                                                */
      __I  uint32_t  MOD_TYPE   :  8;               /*!< (null)                                                                */
      __I  uint32_t  MOD_NUMBER : 16;               /*!< (null)                                                                */
    } ID_b;                                         /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  FDR;                             /*!< Register divider                                                      */
    
    struct {
      __IO uint32_t  STEP       : 10;               /*!< (null)                                                                */
           uint32_t             :  1;
      __IO uint32_t  SM         :  1;               /*!< Select the transition mode Suspend                                    */
      __IO uint32_t  SC         :  2;               /*!< (null)                                                                */
      __IO uint32_t  DM         :  2;               /*!< (null)                                                                */
      __I  uint32_t  RESULT     : 10;               /*!< (null)                                                                */
           uint32_t             :  2;
      __I  uint32_t  SUSACK     :  1;               /*!< Indicate mode Suspend                                                 */
      __I  uint32_t  SUSREQ     :  1;               /*!< Activate Suspend mode                                                 */
      __IO uint32_t  ENHW       :  1;               /*!< Control bit synchronization                                           */
      __IO uint32_t  DISCLK     :  1;               /*!< Disable bit internal clock                                            */
    } FDR_b;                                        /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED1[60];
  NT_CAN_LIST_Type LIST[8];                         /*!< LIST                                                                  */
  __I  uint32_t  RESERVED2[8];
  NT_CAN_MSPND_Type MSPND[8];                       /*!< MSPND                                                                 */
  __I  uint32_t  RESERVED3[8];
  NT_CAN_MSID_Type MSID[8];                         /*!< MSID                                                                  */
  __I  uint32_t  RESERVED4[8];
  
  union {
    __IO uint32_t  MSIMASK;                         /*!< Mask register message index                                           */
    
    struct {
      __IO uint32_t  IM         : 32;               /*!< (null)                                                                */
    } MSIMASK_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  PANCTR;                          /*!< Register command panel                                                */
    
    struct {
      __IO uint32_t  PANCMD     :  8;               /*!< (null)                                                                */
      __I  uint32_t  BUSY       :  1;               /*!< Busy flag panels arguments (waiting to be written at the end
                                                         of the command)                                                       */
      __I  uint32_t  RBUSY      :  1;               /*!< Busy flag panels arguments (running the command list, the result
                                                         of which will be recorded in PANAR1 and PANAR2)                       */
           uint32_t             :  6;
      __IO uint32_t  PANAR1     :  8;               /*!< Panel argument 8                                                      */
      __IO uint32_t  PANAR2     :  8;               /*!< Panel argument 9                                                      */
    } PANCTR_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MCR_REG;                         /*!< No description                                                        */
    
    struct {
           uint32_t             : 12;
      __IO uint32_t  MPSEL      :  4;               /*!< (null)                                                                */
    } MCR_REG_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  MITR;                            /*!< Interrupt register                                                    */
    
    struct {
      __O  uint32_t  IT         : 16;               /*!< (null)                                                                */
    } MITR_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED5[12];
  NT_CAN_CAN_Node_Type CAN_Node[2];                 /*!< CAN_Node                                                              */
  __I  uint32_t  RESERVED6[768];
  NT_CAN_CAN_Msg_Type CAN_Msg[256];                 /*!< CAN_Msg                                                               */
} NT_CAN_Type;


/* ================================================================================ */
/* ================                   NT_ETHERNET                  ================ */
/* ================================================================================ */


/**
  * @brief ETHERNET controller registers (NT_ETHERNET)
  */

typedef struct {                                    /*!< NT_ETHERNET Structure                                                 */
  
  union {
    __IO uint32_t  MAC1;                            /*!< MAC configuration register 1                                          */
    
    struct {
      __IO uint32_t  RXENABLE   :  1;               /*!< Frame reception enable bit                                            */
      __IO uint32_t  PASSALL    :  1;               /*!< Bit control PASS                                                      */
      __IO uint32_t  RXPAUSE    :  1;               /*!< Enable receiving a pause as part of Frame                             */
      __IO uint32_t  TXPAUSE    :  1;               /*!< Enable transmission pauses Frame                                      */
      __IO uint32_t  LOOPBACK   :  1;               /*!< Bit activate reception of packets transmitted back through MACReceive-inte
                                                         rface                                                                 */
           uint32_t             :  3;
      __IO uint32_t  RESETTFUN  :  1;               /*!< Reset bit logic devices packet                                        */
      __IO uint32_t  RESETTMCS  :  1;               /*!< Reset bit device MAC layer, responsible for managing addresses
                                                         in information transmission Reset bit device MAC layer, responsible
                                                          for managing addresses in information transmission                   */
      __IO uint32_t  RESETRFUN  :  1;               /*!< Reset bit logic devices receive packets                               */
      __IO uint32_t  RESETRMCS  :  1;               /*!< Reset bit device MAC layer, responsible for managing the filtering
                                                         addresses of packets received                                         */
           uint32_t             :  2;
      __IO uint32_t  SIMRESET   :  1;               /*!< Reset bit random number generator transmitting device                 */
      __IO uint32_t  SOFTRESET  :  1;               /*!< Reset bit block MAC Ethernet Controller                               */
    } MAC1_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MAC2;                            /*!< MAC configuration register 2                                          */
    
    struct {
      __IO uint32_t  FULLDUPLEX :  1;               /*!< Mode Select bit MAC-run operations                                    */
      __IO uint32_t  LENGTHCHECK:  1;               /*!< Enable bit komparatsii length Frame                                   */
      __IO uint32_t  HUGEFRAME  :  1;               /*!< Enable Bit Frame reception and transmission of arbitrary length       */
      __IO uint32_t  DALAYCRC   :  1;               /*!< Enable bit adding a 4-byte CRC                                        */
      __IO uint32_t  CRCENABLE  :  1;               /*!< Enable bit CRC inserter                                               */
      __IO uint32_t  PADENABLE  :  1;               /*!< Bit resolution and functioning bits AUTOPAD VLANPAD                   */
      __IO uint32_t  VLANPAD    :  1;               /*!< Enable bit short additions Frame                                      */
      __IO uint32_t  AUTOPAD    :  1;               /*!< Bit enable automatic determination of type Frame                      */
      __IO uint32_t  PUREPRE    :  1;               /*!< Bit enable validation preamble                                        */
      __IO uint32_t  LONGPRE    :  1;               /*!< Select bit preamble length packets received                           */
           uint32_t             :  2;
      __IO uint32_t  NOBACKOFF  :  1;               /*!< Bit parameter setting retransmission in conflict                      */
      __IO uint32_t  BP_NOBACKOFF:  1;              /*!< Enable bit retransmission in conflict                                 */
      __IO uint32_t  EXCESSDEF  :  1;               /*!< Mode Select bit packet processing                                     */
    } MAC2_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  IPGT;                            /*!< Register Back-to-Back Inter-Packet-Gap                                */
    
    struct {
      __IO uint32_t  BTBIPG_TRANS:  7;              /*!< (null)                                                                */
    } IPGT_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  IPGR;                            /*!< Register Non-Back-to-Back Inter-Packet-Gap                            */
    
    struct {
      __IO uint32_t  NBTBIPG_TRANS_PART2:  7;       /*!< (null)                                                                */
           uint32_t             :  1;
      __IO uint32_t  NBTBIPG_TRANS_PART1:  7;       /*!< (null)                                                                */
    } IPGR_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CLRT;                            /*!< Register collision window                                             */
    
    struct {
      __IO uint32_t  RETRANS_MAX:  4;               /*!< (null)                                                                */
           uint32_t             :  4;
      __IO uint32_t  COLLISION_WINDOW:  6;          /*!< (null)                                                                */
    } CLRT_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MAXF;                            /*!< Register the upper limit size Frame                                   */
    
    struct {
      __IO uint32_t  MAXFRAME_LENGTH: 16;           /*!< (null)                                                                */
    } MAXF_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SUPP;                            /*!< Register PHY-support interface                                        */
    
    struct {
      __IO uint32_t  BITMODE    :  1;               /*!< Activated mode 10BASE-T ENDEC                                         */
      __IO uint32_t  ENBLJABBER :  1;               /*!< Enable bit of protection against incorrect data transmission
                                                         mode 10T ENDEC                                                        */
           uint32_t             :  1;
      __IO uint32_t  RESET10T   :  1;               /*!< Reset bit module, which converts the MII nibble streams into
                                                         a serial bit stream mode transceiver 10T                              */
      __IO uint32_t  LINKFAIL   :  1;               /*!< Bit resolution modeling                                               */
      __IO uint32_t  NOCIPHER   :  1;               /*!< Select encryption                                                     */
      __IO uint32_t  FORCEQUIET :  1;               /*!< enable encryption                                                     */
      __IO uint32_t  RESET100X  :  1;               /*!< Reset bit of the module that contains the logic of the encoder
                                                         / decoder bit characters 4/5 bits                                     */
      __IO uint32_t  SPEED      :  1;               /*!< Bits set the operating speed simplified MII                           */
           uint32_t             :  2;
      __IO uint32_t  RESETRMII  :  1;               /*!< Reset bit simplified logic MII                                        */
      __IO uint32_t  PHYMODE    :  1;               /*!< Bit configuration consistent with MI SMII-connected devices           */
           uint32_t             :  2;
      __IO uint32_t  RESETINT   :  1;               /*!< Reset bit of the physical interface                                   */
    } SUPP_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED;
  
  union {
    __IO uint32_t  MCFG;                            /*!< Configuration control register MII                                    */
    
    struct {
      __IO uint32_t  SCANINC    :  1;               /*!< Reading module addresses all MII PHY                                  */
      __IO uint32_t  NOPRE      :  1;               /*!< Control bit preamble                                                  */
      __IO uint32_t  CLOCK_SELECT:  3;              /*!< (null)                                                                */
           uint32_t             : 10;
      __IO uint32_t  RESETMGMT  :  1;               /*!< Reset bit MII management module                                       */
    } MCFG_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MCMD;                            /*!< Command register MII                                                  */
    
    struct {
      __IO uint32_t  READ       :  1;               /*!< Single execution of read cycles                                       */
      __IO uint32_t  SCAN       :  1;               /*!< Continuous performance of read cycles                                 */
    } MCMD_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MADR;                            /*!< MII address register                                                  */
    
    struct {
      __IO uint32_t  REG_ADDRESS:  5;               /*!< (null)                                                                */
           uint32_t             :  3;
      __IO uint32_t  PHY_ADDRESS:  5;               /*!< (null)                                                                */
    } MADR_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MWTD;                            /*!< Register data written in MII                                          */
    
    struct {
      __O  uint32_t  WRITE_DATA : 16;               /*!< (null)                                                                */
    } MWTD_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MRDD;                            /*!< Register read data from MII                                           */
    
    struct {
      __I  uint32_t  READ_DATA  : 16;               /*!< (null)                                                                */
    } MRDD_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  MIND;                            /*!< MII status register flags                                             */
    
    struct {
      __I  uint32_t  BUSY       :  1;               /*!< Flag continuing cycle of the read / write control MII                 */
      __I  uint32_t  SCAN       :  1;               /*!< Flag ongoing scan operation (continue reading cycles control
                                                         MII)                                                                  */
      __I  uint32_t  NOTVALID   :  1;               /*!< Flag unfinished read cycle MII (inaccessibility of data to be
                                                         read)                                                                 */
      __I  uint32_t  LINKFAIL   :  1;               /*!< Failure flag control MII (PHY device management)                      */
    } MIND_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  SMII;                            /*!< MII controller status register                                        */
    
    struct {
      __I  uint32_t  SPEED      :  1;               /*!< Speed Indicator                                                       */
      __I  uint32_t  DUPLEX     :  1;               /*!< Mode indicator                                                        */
      __I  uint32_t  LINK       :  1;               /*!< Status Indicator LINK                                                 */
      __I  uint32_t  JABBER     :  1;               /*!< Flag of conditions Jabber                                             */
      __I  uint32_t  CLASH      :  1;               /*!< Flag of the selected mode                                             */
    } SMII_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  FIFOCFG;                         /*!< MIIFIFO configurate register                                          */
    
    struct {
      __IO uint32_t  RST        :  5;               /*!< Reset MIIFIFO                                                         */
           uint32_t             :  3;
      __IO uint32_t  ENREQ      :  5;               /*!< Enable request MIIFIFO                                                */
           uint32_t             :  3;
      __I  uint32_t  ENRPLY     :  5;               /*!< Indicate enable MIIFIFO                                               */
    } FIFOCFG_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SA0;                             /*!< Station address register 0                                            */
    
    struct {
      __IO uint32_t  STATION_ADDRESS_2B:  8;        /*!< (null)                                                                */
      __IO uint32_t  STATION_ADDRESS_1B:  8;        /*!< (null)                                                                */
    } SA0_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SA1;                             /*!< Station address register 1                                            */
    
    struct {
      __IO uint32_t  STATION_ADDRESS_4B:  8;        /*!< (null)                                                                */
      __IO uint32_t  STATION_ADDRESS_3B:  8;        /*!< (null)                                                                */
    } SA1_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SA2;                             /*!< Station address register 2                                            */
    
    struct {
      __IO uint32_t  STATION_ADDRESS_6B:  8;        /*!< (null)                                                                */
      __IO uint32_t  STATION_ADDRESS_5B:  8;        /*!< (null)                                                                */
    } SA2_b;                                        /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED1[77];
  
  union {
    __IO uint32_t  DMATxCtrl;                       /*!< Reception control register                                            */
    
    struct {
      __IO uint32_t  RXENABLE   :  1;               /*!< Enable bit DMA device to receive packets                              */
    } DMATxCtrl_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DMATxDescriptor;                 /*!< Reception descriptor pointer register                                 */
    
    struct {
           uint32_t             :  2;
      __IO uint32_t  DADDR      : 30;               /*!< (null)                                                                */
    } DMATxDescriptor_b;                            /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DMATxStatus;                     /*!< Status transmission register                                          */
    
    struct {
      __IO uint32_t  TXPKTREC   :  1;               /*!< Flag successfully transmit one or more packets                        */
           uint32_t             :  1;
      __IO uint32_t  TXOVERFLOW :  1;               /*!< Data Indicator                                                        */
      __IO uint32_t  BUSERROR   :  1;               /*!< Flag a bus error                                                      */
           uint32_t             : 12;
      __IO uint32_t  TX_PKT_COUNT:  8;              /*!< (null)                                                                */
    } DMATxStatus_b;                                /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DMARxCtrl;                       /*!< Control receive register                                              */
    
    struct {
      __IO uint32_t  RXENABLE   :  1;               /*!< Enable receive                                                        */
    } DMARxCtrl_b;                                  /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DMARxDescriptor;                 /*!< Pointer receive descriptor register                                   */
    
    struct {
           uint32_t             :  2;
      __IO uint32_t  DADDR      : 30;               /*!< (null)                                                                */
    } DMARxDescriptor_b;                            /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DMARxStatus;                     /*!< Status receiving register                                             */
    
    struct {
      __IO uint32_t  RXPKTREC   :  1;               /*!< Flag successfully receive one or more packets                         */
           uint32_t             :  1;
      __IO uint32_t  TXOVERFLOW :  1;               /*!< Data Indicator                                                        */
      __IO uint32_t  BUSERROR   :  1;               /*!< Flag a bus error                                                      */
           uint32_t             : 12;
      __IO uint32_t  RX_PKT_COUNT:  8;              /*!< (null)                                                                */
    } DMARxStatus_b;                                /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DMAINTMASK;                      /*!< Mask interrupt register                                               */
    
    struct {
      __I  uint32_t  TXPKTSENT  :  1;               /*!< (null)                                                                */
      __I  uint32_t  TXUNDERRRUN:  1;               /*!< (null)                                                                */
           uint32_t             :  1;
      __I  uint32_t  BUSERR_TX  :  1;               /*!< (null)                                                                */
      __I  uint32_t  RXPKTREC   :  1;               /*!< (null)                                                                */
           uint32_t             :  1;
      __I  uint32_t  RXOVER     :  1;               /*!< (null)                                                                */
      __I  uint32_t  BUSERR_RX  :  1;               /*!< (null)                                                                */
    } DMAINTMASK_b;                                 /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DMAINT;                          /*!< Interrupt register                                                    */
    
    struct {
      __I  uint32_t  TXPKTSENT  :  1;               /*!< (null)                                                                */
      __I  uint32_t  TXUNDERRRUN:  1;               /*!< (null)                                                                */
           uint32_t             :  1;
      __I  uint32_t  BUSERR_TX  :  1;               /*!< (null)                                                                */
      __I  uint32_t  RXPKTREC   :  1;               /*!< (null)                                                                */
           uint32_t             :  1;
      __I  uint32_t  RXOVER     :  1;               /*!< (null)                                                                */
      __I  uint32_t  BUSERR_RX  :  1;               /*!< (null)                                                                */
    } DMAINT_b;                                     /*!< BitSize                                                               */
  };
} NT_ETHERNET_Type;


/* ================================================================================ */
/* ================                   NT_USBHost                   ================ */
/* ================================================================================ */


/**
  * @brief USB Host controller registers (NT_USBHost)
  */

typedef struct {                                    /*!< NT_USBHost Structure                                                  */
  
  union {
    __I  uint32_t  VERSION;                         /*!< Host controller USB version register                                  */
    
    struct {
      __I  uint32_t  VERSION    :  8;               /*!< (null)                                                                */
    } VERSION_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  USBCMD_STS_INTR;                 /*!< HC Control register 1                                                 */
    
    struct {
           uint32_t             :  1;
      __I  uint32_t  OUTSPACEINTEN:  1;             /*!< Hardware interrupt enable bit                                         */
      __O  uint32_t  INDATAREADYINTEN:  1;          /*!< Enable interrupt InDataReady                                          */
      __O  uint32_t  FRAMESOFINTEN:  1;             /*!< Enable interrupt Frame sof                                            */
      __O  uint32_t  MICROFRAMEINTEN:  1;           /*!< Enable interrupt Microframe soa                                       */
           uint32_t             :  1;
      __O  uint32_t  PORTCHANGINTEN:  1;            /*!< Enable interrupt Port change detect                                   */
           uint32_t             :  3;
      __IO uint32_t  FRAMESOFINT:  1;               /*!< Interrupt flag Framesof                                               */
      __IO uint32_t  MICROFRAMEINT:  1;             /*!< Interrupt flag Microframesof                                          */
           uint32_t             :  1;
      __IO uint32_t  PORTCHANGINT:  1;              /*!< Indicate the any port has a change bit transmission from 0 to
                                                         1                                                                     */
           uint32_t             :  1;
      __I  uint32_t  HCHALTED   :  1;               /*!< Indicator controller stop                                             */
      __IO uint32_t  RUN_STOP   :  1;               /*!< Perfoms data                                                          */
      __IO uint32_t  HOSTRESET  :  1;               /*!< Initial state of USB-controller                                       */
      __IO uint32_t  CONFIGFLAG :  1;               /*!< Configurate flag                                                      */
           uint32_t             :  5;
      __I  uint32_t  INT_SPACE  :  8;               /*!< (null)                                                                */
    } USBCMD_STS_INTR_b;                            /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  FRAME_REG;                       /*!< Register version                                                      */
    
    struct {
      __IO uint32_t  FRAMEINDEX : 14;               /*!< Field of the countdown                                                */
           uint32_t             :  2;
      __I  uint32_t  FRAMELENGTH:  6;               /*!< Micro frame length                                                    */
    } FRAME_REG_b;                                  /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED;
  
  union {
    __IO uint32_t  PORT_STS;                        /*!< HC Control register 2                                                 */
    
    struct {
      __IO uint32_t  PORTCONNECT:  1;               /*!< Indicator device connection                                           */
      __IO uint32_t  PORTCONCHNG:  1;               /*!< Indicator status change bit PORTCONNECT                               */
      __IO uint32_t  PORTENABLE :  1;               /*!< Enable bit port                                                       */
      __IO uint32_t  PORTEN_DISCHNG:  1;            /*!< Indicator status change bit PORTENABLE                                */
      __IO uint32_t  PORTRESET  :  1;               /*!< Setting bit starts the reset procedure in accordance with USB2.0      */
      __I  uint32_t  LINESTATE  :  2;               /*!< Field reflect the current logic level signals D + and D-              */
      __I  uint32_t  PORTOWNER0 :  1;               /*!< Bit with bit PORTOWNER1 assignment of the port speed                  */
      __IO uint32_t  SUSPEND    :  1;               /*!< Bit suspension of work                                                */
      __IO uint32_t  FORCEPORTRESUME:  1;           /*!< Flag resume                                                           */
      __IO uint32_t  XCVRRESET  :  1;               /*!< Reset bit transceiver                                                 */
      __IO uint32_t  XCVRRESLEVEL:  1;              /*!< Bit setting active level reset signal transceiver                     */
      __IO uint32_t  XCVRSUSPEND:  1;               /*!< (null)                                                                */
      __IO uint32_t  TESTJ      :  1;               /*!< keep in line condition HS J                                           */
      __IO uint32_t  TESTK      :  1;               /*!< Enable keep in line condition HS K                                    */
      __IO uint32_t  TESTSEO    :  1;               /*!< Enable keep in line condition SEO                                     */
      __IO uint32_t  TESTFORCEEN:  1;               /*!< Enable transmit packets looped                                        */
      __IO uint32_t  TESTPKT    :  1;               /*!< Bits select the standard USB                                          */
      __I  uint32_t  PORTOWNER1 :  1;               /*!< Indicator low-speed devices                                           */
    } PORT_STS_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  USB_PKT_FIELDS_A;                /*!< Transmission Control register A                                       */
    
    struct {
      __IO uint32_t  EP_ADDR    :  4;               /*!< (null)                                                                */
      __IO uint32_t  PID        :  2;               /*!< (null)                                                                */
      __IO uint32_t  ENDPOINTTYPE:  2;              /*!< Buffer type                                                           */
      __IO uint32_t  DEV_ADDR   :  7;               /*!< (null)                                                                */
      __IO uint32_t  IOC        :  1;               /*!< Bits specify the behavior of the host controller when transfer        */
      __IO uint32_t  PORT_NUMBER:  7;               /*!< (null)                                                                */
      __IO uint32_t  DATATOGGLE :  1;               /*!< Identifier field data to be used in the current transmission          */
      __IO uint32_t  HUB_ADDRESS:  7;               /*!< (null)                                                                */
      __IO uint32_t  ENTRANSFER :  1;               /*!< Beginning of the current permission bits of data                      */
    } USB_PKT_FIELDS_A_b;                           /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  USB_PKT_FIELDS_B;                /*!< Transmission Control register B                                       */
    
    struct {
      __IO uint32_t  MPS        : 11;               /*!< (null)                                                                */
      __IO uint32_t  ABORTTRANSFER:  1;             /*!< Bit the current operation                                             */
      __IO uint32_t  XFRLEVEL   :  1;               /*!< (null)                                                                */
      __IO uint32_t  IGNORSHORTPKT:  1;             /*!< Enable bit ignore short packets                                       */
      __IO uint32_t  EFIELD     :  1;               /*!< Bit transmission control                                              */
      __IO uint32_t  SPEED      :  1;               /*!< Indicator the type of device connected to the router and port         */
      __IO uint32_t  COMPLETESPLIT:  1;             /*!< Complete bit operations such as Split                                 */
      __IO uint32_t  STARTSPLIT :  1;               /*!< Bit run operations such as Split                                      */
           uint32_t             :  2;
      __IO uint32_t  MAX_ERR_CNT:  4;               /*!< Field the maximum number of consecutive transmission errors           */
      __IO uint32_t  MAX_NAK_CNT:  4;               /*!< Maximum number of labels NAK, which is allowed to accept the
                                                         host.                                                                 */
      __IO uint32_t  SLAVEMODE  :  1;               /*!< Enable slave mode                                                     */
           uint32_t             :  2;
      __IO uint32_t  OHCIENABLE :  1;               /*!< Demand indicator                                                      */
    } USB_PKT_FIELDS_B_b;                           /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  BUFF_START_ADDR;                 /*!< Bufer start address register                                          */
    
    struct {
      __IO uint32_t  BUFFSTARTADDR: 32;             /*!< (null)                                                                */
    } BUFF_START_ADDR_b;                            /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  TBT;                             /*!< Transmission data register                                            */
    
    struct {
      __IO uint32_t  TOTALBTRANS: 20;               /*!< Total Byte transfer                                                   */
    } TBT_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  USB_STATUS;                      /*!< XFR STATUS register                                                   */
    
    struct {
           uint32_t             :  8;
      __I  uint32_t  UNEXPPID   :  1;               /*!< Receiving flag PID, different from the expected                       */
      __I  uint32_t  SHORTPKT   :  1;               /*!< Flag receiving fewer bits than indicated in the register TOTAL_BYTES_TRANS
                                                         TBT                                                                   */
      __I  uint32_t  ERRPID     :  1;               /*!< Flag to receive a response to the label ERROR PID Complete Split      */
      __I  uint32_t  OUTSPACEVAILABLE:  1;          /*!< Request flag outbound operation with an empty data buffer             */
      __I  uint32_t  INDATAREADY:  1;               /*!< Flag successful completion of an inbound operation                    */
      __I  uint32_t  PIDERR     :  1;               /*!< Receiving flag incorrect PID                                          */
      __I  uint32_t  CRCERR     :  1;               /*!< CRC error in receiving data                                           */
      __I  uint32_t  TOGGLEERR  :  1;               /*!< Receiving flag bit wrong DATATOGGLE                                   */
      __I  uint32_t  TIMEOUT    :  1;               /*!< Flag timeout response                                                 */
      __I  uint32_t  NYET       :  1;               /*!< Receiving flag tags NYET                                              */
      __I  uint32_t  NAK        :  1;               /*!< Receiving flag tags NAK                                               */
      __I  uint32_t  PAGECROSS  :  1;               /*!< Flag requirements transmission pagecross                              */
      __I  uint32_t  PING       :  1;               /*!< Flag response                                                         */
      __I  uint32_t  XACTNERR   :  1;               /*!< (null)                                                                */
      __I  uint32_t  BABBLE     :  1;               /*!< Flag of finding the system in state Packet Babble                     */
      __I  uint32_t  HALTED     :  1;               /*!< Flag of finding the system in state Stall or Packet Babble            */
      __I  uint32_t  USBINT     :  1;               /*!< Flag of the last operation                                            */
      __I  uint32_t  USBERRINT  :  1;               /*!< Error flag that indicates that the last operation was completed
                                                         due to an erroneous bus state                                         */
    } USB_STATUS_b;                                 /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED1;
  
  union {
    __IO uint32_t  Data_Buffer;                     /*!< Data buffer register                                                  */
    
    struct {
      __IO uint32_t  DATA       : 32;               /*!< Data Buffer                                                           */
    } Data_Buffer_b;                                /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  SLAVE_IN_COUNT;                  /*!< Register received data                                                */
    
    struct {
      __I  uint32_t  BYTECOUNT  : 11;               /*!< Indication of the number of bytes received from the device when
                                                         prompted interruption 'Data ready'                                    */
    } SLAVE_IN_COUNT_b;                             /*!< BitSize                                                               */
  };
} NT_USBHost_Type;


/* ================================================================================ */
/* ================                  NT_USBDevice                  ================ */
/* ================================================================================ */


/**
  * @brief USB Device controller registers (NT_USBDevice)
  */

typedef struct {                                    /*!< NT_USBDevice Structure                                                */
  
  union {
    __IO uint32_t  IRQ_STAT_L;                      /*!< Interrupt status register                                             */
    
    struct {
      __IO uint32_t  USBBUSINT  :  1;               /*!< Interrupt flag events on the USB bus                                  */
      __IO uint32_t  CEP_INT    :  1;               /*!< Interrupt flag Control EndPoint                                       */
      __IO uint32_t  EP0_INT    :  1;               /*!< Interrupt flags EndPoint 1                                            */
      __IO uint32_t  EP1_INT    :  1;               /*!< Interrupt flags EndPoint 2                                            */
    } IRQ_STAT_L_b;                                 /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED;
  
  union {
    __IO uint32_t  IRQ_ENB_L;                       /*!< Interrupt enable register                                             */
    
    struct {
      __IO uint32_t  USBBUSINTEN:  1;               /*!< Enable interrupts from the events on the USB bus                      */
      __IO uint32_t  CEP_INTEN  :  1;               /*!< Interrupt enable for Control EndPoint                                 */
      __IO uint32_t  EP0_INTEN  :  1;               /*!< Interrupt enable for EndPoint 1                                       */
      __IO uint32_t  EP1_INTEN  :  1;               /*!< Interrupt enable for EndPoint 2                                       */
    } IRQ_ENB_L_b;                                  /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED1;
  
  union {
    __IO uint32_t  USB_IRQ_STAT;                    /*!< USB Interrupt status register                                         */
    
    struct {
      __IO uint32_t  SOF        :  1;               /*!< Flag SOF packet reception                                             */
      __IO uint32_t  RESSTATUS  :  1;               /*!< Completion flag reset the root port                                   */
      __IO uint32_t  RESUME     :  1;               /*!< Flag reactivate the device                                            */
      __IO uint32_t  SUSPENDREQ :  1;               /*!< SUSPEND mode request bit                                              */
      __IO uint32_t  HIGHSPEEDSETTLE:  1;           /*!< Completion flag reset and switching devices in high-speed mode        */
      __IO uint32_t  DMACMPLINT :  1;               /*!< Completion flag DMA data transfer                                     */
      __IO uint32_t  CLKUNSTBLINT:  1;              /*!< Interrupt flag, signaling an unstable clock signal UTMI and
                                                         to initialize the device controller registers                         */
    } USB_IRQ_STAT_b;                               /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  USB_IRQ_ENB;                     /*!< USB Interrupt enable register                                         */
    
    struct {
      __IO uint32_t  SOFINTEN   :  1;               /*!< Enable SOF packet reception                                           */
      __IO uint32_t  RESSTATUSINTEN:  1;            /*!< Enable completion reset the root port                                 */
      __IO uint32_t  RESUMEINTEN:  1;               /*!< Enable reactivate the device                                          */
      __IO uint32_t  SUSPENDINTEN:  1;              /*!< Enable SUSPEND mode request bit                                       */
      __IO uint32_t  HISPEEDINTEN:  1;              /*!< Enable completion reset and switching devices in high-speed
                                                         mode                                                                  */
      __IO uint32_t  DMACMPLINTEN:  1;              /*!< Enable completion DMA data transfer                                   */
      __IO uint32_t  CLKUNSTBLINTEN:  1;            /*!< Enable interrupt, signaling an unstable clock signal UTMI and
                                                         to initialize the device controller registers                         */
    } USB_IRQ_ENB_b;                                /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  USB_OPER;                        /*!< USB Operations register                                               */
    
    struct {
      __IO uint32_t  GEN_RESUME :  1;               /*!< Bit start recovery work                                               */
      __IO uint32_t  HIGHSPEED  :  1;               /*!< Trigger bit protocol 'Chirp'                                          */
      __IO uint32_t  CURRENTSPEED:  1;              /*!< Speed indication device controller 1-High speed; 0 - Full speed       */
    } USB_OPER_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  USB_FRAME_CNT;                   /*!< USB Frame counter register                                            */
    
    struct {
      __I  uint32_t  MICRO_FRAME_COUNTER:  3;       /*!< Number field current a chip                                           */
      __I  uint32_t  FRAME_COUNTER: 11;             /*!< Field frame counter since last SOF packet                             */
    } USB_FRAME_CNT_b;                              /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  USB_ADDR;                        /*!< USB Address register                                                  */
    
    struct {
      __IO uint32_t  CURRENT_ADDR:  6;              /*!< Field of the current address of the device                            */
      __IO uint32_t  USBADDR    :  1;               /*!< Field of the current address of the device                            */
    } USB_ADDR_b;                                   /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED2;
  
  union {
    __IO uint32_t  CEP_DATA_BUF;                    /*!< Data buffer for transmission register of Control EndPoint             */
    
    struct {
      __IO uint32_t  DATA_BUF   : 16;               /*!< Data buffer for transmission                                          */
    } CEP_DATA_BUF_b;                               /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CEP_CTRL_STAT;                   /*!< Control register and buffer status of Control EndPoint                */
    
    struct {
      __IO uint32_t  NAKCLEAR   :  1;               /*!< Receiving flag tags SETIP                                             */
      __IO uint32_t  STALL      :  1;               /*!< Enable sending 'Stall'                                                */
      __IO uint32_t  ZEROLEN    :  1;               /*!< Enable transmission zero length packet                                */
      __IO uint32_t  CEPFLUSH   :  1;               /*!< Reset buffer                                                          */
    } CEP_CTRL_STAT_b;                              /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CEP_IRQ_ENB;                     /*!< Interrupt Enable buffer register of Control EndPoint                  */
    
    struct {
      __IO uint32_t  SETUPTOKENINT:  1;             /*!< Enable flag deadline tags SETUP from the host                         */
      __IO uint32_t  SETUPPKTINT:  1;               /*!< Enable flag deadline Setup package from the host                      */
      __IO uint32_t  OUTTOKENINT:  1;               /*!< Enable reception end flag tags OUT from the host                      */
      __IO uint32_t  INTOKENINT :  1;               /*!< Enable reception end flag tags IN from the host                       */
      __IO uint32_t  PINGTOKENINT:  1;              /*!< Enable reception end flag tags PING from host                         */
      __IO uint32_t  DATAPKTTRINT:  1;              /*!< Enable flag successful sending of the data packet in response
                                                         to the label to obtain IN ACK confirming tags                         */
      __IO uint32_t  DATAPKTRECINT:  1;             /*!< Enable flag successful reception of the data packet following
                                                         the label OUT, in response to which the mark has been sent ACK        */
      __IO uint32_t  NAKSENTINT :  1;               /*!< Enable flag closure parcel labels NAK in response to mark IN
                                                         or OUT                                                                */
      __IO uint32_t  STALLSENTINT:  1;              /*!< Enable flag closure parcel labels STALL in response to mark
                                                         IN or OUT                                                             */
      __IO uint32_t  USBERRINT  :  1;               /*!< Enable error flag during the operation                                */
      __IO uint32_t  STATCMPLNINT:  1;              /*!< Enable flag successful completion stage 'Status' operations
                                                         on the USB bus                                                        */
      __IO uint32_t  BUFFFULLINT:  1;               /*!< Enable flag filling control buffer                                    */
      __IO uint32_t  BUFFEMPTYINT:  1;              /*!< Enable flag emptying control buffer                                   */
    } CEP_IRQ_ENB_b;                                /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CEP_IRQ_STAT;                    /*!< Buffer interrupt flag register of Control EndPoint                    */
    
    struct {
      __IO uint32_t  SETUPTOKENINT:  1;             /*!< Flag deadline tags SETUP from the host                                */
      __IO uint32_t  SETUPPKTINT:  1;               /*!< Flag deadline Setup package from the host                             */
      __IO uint32_t  OUTTOKENINT:  1;               /*!< Reception end flag tags OUT from the host                             */
      __IO uint32_t  INTOKENINT :  1;               /*!< Reception end flag tags IN from the host                              */
      __IO uint32_t  PINGTOKENINT:  1;              /*!< Reception end flag tags PING from host                                */
      __IO uint32_t  DATAPKTTRINT:  1;              /*!< Flag successful sending of the data packet in response to the
                                                         label to obtain IN ACK confirming tags                                */
      __IO uint32_t  DATAPKTRECINT:  1;             /*!< Flag successful reception of the data packet following the label
                                                         OUT, in response to which the mark has been sent ACK                  */
      __IO uint32_t  NAKSENTINT :  1;               /*!< Flag closure parcel labels NAK in response to mark IN or OUT          */
      __IO uint32_t  STALLSENTINT:  1;              /*!< Flag closure parcel labels STALL in response to mark IN or OUT        */
      __IO uint32_t  USBERRINT  :  1;               /*!< The error flag during the operation                                   */
      __IO uint32_t  STATCMPLNINT:  1;              /*!< Flag successful completion stage 'Status' operations on the
                                                         USB bus                                                               */
      __I  uint32_t  BUFFFULLINT:  1;               /*!< Flag filling control buffer                                           */
      __I  uint32_t  BUFFEMPTYINT:  1;              /*!< Flag control buffer emptying                                          */
    } CEP_IRQ_STAT_b;                               /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CEP_IN_XFRCNT;                   /*!< In transfer data count register of Control EndPoint                   */
    
    struct {
      __IO uint32_t  DATACOUNT  : 16;               /*!< The number of bytes to be sent in response to a label IN              */
    } CEP_IN_XFRCNT_b;                              /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  CEP_OUT_XFRCNT;                  /*!< Out-transfer data count register of Control EndPoint                  */
    
    struct {
      __I  uint32_t  DATACOUNT  : 16;               /*!< The number of bytes received of data                                  */
    } CEP_OUT_XFRCNT_b;                             /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED3;
  
  union {
    __I  uint32_t  CEP_SETUP1_0;                    /*!< Register zero and first byte packet Setup of Control EndPoint
                                                                                                                               */
    
    struct {
      __I  uint32_t  SETUPPKT_0B:  8;               /*!< destination                                                           */
      __I  uint32_t  SETUPPKT_1B:  8;               /*!< The first byte of the packet Setup                                    */
    } CEP_SETUP1_0_b;                               /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  CEP_SETUP3_2;                    /*!< Register 2nd and 3rd bytes of the packet Setup of Control EndPoint
                                                                                                                               */
    
    struct {
      __I  uint32_t  SETUPPKT_2B:  8;               /*!< Low byte field wValue                                                 */
      __I  uint32_t  SETUPPKT_3B:  8;               /*!< High byte field wValue                                                */
    } CEP_SETUP3_2_b;                               /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  CEP_SETUP5_4;                    /*!< Register 4th and 5th bytes of the packet Setup of Control EndPoint
                                                                                                                               */
    
    struct {
      __I  uint32_t  SETUPPKT_4B:  8;               /*!< Low byte field windex                                                 */
      __I  uint32_t  SETUPPKT_5B:  8;               /*!< High byte field windex                                                */
    } CEP_SETUP5_4_b;                               /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  CEP_SETUP7_6;                    /*!< Register on the 6th and 7th byte packet Setup of Control EndPoint
                                                                                                                               */
    
    struct {
      __I  uint32_t  SETUPPKT_6B:  8;               /*!< Low byte field wLength                                                */
      __I  uint32_t  SETUPPKT_7B:  8;               /*!< High byte field wLength                                               */
    } CEP_SETUP7_6_b;                               /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CEP_START_ADDR;                  /*!< Control EndPoint RAM start Addr register                              */
    
    struct {
      __IO uint32_t  STARTADDR  : 16;               /*!< (null)                                                                */
    } CEP_START_ADDR_b;                             /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CEP_END_ADDR;                    /*!< Control EndPoint RAM end Addr register                                */
    
    struct {
      __IO uint32_t  ENDADDR    : 16;               /*!< (null)                                                                */
    } CEP_END_ADDR_b;                               /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DMA_CTRL_STS;                    /*!< Register control DMA                                                  */
    
    struct {
      __IO uint32_t  DMA_EP_ADDR:  4;               /*!< (null)                                                                */
      __IO uint32_t  DMARW      :  1;               /*!< Type DMA operations 1-Read, 0-Write                                   */
      __IO uint32_t  DMAEN      :  1;               /*!< Enable DMA                                                            */
    } DMA_CTRL_STS_b;                               /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DMA_CNT;                         /*!< DMA Count byte Register                                               */
    
    struct {
      __IO uint32_t  DMA_CNT    : 16;               /*!< (null)                                                                */
    } DMA_CNT_b;                                    /*!< BitSize                                                               */
  };
  NT_USBDevice_USB_EP_Type USB_EP[2];               /*!< USB_EP                                                                */
  __I  uint32_t  RESERVED4[403];
  
  union {
    __IO uint32_t  AHB_DMA_ADDR;                    /*!< AHB addr register                                                     */
    
    struct {
      __IO uint32_t  AHBADDR    : 32;               /*!< It specifies the address from which the DMA has to read / write.The
                                                         address must WORD (32- bits) aligned                                  */
    } AHB_DMA_ADDR_b;                               /*!< BitSize                                                               */
  };
} NT_USBDevice_Type;


/* ================================================================================ */
/* ================                    NT_USBOTG                   ================ */
/* ================================================================================ */


/**
  * @brief USB OTG controller registers (NT_USBOTG)
  */

typedef struct {                                    /*!< NT_USBOTG Structure                                                   */
  
  union {
    __IO uint32_t  OTG_IRQ_STAT;                    /*!< USB OTG interrupt flag register                                       */
    
    struct {
      __IO uint32_t  VBUSERR    :  1;               /*!< Enable interrupt a_clr_err                                            */
      __IO uint32_t  SPRDETECTED:  1;               /*!< Enable interrupt srp_detected                                         */
      __IO uint32_t  HANDOFF_INTR:  1;              /*!< Interrupt when the output state Id                                    */
      __IO uint32_t  SPR_FAIL   :  1;               /*!< Indication of lack of response from the host mode operation
                                                         Device                                                                */
      __I  uint32_t  DEVICE     :  1;               /*!< Set when the kernel is running as a device controller                 */
      __I  uint32_t  HOST       :  1;               /*!< Set when the kernel is running as a host controller                   */
      __IO uint32_t  A_BUSREQ   :  1;               /*!< Request A device control bus                                          */
      __IO uint32_t  A_BUSDROP  :  1;               /*!< Set when the device A, you must disconnect bus                        */
      __IO uint32_t  A_HNPEN    :  1;               /*!< Resolution run HNP device A                                           */
      __IO uint32_t  B_HNPEN    :  1;               /*!< Resolution run HNP device A                                           */
      __IO uint32_t  B_BUSREQ   :  1;               /*!< Request bus control device B                                          */
      __IO uint32_t  A_SUSPENDREQ:  1;              /*!< Request A suspension device                                           */
      __I  uint32_t  A_DEVICE   :  1;               /*!< Display device A connections                                          */
      __I  uint32_t  B_DEVICE   :  1;               /*!< Display device B connections                                          */
      __IO uint32_t  SESSION_FAIL:  1;              /*!< Bit is device B, A when the device interrupts the signal Vbus.        */
      __IO uint32_t  SUSPENDEN  :  1;               /*!< Request                                                               */
      __IO uint32_t  A_DEVCHANGE:  1;               /*!< Bit is set when there is a change device A. At the same time,
                                                         the appropriate interrupt enable bit.                                 */
      __IO uint32_t  B_DEVCHANGE:  1;               /*!< Bit is set when you change the display B. Simultaneously, the
                                                         appropriate interrupt enable bit                                      */
      __IO uint32_t  DEVSYNC    :  1;               /*!< When resynchronization device this bit is set and the corresponding
                                                         interrupt enable bit                                                  */
      __IO uint32_t  HOSTSYNC   :  1;               /*!< When resynchronization host this bit is set and the corresponding
                                                         interrupt enable bit                                                  */
      __IO uint32_t  DISCON     :  1;               /*!< Bit is set when disconnected not in suspend mode                      */
    } OTG_IRQ_STAT_b;                               /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  OTG_IRQ_EN;                      /*!< Interrupt Enable USB OTG register                                     */
    
    struct {
      __IO uint32_t  VBUSERREN  :  1;               /*!< Enable interrupt VBUSERR                                              */
      __IO uint32_t  SPRDETECTEDEN:  1;             /*!< Enable interrupt SPRDETECTED                                          */
      __IO uint32_t  TRANSINTREN:  1;               /*!< Enable interrupt TRANSINTR                                            */
      __IO uint32_t  SRPFAILEN  :  1;               /*!< Enable interrupt SRPFAIL                                              */
      __IO uint32_t  SESSIONFAILEN:  1;             /*!< Enable interrupt SESSIONFAIL                                          */
      __IO uint32_t  A_DEVCHANGEEN:  1;             /*!< Enable interrupt A_DEVCHANGE                                          */
      __IO uint32_t  B_DEVCHANGEEN:  1;             /*!< Enable interrupt B_DEVCHANGE                                          */
      __IO uint32_t  DEVSYNCEN  :  1;               /*!< Enable interrupt DEVSYNC                                              */
      __IO uint32_t  HOSTSYNCEN :  1;               /*!< Enable interrupt HOSTSYNC (Resynchronization host)                    */
      __IO uint32_t  DISCONEN   :  1;               /*!< Enable interrupt Disconnect                                           */
    } OTG_IRQ_EN_b;                                 /*!< BitSize                                                               */
  };
} NT_USBOTG_Type;


/* ================================================================================ */
/* ================                     NT_WDT                     ================ */
/* ================================================================================ */


/**
  * @brief Watchdog controller registers (NT_WDT)
  */

typedef struct {                                    /*!< NT_WDT Structure                                                      */
  
  union {
    __IO uint32_t  LOAD;                            /*!< Watchdog Load Register                                                */
    
    struct {
      __IO uint32_t  COUNT      : 32;               /*!< (null)                                                                */
    } LOAD_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  VALUE;                           /*!< Watchdog Value Register                                               */
    
    struct {
      __I  uint32_t  WDTVAL     : 32;               /*!< (null)                                                                */
    } VALUE_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CTRL;                            /*!< Watchdog Control Register                                             */
    
    struct {
      __IO uint32_t  INTEN      :  1;               /*!< Enable the interrupt event                                            */
      __IO uint32_t  RESEN      :  1;               /*!< Enable watchdog reset output                                          */
    } CTRL_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  INTCLR;                          /*!< Watchdog Clear Interrupt Register                                     */
    
    struct {
      __O  uint32_t  WDTCLR     : 32;               /*!< (null)                                                                */
    } INTCLR_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  RIS;                             /*!< Watchdog Raw Interrupt Status Register                                */
    
    struct {
      __I  uint32_t  RAWWDTINT  :  1;               /*!< Raw interrupt status from the counter                                 */
    } RIS_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  MIS;                             /*!< Watchdog Interrupt Status Register                                    */
    
    struct {
      __I  uint32_t  WDTINT     :  1;               /*!< Enabled interrupt status from the counter                             */
    } MIS_b;                                        /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED[762];
  
  union {
    __O  uint32_t  LOCK;                            /*!< Watchdog Lock Register                                                */
    
    struct {
      __O  uint32_t  REG_WR_DIS :  1;               /*!< Disable write to all registers Watchdog                               */
    } LOCK_b;                                       /*!< BitSize                                                               */
  };
} NT_WDT_Type;


/* ================================================================================ */
/* ================                     NT_I2C0                    ================ */
/* ================================================================================ */


/**
  * @brief I2C controller registers (NT_I2C0)
  */

typedef struct {                                    /*!< NT_I2C0 Structure                                                     */
  
  union {
    __IO uint32_t  SDA;                             /*!< Data register                                                         */
    
    struct {
      __IO uint32_t  DATA       :  8;               /*!< (null)                                                                */
    } SDA_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ST;                              /*!< Status register                                                       */
    
    struct {
      __IO uint32_t  MODE       :  6;               /*!< (null)                                                                */
           uint32_t             :  1;
      __IO uint32_t  INT        :  1;               /*!< Interrupt flag                                                        */
    } ST_b;                                         /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CST;                             /*!< Status and control register                                           */
    
    struct {
      __IO uint32_t  BB         :  1;               /*!< Flag employment bus                                                   */
      __IO uint32_t  TOCDIV     :  2;               /*!< (null)                                                                */
      __IO uint32_t  TOERR      :  1;               /*!< Flag error simple bus                                                 */
      __IO uint32_t  TSDA       :  1;               /*!< Bit test SDA                                                          */
      __IO uint32_t  TGSCL      :  1;               /*!< Bit switch SCL                                                        */
      __IO uint32_t  PECNEXT    :  1;               /*!< Bit control transmit CRC                                              */
      __IO uint32_t  PECFAULT   :  1;               /*!< Error flag                                                            */
    } CST_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CTL0;                            /*!< Control register 0                                                    */
    
    struct {
      __IO uint32_t  START      :  1;               /*!< Start bit                                                             */
      __IO uint32_t  STOP       :  1;               /*!< Stop bit                                                              */
      __IO uint32_t  INTEN      :  1;               /*!< Interrupt enable bit                                                  */
           uint32_t             :  1;
      __IO uint32_t  ACK        :  1;               /*!< Acknowledgment bit reception                                          */
      __IO uint32_t  GCMEN      :  1;               /*!< Control bit part a response to the general call address               */
      __IO uint32_t  SMBARE     :  1;               /*!< Control bit part a response to the response address                   */
      __IO uint32_t  CLRST      :  1;               /*!< Bit reset flag interrupt                                              */
    } CTL0_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ADDR;                            /*!< Register own address                                                  */
    
    struct {
      __IO uint32_t  ADDR       :  7;               /*!< (null)                                                                */
      __IO uint32_t  SAEN       :  1;               /*!< Enable bit address recognition                                        */
    } ADDR_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CTL1;                            /*!< Control register 1                                                    */
    
    struct {
      __IO uint32_t  ENABLE     :  1;               /*!< Enable I2C                                                            */
      __IO uint32_t  SCLFRQ     :  7;               /*!< (null)                                                                */
    } CTL1_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  TOPR;                            /*!< Prescaler load register                                               */
    
    struct {
      __IO uint32_t  SMBTOPR    :  8;               /*!< (null)                                                                */
    } TOPR_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CTL2;                            /*!< Control register 2                                                    */
    
    struct {
      __IO uint32_t  S10ADR     :  3;               /*!< (null)                                                                */
      __IO uint32_t  S10EN      :  1;               /*!< Bit enabled 10-bit addressing slave                                   */
      __IO uint32_t  HSDIV      :  4;               /*!< (null)                                                                */
    } CTL2_b;                                       /*!< BitSize                                                               */
  };
} NT_I2C0_Type;


/* ================================================================================ */
/* ================                    NT_TIMER0                   ================ */
/* ================================================================================ */


/**
  * @brief TIMER controller registers (NT_TIMER0)
  */

typedef struct {                                    /*!< NT_TIMER0 Structure                                                   */
  
  union {
    __IO uint32_t  CTRL;                            /*!< Control Timer register                                                */
    
    struct {
      __IO uint32_t  ON         :  1;               /*!< Enable Timer                                                          */
      __IO uint32_t  EXTINPUT_EN:  1;               /*!< Enable extern                                                         */
      __IO uint32_t  EXTINPUT_CLK:  1;              /*!< Enable extern input clock                                             */
      __IO uint32_t  INTEN      :  1;               /*!< Enable Timer interrupt                                                */
    } CTRL_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  VALUE;                           /*!< Current value timer register                                          */
    
    struct {
      __IO uint32_t  VALUE      : 32;               /*!< (null)                                                                */
    } VALUE_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  RELOAD;                          /*!< Reload value timer register                                           */
    
    struct {
      __IO uint32_t  RELOAD     : 32;               /*!< (null)                                                                */
    } RELOAD_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  INTSTATUS_INTCLEAR;              /*!< No description                                                        */
    
    struct {
      __IO uint32_t  INT        :  1;               /*!< Timer interrupt flag                                                  */
    } INTSTATUS_INTCLEAR_b;                         /*!< BitSize                                                               */
  };
} NT_TIMER0_Type;


/* ================================================================================ */
/* ================                     NT_DMA                     ================ */
/* ================================================================================ */


/**
  * @brief DMA controller registers (NT_DMA)
  */

typedef struct {                                    /*!< NT_DMA Structure                                                      */
  
  union {
    __I  uint32_t  STATUS;                          /*!< Status DMA register                                                   */
    
    struct {
      __I  uint32_t  MASTER_EN  :  1;               /*!< Indicate enable DMA                                                   */
           uint32_t             :  3;
      __I  uint32_t  STATE      :  4;               /*!< State of DMA                                                          */
           uint32_t             :  8;
      __I  uint32_t  CHNLS      :  5;               /*!< Number channel DMA (write: N-1)                                       */
    } STATUS_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  CFG;                             /*!< Configurate DMA register                                              */
    
    struct {
      __O  uint32_t  MASTER_EN  :  1;               /*!< Enable DMA                                                            */
           uint32_t             :  4;
      __O  uint32_t  CHNL_PROT_CTRL:  3;            /*!< Enable control HPROT.1 for access indication with buffering           */
    } CFG_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CTRL_BASE_PTR;                   /*!< Base address register control data channels                           */
    
    struct {
           uint32_t             : 10;
      __IO uint32_t  CTRL_BASE_PTR: 22;             /*!< Pointer to base address of the primary structure of the control
                                                         data                                                                  */
    } CTRL_BASE_PTR_b;                              /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  ALT_CTRL_BASE_PTR;               /*!< Alternate base address register control data channels                 */
    
    struct {
      __I  uint32_t  ALT_CTRL_BASE_PTR: 32;         /*!< Base address of alternative control data channels                     */
    } ALT_CTRL_BASE_PTR_b;                          /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  WAITONREQ_STATUS;                /*!< DMA wait request status                                               */
    
    struct {
      __I  uint32_t  DMA_WAITREQ0:  1;              /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ1:  1;              /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ2:  1;              /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ3:  1;              /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ4:  1;              /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ5:  1;              /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ6:  1;              /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ7:  1;              /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ8:  1;              /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ9:  1;              /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ10:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ11:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ12:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ13:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ14:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ15:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ16:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ17:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ18:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ19:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ20:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ21:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ22:  1;             /*!< Returns the status of the DMA request signals                         */
      __I  uint32_t  DMA_WAITREQ23:  1;             /*!< Returns the status of the DMA request signals                         */
    } WAITONREQ_STATUS_b;                           /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  CHNL_SW_REQUEST;                 /*!< Register software process request DMA channels                        */
    
    struct {
      __O  uint32_t  DMA_SWREQ0 :  1;               /*!< Set software request on channel 0                                     */
      __O  uint32_t  DMA_SWREQ1 :  1;               /*!< Set software request on channel 1                                     */
      __O  uint32_t  DMA_SWREQ2 :  1;               /*!< Set software request on channel 2                                     */
      __O  uint32_t  DMA_SWREQ3 :  1;               /*!< Set software request on channel 3                                     */
      __O  uint32_t  DMA_SWREQ4 :  1;               /*!< Set software request on channel 4                                     */
      __O  uint32_t  DMA_SWREQ5 :  1;               /*!< Set software request on channel 5                                     */
      __O  uint32_t  DMA_SWREQ6 :  1;               /*!< Set software request on channel 6                                     */
      __O  uint32_t  DMA_SWREQ7 :  1;               /*!< Set software request on channel 7                                     */
      __O  uint32_t  DMA_SWREQ8 :  1;               /*!< Set software request on channel 8                                     */
      __O  uint32_t  DMA_SWREQ9 :  1;               /*!< Set software request on channel 9                                     */
      __O  uint32_t  DMA_SWREQ10:  1;               /*!< Set software request on channel 10                                    */
      __O  uint32_t  DMA_SWREQ11:  1;               /*!< Set software request on channel 11                                    */
      __O  uint32_t  DMA_SWREQ12:  1;               /*!< Set software request on channel 12                                    */
      __O  uint32_t  DMA_SWREQ13:  1;               /*!< Set software request on channel 13                                    */
      __O  uint32_t  DMA_SWREQ14:  1;               /*!< Set software request on channel 14                                    */
      __O  uint32_t  DMA_SWREQ15:  1;               /*!< Set software request on channel 15                                    */
      __O  uint32_t  DMA_SWREQ16:  1;               /*!< Set software request on channel 16                                    */
      __O  uint32_t  DMA_SWREQ17:  1;               /*!< Set software request on channel 17                                    */
      __O  uint32_t  DMA_SWREQ18:  1;               /*!< Set software request on channel 18                                    */
      __O  uint32_t  DMA_SWREQ19:  1;               /*!< Set software request on channel 19                                    */
      __O  uint32_t  DMA_SWREQ20:  1;               /*!< Set software request on channel 20                                    */
      __O  uint32_t  DMA_SWREQ21:  1;               /*!< Set software request on channel 21                                    */
      __O  uint32_t  DMA_SWREQ22:  1;               /*!< Set software request on channel 22                                    */
      __O  uint32_t  DMA_SWREQ23:  1;               /*!< Set software request on channel 23                                    */
    } CHNL_SW_REQUEST_b;                            /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CHNL_USEBURST_SET;               /*!< Register Set Packet Exchange DMA channels                             */
    
    struct {
      __IO uint32_t  DMA_BURSTSET0:  1;             /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET1:  1;             /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET2:  1;             /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET3:  1;             /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET4:  1;             /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET5:  1;             /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET6:  1;             /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET7:  1;             /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET8:  1;             /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET9:  1;             /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET10:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET11:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET12:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET13:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET14:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET15:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET16:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET17:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET18:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET19:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET20:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET21:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET22:  1;            /*!< Returns the status of the DMA single request signals                  */
      __IO uint32_t  DMA_BURSTSET23:  1;            /*!< Returns the status of the DMA single request signals                  */
    } CHNL_USEBURST_SET_b;                          /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  CHNL_USEBURST_CLR;               /*!< Register Clear Packet Exchange DMA channels                           */
    
    struct {
      __O  uint32_t  DMA_BURSTCLR0:  1;             /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR1:  1;             /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR2:  1;             /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR3:  1;             /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR4:  1;             /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR5:  1;             /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR6:  1;             /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR7:  1;             /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR8:  1;             /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR9:  1;             /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR10:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR11:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR12:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR13:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR14:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR15:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR16:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR17:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR18:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR19:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR20:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR21:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR22:  1;            /*!< reserved                                                              */
      __O  uint32_t  DMA_BURSTCLR23:  1;            /*!< reserved                                                              */
    } CHNL_USEBURST_CLR_b;                          /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CHNL_REQ_MASK_SET;               /*!< DMA request mask set                                                  */
    
    struct {
      __IO uint32_t  DMA_REQMASKSET0:  1;           /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET1:  1;           /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET2:  1;           /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET3:  1;           /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET4:  1;           /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET5:  1;           /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET6:  1;           /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET7:  1;           /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET8:  1;           /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET9:  1;           /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET10:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET11:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET12:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET13:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET14:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET15:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET16:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET17:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET18:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET19:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET20:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET21:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET22:  1;          /*!< (null)                                                                */
      __IO uint32_t  DMA_REQMASKSET23:  1;          /*!< (null)                                                                */
    } CHNL_REQ_MASK_SET_b;                          /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  CHNL_REQ_MASK_CLR;               /*!< DMA request mask clear                                                */
    
    struct {
      __O  uint32_t  DMA_REQMASKCLR0:  1;           /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR1:  1;           /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR2:  1;           /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR3:  1;           /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR4:  1;           /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR5:  1;           /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR6:  1;           /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR7:  1;           /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR8:  1;           /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR9:  1;           /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR10:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR11:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR12:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR13:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR14:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR15:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR16:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR17:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR18:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR19:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR20:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR21:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR22:  1;          /*!< (null)                                                                */
      __O  uint32_t  DMA_REQMASKCLR23:  1;          /*!< (null)                                                                */
    } CHNL_REQ_MASK_CLR_b;                          /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CHNL_ENABLE_SET;                 /*!< DMA channel enabled set                                               */
    
    struct {
      __IO uint32_t  DMA_ENSET0 :  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET1 :  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET2 :  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET3 :  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET4 :  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET5 :  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET6 :  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET7 :  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET8 :  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET9 :  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET10:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET11:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET12:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET13:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET14:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET15:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET16:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET17:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET18:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET19:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET20:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET21:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET22:  1;               /*!< Returns the status of dma_active[ ]                                   */
      __IO uint32_t  DMA_ENSET23:  1;               /*!< Returns the status of dma_active[ ]                                   */
    } CHNL_ENABLE_SET_b;                            /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  CHNL_ENABLE_CLR;                 /*!< DMA channel enabled clear                                             */
    
    struct {
      __O  uint32_t  DMA_ENCLR0 :  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR1 :  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR2 :  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR3 :  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR4 :  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR5 :  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR6 :  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR7 :  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR8 :  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR9 :  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR10:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR11:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR12:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR13:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR14:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR15:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR16:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR17:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR18:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR19:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR20:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR21:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR22:  1;               /*!< Enables you to set the dma_active[ ]                                  */
      __O  uint32_t  DMA_ENCLR23:  1;               /*!< Enables you to set the dma_active[ ]                                  */
    } CHNL_ENABLE_CLR_b;                            /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CHNL_PRI_ALT_SET;                /*!< Register setting primary / alternate channel control data structure   */
    
    struct {
      __IO uint32_t  DMA_ALTSET0:  1;               /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET1:  1;               /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET2:  1;               /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET3:  1;               /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET4:  1;               /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET5:  1;               /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET6:  1;               /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET7:  1;               /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET8:  1;               /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET9:  1;               /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET10:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET11:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET12:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET13:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET14:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET15:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET16:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET17:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET18:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET19:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET20:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET21:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET22:  1;              /*!< Set primary / alternate channel control data structure                */
      __IO uint32_t  DMA_ALTSET23:  1;              /*!< Set primary / alternate channel control data structure                */
    } CHNL_PRI_ALT_SET_b;                           /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  CHNL_PRI_ALT_CLR;                /*!< Register clearing primary / alternate channel control data structure  */
    
    struct {
      __O  uint32_t  DMA_ALTCLR0:  1;               /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR1:  1;               /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR2:  1;               /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR3:  1;               /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR4:  1;               /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR5:  1;               /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR6:  1;               /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR7:  1;               /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR8:  1;               /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR9:  1;               /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR10:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR11:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR12:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR13:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR14:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR15:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR16:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR17:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR18:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR19:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR20:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR21:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR22:  1;              /*!< Clear primary / alternate channel control data structure              */
      __O  uint32_t  DMA_ALTCLR23:  1;              /*!< Clear primary / alternate channel control data structure              */
    } CHNL_PRI_ALT_CLR_b;                           /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CHNL_PRIORITY_SET;               /*!< Register set the priority channel                                     */
    
    struct {
      __IO uint32_t  DMA_PRISET0:  1;               /*!< Set the priority channel0                                             */
      __IO uint32_t  DMA_PRISET1:  1;               /*!< Set the priority channel1                                             */
      __IO uint32_t  DMA_PRISET2:  1;               /*!< Set the priority channel2                                             */
      __IO uint32_t  DMA_PRISET3:  1;               /*!< Set the priority channel3                                             */
      __IO uint32_t  DMA_PRISET4:  1;               /*!< Set the priority channel4                                             */
      __IO uint32_t  DMA_PRISET5:  1;               /*!< Set the priority channel5                                             */
      __IO uint32_t  DMA_PRISET6:  1;               /*!< Set the priority channel6                                             */
      __IO uint32_t  DMA_PRISET7:  1;               /*!< Set the priority channel7                                             */
      __IO uint32_t  DMA_PRISET8:  1;               /*!< Set the priority channel8                                             */
      __IO uint32_t  DMA_PRISET9:  1;               /*!< Set the priority channel9                                             */
      __IO uint32_t  DMA_PRISET10:  1;              /*!< Set the priority channel10                                            */
      __IO uint32_t  DMA_PRISET11:  1;              /*!< Set the priority channel11                                            */
      __IO uint32_t  DMA_PRISET12:  1;              /*!< Set the priority channel12                                            */
      __IO uint32_t  DMA_PRISET13:  1;              /*!< Set the priority channel13                                            */
      __IO uint32_t  DMA_PRISET14:  1;              /*!< Set the priority channel14                                            */
      __IO uint32_t  DMA_PRISET15:  1;              /*!< Set the priority channel15                                            */
      __IO uint32_t  DMA_PRISET16:  1;              /*!< Set the priority channel16                                            */
      __IO uint32_t  DMA_PRISET17:  1;              /*!< Set the priority channel17                                            */
      __IO uint32_t  DMA_PRISET18:  1;              /*!< Set the priority channel18                                            */
      __IO uint32_t  DMA_PRISET19:  1;              /*!< Set the priority channel19                                            */
      __IO uint32_t  DMA_PRISET20:  1;              /*!< Set the priority channel20                                            */
      __IO uint32_t  DMA_PRISET21:  1;              /*!< Set the priority channel21                                            */
      __IO uint32_t  DMA_PRISET22:  1;              /*!< Set the priority channel22                                            */
      __IO uint32_t  DMA_PRISET23:  1;              /*!< Set the priority channel23                                            */
    } CHNL_PRIORITY_SET_b;                          /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  CHNL_PRIORITY_CLR;               /*!< Register clear the priority channel                                   */
    
    struct {
      __O  uint32_t  DMA_PRICLR0:  1;               /*!< Clear the priority channel0                                           */
      __O  uint32_t  DMA_PRICLR1:  1;               /*!< Clear the priority channel1                                           */
      __O  uint32_t  DMA_PRICLR2:  1;               /*!< Clear the priority channel2                                           */
      __O  uint32_t  DMA_PRICLR3:  1;               /*!< Clear the priority channel3                                           */
      __O  uint32_t  DMA_PRICLR4:  1;               /*!< Clear the priority channel4                                           */
      __O  uint32_t  DMA_PRICLR5:  1;               /*!< Clear the priority channel5                                           */
      __O  uint32_t  DMA_PRICLR6:  1;               /*!< Clear the priority channel6                                           */
      __O  uint32_t  DMA_PRICLR7:  1;               /*!< Clear the priority channel7                                           */
      __O  uint32_t  DMA_PRICLR8:  1;               /*!< Clear the priority channel8                                           */
      __O  uint32_t  DMA_PRICLR9:  1;               /*!< Clear the priority channel9                                           */
      __O  uint32_t  DMA_PRICLR10:  1;              /*!< Clear the priority channel10                                          */
      __O  uint32_t  DMA_PRICLR11:  1;              /*!< Clear the priority channel11                                          */
      __O  uint32_t  DMA_PRICLR12:  1;              /*!< Clear the priority channel12                                          */
      __O  uint32_t  DMA_PRICLR13:  1;              /*!< Clear the priority channel13                                          */
      __O  uint32_t  DMA_PRICLR14:  1;              /*!< Clear the priority channel14                                          */
      __O  uint32_t  DMA_PRICLR15:  1;              /*!< Clear the priority channel15                                          */
      __O  uint32_t  DMA_PRICLR16:  1;              /*!< Clear the priority channel16                                          */
      __O  uint32_t  DMA_PRICLR17:  1;              /*!< Clear the priority channel17                                          */
      __O  uint32_t  DMA_PRICLR18:  1;              /*!< Clear the priority channel18                                          */
      __O  uint32_t  DMA_PRICLR19:  1;              /*!< Clear the priority channel19                                          */
      __O  uint32_t  DMA_PRICLR20:  1;              /*!< Clear the priority channel20                                          */
      __O  uint32_t  DMA_PRICLR21:  1;              /*!< Clear the priority channel21                                          */
      __O  uint32_t  DMA_PRICLR22:  1;              /*!< Clear the priority channel22                                          */
      __O  uint32_t  DMA_PRICLR23:  1;              /*!< Clear the priority channel23                                          */
    } CHNL_PRIORITY_CLR_b;                          /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED[3];
  
  union {
    __IO uint32_t  ERR_CLR;                         /*!< Flag error clear register                                             */
    
    struct {
      __IO uint32_t  ERR_CLR    :  1;               /*!< Indicate Error on bus AHB-Lite / Clear flag error                     */
    } ERR_CLR_b;                                    /*!< BitSize                                                               */
  };
} NT_DMA_Type;


/* ================================================================================ */
/* ================                     NT_PWM0                    ================ */
/* ================================================================================ */


/**
  * @brief PWM controller registers (NT_PWM0)
  */

typedef struct {                                    /*!< NT_PWM0 Structure                                                     */
  
  union {
    __IO uint32_t  TBCTL;                           /*!< Timer Control Register                                                */
    
    struct {
      __IO uint32_t  CTRMODE    :  2;               /*!< (null)                                                                */
      __IO uint32_t  PHSEN      :  1;               /*!< load timer counter                                                    */
      __IO uint32_t  PRDLD      :  1;               /*!< lazy loading mode register                                            */
      __IO uint32_t  SYNCOSEL   :  2;               /*!< (null)                                                                */
      __IO uint32_t  SWFSYNC    :  1;               /*!< Software emulation clock                                              */
      __IO uint32_t  HSPCLKDIV  :  3;               /*!< (null)                                                                */
      __IO uint32_t  CLKDIV     :  3;               /*!< (null)                                                                */
      __IO uint32_t  PHSDIR     :  1;               /*!< The phase direction                                                   */
      __IO uint32_t  FREE_SOFT  :  2;               /*!< (null)                                                                */
    } TBCTL_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  TBSTS;                           /*!< Timer status register                                                 */
    
    struct {
      __I  uint32_t  CTRDIR     :  1;               /*!< Current timer counting direction                                      */
      __I  uint32_t  SYNCI      :  1;               /*!< Synchronization status                                                */
      __I  uint32_t  CTRMAX     :  1;               /*!< Position of the peak value                                            */
    } TBSTS_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  TBPHS;                           /*!< register Phases                                                       */
    
    struct {
           uint32_t             :  8;
      __IO uint32_t  TBPHSHR    :  8;               /*!< (null)                                                                */
      __IO uint32_t  TBPHS      : 16;               /*!< (null)                                                                */
    } TBPHS_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  TBCTR;                           /*!< Register current value of timer                                       */
    
    struct {
      __IO uint32_t  TBCTR      : 16;               /*!< (null)                                                                */
    } TBCTR_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  TBPRD;                           /*!< Register maximum Timer                                                */
    
    struct {
      __IO uint32_t  TBPRD      : 16;               /*!< (null)                                                                */
    } TBPRD_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CMPCTL;                          /*!< No description                                                        */
    
    struct {
      __IO uint32_t  LOADAMODE  :  2;               /*!< (null)                                                                */
      __IO uint32_t  LOADBMODE  :  2;               /*!< (null)                                                                */
      __IO uint32_t  SHDWAMODE  :  1;               /*!< Write-permit mode                                                     */
           uint32_t             :  1;
      __IO uint32_t  SHDWBMODE  :  1;               /*!< Write-permit mode                                                     */
           uint32_t             :  1;
      __I  uint32_t  SHDWAFULL  :  1;               /*!< Status lazy loading in CMPA                                           */
      __I  uint32_t  SHDWBFULL  :  1;               /*!< Status lazy loading in CMPB                                           */
    } CMPCTL_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CMPA;                            /*!< Register threshold A                                                  */
    
    struct {
           uint32_t             :  8;
      __IO uint32_t  CMPAHR     :  8;               /*!< (null)                                                                */
      __IO uint32_t  CMPA       : 16;               /*!< (null)                                                                */
    } CMPA_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CMPB;                            /*!< Register threshold B                                                  */
    
    struct {
           uint32_t             : 16;
      __IO uint32_t  CMPB       : 16;               /*!< (null)                                                                */
    } CMPB_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  AQCTLA;                          /*!< Register handlers for output A                                        */
    
    struct {
      __IO uint32_t  ZRO        :  2;               /*!< (null)                                                                */
      __IO uint32_t  PRD        :  2;               /*!< (null)                                                                */
      __IO uint32_t  CAU        :  2;               /*!< (null)                                                                */
      __IO uint32_t  CAD        :  2;               /*!< (null)                                                                */
      __IO uint32_t  CBU        :  2;               /*!< (null)                                                                */
      __IO uint32_t  CBD        :  2;               /*!< (null)                                                                */
    } AQCTLA_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  AQCTLB;                          /*!< Register handlers for output B                                        */
    
    struct {
      __IO uint32_t  ZRO        :  2;               /*!< (null)                                                                */
      __IO uint32_t  PRD        :  2;               /*!< (null)                                                                */
      __IO uint32_t  CAU        :  2;               /*!< (null)                                                                */
      __IO uint32_t  CAD        :  2;               /*!< (null)                                                                */
      __IO uint32_t  CBU        :  2;               /*!< (null)                                                                */
      __IO uint32_t  CBD        :  2;               /*!< (null)                                                                */
    } AQCTLB_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  AQSFRC;                          /*!< Register handlers for a single program management                     */
    
    struct {
      __IO uint32_t  ACTSFA     :  2;               /*!< (null)                                                                */
      __IO uint32_t  OTSFA      :  1;               /*!< Initialization single pulse                                           */
      __IO uint32_t  ACTSFB     :  2;               /*!< (null)                                                                */
      __IO uint32_t  OTSFB      :  1;               /*!< Initialization single pulse                                           */
      __IO uint32_t  RLDCSF     :  2;               /*!< (null)                                                                */
    } AQSFRC_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  AQCSFRC;                         /*!< Register handlers for the cyclic program Management                   */
    
    struct {
      __IO uint32_t  CSFA       :  2;               /*!< (null)                                                                */
      __IO uint32_t  CSFB       :  2;               /*!< (null)                                                                */
    } AQCSFRC_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DBCTL;                           /*!< Generator Control Register PWM Dead Time                              */
    
    struct {
      __IO uint32_t  OUT_MODE   :  2;               /*!< (null)                                                                */
      __IO uint32_t  POLSEL     :  2;               /*!< (null)                                                                */
      __IO uint32_t  IN_MODE    :  2;               /*!< (null)                                                                */
    } DBCTL_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DBRED;                           /*!< Dead time control register                                            */
    
    struct {
      __IO uint32_t  DEL        : 10;               /*!< (null)                                                                */
    } DBRED_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DBFED;                           /*!< Dead time control register                                            */
    
    struct {
      __IO uint32_t  DEL        : 10;               /*!< (null)                                                                */
    } DBFED_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  TZSEL;                           /*!< Register the source of the accident                                   */
    
    struct {
      __IO uint32_t  CBC0       :  1;               /*!< (null)                                                                */
      __IO uint32_t  CBC1       :  1;               /*!< (null)                                                                */
      __IO uint32_t  CBC2       :  1;               /*!< (null)                                                                */
      __IO uint32_t  CBC3       :  1;               /*!< (null)                                                                */
      __IO uint32_t  CBC4       :  1;               /*!< (null)                                                                */
      __IO uint32_t  CBC5       :  1;               /*!< source signal with the output of the accident Tzx(cyclic mode)        */
           uint32_t             :  2;
      __IO uint32_t  OSHT0      :  1;               /*!< (null)                                                                */
      __IO uint32_t  OSHT1      :  1;               /*!< (null)                                                                */
      __IO uint32_t  OSHT2      :  1;               /*!< (null)                                                                */
      __IO uint32_t  OSHT3      :  1;               /*!< (null)                                                                */
      __IO uint32_t  OSHT4      :  1;               /*!< (null)                                                                */
      __IO uint32_t  OSHT5      :  1;               /*!< source signal with the output of the accident Tzx(Single mode)        */
    } TZSEL_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  TZCTL;                           /*!< Control Register detector alarm signal                                */
    
    struct {
      __IO uint32_t  TZA        :  2;               /*!< (null)                                                                */
      __IO uint32_t  TZB        :  2;               /*!< (null)                                                                */
    } TZCTL_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  TZEINT;                          /*!< Interrupt mask register Signal Detection Alarms                       */
    
    struct {
           uint32_t             :  1;
      __IO uint32_t  CBC        :  1;               /*!< Interrupt generation(cyclic mode)                                     */
      __IO uint32_t  OST        :  1;               /*!< Interrupt generation(single mode)                                     */
    } TZEINT_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  TZFLG;                           /*!< Flags register interrupt signal detector Accidents                    */
    
    struct {
      __I  uint32_t  INT        :  1;               /*!< Status of external interrupts NVIC                                    */
      __I  uint32_t  CBC        :  1;               /*!< Interrupt status in a cyclic mode                                     */
      __I  uint32_t  OST        :  1;               /*!< Interrupt status in one-shot mode                                     */
    } TZFLG_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  TZCLR;                           /*!< Register reset interrupt flag detector alarm signal                   */
    
    struct {
      __IO uint32_t  INT        :  1;               /*!< Reset status of external interrupts NVIC                              */
      __IO uint32_t  CBC        :  1;               /*!< Reset Interrupt status in a cyclic mode                               */
      __IO uint32_t  OST        :  1;               /*!< Reset Interrupt status in one-shot mode                               */
    } TZCLR_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  TZFRC;                           /*!< Register software emulation of faults                                 */
    
    struct {
           uint32_t             :  1;
      __IO uint32_t  CBC        :  1;               /*!< Signal generation(cyclic mode)                                        */
      __IO uint32_t  OST        :  1;               /*!< Signal generation(single mode)                                        */
    } TZFRC_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ETSEL;                           /*!< A Source event trigger                                                */
    
    struct {
      __IO uint32_t  INTSEL     :  3;               /*!< (null)                                                                */
      __IO uint32_t  INTEN      :  1;               /*!< Generation of external interrupt EPWMxINT                             */
           uint32_t             :  4;
      __IO uint32_t  SOCASEL    :  3;               /*!< (null)                                                                */
      __IO uint32_t  SOCAEN     :  1;               /*!< generation of an external signal (EPWMxSOCA)                          */
      __IO uint32_t  SOCBSEL    :  3;               /*!< (null)                                                                */
      __IO uint32_t  SOCBEN     :  1;               /*!< generation of an external signal (EPWMxSOCB)                          */
    } ETSEL_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ETPS;                            /*!< Prescaler register the event trigger                                  */
    
    struct {
      __IO uint32_t  INTPRD     :  2;               /*!< (null)                                                                */
      __I  uint32_t  INTCNT     :  2;               /*!< (null)                                                                */
           uint32_t             :  4;
      __IO uint32_t  SOCAPRD    :  2;               /*!< (null)                                                                */
      __I  uint32_t  SOCACNT    :  2;               /*!< (null)                                                                */
      __IO uint32_t  SOCPRD     :  2;               /*!< (null)                                                                */
      __I  uint32_t  SOCBCNT    :  2;               /*!< (null)                                                                */
    } ETPS_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  ETFLG;                           /*!< Register Flags event trigger                                          */
    
    struct {
      __I  uint32_t  INT        :  1;               /*!< Status of the external interrupt EPWMxINT                             */
           uint32_t             :  1;
      __I  uint32_t  SOCA       :  1;               /*!< Status of the external ADC EPWMxSOCA                                  */
      __I  uint32_t  SOCB       :  1;               /*!< Status of the external ADC EPWMxSOCB                                  */
    } ETFLG_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ETCLR;                           /*!< Register reset flags trigger events                                   */
    
    struct {
      __IO uint32_t  INT        :  1;               /*!< reset the status of the external interrupt EPWMxINT                   */
           uint32_t             :  1;
      __IO uint32_t  SOCA       :  1;               /*!< reset the status of the external ADC EPWMxSOCA                        */
      __IO uint32_t  SOCB       :  1;               /*!< reset the status of the external ADC EPWMxSOCB                        */
    } ETCLR_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  ETFRC;                           /*!< Register software emulation events                                    */
    
    struct {
      __I  uint32_t  INT        :  1;               /*!< activation of an external interrupt EPWMxINT                          */
           uint32_t             :  1;
      __I  uint32_t  SOCA       :  1;               /*!< activation of the external ADC EPWMxSOCA                              */
      __I  uint32_t  SOCB       :  1;               /*!< activation of the external ADC EPWMxSOCB                              */
    } ETFRC_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  PCCTL;                           /*!< Control Register modulator                                            */
    
    struct {
      __IO uint32_t  CHPEN      :  1;               /*!< enables the Modulator                                                 */
      __IO uint32_t  OSHTWTH    :  4;               /*!< (null)                                                                */
      __IO uint32_t  SHRFREQ    :  3;               /*!< (null)                                                                */
      __IO uint32_t  CHPDUTY    :  3;               /*!< (null)                                                                */
    } PCCTL_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  HRCNFG;                          /*!< Register Configuration Block PWM High Definition                      */
    
    struct {
      __IO uint32_t  EDGMODE    :  2;               /*!< (null)                                                                */
      __IO uint32_t  CTLMODE    :  1;               /*!< register specifies the delay                                          */
      __IO uint32_t  HR_LOAD    :  1;               /*!< load event of deferred value to the active register                   */
           uint32_t             : 12;
      __I  uint32_t  MEP_SCALEFACTOR:  8;           /*!< (null)                                                                */
    } HRCNFG_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  FWDTH;                           /*!< Register width filtering                                              */
    
    struct {
      __IO uint32_t  FWDTH      :  8;               /*!< (null)                                                                */
    } FWDTH_b;                                      /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED[5];
  
  union {
    __IO uint32_t  HDSEL;                           /*!< Register source event retention                                       */
    
    struct {
      __IO uint32_t  DCMP       : 24;               /*!< (null)                                                                */
      __IO uint32_t  ACMP       :  3;               /*!< (null)                                                                */
    } HDSEL_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  HDCTL;                           /*!< Control Register detector hold events                                 */
    
    struct {
      __IO uint32_t  HDA        :  2;               /*!< (null)                                                                */
      __IO uint32_t  HDB        :  2;               /*!< (null)                                                                */
    } HDCTL_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  HDEINT;                          /*!< Register software activation threshold trigger                        */
    
    struct {
           uint32_t             :  1;
      __IO uint32_t  CBC        :  1;               /*!< Activation threshold trigger in cycle mode                            */
      __IO uint32_t  OST        :  1;               /*!< Activation threshold trigger in single mode                           */
    } HDEINT_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  HDFLG;                           /*!< Registrer HD flag interrupt                                           */
    
    struct {
      __I  uint32_t  HDINT      :  1;               /*!< (null)                                                                */
      __I  uint32_t  CBC        :  1;               /*!< Activation threshold trigger in cycle mode                            */
      __I  uint32_t  OST        :  1;               /*!< Activation threshold trigger in single mode                           */
    } HDFLG_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  HDCLR;                           /*!< Register clear HD flag                                                */
    
    struct {
      __IO uint32_t  HDINT      :  1;               /*!< Clear flag HDINT                                                      */
    } HDCLR_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  HDFRC;                           /*!< Register software activation threshold trigger                        */
    
    struct {
           uint32_t             :  1;
      __IO uint32_t  CBC        :  1;               /*!< activation threshold trigger in cycle mode                            */
      __IO uint32_t  OST        :  1;               /*!< activation threshold trigger in single mode                           */
    } HDFRC_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  HDINTCLR;                        /*!< Register clear HD interrupt                                           */
    
    struct {
      __O  uint32_t  HDINT      :  1;               /*!< Clear HD interrupt                                                    */
    } HDINTCLR_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  TZINTCLR;                        /*!< Register clear TZ interrupt                                           */
    
    struct {
      __O  uint32_t  TZINT      :  1;               /*!< Clear TZ interrupt                                                    */
    } TZINTCLR_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  INTCLR;                          /*!< Register clear interrupt                                              */
    
    struct {
      __O  uint32_t  INT        :  1;               /*!< Clear interrupt                                                       */
    } INTCLR_b;                                     /*!< BitSize                                                               */
  };
} NT_PWM0_Type;


/* ================================================================================ */
/* ================                     NT_CAP0                    ================ */
/* ================================================================================ */


/**
  * @brief CAP controller registers (NT_CAP0)
  */

typedef struct {                                    /*!< NT_CAP0 Structure                                                     */
  
  union {
    __IO uint32_t  TSCTR;                           /*!< TIMER register                                                        */
    
    struct {
      __IO uint32_t  VALUE      : 32;               /*!< (null)                                                                */
    } TSCTR_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CTRPHS;                          /*!< Load Timer register                                                   */
    
    struct {
      __IO uint32_t  VALUE      : 32;               /*!< (null)                                                                */
    } CTRPHS_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CAP0;                            /*!< Capture register 0                                                    */
    
    struct {
      __IO uint32_t  VALUE      : 32;               /*!< (null)                                                                */
    } CAP0_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CAP1;                            /*!< Capture register 1                                                    */
    
    struct {
      __IO uint32_t  VALUE      : 32;               /*!< (null)                                                                */
    } CAP1_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CAP2;                            /*!< Capture register 2                                                    */
    
    struct {
      __IO uint32_t  VALUE      : 32;               /*!< (null)                                                                */
    } CAP2_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CAP3;                            /*!< Capture register 3                                                    */
    
    struct {
      __IO uint32_t  VALUE      : 32;               /*!< (null)                                                                */
    } CAP3_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED[4];
  
  union {
    __IO uint32_t  ECCTL0;                          /*!< Register capture control 0                                            */
    
    struct {
      __IO uint32_t  CAP0_POL   :  1;               /*!< pos/negedge capture 0                                                 */
      __IO uint32_t  CTR_RST0   :  1;               /*!< reset later event 0                                                   */
      __IO uint32_t  CAP1_POL   :  1;               /*!< pos/negedge capture 1                                                 */
      __IO uint32_t  CTR_RST1   :  1;               /*!< reset later event 1                                                   */
      __IO uint32_t  CAP2_POL   :  1;               /*!< pos/negedge capture 2                                                 */
      __IO uint32_t  CTR_RST2   :  1;               /*!< reset later event 2                                                   */
      __IO uint32_t  CAP3_POL   :  1;               /*!< pos/negedge capture 3                                                 */
      __IO uint32_t  CTR_RST3   :  1;               /*!< reset later event 3                                                   */
      __IO uint32_t  CAPLDEN    :  1;               /*!< enable capture                                                        */
      __IO uint32_t  PRESCALE   :  5;               /*!< (null)                                                                */
      __IO uint32_t  FREE_SOFT  :  2;               /*!< (null)                                                                */
    } ECCTL0_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ECCTL1;                          /*!< Register capture control 1                                            */
    
    struct {
      __IO uint32_t  SWSYNC     :  1;               /*!< Timers synchr                                                         */
      __IO uint32_t  CAP_APWM   :  1;               /*!< Capture mode or APWM                                                  */
      __IO uint32_t  APWM_POL   :  1;               /*!< High/low level APWM                                                   */
           uint32_t             :  5;
      __IO uint32_t  CONT_ONESHT:  1;               /*!< Capture mode                                                          */
      __IO uint32_t  STOP_WRAP  :  2;               /*!< (null)                                                                */
      __IO uint32_t  REARM      :  1;               /*!< reset and enable controller, load reg capt                            */
      __IO uint32_t  TSCTRSTOP  :  1;               /*!< enable Timer                                                          */
      __IO uint32_t  SYNCI_EN   :  1;               /*!< sync outer impulse                                                    */
      __IO uint32_t  SYNCO_SEL  :  2;               /*!< (null)                                                                */
    } ECCTL1_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ECEINT;                          /*!< Register interrupt mask                                               */
    
    struct {
           uint32_t             :  1;
      __IO uint32_t  CEVT0      :  1;               /*!< enable int CEVT0                                                      */
      __IO uint32_t  CEVT1      :  1;               /*!< enable int CEVT1                                                      */
      __IO uint32_t  CEVT2      :  1;               /*!< enable int CEVT2                                                      */
      __IO uint32_t  CEVT3      :  1;               /*!< enable int CEVT3                                                      */
      __IO uint32_t  CTR_OVF    :  1;               /*!< enable int CTR_OVF                                                    */
      __IO uint32_t  CTR_PRD    :  1;               /*!< enable int CTR=PRD                                                    */
      __IO uint32_t  CTR_CMP    :  1;               /*!< enable int CTR=CMP                                                    */
    } ECEINT_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  ECFLG;                           /*!< Register interrupt status                                             */
    
    struct {
      __I  uint32_t  INT        :  1;               /*!< indicate global interrupt                                             */
      __I  uint32_t  CEVT0      :  1;               /*!< Hap interrupt CEVT0                                                   */
      __I  uint32_t  CEVT1      :  1;               /*!< Hap interrupt CEVT1                                                   */
      __I  uint32_t  CEVT2      :  1;               /*!< Hap interrupt CEVT2                                                   */
      __I  uint32_t  CEVT3      :  1;               /*!< Hap interrupt CEVT3                                                   */
      __I  uint32_t  CTR_OVF    :  1;               /*!< Hap interrupt CTROVF                                                  */
      __I  uint32_t  CTR_PRD    :  1;               /*!< Hap interrupt CTR=PRD                                                 */
      __I  uint32_t  CTR_CMP    :  1;               /*!< Hap interrupt CTR=CMP                                                 */
    } ECFLG_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ECCLR;                           /*!< Register reset interrupt                                              */
    
    struct {
      __IO uint32_t  INT        :  1;               /*!< reset global interrupt                                                */
      __IO uint32_t  CEVT0      :  1;               /*!< reset intstatus                                                       */
      __IO uint32_t  CEVT1      :  1;               /*!< reset intstatus                                                       */
      __IO uint32_t  CEVT2      :  1;               /*!< reset intstatus                                                       */
      __IO uint32_t  CEVT3      :  1;               /*!< reset intstatus                                                       */
      __IO uint32_t  CTR_OVF    :  1;               /*!< reset intstatus                                                       */
      __IO uint32_t  CTR_PRD    :  1;               /*!< reset intstatus                                                       */
      __IO uint32_t  CTR_CMP    :  1;               /*!< reset intstatus                                                       */
    } ECCLR_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  ECFRC;                           /*!< Test register interrupt generation                                    */
    
    struct {
           uint32_t             :  1;
      __IO uint32_t  CEVT0      :  1;               /*!< gen test interrupt                                                    */
      __IO uint32_t  CEVT1      :  1;               /*!< gen test interrupt                                                    */
      __IO uint32_t  CEVT2      :  1;               /*!< gen test interrupt                                                    */
      __IO uint32_t  CEVT3      :  1;               /*!< gen test interrupt                                                    */
      __IO uint32_t  CTR_OVF    :  1;               /*!< gen test interrupt                                                    */
      __IO uint32_t  CTR_PRD    :  1;               /*!< gen test interrupt                                                    */
      __IO uint32_t  CTR_CMP    :  1;               /*!< gen test interrupt                                                    */
    } ECFRC_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  PEINT;                           /*!< Active interrupt status register                                      */
    
    struct {
      __IO uint32_t  PEINT      :  1;               /*!< active interrupt flag                                                 */
    } PEINT_b;                                      /*!< BitSize                                                               */
  };
} NT_CAP0_Type;


/* ================================================================================ */
/* ================                     NT_QEP0                    ================ */
/* ================================================================================ */


/**
  * @brief QEP controller registers (NT_QEP0)
  */

typedef struct {                                    /*!< NT_QEP0 Structure                                                     */
  
  union {
    __IO uint32_t  QPOSCNT;                         /*!< Position count register                                               */
    
    struct {
      __IO uint32_t  QPOSCNT    : 32;               /*!< (null)                                                                */
    } QPOSCNT_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QPOSINIT;                        /*!< Shadow count register                                                 */
    
    struct {
      __IO uint32_t  QPOSINIT   : 32;               /*!< (null)                                                                */
    } QPOSINIT_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QPOSMAX;                         /*!< Period register                                                       */
    
    struct {
      __IO uint32_t  QPOSMAX    : 32;               /*!< (null)                                                                */
    } QPOSMAX_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QPOSCMP;                         /*!< Count compare position reg                                            */
    
    struct {
      __IO uint32_t  QPOSCMP    : 32;               /*!< (null)                                                                */
    } QPOSCMP_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  QPOSILAT;                        /*!< Register meaning count position                                       */
    
    struct {
      __I  uint32_t  QPOSILAT   : 32;               /*!< (null)                                                                */
    } QPOSILAT_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  QPOSSLAT;                        /*!< Strobe register                                                       */
    
    struct {
      __I  uint32_t  QPOSSLAT   : 32;               /*!< (null)                                                                */
    } QPOSSLAT_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  QPOSLAT;                         /*!< Time event register                                                   */
    
    struct {
      __I  uint32_t  QPOSLAT    : 32;               /*!< (null)                                                                */
    } QPOSLAT_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QUTMR;                           /*!< Time reading timer register                                           */
    
    struct {
      __IO uint32_t  QUTMR      : 32;               /*!< (null)                                                                */
    } QUTMR_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QUPRD;                           /*!< Period time reading timer register                                    */
    
    struct {
      __IO uint32_t  QUPRD      : 32;               /*!< (null)                                                                */
    } QUPRD_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QWDTMR;                          /*!< Watchdog timer register                                               */
    
    struct {
      __IO uint32_t  QWDTMR     : 32;               /*!< (null)                                                                */
    } QWDTMR_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QWDPRD;                          /*!< Period watchdog timer register                                        */
    
    struct {
      __IO uint32_t  QWDPRD     : 32;               /*!< (null)                                                                */
    } QWDPRD_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QDECCTL;                         /*!< Input control register                                                */
    
    struct {
           uint32_t             :  5;
      __IO uint32_t  QSP        :  1;               /*!< inversion QEPS                                                        */
      __IO uint32_t  QIP        :  1;               /*!< inv. QEPI                                                             */
      __IO uint32_t  QBP        :  1;               /*!< inv. QEPB                                                             */
      __IO uint32_t  QAP        :  1;               /*!< inv. QEPA                                                             */
      __IO uint32_t  IGATE      :  1;               /*!< strobing input signal                                                 */
      __IO uint32_t  SWAP       :  1;               /*!< trade places QEPA and QEPB                                            */
      __IO uint32_t  XCR        :  1;               /*!< edge selector                                                         */
      __IO uint32_t  SPSEL      :  1;               /*!< index/strobe output                                                   */
      __IO uint32_t  SOEN       :  1;               /*!< enable PCSOUT                                                         */
      __IO uint32_t  QSRC       :  2;               /*!< (null)                                                                */
    } QDECCTL_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QEPCTL;                          /*!< Quadrature decoder control register                                   */
    
    struct {
      __IO uint32_t  WDE        :  1;               /*!< enable watchdog timer                                                 */
      __IO uint32_t  UTE        :  1;               /*!< enable time reading timer                                             */
      __IO uint32_t  QCLM       :  1;               /*!< save countposition meaning                                            */
      __IO uint32_t  QPEN       :  1;               /*!< reset meaning countposition                                           */
      __IO uint32_t  IEL        :  2;               /*!< (null)                                                                */
      __IO uint32_t  SEL        :  1;               /*!< sttobevent                                                            */
      __IO uint32_t  SWI        :  1;               /*!< enable positioncount                                                  */
      __IO uint32_t  IEI        :  2;               /*!< (null)                                                                */
      __IO uint32_t  SEI        :  2;               /*!< (null)                                                                */
      __IO uint32_t  PCRM       :  2;               /*!< (null)                                                                */
      __IO uint32_t  FREE_SOFT  :  2;               /*!< (null)                                                                */
    } QEPCTL_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QCAPCTL;                         /*!< Capture register                                                      */
    
    struct {
      __IO uint32_t  UPPS       :  4;               /*!< (null)                                                                */
      __IO uint32_t  CCPS       :  3;               /*!< (null)                                                                */
      __IO uint32_t  SELEVENT   :  1;               /*!< Reset timer                                                           */
           uint32_t             :  7;
      __IO uint32_t  CEN        :  1;               /*!< enable decoder                                                        */
    } QCAPCTL_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QPOSCTL;                         /*!< Register countposition control                                        */
    
    struct {
      __IO uint32_t  PCSPW      : 12;               /*!< (null)                                                                */
      __IO uint32_t  PCE        :  1;               /*!< enable compare                                                        */
      __IO uint32_t  PCPOL      :  1;               /*!< polarity synchout                                                     */
      __IO uint32_t  PCLOAD     :  1;               /*!< Lazy write rate                                                       */
      __IO uint32_t  PCSHDW     :  1;               /*!< Lazy load                                                             */
    } QPOSCTL_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QEINT;                           /*!< Interrupt mask                                                        */
    
    struct {
           uint32_t             :  1;
      __IO uint32_t  PCE        :  1;               /*!< enable countpos interrupt                                             */
      __IO uint32_t  QPE        :  1;               /*!< errorphase interrupt                                                  */
      __IO uint32_t  QDC        :  1;               /*!< Change direction interrupt                                            */
      __IO uint32_t  WTO        :  1;               /*!< Watchdog interrupt                                                    */
      __IO uint32_t  PCU        :  1;               /*!< interrupt countmin                                                    */
      __IO uint32_t  PCO        :  1;               /*!< interrupt countmax                                                    */
      __IO uint32_t  PCR        :  1;               /*!< ready compare int                                                     */
      __IO uint32_t  PCM        :  1;               /*!< enable compare int                                                    */
      __IO uint32_t  SEL        :  1;               /*!< Strobe int                                                            */
      __IO uint32_t  IEL        :  1;               /*!< Index int                                                             */
      __IO uint32_t  UTO        :  1;               /*!< outflow time int                                                      */
    } QEINT_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  QFLG;                            /*!< Flag interrupt                                                        */
    
    struct {
      __I  uint32_t  INT        :  1;               /*!< outint flag                                                           */
      __I  uint32_t  PCE        :  1;               /*!< enable countpos interrupt flag                                        */
      __I  uint32_t  QPE        :  1;               /*!< errorphase interrupt flag                                             */
      __I  uint32_t  QDC        :  1;               /*!< Change direction interrupt flag                                       */
      __I  uint32_t  WTO        :  1;               /*!< Watchdog interrupt flag                                               */
      __I  uint32_t  PCU        :  1;               /*!< interrupt countmin flag                                               */
      __I  uint32_t  PCO        :  1;               /*!< interrupt countmax flag                                               */
      __I  uint32_t  PCR        :  1;               /*!< ready compare int flag                                                */
      __I  uint32_t  PCM        :  1;               /*!< enable compare int flag                                               */
      __I  uint32_t  SEL        :  1;               /*!< Strobe int flag                                                       */
      __I  uint32_t  IEL        :  1;               /*!< Index int flag                                                        */
      __I  uint32_t  UTO        :  1;               /*!< outflow time int flag                                                 */
    } QFLG_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QCLR;                            /*!< Reset interrupt                                                       */
    
    struct {
      __IO uint32_t  INT        :  1;               /*!< reset flag                                                            */
      __IO uint32_t  PCE        :  1;               /*!< reset flag                                                            */
      __IO uint32_t  QPE        :  1;               /*!< reset flag                                                            */
      __IO uint32_t  QDC        :  1;               /*!< reset flag                                                            */
      __IO uint32_t  WTO        :  1;               /*!< reset flag                                                            */
      __IO uint32_t  PCU        :  1;               /*!< reset flag                                                            */
      __IO uint32_t  PCO        :  1;               /*!< reset flag                                                            */
      __IO uint32_t  PCR        :  1;               /*!< reset flag                                                            */
      __IO uint32_t  PCM        :  1;               /*!< reset flag                                                            */
      __IO uint32_t  SEL        :  1;               /*!< reset flag                                                            */
      __IO uint32_t  IEL        :  1;               /*!< reset flag                                                            */
      __IO uint32_t  UTO        :  1;               /*!< reset flag                                                            */
    } QCLR_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QFRC;                            /*!< Emulation interrupt                                                   */
    
    struct {
           uint32_t             :  1;
      __IO uint32_t  PCE        :  1;               /*!< enable flag                                                           */
      __IO uint32_t  QPE        :  1;               /*!< enable flag                                                           */
      __IO uint32_t  QDC        :  1;               /*!< enable flag                                                           */
      __IO uint32_t  WTO        :  1;               /*!< enable flag                                                           */
      __IO uint32_t  PCU        :  1;               /*!< enable flag                                                           */
      __IO uint32_t  PCO        :  1;               /*!< enable flag                                                           */
      __IO uint32_t  PCR        :  1;               /*!< enable flag                                                           */
      __IO uint32_t  PCM        :  1;               /*!< enable flag                                                           */
      __IO uint32_t  SEL        :  1;               /*!< enable flag                                                           */
      __IO uint32_t  IEL        :  1;               /*!< enable flag                                                           */
      __IO uint32_t  UTO        :  1;               /*!< enable flag                                                           */
    } QFRC_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QEPSTS;                          /*!< Status interrupt                                                      */
    
    struct {
      __IO uint32_t  PCEF       :  1;               /*!< error position flag                                                   */
      __IO uint32_t  FIMF       :  1;               /*!< receiving impulse                                                     */
      __IO uint32_t  CDEF       :  1;               /*!< change rotation                                                       */
      __IO uint32_t  COEF       :  1;               /*!< Flag Counter Overflow quadrature                                      */
      __IO uint32_t  QDLF       :  1;               /*!< rotation of the rotor shaft                                           */
      __IO uint32_t  QDF        :  1;               /*!< rotation of the rotor shaft                                           */
      __IO uint32_t  FIDF       :  1;               /*!< rotation of the rotor shaft                                           */
      __IO uint32_t  UPEVNT     :  1;               /*!< Flag timer time samples                                               */
    } QEPSTS_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QCTMR;                           /*!< Timer register                                                        */
    
    struct {
      __IO uint32_t  QCTMR      : 32;               /*!< (null)                                                                */
    } QCTMR_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QCPRD;                           /*!< Period register                                                       */
    
    struct {
      __IO uint32_t  QCPRD      : 32;               /*!< (null)                                                                */
    } QCPRD_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  QCTMRLAT;                        /*!< Register Storage Timer                                                */
    
    struct {
      __I  uint32_t  QCTMRLAT   : 32;               /*!< (null)                                                                */
    } QCTMRLAT_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  QCPRDLAT;                        /*!< Register Storage Period                                               */
    
    struct {
      __IO uint32_t  QCPRDLAT   : 32;               /*!< (null)                                                                */
    } QCPRDLAT_b;                                   /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED[4];
  
  union {
    __IO uint32_t  INTCLR;                          /*!< Clear interrupt register                                              */
    
    struct {
      __IO uint32_t  INT        :  1;               /*!< Active interrupt by read, write 1 to clear interrupt                  */
    } INTCLR_b;                                     /*!< BitSize                                                               */
  };
} NT_QEP0_Type;


/* ================================================================================ */
/* ================                  NT_BOOTFLASH                  ================ */
/* ================================================================================ */


/**
  * @brief BOOTFLASH controller registers (NT_BOOTFLASH)
  */

typedef struct {                                    /*!< NT_BOOTFLASH Structure                                                */
  
  union {
    __IO uint32_t  FMA;                             /*!< Address bootflash register                                            */
    
    struct {
      __IO uint32_t  ADDR       : 20;               /*!< (null)                                                                */
    } FMA_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  FMD0;                            /*!< Data words bootable flash register 0                                  */
    
    struct {
      __IO uint32_t  DATA0      : 32;               /*!< (null)                                                                */
    } FMD0_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  FMC;                             /*!< Command register                                                      */
    
    struct {
      __O  uint32_t  WRITE      :  1;               /*!< Bit writing in main block                                             */
      __O  uint32_t  PAGE_ERASE :  1;               /*!< Bit paged erase the main block                                        */
      __O  uint32_t  FULL_ERASE :  1;               /*!< Bit erase main block                                                  */
           uint32_t             :  1;
      __O  uint32_t  WRITE_IFB  :  1;               /*!< Bit writing on information block                                      */
      __O  uint32_t  PAGEERASE_IFB:  1;             /*!< Bit erase page of information block                                   */
           uint32_t             : 10;
      __O  uint32_t  MAGIC_KEY  : 16;               /*!< (null)                                                                */
    } FMC_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  FCIS;                            /*!< Status register                                                       */
    
    struct {
      __I  uint32_t  OP_CMLT    :  1;               /*!< Completion flag operation                                             */
      __I  uint32_t  OP_ERROR   :  1;               /*!< Flag write error, erase block write-protected or non-existent,
                                                         or read from a non-existent block                                     */
    } FCIS_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  FCIM;                            /*!< Interrupt mask register                                               */
    
    struct {
      __IO uint32_t  MASK_OPCMLT:  1;               /*!< Enables generation of an interrupt upon completion of a read
                                                         or write, or erase                                                    */
    } FCIM_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  FCIC;                            /*!< Command register                                                      */
    
    struct {
      __O  uint32_t  CLR_OPCMLT :  1;               /*!< Clear flag operate complit                                            */
      __O  uint32_t  CLR_OPERROR:  1;               /*!< Clear flag operate Error                                              */
    } FCIC_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED[14];
  
  union {
    __IO uint32_t  FMD1;                            /*!< Data words bootable flash register 1                                  */
    
    struct {
      __IO uint32_t  DATA1      : 32;               /*!< (null)                                                                */
    } FMD1_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  FMD2;                            /*!< Data words bootable flash register 2                                  */
    
    struct {
      __IO uint32_t  DATA2      : 32;               /*!< (null)                                                                */
    } FMD2_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  FMD3;                            /*!< Data words bootable flash register 3                                  */
    
    struct {
      __IO uint32_t  DATA3      : 32;               /*!< (null)                                                                */
    } FMD3_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED1[9];
  
  union {
    __IO uint32_t  T_ACC;                           /*!< Register the delay of setting addresses to read data from the
                                                         flash memory                                                          */
    
    struct {
      __IO uint32_t  T_ACC      : 32;               /*!< (null)                                                                */
    } T_ACC_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_NVS;                           /*!< Register signal delay lifting NVSTR after lifting signal PROG         */
    
    struct {
      __IO uint32_t  T_NVS      : 32;               /*!< (null)                                                                */
    } T_NVS_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_NVH;                           /*!< Register sets the release delay signal NVSTR after releasing
                                                         signal PROG                                                           */
    
    struct {
      __IO uint32_t  T_NVH      : 32;               /*!< (null)                                                                */
    } T_NVH_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_RCV;                           /*!< Register delay from releasing signal NVSTR to raise it to the
                                                         next transaction                                                      */
    
    struct {
      __IO uint32_t  T_RCV      : 32;               /*!< (null)                                                                */
    } T_RCV_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_PGS;                           /*!< Register delay lifting signal YE after lifting signal NVSTR           */
    
    struct {
      __IO uint32_t  T_PGS      : 32;               /*!< (null)                                                                */
    } T_PGS_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_PROG;                          /*!< Register YE signal duration in recording transactions                 */
    
    struct {
      __IO uint32_t  T_PROG     : 32;               /*!< (null)                                                                */
    } T_PROG_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_PGH;                           /*!< Register delay signal NVSTR after releasing signal YE                 */
    
    struct {
      __IO uint32_t  T_PGH      : 32;               /*!< (null)                                                                */
    } T_PGH_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_ERASE;                         /*!< Register duration of the signal in transactions ERASE erasure         */
    
    struct {
      __IO uint32_t  T_ERASE    : 32;               /*!< (null)                                                                */
    } T_ERASE_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_ME;                            /*!< Register specifies the duration of the signal in transactions
                                                         ERASE erasure                                                         */
    
    struct {
      __IO uint32_t  T_ME       : 32;               /*!< (null)                                                                */
    } T_ME_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_NVH1;                          /*!< Register specifies the duration of the signal in transactions
                                                         ERASE erasure                                                         */
    
    struct {
      __IO uint32_t  T_NVH1     : 32;               /*!< (null)                                                                */
    } T_NVH1_b;                                     /*!< BitSize                                                               */
  };
} NT_BOOTFLASH_Type;


/* ================================================================================ */
/* ================                    NT_UART0                    ================ */
/* ================================================================================ */


/**
  * @brief UART controller registers (NT_UART0)
  */

typedef struct {                                    /*!< NT_UART0 Structure                                                    */
  
  union {
    __IO uint32_t  DR;                              /*!< Data Register                                                         */
    
    struct {
      __IO uint32_t  DATA       :  8;               /*!< (null)                                                                */
      __I  uint32_t  FE         :  1;               /*!< Framing error                                                         */
      __I  uint32_t  PE         :  1;               /*!< Parity error                                                          */
      __I  uint32_t  BE         :  1;               /*!< Break error                                                           */
      __I  uint32_t  OE         :  1;               /*!< Overrun error                                                         */
    } DR_b;                                         /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  RSR_ECR;                         /*!< Receive Status Register/Error Clear Register                          */
    
    struct {
      __IO uint32_t  FE         :  1;               /*!< Framing error                                                         */
      __IO uint32_t  PE         :  1;               /*!< Parity error                                                          */
      __IO uint32_t  BE         :  1;               /*!< Break error                                                           */
      __IO uint32_t  OE         :  1;               /*!< Overrun error                                                         */
    } RSR_ECR_b;                                    /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED[4];
  
  union {
    __I  uint32_t  FR;                              /*!< Flag Register                                                         */
    
    struct {
      __I  uint32_t  CTS        :  1;               /*!< Clear to send                                                         */
      __I  uint32_t  DSR        :  1;               /*!< Data set ready                                                        */
      __I  uint32_t  DCD        :  1;               /*!< Data carrier detect                                                   */
      __I  uint32_t  BUSY       :  1;               /*!< UART busy                                                             */
      __I  uint32_t  RXFE       :  1;               /*!< Receive FIFO empty                                                    */
      __I  uint32_t  TXFF       :  1;               /*!< Transmit FIFO full                                                    */
      __I  uint32_t  RXFF       :  1;               /*!< Receive FIFO full                                                     */
      __I  uint32_t  TXFE       :  1;               /*!< Transmit FIFO empty                                                   */
      __I  uint32_t  RI         :  1;               /*!< Ring indicator                                                        */
    } FR_b;                                         /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED1[2];
  
  union {
    __IO uint32_t  IBRD;                            /*!< Integer Baud Rate Register                                            */
    
    struct {
      __IO uint32_t  BAUD_DIVINT: 16;               /*!< (null)                                                                */
    } IBRD_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  FBRD;                            /*!< Fractional Baud Rate Register                                         */
    
    struct {
      __IO uint32_t  BAUD_DIVFRAC:  6;              /*!< (null)                                                                */
    } FBRD_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  LCR_H;                           /*!< Line Control Register                                                 */
    
    struct {
      __IO uint32_t  BRK        :  1;               /*!< Send break                                                            */
      __IO uint32_t  PEN        :  1;               /*!< Parity enable                                                         */
      __IO uint32_t  EPS        :  1;               /*!< Even parity select                                                    */
      __IO uint32_t  STP2       :  1;               /*!< Two stop bits select                                                  */
      __IO uint32_t  FEN        :  1;               /*!< Enable FIFOs                                                          */
      __IO uint32_t  WLEN       :  2;               /*!< (null)                                                                */
      __IO uint32_t  SPS        :  1;               /*!< Stick parity select                                                   */
    } LCR_H_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CR;                              /*!< Control Register                                                      */
    
    struct {
      __IO uint32_t  UARTEN     :  1;               /*!< UART enable                                                           */
           uint32_t             :  7;
      __IO uint32_t  TXE        :  1;               /*!< Transmit enable                                                       */
      __IO uint32_t  RXE        :  1;               /*!< Receive enable                                                        */
      __IO uint32_t  DTR        :  1;               /*!< Data transmit ready                                                   */
      __IO uint32_t  RTS        :  1;               /*!< Request to send                                                       */
      __IO uint32_t  OUT1       :  1;               /*!< This bit is the complement of the UART Out1 (nUARTOut1) modem
                                                         status output                                                         */
      __IO uint32_t  OUT2       :  1;               /*!< This bit is the complement of the UART Out2 (nUARTOut2) modem
                                                         status output                                                         */
      __IO uint32_t  RTSEN      :  1;               /*!< RTS hardware flow control enable                                      */
      __IO uint32_t  CTSEN      :  1;               /*!< CTS hardware flow control enable                                      */
    } CR_b;                                         /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  IFLS;                            /*!< Interrupt FIFO Level Select Register                                  */
    
    struct {
      __IO uint32_t  TXIFLSEL   :  3;               /*!< (null)                                                                */
      __IO uint32_t  RXIFLSEL   :  3;               /*!< (null)                                                                */
    } IFLS_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  IMSC;                            /*!< Interrupt Mask Set/Clear Register                                     */
    
    struct {
      __IO uint32_t  RIMIM      :  1;               /*!< nUARTRI modem interrupt mask                                          */
      __IO uint32_t  CTSMIM     :  1;               /*!< nUARTCTS modem interrupt mask                                         */
      __IO uint32_t  DCDMIM     :  1;               /*!< nUARTDCD modem interrupt mask                                         */
      __IO uint32_t  DSRMIM     :  1;               /*!< nUARTDSR modem interrupt mask                                         */
      __IO uint32_t  RXIM       :  1;               /*!< Receive interrupt mask                                                */
      __IO uint32_t  TXIM       :  1;               /*!< Transmit interrupt mask                                               */
      __IO uint32_t  RTIM       :  1;               /*!< Receive timeout interrupt mask                                        */
      __IO uint32_t  FEIM       :  1;               /*!< Framing error interrupt mask                                          */
      __IO uint32_t  PEIM       :  1;               /*!< Parity error interrupt mask                                           */
      __IO uint32_t  BEIM       :  1;               /*!< Break error interrupt mask                                            */
      __IO uint32_t  OEIM       :  1;               /*!< Overrun error interrupt mask                                          */
    } IMSC_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  RIS;                             /*!< Raw Interrupt Status Register                                         */
    
    struct {
      __I  uint32_t  RIRMIS     :  1;               /*!< nUARTRI modem interrupt status                                        */
      __I  uint32_t  CTSRMIS    :  1;               /*!< nUARTCTS modem interrupt status                                       */
      __I  uint32_t  DCDRMIS    :  1;               /*!< nUARTDCD modem interrupt status                                       */
      __I  uint32_t  DSRRMIS    :  1;               /*!< nUARTDSR modem interrupt status                                       */
      __I  uint32_t  RXRIS      :  1;               /*!< Receive interrupt status                                              */
      __I  uint32_t  TXRIS      :  1;               /*!< Transmit interrupt status                                             */
      __I  uint32_t  RTRIS      :  1;               /*!< Receive timeout interrupt status                                      */
      __I  uint32_t  FERIS      :  1;               /*!< Framing error interrupt status                                        */
      __I  uint32_t  PERIS      :  1;               /*!< Parity error interrupt status                                         */
      __I  uint32_t  BERIS      :  1;               /*!< Break error interrupt status                                          */
      __I  uint32_t  OERIS      :  1;               /*!< Overrun error interrupt status                                        */
    } RIS_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  MIS;                             /*!< Masked Interrupt Status Register                                      */
    
    struct {
      __I  uint32_t  RIMMIS     :  1;               /*!< nUARTRI modem masked interrupt status                                 */
      __I  uint32_t  CTSMMIS    :  1;               /*!< nUARTCTS modem masked interrupt status                                */
      __I  uint32_t  DCDMMIS    :  1;               /*!< nUARTDCD modem masked interrupt status                                */
      __I  uint32_t  DSRMMIS    :  1;               /*!< nUARTDSR modem masked interrupt status                                */
      __I  uint32_t  RXMIS      :  1;               /*!< Receive masked interrupt status                                       */
      __I  uint32_t  TXMIS      :  1;               /*!< Transmit masked interrupt status                                      */
      __I  uint32_t  RTMIS      :  1;               /*!< Receive timeout masked interrupt status                               */
      __I  uint32_t  FEMIS      :  1;               /*!< Framing error masked interrupt status                                 */
      __I  uint32_t  PEMIS      :  1;               /*!< Parity error masked interrupt status                                  */
      __I  uint32_t  BEMIS      :  1;               /*!< Break error masked interrupt status                                   */
      __I  uint32_t  OEMIS      :  1;               /*!< Overrun error masked interrupt status                                 */
    } MIS_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  ICR;                             /*!< Interrupt Clear Register                                              */
    
    struct {
      __O  uint32_t  RIMIC      :  1;               /*!< nUARTRI modem interrupt clear                                         */
      __O  uint32_t  CTSMIC     :  1;               /*!< nUARTCTS modem interrupt clear                                        */
      __O  uint32_t  DCDMIC     :  1;               /*!< nUARTDCD modem interrupt clear                                        */
      __O  uint32_t  DSRMIC     :  1;               /*!< nUARTDSR modem interrupt clear                                        */
      __O  uint32_t  RXIC       :  1;               /*!< Receive interrupt clear                                               */
      __O  uint32_t  TXIC       :  1;               /*!< Transmit interrupt clear                                              */
      __O  uint32_t  RTIC       :  1;               /*!< Receive timeout interrupt clear                                       */
      __O  uint32_t  FEIC       :  1;               /*!< Framing error interrupt clear                                         */
      __O  uint32_t  PEIC       :  1;               /*!< Parity error interrupt clear                                          */
      __O  uint32_t  BEIC       :  1;               /*!< Break error interrupt clear                                           */
      __O  uint32_t  OEIC       :  1;               /*!< Overrun error interrupt clear                                         */
    } ICR_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  DMACR;                           /*!< DMA Control Register                                                  */
    
    struct {
      __IO uint32_t  RXDMAE     :  1;               /*!< Receive DMA enable                                                    */
      __IO uint32_t  TXDMAE     :  1;               /*!< Transmit DMA enable                                                   */
      __IO uint32_t  DMAONERR   :  1;               /*!< DMA on error                                                          */
    } DMACR_b;                                      /*!< BitSize                                                               */
  };
} NT_UART0_Type;


/* ================================================================================ */
/* ================                     NT_CMP                     ================ */
/* ================================================================================ */


/**
  * @brief CMP controller registers (NT_CMP)
  */

typedef struct {                                    /*!< NT_CMP Structure                                                      */
  
  union {
    __IO uint32_t  MIS;                             /*!< Masked interrupt status register                                      */
    
    struct {
      __IO uint32_t  IN0        :  1;               /*!< reset interrupt status CMP0                                           */
      __IO uint32_t  IN1        :  1;               /*!< reset interrupt status CMP1                                           */
      __IO uint32_t  IN2        :  1;               /*!< reset interrupt status CMP2                                           */
           uint32_t             : 13;
      __IO uint32_t  INT0       :  1;               /*!< reset get interrupt CMP0                                              */
      __IO uint32_t  INT1       :  1;               /*!< reset get interrupt CMP1                                              */
      __IO uint32_t  INT2       :  1;               /*!< reset get interrupt CMP2                                              */
    } MIS_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  RIS;                             /*!< Interrupt Status Register                                             */
    
    struct {
      __I  uint32_t  IN0        :  1;               /*!< set interrupt status CMP0                                             */
      __I  uint32_t  IN1        :  1;               /*!< set interrupt status CMP1                                             */
      __I  uint32_t  IN2        :  1;               /*!< set interrupt status CMP2                                             */
    } RIS_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  INTEN;                           /*!< Interrupt mask register                                               */
    
    struct {
      __IO uint32_t  IN0        :  1;               /*!< Mask interrupt CMP0                                                   */
      __IO uint32_t  IN1        :  1;               /*!< Mask interrupt CMP1                                                   */
      __IO uint32_t  IN2        :  1;               /*!< Mask interrupt CMP2                                                   */
    } INTEN_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  REFCTL0;                         /*!< Reference voltage control DAC0 register                               */
    
    struct {
      __IO uint32_t  VREF       :  4;               /*!< (null)                                                                */
           uint32_t             :  4;
      __IO uint32_t  RNG        :  1;               /*!< range of the DAC                                                      */
      __IO uint32_t  EN         :  1;               /*!< power to the built-in DAC                                             */
    } REFCTL0_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  REFCTL1;                         /*!< Reference voltage control DAC1 register                               */
    
    struct {
      __IO uint32_t  VREF       :  4;               /*!< (null)                                                                */
           uint32_t             :  4;
      __IO uint32_t  RNG        :  1;               /*!< range of the DAC                                                      */
      __IO uint32_t  EN         :  1;               /*!< power to the built-in DAC                                             */
    } REFCTL1_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  REFCTL2;                         /*!< Reference voltage control DAC2 register                               */
    
    struct {
      __IO uint32_t  VREF       :  4;               /*!< (null)                                                                */
           uint32_t             :  4;
      __IO uint32_t  RNG        :  1;               /*!< range of the DAC                                                      */
      __IO uint32_t  EN         :  1;               /*!< power to the built-in DAC                                             */
    } REFCTL2_b;                                    /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED[2];
  
  union {
    __I  uint32_t  STAT0;                           /*!< Status register CMP0                                                  */
    
    struct {
           uint32_t             :  1;
      __I  uint32_t  OVAL       :  1;               /*!< output value of the comparator0                                       */
    } STAT0_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CTL0;                            /*!< Control Register CMP0                                                 */
    
    struct {
      __IO uint32_t  CEN        :  1;               /*!< enable compare 0                                                      */
      __IO uint32_t  CINV       :  1;               /*!< polarity of output signal                                             */
      __IO uint32_t  ISEN       :  2;               /*!< (null)                                                                */
      __IO uint32_t  ISVAL      :  1;               /*!< interrupt on a low level                                              */
      __IO uint32_t  TSEN       :  2;               /*!< (null)                                                                */
      __IO uint32_t  TSVAL      :  1;               /*!< ADC start at a low level                                              */
      __IO uint32_t  ASRCP      :  2;               /*!< (null)                                                                */
      __IO uint32_t  TOEN       :  1;               /*!< ADC start generating events                                           */
    } CTL0_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED1[6];
  
  union {
    __I  uint32_t  STAT1;                           /*!< Status register CMP1                                                  */
    
    struct {
           uint32_t             :  1;
      __I  uint32_t  OVAL       :  1;               /*!< output value of the comparator1                                       */
    } STAT1_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CTL1;                            /*!< Control Register CMP1                                                 */
    
    struct {
      __IO uint32_t  CEN        :  1;               /*!< enable compare 1                                                      */
      __IO uint32_t  CINV       :  1;               /*!< polarity of output signal                                             */
      __IO uint32_t  ISEN       :  2;               /*!< (null)                                                                */
      __IO uint32_t  ISVAL      :  1;               /*!< interrupt on a low level                                              */
      __IO uint32_t  TSEN       :  2;               /*!< (null)                                                                */
      __IO uint32_t  TSVAL      :  1;               /*!< ADC start at a low level                                              */
      __IO uint32_t  ASRCP      :  2;               /*!< (null)                                                                */
      __IO uint32_t  TOEN       :  1;               /*!< ADC start generating events                                           */
    } CTL1_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED2[6];
  
  union {
    __I  uint32_t  STAT2;                           /*!< Status register CMP2                                                  */
    
    struct {
           uint32_t             :  1;
      __I  uint32_t  OVAL       :  1;               /*!< output value of the comparator2                                       */
    } STAT2_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  CTL2;                            /*!< Control Register CMP2                                                 */
    
    struct {
      __IO uint32_t  CEN        :  1;               /*!< enable compare 2                                                      */
      __IO uint32_t  CINV       :  1;               /*!< polarity of output signal                                             */
      __IO uint32_t  ISEN       :  2;               /*!< (null)                                                                */
      __IO uint32_t  ISVAL      :  1;               /*!< interrupt on a low level                                              */
      __IO uint32_t  TSEN       :  2;               /*!< (null)                                                                */
      __IO uint32_t  TSVAL      :  1;               /*!< ADC start at a low level                                              */
      __IO uint32_t  ASRCP      :  2;               /*!< (null)                                                                */
      __IO uint32_t  TOEN       :  1;               /*!< ADC start generating events                                           */
    } CTL2_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED3[5];
  
  union {
    __IO uint32_t  POWER;                           /*!< Power analog circuits register                                        */
    
    struct {
      __IO uint32_t  PWU        :  1;               /*!< Enable power analog circuits                                          */
    } POWER_b;                                      /*!< BitSize                                                               */
  };
} NT_CMP_Type;


/* ================================================================================ */
/* ================                     NT_SPI0                    ================ */
/* ================================================================================ */


/**
  * @brief SPI controller registers (NT_SPI0)
  */

typedef struct {                                    /*!< NT_SPI0 Structure                                                     */
  
  union {
    __IO uint32_t  SPI_CR0;                         /*!< Control register 0                                                    */
    
    struct {
      __IO uint32_t  DSS        :  4;               /*!< (null)                                                                */
      __IO uint32_t  FRF        :  2;               /*!< (null)                                                                */
      __IO uint32_t  SPO        :  1;               /*!< Polarity SSPCLKOUT                                                    */
      __IO uint32_t  SPH        :  1;               /*!< Phase SSPCLKOUT                                                       */
      __IO uint32_t  SCR        :  8;               /*!< (null)                                                                */
    } SPI_CR0_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SPI_CR1;                         /*!< Control register 1                                                    */
    
    struct {
           uint32_t             :  1;
      __IO uint32_t  SSE        :  1;               /*!< Enable transceiver                                                    */
      __IO uint32_t  MS         :  1;               /*!< Select mode                                                           */
      __IO uint32_t  SOD        :  1;               /*!< Disable bit data                                                      */
    } SPI_CR1_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SPI_DR;                          /*!< Data register                                                         */
    
    struct {
      __IO uint32_t  DATA       : 16;               /*!< (null)                                                                */
    } SPI_DR_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  SPI_SR;                          /*!< State register                                                        */
    
    struct {
      __I  uint32_t  TFE        :  1;               /*!< FIFO buffer empty flag transmitter                                    */
      __I  uint32_t  TNF        :  1;               /*!< Indicator the transmitter FIFO buffer is not full                     */
      __I  uint32_t  RNE        :  1;               /*!< Indicate not empty reseive buffer                                     */
      __I  uint32_t  RFF        :  1;               /*!< Indicate empty receive buffer                                         */
      __I  uint32_t  BSY        :  1;               /*!< Activity flag                                                         */
    } SPI_SR_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SPI_CPSR;                        /*!< Clock division factor register                                        */
    
    struct {
      __I  uint32_t  CPSDVSR    :  8;               /*!< (null)                                                                */
    } SPI_CPSR_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SPI_IMSC;                        /*!< Mask interrupt register                                               */
    
    struct {
      __IO uint32_t  RORIM      :  1;               /*!< Interrupt mask bit SSPRORINTR buffer overflow receiver                */
      __IO uint32_t  RTIM       :  1;               /*!< Interrupt mask bit SSPRTINTR timeout receiver                         */
      __IO uint32_t  RXIM       :  1;               /*!< SSPRXINTR interrupt mask bit to fill 50% or less of the receiver
                                                         FIFO buffer                                                           */
      __IO uint32_t  TXIM       :  1;               /*!< SSPTXINTR interrupt mask bit to fill 50% or less of the FIFO
                                                         buffer of the transmitter                                             */
    } SPI_IMSC_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  SPI_RIS;                         /*!< Status register interrupt without mask                                */
    
    struct {
      __I  uint32_t  RORRIS     :  1;               /*!< Interrupt status before masking SSPRORINTR                            */
      __I  uint32_t  RTRIS      :  1;               /*!< Interrupt status before masking SSPRTINTR                             */
      __I  uint32_t  RXRIS      :  1;               /*!< Interrupt status before masking SSPRXINTR                             */
      __I  uint32_t  TXRIS      :  1;               /*!< Interrupt status before masking SSPTXINTR                             */
    } SPI_RIS_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  SPI_MIS;                         /*!< Status register interrupt masking account                             */
    
    struct {
      __I  uint32_t  RORRIS     :  1;               /*!< Masked interrupt status SSPRORINTR                                    */
      __I  uint32_t  RTRIS      :  1;               /*!< Masked interrupt status SSPRTINTR                                     */
      __I  uint32_t  RXRIS      :  1;               /*!< Masked interrupt status SSPRXINTR                                     */
      __I  uint32_t  TXRIS      :  1;               /*!< Masked interrupt status SSPTXINTR                                     */
    } SPI_MIS_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  SPI_ICR;                         /*!< Register reset interrupt                                              */
    
    struct {
      __O  uint32_t  RORIC      :  1;               /*!< Reset interrupt SSPRORINTR                                            */
      __O  uint32_t  RTIC       :  1;               /*!< Reset interrupt SSPRTINTR                                             */
    } SPI_ICR_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SPI_DMACR;                       /*!< Control register DMA                                                  */
    
    struct {
      __IO uint32_t  RXDMAE     :  1;               /*!< DMA enable bit at reception                                           */
      __IO uint32_t  TXDMAE     :  1;               /*!< DMA enable bit transmission                                           */
    } SPI_DMACR_b;                                  /*!< BitSize                                                               */
  };
} NT_SPI0_Type;


/* ================================================================================ */
/* ================                  NT_USERFLASH                  ================ */
/* ================================================================================ */


/**
  * @brief USERFLASH controller registers (NT_USERFLASH)
  */

typedef struct {                                    /*!< NT_USERFLASH Structure                                                */
  
  union {
    __IO uint32_t  FMA;                             /*!< Address userflash register                                            */
    
    struct {
      __IO uint32_t  ADDR       : 16;               /*!< Address for commands write and page erase                             */
    } FMA_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  FMD;                             /*!< Data byte user flash register                                         */
    
    struct {
      __IO uint32_t  DATA       :  8;               /*!< User flash data                                                       */
    } FMD_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  FMC;                             /*!< Command register                                                      */
    
    struct {
      __O  uint32_t  WRITE      :  1;               /*!< Bit writing in main block                                             */
      __O  uint32_t  PAGE_ERASE :  1;               /*!< Bit paged erase the main block                                        */
      __O  uint32_t  FULL_ERASE :  1;               /*!< Bit erase main block                                                  */
      __O  uint32_t  READ       :  1;               /*!< (null)                                                                */
      __O  uint32_t  WRITE_IFB  :  1;               /*!< Bit writing on information block                                      */
      __O  uint32_t  PAGEERASE_IFB:  1;             /*!< Bit erase page of information block                                   */
      __O  uint32_t  READ_IFB   :  1;               /*!< (null)                                                                */
           uint32_t             :  9;
      __O  uint32_t  MAGIC_KEY  : 16;               /*!< Code run command. For activate command in MAGIC_KEY write 0xA442      */
    } FMC_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  FCIS;                            /*!< Status register                                                       */
    
    struct {
      __I  uint32_t  OP_CMLT    :  1;               /*!< Completion flag operation                                             */
      __I  uint32_t  OP_ERROR   :  1;               /*!< Flag write error, erase block write-protected or non-existent,
                                                         or read from a non-existent block                                     */
    } FCIS_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  FCIM;                            /*!< Interrupt mask register                                               */
    
    struct {
      __IO uint32_t  MASK_OPCMLT:  1;               /*!< Enables generation of an interrupt upon completion of a read
                                                         or write, or erase                                                    */
    } FCIM_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  FCIC;                            /*!< Clear status register                                                 */
    
    struct {
      __O  uint32_t  CLR_OPCMLT :  1;               /*!< Clear flag operate complit                                            */
      __O  uint32_t  CLR_OPERROR:  1;               /*!< Clear flag operate Error                                              */
    } FCIC_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED[26];
  
  union {
    __IO uint32_t  T_ACC;                           /*!< Register the delay of setting addresses to read data from the
                                                         flash memory                                                          */
    
    struct {
      __IO uint32_t  T_ACC      : 32;               /*!< (null)                                                                */
    } T_ACC_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_NVS;                           /*!< Register signal delay lifting NVSTR after lifting signal PROG         */
    
    struct {
      __IO uint32_t  T_NVS      : 32;               /*!< (null)                                                                */
    } T_NVS_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_NVH;                           /*!< Register sets the release delay signal NVSTR after releasing
                                                         signal PROG                                                           */
    
    struct {
      __IO uint32_t  T_NVH      : 32;               /*!< (null)                                                                */
    } T_NVH_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_RCV;                           /*!< Register delay from releasing signal NVSTR to raise it to the
                                                         next transaction                                                      */
    
    struct {
      __IO uint32_t  T_RCV      : 32;               /*!< (null)                                                                */
    } T_RCV_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_PGS;                           /*!< Register delay lifting signal YE after lifting signal NVSTR           */
    
    struct {
      __IO uint32_t  T_PGS      : 32;               /*!< (null)                                                                */
    } T_PGS_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_PROG;                          /*!< Register YE signal duration in recording transactions                 */
    
    struct {
      __IO uint32_t  T_PROG     : 32;               /*!< (null)                                                                */
    } T_PROG_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_PGH;                           /*!< Register delay signal NVSTR after releasing signal YE                 */
    
    struct {
      __IO uint32_t  T_PGH      : 32;               /*!< (null)                                                                */
    } T_PGH_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_ERASE;                         /*!< Register duration of the signal in transactions ERASE erasure         */
    
    struct {
      __IO uint32_t  T_ERASE    : 32;               /*!< (null)                                                                */
    } T_ERASE_b;                                    /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_ME;                            /*!< Register specifies the duration of the signal in transactions
                                                         ERASE erasure                                                         */
    
    struct {
      __IO uint32_t  T_ME       : 32;               /*!< (null)                                                                */
    } T_ME_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  T_NVH1;                          /*!< Register specifies the duration of the signal in transactions
                                                         ERASE erasure                                                         */
    
    struct {
      __IO uint32_t  T_NVH1     : 32;               /*!< (null)                                                                */
    } T_NVH1_b;                                     /*!< BitSize                                                               */
  };
} NT_USERFLASH_Type;


/* ================================================================================ */
/* ================                     NT_RTC                     ================ */
/* ================================================================================ */


/**
  * @brief RTC controller registers (NT_RTC)
  */

typedef struct {                                    /*!< NT_RTC Structure                                                      */
  
  union {
    __IO uint32_t  PSECONDS;                        /*!< Part seconds register                                                 */
    
    struct {
      __IO uint32_t  PART_SEC   : 10;               /*!< (null)                                                                */
    } PSECONDS_b;                                   /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  SECOND;                          /*!< Seconds register                                                      */
    
    struct {
      __IO uint32_t  SECOND     :  7;               /*!< (null)                                                                */
    } SECOND_b;                                     /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MINUTE;                          /*!< Minute register                                                       */
    
    struct {
      __IO uint32_t  MINUTE     :  7;               /*!< (null)                                                                */
    } MINUTE_b;                                     /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED;
  
  union {
    __IO uint32_t  HOUR;                            /*!< Hour register                                                         */
    
    struct {
      __IO uint32_t  HOUR       :  6;               /*!< Hours in BCD format                                                   */
    } HOUR_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED1;
  
  union {
    __IO uint32_t  WDAY;                            /*!< Day of week register                                                  */
    
    struct {
      __IO uint32_t  DAYWEEK    :  3;               /*!< (null)                                                                */
    } WDAY_b;                                       /*!< BitSize                                                               */
  };
  __I  uint32_t  RESERVED2;
  
  union {
    __IO uint32_t  DAY;                             /*!< Day register                                                          */
    
    struct {
      __IO uint32_t  DAY        :  6;               /*!< Day in BCD format                                                     */
    } DAY_b;                                        /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  MONTH;                           /*!< Month register                                                        */
    
    struct {
      __IO uint32_t  MONTH      :  5;               /*!< (null)                                                                */
    } MONTH_b;                                      /*!< BitSize                                                               */
  };
  
  union {
    __IO uint32_t  YEAR;                            /*!< Year register                                                         */
    
    struct {
      __IO uint32_t  YEAR       :  8;               /*!< (null)                                                                */
    } YEAR_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __O  uint32_t  SHDW;                            /*!< Register Update shadow registers RTC                                  */
    
    struct {
           uint32_t             :  7;
      __O  uint32_t  UPDTEN     :  1;               /*!< Enable update shadow registers RTC                                    */
    } SHDW_b;                                       /*!< BitSize                                                               */
  };
  
  union {
    __I  uint32_t  TIME;                            /*!< General register Time                                                 */
    
    struct {
      __I  uint32_t  SPLIT_SEC  : 10;               /*!< (null)                                                                */
      __I  uint32_t  SECOND     :  7;               /*!< (null)                                                                */
      __I  uint32_t  MINUTE     :  7;               /*!< (null)                                                                */
      __I  uint32_t  HOUR       :  6;               /*!< (null)                                                                */
    } TIME_b;                                       /*!< BitSize                                                               */
  };
} NT_RTC_Type;


/* --------------------  End of section using anonymous unions  ------------------- */
#if defined(__CC_ARM)
  #pragma pop
#elif defined(__ICCARM__)
  /* leave anonymous unions enabled */
#elif defined(__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined(__TMS470__)
  /* anonymous unions are enabled by default */
#elif defined(__TASKING__)
  #pragma warning restore
#else
  #warning Not supported compiler type
#endif



/* ================================================================================ */
/* ================         struct 'NT_ADC' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_ADC_ACTSS  -------------------------------- */
#define NT_ADC_ACTSS_ASEN0_Pos                0                                                       /*!< NT_ADC ACTSS: ASEN0 Position            */
#define NT_ADC_ACTSS_ASEN0_Msk                (0x01UL << NT_ADC_ACTSS_ASEN0_Pos)                      /*!< NT_ADC ACTSS: ASEN0 Mask                */
#define NT_ADC_ACTSS_ASEN1_Pos                1                                                       /*!< NT_ADC ACTSS: ASEN1 Position            */
#define NT_ADC_ACTSS_ASEN1_Msk                (0x01UL << NT_ADC_ACTSS_ASEN1_Pos)                      /*!< NT_ADC ACTSS: ASEN1 Mask                */
#define NT_ADC_ACTSS_ASEN2_Pos                2                                                       /*!< NT_ADC ACTSS: ASEN2 Position            */
#define NT_ADC_ACTSS_ASEN2_Msk                (0x01UL << NT_ADC_ACTSS_ASEN2_Pos)                      /*!< NT_ADC ACTSS: ASEN2 Mask                */
#define NT_ADC_ACTSS_ASEN3_Pos                3                                                       /*!< NT_ADC ACTSS: ASEN3 Position            */
#define NT_ADC_ACTSS_ASEN3_Msk                (0x01UL << NT_ADC_ACTSS_ASEN3_Pos)                      /*!< NT_ADC ACTSS: ASEN3 Mask                */
#define NT_ADC_ACTSS_ASEN4_Pos                4                                                       /*!< NT_ADC ACTSS: ASEN4 Position            */
#define NT_ADC_ACTSS_ASEN4_Msk                (0x01UL << NT_ADC_ACTSS_ASEN4_Pos)                      /*!< NT_ADC ACTSS: ASEN4 Mask                */
#define NT_ADC_ACTSS_ASEN5_Pos                5                                                       /*!< NT_ADC ACTSS: ASEN5 Position            */
#define NT_ADC_ACTSS_ASEN5_Msk                (0x01UL << NT_ADC_ACTSS_ASEN5_Pos)                      /*!< NT_ADC ACTSS: ASEN5 Mask                */
#define NT_ADC_ACTSS_ASEN6_Pos                6                                                       /*!< NT_ADC ACTSS: ASEN6 Position            */
#define NT_ADC_ACTSS_ASEN6_Msk                (0x01UL << NT_ADC_ACTSS_ASEN6_Pos)                      /*!< NT_ADC ACTSS: ASEN6 Mask                */
#define NT_ADC_ACTSS_ASEN7_Pos                7                                                       /*!< NT_ADC ACTSS: ASEN7 Position            */
#define NT_ADC_ACTSS_ASEN7_Msk                (0x01UL << NT_ADC_ACTSS_ASEN7_Pos)                      /*!< NT_ADC ACTSS: ASEN7 Mask                */

/* ---------------------------------  NT_ADC_RIS  --------------------------------- */
#define NT_ADC_RIS_INR0_Pos                   0                                                       /*!< NT_ADC RIS: INR0 Position               */
#define NT_ADC_RIS_INR0_Msk                   (0x01UL << NT_ADC_RIS_INR0_Pos)                         /*!< NT_ADC RIS: INR0 Mask                   */
#define NT_ADC_RIS_INR1_Pos                   1                                                       /*!< NT_ADC RIS: INR1 Position               */
#define NT_ADC_RIS_INR1_Msk                   (0x01UL << NT_ADC_RIS_INR1_Pos)                         /*!< NT_ADC RIS: INR1 Mask                   */
#define NT_ADC_RIS_INR2_Pos                   2                                                       /*!< NT_ADC RIS: INR2 Position               */
#define NT_ADC_RIS_INR2_Msk                   (0x01UL << NT_ADC_RIS_INR2_Pos)                         /*!< NT_ADC RIS: INR2 Mask                   */
#define NT_ADC_RIS_INR3_Pos                   3                                                       /*!< NT_ADC RIS: INR3 Position               */
#define NT_ADC_RIS_INR3_Msk                   (0x01UL << NT_ADC_RIS_INR3_Pos)                         /*!< NT_ADC RIS: INR3 Mask                   */
#define NT_ADC_RIS_INR4_Pos                   4                                                       /*!< NT_ADC RIS: INR4 Position               */
#define NT_ADC_RIS_INR4_Msk                   (0x01UL << NT_ADC_RIS_INR4_Pos)                         /*!< NT_ADC RIS: INR4 Mask                   */
#define NT_ADC_RIS_INR5_Pos                   5                                                       /*!< NT_ADC RIS: INR5 Position               */
#define NT_ADC_RIS_INR5_Msk                   (0x01UL << NT_ADC_RIS_INR5_Pos)                         /*!< NT_ADC RIS: INR5 Mask                   */
#define NT_ADC_RIS_INR6_Pos                   6                                                       /*!< NT_ADC RIS: INR6 Position               */
#define NT_ADC_RIS_INR6_Msk                   (0x01UL << NT_ADC_RIS_INR6_Pos)                         /*!< NT_ADC RIS: INR6 Mask                   */
#define NT_ADC_RIS_INR7_Pos                   7                                                       /*!< NT_ADC RIS: INR7 Position               */
#define NT_ADC_RIS_INR7_Msk                   (0x01UL << NT_ADC_RIS_INR7_Pos)                         /*!< NT_ADC RIS: INR7 Mask                   */
#define NT_ADC_RIS_INRDC0_Pos                 8                                                       /*!< NT_ADC RIS: INRDC0 Position             */
#define NT_ADC_RIS_INRDC0_Msk                 (0x01UL << NT_ADC_RIS_INRDC0_Pos)                       /*!< NT_ADC RIS: INRDC0 Mask                 */
#define NT_ADC_RIS_INRDC1_Pos                 9                                                       /*!< NT_ADC RIS: INRDC1 Position             */
#define NT_ADC_RIS_INRDC1_Msk                 (0x01UL << NT_ADC_RIS_INRDC1_Pos)                       /*!< NT_ADC RIS: INRDC1 Mask                 */
#define NT_ADC_RIS_INRDC2_Pos                 10                                                      /*!< NT_ADC RIS: INRDC2 Position             */
#define NT_ADC_RIS_INRDC2_Msk                 (0x01UL << NT_ADC_RIS_INRDC2_Pos)                       /*!< NT_ADC RIS: INRDC2 Mask                 */
#define NT_ADC_RIS_INRDC3_Pos                 11                                                      /*!< NT_ADC RIS: INRDC3 Position             */
#define NT_ADC_RIS_INRDC3_Msk                 (0x01UL << NT_ADC_RIS_INRDC3_Pos)                       /*!< NT_ADC RIS: INRDC3 Mask                 */
#define NT_ADC_RIS_INRDC4_Pos                 12                                                      /*!< NT_ADC RIS: INRDC4 Position             */
#define NT_ADC_RIS_INRDC4_Msk                 (0x01UL << NT_ADC_RIS_INRDC4_Pos)                       /*!< NT_ADC RIS: INRDC4 Mask                 */
#define NT_ADC_RIS_INRDC5_Pos                 13                                                      /*!< NT_ADC RIS: INRDC5 Position             */
#define NT_ADC_RIS_INRDC5_Msk                 (0x01UL << NT_ADC_RIS_INRDC5_Pos)                       /*!< NT_ADC RIS: INRDC5 Mask                 */
#define NT_ADC_RIS_INRDC6_Pos                 14                                                      /*!< NT_ADC RIS: INRDC6 Position             */
#define NT_ADC_RIS_INRDC6_Msk                 (0x01UL << NT_ADC_RIS_INRDC6_Pos)                       /*!< NT_ADC RIS: INRDC6 Mask                 */
#define NT_ADC_RIS_INRDC7_Pos                 15                                                      /*!< NT_ADC RIS: INRDC7 Position             */
#define NT_ADC_RIS_INRDC7_Msk                 (0x01UL << NT_ADC_RIS_INRDC7_Pos)                       /*!< NT_ADC RIS: INRDC7 Mask                 */
#define NT_ADC_RIS_INRDC8_Pos                 16                                                      /*!< NT_ADC RIS: INRDC8 Position             */
#define NT_ADC_RIS_INRDC8_Msk                 (0x01UL << NT_ADC_RIS_INRDC8_Pos)                       /*!< NT_ADC RIS: INRDC8 Mask                 */
#define NT_ADC_RIS_INRDC9_Pos                 17                                                      /*!< NT_ADC RIS: INRDC9 Position             */
#define NT_ADC_RIS_INRDC9_Msk                 (0x01UL << NT_ADC_RIS_INRDC9_Pos)                       /*!< NT_ADC RIS: INRDC9 Mask                 */
#define NT_ADC_RIS_INRDC10_Pos                18                                                      /*!< NT_ADC RIS: INRDC10 Position            */
#define NT_ADC_RIS_INRDC10_Msk                (0x01UL << NT_ADC_RIS_INRDC10_Pos)                      /*!< NT_ADC RIS: INRDC10 Mask                */
#define NT_ADC_RIS_INRDC11_Pos                19                                                      /*!< NT_ADC RIS: INRDC11 Position            */
#define NT_ADC_RIS_INRDC11_Msk                (0x01UL << NT_ADC_RIS_INRDC11_Pos)                      /*!< NT_ADC RIS: INRDC11 Mask                */
#define NT_ADC_RIS_INRDC12_Pos                20                                                      /*!< NT_ADC RIS: INRDC12 Position            */
#define NT_ADC_RIS_INRDC12_Msk                (0x01UL << NT_ADC_RIS_INRDC12_Pos)                      /*!< NT_ADC RIS: INRDC12 Mask                */
#define NT_ADC_RIS_INRDC13_Pos                21                                                      /*!< NT_ADC RIS: INRDC13 Position            */
#define NT_ADC_RIS_INRDC13_Msk                (0x01UL << NT_ADC_RIS_INRDC13_Pos)                      /*!< NT_ADC RIS: INRDC13 Mask                */
#define NT_ADC_RIS_INRDC14_Pos                22                                                      /*!< NT_ADC RIS: INRDC14 Position            */
#define NT_ADC_RIS_INRDC14_Msk                (0x01UL << NT_ADC_RIS_INRDC14_Pos)                      /*!< NT_ADC RIS: INRDC14 Mask                */
#define NT_ADC_RIS_INRDC15_Pos                23                                                      /*!< NT_ADC RIS: INRDC15 Position            */
#define NT_ADC_RIS_INRDC15_Msk                (0x01UL << NT_ADC_RIS_INRDC15_Pos)                      /*!< NT_ADC RIS: INRDC15 Mask                */
#define NT_ADC_RIS_INRDC16_Pos                24                                                      /*!< NT_ADC RIS: INRDC16 Position            */
#define NT_ADC_RIS_INRDC16_Msk                (0x01UL << NT_ADC_RIS_INRDC16_Pos)                      /*!< NT_ADC RIS: INRDC16 Mask                */
#define NT_ADC_RIS_INRDC17_Pos                25                                                      /*!< NT_ADC RIS: INRDC17 Position            */
#define NT_ADC_RIS_INRDC17_Msk                (0x01UL << NT_ADC_RIS_INRDC17_Pos)                      /*!< NT_ADC RIS: INRDC17 Mask                */
#define NT_ADC_RIS_INRDC18_Pos                26                                                      /*!< NT_ADC RIS: INRDC18 Position            */
#define NT_ADC_RIS_INRDC18_Msk                (0x01UL << NT_ADC_RIS_INRDC18_Pos)                      /*!< NT_ADC RIS: INRDC18 Mask                */
#define NT_ADC_RIS_INRDC19_Pos                27                                                      /*!< NT_ADC RIS: INRDC19 Position            */
#define NT_ADC_RIS_INRDC19_Msk                (0x01UL << NT_ADC_RIS_INRDC19_Pos)                      /*!< NT_ADC RIS: INRDC19 Mask                */
#define NT_ADC_RIS_INRDC20_Pos                28                                                      /*!< NT_ADC RIS: INRDC20 Position            */
#define NT_ADC_RIS_INRDC20_Msk                (0x01UL << NT_ADC_RIS_INRDC20_Pos)                      /*!< NT_ADC RIS: INRDC20 Mask                */
#define NT_ADC_RIS_INRDC21_Pos                29                                                      /*!< NT_ADC RIS: INRDC21 Position            */
#define NT_ADC_RIS_INRDC21_Msk                (0x01UL << NT_ADC_RIS_INRDC21_Pos)                      /*!< NT_ADC RIS: INRDC21 Mask                */
#define NT_ADC_RIS_INRDC22_Pos                30                                                      /*!< NT_ADC RIS: INRDC22 Position            */
#define NT_ADC_RIS_INRDC22_Msk                (0x01UL << NT_ADC_RIS_INRDC22_Pos)                      /*!< NT_ADC RIS: INRDC22 Mask                */
#define NT_ADC_RIS_INRDC23_Pos                31                                                      /*!< NT_ADC RIS: INRDC23 Position            */
#define NT_ADC_RIS_INRDC23_Msk                (0x01UL << NT_ADC_RIS_INRDC23_Pos)                      /*!< NT_ADC RIS: INRDC23 Mask                */

/* ----------------------------------  NT_ADC_IM  --------------------------------- */
#define NT_ADC_IM_MASK0_Pos                   0                                                       /*!< NT_ADC IM: MASK0 Position               */
#define NT_ADC_IM_MASK0_Msk                   (0x01UL << NT_ADC_IM_MASK0_Pos)                         /*!< NT_ADC IM: MASK0 Mask                   */
#define NT_ADC_IM_MASK1_Pos                   1                                                       /*!< NT_ADC IM: MASK1 Position               */
#define NT_ADC_IM_MASK1_Msk                   (0x01UL << NT_ADC_IM_MASK1_Pos)                         /*!< NT_ADC IM: MASK1 Mask                   */
#define NT_ADC_IM_MASK2_Pos                   2                                                       /*!< NT_ADC IM: MASK2 Position               */
#define NT_ADC_IM_MASK2_Msk                   (0x01UL << NT_ADC_IM_MASK2_Pos)                         /*!< NT_ADC IM: MASK2 Mask                   */
#define NT_ADC_IM_MASK3_Pos                   3                                                       /*!< NT_ADC IM: MASK3 Position               */
#define NT_ADC_IM_MASK3_Msk                   (0x01UL << NT_ADC_IM_MASK3_Pos)                         /*!< NT_ADC IM: MASK3 Mask                   */
#define NT_ADC_IM_MASK4_Pos                   4                                                       /*!< NT_ADC IM: MASK4 Position               */
#define NT_ADC_IM_MASK4_Msk                   (0x01UL << NT_ADC_IM_MASK4_Pos)                         /*!< NT_ADC IM: MASK4 Mask                   */
#define NT_ADC_IM_MASK5_Pos                   5                                                       /*!< NT_ADC IM: MASK5 Position               */
#define NT_ADC_IM_MASK5_Msk                   (0x01UL << NT_ADC_IM_MASK5_Pos)                         /*!< NT_ADC IM: MASK5 Mask                   */
#define NT_ADC_IM_MASK6_Pos                   6                                                       /*!< NT_ADC IM: MASK6 Position               */
#define NT_ADC_IM_MASK6_Msk                   (0x01UL << NT_ADC_IM_MASK6_Pos)                         /*!< NT_ADC IM: MASK6 Mask                   */
#define NT_ADC_IM_MASK7_Pos                   7                                                       /*!< NT_ADC IM: MASK7 Position               */
#define NT_ADC_IM_MASK7_Msk                   (0x01UL << NT_ADC_IM_MASK7_Pos)                         /*!< NT_ADC IM: MASK7 Mask                   */
#define NT_ADC_IM_MIDC0_Pos                   8                                                       /*!< NT_ADC IM: MIDC0 Position               */
#define NT_ADC_IM_MIDC0_Msk                   (0x01UL << NT_ADC_IM_MIDC0_Pos)                         /*!< NT_ADC IM: MIDC0 Mask                   */
#define NT_ADC_IM_MIDC1_Pos                   9                                                       /*!< NT_ADC IM: MIDC1 Position               */
#define NT_ADC_IM_MIDC1_Msk                   (0x01UL << NT_ADC_IM_MIDC1_Pos)                         /*!< NT_ADC IM: MIDC1 Mask                   */
#define NT_ADC_IM_MIDC2_Pos                   10                                                      /*!< NT_ADC IM: MIDC2 Position               */
#define NT_ADC_IM_MIDC2_Msk                   (0x01UL << NT_ADC_IM_MIDC2_Pos)                         /*!< NT_ADC IM: MIDC2 Mask                   */
#define NT_ADC_IM_MIDC3_Pos                   11                                                      /*!< NT_ADC IM: MIDC3 Position               */
#define NT_ADC_IM_MIDC3_Msk                   (0x01UL << NT_ADC_IM_MIDC3_Pos)                         /*!< NT_ADC IM: MIDC3 Mask                   */
#define NT_ADC_IM_MIDC4_Pos                   12                                                      /*!< NT_ADC IM: MIDC4 Position               */
#define NT_ADC_IM_MIDC4_Msk                   (0x01UL << NT_ADC_IM_MIDC4_Pos)                         /*!< NT_ADC IM: MIDC4 Mask                   */
#define NT_ADC_IM_MIDC5_Pos                   13                                                      /*!< NT_ADC IM: MIDC5 Position               */
#define NT_ADC_IM_MIDC5_Msk                   (0x01UL << NT_ADC_IM_MIDC5_Pos)                         /*!< NT_ADC IM: MIDC5 Mask                   */
#define NT_ADC_IM_MIDC6_Pos                   14                                                      /*!< NT_ADC IM: MIDC6 Position               */
#define NT_ADC_IM_MIDC6_Msk                   (0x01UL << NT_ADC_IM_MIDC6_Pos)                         /*!< NT_ADC IM: MIDC6 Mask                   */
#define NT_ADC_IM_MIDC7_Pos                   15                                                      /*!< NT_ADC IM: MIDC7 Position               */
#define NT_ADC_IM_MIDC7_Msk                   (0x01UL << NT_ADC_IM_MIDC7_Pos)                         /*!< NT_ADC IM: MIDC7 Mask                   */
#define NT_ADC_IM_MIDC8_Pos                   16                                                      /*!< NT_ADC IM: MIDC8 Position               */
#define NT_ADC_IM_MIDC8_Msk                   (0x01UL << NT_ADC_IM_MIDC8_Pos)                         /*!< NT_ADC IM: MIDC8 Mask                   */
#define NT_ADC_IM_MIDC9_Pos                   17                                                      /*!< NT_ADC IM: MIDC9 Position               */
#define NT_ADC_IM_MIDC9_Msk                   (0x01UL << NT_ADC_IM_MIDC9_Pos)                         /*!< NT_ADC IM: MIDC9 Mask                   */
#define NT_ADC_IM_MIDC10_Pos                  18                                                      /*!< NT_ADC IM: MIDC10 Position              */
#define NT_ADC_IM_MIDC10_Msk                  (0x01UL << NT_ADC_IM_MIDC10_Pos)                        /*!< NT_ADC IM: MIDC10 Mask                  */
#define NT_ADC_IM_MIDC11_Pos                  19                                                      /*!< NT_ADC IM: MIDC11 Position              */
#define NT_ADC_IM_MIDC11_Msk                  (0x01UL << NT_ADC_IM_MIDC11_Pos)                        /*!< NT_ADC IM: MIDC11 Mask                  */
#define NT_ADC_IM_MIDC12_Pos                  20                                                      /*!< NT_ADC IM: MIDC12 Position              */
#define NT_ADC_IM_MIDC12_Msk                  (0x01UL << NT_ADC_IM_MIDC12_Pos)                        /*!< NT_ADC IM: MIDC12 Mask                  */
#define NT_ADC_IM_MIDC13_Pos                  21                                                      /*!< NT_ADC IM: MIDC13 Position              */
#define NT_ADC_IM_MIDC13_Msk                  (0x01UL << NT_ADC_IM_MIDC13_Pos)                        /*!< NT_ADC IM: MIDC13 Mask                  */
#define NT_ADC_IM_MIDC14_Pos                  22                                                      /*!< NT_ADC IM: MIDC14 Position              */
#define NT_ADC_IM_MIDC14_Msk                  (0x01UL << NT_ADC_IM_MIDC14_Pos)                        /*!< NT_ADC IM: MIDC14 Mask                  */
#define NT_ADC_IM_MIDC15_Pos                  23                                                      /*!< NT_ADC IM: MIDC15 Position              */
#define NT_ADC_IM_MIDC15_Msk                  (0x01UL << NT_ADC_IM_MIDC15_Pos)                        /*!< NT_ADC IM: MIDC15 Mask                  */
#define NT_ADC_IM_MIDC16_Pos                  24                                                      /*!< NT_ADC IM: MIDC16 Position              */
#define NT_ADC_IM_MIDC16_Msk                  (0x01UL << NT_ADC_IM_MIDC16_Pos)                        /*!< NT_ADC IM: MIDC16 Mask                  */
#define NT_ADC_IM_MIDC17_Pos                  25                                                      /*!< NT_ADC IM: MIDC17 Position              */
#define NT_ADC_IM_MIDC17_Msk                  (0x01UL << NT_ADC_IM_MIDC17_Pos)                        /*!< NT_ADC IM: MIDC17 Mask                  */
#define NT_ADC_IM_MIDC18_Pos                  26                                                      /*!< NT_ADC IM: MIDC18 Position              */
#define NT_ADC_IM_MIDC18_Msk                  (0x01UL << NT_ADC_IM_MIDC18_Pos)                        /*!< NT_ADC IM: MIDC18 Mask                  */
#define NT_ADC_IM_MIDC19_Pos                  27                                                      /*!< NT_ADC IM: MIDC19 Position              */
#define NT_ADC_IM_MIDC19_Msk                  (0x01UL << NT_ADC_IM_MIDC19_Pos)                        /*!< NT_ADC IM: MIDC19 Mask                  */
#define NT_ADC_IM_MIDC20_Pos                  28                                                      /*!< NT_ADC IM: MIDC20 Position              */
#define NT_ADC_IM_MIDC20_Msk                  (0x01UL << NT_ADC_IM_MIDC20_Pos)                        /*!< NT_ADC IM: MIDC20 Mask                  */
#define NT_ADC_IM_MIDC21_Pos                  29                                                      /*!< NT_ADC IM: MIDC21 Position              */
#define NT_ADC_IM_MIDC21_Msk                  (0x01UL << NT_ADC_IM_MIDC21_Pos)                        /*!< NT_ADC IM: MIDC21 Mask                  */
#define NT_ADC_IM_MIDC22_Pos                  30                                                      /*!< NT_ADC IM: MIDC22 Position              */
#define NT_ADC_IM_MIDC22_Msk                  (0x01UL << NT_ADC_IM_MIDC22_Pos)                        /*!< NT_ADC IM: MIDC22 Mask                  */
#define NT_ADC_IM_MIDC23_Pos                  31                                                      /*!< NT_ADC IM: MIDC23 Position              */
#define NT_ADC_IM_MIDC23_Msk                  (0x01UL << NT_ADC_IM_MIDC23_Pos)                        /*!< NT_ADC IM: MIDC23 Mask                  */

/* ---------------------------------  NT_ADC_ISC  --------------------------------- */
#define NT_ADC_ISC_IN0_Pos                    0                                                       /*!< NT_ADC ISC: IN0 Position                */
#define NT_ADC_ISC_IN0_Msk                    (0x01UL << NT_ADC_ISC_IN0_Pos)                          /*!< NT_ADC ISC: IN0 Mask                    */
#define NT_ADC_ISC_IN1_Pos                    1                                                       /*!< NT_ADC ISC: IN1 Position                */
#define NT_ADC_ISC_IN1_Msk                    (0x01UL << NT_ADC_ISC_IN1_Pos)                          /*!< NT_ADC ISC: IN1 Mask                    */
#define NT_ADC_ISC_IN2_Pos                    2                                                       /*!< NT_ADC ISC: IN2 Position                */
#define NT_ADC_ISC_IN2_Msk                    (0x01UL << NT_ADC_ISC_IN2_Pos)                          /*!< NT_ADC ISC: IN2 Mask                    */
#define NT_ADC_ISC_IN3_Pos                    3                                                       /*!< NT_ADC ISC: IN3 Position                */
#define NT_ADC_ISC_IN3_Msk                    (0x01UL << NT_ADC_ISC_IN3_Pos)                          /*!< NT_ADC ISC: IN3 Mask                    */
#define NT_ADC_ISC_IN4_Pos                    4                                                       /*!< NT_ADC ISC: IN4 Position                */
#define NT_ADC_ISC_IN4_Msk                    (0x01UL << NT_ADC_ISC_IN4_Pos)                          /*!< NT_ADC ISC: IN4 Mask                    */
#define NT_ADC_ISC_IN5_Pos                    5                                                       /*!< NT_ADC ISC: IN5 Position                */
#define NT_ADC_ISC_IN5_Msk                    (0x01UL << NT_ADC_ISC_IN5_Pos)                          /*!< NT_ADC ISC: IN5 Mask                    */
#define NT_ADC_ISC_IN6_Pos                    6                                                       /*!< NT_ADC ISC: IN6 Position                */
#define NT_ADC_ISC_IN6_Msk                    (0x01UL << NT_ADC_ISC_IN6_Pos)                          /*!< NT_ADC ISC: IN6 Mask                    */
#define NT_ADC_ISC_IN7_Pos                    7                                                       /*!< NT_ADC ISC: IN7 Position                */
#define NT_ADC_ISC_IN7_Msk                    (0x01UL << NT_ADC_ISC_IN7_Pos)                          /*!< NT_ADC ISC: IN7 Mask                    */
#define NT_ADC_ISC_DCIN0_Pos                  8                                                       /*!< NT_ADC ISC: DCIN0 Position              */
#define NT_ADC_ISC_DCIN0_Msk                  (0x01UL << NT_ADC_ISC_DCIN0_Pos)                        /*!< NT_ADC ISC: DCIN0 Mask                  */
#define NT_ADC_ISC_DCIN1_Pos                  9                                                       /*!< NT_ADC ISC: DCIN1 Position              */
#define NT_ADC_ISC_DCIN1_Msk                  (0x01UL << NT_ADC_ISC_DCIN1_Pos)                        /*!< NT_ADC ISC: DCIN1 Mask                  */
#define NT_ADC_ISC_DCIN2_Pos                  10                                                      /*!< NT_ADC ISC: DCIN2 Position              */
#define NT_ADC_ISC_DCIN2_Msk                  (0x01UL << NT_ADC_ISC_DCIN2_Pos)                        /*!< NT_ADC ISC: DCIN2 Mask                  */
#define NT_ADC_ISC_DCIN3_Pos                  11                                                      /*!< NT_ADC ISC: DCIN3 Position              */
#define NT_ADC_ISC_DCIN3_Msk                  (0x01UL << NT_ADC_ISC_DCIN3_Pos)                        /*!< NT_ADC ISC: DCIN3 Mask                  */
#define NT_ADC_ISC_DCIN4_Pos                  12                                                      /*!< NT_ADC ISC: DCIN4 Position              */
#define NT_ADC_ISC_DCIN4_Msk                  (0x01UL << NT_ADC_ISC_DCIN4_Pos)                        /*!< NT_ADC ISC: DCIN4 Mask                  */
#define NT_ADC_ISC_DCIN5_Pos                  13                                                      /*!< NT_ADC ISC: DCIN5 Position              */
#define NT_ADC_ISC_DCIN5_Msk                  (0x01UL << NT_ADC_ISC_DCIN5_Pos)                        /*!< NT_ADC ISC: DCIN5 Mask                  */
#define NT_ADC_ISC_DCIN6_Pos                  14                                                      /*!< NT_ADC ISC: DCIN6 Position              */
#define NT_ADC_ISC_DCIN6_Msk                  (0x01UL << NT_ADC_ISC_DCIN6_Pos)                        /*!< NT_ADC ISC: DCIN6 Mask                  */
#define NT_ADC_ISC_DCIN7_Pos                  15                                                      /*!< NT_ADC ISC: DCIN7 Position              */
#define NT_ADC_ISC_DCIN7_Msk                  (0x01UL << NT_ADC_ISC_DCIN7_Pos)                        /*!< NT_ADC ISC: DCIN7 Mask                  */
#define NT_ADC_ISC_DCIN8_Pos                  16                                                      /*!< NT_ADC ISC: DCIN8 Position              */
#define NT_ADC_ISC_DCIN8_Msk                  (0x01UL << NT_ADC_ISC_DCIN8_Pos)                        /*!< NT_ADC ISC: DCIN8 Mask                  */
#define NT_ADC_ISC_DCIN9_Pos                  17                                                      /*!< NT_ADC ISC: DCIN9 Position              */
#define NT_ADC_ISC_DCIN9_Msk                  (0x01UL << NT_ADC_ISC_DCIN9_Pos)                        /*!< NT_ADC ISC: DCIN9 Mask                  */
#define NT_ADC_ISC_DCIN10_Pos                 18                                                      /*!< NT_ADC ISC: DCIN10 Position             */
#define NT_ADC_ISC_DCIN10_Msk                 (0x01UL << NT_ADC_ISC_DCIN10_Pos)                       /*!< NT_ADC ISC: DCIN10 Mask                 */
#define NT_ADC_ISC_DCIN11_Pos                 19                                                      /*!< NT_ADC ISC: DCIN11 Position             */
#define NT_ADC_ISC_DCIN11_Msk                 (0x01UL << NT_ADC_ISC_DCIN11_Pos)                       /*!< NT_ADC ISC: DCIN11 Mask                 */
#define NT_ADC_ISC_DCIN12_Pos                 20                                                      /*!< NT_ADC ISC: DCIN12 Position             */
#define NT_ADC_ISC_DCIN12_Msk                 (0x01UL << NT_ADC_ISC_DCIN12_Pos)                       /*!< NT_ADC ISC: DCIN12 Mask                 */
#define NT_ADC_ISC_DCIN13_Pos                 21                                                      /*!< NT_ADC ISC: DCIN13 Position             */
#define NT_ADC_ISC_DCIN13_Msk                 (0x01UL << NT_ADC_ISC_DCIN13_Pos)                       /*!< NT_ADC ISC: DCIN13 Mask                 */
#define NT_ADC_ISC_DCIN14_Pos                 22                                                      /*!< NT_ADC ISC: DCIN14 Position             */
#define NT_ADC_ISC_DCIN14_Msk                 (0x01UL << NT_ADC_ISC_DCIN14_Pos)                       /*!< NT_ADC ISC: DCIN14 Mask                 */
#define NT_ADC_ISC_DCIN15_Pos                 23                                                      /*!< NT_ADC ISC: DCIN15 Position             */
#define NT_ADC_ISC_DCIN15_Msk                 (0x01UL << NT_ADC_ISC_DCIN15_Pos)                       /*!< NT_ADC ISC: DCIN15 Mask                 */
#define NT_ADC_ISC_DCIN16_Pos                 24                                                      /*!< NT_ADC ISC: DCIN16 Position             */
#define NT_ADC_ISC_DCIN16_Msk                 (0x01UL << NT_ADC_ISC_DCIN16_Pos)                       /*!< NT_ADC ISC: DCIN16 Mask                 */
#define NT_ADC_ISC_DCIN17_Pos                 25                                                      /*!< NT_ADC ISC: DCIN17 Position             */
#define NT_ADC_ISC_DCIN17_Msk                 (0x01UL << NT_ADC_ISC_DCIN17_Pos)                       /*!< NT_ADC ISC: DCIN17 Mask                 */
#define NT_ADC_ISC_DCIN18_Pos                 26                                                      /*!< NT_ADC ISC: DCIN18 Position             */
#define NT_ADC_ISC_DCIN18_Msk                 (0x01UL << NT_ADC_ISC_DCIN18_Pos)                       /*!< NT_ADC ISC: DCIN18 Mask                 */
#define NT_ADC_ISC_DCIN19_Pos                 27                                                      /*!< NT_ADC ISC: DCIN19 Position             */
#define NT_ADC_ISC_DCIN19_Msk                 (0x01UL << NT_ADC_ISC_DCIN19_Pos)                       /*!< NT_ADC ISC: DCIN19 Mask                 */
#define NT_ADC_ISC_DCIN20_Pos                 28                                                      /*!< NT_ADC ISC: DCIN20 Position             */
#define NT_ADC_ISC_DCIN20_Msk                 (0x01UL << NT_ADC_ISC_DCIN20_Pos)                       /*!< NT_ADC ISC: DCIN20 Mask                 */
#define NT_ADC_ISC_DCIN21_Pos                 29                                                      /*!< NT_ADC ISC: DCIN21 Position             */
#define NT_ADC_ISC_DCIN21_Msk                 (0x01UL << NT_ADC_ISC_DCIN21_Pos)                       /*!< NT_ADC ISC: DCIN21 Mask                 */
#define NT_ADC_ISC_DCIN22_Pos                 30                                                      /*!< NT_ADC ISC: DCIN22 Position             */
#define NT_ADC_ISC_DCIN22_Msk                 (0x01UL << NT_ADC_ISC_DCIN22_Pos)                       /*!< NT_ADC ISC: DCIN22 Mask                 */
#define NT_ADC_ISC_DCIN23_Pos                 31                                                      /*!< NT_ADC ISC: DCIN23 Position             */
#define NT_ADC_ISC_DCIN23_Msk                 (0x01UL << NT_ADC_ISC_DCIN23_Pos)                       /*!< NT_ADC ISC: DCIN23 Mask                 */

/* --------------------------------  NT_ADC_OSTAT  -------------------------------- */
#define NT_ADC_OSTAT_OV0_Pos                  0                                                       /*!< NT_ADC OSTAT: OV0 Position              */
#define NT_ADC_OSTAT_OV0_Msk                  (0x01UL << NT_ADC_OSTAT_OV0_Pos)                        /*!< NT_ADC OSTAT: OV0 Mask                  */
#define NT_ADC_OSTAT_OV1_Pos                  1                                                       /*!< NT_ADC OSTAT: OV1 Position              */
#define NT_ADC_OSTAT_OV1_Msk                  (0x01UL << NT_ADC_OSTAT_OV1_Pos)                        /*!< NT_ADC OSTAT: OV1 Mask                  */
#define NT_ADC_OSTAT_OV2_Pos                  2                                                       /*!< NT_ADC OSTAT: OV2 Position              */
#define NT_ADC_OSTAT_OV2_Msk                  (0x01UL << NT_ADC_OSTAT_OV2_Pos)                        /*!< NT_ADC OSTAT: OV2 Mask                  */
#define NT_ADC_OSTAT_OV3_Pos                  3                                                       /*!< NT_ADC OSTAT: OV3 Position              */
#define NT_ADC_OSTAT_OV3_Msk                  (0x01UL << NT_ADC_OSTAT_OV3_Pos)                        /*!< NT_ADC OSTAT: OV3 Mask                  */
#define NT_ADC_OSTAT_OV4_Pos                  4                                                       /*!< NT_ADC OSTAT: OV4 Position              */
#define NT_ADC_OSTAT_OV4_Msk                  (0x01UL << NT_ADC_OSTAT_OV4_Pos)                        /*!< NT_ADC OSTAT: OV4 Mask                  */
#define NT_ADC_OSTAT_OV5_Pos                  5                                                       /*!< NT_ADC OSTAT: OV5 Position              */
#define NT_ADC_OSTAT_OV5_Msk                  (0x01UL << NT_ADC_OSTAT_OV5_Pos)                        /*!< NT_ADC OSTAT: OV5 Mask                  */
#define NT_ADC_OSTAT_OV6_Pos                  6                                                       /*!< NT_ADC OSTAT: OV6 Position              */
#define NT_ADC_OSTAT_OV6_Msk                  (0x01UL << NT_ADC_OSTAT_OV6_Pos)                        /*!< NT_ADC OSTAT: OV6 Mask                  */
#define NT_ADC_OSTAT_OV7_Pos                  7                                                       /*!< NT_ADC OSTAT: OV7 Position              */
#define NT_ADC_OSTAT_OV7_Msk                  (0x01UL << NT_ADC_OSTAT_OV7_Pos)                        /*!< NT_ADC OSTAT: OV7 Mask                  */
#define NT_ADC_OSTAT_DOV0_Pos                 16                                                      /*!< NT_ADC OSTAT: DOV0 Position             */
#define NT_ADC_OSTAT_DOV0_Msk                 (0x01UL << NT_ADC_OSTAT_DOV0_Pos)                       /*!< NT_ADC OSTAT: DOV0 Mask                 */
#define NT_ADC_OSTAT_DOV1_Pos                 17                                                      /*!< NT_ADC OSTAT: DOV1 Position             */
#define NT_ADC_OSTAT_DOV1_Msk                 (0x01UL << NT_ADC_OSTAT_DOV1_Pos)                       /*!< NT_ADC OSTAT: DOV1 Mask                 */
#define NT_ADC_OSTAT_DOV2_Pos                 18                                                      /*!< NT_ADC OSTAT: DOV2 Position             */
#define NT_ADC_OSTAT_DOV2_Msk                 (0x01UL << NT_ADC_OSTAT_DOV2_Pos)                       /*!< NT_ADC OSTAT: DOV2 Mask                 */
#define NT_ADC_OSTAT_DOV3_Pos                 19                                                      /*!< NT_ADC OSTAT: DOV3 Position             */
#define NT_ADC_OSTAT_DOV3_Msk                 (0x01UL << NT_ADC_OSTAT_DOV3_Pos)                       /*!< NT_ADC OSTAT: DOV3 Mask                 */
#define NT_ADC_OSTAT_DOV4_Pos                 20                                                      /*!< NT_ADC OSTAT: DOV4 Position             */
#define NT_ADC_OSTAT_DOV4_Msk                 (0x01UL << NT_ADC_OSTAT_DOV4_Pos)                       /*!< NT_ADC OSTAT: DOV4 Mask                 */
#define NT_ADC_OSTAT_DOV5_Pos                 21                                                      /*!< NT_ADC OSTAT: DOV5 Position             */
#define NT_ADC_OSTAT_DOV5_Msk                 (0x01UL << NT_ADC_OSTAT_DOV5_Pos)                       /*!< NT_ADC OSTAT: DOV5 Mask                 */
#define NT_ADC_OSTAT_DOV6_Pos                 22                                                      /*!< NT_ADC OSTAT: DOV6 Position             */
#define NT_ADC_OSTAT_DOV6_Msk                 (0x01UL << NT_ADC_OSTAT_DOV6_Pos)                       /*!< NT_ADC OSTAT: DOV6 Mask                 */
#define NT_ADC_OSTAT_DOV7_Pos                 23                                                      /*!< NT_ADC OSTAT: DOV7 Position             */
#define NT_ADC_OSTAT_DOV7_Msk                 (0x01UL << NT_ADC_OSTAT_DOV7_Pos)                       /*!< NT_ADC OSTAT: DOV7 Mask                 */

/* ---------------------------------  NT_ADC_EMUX  -------------------------------- */
#define NT_ADC_EMUX_EM0_Pos                   0                                                       /*!< NT_ADC EMUX: EM0 Position               */
#define NT_ADC_EMUX_EM0_Msk                   (0x0fUL << NT_ADC_EMUX_EM0_Pos)                         /*!< NT_ADC EMUX: EM0 Mask                   */
#define NT_ADC_EMUX_EM1_Pos                   4                                                       /*!< NT_ADC EMUX: EM1 Position               */
#define NT_ADC_EMUX_EM1_Msk                   (0x0fUL << NT_ADC_EMUX_EM1_Pos)                         /*!< NT_ADC EMUX: EM1 Mask                   */
#define NT_ADC_EMUX_EM2_Pos                   8                                                       /*!< NT_ADC EMUX: EM2 Position               */
#define NT_ADC_EMUX_EM2_Msk                   (0x0fUL << NT_ADC_EMUX_EM2_Pos)                         /*!< NT_ADC EMUX: EM2 Mask                   */
#define NT_ADC_EMUX_EM3_Pos                   12                                                      /*!< NT_ADC EMUX: EM3 Position               */
#define NT_ADC_EMUX_EM3_Msk                   (0x0fUL << NT_ADC_EMUX_EM3_Pos)                         /*!< NT_ADC EMUX: EM3 Mask                   */
#define NT_ADC_EMUX_EM4_Pos                   16                                                      /*!< NT_ADC EMUX: EM4 Position               */
#define NT_ADC_EMUX_EM4_Msk                   (0x0fUL << NT_ADC_EMUX_EM4_Pos)                         /*!< NT_ADC EMUX: EM4 Mask                   */
#define NT_ADC_EMUX_EM5_Pos                   20                                                      /*!< NT_ADC EMUX: EM5 Position               */
#define NT_ADC_EMUX_EM5_Msk                   (0x0fUL << NT_ADC_EMUX_EM5_Pos)                         /*!< NT_ADC EMUX: EM5 Mask                   */
#define NT_ADC_EMUX_EM6_Pos                   24                                                      /*!< NT_ADC EMUX: EM6 Position               */
#define NT_ADC_EMUX_EM6_Msk                   (0x0fUL << NT_ADC_EMUX_EM6_Pos)                         /*!< NT_ADC EMUX: EM6 Mask                   */
#define NT_ADC_EMUX_EM7_Pos                   28                                                      /*!< NT_ADC EMUX: EM7 Position               */
#define NT_ADC_EMUX_EM7_Msk                   (0x0fUL << NT_ADC_EMUX_EM7_Pos)                         /*!< NT_ADC EMUX: EM7 Mask                   */

/* --------------------------------  NT_ADC_USTAT  -------------------------------- */
#define NT_ADC_USTAT_UV0_Pos                  0                                                       /*!< NT_ADC USTAT: UV0 Position              */
#define NT_ADC_USTAT_UV0_Msk                  (0x01UL << NT_ADC_USTAT_UV0_Pos)                        /*!< NT_ADC USTAT: UV0 Mask                  */
#define NT_ADC_USTAT_UV1_Pos                  1                                                       /*!< NT_ADC USTAT: UV1 Position              */
#define NT_ADC_USTAT_UV1_Msk                  (0x01UL << NT_ADC_USTAT_UV1_Pos)                        /*!< NT_ADC USTAT: UV1 Mask                  */
#define NT_ADC_USTAT_UV2_Pos                  2                                                       /*!< NT_ADC USTAT: UV2 Position              */
#define NT_ADC_USTAT_UV2_Msk                  (0x01UL << NT_ADC_USTAT_UV2_Pos)                        /*!< NT_ADC USTAT: UV2 Mask                  */
#define NT_ADC_USTAT_UV3_Pos                  3                                                       /*!< NT_ADC USTAT: UV3 Position              */
#define NT_ADC_USTAT_UV3_Msk                  (0x01UL << NT_ADC_USTAT_UV3_Pos)                        /*!< NT_ADC USTAT: UV3 Mask                  */
#define NT_ADC_USTAT_UV4_Pos                  4                                                       /*!< NT_ADC USTAT: UV4 Position              */
#define NT_ADC_USTAT_UV4_Msk                  (0x01UL << NT_ADC_USTAT_UV4_Pos)                        /*!< NT_ADC USTAT: UV4 Mask                  */
#define NT_ADC_USTAT_UV5_Pos                  5                                                       /*!< NT_ADC USTAT: UV5 Position              */
#define NT_ADC_USTAT_UV5_Msk                  (0x01UL << NT_ADC_USTAT_UV5_Pos)                        /*!< NT_ADC USTAT: UV5 Mask                  */
#define NT_ADC_USTAT_UV6_Pos                  6                                                       /*!< NT_ADC USTAT: UV6 Position              */
#define NT_ADC_USTAT_UV6_Msk                  (0x01UL << NT_ADC_USTAT_UV6_Pos)                        /*!< NT_ADC USTAT: UV6 Mask                  */
#define NT_ADC_USTAT_UV7_Pos                  7                                                       /*!< NT_ADC USTAT: UV7 Position              */
#define NT_ADC_USTAT_UV7_Msk                  (0x01UL << NT_ADC_USTAT_UV7_Pos)                        /*!< NT_ADC USTAT: UV7 Mask                  */

/* ---------------------------------  NT_ADC_SPC0  -------------------------------- */
#define NT_ADC_SPC0_PHASE0_Pos                0                                                       /*!< NT_ADC SPC0: PHASE0 Position            */
#define NT_ADC_SPC0_PHASE0_Msk                (0x00000fffUL << NT_ADC_SPC0_PHASE0_Pos)                /*!< NT_ADC SPC0: PHASE0 Mask                */
#define NT_ADC_SPC0_PHASE1_Pos                16                                                      /*!< NT_ADC SPC0: PHASE1 Position            */
#define NT_ADC_SPC0_PHASE1_Msk                (0x00000fffUL << NT_ADC_SPC0_PHASE1_Pos)                /*!< NT_ADC SPC0: PHASE1 Mask                */

/* ---------------------------------  NT_ADC_SPC1  -------------------------------- */
#define NT_ADC_SPC1_PHASE2_Pos                0                                                       /*!< NT_ADC SPC1: PHASE2 Position            */
#define NT_ADC_SPC1_PHASE2_Msk                (0x00000fffUL << NT_ADC_SPC1_PHASE2_Pos)                /*!< NT_ADC SPC1: PHASE2 Mask                */
#define NT_ADC_SPC1_PHASE3_Pos                16                                                      /*!< NT_ADC SPC1: PHASE3 Position            */
#define NT_ADC_SPC1_PHASE3_Msk                (0x00000fffUL << NT_ADC_SPC1_PHASE3_Pos)                /*!< NT_ADC SPC1: PHASE3 Mask                */

/* ---------------------------------  NT_ADC_SPC2  -------------------------------- */
#define NT_ADC_SPC2_PHASE4_Pos                0                                                       /*!< NT_ADC SPC2: PHASE4 Position            */
#define NT_ADC_SPC2_PHASE4_Msk                (0x00000fffUL << NT_ADC_SPC2_PHASE4_Pos)                /*!< NT_ADC SPC2: PHASE4 Mask                */
#define NT_ADC_SPC2_PHASE5_Pos                16                                                      /*!< NT_ADC SPC2: PHASE5 Position            */
#define NT_ADC_SPC2_PHASE5_Msk                (0x00000fffUL << NT_ADC_SPC2_PHASE5_Pos)                /*!< NT_ADC SPC2: PHASE5 Mask                */

/* ---------------------------------  NT_ADC_SPC3  -------------------------------- */
#define NT_ADC_SPC3_PHASE6_Pos                0                                                       /*!< NT_ADC SPC3: PHASE6 Position            */
#define NT_ADC_SPC3_PHASE6_Msk                (0x00000fffUL << NT_ADC_SPC3_PHASE6_Pos)                /*!< NT_ADC SPC3: PHASE6 Mask                */
#define NT_ADC_SPC3_PHASE7_Pos                16                                                      /*!< NT_ADC SPC3: PHASE7 Position            */
#define NT_ADC_SPC3_PHASE7_Msk                (0x00000fffUL << NT_ADC_SPC3_PHASE7_Pos)                /*!< NT_ADC SPC3: PHASE7 Mask                */

/* ---------------------------------  NT_ADC_SPC4  -------------------------------- */
#define NT_ADC_SPC4_PHASE8_Pos                0                                                       /*!< NT_ADC SPC4: PHASE8 Position            */
#define NT_ADC_SPC4_PHASE8_Msk                (0x00000fffUL << NT_ADC_SPC4_PHASE8_Pos)                /*!< NT_ADC SPC4: PHASE8 Mask                */
#define NT_ADC_SPC4_PHASE9_Pos                16                                                      /*!< NT_ADC SPC4: PHASE9 Position            */
#define NT_ADC_SPC4_PHASE9_Msk                (0x00000fffUL << NT_ADC_SPC4_PHASE9_Pos)                /*!< NT_ADC SPC4: PHASE9 Mask                */

/* ---------------------------------  NT_ADC_SPC5  -------------------------------- */
#define NT_ADC_SPC5_PHASE10_Pos               0                                                       /*!< NT_ADC SPC5: PHASE10 Position           */
#define NT_ADC_SPC5_PHASE10_Msk               (0x00000fffUL << NT_ADC_SPC5_PHASE10_Pos)               /*!< NT_ADC SPC5: PHASE10 Mask               */
#define NT_ADC_SPC5_PHASE11_Pos               16                                                      /*!< NT_ADC SPC5: PHASE11 Position           */
#define NT_ADC_SPC5_PHASE11_Msk               (0x00000fffUL << NT_ADC_SPC5_PHASE11_Pos)               /*!< NT_ADC SPC5: PHASE11 Mask               */

/* ---------------------------------  NT_ADC_SAC  --------------------------------- */
#define NT_ADC_SAC_AVG0_Pos                   0                                                       /*!< NT_ADC SAC: AVG0 Position               */
#define NT_ADC_SAC_AVG0_Msk                   (0x07UL << NT_ADC_SAC_AVG0_Pos)                         /*!< NT_ADC SAC: AVG0 Mask                   */
#define NT_ADC_SAC_AVG1_Pos                   4                                                       /*!< NT_ADC SAC: AVG1 Position               */
#define NT_ADC_SAC_AVG1_Msk                   (0x07UL << NT_ADC_SAC_AVG1_Pos)                         /*!< NT_ADC SAC: AVG1 Mask                   */
#define NT_ADC_SAC_AVG2_Pos                   8                                                       /*!< NT_ADC SAC: AVG2 Position               */
#define NT_ADC_SAC_AVG2_Msk                   (0x07UL << NT_ADC_SAC_AVG2_Pos)                         /*!< NT_ADC SAC: AVG2 Mask                   */
#define NT_ADC_SAC_AVG3_Pos                   12                                                      /*!< NT_ADC SAC: AVG3 Position               */
#define NT_ADC_SAC_AVG3_Msk                   (0x07UL << NT_ADC_SAC_AVG3_Pos)                         /*!< NT_ADC SAC: AVG3 Mask                   */
#define NT_ADC_SAC_AVG4_Pos                   16                                                      /*!< NT_ADC SAC: AVG4 Position               */
#define NT_ADC_SAC_AVG4_Msk                   (0x07UL << NT_ADC_SAC_AVG4_Pos)                         /*!< NT_ADC SAC: AVG4 Mask                   */
#define NT_ADC_SAC_AVG5_Pos                   20                                                      /*!< NT_ADC SAC: AVG5 Position               */
#define NT_ADC_SAC_AVG5_Msk                   (0x07UL << NT_ADC_SAC_AVG5_Pos)                         /*!< NT_ADC SAC: AVG5 Mask                   */
#define NT_ADC_SAC_AVG6_Pos                   24                                                      /*!< NT_ADC SAC: AVG6 Position               */
#define NT_ADC_SAC_AVG6_Msk                   (0x07UL << NT_ADC_SAC_AVG6_Pos)                         /*!< NT_ADC SAC: AVG6 Mask                   */
#define NT_ADC_SAC_AVG7_Pos                   28                                                      /*!< NT_ADC SAC: AVG7 Position               */
#define NT_ADC_SAC_AVG7_Msk                   (0x07UL << NT_ADC_SAC_AVG7_Pos)                         /*!< NT_ADC SAC: AVG7 Mask                   */

/* --------------------------------  NT_ADC_RICNT  -------------------------------- */
#define NT_ADC_RICNT_AVG8_Pos                 0                                                       /*!< NT_ADC RICNT: AVG8 Position             */
#define NT_ADC_RICNT_AVG8_Msk                 (0x07UL << NT_ADC_RICNT_AVG8_Pos)                       /*!< NT_ADC RICNT: AVG8 Mask                 */
#define NT_ADC_RICNT_AVG9_Pos                 4                                                       /*!< NT_ADC RICNT: AVG9 Position             */
#define NT_ADC_RICNT_AVG9_Msk                 (0x07UL << NT_ADC_RICNT_AVG9_Pos)                       /*!< NT_ADC RICNT: AVG9 Mask                 */
#define NT_ADC_RICNT_AVG10_Pos                8                                                       /*!< NT_ADC RICNT: AVG10 Position            */
#define NT_ADC_RICNT_AVG10_Msk                (0x07UL << NT_ADC_RICNT_AVG10_Pos)                      /*!< NT_ADC RICNT: AVG10 Mask                */
#define NT_ADC_RICNT_AVG11_Pos                12                                                      /*!< NT_ADC RICNT: AVG11 Position            */
#define NT_ADC_RICNT_AVG11_Msk                (0x07UL << NT_ADC_RICNT_AVG11_Pos)                      /*!< NT_ADC RICNT: AVG11 Mask                */
#define NT_ADC_RICNT_RICNT0_Pos               16                                                      /*!< NT_ADC RICNT: RICNT0 Position           */
#define NT_ADC_RICNT_RICNT0_Msk               (0x01UL << NT_ADC_RICNT_RICNT0_Pos)                     /*!< NT_ADC RICNT: RICNT0 Mask               */
#define NT_ADC_RICNT_RICNT1_Pos               17                                                      /*!< NT_ADC RICNT: RICNT1 Position           */
#define NT_ADC_RICNT_RICNT1_Msk               (0x01UL << NT_ADC_RICNT_RICNT1_Pos)                     /*!< NT_ADC RICNT: RICNT1 Mask               */
#define NT_ADC_RICNT_RICNT2_Pos               18                                                      /*!< NT_ADC RICNT: RICNT2 Position           */
#define NT_ADC_RICNT_RICNT2_Msk               (0x01UL << NT_ADC_RICNT_RICNT2_Pos)                     /*!< NT_ADC RICNT: RICNT2 Mask               */
#define NT_ADC_RICNT_RICNT3_Pos               19                                                      /*!< NT_ADC RICNT: RICNT3 Position           */
#define NT_ADC_RICNT_RICNT3_Msk               (0x01UL << NT_ADC_RICNT_RICNT3_Pos)                     /*!< NT_ADC RICNT: RICNT3 Mask               */
#define NT_ADC_RICNT_RICNT4_Pos               20                                                      /*!< NT_ADC RICNT: RICNT4 Position           */
#define NT_ADC_RICNT_RICNT4_Msk               (0x01UL << NT_ADC_RICNT_RICNT4_Pos)                     /*!< NT_ADC RICNT: RICNT4 Mask               */
#define NT_ADC_RICNT_RICNT5_Pos               21                                                      /*!< NT_ADC RICNT: RICNT5 Position           */
#define NT_ADC_RICNT_RICNT5_Msk               (0x01UL << NT_ADC_RICNT_RICNT5_Pos)                     /*!< NT_ADC RICNT: RICNT5 Mask               */
#define NT_ADC_RICNT_RICNT6_Pos               22                                                      /*!< NT_ADC RICNT: RICNT6 Position           */
#define NT_ADC_RICNT_RICNT6_Msk               (0x01UL << NT_ADC_RICNT_RICNT6_Pos)                     /*!< NT_ADC RICNT: RICNT6 Mask               */
#define NT_ADC_RICNT_RICNT7_Pos               23                                                      /*!< NT_ADC RICNT: RICNT7 Position           */
#define NT_ADC_RICNT_RICNT7_Msk               (0x01UL << NT_ADC_RICNT_RICNT7_Pos)                     /*!< NT_ADC RICNT: RICNT7 Mask               */


/* ================================================================================ */
/* ================          struct 'SEQ' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  SEQ_MUX  ---------------------------------- */
#define SEQ_MUX_CH0_Pos                       0                                                       /*!< SEQ MUX: CH0 Position                   */
#define SEQ_MUX_CH0_Msk                       (0x01UL << SEQ_MUX_CH0_Pos)                             /*!< SEQ MUX: CH0 Mask                       */
#define SEQ_MUX_CH1_Pos                       1                                                       /*!< SEQ MUX: CH1 Position                   */
#define SEQ_MUX_CH1_Msk                       (0x01UL << SEQ_MUX_CH1_Pos)                             /*!< SEQ MUX: CH1 Mask                       */
#define SEQ_MUX_CH2_Pos                       2                                                       /*!< SEQ MUX: CH2 Position                   */
#define SEQ_MUX_CH2_Msk                       (0x01UL << SEQ_MUX_CH2_Pos)                             /*!< SEQ MUX: CH2 Mask                       */
#define SEQ_MUX_CH3_Pos                       3                                                       /*!< SEQ MUX: CH3 Position                   */
#define SEQ_MUX_CH3_Msk                       (0x01UL << SEQ_MUX_CH3_Pos)                             /*!< SEQ MUX: CH3 Mask                       */
#define SEQ_MUX_CH4_Pos                       4                                                       /*!< SEQ MUX: CH4 Position                   */
#define SEQ_MUX_CH4_Msk                       (0x01UL << SEQ_MUX_CH4_Pos)                             /*!< SEQ MUX: CH4 Mask                       */
#define SEQ_MUX_CH5_Pos                       5                                                       /*!< SEQ MUX: CH5 Position                   */
#define SEQ_MUX_CH5_Msk                       (0x01UL << SEQ_MUX_CH5_Pos)                             /*!< SEQ MUX: CH5 Mask                       */
#define SEQ_MUX_CH6_Pos                       6                                                       /*!< SEQ MUX: CH6 Position                   */
#define SEQ_MUX_CH6_Msk                       (0x01UL << SEQ_MUX_CH6_Pos)                             /*!< SEQ MUX: CH6 Mask                       */
#define SEQ_MUX_CH7_Pos                       7                                                       /*!< SEQ MUX: CH7 Position                   */
#define SEQ_MUX_CH7_Msk                       (0x01UL << SEQ_MUX_CH7_Pos)                             /*!< SEQ MUX: CH7 Mask                       */
#define SEQ_MUX_CH8_Pos                       8                                                       /*!< SEQ MUX: CH8 Position                   */
#define SEQ_MUX_CH8_Msk                       (0x01UL << SEQ_MUX_CH8_Pos)                             /*!< SEQ MUX: CH8 Mask                       */
#define SEQ_MUX_CH9_Pos                       9                                                       /*!< SEQ MUX: CH9 Position                   */
#define SEQ_MUX_CH9_Msk                       (0x01UL << SEQ_MUX_CH9_Pos)                             /*!< SEQ MUX: CH9 Mask                       */
#define SEQ_MUX_CH10_Pos                      10                                                      /*!< SEQ MUX: CH10 Position                  */
#define SEQ_MUX_CH10_Msk                      (0x01UL << SEQ_MUX_CH10_Pos)                            /*!< SEQ MUX: CH10 Mask                      */
#define SEQ_MUX_CH11_Pos                      11                                                      /*!< SEQ MUX: CH11 Position                  */
#define SEQ_MUX_CH11_Msk                      (0x01UL << SEQ_MUX_CH11_Pos)                            /*!< SEQ MUX: CH11 Mask                      */
#define SEQ_MUX_CH12_Pos                      12                                                      /*!< SEQ MUX: CH12 Position                  */
#define SEQ_MUX_CH12_Msk                      (0x01UL << SEQ_MUX_CH12_Pos)                            /*!< SEQ MUX: CH12 Mask                      */
#define SEQ_MUX_CH13_Pos                      13                                                      /*!< SEQ MUX: CH13 Position                  */
#define SEQ_MUX_CH13_Msk                      (0x01UL << SEQ_MUX_CH13_Pos)                            /*!< SEQ MUX: CH13 Mask                      */
#define SEQ_MUX_CH14_Pos                      14                                                      /*!< SEQ MUX: CH14 Position                  */
#define SEQ_MUX_CH14_Msk                      (0x01UL << SEQ_MUX_CH14_Pos)                            /*!< SEQ MUX: CH14 Mask                      */
#define SEQ_MUX_CH15_Pos                      15                                                      /*!< SEQ MUX: CH15 Position                  */
#define SEQ_MUX_CH15_Msk                      (0x01UL << SEQ_MUX_CH15_Pos)                            /*!< SEQ MUX: CH15 Mask                      */
#define SEQ_MUX_CH16_Pos                      16                                                      /*!< SEQ MUX: CH16 Position                  */
#define SEQ_MUX_CH16_Msk                      (0x01UL << SEQ_MUX_CH16_Pos)                            /*!< SEQ MUX: CH16 Mask                      */
#define SEQ_MUX_CH17_Pos                      17                                                      /*!< SEQ MUX: CH17 Position                  */
#define SEQ_MUX_CH17_Msk                      (0x01UL << SEQ_MUX_CH17_Pos)                            /*!< SEQ MUX: CH17 Mask                      */
#define SEQ_MUX_CH18_Pos                      18                                                      /*!< SEQ MUX: CH18 Position                  */
#define SEQ_MUX_CH18_Msk                      (0x01UL << SEQ_MUX_CH18_Pos)                            /*!< SEQ MUX: CH18 Mask                      */
#define SEQ_MUX_CH19_Pos                      19                                                      /*!< SEQ MUX: CH19 Position                  */
#define SEQ_MUX_CH19_Msk                      (0x01UL << SEQ_MUX_CH19_Pos)                            /*!< SEQ MUX: CH19 Mask                      */
#define SEQ_MUX_CH20_Pos                      20                                                      /*!< SEQ MUX: CH20 Position                  */
#define SEQ_MUX_CH20_Msk                      (0x01UL << SEQ_MUX_CH20_Pos)                            /*!< SEQ MUX: CH20 Mask                      */
#define SEQ_MUX_CH21_Pos                      21                                                      /*!< SEQ MUX: CH21 Position                  */
#define SEQ_MUX_CH21_Msk                      (0x01UL << SEQ_MUX_CH21_Pos)                            /*!< SEQ MUX: CH21 Mask                      */
#define SEQ_MUX_CH22_Pos                      22                                                      /*!< SEQ MUX: CH22 Position                  */
#define SEQ_MUX_CH22_Msk                      (0x01UL << SEQ_MUX_CH22_Pos)                            /*!< SEQ MUX: CH22 Mask                      */
#define SEQ_MUX_CH23_Pos                      23                                                      /*!< SEQ MUX: CH23 Position                  */
#define SEQ_MUX_CH23_Msk                      (0x01UL << SEQ_MUX_CH23_Pos)                            /*!< SEQ MUX: CH23 Mask                      */

/* -----------------------------------  SEQ_CTL  ---------------------------------- */
#define SEQ_CTL_RCNT_Pos                      0                                                       /*!< SEQ CTL: RCNT Position                  */
#define SEQ_CTL_RCNT_Msk                      (0x000000ffUL << SEQ_CTL_RCNT_Pos)                      /*!< SEQ CTL: RCNT Mask                      */
#define SEQ_CTL_ICNT_Pos                      16                                                      /*!< SEQ CTL: ICNT Position                  */
#define SEQ_CTL_ICNT_Msk                      (0x000000ffUL << SEQ_CTL_ICNT_Pos)                      /*!< SEQ CTL: ICNT Mask                      */
#define SEQ_CTL_WMARK_Pos                     24                                                      /*!< SEQ CTL: WMARK Position                 */
#define SEQ_CTL_WMARK_Msk                     (0x07UL << SEQ_CTL_WMARK_Pos)                           /*!< SEQ CTL: WMARK Mask                     */
#define SEQ_CTL_DMAEN_Pos                     28                                                      /*!< SEQ CTL: DMAEN Position                 */
#define SEQ_CTL_DMAEN_Msk                     (0x01UL << SEQ_CTL_DMAEN_Pos)                           /*!< SEQ CTL: DMAEN Mask                     */

/* ----------------------------------  SEQ_FSTAT  --------------------------------- */
#define SEQ_FSTAT_FLOAD_Pos                   0                                                       /*!< SEQ FSTAT: FLOAD Position               */
#define SEQ_FSTAT_FLOAD_Msk                   (0x3fUL << SEQ_FSTAT_FLOAD_Pos)                         /*!< SEQ FSTAT: FLOAD Mask                   */

/* -----------------------------------  SEQ_OP  ----------------------------------- */
#define SEQ_OP_RCNT_Pos                       0                                                       /*!< SEQ OP: RCNT Position                   */
#define SEQ_OP_RCNT_Msk                       (0x000000ffUL << SEQ_OP_RCNT_Pos)                       /*!< SEQ OP: RCNT Mask                       */
#define SEQ_OP_ICNT_Pos                       16                                                      /*!< SEQ OP: ICNT Position                   */
#define SEQ_OP_ICNT_Msk                       (0x000000ffUL << SEQ_OP_ICNT_Pos)                       /*!< SEQ OP: ICNT Mask                       */

/* -----------------------------------  SEQ_DCP  ---------------------------------- */
#define SEQ_DCP_CMP0_Pos                      0                                                       /*!< SEQ DCP: CMP0 Position                  */
#define SEQ_DCP_CMP0_Msk                      (0x01UL << SEQ_DCP_CMP0_Pos)                            /*!< SEQ DCP: CMP0 Mask                      */
#define SEQ_DCP_CMP1_Pos                      1                                                       /*!< SEQ DCP: CMP1 Position                  */
#define SEQ_DCP_CMP1_Msk                      (0x01UL << SEQ_DCP_CMP1_Pos)                            /*!< SEQ DCP: CMP1 Mask                      */
#define SEQ_DCP_CMP2_Pos                      2                                                       /*!< SEQ DCP: CMP2 Position                  */
#define SEQ_DCP_CMP2_Msk                      (0x01UL << SEQ_DCP_CMP2_Pos)                            /*!< SEQ DCP: CMP2 Mask                      */
#define SEQ_DCP_CMP3_Pos                      3                                                       /*!< SEQ DCP: CMP3 Position                  */
#define SEQ_DCP_CMP3_Msk                      (0x01UL << SEQ_DCP_CMP3_Pos)                            /*!< SEQ DCP: CMP3 Mask                      */
#define SEQ_DCP_CMP4_Pos                      4                                                       /*!< SEQ DCP: CMP4 Position                  */
#define SEQ_DCP_CMP4_Msk                      (0x01UL << SEQ_DCP_CMP4_Pos)                            /*!< SEQ DCP: CMP4 Mask                      */
#define SEQ_DCP_CMP5_Pos                      5                                                       /*!< SEQ DCP: CMP5 Position                  */
#define SEQ_DCP_CMP5_Msk                      (0x01UL << SEQ_DCP_CMP5_Pos)                            /*!< SEQ DCP: CMP5 Mask                      */
#define SEQ_DCP_CMP6_Pos                      6                                                       /*!< SEQ DCP: CMP6 Position                  */
#define SEQ_DCP_CMP6_Msk                      (0x01UL << SEQ_DCP_CMP6_Pos)                            /*!< SEQ DCP: CMP6 Mask                      */
#define SEQ_DCP_CMP7_Pos                      7                                                       /*!< SEQ DCP: CMP7 Position                  */
#define SEQ_DCP_CMP7_Msk                      (0x01UL << SEQ_DCP_CMP7_Pos)                            /*!< SEQ DCP: CMP7 Mask                      */
#define SEQ_DCP_CMP8_Pos                      8                                                       /*!< SEQ DCP: CMP8 Position                  */
#define SEQ_DCP_CMP8_Msk                      (0x01UL << SEQ_DCP_CMP8_Pos)                            /*!< SEQ DCP: CMP8 Mask                      */
#define SEQ_DCP_CMP9_Pos                      9                                                       /*!< SEQ DCP: CMP9 Position                  */
#define SEQ_DCP_CMP9_Msk                      (0x01UL << SEQ_DCP_CMP9_Pos)                            /*!< SEQ DCP: CMP9 Mask                      */
#define SEQ_DCP_CMP10_Pos                     10                                                      /*!< SEQ DCP: CMP10 Position                 */
#define SEQ_DCP_CMP10_Msk                     (0x01UL << SEQ_DCP_CMP10_Pos)                           /*!< SEQ DCP: CMP10 Mask                     */
#define SEQ_DCP_CMP11_Pos                     11                                                      /*!< SEQ DCP: CMP11 Position                 */
#define SEQ_DCP_CMP11_Msk                     (0x01UL << SEQ_DCP_CMP11_Pos)                           /*!< SEQ DCP: CMP11 Mask                     */
#define SEQ_DCP_CMP12_Pos                     12                                                      /*!< SEQ DCP: CMP12 Position                 */
#define SEQ_DCP_CMP12_Msk                     (0x01UL << SEQ_DCP_CMP12_Pos)                           /*!< SEQ DCP: CMP12 Mask                     */
#define SEQ_DCP_CMP13_Pos                     13                                                      /*!< SEQ DCP: CMP13 Position                 */
#define SEQ_DCP_CMP13_Msk                     (0x01UL << SEQ_DCP_CMP13_Pos)                           /*!< SEQ DCP: CMP13 Mask                     */
#define SEQ_DCP_CMP14_Pos                     14                                                      /*!< SEQ DCP: CMP14 Position                 */
#define SEQ_DCP_CMP14_Msk                     (0x01UL << SEQ_DCP_CMP14_Pos)                           /*!< SEQ DCP: CMP14 Mask                     */
#define SEQ_DCP_CMP15_Pos                     15                                                      /*!< SEQ DCP: CMP15 Position                 */
#define SEQ_DCP_CMP15_Msk                     (0x01UL << SEQ_DCP_CMP15_Pos)                           /*!< SEQ DCP: CMP15 Mask                     */
#define SEQ_DCP_CMP16_Pos                     16                                                      /*!< SEQ DCP: CMP16 Position                 */
#define SEQ_DCP_CMP16_Msk                     (0x01UL << SEQ_DCP_CMP16_Pos)                           /*!< SEQ DCP: CMP16 Mask                     */
#define SEQ_DCP_CMP17_Pos                     17                                                      /*!< SEQ DCP: CMP17 Position                 */
#define SEQ_DCP_CMP17_Msk                     (0x01UL << SEQ_DCP_CMP17_Pos)                           /*!< SEQ DCP: CMP17 Mask                     */
#define SEQ_DCP_CMP18_Pos                     18                                                      /*!< SEQ DCP: CMP18 Position                 */
#define SEQ_DCP_CMP18_Msk                     (0x01UL << SEQ_DCP_CMP18_Pos)                           /*!< SEQ DCP: CMP18 Mask                     */
#define SEQ_DCP_CMP19_Pos                     19                                                      /*!< SEQ DCP: CMP19 Position                 */
#define SEQ_DCP_CMP19_Msk                     (0x01UL << SEQ_DCP_CMP19_Pos)                           /*!< SEQ DCP: CMP19 Mask                     */
#define SEQ_DCP_CMP20_Pos                     20                                                      /*!< SEQ DCP: CMP20 Position                 */
#define SEQ_DCP_CMP20_Msk                     (0x01UL << SEQ_DCP_CMP20_Pos)                           /*!< SEQ DCP: CMP20 Mask                     */
#define SEQ_DCP_CMP21_Pos                     21                                                      /*!< SEQ DCP: CMP21 Position                 */
#define SEQ_DCP_CMP21_Msk                     (0x01UL << SEQ_DCP_CMP21_Pos)                           /*!< SEQ DCP: CMP21 Mask                     */
#define SEQ_DCP_CMP22_Pos                     22                                                      /*!< SEQ DCP: CMP22 Position                 */
#define SEQ_DCP_CMP22_Msk                     (0x01UL << SEQ_DCP_CMP22_Pos)                           /*!< SEQ DCP: CMP22 Mask                     */
#define SEQ_DCP_CMP23_Pos                     23                                                      /*!< SEQ DCP: CMP23 Position                 */
#define SEQ_DCP_CMP23_Msk                     (0x01UL << SEQ_DCP_CMP23_Pos)                           /*!< SEQ DCP: CMP23 Mask                     */

/* -----------------------------------  SEQ_TMR  ---------------------------------- */
#define SEQ_TMR_TMR_Pos                       0                                                       /*!< SEQ TMR: TMR Position                   */
#define SEQ_TMR_TMR_Msk                       (0x00ffffffUL << SEQ_TMR_TMR_Pos)                       /*!< SEQ TMR: TMR Mask                       */

/* ----------------------------------  SEQ_FIFO  ---------------------------------- */
#define SEQ_FIFO_DATA_Pos                     0                                                       /*!< SEQ FIFO: DATA Position                 */
#define SEQ_FIFO_DATA_Msk                     (0x0000ffffUL << SEQ_FIFO_DATA_Pos)                     /*!< SEQ FIFO: DATA Mask                     */


/* ================================================================================ */
/* ================         struct 'DCCTL' Position & Mask         ================ */
/* ================================================================================ */


/* ---------------------------------  DCCTL_DCCTL  -------------------------------- */
#define DCCTL_DCCTL_CIM_Pos                   0                                                       /*!< DCCTL DCCTL: CIM Position               */
#define DCCTL_DCCTL_CIM_Msk                   (0x03UL << DCCTL_DCCTL_CIM_Pos)                         /*!< DCCTL DCCTL: CIM Mask                   */
#define DCCTL_DCCTL_CIC_Pos                   2                                                       /*!< DCCTL DCCTL: CIC Position               */
#define DCCTL_DCCTL_CIC_Msk                   (0x03UL << DCCTL_DCCTL_CIC_Pos)                         /*!< DCCTL DCCTL: CIC Mask                   */
#define DCCTL_DCCTL_CIE_Pos                   4                                                       /*!< DCCTL DCCTL: CIE Position               */
#define DCCTL_DCCTL_CIE_Msk                   (0x01UL << DCCTL_DCCTL_CIE_Pos)                         /*!< DCCTL DCCTL: CIE Mask                   */
#define DCCTL_DCCTL_CTM_Pos                   8                                                       /*!< DCCTL DCCTL: CTM Position               */
#define DCCTL_DCCTL_CTM_Msk                   (0x03UL << DCCTL_DCCTL_CTM_Pos)                         /*!< DCCTL DCCTL: CTM Mask                   */
#define DCCTL_DCCTL_CTC_Pos                   10                                                      /*!< DCCTL DCCTL: CTC Position               */
#define DCCTL_DCCTL_CTC_Msk                   (0x03UL << DCCTL_DCCTL_CTC_Pos)                         /*!< DCCTL DCCTL: CTC Mask                   */
#define DCCTL_DCCTL_CTE_Pos                   12                                                      /*!< DCCTL DCCTL: CTE Position               */
#define DCCTL_DCCTL_CTE_Msk                   (0x01UL << DCCTL_DCCTL_CTE_Pos)                         /*!< DCCTL DCCTL: CTE Mask                   */
#define DCCTL_DCCTL_CHNL_Pos                  16                                                      /*!< DCCTL DCCTL: CHNL Position              */
#define DCCTL_DCCTL_CHNL_Msk                  (0x1fUL << DCCTL_DCCTL_CHNL_Pos)                        /*!< DCCTL DCCTL: CHNL Mask                  */


/* ================================================================================ */
/* ================         struct 'DCCMP' Position & Mask         ================ */
/* ================================================================================ */


/* ---------------------------------  DCCMP_DCCMP  -------------------------------- */
#define DCCMP_DCCMP_COMP0_Pos                 0                                                       /*!< DCCMP DCCMP: COMP0 Position             */
#define DCCMP_DCCMP_COMP0_Msk                 (0x00000fffUL << DCCMP_DCCMP_COMP0_Pos)                 /*!< DCCMP DCCMP: COMP0 Mask                 */
#define DCCMP_DCCMP_COMP1_Pos                 16                                                      /*!< DCCMP DCCMP: COMP1 Position             */
#define DCCMP_DCCMP_COMP1_Msk                 (0x00000fffUL << DCCMP_DCCMP_COMP1_Pos)                 /*!< DCCMP DCCMP: COMP1 Mask                 */


/* ================================================================================ */
/* ================         struct 'DCVAL' Position & Mask         ================ */
/* ================================================================================ */


/* ---------------------------------  DCVAL_DCVAL  -------------------------------- */
#define DCVAL_DCVAL_VAL_Pos                   0                                                       /*!< DCVAL DCVAL: VAL Position               */
#define DCVAL_DCVAL_VAL_Msk                   (0x00000fffUL << DCVAL_DCVAL_VAL_Pos)                   /*!< DCVAL DCVAL: VAL Mask                   */

/* --------------------------------  NT_ADC_DCRTC  -------------------------------- */
#define NT_ADC_DCRTC_DCTRIG0_Pos              0                                                       /*!< NT_ADC DCRTC: DCTRIG0 Position          */
#define NT_ADC_DCRTC_DCTRIG0_Msk              (0x01UL << NT_ADC_DCRTC_DCTRIG0_Pos)                    /*!< NT_ADC DCRTC: DCTRIG0 Mask              */
#define NT_ADC_DCRTC_DCTRIG1_Pos              1                                                       /*!< NT_ADC DCRTC: DCTRIG1 Position          */
#define NT_ADC_DCRTC_DCTRIG1_Msk              (0x01UL << NT_ADC_DCRTC_DCTRIG1_Pos)                    /*!< NT_ADC DCRTC: DCTRIG1 Mask              */
#define NT_ADC_DCRTC_DCTRIG2_Pos              2                                                       /*!< NT_ADC DCRTC: DCTRIG2 Position          */
#define NT_ADC_DCRTC_DCTRIG2_Msk              (0x01UL << NT_ADC_DCRTC_DCTRIG2_Pos)                    /*!< NT_ADC DCRTC: DCTRIG2 Mask              */
#define NT_ADC_DCRTC_DCTRIG3_Pos              3                                                       /*!< NT_ADC DCRTC: DCTRIG3 Position          */
#define NT_ADC_DCRTC_DCTRIG3_Msk              (0x01UL << NT_ADC_DCRTC_DCTRIG3_Pos)                    /*!< NT_ADC DCRTC: DCTRIG3 Mask              */
#define NT_ADC_DCRTC_DCTRIG4_Pos              4                                                       /*!< NT_ADC DCRTC: DCTRIG4 Position          */
#define NT_ADC_DCRTC_DCTRIG4_Msk              (0x01UL << NT_ADC_DCRTC_DCTRIG4_Pos)                    /*!< NT_ADC DCRTC: DCTRIG4 Mask              */
#define NT_ADC_DCRTC_DCTRIG5_Pos              5                                                       /*!< NT_ADC DCRTC: DCTRIG5 Position          */
#define NT_ADC_DCRTC_DCTRIG5_Msk              (0x01UL << NT_ADC_DCRTC_DCTRIG5_Pos)                    /*!< NT_ADC DCRTC: DCTRIG5 Mask              */
#define NT_ADC_DCRTC_DCTRIG6_Pos              6                                                       /*!< NT_ADC DCRTC: DCTRIG6 Position          */
#define NT_ADC_DCRTC_DCTRIG6_Msk              (0x01UL << NT_ADC_DCRTC_DCTRIG6_Pos)                    /*!< NT_ADC DCRTC: DCTRIG6 Mask              */
#define NT_ADC_DCRTC_DCTRIG7_Pos              7                                                       /*!< NT_ADC DCRTC: DCTRIG7 Position          */
#define NT_ADC_DCRTC_DCTRIG7_Msk              (0x01UL << NT_ADC_DCRTC_DCTRIG7_Pos)                    /*!< NT_ADC DCRTC: DCTRIG7 Mask              */
#define NT_ADC_DCRTC_DCTRIG8_Pos              8                                                       /*!< NT_ADC DCRTC: DCTRIG8 Position          */
#define NT_ADC_DCRTC_DCTRIG8_Msk              (0x01UL << NT_ADC_DCRTC_DCTRIG8_Pos)                    /*!< NT_ADC DCRTC: DCTRIG8 Mask              */
#define NT_ADC_DCRTC_DCTRIG9_Pos              9                                                       /*!< NT_ADC DCRTC: DCTRIG9 Position          */
#define NT_ADC_DCRTC_DCTRIG9_Msk              (0x01UL << NT_ADC_DCRTC_DCTRIG9_Pos)                    /*!< NT_ADC DCRTC: DCTRIG9 Mask              */
#define NT_ADC_DCRTC_DCTRIG10_Pos             10                                                      /*!< NT_ADC DCRTC: DCTRIG10 Position         */
#define NT_ADC_DCRTC_DCTRIG10_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG10_Pos)                   /*!< NT_ADC DCRTC: DCTRIG10 Mask             */
#define NT_ADC_DCRTC_DCTRIG11_Pos             11                                                      /*!< NT_ADC DCRTC: DCTRIG11 Position         */
#define NT_ADC_DCRTC_DCTRIG11_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG11_Pos)                   /*!< NT_ADC DCRTC: DCTRIG11 Mask             */
#define NT_ADC_DCRTC_DCTRIG12_Pos             12                                                      /*!< NT_ADC DCRTC: DCTRIG12 Position         */
#define NT_ADC_DCRTC_DCTRIG12_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG12_Pos)                   /*!< NT_ADC DCRTC: DCTRIG12 Mask             */
#define NT_ADC_DCRTC_DCTRIG13_Pos             13                                                      /*!< NT_ADC DCRTC: DCTRIG13 Position         */
#define NT_ADC_DCRTC_DCTRIG13_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG13_Pos)                   /*!< NT_ADC DCRTC: DCTRIG13 Mask             */
#define NT_ADC_DCRTC_DCTRIG14_Pos             14                                                      /*!< NT_ADC DCRTC: DCTRIG14 Position         */
#define NT_ADC_DCRTC_DCTRIG14_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG14_Pos)                   /*!< NT_ADC DCRTC: DCTRIG14 Mask             */
#define NT_ADC_DCRTC_DCTRIG15_Pos             15                                                      /*!< NT_ADC DCRTC: DCTRIG15 Position         */
#define NT_ADC_DCRTC_DCTRIG15_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG15_Pos)                   /*!< NT_ADC DCRTC: DCTRIG15 Mask             */
#define NT_ADC_DCRTC_DCTRIG16_Pos             16                                                      /*!< NT_ADC DCRTC: DCTRIG16 Position         */
#define NT_ADC_DCRTC_DCTRIG16_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG16_Pos)                   /*!< NT_ADC DCRTC: DCTRIG16 Mask             */
#define NT_ADC_DCRTC_DCTRIG17_Pos             17                                                      /*!< NT_ADC DCRTC: DCTRIG17 Position         */
#define NT_ADC_DCRTC_DCTRIG17_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG17_Pos)                   /*!< NT_ADC DCRTC: DCTRIG17 Mask             */
#define NT_ADC_DCRTC_DCTRIG18_Pos             18                                                      /*!< NT_ADC DCRTC: DCTRIG18 Position         */
#define NT_ADC_DCRTC_DCTRIG18_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG18_Pos)                   /*!< NT_ADC DCRTC: DCTRIG18 Mask             */
#define NT_ADC_DCRTC_DCTRIG19_Pos             19                                                      /*!< NT_ADC DCRTC: DCTRIG19 Position         */
#define NT_ADC_DCRTC_DCTRIG19_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG19_Pos)                   /*!< NT_ADC DCRTC: DCTRIG19 Mask             */
#define NT_ADC_DCRTC_DCTRIG20_Pos             20                                                      /*!< NT_ADC DCRTC: DCTRIG20 Position         */
#define NT_ADC_DCRTC_DCTRIG20_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG20_Pos)                   /*!< NT_ADC DCRTC: DCTRIG20 Mask             */
#define NT_ADC_DCRTC_DCTRIG21_Pos             21                                                      /*!< NT_ADC DCRTC: DCTRIG21 Position         */
#define NT_ADC_DCRTC_DCTRIG21_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG21_Pos)                   /*!< NT_ADC DCRTC: DCTRIG21 Mask             */
#define NT_ADC_DCRTC_DCTRIG22_Pos             22                                                      /*!< NT_ADC DCRTC: DCTRIG22 Position         */
#define NT_ADC_DCRTC_DCTRIG22_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG22_Pos)                   /*!< NT_ADC DCRTC: DCTRIG22 Mask             */
#define NT_ADC_DCRTC_DCTRIG23_Pos             23                                                      /*!< NT_ADC DCRTC: DCTRIG23 Position         */
#define NT_ADC_DCRTC_DCTRIG23_Msk             (0x01UL << NT_ADC_DCRTC_DCTRIG23_Pos)                   /*!< NT_ADC DCRTC: DCTRIG23 Mask             */


/* ================================================================================ */
/* ================           struct 'PP' Position & Mask          ================ */
/* ================================================================================ */


/* ------------------------------------  PP_PP  ----------------------------------- */
#define PP_PP_OM_Pos                          16                                                      /*!< PP PP: OM Position                      */
#define PP_PP_OM_Msk                          (0x000000ffUL << PP_PP_OM_Pos)                          /*!< PP PP: OM Mask                          */
#define PP_PP_ENA_Pos                         31                                                      /*!< PP PP: ENA Position                     */
#define PP_PP_ENA_Msk                         (0x01UL << PP_PP_ENA_Pos)                               /*!< PP PP: ENA Mask                         */

/* ---------------------------------  NT_ADC_PSSI  -------------------------------- */
#define NT_ADC_PSSI_SS0_Pos                   0                                                       /*!< NT_ADC PSSI: SS0 Position               */
#define NT_ADC_PSSI_SS0_Msk                   (0x01UL << NT_ADC_PSSI_SS0_Pos)                         /*!< NT_ADC PSSI: SS0 Mask                   */
#define NT_ADC_PSSI_SS1_Pos                   1                                                       /*!< NT_ADC PSSI: SS1 Position               */
#define NT_ADC_PSSI_SS1_Msk                   (0x01UL << NT_ADC_PSSI_SS1_Pos)                         /*!< NT_ADC PSSI: SS1 Mask                   */
#define NT_ADC_PSSI_SS2_Pos                   2                                                       /*!< NT_ADC PSSI: SS2 Position               */
#define NT_ADC_PSSI_SS2_Msk                   (0x01UL << NT_ADC_PSSI_SS2_Pos)                         /*!< NT_ADC PSSI: SS2 Mask                   */
#define NT_ADC_PSSI_SS3_Pos                   3                                                       /*!< NT_ADC PSSI: SS3 Position               */
#define NT_ADC_PSSI_SS3_Msk                   (0x01UL << NT_ADC_PSSI_SS3_Pos)                         /*!< NT_ADC PSSI: SS3 Mask                   */
#define NT_ADC_PSSI_SS4_Pos                   4                                                       /*!< NT_ADC PSSI: SS4 Position               */
#define NT_ADC_PSSI_SS4_Msk                   (0x01UL << NT_ADC_PSSI_SS4_Pos)                         /*!< NT_ADC PSSI: SS4 Mask                   */
#define NT_ADC_PSSI_SS5_Pos                   5                                                       /*!< NT_ADC PSSI: SS5 Position               */
#define NT_ADC_PSSI_SS5_Msk                   (0x01UL << NT_ADC_PSSI_SS5_Pos)                         /*!< NT_ADC PSSI: SS5 Mask                   */
#define NT_ADC_PSSI_SS6_Pos                   6                                                       /*!< NT_ADC PSSI: SS6 Position               */
#define NT_ADC_PSSI_SS6_Msk                   (0x01UL << NT_ADC_PSSI_SS6_Pos)                         /*!< NT_ADC PSSI: SS6 Mask                   */
#define NT_ADC_PSSI_SS7_Pos                   7                                                       /*!< NT_ADC PSSI: SS7 Position               */
#define NT_ADC_PSSI_SS7_Msk                   (0x01UL << NT_ADC_PSSI_SS7_Pos)                         /*!< NT_ADC PSSI: SS7 Mask                   */
#define NT_ADC_PSSI_GSYNC_Pos                 31                                                      /*!< NT_ADC PSSI: GSYNC Position             */
#define NT_ADC_PSSI_GSYNC_Msk                 (0x01UL << NT_ADC_PSSI_GSYNC_Pos)                       /*!< NT_ADC PSSI: GSYNC Mask                 */


/* ================================================================================ */
/* ================        struct 'NT_GPIOA' Position & Mask       ================ */
/* ================================================================================ */


/* --------------------------------  NT_GPIOA_DATA  ------------------------------- */
#define NT_GPIOA_DATA_DATA_Pos                0                                                       /*!< NT_GPIOA DATA: DATA Position            */
#define NT_GPIOA_DATA_DATA_Msk                (0x0000ffffUL << NT_GPIOA_DATA_DATA_Pos)                /*!< NT_GPIOA DATA: DATA Mask                */

/* ------------------------------  NT_GPIOA_DATAOUT  ------------------------------ */
#define NT_GPIOA_DATAOUT_DATAOUT_Pos          0                                                       /*!< NT_GPIOA DATAOUT: DATAOUT Position      */
#define NT_GPIOA_DATAOUT_DATAOUT_Msk          (0x0000ffffUL << NT_GPIOA_DATAOUT_DATAOUT_Pos)          /*!< NT_GPIOA DATAOUT: DATAOUT Mask          */

/* ------------------------------  NT_GPIOA_OUTENSET  ----------------------------- */
#define NT_GPIOA_OUTENSET_OUTENSET_Pos        0                                                       /*!< NT_GPIOA OUTENSET: OUTENSET Position    */
#define NT_GPIOA_OUTENSET_OUTENSET_Msk        (0x0000ffffUL << NT_GPIOA_OUTENSET_OUTENSET_Pos)        /*!< NT_GPIOA OUTENSET: OUTENSET Mask        */

/* ------------------------------  NT_GPIOA_OUTENCLR  ----------------------------- */
#define NT_GPIOA_OUTENCLR_OUTENCLR_Pos        0                                                       /*!< NT_GPIOA OUTENCLR: OUTENCLR Position    */
#define NT_GPIOA_OUTENCLR_OUTENCLR_Msk        (0x0000ffffUL << NT_GPIOA_OUTENCLR_OUTENCLR_Pos)        /*!< NT_GPIOA OUTENCLR: OUTENCLR Mask        */

/* -----------------------------  NT_GPIOA_ALTFUNCSET  ---------------------------- */
#define NT_GPIOA_ALTFUNCSET_ALTFUNCSET_Pos    0                                                       /*!< NT_GPIOA ALTFUNCSET: ALTFUNCSET Position */
#define NT_GPIOA_ALTFUNCSET_ALTFUNCSET_Msk    (0x0000ffffUL << NT_GPIOA_ALTFUNCSET_ALTFUNCSET_Pos)    /*!< NT_GPIOA ALTFUNCSET: ALTFUNCSET Mask    */

/* -----------------------------  NT_GPIOA_ALTFUNCCLR  ---------------------------- */
#define NT_GPIOA_ALTFUNCCLR_ALTFUNCCLR_Pos    0                                                       /*!< NT_GPIOA ALTFUNCCLR: ALTFUNCCLR Position */
#define NT_GPIOA_ALTFUNCCLR_ALTFUNCCLR_Msk    (0x0000ffffUL << NT_GPIOA_ALTFUNCCLR_ALTFUNCCLR_Pos)    /*!< NT_GPIOA ALTFUNCCLR: ALTFUNCCLR Mask    */

/* ------------------------------  NT_GPIOA_INTENSET  ----------------------------- */
#define NT_GPIOA_INTENSET_INTENSET_Pos        0                                                       /*!< NT_GPIOA INTENSET: INTENSET Position    */
#define NT_GPIOA_INTENSET_INTENSET_Msk        (0x0000ffffUL << NT_GPIOA_INTENSET_INTENSET_Pos)        /*!< NT_GPIOA INTENSET: INTENSET Mask        */

/* ------------------------------  NT_GPIOA_INTENCLR  ----------------------------- */
#define NT_GPIOA_INTENCLR_INTENCLR_Pos        0                                                       /*!< NT_GPIOA INTENCLR: INTENCLR Position    */
#define NT_GPIOA_INTENCLR_INTENCLR_Msk        (0x0000ffffUL << NT_GPIOA_INTENCLR_INTENCLR_Pos)        /*!< NT_GPIOA INTENCLR: INTENCLR Mask        */

/* -----------------------------  NT_GPIOA_INTTYPESET  ---------------------------- */
#define NT_GPIOA_INTTYPESET_INTTYPESET_Pos    0                                                       /*!< NT_GPIOA INTTYPESET: INTTYPESET Position */
#define NT_GPIOA_INTTYPESET_INTTYPESET_Msk    (0x0000ffffUL << NT_GPIOA_INTTYPESET_INTTYPESET_Pos)    /*!< NT_GPIOA INTTYPESET: INTTYPESET Mask    */

/* -----------------------------  NT_GPIOA_INTTYPECLR  ---------------------------- */
#define NT_GPIOA_INTTYPECLR_INTTYPECLR_Pos    0                                                       /*!< NT_GPIOA INTTYPECLR: INTTYPECLR Position */
#define NT_GPIOA_INTTYPECLR_INTTYPECLR_Msk    (0x0000ffffUL << NT_GPIOA_INTTYPECLR_INTTYPECLR_Pos)    /*!< NT_GPIOA INTTYPECLR: INTTYPECLR Mask    */

/* -----------------------------  NT_GPIOA_INTPOLSET  ----------------------------- */
#define NT_GPIOA_INTPOLSET_INTPOLSET_Pos      0                                                       /*!< NT_GPIOA INTPOLSET: INTPOLSET Position  */
#define NT_GPIOA_INTPOLSET_INTPOLSET_Msk      (0x0000ffffUL << NT_GPIOA_INTPOLSET_INTPOLSET_Pos)      /*!< NT_GPIOA INTPOLSET: INTPOLSET Mask      */

/* -----------------------------  NT_GPIOA_INTPOLCLR  ----------------------------- */
#define NT_GPIOA_INTPOLCLR_INTPOLCLR_Pos      0                                                       /*!< NT_GPIOA INTPOLCLR: INTPOLCLR Position  */
#define NT_GPIOA_INTPOLCLR_INTPOLCLR_Msk      (0x0000ffffUL << NT_GPIOA_INTPOLCLR_INTPOLCLR_Pos)      /*!< NT_GPIOA INTPOLCLR: INTPOLCLR Mask      */

/* -----------------------------  NT_GPIOA_INTSTATUS  ----------------------------- */
#define NT_GPIOA_INTSTATUS_INTSTATUS_Pos      0                                                       /*!< NT_GPIOA INTSTATUS: INTSTATUS Position  */
#define NT_GPIOA_INTSTATUS_INTSTATUS_Msk      (0x0000ffffUL << NT_GPIOA_INTSTATUS_INTSTATUS_Pos)      /*!< NT_GPIOA INTSTATUS: INTSTATUS Mask      */


/* ================================================================================ */
/* ================      struct 'MASKLOWBYTE' Position & Mask      ================ */
/* ================================================================================ */


/* ---------------------------  MASKLOWBYTE_MASKLOWBYTE  -------------------------- */
#define MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos    0                                                       /*!< MASKLOWBYTE MASKLOWBYTE: MASKLB Position */
#define MASKLOWBYTE_MASKLOWBYTE_MASKLB_Msk    (0x000000ffUL << MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos)    /*!< MASKLOWBYTE MASKLOWBYTE: MASKLB Mask    */


/* ================================================================================ */
/* ================      struct 'MASKHIGHBYTE' Position & Mask     ================ */
/* ================================================================================ */


/* --------------------------  MASKHIGHBYTE_MASKHIGHBYTE  ------------------------- */
#define MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos  8                                                       /*!< MASKHIGHBYTE MASKHIGHBYTE: MASKHB Position */
#define MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Msk  (0x000000ffUL << MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos)  /*!< MASKHIGHBYTE MASKHIGHBYTE: MASKHB Mask  */


/* ================================================================================ */
/* ================        struct 'NT_GPIOB' Position & Mask       ================ */
/* ================================================================================ */


/* --------------------------------  NT_GPIOB_DATA  ------------------------------- */
#define NT_GPIOB_DATA_DATA_Pos                0                                                       /*!< NT_GPIOB DATA: DATA Position            */
#define NT_GPIOB_DATA_DATA_Msk                (0x0000ffffUL << NT_GPIOB_DATA_DATA_Pos)                /*!< NT_GPIOB DATA: DATA Mask                */

/* ------------------------------  NT_GPIOB_DATAOUT  ------------------------------ */
#define NT_GPIOB_DATAOUT_DATAOUT_Pos          0                                                       /*!< NT_GPIOB DATAOUT: DATAOUT Position      */
#define NT_GPIOB_DATAOUT_DATAOUT_Msk          (0x0000ffffUL << NT_GPIOB_DATAOUT_DATAOUT_Pos)          /*!< NT_GPIOB DATAOUT: DATAOUT Mask          */

/* ------------------------------  NT_GPIOB_OUTENSET  ----------------------------- */
#define NT_GPIOB_OUTENSET_OUTENSET_Pos        0                                                       /*!< NT_GPIOB OUTENSET: OUTENSET Position    */
#define NT_GPIOB_OUTENSET_OUTENSET_Msk        (0x0000ffffUL << NT_GPIOB_OUTENSET_OUTENSET_Pos)        /*!< NT_GPIOB OUTENSET: OUTENSET Mask        */

/* ------------------------------  NT_GPIOB_OUTENCLR  ----------------------------- */
#define NT_GPIOB_OUTENCLR_OUTENCLR_Pos        0                                                       /*!< NT_GPIOB OUTENCLR: OUTENCLR Position    */
#define NT_GPIOB_OUTENCLR_OUTENCLR_Msk        (0x0000ffffUL << NT_GPIOB_OUTENCLR_OUTENCLR_Pos)        /*!< NT_GPIOB OUTENCLR: OUTENCLR Mask        */

/* -----------------------------  NT_GPIOB_ALTFUNCSET  ---------------------------- */
#define NT_GPIOB_ALTFUNCSET_ALTFUNCSET_Pos    0                                                       /*!< NT_GPIOB ALTFUNCSET: ALTFUNCSET Position */
#define NT_GPIOB_ALTFUNCSET_ALTFUNCSET_Msk    (0x0000ffffUL << NT_GPIOB_ALTFUNCSET_ALTFUNCSET_Pos)    /*!< NT_GPIOB ALTFUNCSET: ALTFUNCSET Mask    */

/* -----------------------------  NT_GPIOB_ALTFUNCCLR  ---------------------------- */
#define NT_GPIOB_ALTFUNCCLR_ALTFUNCCLR_Pos    0                                                       /*!< NT_GPIOB ALTFUNCCLR: ALTFUNCCLR Position */
#define NT_GPIOB_ALTFUNCCLR_ALTFUNCCLR_Msk    (0x0000ffffUL << NT_GPIOB_ALTFUNCCLR_ALTFUNCCLR_Pos)    /*!< NT_GPIOB ALTFUNCCLR: ALTFUNCCLR Mask    */

/* ------------------------------  NT_GPIOB_INTENSET  ----------------------------- */
#define NT_GPIOB_INTENSET_INTENSET_Pos        0                                                       /*!< NT_GPIOB INTENSET: INTENSET Position    */
#define NT_GPIOB_INTENSET_INTENSET_Msk        (0x0000ffffUL << NT_GPIOB_INTENSET_INTENSET_Pos)        /*!< NT_GPIOB INTENSET: INTENSET Mask        */

/* ------------------------------  NT_GPIOB_INTENCLR  ----------------------------- */
#define NT_GPIOB_INTENCLR_INTENCLR_Pos        0                                                       /*!< NT_GPIOB INTENCLR: INTENCLR Position    */
#define NT_GPIOB_INTENCLR_INTENCLR_Msk        (0x0000ffffUL << NT_GPIOB_INTENCLR_INTENCLR_Pos)        /*!< NT_GPIOB INTENCLR: INTENCLR Mask        */

/* -----------------------------  NT_GPIOB_INTTYPESET  ---------------------------- */
#define NT_GPIOB_INTTYPESET_INTTYPESET_Pos    0                                                       /*!< NT_GPIOB INTTYPESET: INTTYPESET Position */
#define NT_GPIOB_INTTYPESET_INTTYPESET_Msk    (0x0000ffffUL << NT_GPIOB_INTTYPESET_INTTYPESET_Pos)    /*!< NT_GPIOB INTTYPESET: INTTYPESET Mask    */

/* -----------------------------  NT_GPIOB_INTTYPECLR  ---------------------------- */
#define NT_GPIOB_INTTYPECLR_INTTYPECLR_Pos    0                                                       /*!< NT_GPIOB INTTYPECLR: INTTYPECLR Position */
#define NT_GPIOB_INTTYPECLR_INTTYPECLR_Msk    (0x0000ffffUL << NT_GPIOB_INTTYPECLR_INTTYPECLR_Pos)    /*!< NT_GPIOB INTTYPECLR: INTTYPECLR Mask    */

/* -----------------------------  NT_GPIOB_INTPOLSET  ----------------------------- */
#define NT_GPIOB_INTPOLSET_INTPOLSET_Pos      0                                                       /*!< NT_GPIOB INTPOLSET: INTPOLSET Position  */
#define NT_GPIOB_INTPOLSET_INTPOLSET_Msk      (0x0000ffffUL << NT_GPIOB_INTPOLSET_INTPOLSET_Pos)      /*!< NT_GPIOB INTPOLSET: INTPOLSET Mask      */

/* -----------------------------  NT_GPIOB_INTPOLCLR  ----------------------------- */
#define NT_GPIOB_INTPOLCLR_INTPOLCLR_Pos      0                                                       /*!< NT_GPIOB INTPOLCLR: INTPOLCLR Position  */
#define NT_GPIOB_INTPOLCLR_INTPOLCLR_Msk      (0x0000ffffUL << NT_GPIOB_INTPOLCLR_INTPOLCLR_Pos)      /*!< NT_GPIOB INTPOLCLR: INTPOLCLR Mask      */

/* -----------------------------  NT_GPIOB_INTSTATUS  ----------------------------- */
#define NT_GPIOB_INTSTATUS_INTSTATUS_Pos      0                                                       /*!< NT_GPIOB INTSTATUS: INTSTATUS Position  */
#define NT_GPIOB_INTSTATUS_INTSTATUS_Msk      (0x0000ffffUL << NT_GPIOB_INTSTATUS_INTSTATUS_Pos)      /*!< NT_GPIOB INTSTATUS: INTSTATUS Mask      */


/* ================================================================================ */
/* ================      struct 'MASKLOWBYTE' Position & Mask      ================ */
/* ================================================================================ */


/* ----------------------  NT_GPIOB_MASKLOWBYTE_MASKLOWBYTE  ---------------------- */
#define NT_GPIOB_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos 0                                                 /*!< NT_GPIOB_MASKLOWBYTE MASKLOWBYTE: MASKLB Position */
#define NT_GPIOB_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Msk (0x000000ffUL << NT_GPIOB_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos)/*!< NT_GPIOB_MASKLOWBYTE MASKLOWBYTE: MASKLB Mask */


/* ================================================================================ */
/* ================      struct 'MASKHIGHBYTE' Position & Mask     ================ */
/* ================================================================================ */


/* ---------------------  NT_GPIOB_MASKHIGHBYTE_MASKHIGHBYTE  --------------------- */
#define NT_GPIOB_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos 8                                               /*!< NT_GPIOB_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Position */
#define NT_GPIOB_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Msk (0x000000ffUL << NT_GPIOB_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos)/*!< NT_GPIOB_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Mask */


/* ================================================================================ */
/* ================        struct 'NT_GPIOC' Position & Mask       ================ */
/* ================================================================================ */


/* --------------------------------  NT_GPIOC_DATA  ------------------------------- */
#define NT_GPIOC_DATA_DATA_Pos                0                                                       /*!< NT_GPIOC DATA: DATA Position            */
#define NT_GPIOC_DATA_DATA_Msk                (0x0000ffffUL << NT_GPIOC_DATA_DATA_Pos)                /*!< NT_GPIOC DATA: DATA Mask                */

/* ------------------------------  NT_GPIOC_DATAOUT  ------------------------------ */
#define NT_GPIOC_DATAOUT_DATAOUT_Pos          0                                                       /*!< NT_GPIOC DATAOUT: DATAOUT Position      */
#define NT_GPIOC_DATAOUT_DATAOUT_Msk          (0x0000ffffUL << NT_GPIOC_DATAOUT_DATAOUT_Pos)          /*!< NT_GPIOC DATAOUT: DATAOUT Mask          */

/* ------------------------------  NT_GPIOC_OUTENSET  ----------------------------- */
#define NT_GPIOC_OUTENSET_OUTENSET_Pos        0                                                       /*!< NT_GPIOC OUTENSET: OUTENSET Position    */
#define NT_GPIOC_OUTENSET_OUTENSET_Msk        (0x0000ffffUL << NT_GPIOC_OUTENSET_OUTENSET_Pos)        /*!< NT_GPIOC OUTENSET: OUTENSET Mask        */

/* ------------------------------  NT_GPIOC_OUTENCLR  ----------------------------- */
#define NT_GPIOC_OUTENCLR_OUTENCLR_Pos        0                                                       /*!< NT_GPIOC OUTENCLR: OUTENCLR Position    */
#define NT_GPIOC_OUTENCLR_OUTENCLR_Msk        (0x0000ffffUL << NT_GPIOC_OUTENCLR_OUTENCLR_Pos)        /*!< NT_GPIOC OUTENCLR: OUTENCLR Mask        */

/* -----------------------------  NT_GPIOC_ALTFUNCSET  ---------------------------- */
#define NT_GPIOC_ALTFUNCSET_ALTFUNCSET_Pos    0                                                       /*!< NT_GPIOC ALTFUNCSET: ALTFUNCSET Position */
#define NT_GPIOC_ALTFUNCSET_ALTFUNCSET_Msk    (0x0000ffffUL << NT_GPIOC_ALTFUNCSET_ALTFUNCSET_Pos)    /*!< NT_GPIOC ALTFUNCSET: ALTFUNCSET Mask    */

/* -----------------------------  NT_GPIOC_ALTFUNCCLR  ---------------------------- */
#define NT_GPIOC_ALTFUNCCLR_ALTFUNCCLR_Pos    0                                                       /*!< NT_GPIOC ALTFUNCCLR: ALTFUNCCLR Position */
#define NT_GPIOC_ALTFUNCCLR_ALTFUNCCLR_Msk    (0x0000ffffUL << NT_GPIOC_ALTFUNCCLR_ALTFUNCCLR_Pos)    /*!< NT_GPIOC ALTFUNCCLR: ALTFUNCCLR Mask    */

/* ------------------------------  NT_GPIOC_INTENSET  ----------------------------- */
#define NT_GPIOC_INTENSET_INTENSET_Pos        0                                                       /*!< NT_GPIOC INTENSET: INTENSET Position    */
#define NT_GPIOC_INTENSET_INTENSET_Msk        (0x0000ffffUL << NT_GPIOC_INTENSET_INTENSET_Pos)        /*!< NT_GPIOC INTENSET: INTENSET Mask        */

/* ------------------------------  NT_GPIOC_INTENCLR  ----------------------------- */
#define NT_GPIOC_INTENCLR_INTENCLR_Pos        0                                                       /*!< NT_GPIOC INTENCLR: INTENCLR Position    */
#define NT_GPIOC_INTENCLR_INTENCLR_Msk        (0x0000ffffUL << NT_GPIOC_INTENCLR_INTENCLR_Pos)        /*!< NT_GPIOC INTENCLR: INTENCLR Mask        */

/* -----------------------------  NT_GPIOC_INTTYPESET  ---------------------------- */
#define NT_GPIOC_INTTYPESET_INTTYPESET_Pos    0                                                       /*!< NT_GPIOC INTTYPESET: INTTYPESET Position */
#define NT_GPIOC_INTTYPESET_INTTYPESET_Msk    (0x0000ffffUL << NT_GPIOC_INTTYPESET_INTTYPESET_Pos)    /*!< NT_GPIOC INTTYPESET: INTTYPESET Mask    */

/* -----------------------------  NT_GPIOC_INTTYPECLR  ---------------------------- */
#define NT_GPIOC_INTTYPECLR_INTTYPECLR_Pos    0                                                       /*!< NT_GPIOC INTTYPECLR: INTTYPECLR Position */
#define NT_GPIOC_INTTYPECLR_INTTYPECLR_Msk    (0x0000ffffUL << NT_GPIOC_INTTYPECLR_INTTYPECLR_Pos)    /*!< NT_GPIOC INTTYPECLR: INTTYPECLR Mask    */

/* -----------------------------  NT_GPIOC_INTPOLSET  ----------------------------- */
#define NT_GPIOC_INTPOLSET_INTPOLSET_Pos      0                                                       /*!< NT_GPIOC INTPOLSET: INTPOLSET Position  */
#define NT_GPIOC_INTPOLSET_INTPOLSET_Msk      (0x0000ffffUL << NT_GPIOC_INTPOLSET_INTPOLSET_Pos)      /*!< NT_GPIOC INTPOLSET: INTPOLSET Mask      */

/* -----------------------------  NT_GPIOC_INTPOLCLR  ----------------------------- */
#define NT_GPIOC_INTPOLCLR_INTPOLCLR_Pos      0                                                       /*!< NT_GPIOC INTPOLCLR: INTPOLCLR Position  */
#define NT_GPIOC_INTPOLCLR_INTPOLCLR_Msk      (0x0000ffffUL << NT_GPIOC_INTPOLCLR_INTPOLCLR_Pos)      /*!< NT_GPIOC INTPOLCLR: INTPOLCLR Mask      */

/* -----------------------------  NT_GPIOC_INTSTATUS  ----------------------------- */
#define NT_GPIOC_INTSTATUS_INTSTATUS_Pos      0                                                       /*!< NT_GPIOC INTSTATUS: INTSTATUS Position  */
#define NT_GPIOC_INTSTATUS_INTSTATUS_Msk      (0x0000ffffUL << NT_GPIOC_INTSTATUS_INTSTATUS_Pos)      /*!< NT_GPIOC INTSTATUS: INTSTATUS Mask      */


/* ================================================================================ */
/* ================      struct 'MASKLOWBYTE' Position & Mask      ================ */
/* ================================================================================ */


/* ----------------------  NT_GPIOC_MASKLOWBYTE_MASKLOWBYTE  ---------------------- */
#define NT_GPIOC_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos 0                                                 /*!< NT_GPIOC_MASKLOWBYTE MASKLOWBYTE: MASKLB Position */
#define NT_GPIOC_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Msk (0x000000ffUL << NT_GPIOC_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos)/*!< NT_GPIOC_MASKLOWBYTE MASKLOWBYTE: MASKLB Mask */


/* ================================================================================ */
/* ================      struct 'MASKHIGHBYTE' Position & Mask     ================ */
/* ================================================================================ */


/* ---------------------  NT_GPIOC_MASKHIGHBYTE_MASKHIGHBYTE  --------------------- */
#define NT_GPIOC_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos 8                                               /*!< NT_GPIOC_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Position */
#define NT_GPIOC_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Msk (0x000000ffUL << NT_GPIOC_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos)/*!< NT_GPIOC_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Mask */


/* ================================================================================ */
/* ================        struct 'NT_GPIOD' Position & Mask       ================ */
/* ================================================================================ */


/* --------------------------------  NT_GPIOD_DATA  ------------------------------- */
#define NT_GPIOD_DATA_DATA_Pos                0                                                       /*!< NT_GPIOD DATA: DATA Position            */
#define NT_GPIOD_DATA_DATA_Msk                (0x0000ffffUL << NT_GPIOD_DATA_DATA_Pos)                /*!< NT_GPIOD DATA: DATA Mask                */

/* ------------------------------  NT_GPIOD_DATAOUT  ------------------------------ */
#define NT_GPIOD_DATAOUT_DATAOUT_Pos          0                                                       /*!< NT_GPIOD DATAOUT: DATAOUT Position      */
#define NT_GPIOD_DATAOUT_DATAOUT_Msk          (0x0000ffffUL << NT_GPIOD_DATAOUT_DATAOUT_Pos)          /*!< NT_GPIOD DATAOUT: DATAOUT Mask          */

/* ------------------------------  NT_GPIOD_OUTENSET  ----------------------------- */
#define NT_GPIOD_OUTENSET_OUTENSET_Pos        0                                                       /*!< NT_GPIOD OUTENSET: OUTENSET Position    */
#define NT_GPIOD_OUTENSET_OUTENSET_Msk        (0x0000ffffUL << NT_GPIOD_OUTENSET_OUTENSET_Pos)        /*!< NT_GPIOD OUTENSET: OUTENSET Mask        */

/* ------------------------------  NT_GPIOD_OUTENCLR  ----------------------------- */
#define NT_GPIOD_OUTENCLR_OUTENCLR_Pos        0                                                       /*!< NT_GPIOD OUTENCLR: OUTENCLR Position    */
#define NT_GPIOD_OUTENCLR_OUTENCLR_Msk        (0x0000ffffUL << NT_GPIOD_OUTENCLR_OUTENCLR_Pos)        /*!< NT_GPIOD OUTENCLR: OUTENCLR Mask        */

/* -----------------------------  NT_GPIOD_ALTFUNCSET  ---------------------------- */
#define NT_GPIOD_ALTFUNCSET_ALTFUNCSET_Pos    0                                                       /*!< NT_GPIOD ALTFUNCSET: ALTFUNCSET Position */
#define NT_GPIOD_ALTFUNCSET_ALTFUNCSET_Msk    (0x0000ffffUL << NT_GPIOD_ALTFUNCSET_ALTFUNCSET_Pos)    /*!< NT_GPIOD ALTFUNCSET: ALTFUNCSET Mask    */

/* -----------------------------  NT_GPIOD_ALTFUNCCLR  ---------------------------- */
#define NT_GPIOD_ALTFUNCCLR_ALTFUNCCLR_Pos    0                                                       /*!< NT_GPIOD ALTFUNCCLR: ALTFUNCCLR Position */
#define NT_GPIOD_ALTFUNCCLR_ALTFUNCCLR_Msk    (0x0000ffffUL << NT_GPIOD_ALTFUNCCLR_ALTFUNCCLR_Pos)    /*!< NT_GPIOD ALTFUNCCLR: ALTFUNCCLR Mask    */

/* ------------------------------  NT_GPIOD_INTENSET  ----------------------------- */
#define NT_GPIOD_INTENSET_INTENSET_Pos        0                                                       /*!< NT_GPIOD INTENSET: INTENSET Position    */
#define NT_GPIOD_INTENSET_INTENSET_Msk        (0x0000ffffUL << NT_GPIOD_INTENSET_INTENSET_Pos)        /*!< NT_GPIOD INTENSET: INTENSET Mask        */

/* ------------------------------  NT_GPIOD_INTENCLR  ----------------------------- */
#define NT_GPIOD_INTENCLR_INTENCLR_Pos        0                                                       /*!< NT_GPIOD INTENCLR: INTENCLR Position    */
#define NT_GPIOD_INTENCLR_INTENCLR_Msk        (0x0000ffffUL << NT_GPIOD_INTENCLR_INTENCLR_Pos)        /*!< NT_GPIOD INTENCLR: INTENCLR Mask        */

/* -----------------------------  NT_GPIOD_INTTYPESET  ---------------------------- */
#define NT_GPIOD_INTTYPESET_INTTYPESET_Pos    0                                                       /*!< NT_GPIOD INTTYPESET: INTTYPESET Position */
#define NT_GPIOD_INTTYPESET_INTTYPESET_Msk    (0x0000ffffUL << NT_GPIOD_INTTYPESET_INTTYPESET_Pos)    /*!< NT_GPIOD INTTYPESET: INTTYPESET Mask    */

/* -----------------------------  NT_GPIOD_INTTYPECLR  ---------------------------- */
#define NT_GPIOD_INTTYPECLR_INTTYPECLR_Pos    0                                                       /*!< NT_GPIOD INTTYPECLR: INTTYPECLR Position */
#define NT_GPIOD_INTTYPECLR_INTTYPECLR_Msk    (0x0000ffffUL << NT_GPIOD_INTTYPECLR_INTTYPECLR_Pos)    /*!< NT_GPIOD INTTYPECLR: INTTYPECLR Mask    */

/* -----------------------------  NT_GPIOD_INTPOLSET  ----------------------------- */
#define NT_GPIOD_INTPOLSET_INTPOLSET_Pos      0                                                       /*!< NT_GPIOD INTPOLSET: INTPOLSET Position  */
#define NT_GPIOD_INTPOLSET_INTPOLSET_Msk      (0x0000ffffUL << NT_GPIOD_INTPOLSET_INTPOLSET_Pos)      /*!< NT_GPIOD INTPOLSET: INTPOLSET Mask      */

/* -----------------------------  NT_GPIOD_INTPOLCLR  ----------------------------- */
#define NT_GPIOD_INTPOLCLR_INTPOLCLR_Pos      0                                                       /*!< NT_GPIOD INTPOLCLR: INTPOLCLR Position  */
#define NT_GPIOD_INTPOLCLR_INTPOLCLR_Msk      (0x0000ffffUL << NT_GPIOD_INTPOLCLR_INTPOLCLR_Pos)      /*!< NT_GPIOD INTPOLCLR: INTPOLCLR Mask      */

/* -----------------------------  NT_GPIOD_INTSTATUS  ----------------------------- */
#define NT_GPIOD_INTSTATUS_INTSTATUS_Pos      0                                                       /*!< NT_GPIOD INTSTATUS: INTSTATUS Position  */
#define NT_GPIOD_INTSTATUS_INTSTATUS_Msk      (0x0000ffffUL << NT_GPIOD_INTSTATUS_INTSTATUS_Pos)      /*!< NT_GPIOD INTSTATUS: INTSTATUS Mask      */


/* ================================================================================ */
/* ================      struct 'MASKLOWBYTE' Position & Mask      ================ */
/* ================================================================================ */


/* ----------------------  NT_GPIOD_MASKLOWBYTE_MASKLOWBYTE  ---------------------- */
#define NT_GPIOD_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos 0                                                 /*!< NT_GPIOD_MASKLOWBYTE MASKLOWBYTE: MASKLB Position */
#define NT_GPIOD_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Msk (0x000000ffUL << NT_GPIOD_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos)/*!< NT_GPIOD_MASKLOWBYTE MASKLOWBYTE: MASKLB Mask */


/* ================================================================================ */
/* ================      struct 'MASKHIGHBYTE' Position & Mask     ================ */
/* ================================================================================ */


/* ---------------------  NT_GPIOD_MASKHIGHBYTE_MASKHIGHBYTE  --------------------- */
#define NT_GPIOD_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos 8                                               /*!< NT_GPIOD_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Position */
#define NT_GPIOD_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Msk (0x000000ffUL << NT_GPIOD_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos)/*!< NT_GPIOD_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Mask */


/* ================================================================================ */
/* ================        struct 'NT_GPIOE' Position & Mask       ================ */
/* ================================================================================ */


/* --------------------------------  NT_GPIOE_DATA  ------------------------------- */
#define NT_GPIOE_DATA_DATA_Pos                0                                                       /*!< NT_GPIOE DATA: DATA Position            */
#define NT_GPIOE_DATA_DATA_Msk                (0x0000ffffUL << NT_GPIOE_DATA_DATA_Pos)                /*!< NT_GPIOE DATA: DATA Mask                */

/* ------------------------------  NT_GPIOE_DATAOUT  ------------------------------ */
#define NT_GPIOE_DATAOUT_DATAOUT_Pos          0                                                       /*!< NT_GPIOE DATAOUT: DATAOUT Position      */
#define NT_GPIOE_DATAOUT_DATAOUT_Msk          (0x0000ffffUL << NT_GPIOE_DATAOUT_DATAOUT_Pos)          /*!< NT_GPIOE DATAOUT: DATAOUT Mask          */

/* ------------------------------  NT_GPIOE_OUTENSET  ----------------------------- */
#define NT_GPIOE_OUTENSET_OUTENSET_Pos        0                                                       /*!< NT_GPIOE OUTENSET: OUTENSET Position    */
#define NT_GPIOE_OUTENSET_OUTENSET_Msk        (0x0000ffffUL << NT_GPIOE_OUTENSET_OUTENSET_Pos)        /*!< NT_GPIOE OUTENSET: OUTENSET Mask        */

/* ------------------------------  NT_GPIOE_OUTENCLR  ----------------------------- */
#define NT_GPIOE_OUTENCLR_OUTENCLR_Pos        0                                                       /*!< NT_GPIOE OUTENCLR: OUTENCLR Position    */
#define NT_GPIOE_OUTENCLR_OUTENCLR_Msk        (0x0000ffffUL << NT_GPIOE_OUTENCLR_OUTENCLR_Pos)        /*!< NT_GPIOE OUTENCLR: OUTENCLR Mask        */

/* -----------------------------  NT_GPIOE_ALTFUNCSET  ---------------------------- */
#define NT_GPIOE_ALTFUNCSET_ALTFUNCSET_Pos    0                                                       /*!< NT_GPIOE ALTFUNCSET: ALTFUNCSET Position */
#define NT_GPIOE_ALTFUNCSET_ALTFUNCSET_Msk    (0x0000ffffUL << NT_GPIOE_ALTFUNCSET_ALTFUNCSET_Pos)    /*!< NT_GPIOE ALTFUNCSET: ALTFUNCSET Mask    */

/* -----------------------------  NT_GPIOE_ALTFUNCCLR  ---------------------------- */
#define NT_GPIOE_ALTFUNCCLR_ALTFUNCCLR_Pos    0                                                       /*!< NT_GPIOE ALTFUNCCLR: ALTFUNCCLR Position */
#define NT_GPIOE_ALTFUNCCLR_ALTFUNCCLR_Msk    (0x0000ffffUL << NT_GPIOE_ALTFUNCCLR_ALTFUNCCLR_Pos)    /*!< NT_GPIOE ALTFUNCCLR: ALTFUNCCLR Mask    */

/* ------------------------------  NT_GPIOE_INTENSET  ----------------------------- */
#define NT_GPIOE_INTENSET_INTENSET_Pos        0                                                       /*!< NT_GPIOE INTENSET: INTENSET Position    */
#define NT_GPIOE_INTENSET_INTENSET_Msk        (0x0000ffffUL << NT_GPIOE_INTENSET_INTENSET_Pos)        /*!< NT_GPIOE INTENSET: INTENSET Mask        */

/* ------------------------------  NT_GPIOE_INTENCLR  ----------------------------- */
#define NT_GPIOE_INTENCLR_INTENCLR_Pos        0                                                       /*!< NT_GPIOE INTENCLR: INTENCLR Position    */
#define NT_GPIOE_INTENCLR_INTENCLR_Msk        (0x0000ffffUL << NT_GPIOE_INTENCLR_INTENCLR_Pos)        /*!< NT_GPIOE INTENCLR: INTENCLR Mask        */

/* -----------------------------  NT_GPIOE_INTTYPESET  ---------------------------- */
#define NT_GPIOE_INTTYPESET_INTTYPESET_Pos    0                                                       /*!< NT_GPIOE INTTYPESET: INTTYPESET Position */
#define NT_GPIOE_INTTYPESET_INTTYPESET_Msk    (0x0000ffffUL << NT_GPIOE_INTTYPESET_INTTYPESET_Pos)    /*!< NT_GPIOE INTTYPESET: INTTYPESET Mask    */

/* -----------------------------  NT_GPIOE_INTTYPECLR  ---------------------------- */
#define NT_GPIOE_INTTYPECLR_INTTYPECLR_Pos    0                                                       /*!< NT_GPIOE INTTYPECLR: INTTYPECLR Position */
#define NT_GPIOE_INTTYPECLR_INTTYPECLR_Msk    (0x0000ffffUL << NT_GPIOE_INTTYPECLR_INTTYPECLR_Pos)    /*!< NT_GPIOE INTTYPECLR: INTTYPECLR Mask    */

/* -----------------------------  NT_GPIOE_INTPOLSET  ----------------------------- */
#define NT_GPIOE_INTPOLSET_INTPOLSET_Pos      0                                                       /*!< NT_GPIOE INTPOLSET: INTPOLSET Position  */
#define NT_GPIOE_INTPOLSET_INTPOLSET_Msk      (0x0000ffffUL << NT_GPIOE_INTPOLSET_INTPOLSET_Pos)      /*!< NT_GPIOE INTPOLSET: INTPOLSET Mask      */

/* -----------------------------  NT_GPIOE_INTPOLCLR  ----------------------------- */
#define NT_GPIOE_INTPOLCLR_INTPOLCLR_Pos      0                                                       /*!< NT_GPIOE INTPOLCLR: INTPOLCLR Position  */
#define NT_GPIOE_INTPOLCLR_INTPOLCLR_Msk      (0x0000ffffUL << NT_GPIOE_INTPOLCLR_INTPOLCLR_Pos)      /*!< NT_GPIOE INTPOLCLR: INTPOLCLR Mask      */

/* -----------------------------  NT_GPIOE_INTSTATUS  ----------------------------- */
#define NT_GPIOE_INTSTATUS_INTSTATUS_Pos      0                                                       /*!< NT_GPIOE INTSTATUS: INTSTATUS Position  */
#define NT_GPIOE_INTSTATUS_INTSTATUS_Msk      (0x0000ffffUL << NT_GPIOE_INTSTATUS_INTSTATUS_Pos)      /*!< NT_GPIOE INTSTATUS: INTSTATUS Mask      */


/* ================================================================================ */
/* ================      struct 'MASKLOWBYTE' Position & Mask      ================ */
/* ================================================================================ */


/* ----------------------  NT_GPIOE_MASKLOWBYTE_MASKLOWBYTE  ---------------------- */
#define NT_GPIOE_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos 0                                                 /*!< NT_GPIOE_MASKLOWBYTE MASKLOWBYTE: MASKLB Position */
#define NT_GPIOE_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Msk (0x000000ffUL << NT_GPIOE_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos)/*!< NT_GPIOE_MASKLOWBYTE MASKLOWBYTE: MASKLB Mask */


/* ================================================================================ */
/* ================      struct 'MASKHIGHBYTE' Position & Mask     ================ */
/* ================================================================================ */


/* ---------------------  NT_GPIOE_MASKHIGHBYTE_MASKHIGHBYTE  --------------------- */
#define NT_GPIOE_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos 8                                               /*!< NT_GPIOE_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Position */
#define NT_GPIOE_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Msk (0x000000ffUL << NT_GPIOE_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos)/*!< NT_GPIOE_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Mask */


/* ================================================================================ */
/* ================        struct 'NT_GPIOF' Position & Mask       ================ */
/* ================================================================================ */


/* --------------------------------  NT_GPIOF_DATA  ------------------------------- */
#define NT_GPIOF_DATA_DATA_Pos                0                                                       /*!< NT_GPIOF DATA: DATA Position            */
#define NT_GPIOF_DATA_DATA_Msk                (0x0000ffffUL << NT_GPIOF_DATA_DATA_Pos)                /*!< NT_GPIOF DATA: DATA Mask                */

/* ------------------------------  NT_GPIOF_DATAOUT  ------------------------------ */
#define NT_GPIOF_DATAOUT_DATAOUT_Pos          0                                                       /*!< NT_GPIOF DATAOUT: DATAOUT Position      */
#define NT_GPIOF_DATAOUT_DATAOUT_Msk          (0x0000ffffUL << NT_GPIOF_DATAOUT_DATAOUT_Pos)          /*!< NT_GPIOF DATAOUT: DATAOUT Mask          */

/* ------------------------------  NT_GPIOF_OUTENSET  ----------------------------- */
#define NT_GPIOF_OUTENSET_OUTENSET_Pos        0                                                       /*!< NT_GPIOF OUTENSET: OUTENSET Position    */
#define NT_GPIOF_OUTENSET_OUTENSET_Msk        (0x0000ffffUL << NT_GPIOF_OUTENSET_OUTENSET_Pos)        /*!< NT_GPIOF OUTENSET: OUTENSET Mask        */

/* ------------------------------  NT_GPIOF_OUTENCLR  ----------------------------- */
#define NT_GPIOF_OUTENCLR_OUTENCLR_Pos        0                                                       /*!< NT_GPIOF OUTENCLR: OUTENCLR Position    */
#define NT_GPIOF_OUTENCLR_OUTENCLR_Msk        (0x0000ffffUL << NT_GPIOF_OUTENCLR_OUTENCLR_Pos)        /*!< NT_GPIOF OUTENCLR: OUTENCLR Mask        */

/* -----------------------------  NT_GPIOF_ALTFUNCSET  ---------------------------- */
#define NT_GPIOF_ALTFUNCSET_ALTFUNCSET_Pos    0                                                       /*!< NT_GPIOF ALTFUNCSET: ALTFUNCSET Position */
#define NT_GPIOF_ALTFUNCSET_ALTFUNCSET_Msk    (0x0000ffffUL << NT_GPIOF_ALTFUNCSET_ALTFUNCSET_Pos)    /*!< NT_GPIOF ALTFUNCSET: ALTFUNCSET Mask    */

/* -----------------------------  NT_GPIOF_ALTFUNCCLR  ---------------------------- */
#define NT_GPIOF_ALTFUNCCLR_ALTFUNCCLR_Pos    0                                                       /*!< NT_GPIOF ALTFUNCCLR: ALTFUNCCLR Position */
#define NT_GPIOF_ALTFUNCCLR_ALTFUNCCLR_Msk    (0x0000ffffUL << NT_GPIOF_ALTFUNCCLR_ALTFUNCCLR_Pos)    /*!< NT_GPIOF ALTFUNCCLR: ALTFUNCCLR Mask    */

/* ------------------------------  NT_GPIOF_INTENSET  ----------------------------- */
#define NT_GPIOF_INTENSET_INTENSET_Pos        0                                                       /*!< NT_GPIOF INTENSET: INTENSET Position    */
#define NT_GPIOF_INTENSET_INTENSET_Msk        (0x0000ffffUL << NT_GPIOF_INTENSET_INTENSET_Pos)        /*!< NT_GPIOF INTENSET: INTENSET Mask        */

/* ------------------------------  NT_GPIOF_INTENCLR  ----------------------------- */
#define NT_GPIOF_INTENCLR_INTENCLR_Pos        0                                                       /*!< NT_GPIOF INTENCLR: INTENCLR Position    */
#define NT_GPIOF_INTENCLR_INTENCLR_Msk        (0x0000ffffUL << NT_GPIOF_INTENCLR_INTENCLR_Pos)        /*!< NT_GPIOF INTENCLR: INTENCLR Mask        */

/* -----------------------------  NT_GPIOF_INTTYPESET  ---------------------------- */
#define NT_GPIOF_INTTYPESET_INTTYPESET_Pos    0                                                       /*!< NT_GPIOF INTTYPESET: INTTYPESET Position */
#define NT_GPIOF_INTTYPESET_INTTYPESET_Msk    (0x0000ffffUL << NT_GPIOF_INTTYPESET_INTTYPESET_Pos)    /*!< NT_GPIOF INTTYPESET: INTTYPESET Mask    */

/* -----------------------------  NT_GPIOF_INTTYPECLR  ---------------------------- */
#define NT_GPIOF_INTTYPECLR_INTTYPECLR_Pos    0                                                       /*!< NT_GPIOF INTTYPECLR: INTTYPECLR Position */
#define NT_GPIOF_INTTYPECLR_INTTYPECLR_Msk    (0x0000ffffUL << NT_GPIOF_INTTYPECLR_INTTYPECLR_Pos)    /*!< NT_GPIOF INTTYPECLR: INTTYPECLR Mask    */

/* -----------------------------  NT_GPIOF_INTPOLSET  ----------------------------- */
#define NT_GPIOF_INTPOLSET_INTPOLSET_Pos      0                                                       /*!< NT_GPIOF INTPOLSET: INTPOLSET Position  */
#define NT_GPIOF_INTPOLSET_INTPOLSET_Msk      (0x0000ffffUL << NT_GPIOF_INTPOLSET_INTPOLSET_Pos)      /*!< NT_GPIOF INTPOLSET: INTPOLSET Mask      */

/* -----------------------------  NT_GPIOF_INTPOLCLR  ----------------------------- */
#define NT_GPIOF_INTPOLCLR_INTPOLCLR_Pos      0                                                       /*!< NT_GPIOF INTPOLCLR: INTPOLCLR Position  */
#define NT_GPIOF_INTPOLCLR_INTPOLCLR_Msk      (0x0000ffffUL << NT_GPIOF_INTPOLCLR_INTPOLCLR_Pos)      /*!< NT_GPIOF INTPOLCLR: INTPOLCLR Mask      */

/* -----------------------------  NT_GPIOF_INTSTATUS  ----------------------------- */
#define NT_GPIOF_INTSTATUS_INTSTATUS_Pos      0                                                       /*!< NT_GPIOF INTSTATUS: INTSTATUS Position  */
#define NT_GPIOF_INTSTATUS_INTSTATUS_Msk      (0x0000ffffUL << NT_GPIOF_INTSTATUS_INTSTATUS_Pos)      /*!< NT_GPIOF INTSTATUS: INTSTATUS Mask      */


/* ================================================================================ */
/* ================      struct 'MASKLOWBYTE' Position & Mask      ================ */
/* ================================================================================ */


/* ----------------------  NT_GPIOF_MASKLOWBYTE_MASKLOWBYTE  ---------------------- */
#define NT_GPIOF_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos 0                                                 /*!< NT_GPIOF_MASKLOWBYTE MASKLOWBYTE: MASKLB Position */
#define NT_GPIOF_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Msk (0x000000ffUL << NT_GPIOF_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos)/*!< NT_GPIOF_MASKLOWBYTE MASKLOWBYTE: MASKLB Mask */


/* ================================================================================ */
/* ================      struct 'MASKHIGHBYTE' Position & Mask     ================ */
/* ================================================================================ */


/* ---------------------  NT_GPIOF_MASKHIGHBYTE_MASKHIGHBYTE  --------------------- */
#define NT_GPIOF_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos 8                                               /*!< NT_GPIOF_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Position */
#define NT_GPIOF_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Msk (0x000000ffUL << NT_GPIOF_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos)/*!< NT_GPIOF_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Mask */


/* ================================================================================ */
/* ================        struct 'NT_GPIOG' Position & Mask       ================ */
/* ================================================================================ */


/* --------------------------------  NT_GPIOG_DATA  ------------------------------- */
#define NT_GPIOG_DATA_DATA_Pos                0                                                       /*!< NT_GPIOG DATA: DATA Position            */
#define NT_GPIOG_DATA_DATA_Msk                (0x0000ffffUL << NT_GPIOG_DATA_DATA_Pos)                /*!< NT_GPIOG DATA: DATA Mask                */

/* ------------------------------  NT_GPIOG_DATAOUT  ------------------------------ */
#define NT_GPIOG_DATAOUT_DATAOUT_Pos          0                                                       /*!< NT_GPIOG DATAOUT: DATAOUT Position      */
#define NT_GPIOG_DATAOUT_DATAOUT_Msk          (0x0000ffffUL << NT_GPIOG_DATAOUT_DATAOUT_Pos)          /*!< NT_GPIOG DATAOUT: DATAOUT Mask          */

/* ------------------------------  NT_GPIOG_OUTENSET  ----------------------------- */
#define NT_GPIOG_OUTENSET_OUTENSET_Pos        0                                                       /*!< NT_GPIOG OUTENSET: OUTENSET Position    */
#define NT_GPIOG_OUTENSET_OUTENSET_Msk        (0x0000ffffUL << NT_GPIOG_OUTENSET_OUTENSET_Pos)        /*!< NT_GPIOG OUTENSET: OUTENSET Mask        */

/* ------------------------------  NT_GPIOG_OUTENCLR  ----------------------------- */
#define NT_GPIOG_OUTENCLR_OUTENCLR_Pos        0                                                       /*!< NT_GPIOG OUTENCLR: OUTENCLR Position    */
#define NT_GPIOG_OUTENCLR_OUTENCLR_Msk        (0x0000ffffUL << NT_GPIOG_OUTENCLR_OUTENCLR_Pos)        /*!< NT_GPIOG OUTENCLR: OUTENCLR Mask        */

/* -----------------------------  NT_GPIOG_ALTFUNCSET  ---------------------------- */
#define NT_GPIOG_ALTFUNCSET_ALTFUNCSET_Pos    0                                                       /*!< NT_GPIOG ALTFUNCSET: ALTFUNCSET Position */
#define NT_GPIOG_ALTFUNCSET_ALTFUNCSET_Msk    (0x0000ffffUL << NT_GPIOG_ALTFUNCSET_ALTFUNCSET_Pos)    /*!< NT_GPIOG ALTFUNCSET: ALTFUNCSET Mask    */

/* -----------------------------  NT_GPIOG_ALTFUNCCLR  ---------------------------- */
#define NT_GPIOG_ALTFUNCCLR_ALTFUNCCLR_Pos    0                                                       /*!< NT_GPIOG ALTFUNCCLR: ALTFUNCCLR Position */
#define NT_GPIOG_ALTFUNCCLR_ALTFUNCCLR_Msk    (0x0000ffffUL << NT_GPIOG_ALTFUNCCLR_ALTFUNCCLR_Pos)    /*!< NT_GPIOG ALTFUNCCLR: ALTFUNCCLR Mask    */

/* ------------------------------  NT_GPIOG_INTENSET  ----------------------------- */
#define NT_GPIOG_INTENSET_INTENSET_Pos        0                                                       /*!< NT_GPIOG INTENSET: INTENSET Position    */
#define NT_GPIOG_INTENSET_INTENSET_Msk        (0x0000ffffUL << NT_GPIOG_INTENSET_INTENSET_Pos)        /*!< NT_GPIOG INTENSET: INTENSET Mask        */

/* ------------------------------  NT_GPIOG_INTENCLR  ----------------------------- */
#define NT_GPIOG_INTENCLR_INTENCLR_Pos        0                                                       /*!< NT_GPIOG INTENCLR: INTENCLR Position    */
#define NT_GPIOG_INTENCLR_INTENCLR_Msk        (0x0000ffffUL << NT_GPIOG_INTENCLR_INTENCLR_Pos)        /*!< NT_GPIOG INTENCLR: INTENCLR Mask        */

/* -----------------------------  NT_GPIOG_INTTYPESET  ---------------------------- */
#define NT_GPIOG_INTTYPESET_INTTYPESET_Pos    0                                                       /*!< NT_GPIOG INTTYPESET: INTTYPESET Position */
#define NT_GPIOG_INTTYPESET_INTTYPESET_Msk    (0x0000ffffUL << NT_GPIOG_INTTYPESET_INTTYPESET_Pos)    /*!< NT_GPIOG INTTYPESET: INTTYPESET Mask    */

/* -----------------------------  NT_GPIOG_INTTYPECLR  ---------------------------- */
#define NT_GPIOG_INTTYPECLR_INTTYPECLR_Pos    0                                                       /*!< NT_GPIOG INTTYPECLR: INTTYPECLR Position */
#define NT_GPIOG_INTTYPECLR_INTTYPECLR_Msk    (0x0000ffffUL << NT_GPIOG_INTTYPECLR_INTTYPECLR_Pos)    /*!< NT_GPIOG INTTYPECLR: INTTYPECLR Mask    */

/* -----------------------------  NT_GPIOG_INTPOLSET  ----------------------------- */
#define NT_GPIOG_INTPOLSET_INTPOLSET_Pos      0                                                       /*!< NT_GPIOG INTPOLSET: INTPOLSET Position  */
#define NT_GPIOG_INTPOLSET_INTPOLSET_Msk      (0x0000ffffUL << NT_GPIOG_INTPOLSET_INTPOLSET_Pos)      /*!< NT_GPIOG INTPOLSET: INTPOLSET Mask      */

/* -----------------------------  NT_GPIOG_INTPOLCLR  ----------------------------- */
#define NT_GPIOG_INTPOLCLR_INTPOLCLR_Pos      0                                                       /*!< NT_GPIOG INTPOLCLR: INTPOLCLR Position  */
#define NT_GPIOG_INTPOLCLR_INTPOLCLR_Msk      (0x0000ffffUL << NT_GPIOG_INTPOLCLR_INTPOLCLR_Pos)      /*!< NT_GPIOG INTPOLCLR: INTPOLCLR Mask      */

/* -----------------------------  NT_GPIOG_INTSTATUS  ----------------------------- */
#define NT_GPIOG_INTSTATUS_INTSTATUS_Pos      0                                                       /*!< NT_GPIOG INTSTATUS: INTSTATUS Position  */
#define NT_GPIOG_INTSTATUS_INTSTATUS_Msk      (0x0000ffffUL << NT_GPIOG_INTSTATUS_INTSTATUS_Pos)      /*!< NT_GPIOG INTSTATUS: INTSTATUS Mask      */


/* ================================================================================ */
/* ================      struct 'MASKLOWBYTE' Position & Mask      ================ */
/* ================================================================================ */


/* ----------------------  NT_GPIOG_MASKLOWBYTE_MASKLOWBYTE  ---------------------- */
#define NT_GPIOG_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos 0                                                 /*!< NT_GPIOG_MASKLOWBYTE MASKLOWBYTE: MASKLB Position */
#define NT_GPIOG_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Msk (0x000000ffUL << NT_GPIOG_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos)/*!< NT_GPIOG_MASKLOWBYTE MASKLOWBYTE: MASKLB Mask */


/* ================================================================================ */
/* ================      struct 'MASKHIGHBYTE' Position & Mask     ================ */
/* ================================================================================ */


/* ---------------------  NT_GPIOG_MASKHIGHBYTE_MASKHIGHBYTE  --------------------- */
#define NT_GPIOG_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos 8                                               /*!< NT_GPIOG_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Position */
#define NT_GPIOG_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Msk (0x000000ffUL << NT_GPIOG_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos)/*!< NT_GPIOG_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Mask */


/* ================================================================================ */
/* ================        struct 'NT_GPIOH' Position & Mask       ================ */
/* ================================================================================ */


/* --------------------------------  NT_GPIOH_DATA  ------------------------------- */
#define NT_GPIOH_DATA_DATA_Pos                0                                                       /*!< NT_GPIOH DATA: DATA Position            */
#define NT_GPIOH_DATA_DATA_Msk                (0x0000ffffUL << NT_GPIOH_DATA_DATA_Pos)                /*!< NT_GPIOH DATA: DATA Mask                */

/* ------------------------------  NT_GPIOH_DATAOUT  ------------------------------ */
#define NT_GPIOH_DATAOUT_DATAOUT_Pos          0                                                       /*!< NT_GPIOH DATAOUT: DATAOUT Position      */
#define NT_GPIOH_DATAOUT_DATAOUT_Msk          (0x0000ffffUL << NT_GPIOH_DATAOUT_DATAOUT_Pos)          /*!< NT_GPIOH DATAOUT: DATAOUT Mask          */

/* ------------------------------  NT_GPIOH_OUTENSET  ----------------------------- */
#define NT_GPIOH_OUTENSET_OUTENSET_Pos        0                                                       /*!< NT_GPIOH OUTENSET: OUTENSET Position    */
#define NT_GPIOH_OUTENSET_OUTENSET_Msk        (0x0000ffffUL << NT_GPIOH_OUTENSET_OUTENSET_Pos)        /*!< NT_GPIOH OUTENSET: OUTENSET Mask        */

/* ------------------------------  NT_GPIOH_OUTENCLR  ----------------------------- */
#define NT_GPIOH_OUTENCLR_OUTENCLR_Pos        0                                                       /*!< NT_GPIOH OUTENCLR: OUTENCLR Position    */
#define NT_GPIOH_OUTENCLR_OUTENCLR_Msk        (0x0000ffffUL << NT_GPIOH_OUTENCLR_OUTENCLR_Pos)        /*!< NT_GPIOH OUTENCLR: OUTENCLR Mask        */

/* -----------------------------  NT_GPIOH_ALTFUNCSET  ---------------------------- */
#define NT_GPIOH_ALTFUNCSET_ALTFUNCSET_Pos    0                                                       /*!< NT_GPIOH ALTFUNCSET: ALTFUNCSET Position */
#define NT_GPIOH_ALTFUNCSET_ALTFUNCSET_Msk    (0x0000ffffUL << NT_GPIOH_ALTFUNCSET_ALTFUNCSET_Pos)    /*!< NT_GPIOH ALTFUNCSET: ALTFUNCSET Mask    */

/* -----------------------------  NT_GPIOH_ALTFUNCCLR  ---------------------------- */
#define NT_GPIOH_ALTFUNCCLR_ALTFUNCCLR_Pos    0                                                       /*!< NT_GPIOH ALTFUNCCLR: ALTFUNCCLR Position */
#define NT_GPIOH_ALTFUNCCLR_ALTFUNCCLR_Msk    (0x0000ffffUL << NT_GPIOH_ALTFUNCCLR_ALTFUNCCLR_Pos)    /*!< NT_GPIOH ALTFUNCCLR: ALTFUNCCLR Mask    */

/* ------------------------------  NT_GPIOH_INTENSET  ----------------------------- */
#define NT_GPIOH_INTENSET_INTENSET_Pos        0                                                       /*!< NT_GPIOH INTENSET: INTENSET Position    */
#define NT_GPIOH_INTENSET_INTENSET_Msk        (0x0000ffffUL << NT_GPIOH_INTENSET_INTENSET_Pos)        /*!< NT_GPIOH INTENSET: INTENSET Mask        */

/* ------------------------------  NT_GPIOH_INTENCLR  ----------------------------- */
#define NT_GPIOH_INTENCLR_INTENCLR_Pos        0                                                       /*!< NT_GPIOH INTENCLR: INTENCLR Position    */
#define NT_GPIOH_INTENCLR_INTENCLR_Msk        (0x0000ffffUL << NT_GPIOH_INTENCLR_INTENCLR_Pos)        /*!< NT_GPIOH INTENCLR: INTENCLR Mask        */

/* -----------------------------  NT_GPIOH_INTTYPESET  ---------------------------- */
#define NT_GPIOH_INTTYPESET_INTTYPESET_Pos    0                                                       /*!< NT_GPIOH INTTYPESET: INTTYPESET Position */
#define NT_GPIOH_INTTYPESET_INTTYPESET_Msk    (0x0000ffffUL << NT_GPIOH_INTTYPESET_INTTYPESET_Pos)    /*!< NT_GPIOH INTTYPESET: INTTYPESET Mask    */

/* -----------------------------  NT_GPIOH_INTTYPECLR  ---------------------------- */
#define NT_GPIOH_INTTYPECLR_INTTYPECLR_Pos    0                                                       /*!< NT_GPIOH INTTYPECLR: INTTYPECLR Position */
#define NT_GPIOH_INTTYPECLR_INTTYPECLR_Msk    (0x0000ffffUL << NT_GPIOH_INTTYPECLR_INTTYPECLR_Pos)    /*!< NT_GPIOH INTTYPECLR: INTTYPECLR Mask    */

/* -----------------------------  NT_GPIOH_INTPOLSET  ----------------------------- */
#define NT_GPIOH_INTPOLSET_INTPOLSET_Pos      0                                                       /*!< NT_GPIOH INTPOLSET: INTPOLSET Position  */
#define NT_GPIOH_INTPOLSET_INTPOLSET_Msk      (0x0000ffffUL << NT_GPIOH_INTPOLSET_INTPOLSET_Pos)      /*!< NT_GPIOH INTPOLSET: INTPOLSET Mask      */

/* -----------------------------  NT_GPIOH_INTPOLCLR  ----------------------------- */
#define NT_GPIOH_INTPOLCLR_INTPOLCLR_Pos      0                                                       /*!< NT_GPIOH INTPOLCLR: INTPOLCLR Position  */
#define NT_GPIOH_INTPOLCLR_INTPOLCLR_Msk      (0x0000ffffUL << NT_GPIOH_INTPOLCLR_INTPOLCLR_Pos)      /*!< NT_GPIOH INTPOLCLR: INTPOLCLR Mask      */

/* -----------------------------  NT_GPIOH_INTSTATUS  ----------------------------- */
#define NT_GPIOH_INTSTATUS_INTSTATUS_Pos      0                                                       /*!< NT_GPIOH INTSTATUS: INTSTATUS Position  */
#define NT_GPIOH_INTSTATUS_INTSTATUS_Msk      (0x0000ffffUL << NT_GPIOH_INTSTATUS_INTSTATUS_Pos)      /*!< NT_GPIOH INTSTATUS: INTSTATUS Mask      */


/* ================================================================================ */
/* ================      struct 'MASKLOWBYTE' Position & Mask      ================ */
/* ================================================================================ */


/* ----------------------  NT_GPIOH_MASKLOWBYTE_MASKLOWBYTE  ---------------------- */
#define NT_GPIOH_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos 0                                                 /*!< NT_GPIOH_MASKLOWBYTE MASKLOWBYTE: MASKLB Position */
#define NT_GPIOH_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Msk (0x000000ffUL << NT_GPIOH_MASKLOWBYTE_MASKLOWBYTE_MASKLB_Pos)/*!< NT_GPIOH_MASKLOWBYTE MASKLOWBYTE: MASKLB Mask */


/* ================================================================================ */
/* ================      struct 'MASKHIGHBYTE' Position & Mask     ================ */
/* ================================================================================ */


/* ---------------------  NT_GPIOH_MASKHIGHBYTE_MASKHIGHBYTE  --------------------- */
#define NT_GPIOH_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos 8                                               /*!< NT_GPIOH_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Position */
#define NT_GPIOH_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Msk (0x000000ffUL << NT_GPIOH_MASKHIGHBYTE_MASKHIGHBYTE_MASKHB_Pos)/*!< NT_GPIOH_MASKHIGHBYTE MASKHIGHBYTE: MASKHB Mask */


/* ================================================================================ */
/* ================     struct 'NT_COMMON_REG' Position & Mask     ================ */
/* ================================================================================ */


/* ---------------------------  NT_COMMON_REG_GPIODEN0  --------------------------- */
#define NT_COMMON_REG_GPIODEN0_PORTA_Pos      0                                                       /*!< NT_COMMON_REG GPIODEN0: PORTA Position  */
#define NT_COMMON_REG_GPIODEN0_PORTA_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODEN0_PORTA_Pos)      /*!< NT_COMMON_REG GPIODEN0: PORTA Mask      */
#define NT_COMMON_REG_GPIODEN0_PORTB_Pos      16                                                      /*!< NT_COMMON_REG GPIODEN0: PORTB Position  */
#define NT_COMMON_REG_GPIODEN0_PORTB_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODEN0_PORTB_Pos)      /*!< NT_COMMON_REG GPIODEN0: PORTB Mask      */

/* ---------------------------  NT_COMMON_REG_GPIODENA  --------------------------- */
#define NT_COMMON_REG_GPIODENA_PORTA_Pos      0                                                       /*!< NT_COMMON_REG GPIODENA: PORTA Position  */
#define NT_COMMON_REG_GPIODENA_PORTA_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODENA_PORTA_Pos)      /*!< NT_COMMON_REG GPIODENA: PORTA Mask      */

/* ---------------------------  NT_COMMON_REG_GPIODENB  --------------------------- */
#define NT_COMMON_REG_GPIODENB_PORTB_Pos      0                                                       /*!< NT_COMMON_REG GPIODENB: PORTB Position  */
#define NT_COMMON_REG_GPIODENB_PORTB_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODENB_PORTB_Pos)      /*!< NT_COMMON_REG GPIODENB: PORTB Mask      */

/* ---------------------------  NT_COMMON_REG_GPIODEN1  --------------------------- */
#define NT_COMMON_REG_GPIODEN1_PORTC_Pos      0                                                       /*!< NT_COMMON_REG GPIODEN1: PORTC Position  */
#define NT_COMMON_REG_GPIODEN1_PORTC_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODEN1_PORTC_Pos)      /*!< NT_COMMON_REG GPIODEN1: PORTC Mask      */
#define NT_COMMON_REG_GPIODEN1_PORTD_Pos      16                                                      /*!< NT_COMMON_REG GPIODEN1: PORTD Position  */
#define NT_COMMON_REG_GPIODEN1_PORTD_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODEN1_PORTD_Pos)      /*!< NT_COMMON_REG GPIODEN1: PORTD Mask      */

/* ---------------------------  NT_COMMON_REG_GPIODENC  --------------------------- */
#define NT_COMMON_REG_GPIODENC_PORTC_Pos      0                                                       /*!< NT_COMMON_REG GPIODENC: PORTC Position  */
#define NT_COMMON_REG_GPIODENC_PORTC_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODENC_PORTC_Pos)      /*!< NT_COMMON_REG GPIODENC: PORTC Mask      */

/* ---------------------------  NT_COMMON_REG_GPIODEND  --------------------------- */
#define NT_COMMON_REG_GPIODEND_PORTD_Pos      0                                                       /*!< NT_COMMON_REG GPIODEND: PORTD Position  */
#define NT_COMMON_REG_GPIODEND_PORTD_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODEND_PORTD_Pos)      /*!< NT_COMMON_REG GPIODEND: PORTD Mask      */

/* ---------------------------  NT_COMMON_REG_GPIODEN2  --------------------------- */
#define NT_COMMON_REG_GPIODEN2_PORTE_Pos      0                                                       /*!< NT_COMMON_REG GPIODEN2: PORTE Position  */
#define NT_COMMON_REG_GPIODEN2_PORTE_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODEN2_PORTE_Pos)      /*!< NT_COMMON_REG GPIODEN2: PORTE Mask      */
#define NT_COMMON_REG_GPIODEN2_PORTF_Pos      16                                                      /*!< NT_COMMON_REG GPIODEN2: PORTF Position  */
#define NT_COMMON_REG_GPIODEN2_PORTF_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODEN2_PORTF_Pos)      /*!< NT_COMMON_REG GPIODEN2: PORTF Mask      */

/* ---------------------------  NT_COMMON_REG_GPIODENE  --------------------------- */
#define NT_COMMON_REG_GPIODENE_PORTE_Pos      0                                                       /*!< NT_COMMON_REG GPIODENE: PORTE Position  */
#define NT_COMMON_REG_GPIODENE_PORTE_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODENE_PORTE_Pos)      /*!< NT_COMMON_REG GPIODENE: PORTE Mask      */

/* ---------------------------  NT_COMMON_REG_GPIODENF  --------------------------- */
#define NT_COMMON_REG_GPIODENF_PORTF_Pos      0                                                       /*!< NT_COMMON_REG GPIODENF: PORTF Position  */
#define NT_COMMON_REG_GPIODENF_PORTF_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODENF_PORTF_Pos)      /*!< NT_COMMON_REG GPIODENF: PORTF Mask      */

/* ---------------------------  NT_COMMON_REG_GPIODEN3  --------------------------- */
#define NT_COMMON_REG_GPIODEN3_PORTG_Pos      0                                                       /*!< NT_COMMON_REG GPIODEN3: PORTG Position  */
#define NT_COMMON_REG_GPIODEN3_PORTG_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODEN3_PORTG_Pos)      /*!< NT_COMMON_REG GPIODEN3: PORTG Mask      */
#define NT_COMMON_REG_GPIODEN3_PORTH_Pos      16                                                      /*!< NT_COMMON_REG GPIODEN3: PORTH Position  */
#define NT_COMMON_REG_GPIODEN3_PORTH_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODEN3_PORTH_Pos)      /*!< NT_COMMON_REG GPIODEN3: PORTH Mask      */

/* ---------------------------  NT_COMMON_REG_GPIODENG  --------------------------- */
#define NT_COMMON_REG_GPIODENG_PORTG_Pos      0                                                       /*!< NT_COMMON_REG GPIODENG: PORTG Position  */
#define NT_COMMON_REG_GPIODENG_PORTG_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODENG_PORTG_Pos)      /*!< NT_COMMON_REG GPIODENG: PORTG Mask      */

/* ---------------------------  NT_COMMON_REG_GPIODENH  --------------------------- */
#define NT_COMMON_REG_GPIODENH_PORTH_Pos      0                                                       /*!< NT_COMMON_REG GPIODENH: PORTH Position  */
#define NT_COMMON_REG_GPIODENH_PORTH_Msk      (0x0000ffffUL << NT_COMMON_REG_GPIODENH_PORTH_Pos)      /*!< NT_COMMON_REG GPIODENH: PORTH Mask      */

/* ---------------------------  NT_COMMON_REG_GPIOPCTLA  -------------------------- */
#define NT_COMMON_REG_GPIOPCTLA_PIN0_Pos      0                                                       /*!< NT_COMMON_REG GPIOPCTLA: PIN0 Position  */
#define NT_COMMON_REG_GPIOPCTLA_PIN0_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN0_Pos)            /*!< NT_COMMON_REG GPIOPCTLA: PIN0 Mask      */
#define NT_COMMON_REG_GPIOPCTLA_PIN1_Pos      2                                                       /*!< NT_COMMON_REG GPIOPCTLA: PIN1 Position  */
#define NT_COMMON_REG_GPIOPCTLA_PIN1_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN1_Pos)            /*!< NT_COMMON_REG GPIOPCTLA: PIN1 Mask      */
#define NT_COMMON_REG_GPIOPCTLA_PIN2_Pos      4                                                       /*!< NT_COMMON_REG GPIOPCTLA: PIN2 Position  */
#define NT_COMMON_REG_GPIOPCTLA_PIN2_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN2_Pos)            /*!< NT_COMMON_REG GPIOPCTLA: PIN2 Mask      */
#define NT_COMMON_REG_GPIOPCTLA_PIN3_Pos      6                                                       /*!< NT_COMMON_REG GPIOPCTLA: PIN3 Position  */
#define NT_COMMON_REG_GPIOPCTLA_PIN3_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN3_Pos)            /*!< NT_COMMON_REG GPIOPCTLA: PIN3 Mask      */
#define NT_COMMON_REG_GPIOPCTLA_PIN4_Pos      8                                                       /*!< NT_COMMON_REG GPIOPCTLA: PIN4 Position  */
#define NT_COMMON_REG_GPIOPCTLA_PIN4_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN4_Pos)            /*!< NT_COMMON_REG GPIOPCTLA: PIN4 Mask      */
#define NT_COMMON_REG_GPIOPCTLA_PIN5_Pos      10                                                      /*!< NT_COMMON_REG GPIOPCTLA: PIN5 Position  */
#define NT_COMMON_REG_GPIOPCTLA_PIN5_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN5_Pos)            /*!< NT_COMMON_REG GPIOPCTLA: PIN5 Mask      */
#define NT_COMMON_REG_GPIOPCTLA_PIN6_Pos      12                                                      /*!< NT_COMMON_REG GPIOPCTLA: PIN6 Position  */
#define NT_COMMON_REG_GPIOPCTLA_PIN6_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN6_Pos)            /*!< NT_COMMON_REG GPIOPCTLA: PIN6 Mask      */
#define NT_COMMON_REG_GPIOPCTLA_PIN7_Pos      14                                                      /*!< NT_COMMON_REG GPIOPCTLA: PIN7 Position  */
#define NT_COMMON_REG_GPIOPCTLA_PIN7_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN7_Pos)            /*!< NT_COMMON_REG GPIOPCTLA: PIN7 Mask      */
#define NT_COMMON_REG_GPIOPCTLA_PIN8_Pos      16                                                      /*!< NT_COMMON_REG GPIOPCTLA: PIN8 Position  */
#define NT_COMMON_REG_GPIOPCTLA_PIN8_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN8_Pos)            /*!< NT_COMMON_REG GPIOPCTLA: PIN8 Mask      */
#define NT_COMMON_REG_GPIOPCTLA_PIN9_Pos      18                                                      /*!< NT_COMMON_REG GPIOPCTLA: PIN9 Position  */
#define NT_COMMON_REG_GPIOPCTLA_PIN9_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN9_Pos)            /*!< NT_COMMON_REG GPIOPCTLA: PIN9 Mask      */
#define NT_COMMON_REG_GPIOPCTLA_PIN10_Pos     20                                                      /*!< NT_COMMON_REG GPIOPCTLA: PIN10 Position */
#define NT_COMMON_REG_GPIOPCTLA_PIN10_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN10_Pos)           /*!< NT_COMMON_REG GPIOPCTLA: PIN10 Mask     */
#define NT_COMMON_REG_GPIOPCTLA_PIN11_Pos     22                                                      /*!< NT_COMMON_REG GPIOPCTLA: PIN11 Position */
#define NT_COMMON_REG_GPIOPCTLA_PIN11_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN11_Pos)           /*!< NT_COMMON_REG GPIOPCTLA: PIN11 Mask     */
#define NT_COMMON_REG_GPIOPCTLA_PIN12_Pos     24                                                      /*!< NT_COMMON_REG GPIOPCTLA: PIN12 Position */
#define NT_COMMON_REG_GPIOPCTLA_PIN12_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN12_Pos)           /*!< NT_COMMON_REG GPIOPCTLA: PIN12 Mask     */
#define NT_COMMON_REG_GPIOPCTLA_PIN13_Pos     26                                                      /*!< NT_COMMON_REG GPIOPCTLA: PIN13 Position */
#define NT_COMMON_REG_GPIOPCTLA_PIN13_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN13_Pos)           /*!< NT_COMMON_REG GPIOPCTLA: PIN13 Mask     */
#define NT_COMMON_REG_GPIOPCTLA_PIN14_Pos     28                                                      /*!< NT_COMMON_REG GPIOPCTLA: PIN14 Position */
#define NT_COMMON_REG_GPIOPCTLA_PIN14_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN14_Pos)           /*!< NT_COMMON_REG GPIOPCTLA: PIN14 Mask     */
#define NT_COMMON_REG_GPIOPCTLA_PIN15_Pos     30                                                      /*!< NT_COMMON_REG GPIOPCTLA: PIN15 Position */
#define NT_COMMON_REG_GPIOPCTLA_PIN15_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLA_PIN15_Pos)           /*!< NT_COMMON_REG GPIOPCTLA: PIN15 Mask     */

/* ---------------------------  NT_COMMON_REG_GPIOPCTLB  -------------------------- */
#define NT_COMMON_REG_GPIOPCTLB_PIN0_Pos      0                                                       /*!< NT_COMMON_REG GPIOPCTLB: PIN0 Position  */
#define NT_COMMON_REG_GPIOPCTLB_PIN0_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN0_Pos)            /*!< NT_COMMON_REG GPIOPCTLB: PIN0 Mask      */
#define NT_COMMON_REG_GPIOPCTLB_PIN1_Pos      2                                                       /*!< NT_COMMON_REG GPIOPCTLB: PIN1 Position  */
#define NT_COMMON_REG_GPIOPCTLB_PIN1_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN1_Pos)            /*!< NT_COMMON_REG GPIOPCTLB: PIN1 Mask      */
#define NT_COMMON_REG_GPIOPCTLB_PIN2_Pos      4                                                       /*!< NT_COMMON_REG GPIOPCTLB: PIN2 Position  */
#define NT_COMMON_REG_GPIOPCTLB_PIN2_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN2_Pos)            /*!< NT_COMMON_REG GPIOPCTLB: PIN2 Mask      */
#define NT_COMMON_REG_GPIOPCTLB_PIN3_Pos      6                                                       /*!< NT_COMMON_REG GPIOPCTLB: PIN3 Position  */
#define NT_COMMON_REG_GPIOPCTLB_PIN3_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN3_Pos)            /*!< NT_COMMON_REG GPIOPCTLB: PIN3 Mask      */
#define NT_COMMON_REG_GPIOPCTLB_PIN4_Pos      8                                                       /*!< NT_COMMON_REG GPIOPCTLB: PIN4 Position  */
#define NT_COMMON_REG_GPIOPCTLB_PIN4_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN4_Pos)            /*!< NT_COMMON_REG GPIOPCTLB: PIN4 Mask      */
#define NT_COMMON_REG_GPIOPCTLB_PIN5_Pos      10                                                      /*!< NT_COMMON_REG GPIOPCTLB: PIN5 Position  */
#define NT_COMMON_REG_GPIOPCTLB_PIN5_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN5_Pos)            /*!< NT_COMMON_REG GPIOPCTLB: PIN5 Mask      */
#define NT_COMMON_REG_GPIOPCTLB_PIN6_Pos      12                                                      /*!< NT_COMMON_REG GPIOPCTLB: PIN6 Position  */
#define NT_COMMON_REG_GPIOPCTLB_PIN6_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN6_Pos)            /*!< NT_COMMON_REG GPIOPCTLB: PIN6 Mask      */
#define NT_COMMON_REG_GPIOPCTLB_PIN7_Pos      14                                                      /*!< NT_COMMON_REG GPIOPCTLB: PIN7 Position  */
#define NT_COMMON_REG_GPIOPCTLB_PIN7_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN7_Pos)            /*!< NT_COMMON_REG GPIOPCTLB: PIN7 Mask      */
#define NT_COMMON_REG_GPIOPCTLB_PIN8_Pos      16                                                      /*!< NT_COMMON_REG GPIOPCTLB: PIN8 Position  */
#define NT_COMMON_REG_GPIOPCTLB_PIN8_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN8_Pos)            /*!< NT_COMMON_REG GPIOPCTLB: PIN8 Mask      */
#define NT_COMMON_REG_GPIOPCTLB_PIN9_Pos      18                                                      /*!< NT_COMMON_REG GPIOPCTLB: PIN9 Position  */
#define NT_COMMON_REG_GPIOPCTLB_PIN9_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN9_Pos)            /*!< NT_COMMON_REG GPIOPCTLB: PIN9 Mask      */
#define NT_COMMON_REG_GPIOPCTLB_PIN10_Pos     20                                                      /*!< NT_COMMON_REG GPIOPCTLB: PIN10 Position */
#define NT_COMMON_REG_GPIOPCTLB_PIN10_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN10_Pos)           /*!< NT_COMMON_REG GPIOPCTLB: PIN10 Mask     */
#define NT_COMMON_REG_GPIOPCTLB_PIN11_Pos     22                                                      /*!< NT_COMMON_REG GPIOPCTLB: PIN11 Position */
#define NT_COMMON_REG_GPIOPCTLB_PIN11_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN11_Pos)           /*!< NT_COMMON_REG GPIOPCTLB: PIN11 Mask     */
#define NT_COMMON_REG_GPIOPCTLB_PIN12_Pos     24                                                      /*!< NT_COMMON_REG GPIOPCTLB: PIN12 Position */
#define NT_COMMON_REG_GPIOPCTLB_PIN12_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN12_Pos)           /*!< NT_COMMON_REG GPIOPCTLB: PIN12 Mask     */
#define NT_COMMON_REG_GPIOPCTLB_PIN13_Pos     26                                                      /*!< NT_COMMON_REG GPIOPCTLB: PIN13 Position */
#define NT_COMMON_REG_GPIOPCTLB_PIN13_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN13_Pos)           /*!< NT_COMMON_REG GPIOPCTLB: PIN13 Mask     */
#define NT_COMMON_REG_GPIOPCTLB_PIN14_Pos     28                                                      /*!< NT_COMMON_REG GPIOPCTLB: PIN14 Position */
#define NT_COMMON_REG_GPIOPCTLB_PIN14_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN14_Pos)           /*!< NT_COMMON_REG GPIOPCTLB: PIN14 Mask     */
#define NT_COMMON_REG_GPIOPCTLB_PIN15_Pos     30                                                      /*!< NT_COMMON_REG GPIOPCTLB: PIN15 Position */
#define NT_COMMON_REG_GPIOPCTLB_PIN15_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLB_PIN15_Pos)           /*!< NT_COMMON_REG GPIOPCTLB: PIN15 Mask     */

/* ---------------------------  NT_COMMON_REG_GPIOPCTLC  -------------------------- */
#define NT_COMMON_REG_GPIOPCTLC_PIN0_Pos      0                                                       /*!< NT_COMMON_REG GPIOPCTLC: PIN0 Position  */
#define NT_COMMON_REG_GPIOPCTLC_PIN0_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN0_Pos)            /*!< NT_COMMON_REG GPIOPCTLC: PIN0 Mask      */
#define NT_COMMON_REG_GPIOPCTLC_PIN1_Pos      2                                                       /*!< NT_COMMON_REG GPIOPCTLC: PIN1 Position  */
#define NT_COMMON_REG_GPIOPCTLC_PIN1_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN1_Pos)            /*!< NT_COMMON_REG GPIOPCTLC: PIN1 Mask      */
#define NT_COMMON_REG_GPIOPCTLC_PIN2_Pos      4                                                       /*!< NT_COMMON_REG GPIOPCTLC: PIN2 Position  */
#define NT_COMMON_REG_GPIOPCTLC_PIN2_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN2_Pos)            /*!< NT_COMMON_REG GPIOPCTLC: PIN2 Mask      */
#define NT_COMMON_REG_GPIOPCTLC_PIN3_Pos      6                                                       /*!< NT_COMMON_REG GPIOPCTLC: PIN3 Position  */
#define NT_COMMON_REG_GPIOPCTLC_PIN3_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN3_Pos)            /*!< NT_COMMON_REG GPIOPCTLC: PIN3 Mask      */
#define NT_COMMON_REG_GPIOPCTLC_PIN4_Pos      8                                                       /*!< NT_COMMON_REG GPIOPCTLC: PIN4 Position  */
#define NT_COMMON_REG_GPIOPCTLC_PIN4_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN4_Pos)            /*!< NT_COMMON_REG GPIOPCTLC: PIN4 Mask      */
#define NT_COMMON_REG_GPIOPCTLC_PIN5_Pos      10                                                      /*!< NT_COMMON_REG GPIOPCTLC: PIN5 Position  */
#define NT_COMMON_REG_GPIOPCTLC_PIN5_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN5_Pos)            /*!< NT_COMMON_REG GPIOPCTLC: PIN5 Mask      */
#define NT_COMMON_REG_GPIOPCTLC_PIN6_Pos      12                                                      /*!< NT_COMMON_REG GPIOPCTLC: PIN6 Position  */
#define NT_COMMON_REG_GPIOPCTLC_PIN6_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN6_Pos)            /*!< NT_COMMON_REG GPIOPCTLC: PIN6 Mask      */
#define NT_COMMON_REG_GPIOPCTLC_PIN7_Pos      14                                                      /*!< NT_COMMON_REG GPIOPCTLC: PIN7 Position  */
#define NT_COMMON_REG_GPIOPCTLC_PIN7_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN7_Pos)            /*!< NT_COMMON_REG GPIOPCTLC: PIN7 Mask      */
#define NT_COMMON_REG_GPIOPCTLC_PIN8_Pos      16                                                      /*!< NT_COMMON_REG GPIOPCTLC: PIN8 Position  */
#define NT_COMMON_REG_GPIOPCTLC_PIN8_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN8_Pos)            /*!< NT_COMMON_REG GPIOPCTLC: PIN8 Mask      */
#define NT_COMMON_REG_GPIOPCTLC_PIN9_Pos      18                                                      /*!< NT_COMMON_REG GPIOPCTLC: PIN9 Position  */
#define NT_COMMON_REG_GPIOPCTLC_PIN9_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN9_Pos)            /*!< NT_COMMON_REG GPIOPCTLC: PIN9 Mask      */
#define NT_COMMON_REG_GPIOPCTLC_PIN10_Pos     20                                                      /*!< NT_COMMON_REG GPIOPCTLC: PIN10 Position */
#define NT_COMMON_REG_GPIOPCTLC_PIN10_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN10_Pos)           /*!< NT_COMMON_REG GPIOPCTLC: PIN10 Mask     */
#define NT_COMMON_REG_GPIOPCTLC_PIN11_Pos     22                                                      /*!< NT_COMMON_REG GPIOPCTLC: PIN11 Position */
#define NT_COMMON_REG_GPIOPCTLC_PIN11_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN11_Pos)           /*!< NT_COMMON_REG GPIOPCTLC: PIN11 Mask     */
#define NT_COMMON_REG_GPIOPCTLC_PIN12_Pos     24                                                      /*!< NT_COMMON_REG GPIOPCTLC: PIN12 Position */
#define NT_COMMON_REG_GPIOPCTLC_PIN12_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN12_Pos)           /*!< NT_COMMON_REG GPIOPCTLC: PIN12 Mask     */
#define NT_COMMON_REG_GPIOPCTLC_PIN13_Pos     26                                                      /*!< NT_COMMON_REG GPIOPCTLC: PIN13 Position */
#define NT_COMMON_REG_GPIOPCTLC_PIN13_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN13_Pos)           /*!< NT_COMMON_REG GPIOPCTLC: PIN13 Mask     */
#define NT_COMMON_REG_GPIOPCTLC_PIN14_Pos     28                                                      /*!< NT_COMMON_REG GPIOPCTLC: PIN14 Position */
#define NT_COMMON_REG_GPIOPCTLC_PIN14_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN14_Pos)           /*!< NT_COMMON_REG GPIOPCTLC: PIN14 Mask     */
#define NT_COMMON_REG_GPIOPCTLC_PIN15_Pos     30                                                      /*!< NT_COMMON_REG GPIOPCTLC: PIN15 Position */
#define NT_COMMON_REG_GPIOPCTLC_PIN15_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLC_PIN15_Pos)           /*!< NT_COMMON_REG GPIOPCTLC: PIN15 Mask     */

/* ---------------------------  NT_COMMON_REG_GPIOPCTLD  -------------------------- */
#define NT_COMMON_REG_GPIOPCTLD_PIN0_Pos      0                                                       /*!< NT_COMMON_REG GPIOPCTLD: PIN0 Position  */
#define NT_COMMON_REG_GPIOPCTLD_PIN0_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN0_Pos)            /*!< NT_COMMON_REG GPIOPCTLD: PIN0 Mask      */
#define NT_COMMON_REG_GPIOPCTLD_PIN1_Pos      2                                                       /*!< NT_COMMON_REG GPIOPCTLD: PIN1 Position  */
#define NT_COMMON_REG_GPIOPCTLD_PIN1_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN1_Pos)            /*!< NT_COMMON_REG GPIOPCTLD: PIN1 Mask      */
#define NT_COMMON_REG_GPIOPCTLD_PIN2_Pos      4                                                       /*!< NT_COMMON_REG GPIOPCTLD: PIN2 Position  */
#define NT_COMMON_REG_GPIOPCTLD_PIN2_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN2_Pos)            /*!< NT_COMMON_REG GPIOPCTLD: PIN2 Mask      */
#define NT_COMMON_REG_GPIOPCTLD_PIN3_Pos      6                                                       /*!< NT_COMMON_REG GPIOPCTLD: PIN3 Position  */
#define NT_COMMON_REG_GPIOPCTLD_PIN3_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN3_Pos)            /*!< NT_COMMON_REG GPIOPCTLD: PIN3 Mask      */
#define NT_COMMON_REG_GPIOPCTLD_PIN4_Pos      8                                                       /*!< NT_COMMON_REG GPIOPCTLD: PIN4 Position  */
#define NT_COMMON_REG_GPIOPCTLD_PIN4_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN4_Pos)            /*!< NT_COMMON_REG GPIOPCTLD: PIN4 Mask      */
#define NT_COMMON_REG_GPIOPCTLD_PIN5_Pos      10                                                      /*!< NT_COMMON_REG GPIOPCTLD: PIN5 Position  */
#define NT_COMMON_REG_GPIOPCTLD_PIN5_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN5_Pos)            /*!< NT_COMMON_REG GPIOPCTLD: PIN5 Mask      */
#define NT_COMMON_REG_GPIOPCTLD_PIN6_Pos      12                                                      /*!< NT_COMMON_REG GPIOPCTLD: PIN6 Position  */
#define NT_COMMON_REG_GPIOPCTLD_PIN6_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN6_Pos)            /*!< NT_COMMON_REG GPIOPCTLD: PIN6 Mask      */
#define NT_COMMON_REG_GPIOPCTLD_PIN7_Pos      14                                                      /*!< NT_COMMON_REG GPIOPCTLD: PIN7 Position  */
#define NT_COMMON_REG_GPIOPCTLD_PIN7_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN7_Pos)            /*!< NT_COMMON_REG GPIOPCTLD: PIN7 Mask      */
#define NT_COMMON_REG_GPIOPCTLD_PIN8_Pos      16                                                      /*!< NT_COMMON_REG GPIOPCTLD: PIN8 Position  */
#define NT_COMMON_REG_GPIOPCTLD_PIN8_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN8_Pos)            /*!< NT_COMMON_REG GPIOPCTLD: PIN8 Mask      */
#define NT_COMMON_REG_GPIOPCTLD_PIN9_Pos      18                                                      /*!< NT_COMMON_REG GPIOPCTLD: PIN9 Position  */
#define NT_COMMON_REG_GPIOPCTLD_PIN9_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN9_Pos)            /*!< NT_COMMON_REG GPIOPCTLD: PIN9 Mask      */
#define NT_COMMON_REG_GPIOPCTLD_PIN10_Pos     20                                                      /*!< NT_COMMON_REG GPIOPCTLD: PIN10 Position */
#define NT_COMMON_REG_GPIOPCTLD_PIN10_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN10_Pos)           /*!< NT_COMMON_REG GPIOPCTLD: PIN10 Mask     */
#define NT_COMMON_REG_GPIOPCTLD_PIN11_Pos     22                                                      /*!< NT_COMMON_REG GPIOPCTLD: PIN11 Position */
#define NT_COMMON_REG_GPIOPCTLD_PIN11_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN11_Pos)           /*!< NT_COMMON_REG GPIOPCTLD: PIN11 Mask     */
#define NT_COMMON_REG_GPIOPCTLD_PIN12_Pos     24                                                      /*!< NT_COMMON_REG GPIOPCTLD: PIN12 Position */
#define NT_COMMON_REG_GPIOPCTLD_PIN12_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN12_Pos)           /*!< NT_COMMON_REG GPIOPCTLD: PIN12 Mask     */
#define NT_COMMON_REG_GPIOPCTLD_PIN13_Pos     26                                                      /*!< NT_COMMON_REG GPIOPCTLD: PIN13 Position */
#define NT_COMMON_REG_GPIOPCTLD_PIN13_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN13_Pos)           /*!< NT_COMMON_REG GPIOPCTLD: PIN13 Mask     */
#define NT_COMMON_REG_GPIOPCTLD_PIN14_Pos     28                                                      /*!< NT_COMMON_REG GPIOPCTLD: PIN14 Position */
#define NT_COMMON_REG_GPIOPCTLD_PIN14_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN14_Pos)           /*!< NT_COMMON_REG GPIOPCTLD: PIN14 Mask     */
#define NT_COMMON_REG_GPIOPCTLD_PIN15_Pos     30                                                      /*!< NT_COMMON_REG GPIOPCTLD: PIN15 Position */
#define NT_COMMON_REG_GPIOPCTLD_PIN15_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLD_PIN15_Pos)           /*!< NT_COMMON_REG GPIOPCTLD: PIN15 Mask     */

/* ---------------------------  NT_COMMON_REG_GPIOPCTLE  -------------------------- */
#define NT_COMMON_REG_GPIOPCTLE_PIN0_Pos      0                                                       /*!< NT_COMMON_REG GPIOPCTLE: PIN0 Position  */
#define NT_COMMON_REG_GPIOPCTLE_PIN0_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN0_Pos)            /*!< NT_COMMON_REG GPIOPCTLE: PIN0 Mask      */
#define NT_COMMON_REG_GPIOPCTLE_PIN1_Pos      2                                                       /*!< NT_COMMON_REG GPIOPCTLE: PIN1 Position  */
#define NT_COMMON_REG_GPIOPCTLE_PIN1_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN1_Pos)            /*!< NT_COMMON_REG GPIOPCTLE: PIN1 Mask      */
#define NT_COMMON_REG_GPIOPCTLE_PIN2_Pos      4                                                       /*!< NT_COMMON_REG GPIOPCTLE: PIN2 Position  */
#define NT_COMMON_REG_GPIOPCTLE_PIN2_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN2_Pos)            /*!< NT_COMMON_REG GPIOPCTLE: PIN2 Mask      */
#define NT_COMMON_REG_GPIOPCTLE_PIN3_Pos      6                                                       /*!< NT_COMMON_REG GPIOPCTLE: PIN3 Position  */
#define NT_COMMON_REG_GPIOPCTLE_PIN3_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN3_Pos)            /*!< NT_COMMON_REG GPIOPCTLE: PIN3 Mask      */
#define NT_COMMON_REG_GPIOPCTLE_PIN4_Pos      8                                                       /*!< NT_COMMON_REG GPIOPCTLE: PIN4 Position  */
#define NT_COMMON_REG_GPIOPCTLE_PIN4_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN4_Pos)            /*!< NT_COMMON_REG GPIOPCTLE: PIN4 Mask      */
#define NT_COMMON_REG_GPIOPCTLE_PIN5_Pos      10                                                      /*!< NT_COMMON_REG GPIOPCTLE: PIN5 Position  */
#define NT_COMMON_REG_GPIOPCTLE_PIN5_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN5_Pos)            /*!< NT_COMMON_REG GPIOPCTLE: PIN5 Mask      */
#define NT_COMMON_REG_GPIOPCTLE_PIN6_Pos      12                                                      /*!< NT_COMMON_REG GPIOPCTLE: PIN6 Position  */
#define NT_COMMON_REG_GPIOPCTLE_PIN6_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN6_Pos)            /*!< NT_COMMON_REG GPIOPCTLE: PIN6 Mask      */
#define NT_COMMON_REG_GPIOPCTLE_PIN7_Pos      14                                                      /*!< NT_COMMON_REG GPIOPCTLE: PIN7 Position  */
#define NT_COMMON_REG_GPIOPCTLE_PIN7_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN7_Pos)            /*!< NT_COMMON_REG GPIOPCTLE: PIN7 Mask      */
#define NT_COMMON_REG_GPIOPCTLE_PIN8_Pos      16                                                      /*!< NT_COMMON_REG GPIOPCTLE: PIN8 Position  */
#define NT_COMMON_REG_GPIOPCTLE_PIN8_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN8_Pos)            /*!< NT_COMMON_REG GPIOPCTLE: PIN8 Mask      */
#define NT_COMMON_REG_GPIOPCTLE_PIN9_Pos      18                                                      /*!< NT_COMMON_REG GPIOPCTLE: PIN9 Position  */
#define NT_COMMON_REG_GPIOPCTLE_PIN9_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN9_Pos)            /*!< NT_COMMON_REG GPIOPCTLE: PIN9 Mask      */
#define NT_COMMON_REG_GPIOPCTLE_PIN10_Pos     20                                                      /*!< NT_COMMON_REG GPIOPCTLE: PIN10 Position */
#define NT_COMMON_REG_GPIOPCTLE_PIN10_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN10_Pos)           /*!< NT_COMMON_REG GPIOPCTLE: PIN10 Mask     */
#define NT_COMMON_REG_GPIOPCTLE_PIN11_Pos     22                                                      /*!< NT_COMMON_REG GPIOPCTLE: PIN11 Position */
#define NT_COMMON_REG_GPIOPCTLE_PIN11_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN11_Pos)           /*!< NT_COMMON_REG GPIOPCTLE: PIN11 Mask     */
#define NT_COMMON_REG_GPIOPCTLE_PIN12_Pos     24                                                      /*!< NT_COMMON_REG GPIOPCTLE: PIN12 Position */
#define NT_COMMON_REG_GPIOPCTLE_PIN12_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN12_Pos)           /*!< NT_COMMON_REG GPIOPCTLE: PIN12 Mask     */
#define NT_COMMON_REG_GPIOPCTLE_PIN13_Pos     26                                                      /*!< NT_COMMON_REG GPIOPCTLE: PIN13 Position */
#define NT_COMMON_REG_GPIOPCTLE_PIN13_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN13_Pos)           /*!< NT_COMMON_REG GPIOPCTLE: PIN13 Mask     */
#define NT_COMMON_REG_GPIOPCTLE_PIN14_Pos     28                                                      /*!< NT_COMMON_REG GPIOPCTLE: PIN14 Position */
#define NT_COMMON_REG_GPIOPCTLE_PIN14_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN14_Pos)           /*!< NT_COMMON_REG GPIOPCTLE: PIN14 Mask     */
#define NT_COMMON_REG_GPIOPCTLE_PIN15_Pos     30                                                      /*!< NT_COMMON_REG GPIOPCTLE: PIN15 Position */
#define NT_COMMON_REG_GPIOPCTLE_PIN15_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLE_PIN15_Pos)           /*!< NT_COMMON_REG GPIOPCTLE: PIN15 Mask     */

/* ---------------------------  NT_COMMON_REG_GPIOPCTLF  -------------------------- */
#define NT_COMMON_REG_GPIOPCTLF_PIN0_Pos      0                                                       /*!< NT_COMMON_REG GPIOPCTLF: PIN0 Position  */
#define NT_COMMON_REG_GPIOPCTLF_PIN0_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN0_Pos)            /*!< NT_COMMON_REG GPIOPCTLF: PIN0 Mask      */
#define NT_COMMON_REG_GPIOPCTLF_PIN1_Pos      2                                                       /*!< NT_COMMON_REG GPIOPCTLF: PIN1 Position  */
#define NT_COMMON_REG_GPIOPCTLF_PIN1_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN1_Pos)            /*!< NT_COMMON_REG GPIOPCTLF: PIN1 Mask      */
#define NT_COMMON_REG_GPIOPCTLF_PIN2_Pos      4                                                       /*!< NT_COMMON_REG GPIOPCTLF: PIN2 Position  */
#define NT_COMMON_REG_GPIOPCTLF_PIN2_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN2_Pos)            /*!< NT_COMMON_REG GPIOPCTLF: PIN2 Mask      */
#define NT_COMMON_REG_GPIOPCTLF_PIN3_Pos      6                                                       /*!< NT_COMMON_REG GPIOPCTLF: PIN3 Position  */
#define NT_COMMON_REG_GPIOPCTLF_PIN3_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN3_Pos)            /*!< NT_COMMON_REG GPIOPCTLF: PIN3 Mask      */
#define NT_COMMON_REG_GPIOPCTLF_PIN4_Pos      8                                                       /*!< NT_COMMON_REG GPIOPCTLF: PIN4 Position  */
#define NT_COMMON_REG_GPIOPCTLF_PIN4_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN4_Pos)            /*!< NT_COMMON_REG GPIOPCTLF: PIN4 Mask      */
#define NT_COMMON_REG_GPIOPCTLF_PIN5_Pos      10                                                      /*!< NT_COMMON_REG GPIOPCTLF: PIN5 Position  */
#define NT_COMMON_REG_GPIOPCTLF_PIN5_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN5_Pos)            /*!< NT_COMMON_REG GPIOPCTLF: PIN5 Mask      */
#define NT_COMMON_REG_GPIOPCTLF_PIN6_Pos      12                                                      /*!< NT_COMMON_REG GPIOPCTLF: PIN6 Position  */
#define NT_COMMON_REG_GPIOPCTLF_PIN6_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN6_Pos)            /*!< NT_COMMON_REG GPIOPCTLF: PIN6 Mask      */
#define NT_COMMON_REG_GPIOPCTLF_PIN7_Pos      14                                                      /*!< NT_COMMON_REG GPIOPCTLF: PIN7 Position  */
#define NT_COMMON_REG_GPIOPCTLF_PIN7_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN7_Pos)            /*!< NT_COMMON_REG GPIOPCTLF: PIN7 Mask      */
#define NT_COMMON_REG_GPIOPCTLF_PIN8_Pos      16                                                      /*!< NT_COMMON_REG GPIOPCTLF: PIN8 Position  */
#define NT_COMMON_REG_GPIOPCTLF_PIN8_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN8_Pos)            /*!< NT_COMMON_REG GPIOPCTLF: PIN8 Mask      */
#define NT_COMMON_REG_GPIOPCTLF_PIN9_Pos      18                                                      /*!< NT_COMMON_REG GPIOPCTLF: PIN9 Position  */
#define NT_COMMON_REG_GPIOPCTLF_PIN9_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN9_Pos)            /*!< NT_COMMON_REG GPIOPCTLF: PIN9 Mask      */
#define NT_COMMON_REG_GPIOPCTLF_PIN10_Pos     20                                                      /*!< NT_COMMON_REG GPIOPCTLF: PIN10 Position */
#define NT_COMMON_REG_GPIOPCTLF_PIN10_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN10_Pos)           /*!< NT_COMMON_REG GPIOPCTLF: PIN10 Mask     */
#define NT_COMMON_REG_GPIOPCTLF_PIN11_Pos     22                                                      /*!< NT_COMMON_REG GPIOPCTLF: PIN11 Position */
#define NT_COMMON_REG_GPIOPCTLF_PIN11_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN11_Pos)           /*!< NT_COMMON_REG GPIOPCTLF: PIN11 Mask     */
#define NT_COMMON_REG_GPIOPCTLF_PIN12_Pos     24                                                      /*!< NT_COMMON_REG GPIOPCTLF: PIN12 Position */
#define NT_COMMON_REG_GPIOPCTLF_PIN12_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN12_Pos)           /*!< NT_COMMON_REG GPIOPCTLF: PIN12 Mask     */
#define NT_COMMON_REG_GPIOPCTLF_PIN13_Pos     26                                                      /*!< NT_COMMON_REG GPIOPCTLF: PIN13 Position */
#define NT_COMMON_REG_GPIOPCTLF_PIN13_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN13_Pos)           /*!< NT_COMMON_REG GPIOPCTLF: PIN13 Mask     */
#define NT_COMMON_REG_GPIOPCTLF_PIN14_Pos     28                                                      /*!< NT_COMMON_REG GPIOPCTLF: PIN14 Position */
#define NT_COMMON_REG_GPIOPCTLF_PIN14_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN14_Pos)           /*!< NT_COMMON_REG GPIOPCTLF: PIN14 Mask     */
#define NT_COMMON_REG_GPIOPCTLF_PIN15_Pos     30                                                      /*!< NT_COMMON_REG GPIOPCTLF: PIN15 Position */
#define NT_COMMON_REG_GPIOPCTLF_PIN15_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLF_PIN15_Pos)           /*!< NT_COMMON_REG GPIOPCTLF: PIN15 Mask     */

/* ---------------------------  NT_COMMON_REG_GPIOPCTLG  -------------------------- */
#define NT_COMMON_REG_GPIOPCTLG_PIN0_Pos      0                                                       /*!< NT_COMMON_REG GPIOPCTLG: PIN0 Position  */
#define NT_COMMON_REG_GPIOPCTLG_PIN0_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN0_Pos)            /*!< NT_COMMON_REG GPIOPCTLG: PIN0 Mask      */
#define NT_COMMON_REG_GPIOPCTLG_PIN1_Pos      2                                                       /*!< NT_COMMON_REG GPIOPCTLG: PIN1 Position  */
#define NT_COMMON_REG_GPIOPCTLG_PIN1_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN1_Pos)            /*!< NT_COMMON_REG GPIOPCTLG: PIN1 Mask      */
#define NT_COMMON_REG_GPIOPCTLG_PIN2_Pos      4                                                       /*!< NT_COMMON_REG GPIOPCTLG: PIN2 Position  */
#define NT_COMMON_REG_GPIOPCTLG_PIN2_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN2_Pos)            /*!< NT_COMMON_REG GPIOPCTLG: PIN2 Mask      */
#define NT_COMMON_REG_GPIOPCTLG_PIN3_Pos      6                                                       /*!< NT_COMMON_REG GPIOPCTLG: PIN3 Position  */
#define NT_COMMON_REG_GPIOPCTLG_PIN3_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN3_Pos)            /*!< NT_COMMON_REG GPIOPCTLG: PIN3 Mask      */
#define NT_COMMON_REG_GPIOPCTLG_PIN4_Pos      8                                                       /*!< NT_COMMON_REG GPIOPCTLG: PIN4 Position  */
#define NT_COMMON_REG_GPIOPCTLG_PIN4_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN4_Pos)            /*!< NT_COMMON_REG GPIOPCTLG: PIN4 Mask      */
#define NT_COMMON_REG_GPIOPCTLG_PIN5_Pos      10                                                      /*!< NT_COMMON_REG GPIOPCTLG: PIN5 Position  */
#define NT_COMMON_REG_GPIOPCTLG_PIN5_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN5_Pos)            /*!< NT_COMMON_REG GPIOPCTLG: PIN5 Mask      */
#define NT_COMMON_REG_GPIOPCTLG_PIN6_Pos      12                                                      /*!< NT_COMMON_REG GPIOPCTLG: PIN6 Position  */
#define NT_COMMON_REG_GPIOPCTLG_PIN6_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN6_Pos)            /*!< NT_COMMON_REG GPIOPCTLG: PIN6 Mask      */
#define NT_COMMON_REG_GPIOPCTLG_PIN7_Pos      14                                                      /*!< NT_COMMON_REG GPIOPCTLG: PIN7 Position  */
#define NT_COMMON_REG_GPIOPCTLG_PIN7_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN7_Pos)            /*!< NT_COMMON_REG GPIOPCTLG: PIN7 Mask      */
#define NT_COMMON_REG_GPIOPCTLG_PIN8_Pos      16                                                      /*!< NT_COMMON_REG GPIOPCTLG: PIN8 Position  */
#define NT_COMMON_REG_GPIOPCTLG_PIN8_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN8_Pos)            /*!< NT_COMMON_REG GPIOPCTLG: PIN8 Mask      */
#define NT_COMMON_REG_GPIOPCTLG_PIN9_Pos      18                                                      /*!< NT_COMMON_REG GPIOPCTLG: PIN9 Position  */
#define NT_COMMON_REG_GPIOPCTLG_PIN9_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN9_Pos)            /*!< NT_COMMON_REG GPIOPCTLG: PIN9 Mask      */
#define NT_COMMON_REG_GPIOPCTLG_PIN10_Pos     20                                                      /*!< NT_COMMON_REG GPIOPCTLG: PIN10 Position */
#define NT_COMMON_REG_GPIOPCTLG_PIN10_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN10_Pos)           /*!< NT_COMMON_REG GPIOPCTLG: PIN10 Mask     */
#define NT_COMMON_REG_GPIOPCTLG_PIN11_Pos     22                                                      /*!< NT_COMMON_REG GPIOPCTLG: PIN11 Position */
#define NT_COMMON_REG_GPIOPCTLG_PIN11_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN11_Pos)           /*!< NT_COMMON_REG GPIOPCTLG: PIN11 Mask     */
#define NT_COMMON_REG_GPIOPCTLG_PIN12_Pos     24                                                      /*!< NT_COMMON_REG GPIOPCTLG: PIN12 Position */
#define NT_COMMON_REG_GPIOPCTLG_PIN12_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN12_Pos)           /*!< NT_COMMON_REG GPIOPCTLG: PIN12 Mask     */
#define NT_COMMON_REG_GPIOPCTLG_PIN13_Pos     26                                                      /*!< NT_COMMON_REG GPIOPCTLG: PIN13 Position */
#define NT_COMMON_REG_GPIOPCTLG_PIN13_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN13_Pos)           /*!< NT_COMMON_REG GPIOPCTLG: PIN13 Mask     */
#define NT_COMMON_REG_GPIOPCTLG_PIN14_Pos     28                                                      /*!< NT_COMMON_REG GPIOPCTLG: PIN14 Position */
#define NT_COMMON_REG_GPIOPCTLG_PIN14_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN14_Pos)           /*!< NT_COMMON_REG GPIOPCTLG: PIN14 Mask     */
#define NT_COMMON_REG_GPIOPCTLG_PIN15_Pos     30                                                      /*!< NT_COMMON_REG GPIOPCTLG: PIN15 Position */
#define NT_COMMON_REG_GPIOPCTLG_PIN15_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLG_PIN15_Pos)           /*!< NT_COMMON_REG GPIOPCTLG: PIN15 Mask     */

/* ---------------------------  NT_COMMON_REG_GPIOPCTLH  -------------------------- */
#define NT_COMMON_REG_GPIOPCTLH_PIN0_Pos      0                                                       /*!< NT_COMMON_REG GPIOPCTLH: PIN0 Position  */
#define NT_COMMON_REG_GPIOPCTLH_PIN0_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN0_Pos)            /*!< NT_COMMON_REG GPIOPCTLH: PIN0 Mask      */
#define NT_COMMON_REG_GPIOPCTLH_PIN1_Pos      2                                                       /*!< NT_COMMON_REG GPIOPCTLH: PIN1 Position  */
#define NT_COMMON_REG_GPIOPCTLH_PIN1_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN1_Pos)            /*!< NT_COMMON_REG GPIOPCTLH: PIN1 Mask      */
#define NT_COMMON_REG_GPIOPCTLH_PIN2_Pos      4                                                       /*!< NT_COMMON_REG GPIOPCTLH: PIN2 Position  */
#define NT_COMMON_REG_GPIOPCTLH_PIN2_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN2_Pos)            /*!< NT_COMMON_REG GPIOPCTLH: PIN2 Mask      */
#define NT_COMMON_REG_GPIOPCTLH_PIN3_Pos      6                                                       /*!< NT_COMMON_REG GPIOPCTLH: PIN3 Position  */
#define NT_COMMON_REG_GPIOPCTLH_PIN3_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN3_Pos)            /*!< NT_COMMON_REG GPIOPCTLH: PIN3 Mask      */
#define NT_COMMON_REG_GPIOPCTLH_PIN4_Pos      8                                                       /*!< NT_COMMON_REG GPIOPCTLH: PIN4 Position  */
#define NT_COMMON_REG_GPIOPCTLH_PIN4_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN4_Pos)            /*!< NT_COMMON_REG GPIOPCTLH: PIN4 Mask      */
#define NT_COMMON_REG_GPIOPCTLH_PIN5_Pos      10                                                      /*!< NT_COMMON_REG GPIOPCTLH: PIN5 Position  */
#define NT_COMMON_REG_GPIOPCTLH_PIN5_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN5_Pos)            /*!< NT_COMMON_REG GPIOPCTLH: PIN5 Mask      */
#define NT_COMMON_REG_GPIOPCTLH_PIN6_Pos      12                                                      /*!< NT_COMMON_REG GPIOPCTLH: PIN6 Position  */
#define NT_COMMON_REG_GPIOPCTLH_PIN6_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN6_Pos)            /*!< NT_COMMON_REG GPIOPCTLH: PIN6 Mask      */
#define NT_COMMON_REG_GPIOPCTLH_PIN7_Pos      14                                                      /*!< NT_COMMON_REG GPIOPCTLH: PIN7 Position  */
#define NT_COMMON_REG_GPIOPCTLH_PIN7_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN7_Pos)            /*!< NT_COMMON_REG GPIOPCTLH: PIN7 Mask      */
#define NT_COMMON_REG_GPIOPCTLH_PIN8_Pos      16                                                      /*!< NT_COMMON_REG GPIOPCTLH: PIN8 Position  */
#define NT_COMMON_REG_GPIOPCTLH_PIN8_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN8_Pos)            /*!< NT_COMMON_REG GPIOPCTLH: PIN8 Mask      */
#define NT_COMMON_REG_GPIOPCTLH_PIN9_Pos      18                                                      /*!< NT_COMMON_REG GPIOPCTLH: PIN9 Position  */
#define NT_COMMON_REG_GPIOPCTLH_PIN9_Msk      (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN9_Pos)            /*!< NT_COMMON_REG GPIOPCTLH: PIN9 Mask      */
#define NT_COMMON_REG_GPIOPCTLH_PIN10_Pos     20                                                      /*!< NT_COMMON_REG GPIOPCTLH: PIN10 Position */
#define NT_COMMON_REG_GPIOPCTLH_PIN10_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN10_Pos)           /*!< NT_COMMON_REG GPIOPCTLH: PIN10 Mask     */
#define NT_COMMON_REG_GPIOPCTLH_PIN11_Pos     22                                                      /*!< NT_COMMON_REG GPIOPCTLH: PIN11 Position */
#define NT_COMMON_REG_GPIOPCTLH_PIN11_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN11_Pos)           /*!< NT_COMMON_REG GPIOPCTLH: PIN11 Mask     */
#define NT_COMMON_REG_GPIOPCTLH_PIN12_Pos     24                                                      /*!< NT_COMMON_REG GPIOPCTLH: PIN12 Position */
#define NT_COMMON_REG_GPIOPCTLH_PIN12_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN12_Pos)           /*!< NT_COMMON_REG GPIOPCTLH: PIN12 Mask     */
#define NT_COMMON_REG_GPIOPCTLH_PIN13_Pos     26                                                      /*!< NT_COMMON_REG GPIOPCTLH: PIN13 Position */
#define NT_COMMON_REG_GPIOPCTLH_PIN13_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN13_Pos)           /*!< NT_COMMON_REG GPIOPCTLH: PIN13 Mask     */
#define NT_COMMON_REG_GPIOPCTLH_PIN14_Pos     28                                                      /*!< NT_COMMON_REG GPIOPCTLH: PIN14 Position */
#define NT_COMMON_REG_GPIOPCTLH_PIN14_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN14_Pos)           /*!< NT_COMMON_REG GPIOPCTLH: PIN14 Mask     */
#define NT_COMMON_REG_GPIOPCTLH_PIN15_Pos     30                                                      /*!< NT_COMMON_REG GPIOPCTLH: PIN15 Position */
#define NT_COMMON_REG_GPIOPCTLH_PIN15_Msk     (0x03UL << NT_COMMON_REG_GPIOPCTLH_PIN15_Pos)           /*!< NT_COMMON_REG GPIOPCTLH: PIN15 Mask     */

/* --------------------------  NT_COMMON_REG_GPIOODCTL0  -------------------------- */
#define NT_COMMON_REG_GPIOODCTL0_PORTA_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTL0: PORTA Position */
#define NT_COMMON_REG_GPIOODCTL0_PORTA_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTL0_PORTA_Pos)    /*!< NT_COMMON_REG GPIOODCTL0: PORTA Mask    */
#define NT_COMMON_REG_GPIOODCTL0_PORTB_Pos    16                                                      /*!< NT_COMMON_REG GPIOODCTL0: PORTB Position */
#define NT_COMMON_REG_GPIOODCTL0_PORTB_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTL0_PORTB_Pos)    /*!< NT_COMMON_REG GPIOODCTL0: PORTB Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODCTLA  -------------------------- */
#define NT_COMMON_REG_GPIOODCTLA_PORTA_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTLA: PORTA Position */
#define NT_COMMON_REG_GPIOODCTLA_PORTA_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTLA_PORTA_Pos)    /*!< NT_COMMON_REG GPIOODCTLA: PORTA Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODCTLB  -------------------------- */
#define NT_COMMON_REG_GPIOODCTLB_PORTB_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTLB: PORTB Position */
#define NT_COMMON_REG_GPIOODCTLB_PORTB_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTLB_PORTB_Pos)    /*!< NT_COMMON_REG GPIOODCTLB: PORTB Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODCTL1  -------------------------- */
#define NT_COMMON_REG_GPIOODCTL1_PORTC_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTL1: PORTC Position */
#define NT_COMMON_REG_GPIOODCTL1_PORTC_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTL1_PORTC_Pos)    /*!< NT_COMMON_REG GPIOODCTL1: PORTC Mask    */
#define NT_COMMON_REG_GPIOODCTL1_PORTD_Pos    16                                                      /*!< NT_COMMON_REG GPIOODCTL1: PORTD Position */
#define NT_COMMON_REG_GPIOODCTL1_PORTD_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTL1_PORTD_Pos)    /*!< NT_COMMON_REG GPIOODCTL1: PORTD Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODCTLC  -------------------------- */
#define NT_COMMON_REG_GPIOODCTLC_PORTC_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTLC: PORTC Position */
#define NT_COMMON_REG_GPIOODCTLC_PORTC_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTLC_PORTC_Pos)    /*!< NT_COMMON_REG GPIOODCTLC: PORTC Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODCTLD  -------------------------- */
#define NT_COMMON_REG_GPIOODCTLD_PORTD_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTLD: PORTD Position */
#define NT_COMMON_REG_GPIOODCTLD_PORTD_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTLD_PORTD_Pos)    /*!< NT_COMMON_REG GPIOODCTLD: PORTD Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODCTL2  -------------------------- */
#define NT_COMMON_REG_GPIOODCTL2_PORTE_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTL2: PORTE Position */
#define NT_COMMON_REG_GPIOODCTL2_PORTE_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTL2_PORTE_Pos)    /*!< NT_COMMON_REG GPIOODCTL2: PORTE Mask    */
#define NT_COMMON_REG_GPIOODCTL2_PORTF_Pos    16                                                      /*!< NT_COMMON_REG GPIOODCTL2: PORTF Position */
#define NT_COMMON_REG_GPIOODCTL2_PORTF_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTL2_PORTF_Pos)    /*!< NT_COMMON_REG GPIOODCTL2: PORTF Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODCTLE  -------------------------- */
#define NT_COMMON_REG_GPIOODCTLE_PORTE_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTLE: PORTE Position */
#define NT_COMMON_REG_GPIOODCTLE_PORTE_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTLE_PORTE_Pos)    /*!< NT_COMMON_REG GPIOODCTLE: PORTE Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODCTLF  -------------------------- */
#define NT_COMMON_REG_GPIOODCTLF_PORTF_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTLF: PORTF Position */
#define NT_COMMON_REG_GPIOODCTLF_PORTF_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTLF_PORTF_Pos)    /*!< NT_COMMON_REG GPIOODCTLF: PORTF Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODCTL3  -------------------------- */
#define NT_COMMON_REG_GPIOODCTL3_PORTG_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTL3: PORTG Position */
#define NT_COMMON_REG_GPIOODCTL3_PORTG_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTL3_PORTG_Pos)    /*!< NT_COMMON_REG GPIOODCTL3: PORTG Mask    */
#define NT_COMMON_REG_GPIOODCTL3_PORTH_Pos    16                                                      /*!< NT_COMMON_REG GPIOODCTL3: PORTH Position */
#define NT_COMMON_REG_GPIOODCTL3_PORTH_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTL3_PORTH_Pos)    /*!< NT_COMMON_REG GPIOODCTL3: PORTH Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODCTLG  -------------------------- */
#define NT_COMMON_REG_GPIOODCTLG_PORTG_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTLG: PORTG Position */
#define NT_COMMON_REG_GPIOODCTLG_PORTG_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTLG_PORTG_Pos)    /*!< NT_COMMON_REG GPIOODCTLG: PORTG Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODCTLH  -------------------------- */
#define NT_COMMON_REG_GPIOODCTLH_PORTH_Pos    0                                                       /*!< NT_COMMON_REG GPIOODCTLH: PORTH Position */
#define NT_COMMON_REG_GPIOODCTLH_PORTH_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOODCTLH_PORTH_Pos)    /*!< NT_COMMON_REG GPIOODCTLH: PORTH Mask    */

/* --------------------------  NT_COMMON_REG_GPIOODSCTL0  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTL0_PORTA_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTL0: PORTA Position */
#define NT_COMMON_REG_GPIOODSCTL0_PORTA_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTL0_PORTA_Pos)   /*!< NT_COMMON_REG GPIOODSCTL0: PORTA Mask   */
#define NT_COMMON_REG_GPIOODSCTL0_PORTB_Pos   16                                                      /*!< NT_COMMON_REG GPIOODSCTL0: PORTB Position */
#define NT_COMMON_REG_GPIOODSCTL0_PORTB_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTL0_PORTB_Pos)   /*!< NT_COMMON_REG GPIOODSCTL0: PORTB Mask   */

/* --------------------------  NT_COMMON_REG_GPIOODSCTLA  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTLA_PORTA_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTLA: PORTA Position */
#define NT_COMMON_REG_GPIOODSCTLA_PORTA_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTLA_PORTA_Pos)   /*!< NT_COMMON_REG GPIOODSCTLA: PORTA Mask   */

/* --------------------------  NT_COMMON_REG_GPIOODSCTLB  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTLB_PORTB_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTLB: PORTB Position */
#define NT_COMMON_REG_GPIOODSCTLB_PORTB_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTLB_PORTB_Pos)   /*!< NT_COMMON_REG GPIOODSCTLB: PORTB Mask   */

/* --------------------------  NT_COMMON_REG_GPIOODSCTL1  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTL1_PORTC_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTL1: PORTC Position */
#define NT_COMMON_REG_GPIOODSCTL1_PORTC_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTL1_PORTC_Pos)   /*!< NT_COMMON_REG GPIOODSCTL1: PORTC Mask   */
#define NT_COMMON_REG_GPIOODSCTL1_PORTD_Pos   16                                                      /*!< NT_COMMON_REG GPIOODSCTL1: PORTD Position */
#define NT_COMMON_REG_GPIOODSCTL1_PORTD_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTL1_PORTD_Pos)   /*!< NT_COMMON_REG GPIOODSCTL1: PORTD Mask   */

/* --------------------------  NT_COMMON_REG_GPIOODSCTLC  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTLC_PORTC_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTLC: PORTC Position */
#define NT_COMMON_REG_GPIOODSCTLC_PORTC_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTLC_PORTC_Pos)   /*!< NT_COMMON_REG GPIOODSCTLC: PORTC Mask   */

/* --------------------------  NT_COMMON_REG_GPIOODSCTLD  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTLD_PORTD_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTLD: PORTD Position */
#define NT_COMMON_REG_GPIOODSCTLD_PORTD_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTLD_PORTD_Pos)   /*!< NT_COMMON_REG GPIOODSCTLD: PORTD Mask   */

/* --------------------------  NT_COMMON_REG_GPIOODSCTL2  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTL2_PORTE_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTL2: PORTE Position */
#define NT_COMMON_REG_GPIOODSCTL2_PORTE_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTL2_PORTE_Pos)   /*!< NT_COMMON_REG GPIOODSCTL2: PORTE Mask   */
#define NT_COMMON_REG_GPIOODSCTL2_PORTF_Pos   16                                                      /*!< NT_COMMON_REG GPIOODSCTL2: PORTF Position */
#define NT_COMMON_REG_GPIOODSCTL2_PORTF_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTL2_PORTF_Pos)   /*!< NT_COMMON_REG GPIOODSCTL2: PORTF Mask   */

/* --------------------------  NT_COMMON_REG_GPIOODSCTLE  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTLE_PORTE_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTLE: PORTE Position */
#define NT_COMMON_REG_GPIOODSCTLE_PORTE_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTLE_PORTE_Pos)   /*!< NT_COMMON_REG GPIOODSCTLE: PORTE Mask   */

/* --------------------------  NT_COMMON_REG_GPIOODSCTLF  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTLF_PORTF_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTLF: PORTF Position */
#define NT_COMMON_REG_GPIOODSCTLF_PORTF_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTLF_PORTF_Pos)   /*!< NT_COMMON_REG GPIOODSCTLF: PORTF Mask   */

/* --------------------------  NT_COMMON_REG_GPIOODSCTL3  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTL3_PORTG_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTL3: PORTG Position */
#define NT_COMMON_REG_GPIOODSCTL3_PORTG_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTL3_PORTG_Pos)   /*!< NT_COMMON_REG GPIOODSCTL3: PORTG Mask   */
#define NT_COMMON_REG_GPIOODSCTL3_PORTH_Pos   16                                                      /*!< NT_COMMON_REG GPIOODSCTL3: PORTH Position */
#define NT_COMMON_REG_GPIOODSCTL3_PORTH_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTL3_PORTH_Pos)   /*!< NT_COMMON_REG GPIOODSCTL3: PORTH Mask   */

/* --------------------------  NT_COMMON_REG_GPIOODSCTLG  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTLG_PORTG_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTLG: PORTG Position */
#define NT_COMMON_REG_GPIOODSCTLG_PORTG_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTLG_PORTG_Pos)   /*!< NT_COMMON_REG GPIOODSCTLG: PORTG Mask   */

/* --------------------------  NT_COMMON_REG_GPIOODSCTLH  ------------------------- */
#define NT_COMMON_REG_GPIOODSCTLH_PORTH_Pos   0                                                       /*!< NT_COMMON_REG GPIOODSCTLH: PORTH Position */
#define NT_COMMON_REG_GPIOODSCTLH_PORTH_Msk   (0x0000ffffUL << NT_COMMON_REG_GPIOODSCTLH_PORTH_Pos)   /*!< NT_COMMON_REG GPIOODSCTLH: PORTH Mask   */

/* --------------------------  NT_COMMON_REG_GPIOPUCTL0  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTL0_PORTA_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTL0: PORTA Position */
#define NT_COMMON_REG_GPIOPUCTL0_PORTA_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTL0_PORTA_Pos)    /*!< NT_COMMON_REG GPIOPUCTL0: PORTA Mask    */
#define NT_COMMON_REG_GPIOPUCTL0_PORTB_Pos    16                                                      /*!< NT_COMMON_REG GPIOPUCTL0: PORTB Position */
#define NT_COMMON_REG_GPIOPUCTL0_PORTB_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTL0_PORTB_Pos)    /*!< NT_COMMON_REG GPIOPUCTL0: PORTB Mask    */

/* --------------------------  NT_COMMON_REG_GPIOPUCTLA  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTLA_PORTA_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTLA: PORTA Position */
#define NT_COMMON_REG_GPIOPUCTLA_PORTA_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTLA_PORTA_Pos)    /*!< NT_COMMON_REG GPIOPUCTLA: PORTA Mask    */

/* --------------------------  NT_COMMON_REG_GPIOPUCTLB  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTLB_PORTB_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTLB: PORTB Position */
#define NT_COMMON_REG_GPIOPUCTLB_PORTB_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTLB_PORTB_Pos)    /*!< NT_COMMON_REG GPIOPUCTLB: PORTB Mask    */

/* --------------------------  NT_COMMON_REG_GPIOPUCTL1  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTL1_PORTC_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTL1: PORTC Position */
#define NT_COMMON_REG_GPIOPUCTL1_PORTC_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTL1_PORTC_Pos)    /*!< NT_COMMON_REG GPIOPUCTL1: PORTC Mask    */
#define NT_COMMON_REG_GPIOPUCTL1_PORTD_Pos    16                                                      /*!< NT_COMMON_REG GPIOPUCTL1: PORTD Position */
#define NT_COMMON_REG_GPIOPUCTL1_PORTD_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTL1_PORTD_Pos)    /*!< NT_COMMON_REG GPIOPUCTL1: PORTD Mask    */

/* --------------------------  NT_COMMON_REG_GPIOPUCTLC  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTLC_PORTC_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTLC: PORTC Position */
#define NT_COMMON_REG_GPIOPUCTLC_PORTC_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTLC_PORTC_Pos)    /*!< NT_COMMON_REG GPIOPUCTLC: PORTC Mask    */

/* --------------------------  NT_COMMON_REG_GPIOPUCTLD  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTLD_PORTD_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTLD: PORTD Position */
#define NT_COMMON_REG_GPIOPUCTLD_PORTD_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTLD_PORTD_Pos)    /*!< NT_COMMON_REG GPIOPUCTLD: PORTD Mask    */

/* --------------------------  NT_COMMON_REG_GPIOPUCTL2  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTL2_PORTE_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTL2: PORTE Position */
#define NT_COMMON_REG_GPIOPUCTL2_PORTE_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTL2_PORTE_Pos)    /*!< NT_COMMON_REG GPIOPUCTL2: PORTE Mask    */
#define NT_COMMON_REG_GPIOPUCTL2_PORTF_Pos    16                                                      /*!< NT_COMMON_REG GPIOPUCTL2: PORTF Position */
#define NT_COMMON_REG_GPIOPUCTL2_PORTF_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTL2_PORTF_Pos)    /*!< NT_COMMON_REG GPIOPUCTL2: PORTF Mask    */

/* --------------------------  NT_COMMON_REG_GPIOPUCTLE  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTLE_PORTE_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTLE: PORTE Position */
#define NT_COMMON_REG_GPIOPUCTLE_PORTE_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTLE_PORTE_Pos)    /*!< NT_COMMON_REG GPIOPUCTLE: PORTE Mask    */

/* --------------------------  NT_COMMON_REG_GPIOPUCTLF  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTLF_PORTF_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTLF: PORTF Position */
#define NT_COMMON_REG_GPIOPUCTLF_PORTF_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTLF_PORTF_Pos)    /*!< NT_COMMON_REG GPIOPUCTLF: PORTF Mask    */

/* --------------------------  NT_COMMON_REG_GPIOPUCTL3  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTL3_PORTG_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTL3: PORTG Position */
#define NT_COMMON_REG_GPIOPUCTL3_PORTG_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTL3_PORTG_Pos)    /*!< NT_COMMON_REG GPIOPUCTL3: PORTG Mask    */
#define NT_COMMON_REG_GPIOPUCTL3_PORTH_Pos    16                                                      /*!< NT_COMMON_REG GPIOPUCTL3: PORTH Position */
#define NT_COMMON_REG_GPIOPUCTL3_PORTH_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTL3_PORTH_Pos)    /*!< NT_COMMON_REG GPIOPUCTL3: PORTH Mask    */

/* --------------------------  NT_COMMON_REG_GPIOPUCTLG  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTLG_PORTG_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTLG: PORTG Position */
#define NT_COMMON_REG_GPIOPUCTLG_PORTG_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTLG_PORTG_Pos)    /*!< NT_COMMON_REG GPIOPUCTLG: PORTG Mask    */

/* --------------------------  NT_COMMON_REG_GPIOPUCTLH  -------------------------- */
#define NT_COMMON_REG_GPIOPUCTLH_PORTH_Pos    0                                                       /*!< NT_COMMON_REG GPIOPUCTLH: PORTH Position */
#define NT_COMMON_REG_GPIOPUCTLH_PORTH_Msk    (0x0000ffffUL << NT_COMMON_REG_GPIOPUCTLH_PORTH_Pos)    /*!< NT_COMMON_REG GPIOPUCTLH: PORTH Mask    */

/* ---------------------------  NT_COMMON_REG_PLL_CTRL  --------------------------- */
#define NT_COMMON_REG_PLL_CTRL_REFSEL_Pos     0                                                       /*!< NT_COMMON_REG PLL_CTRL: REFSEL Position */
#define NT_COMMON_REG_PLL_CTRL_REFSEL_Msk     (0x03UL << NT_COMMON_REG_PLL_CTRL_REFSEL_Pos)           /*!< NT_COMMON_REG PLL_CTRL: REFSEL Mask     */
#define NT_COMMON_REG_PLL_CTRL_PLL_DIV_Pos    8                                                       /*!< NT_COMMON_REG PLL_CTRL: PLL_DIV Position */
#define NT_COMMON_REG_PLL_CTRL_PLL_DIV_Msk    (0x000000ffUL << NT_COMMON_REG_PLL_CTRL_PLL_DIV_Pos)    /*!< NT_COMMON_REG PLL_CTRL: PLL_DIV Mask    */
#define NT_COMMON_REG_PLL_CTRL_PD_Pos         31                                                      /*!< NT_COMMON_REG PLL_CTRL: PD Position     */
#define NT_COMMON_REG_PLL_CTRL_PD_Msk         (0x01UL << NT_COMMON_REG_PLL_CTRL_PD_Pos)               /*!< NT_COMMON_REG PLL_CTRL: PD Mask         */

/* ----------------------------  NT_COMMON_REG_PLL_OD  ---------------------------- */
#define NT_COMMON_REG_PLL_OD_PLL_OD_Pos       0                                                       /*!< NT_COMMON_REG PLL_OD: PLL_OD Position   */
#define NT_COMMON_REG_PLL_OD_PLL_OD_Msk       (0x03UL << NT_COMMON_REG_PLL_OD_PLL_OD_Pos)             /*!< NT_COMMON_REG PLL_OD: PLL_OD Mask       */

/* ----------------------------  NT_COMMON_REG_PLL_NR  ---------------------------- */
#define NT_COMMON_REG_PLL_NR_R_PLL_Pos        0                                                       /*!< NT_COMMON_REG PLL_NR: R_PLL Position    */
#define NT_COMMON_REG_PLL_NR_R_PLL_Msk        (0x1fUL << NT_COMMON_REG_PLL_NR_R_PLL_Pos)              /*!< NT_COMMON_REG PLL_NR: R_PLL Mask        */

/* ----------------------------  NT_COMMON_REG_PLL_NF  ---------------------------- */
#define NT_COMMON_REG_PLL_NF_F_PLL_Pos        0                                                       /*!< NT_COMMON_REG PLL_NF: F_PLL Position    */
#define NT_COMMON_REG_PLL_NF_F_PLL_Msk        (0x000001ffUL << NT_COMMON_REG_PLL_NF_F_PLL_Pos)        /*!< NT_COMMON_REG PLL_NF: F_PLL Mask        */

/* --------------------------  NT_COMMON_REG_EXT_MEM_CFG  ------------------------- */
#define NT_COMMON_REG_EXT_MEM_CFG_ReadWS_Pos  0                                                       /*!< NT_COMMON_REG EXT_MEM_CFG: ReadWS Position */
#define NT_COMMON_REG_EXT_MEM_CFG_ReadWS_Msk  (0x07UL << NT_COMMON_REG_EXT_MEM_CFG_ReadWS_Pos)        /*!< NT_COMMON_REG EXT_MEM_CFG: ReadWS Mask  */
#define NT_COMMON_REG_EXT_MEM_CFG_WriteWS_Pos 3                                                       /*!< NT_COMMON_REG EXT_MEM_CFG: WriteWS Position */
#define NT_COMMON_REG_EXT_MEM_CFG_WriteWS_Msk (0x07UL << NT_COMMON_REG_EXT_MEM_CFG_WriteWS_Pos)       /*!< NT_COMMON_REG EXT_MEM_CFG: WriteWS Mask */
#define NT_COMMON_REG_EXT_MEM_CFG_RWWS_Pos    6                                                       /*!< NT_COMMON_REG EXT_MEM_CFG: RWWS Position */
#define NT_COMMON_REG_EXT_MEM_CFG_RWWS_Msk    (0x07UL << NT_COMMON_REG_EXT_MEM_CFG_RWWS_Pos)          /*!< NT_COMMON_REG EXT_MEM_CFG: RWWS Mask    */
#define NT_COMMON_REG_EXT_MEM_CFG_CE_MASK_Pos 9                                                       /*!< NT_COMMON_REG EXT_MEM_CFG: CE_MASK Position */
#define NT_COMMON_REG_EXT_MEM_CFG_CE_MASK_Msk (0x000001ffUL << NT_COMMON_REG_EXT_MEM_CFG_CE_MASK_Pos) /*!< NT_COMMON_REG EXT_MEM_CFG: CE_MASK Mask */
#define NT_COMMON_REG_EXT_MEM_CFG_BV_Pos      31                                                      /*!< NT_COMMON_REG EXT_MEM_CFG: BV Position  */
#define NT_COMMON_REG_EXT_MEM_CFG_BV_Msk      (0x01UL << NT_COMMON_REG_EXT_MEM_CFG_BV_Pos)            /*!< NT_COMMON_REG EXT_MEM_CFG: BV Mask      */

/* ---------------------------  NT_COMMON_REG_ADC_CTRL0  -------------------------- */
#define NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC0_Pos 0                                                      /*!< NT_COMMON_REG ADC_CTRL0: CLKEN_ADC0 Position */
#define NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC0_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC0_Pos)     /*!< NT_COMMON_REG ADC_CTRL0: CLKEN_ADC0 Mask */
#define NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC0_Pos 1                                                      /*!< NT_COMMON_REG ADC_CTRL0: DIVEN_ADC0 Position */
#define NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC0_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC0_Pos)     /*!< NT_COMMON_REG ADC_CTRL0: DIVEN_ADC0 Mask */
#define NT_COMMON_REG_ADC_CTRL0_DIV_ADC0_Pos  2                                                       /*!< NT_COMMON_REG ADC_CTRL0: DIV_ADC0 Position */
#define NT_COMMON_REG_ADC_CTRL0_DIV_ADC0_Msk  (0x3fUL << NT_COMMON_REG_ADC_CTRL0_DIV_ADC0_Pos)        /*!< NT_COMMON_REG ADC_CTRL0: DIV_ADC0 Mask  */
#define NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC1_Pos 8                                                      /*!< NT_COMMON_REG ADC_CTRL0: CLKEN_ADC1 Position */
#define NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC1_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC1_Pos)     /*!< NT_COMMON_REG ADC_CTRL0: CLKEN_ADC1 Mask */
#define NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC1_Pos 9                                                      /*!< NT_COMMON_REG ADC_CTRL0: DIVEN_ADC1 Position */
#define NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC1_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC1_Pos)     /*!< NT_COMMON_REG ADC_CTRL0: DIVEN_ADC1 Mask */
#define NT_COMMON_REG_ADC_CTRL0_DIV_ADC1_Pos  10                                                      /*!< NT_COMMON_REG ADC_CTRL0: DIV_ADC1 Position */
#define NT_COMMON_REG_ADC_CTRL0_DIV_ADC1_Msk  (0x3fUL << NT_COMMON_REG_ADC_CTRL0_DIV_ADC1_Pos)        /*!< NT_COMMON_REG ADC_CTRL0: DIV_ADC1 Mask  */
#define NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC2_Pos 16                                                     /*!< NT_COMMON_REG ADC_CTRL0: CLKEN_ADC2 Position */
#define NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC2_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC2_Pos)     /*!< NT_COMMON_REG ADC_CTRL0: CLKEN_ADC2 Mask */
#define NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC2_Pos 17                                                     /*!< NT_COMMON_REG ADC_CTRL0: DIVEN_ADC2 Position */
#define NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC2_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC2_Pos)     /*!< NT_COMMON_REG ADC_CTRL0: DIVEN_ADC2 Mask */
#define NT_COMMON_REG_ADC_CTRL0_DIV_ADC2_Pos  18                                                      /*!< NT_COMMON_REG ADC_CTRL0: DIV_ADC2 Position */
#define NT_COMMON_REG_ADC_CTRL0_DIV_ADC2_Msk  (0x3fUL << NT_COMMON_REG_ADC_CTRL0_DIV_ADC2_Pos)        /*!< NT_COMMON_REG ADC_CTRL0: DIV_ADC2 Mask  */
#define NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC3_Pos 24                                                     /*!< NT_COMMON_REG ADC_CTRL0: CLKEN_ADC3 Position */
#define NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC3_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL0_CLKEN_ADC3_Pos)     /*!< NT_COMMON_REG ADC_CTRL0: CLKEN_ADC3 Mask */
#define NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC3_Pos 25                                                     /*!< NT_COMMON_REG ADC_CTRL0: DIVEN_ADC3 Position */
#define NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC3_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL0_DIVEN_ADC3_Pos)     /*!< NT_COMMON_REG ADC_CTRL0: DIVEN_ADC3 Mask */
#define NT_COMMON_REG_ADC_CTRL0_DIV_ADC3_Pos  26                                                      /*!< NT_COMMON_REG ADC_CTRL0: DIV_ADC3 Position */
#define NT_COMMON_REG_ADC_CTRL0_DIV_ADC3_Msk  (0x3fUL << NT_COMMON_REG_ADC_CTRL0_DIV_ADC3_Pos)        /*!< NT_COMMON_REG ADC_CTRL0: DIV_ADC3 Mask  */

/* ---------------------------  NT_COMMON_REG_ADC_CTRL1  -------------------------- */
#define NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC4_Pos 0                                                      /*!< NT_COMMON_REG ADC_CTRL1: CLKEN_ADC4 Position */
#define NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC4_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC4_Pos)     /*!< NT_COMMON_REG ADC_CTRL1: CLKEN_ADC4 Mask */
#define NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC4_Pos 1                                                      /*!< NT_COMMON_REG ADC_CTRL1: DIVEN_ADC4 Position */
#define NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC4_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC4_Pos)     /*!< NT_COMMON_REG ADC_CTRL1: DIVEN_ADC4 Mask */
#define NT_COMMON_REG_ADC_CTRL1_DIV_ADC4_Pos  2                                                       /*!< NT_COMMON_REG ADC_CTRL1: DIV_ADC4 Position */
#define NT_COMMON_REG_ADC_CTRL1_DIV_ADC4_Msk  (0x3fUL << NT_COMMON_REG_ADC_CTRL1_DIV_ADC4_Pos)        /*!< NT_COMMON_REG ADC_CTRL1: DIV_ADC4 Mask  */
#define NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC5_Pos 8                                                      /*!< NT_COMMON_REG ADC_CTRL1: CLKEN_ADC5 Position */
#define NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC5_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC5_Pos)     /*!< NT_COMMON_REG ADC_CTRL1: CLKEN_ADC5 Mask */
#define NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC5_Pos 9                                                      /*!< NT_COMMON_REG ADC_CTRL1: DIVEN_ADC5 Position */
#define NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC5_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC5_Pos)     /*!< NT_COMMON_REG ADC_CTRL1: DIVEN_ADC5 Mask */
#define NT_COMMON_REG_ADC_CTRL1_DIV_ADC5_Pos  10                                                      /*!< NT_COMMON_REG ADC_CTRL1: DIV_ADC5 Position */
#define NT_COMMON_REG_ADC_CTRL1_DIV_ADC5_Msk  (0x3fUL << NT_COMMON_REG_ADC_CTRL1_DIV_ADC5_Pos)        /*!< NT_COMMON_REG ADC_CTRL1: DIV_ADC5 Mask  */
#define NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC6_Pos 16                                                     /*!< NT_COMMON_REG ADC_CTRL1: CLKEN_ADC6 Position */
#define NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC6_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC6_Pos)     /*!< NT_COMMON_REG ADC_CTRL1: CLKEN_ADC6 Mask */
#define NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC6_Pos 17                                                     /*!< NT_COMMON_REG ADC_CTRL1: DIVEN_ADC6 Position */
#define NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC6_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC6_Pos)     /*!< NT_COMMON_REG ADC_CTRL1: DIVEN_ADC6 Mask */
#define NT_COMMON_REG_ADC_CTRL1_DIV_ADC6_Pos  18                                                      /*!< NT_COMMON_REG ADC_CTRL1: DIV_ADC6 Position */
#define NT_COMMON_REG_ADC_CTRL1_DIV_ADC6_Msk  (0x3fUL << NT_COMMON_REG_ADC_CTRL1_DIV_ADC6_Pos)        /*!< NT_COMMON_REG ADC_CTRL1: DIV_ADC6 Mask  */
#define NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC7_Pos 24                                                     /*!< NT_COMMON_REG ADC_CTRL1: CLKEN_ADC7 Position */
#define NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC7_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL1_CLKEN_ADC7_Pos)     /*!< NT_COMMON_REG ADC_CTRL1: CLKEN_ADC7 Mask */
#define NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC7_Pos 25                                                     /*!< NT_COMMON_REG ADC_CTRL1: DIVEN_ADC7 Position */
#define NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC7_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL1_DIVEN_ADC7_Pos)     /*!< NT_COMMON_REG ADC_CTRL1: DIVEN_ADC7 Mask */
#define NT_COMMON_REG_ADC_CTRL1_DIV_ADC7_Pos  26                                                      /*!< NT_COMMON_REG ADC_CTRL1: DIV_ADC7 Position */
#define NT_COMMON_REG_ADC_CTRL1_DIV_ADC7_Msk  (0x3fUL << NT_COMMON_REG_ADC_CTRL1_DIV_ADC7_Pos)        /*!< NT_COMMON_REG ADC_CTRL1: DIV_ADC7 Mask  */

/* ---------------------------  NT_COMMON_REG_PWM_SYNC  --------------------------- */
#define NT_COMMON_REG_PWM_SYNC_TBCLKSYNC_Pos  0                                                       /*!< NT_COMMON_REG PWM_SYNC: TBCLKSYNC Position */
#define NT_COMMON_REG_PWM_SYNC_TBCLKSYNC_Msk  (0x000001ffUL << NT_COMMON_REG_PWM_SYNC_TBCLKSYNC_Pos)  /*!< NT_COMMON_REG PWM_SYNC: TBCLKSYNC Mask  */

/* ---------------------------  NT_COMMON_REG_PWM_CTRL  --------------------------- */
#define NT_COMMON_REG_PWM_CTRL_SYNCSELECT_Pos 0                                                       /*!< NT_COMMON_REG PWM_CTRL: SYNCSELECT Position */
#define NT_COMMON_REG_PWM_CTRL_SYNCSELECT_Msk (0x03UL << NT_COMMON_REG_PWM_CTRL_SYNCSELECT_Pos)       /*!< NT_COMMON_REG PWM_CTRL: SYNCSELECT Mask */
#define NT_COMMON_REG_PWM_CTRL_CAPSYNCSEL_Pos 2                                                       /*!< NT_COMMON_REG PWM_CTRL: CAPSYNCSEL Position */
#define NT_COMMON_REG_PWM_CTRL_CAPSYNCSEL_Msk (0x01UL << NT_COMMON_REG_PWM_CTRL_CAPSYNCSEL_Pos)       /*!< NT_COMMON_REG PWM_CTRL: CAPSYNCSEL Mask */
#define NT_COMMON_REG_PWM_CTRL_SYNCREG_Pos    3                                                       /*!< NT_COMMON_REG PWM_CTRL: SYNCREG Position */
#define NT_COMMON_REG_PWM_CTRL_SYNCREG_Msk    (0x01UL << NT_COMMON_REG_PWM_CTRL_SYNCREG_Pos)          /*!< NT_COMMON_REG PWM_CTRL: SYNCREG Mask    */

/* ----------------------------  NT_COMMON_REG_SYS_CLK  --------------------------- */
#define NT_COMMON_REG_SYS_CLK_SEL_SRC_Pos     0                                                       /*!< NT_COMMON_REG SYS_CLK: SEL_SRC Position */
#define NT_COMMON_REG_SYS_CLK_SEL_SRC_Msk     (0x07UL << NT_COMMON_REG_SYS_CLK_SEL_SRC_Pos)           /*!< NT_COMMON_REG SYS_CLK: SEL_SRC Mask     */
#define NT_COMMON_REG_SYS_CLK_CURR_SRC_Pos    8                                                       /*!< NT_COMMON_REG SYS_CLK: CURR_SRC Position */
#define NT_COMMON_REG_SYS_CLK_CURR_SRC_Msk    (0x07UL << NT_COMMON_REG_SYS_CLK_CURR_SRC_Pos)          /*!< NT_COMMON_REG SYS_CLK: CURR_SRC Mask    */

/* ----------------------------  NT_COMMON_REG_APB_CLK  --------------------------- */
#define NT_COMMON_REG_APB_CLK_QEPEN0_Pos      1                                                       /*!< NT_COMMON_REG APB_CLK: QEPEN0 Position  */
#define NT_COMMON_REG_APB_CLK_QEPEN0_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_QEPEN0_Pos)            /*!< NT_COMMON_REG APB_CLK: QEPEN0 Mask      */
#define NT_COMMON_REG_APB_CLK_QEPEN1_Pos      2                                                       /*!< NT_COMMON_REG APB_CLK: QEPEN1 Position  */
#define NT_COMMON_REG_APB_CLK_QEPEN1_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_QEPEN1_Pos)            /*!< NT_COMMON_REG APB_CLK: QEPEN1 Mask      */
#define NT_COMMON_REG_APB_CLK_CMPEN_Pos       9                                                       /*!< NT_COMMON_REG APB_CLK: CMPEN Position   */
#define NT_COMMON_REG_APB_CLK_CMPEN_Msk       (0x01UL << NT_COMMON_REG_APB_CLK_CMPEN_Pos)             /*!< NT_COMMON_REG APB_CLK: CMPEN Mask       */
#define NT_COMMON_REG_APB_CLK_PWMEN0_Pos      10                                                      /*!< NT_COMMON_REG APB_CLK: PWMEN0 Position  */
#define NT_COMMON_REG_APB_CLK_PWMEN0_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_PWMEN0_Pos)            /*!< NT_COMMON_REG APB_CLK: PWMEN0 Mask      */
#define NT_COMMON_REG_APB_CLK_PWMEN1_Pos      11                                                      /*!< NT_COMMON_REG APB_CLK: PWMEN1 Position  */
#define NT_COMMON_REG_APB_CLK_PWMEN1_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_PWMEN1_Pos)            /*!< NT_COMMON_REG APB_CLK: PWMEN1 Mask      */
#define NT_COMMON_REG_APB_CLK_PWMEN2_Pos      12                                                      /*!< NT_COMMON_REG APB_CLK: PWMEN2 Position  */
#define NT_COMMON_REG_APB_CLK_PWMEN2_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_PWMEN2_Pos)            /*!< NT_COMMON_REG APB_CLK: PWMEN2 Mask      */
#define NT_COMMON_REG_APB_CLK_PWMEN3_Pos      13                                                      /*!< NT_COMMON_REG APB_CLK: PWMEN3 Position  */
#define NT_COMMON_REG_APB_CLK_PWMEN3_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_PWMEN3_Pos)            /*!< NT_COMMON_REG APB_CLK: PWMEN3 Mask      */
#define NT_COMMON_REG_APB_CLK_PWMEN4_Pos      14                                                      /*!< NT_COMMON_REG APB_CLK: PWMEN4 Position  */
#define NT_COMMON_REG_APB_CLK_PWMEN4_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_PWMEN4_Pos)            /*!< NT_COMMON_REG APB_CLK: PWMEN4 Mask      */
#define NT_COMMON_REG_APB_CLK_PWMEN5_Pos      15                                                      /*!< NT_COMMON_REG APB_CLK: PWMEN5 Position  */
#define NT_COMMON_REG_APB_CLK_PWMEN5_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_PWMEN5_Pos)            /*!< NT_COMMON_REG APB_CLK: PWMEN5 Mask      */
#define NT_COMMON_REG_APB_CLK_PWMEN6_Pos      16                                                      /*!< NT_COMMON_REG APB_CLK: PWMEN6 Position  */
#define NT_COMMON_REG_APB_CLK_PWMEN6_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_PWMEN6_Pos)            /*!< NT_COMMON_REG APB_CLK: PWMEN6 Mask      */
#define NT_COMMON_REG_APB_CLK_PWMEN7_Pos      17                                                      /*!< NT_COMMON_REG APB_CLK: PWMEN7 Position  */
#define NT_COMMON_REG_APB_CLK_PWMEN7_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_PWMEN7_Pos)            /*!< NT_COMMON_REG APB_CLK: PWMEN7 Mask      */
#define NT_COMMON_REG_APB_CLK_PWMEN8_Pos      18                                                      /*!< NT_COMMON_REG APB_CLK: PWMEN8 Position  */
#define NT_COMMON_REG_APB_CLK_PWMEN8_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_PWMEN8_Pos)            /*!< NT_COMMON_REG APB_CLK: PWMEN8 Mask      */
#define NT_COMMON_REG_APB_CLK_WDEN_Pos        19                                                      /*!< NT_COMMON_REG APB_CLK: WDEN Position    */
#define NT_COMMON_REG_APB_CLK_WDEN_Msk        (0x01UL << NT_COMMON_REG_APB_CLK_WDEN_Pos)              /*!< NT_COMMON_REG APB_CLK: WDEN Mask        */
#define NT_COMMON_REG_APB_CLK_I2CEN0_Pos      20                                                      /*!< NT_COMMON_REG APB_CLK: I2CEN0 Position  */
#define NT_COMMON_REG_APB_CLK_I2CEN0_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_I2CEN0_Pos)            /*!< NT_COMMON_REG APB_CLK: I2CEN0 Mask      */
#define NT_COMMON_REG_APB_CLK_I2CEN1_Pos      21                                                      /*!< NT_COMMON_REG APB_CLK: I2CEN1 Position  */
#define NT_COMMON_REG_APB_CLK_I2CEN1_Msk      (0x01UL << NT_COMMON_REG_APB_CLK_I2CEN1_Pos)            /*!< NT_COMMON_REG APB_CLK: I2CEN1 Mask      */
#define NT_COMMON_REG_APB_CLK_ADCEN_Pos       24                                                      /*!< NT_COMMON_REG APB_CLK: ADCEN Position   */
#define NT_COMMON_REG_APB_CLK_ADCEN_Msk       (0x01UL << NT_COMMON_REG_APB_CLK_ADCEN_Pos)             /*!< NT_COMMON_REG APB_CLK: ADCEN Mask       */

/* ---------------------------  NT_COMMON_REG_UART_CLK  --------------------------- */
#define NT_COMMON_REG_UART_CLK_CLKEN_UART0_Pos 0                                                      /*!< NT_COMMON_REG UART_CLK: CLKEN_UART0 Position */
#define NT_COMMON_REG_UART_CLK_CLKEN_UART0_Msk (0x01UL << NT_COMMON_REG_UART_CLK_CLKEN_UART0_Pos)     /*!< NT_COMMON_REG UART_CLK: CLKEN_UART0 Mask */
#define NT_COMMON_REG_UART_CLK_DIVEN_UART0_Pos 1                                                      /*!< NT_COMMON_REG UART_CLK: DIVEN_UART0 Position */
#define NT_COMMON_REG_UART_CLK_DIVEN_UART0_Msk (0x01UL << NT_COMMON_REG_UART_CLK_DIVEN_UART0_Pos)     /*!< NT_COMMON_REG UART_CLK: DIVEN_UART0 Mask */
#define NT_COMMON_REG_UART_CLK_DIV_UART0_Pos  2                                                       /*!< NT_COMMON_REG UART_CLK: DIV_UART0 Position */
#define NT_COMMON_REG_UART_CLK_DIV_UART0_Msk  (0x3fUL << NT_COMMON_REG_UART_CLK_DIV_UART0_Pos)        /*!< NT_COMMON_REG UART_CLK: DIV_UART0 Mask  */
#define NT_COMMON_REG_UART_CLK_CLKEN_UART1_Pos 8                                                      /*!< NT_COMMON_REG UART_CLK: CLKEN_UART1 Position */
#define NT_COMMON_REG_UART_CLK_CLKEN_UART1_Msk (0x01UL << NT_COMMON_REG_UART_CLK_CLKEN_UART1_Pos)     /*!< NT_COMMON_REG UART_CLK: CLKEN_UART1 Mask */
#define NT_COMMON_REG_UART_CLK_DIVEN_UART1_Pos 9                                                      /*!< NT_COMMON_REG UART_CLK: DIVEN_UART1 Position */
#define NT_COMMON_REG_UART_CLK_DIVEN_UART1_Msk (0x01UL << NT_COMMON_REG_UART_CLK_DIVEN_UART1_Pos)     /*!< NT_COMMON_REG UART_CLK: DIVEN_UART1 Mask */
#define NT_COMMON_REG_UART_CLK_DIV_UART1_Pos  10                                                      /*!< NT_COMMON_REG UART_CLK: DIV_UART1 Position */
#define NT_COMMON_REG_UART_CLK_DIV_UART1_Msk  (0x3fUL << NT_COMMON_REG_UART_CLK_DIV_UART1_Pos)        /*!< NT_COMMON_REG UART_CLK: DIV_UART1 Mask  */
#define NT_COMMON_REG_UART_CLK_CLKEN_UART2_Pos 16                                                     /*!< NT_COMMON_REG UART_CLK: CLKEN_UART2 Position */
#define NT_COMMON_REG_UART_CLK_CLKEN_UART2_Msk (0x01UL << NT_COMMON_REG_UART_CLK_CLKEN_UART2_Pos)     /*!< NT_COMMON_REG UART_CLK: CLKEN_UART2 Mask */
#define NT_COMMON_REG_UART_CLK_DIVEN_UART2_Pos 17                                                     /*!< NT_COMMON_REG UART_CLK: DIVEN_UART2 Position */
#define NT_COMMON_REG_UART_CLK_DIVEN_UART2_Msk (0x01UL << NT_COMMON_REG_UART_CLK_DIVEN_UART2_Pos)     /*!< NT_COMMON_REG UART_CLK: DIVEN_UART2 Mask */
#define NT_COMMON_REG_UART_CLK_DIV_UART2_Pos  18                                                      /*!< NT_COMMON_REG UART_CLK: DIV_UART2 Position */
#define NT_COMMON_REG_UART_CLK_DIV_UART2_Msk  (0x3fUL << NT_COMMON_REG_UART_CLK_DIV_UART2_Pos)        /*!< NT_COMMON_REG UART_CLK: DIV_UART2 Mask  */
#define NT_COMMON_REG_UART_CLK_CLKEN_UART3_Pos 24                                                     /*!< NT_COMMON_REG UART_CLK: CLKEN_UART3 Position */
#define NT_COMMON_REG_UART_CLK_CLKEN_UART3_Msk (0x01UL << NT_COMMON_REG_UART_CLK_CLKEN_UART3_Pos)     /*!< NT_COMMON_REG UART_CLK: CLKEN_UART3 Mask */
#define NT_COMMON_REG_UART_CLK_DIVEN_UART3_Pos 25                                                     /*!< NT_COMMON_REG UART_CLK: DIVEN_UART3 Position */
#define NT_COMMON_REG_UART_CLK_DIVEN_UART3_Msk (0x01UL << NT_COMMON_REG_UART_CLK_DIVEN_UART3_Pos)     /*!< NT_COMMON_REG UART_CLK: DIVEN_UART3 Mask */
#define NT_COMMON_REG_UART_CLK_DIV_UART3_Pos  26                                                      /*!< NT_COMMON_REG UART_CLK: DIV_UART3 Position */
#define NT_COMMON_REG_UART_CLK_DIV_UART3_Msk  (0x3fUL << NT_COMMON_REG_UART_CLK_DIV_UART3_Pos)        /*!< NT_COMMON_REG UART_CLK: DIV_UART3 Mask  */

/* ----------------------------  NT_COMMON_REG_SPI_CLK  --------------------------- */
#define NT_COMMON_REG_SPI_CLK_CLKEN_SPI0_Pos  0                                                       /*!< NT_COMMON_REG SPI_CLK: CLKEN_SPI0 Position */
#define NT_COMMON_REG_SPI_CLK_CLKEN_SPI0_Msk  (0x01UL << NT_COMMON_REG_SPI_CLK_CLKEN_SPI0_Pos)        /*!< NT_COMMON_REG SPI_CLK: CLKEN_SPI0 Mask  */
#define NT_COMMON_REG_SPI_CLK_DIVEN_SPI0_Pos  1                                                       /*!< NT_COMMON_REG SPI_CLK: DIVEN_SPI0 Position */
#define NT_COMMON_REG_SPI_CLK_DIVEN_SPI0_Msk  (0x01UL << NT_COMMON_REG_SPI_CLK_DIVEN_SPI0_Pos)        /*!< NT_COMMON_REG SPI_CLK: DIVEN_SPI0 Mask  */
#define NT_COMMON_REG_SPI_CLK_DIV_SPI0_Pos    2                                                       /*!< NT_COMMON_REG SPI_CLK: DIV_SPI0 Position */
#define NT_COMMON_REG_SPI_CLK_DIV_SPI0_Msk    (0x3fUL << NT_COMMON_REG_SPI_CLK_DIV_SPI0_Pos)          /*!< NT_COMMON_REG SPI_CLK: DIV_SPI0 Mask    */
#define NT_COMMON_REG_SPI_CLK_CLKEN_SPI1_Pos  8                                                       /*!< NT_COMMON_REG SPI_CLK: CLKEN_SPI1 Position */
#define NT_COMMON_REG_SPI_CLK_CLKEN_SPI1_Msk  (0x01UL << NT_COMMON_REG_SPI_CLK_CLKEN_SPI1_Pos)        /*!< NT_COMMON_REG SPI_CLK: CLKEN_SPI1 Mask  */
#define NT_COMMON_REG_SPI_CLK_DIVEN_SPI1_Pos  9                                                       /*!< NT_COMMON_REG SPI_CLK: DIVEN_SPI1 Position */
#define NT_COMMON_REG_SPI_CLK_DIVEN_SPI1_Msk  (0x01UL << NT_COMMON_REG_SPI_CLK_DIVEN_SPI1_Pos)        /*!< NT_COMMON_REG SPI_CLK: DIVEN_SPI1 Mask  */
#define NT_COMMON_REG_SPI_CLK_DIV_SPI1_Pos    10                                                      /*!< NT_COMMON_REG SPI_CLK: DIV_SPI1 Position */
#define NT_COMMON_REG_SPI_CLK_DIV_SPI1_Msk    (0x3fUL << NT_COMMON_REG_SPI_CLK_DIV_SPI1_Pos)          /*!< NT_COMMON_REG SPI_CLK: DIV_SPI1 Mask    */
#define NT_COMMON_REG_SPI_CLK_CLKEN_SPI2_Pos  16                                                      /*!< NT_COMMON_REG SPI_CLK: CLKEN_SPI2 Position */
#define NT_COMMON_REG_SPI_CLK_CLKEN_SPI2_Msk  (0x01UL << NT_COMMON_REG_SPI_CLK_CLKEN_SPI2_Pos)        /*!< NT_COMMON_REG SPI_CLK: CLKEN_SPI2 Mask  */
#define NT_COMMON_REG_SPI_CLK_DIVEN_SPI2_Pos  17                                                      /*!< NT_COMMON_REG SPI_CLK: DIVEN_SPI2 Position */
#define NT_COMMON_REG_SPI_CLK_DIVEN_SPI2_Msk  (0x01UL << NT_COMMON_REG_SPI_CLK_DIVEN_SPI2_Pos)        /*!< NT_COMMON_REG SPI_CLK: DIVEN_SPI2 Mask  */
#define NT_COMMON_REG_SPI_CLK_DIV_SPI2_Pos    18                                                      /*!< NT_COMMON_REG SPI_CLK: DIV_SPI2 Position */
#define NT_COMMON_REG_SPI_CLK_DIV_SPI2_Msk    (0x3fUL << NT_COMMON_REG_SPI_CLK_DIV_SPI2_Pos)          /*!< NT_COMMON_REG SPI_CLK: DIV_SPI2 Mask    */
#define NT_COMMON_REG_SPI_CLK_CLKEN_SPI3_Pos  24                                                      /*!< NT_COMMON_REG SPI_CLK: CLKEN_SPI3 Position */
#define NT_COMMON_REG_SPI_CLK_CLKEN_SPI3_Msk  (0x01UL << NT_COMMON_REG_SPI_CLK_CLKEN_SPI3_Pos)        /*!< NT_COMMON_REG SPI_CLK: CLKEN_SPI3 Mask  */
#define NT_COMMON_REG_SPI_CLK_DIVEN_SPI3_Pos  25                                                      /*!< NT_COMMON_REG SPI_CLK: DIVEN_SPI3 Position */
#define NT_COMMON_REG_SPI_CLK_DIVEN_SPI3_Msk  (0x01UL << NT_COMMON_REG_SPI_CLK_DIVEN_SPI3_Pos)        /*!< NT_COMMON_REG SPI_CLK: DIVEN_SPI3 Mask  */
#define NT_COMMON_REG_SPI_CLK_DIV_SPI3_Pos    26                                                      /*!< NT_COMMON_REG SPI_CLK: DIV_SPI3 Position */
#define NT_COMMON_REG_SPI_CLK_DIV_SPI3_Msk    (0x3fUL << NT_COMMON_REG_SPI_CLK_DIV_SPI3_Pos)          /*!< NT_COMMON_REG SPI_CLK: DIV_SPI3 Mask    */

/* ---------------------------  NT_COMMON_REG_PER_RST0  --------------------------- */
#define NT_COMMON_REG_PER_RST0_WDRST_Pos      0                                                       /*!< NT_COMMON_REG PER_RST0: WDRST Position  */
#define NT_COMMON_REG_PER_RST0_WDRST_Msk      (0x01UL << NT_COMMON_REG_PER_RST0_WDRST_Pos)            /*!< NT_COMMON_REG PER_RST0: WDRST Mask      */
#define NT_COMMON_REG_PER_RST0_I2CRST0_Pos    1                                                       /*!< NT_COMMON_REG PER_RST0: I2CRST0 Position */
#define NT_COMMON_REG_PER_RST0_I2CRST0_Msk    (0x01UL << NT_COMMON_REG_PER_RST0_I2CRST0_Pos)          /*!< NT_COMMON_REG PER_RST0: I2CRST0 Mask    */
#define NT_COMMON_REG_PER_RST0_I2CRST1_Pos    2                                                       /*!< NT_COMMON_REG PER_RST0: I2CRST1 Position */
#define NT_COMMON_REG_PER_RST0_I2CRST1_Msk    (0x01UL << NT_COMMON_REG_PER_RST0_I2CRST1_Pos)          /*!< NT_COMMON_REG PER_RST0: I2CRST1 Mask    */
#define NT_COMMON_REG_PER_RST0_USBPHYRST_Pos  3                                                       /*!< NT_COMMON_REG PER_RST0: USBPHYRST Position */
#define NT_COMMON_REG_PER_RST0_USBPHYRST_Msk  (0x01UL << NT_COMMON_REG_PER_RST0_USBPHYRST_Pos)        /*!< NT_COMMON_REG PER_RST0: USBPHYRST Mask  */
#define NT_COMMON_REG_PER_RST0_TIMERRST0_Pos  4                                                       /*!< NT_COMMON_REG PER_RST0: TIMERRST0 Position */
#define NT_COMMON_REG_PER_RST0_TIMERRST0_Msk  (0x01UL << NT_COMMON_REG_PER_RST0_TIMERRST0_Pos)        /*!< NT_COMMON_REG PER_RST0: TIMERRST0 Mask  */
#define NT_COMMON_REG_PER_RST0_TIMERRST1_Pos  5                                                       /*!< NT_COMMON_REG PER_RST0: TIMERRST1 Position */
#define NT_COMMON_REG_PER_RST0_TIMERRST1_Msk  (0x01UL << NT_COMMON_REG_PER_RST0_TIMERRST1_Pos)        /*!< NT_COMMON_REG PER_RST0: TIMERRST1 Mask  */
#define NT_COMMON_REG_PER_RST0_TIMERRST2_Pos  6                                                       /*!< NT_COMMON_REG PER_RST0: TIMERRST2 Position */
#define NT_COMMON_REG_PER_RST0_TIMERRST2_Msk  (0x01UL << NT_COMMON_REG_PER_RST0_TIMERRST2_Pos)        /*!< NT_COMMON_REG PER_RST0: TIMERRST2 Mask  */
#define NT_COMMON_REG_PER_RST0_UARTRST0_Pos   7                                                       /*!< NT_COMMON_REG PER_RST0: UARTRST0 Position */
#define NT_COMMON_REG_PER_RST0_UARTRST0_Msk   (0x01UL << NT_COMMON_REG_PER_RST0_UARTRST0_Pos)         /*!< NT_COMMON_REG PER_RST0: UARTRST0 Mask   */
#define NT_COMMON_REG_PER_RST0_UARTRST1_Pos   8                                                       /*!< NT_COMMON_REG PER_RST0: UARTRST1 Position */
#define NT_COMMON_REG_PER_RST0_UARTRST1_Msk   (0x01UL << NT_COMMON_REG_PER_RST0_UARTRST1_Pos)         /*!< NT_COMMON_REG PER_RST0: UARTRST1 Mask   */
#define NT_COMMON_REG_PER_RST0_UARTRST2_Pos   9                                                       /*!< NT_COMMON_REG PER_RST0: UARTRST2 Position */
#define NT_COMMON_REG_PER_RST0_UARTRST2_Msk   (0x01UL << NT_COMMON_REG_PER_RST0_UARTRST2_Pos)         /*!< NT_COMMON_REG PER_RST0: UARTRST2 Mask   */
#define NT_COMMON_REG_PER_RST0_UARTRST3_Pos   10                                                      /*!< NT_COMMON_REG PER_RST0: UARTRST3 Position */
#define NT_COMMON_REG_PER_RST0_UARTRST3_Msk   (0x01UL << NT_COMMON_REG_PER_RST0_UARTRST3_Pos)         /*!< NT_COMMON_REG PER_RST0: UARTRST3 Mask   */
#define NT_COMMON_REG_PER_RST0_SPIRST0_Pos    11                                                      /*!< NT_COMMON_REG PER_RST0: SPIRST0 Position */
#define NT_COMMON_REG_PER_RST0_SPIRST0_Msk    (0x01UL << NT_COMMON_REG_PER_RST0_SPIRST0_Pos)          /*!< NT_COMMON_REG PER_RST0: SPIRST0 Mask    */
#define NT_COMMON_REG_PER_RST0_SPIRST1_Pos    12                                                      /*!< NT_COMMON_REG PER_RST0: SPIRST1 Position */
#define NT_COMMON_REG_PER_RST0_SPIRST1_Msk    (0x01UL << NT_COMMON_REG_PER_RST0_SPIRST1_Pos)          /*!< NT_COMMON_REG PER_RST0: SPIRST1 Mask    */
#define NT_COMMON_REG_PER_RST0_SPIRST2_Pos    13                                                      /*!< NT_COMMON_REG PER_RST0: SPIRST2 Position */
#define NT_COMMON_REG_PER_RST0_SPIRST2_Msk    (0x01UL << NT_COMMON_REG_PER_RST0_SPIRST2_Pos)          /*!< NT_COMMON_REG PER_RST0: SPIRST2 Mask    */
#define NT_COMMON_REG_PER_RST0_SPIRST3_Pos    14                                                      /*!< NT_COMMON_REG PER_RST0: SPIRST3 Position */
#define NT_COMMON_REG_PER_RST0_SPIRST3_Msk    (0x01UL << NT_COMMON_REG_PER_RST0_SPIRST3_Pos)          /*!< NT_COMMON_REG PER_RST0: SPIRST3 Mask    */
#define NT_COMMON_REG_PER_RST0_ETHRST_Pos     15                                                      /*!< NT_COMMON_REG PER_RST0: ETHRST Position */
#define NT_COMMON_REG_PER_RST0_ETHRST_Msk     (0x01UL << NT_COMMON_REG_PER_RST0_ETHRST_Pos)           /*!< NT_COMMON_REG PER_RST0: ETHRST Mask     */

/* ---------------------------  NT_COMMON_REG_PER_RST1  --------------------------- */
#define NT_COMMON_REG_PER_RST1_QEPRST0_Pos    0                                                       /*!< NT_COMMON_REG PER_RST1: QEPRST0 Position */
#define NT_COMMON_REG_PER_RST1_QEPRST0_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_QEPRST0_Pos)          /*!< NT_COMMON_REG PER_RST1: QEPRST0 Mask    */
#define NT_COMMON_REG_PER_RST1_QEPRST1_Pos    1                                                       /*!< NT_COMMON_REG PER_RST1: QEPRST1 Position */
#define NT_COMMON_REG_PER_RST1_QEPRST1_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_QEPRST1_Pos)          /*!< NT_COMMON_REG PER_RST1: QEPRST1 Mask    */
#define NT_COMMON_REG_PER_RST1_PWMRST0_Pos    2                                                       /*!< NT_COMMON_REG PER_RST1: PWMRST0 Position */
#define NT_COMMON_REG_PER_RST1_PWMRST0_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_PWMRST0_Pos)          /*!< NT_COMMON_REG PER_RST1: PWMRST0 Mask    */
#define NT_COMMON_REG_PER_RST1_PWMRST1_Pos    3                                                       /*!< NT_COMMON_REG PER_RST1: PWMRST1 Position */
#define NT_COMMON_REG_PER_RST1_PWMRST1_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_PWMRST1_Pos)          /*!< NT_COMMON_REG PER_RST1: PWMRST1 Mask    */
#define NT_COMMON_REG_PER_RST1_PWMRST2_Pos    4                                                       /*!< NT_COMMON_REG PER_RST1: PWMRST2 Position */
#define NT_COMMON_REG_PER_RST1_PWMRST2_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_PWMRST2_Pos)          /*!< NT_COMMON_REG PER_RST1: PWMRST2 Mask    */
#define NT_COMMON_REG_PER_RST1_PWMRST3_Pos    5                                                       /*!< NT_COMMON_REG PER_RST1: PWMRST3 Position */
#define NT_COMMON_REG_PER_RST1_PWMRST3_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_PWMRST3_Pos)          /*!< NT_COMMON_REG PER_RST1: PWMRST3 Mask    */
#define NT_COMMON_REG_PER_RST1_PWMRST4_Pos    6                                                       /*!< NT_COMMON_REG PER_RST1: PWMRST4 Position */
#define NT_COMMON_REG_PER_RST1_PWMRST4_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_PWMRST4_Pos)          /*!< NT_COMMON_REG PER_RST1: PWMRST4 Mask    */
#define NT_COMMON_REG_PER_RST1_PWMRST5_Pos    7                                                       /*!< NT_COMMON_REG PER_RST1: PWMRST5 Position */
#define NT_COMMON_REG_PER_RST1_PWMRST5_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_PWMRST5_Pos)          /*!< NT_COMMON_REG PER_RST1: PWMRST5 Mask    */
#define NT_COMMON_REG_PER_RST1_PWMRST6_Pos    8                                                       /*!< NT_COMMON_REG PER_RST1: PWMRST6 Position */
#define NT_COMMON_REG_PER_RST1_PWMRST6_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_PWMRST6_Pos)          /*!< NT_COMMON_REG PER_RST1: PWMRST6 Mask    */
#define NT_COMMON_REG_PER_RST1_PWMRST7_Pos    9                                                       /*!< NT_COMMON_REG PER_RST1: PWMRST7 Position */
#define NT_COMMON_REG_PER_RST1_PWMRST7_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_PWMRST7_Pos)          /*!< NT_COMMON_REG PER_RST1: PWMRST7 Mask    */
#define NT_COMMON_REG_PER_RST1_PWMRST8_Pos    10                                                      /*!< NT_COMMON_REG PER_RST1: PWMRST8 Position */
#define NT_COMMON_REG_PER_RST1_PWMRST8_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_PWMRST8_Pos)          /*!< NT_COMMON_REG PER_RST1: PWMRST8 Mask    */
#define NT_COMMON_REG_PER_RST1_CAPRST0_Pos    11                                                      /*!< NT_COMMON_REG PER_RST1: CAPRST0 Position */
#define NT_COMMON_REG_PER_RST1_CAPRST0_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_CAPRST0_Pos)          /*!< NT_COMMON_REG PER_RST1: CAPRST0 Mask    */
#define NT_COMMON_REG_PER_RST1_CAPRST1_Pos    12                                                      /*!< NT_COMMON_REG PER_RST1: CAPRST1 Position */
#define NT_COMMON_REG_PER_RST1_CAPRST1_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_CAPRST1_Pos)          /*!< NT_COMMON_REG PER_RST1: CAPRST1 Mask    */
#define NT_COMMON_REG_PER_RST1_CAPRST2_Pos    13                                                      /*!< NT_COMMON_REG PER_RST1: CAPRST2 Position */
#define NT_COMMON_REG_PER_RST1_CAPRST2_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_CAPRST2_Pos)          /*!< NT_COMMON_REG PER_RST1: CAPRST2 Mask    */
#define NT_COMMON_REG_PER_RST1_CAPRST3_Pos    14                                                      /*!< NT_COMMON_REG PER_RST1: CAPRST3 Position */
#define NT_COMMON_REG_PER_RST1_CAPRST3_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_CAPRST3_Pos)          /*!< NT_COMMON_REG PER_RST1: CAPRST3 Mask    */
#define NT_COMMON_REG_PER_RST1_CAPRST4_Pos    15                                                      /*!< NT_COMMON_REG PER_RST1: CAPRST4 Position */
#define NT_COMMON_REG_PER_RST1_CAPRST4_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_CAPRST4_Pos)          /*!< NT_COMMON_REG PER_RST1: CAPRST4 Mask    */
#define NT_COMMON_REG_PER_RST1_CAPRST5_Pos    16                                                      /*!< NT_COMMON_REG PER_RST1: CAPRST5 Position */
#define NT_COMMON_REG_PER_RST1_CAPRST5_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_CAPRST5_Pos)          /*!< NT_COMMON_REG PER_RST1: CAPRST5 Mask    */
#define NT_COMMON_REG_PER_RST1_ECMPRST_Pos    17                                                      /*!< NT_COMMON_REG PER_RST1: ECMPRST Position */
#define NT_COMMON_REG_PER_RST1_ECMPRST_Msk    (0x01UL << NT_COMMON_REG_PER_RST1_ECMPRST_Pos)          /*!< NT_COMMON_REG PER_RST1: ECMPRST Mask    */

/* ----------------------------  NT_COMMON_REG_GPIOSE0  --------------------------- */
#define NT_COMMON_REG_GPIOSE0_PORTA_Pos       0                                                       /*!< NT_COMMON_REG GPIOSE0: PORTA Position   */
#define NT_COMMON_REG_GPIOSE0_PORTA_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOSE0_PORTA_Pos)       /*!< NT_COMMON_REG GPIOSE0: PORTA Mask       */
#define NT_COMMON_REG_GPIOSE0_PORTB_Pos       16                                                      /*!< NT_COMMON_REG GPIOSE0: PORTB Position   */
#define NT_COMMON_REG_GPIOSE0_PORTB_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOSE0_PORTB_Pos)       /*!< NT_COMMON_REG GPIOSE0: PORTB Mask       */

/* ----------------------------  NT_COMMON_REG_GPIOSE1  --------------------------- */
#define NT_COMMON_REG_GPIOSE1_PORTC_Pos       0                                                       /*!< NT_COMMON_REG GPIOSE1: PORTC Position   */
#define NT_COMMON_REG_GPIOSE1_PORTC_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOSE1_PORTC_Pos)       /*!< NT_COMMON_REG GPIOSE1: PORTC Mask       */
#define NT_COMMON_REG_GPIOSE1_PORTD_Pos       16                                                      /*!< NT_COMMON_REG GPIOSE1: PORTD Position   */
#define NT_COMMON_REG_GPIOSE1_PORTD_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOSE1_PORTD_Pos)       /*!< NT_COMMON_REG GPIOSE1: PORTD Mask       */

/* ----------------------------  NT_COMMON_REG_GPIOSE2  --------------------------- */
#define NT_COMMON_REG_GPIOSE2_PORTE_Pos       0                                                       /*!< NT_COMMON_REG GPIOSE2: PORTE Position   */
#define NT_COMMON_REG_GPIOSE2_PORTE_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOSE2_PORTE_Pos)       /*!< NT_COMMON_REG GPIOSE2: PORTE Mask       */
#define NT_COMMON_REG_GPIOSE2_PORTF_Pos       16                                                      /*!< NT_COMMON_REG GPIOSE2: PORTF Position   */
#define NT_COMMON_REG_GPIOSE2_PORTF_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOSE2_PORTF_Pos)       /*!< NT_COMMON_REG GPIOSE2: PORTF Mask       */

/* ----------------------------  NT_COMMON_REG_GPIOSE3  --------------------------- */
#define NT_COMMON_REG_GPIOSE3_PORTG_Pos       0                                                       /*!< NT_COMMON_REG GPIOSE3: PORTG Position   */
#define NT_COMMON_REG_GPIOSE3_PORTG_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOSE3_PORTG_Pos)       /*!< NT_COMMON_REG GPIOSE3: PORTG Mask       */
#define NT_COMMON_REG_GPIOSE3_PORTH_Pos       16                                                      /*!< NT_COMMON_REG GPIOSE3: PORTH Position   */
#define NT_COMMON_REG_GPIOSE3_PORTH_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOSE3_PORTH_Pos)       /*!< NT_COMMON_REG GPIOSE3: PORTH Mask       */

/* ----------------------------  NT_COMMON_REG_GPIOQE0  --------------------------- */
#define NT_COMMON_REG_GPIOQE0_PORTA_Pos       0                                                       /*!< NT_COMMON_REG GPIOQE0: PORTA Position   */
#define NT_COMMON_REG_GPIOQE0_PORTA_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQE0_PORTA_Pos)       /*!< NT_COMMON_REG GPIOQE0: PORTA Mask       */
#define NT_COMMON_REG_GPIOQE0_PORTB_Pos       16                                                      /*!< NT_COMMON_REG GPIOQE0: PORTB Position   */
#define NT_COMMON_REG_GPIOQE0_PORTB_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQE0_PORTB_Pos)       /*!< NT_COMMON_REG GPIOQE0: PORTB Mask       */

/* ----------------------------  NT_COMMON_REG_GPIOQE1  --------------------------- */
#define NT_COMMON_REG_GPIOQE1_PORTC_Pos       0                                                       /*!< NT_COMMON_REG GPIOQE1: PORTC Position   */
#define NT_COMMON_REG_GPIOQE1_PORTC_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQE1_PORTC_Pos)       /*!< NT_COMMON_REG GPIOQE1: PORTC Mask       */
#define NT_COMMON_REG_GPIOQE1_PORTD_Pos       16                                                      /*!< NT_COMMON_REG GPIOQE1: PORTD Position   */
#define NT_COMMON_REG_GPIOQE1_PORTD_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQE1_PORTD_Pos)       /*!< NT_COMMON_REG GPIOQE1: PORTD Mask       */

/* ----------------------------  NT_COMMON_REG_GPIOQE2  --------------------------- */
#define NT_COMMON_REG_GPIOQE2_PORTE_Pos       0                                                       /*!< NT_COMMON_REG GPIOQE2: PORTE Position   */
#define NT_COMMON_REG_GPIOQE2_PORTE_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQE2_PORTE_Pos)       /*!< NT_COMMON_REG GPIOQE2: PORTE Mask       */
#define NT_COMMON_REG_GPIOQE2_PORTF_Pos       16                                                      /*!< NT_COMMON_REG GPIOQE2: PORTF Position   */
#define NT_COMMON_REG_GPIOQE2_PORTF_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQE2_PORTF_Pos)       /*!< NT_COMMON_REG GPIOQE2: PORTF Mask       */

/* ----------------------------  NT_COMMON_REG_GPIOQE3  --------------------------- */
#define NT_COMMON_REG_GPIOQE3_PORTG_Pos       0                                                       /*!< NT_COMMON_REG GPIOQE3: PORTG Position   */
#define NT_COMMON_REG_GPIOQE3_PORTG_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQE3_PORTG_Pos)       /*!< NT_COMMON_REG GPIOQE3: PORTG Mask       */
#define NT_COMMON_REG_GPIOQE3_PORTH_Pos       16                                                      /*!< NT_COMMON_REG GPIOQE3: PORTH Position   */
#define NT_COMMON_REG_GPIOQE3_PORTH_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQE3_PORTH_Pos)       /*!< NT_COMMON_REG GPIOQE3: PORTH Mask       */

/* ----------------------------  NT_COMMON_REG_GPIOQM0  --------------------------- */
#define NT_COMMON_REG_GPIOQM0_PORTA_Pos       0                                                       /*!< NT_COMMON_REG GPIOQM0: PORTA Position   */
#define NT_COMMON_REG_GPIOQM0_PORTA_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQM0_PORTA_Pos)       /*!< NT_COMMON_REG GPIOQM0: PORTA Mask       */
#define NT_COMMON_REG_GPIOQM0_PORTB_Pos       16                                                      /*!< NT_COMMON_REG GPIOQM0: PORTB Position   */
#define NT_COMMON_REG_GPIOQM0_PORTB_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQM0_PORTB_Pos)       /*!< NT_COMMON_REG GPIOQM0: PORTB Mask       */

/* ----------------------------  NT_COMMON_REG_GPIOQM1  --------------------------- */
#define NT_COMMON_REG_GPIOQM1_PORTC_Pos       0                                                       /*!< NT_COMMON_REG GPIOQM1: PORTC Position   */
#define NT_COMMON_REG_GPIOQM1_PORTC_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQM1_PORTC_Pos)       /*!< NT_COMMON_REG GPIOQM1: PORTC Mask       */
#define NT_COMMON_REG_GPIOQM1_PORTD_Pos       16                                                      /*!< NT_COMMON_REG GPIOQM1: PORTD Position   */
#define NT_COMMON_REG_GPIOQM1_PORTD_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQM1_PORTD_Pos)       /*!< NT_COMMON_REG GPIOQM1: PORTD Mask       */

/* ----------------------------  NT_COMMON_REG_GPIOQM2  --------------------------- */
#define NT_COMMON_REG_GPIOQM2_PORTE_Pos       0                                                       /*!< NT_COMMON_REG GPIOQM2: PORTE Position   */
#define NT_COMMON_REG_GPIOQM2_PORTE_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQM2_PORTE_Pos)       /*!< NT_COMMON_REG GPIOQM2: PORTE Mask       */
#define NT_COMMON_REG_GPIOQM2_PORTF_Pos       16                                                      /*!< NT_COMMON_REG GPIOQM2: PORTF Position   */
#define NT_COMMON_REG_GPIOQM2_PORTF_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQM2_PORTF_Pos)       /*!< NT_COMMON_REG GPIOQM2: PORTF Mask       */

/* ----------------------------  NT_COMMON_REG_GPIOQM3  --------------------------- */
#define NT_COMMON_REG_GPIOQM3_PORTG_Pos       0                                                       /*!< NT_COMMON_REG GPIOQM3: PORTG Position   */
#define NT_COMMON_REG_GPIOQM3_PORTG_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQM3_PORTG_Pos)       /*!< NT_COMMON_REG GPIOQM3: PORTG Mask       */
#define NT_COMMON_REG_GPIOQM3_PORTH_Pos       16                                                      /*!< NT_COMMON_REG GPIOQM3: PORTH Position   */
#define NT_COMMON_REG_GPIOQM3_PORTH_Msk       (0x0000ffffUL << NT_COMMON_REG_GPIOQM3_PORTH_Pos)       /*!< NT_COMMON_REG GPIOQM3: PORTH Mask       */

/* ---------------------------  NT_COMMON_REG_GPIOQPAD  --------------------------- */
#define NT_COMMON_REG_GPIOQPAD_SPRDA_Pos      0                                                       /*!< NT_COMMON_REG GPIOQPAD: SPRDA Position  */
#define NT_COMMON_REG_GPIOQPAD_SPRDA_Msk      (0x000000ffUL << NT_COMMON_REG_GPIOQPAD_SPRDA_Pos)      /*!< NT_COMMON_REG GPIOQPAD: SPRDA Mask      */
#define NT_COMMON_REG_GPIOQPAD_SPRDB_Pos      8                                                       /*!< NT_COMMON_REG GPIOQPAD: SPRDB Position  */
#define NT_COMMON_REG_GPIOQPAD_SPRDB_Msk      (0x000000ffUL << NT_COMMON_REG_GPIOQPAD_SPRDB_Pos)      /*!< NT_COMMON_REG GPIOQPAD: SPRDB Mask      */
#define NT_COMMON_REG_GPIOQPAD_SPRDC_Pos      16                                                      /*!< NT_COMMON_REG GPIOQPAD: SPRDC Position  */
#define NT_COMMON_REG_GPIOQPAD_SPRDC_Msk      (0x000000ffUL << NT_COMMON_REG_GPIOQPAD_SPRDC_Pos)      /*!< NT_COMMON_REG GPIOQPAD: SPRDC Mask      */
#define NT_COMMON_REG_GPIOQPAD_SPRDD_Pos      24                                                      /*!< NT_COMMON_REG GPIOQPAD: SPRDD Position  */
#define NT_COMMON_REG_GPIOQPAD_SPRDD_Msk      (0x000000ffUL << NT_COMMON_REG_GPIOQPAD_SPRDD_Pos)      /*!< NT_COMMON_REG GPIOQPAD: SPRDD Mask      */

/* ---------------------------  NT_COMMON_REG_GPIOQPEH  --------------------------- */
#define NT_COMMON_REG_GPIOQPEH_SPRDE_Pos      0                                                       /*!< NT_COMMON_REG GPIOQPEH: SPRDE Position  */
#define NT_COMMON_REG_GPIOQPEH_SPRDE_Msk      (0x000000ffUL << NT_COMMON_REG_GPIOQPEH_SPRDE_Pos)      /*!< NT_COMMON_REG GPIOQPEH: SPRDE Mask      */
#define NT_COMMON_REG_GPIOQPEH_SPRDF_Pos      8                                                       /*!< NT_COMMON_REG GPIOQPEH: SPRDF Position  */
#define NT_COMMON_REG_GPIOQPEH_SPRDF_Msk      (0x000000ffUL << NT_COMMON_REG_GPIOQPEH_SPRDF_Pos)      /*!< NT_COMMON_REG GPIOQPEH: SPRDF Mask      */
#define NT_COMMON_REG_GPIOQPEH_SPRDG_Pos      16                                                      /*!< NT_COMMON_REG GPIOQPEH: SPRDG Position  */
#define NT_COMMON_REG_GPIOQPEH_SPRDG_Msk      (0x000000ffUL << NT_COMMON_REG_GPIOQPEH_SPRDG_Pos)      /*!< NT_COMMON_REG GPIOQPEH: SPRDG Mask      */
#define NT_COMMON_REG_GPIOQPEH_SPRDH_Pos      24                                                      /*!< NT_COMMON_REG GPIOQPEH: SPRDH Position  */
#define NT_COMMON_REG_GPIOQPEH_SPRDH_Msk      (0x000000ffUL << NT_COMMON_REG_GPIOQPEH_SPRDH_Pos)      /*!< NT_COMMON_REG GPIOQPEH: SPRDH Mask      */

/* ---------------------------  NT_COMMON_REG_USB_CTRL  --------------------------- */
#define NT_COMMON_REG_USB_CTRL_FSEL_Pos       0                                                       /*!< NT_COMMON_REG USB_CTRL: FSEL Position   */
#define NT_COMMON_REG_USB_CTRL_FSEL_Msk       (0x01UL << NT_COMMON_REG_USB_CTRL_FSEL_Pos)             /*!< NT_COMMON_REG USB_CTRL: FSEL Mask       */
#define NT_COMMON_REG_USB_CTRL_CLKSEL_Pos     1                                                       /*!< NT_COMMON_REG USB_CTRL: CLKSEL Position */
#define NT_COMMON_REG_USB_CTRL_CLKSEL_Msk     (0x01UL << NT_COMMON_REG_USB_CTRL_CLKSEL_Pos)           /*!< NT_COMMON_REG USB_CTRL: CLKSEL Mask     */
#define NT_COMMON_REG_USB_CTRL_CLKEN_Pos      2                                                       /*!< NT_COMMON_REG USB_CTRL: CLKEN Position  */
#define NT_COMMON_REG_USB_CTRL_CLKEN_Msk      (0x01UL << NT_COMMON_REG_USB_CTRL_CLKEN_Pos)            /*!< NT_COMMON_REG USB_CTRL: CLKEN Mask      */

/* -----------------------  NT_COMMON_REG_UART_SPI_CLK_SEL  ----------------------- */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART0_Pos 0                                                /*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_UART0 Position */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART0_Msk (0x03UL << NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART0_Pos)/*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_UART0 Mask */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART1_Pos 2                                                /*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_UART1 Position */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART1_Msk (0x03UL << NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART1_Pos)/*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_UART1 Mask */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART2_Pos 4                                                /*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_UART2 Position */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART2_Msk (0x03UL << NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART2_Pos)/*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_UART2 Mask */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART3_Pos 6                                                /*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_UART3 Position */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART3_Msk (0x03UL << NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_UART3_Pos)/*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_UART3 Mask */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI0_Pos 8                                                 /*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_SPI0 Position */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI0_Msk (0x03UL << NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI0_Pos)/*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_SPI0 Mask */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI1_Pos 10                                                /*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_SPI1 Position */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI1_Msk (0x03UL << NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI1_Pos)/*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_SPI1 Mask */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI2_Pos 12                                                /*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_SPI2 Position */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI2_Msk (0x03UL << NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI2_Pos)/*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_SPI2 Mask */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI3_Pos 14                                                /*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_SPI3 Position */
#define NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI3_Msk (0x03UL << NT_COMMON_REG_UART_SPI_CLK_SEL_SEL_SPI3_Pos)/*!< NT_COMMON_REG UART_SPI_CLK_SEL: SEL_SPI3 Mask */

/* ---------------------------  NT_COMMON_REG_ADC_CTRL2  -------------------------- */
#define NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC8_Pos 0                                                      /*!< NT_COMMON_REG ADC_CTRL2: CLKEN_ADC8 Position */
#define NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC8_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC8_Pos)     /*!< NT_COMMON_REG ADC_CTRL2: CLKEN_ADC8 Mask */
#define NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC8_Pos 1                                                      /*!< NT_COMMON_REG ADC_CTRL2: DIVEN_ADC8 Position */
#define NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC8_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC8_Pos)     /*!< NT_COMMON_REG ADC_CTRL2: DIVEN_ADC8 Mask */
#define NT_COMMON_REG_ADC_CTRL2_DIV_ADC8_Pos  2                                                       /*!< NT_COMMON_REG ADC_CTRL2: DIV_ADC8 Position */
#define NT_COMMON_REG_ADC_CTRL2_DIV_ADC8_Msk  (0x3fUL << NT_COMMON_REG_ADC_CTRL2_DIV_ADC8_Pos)        /*!< NT_COMMON_REG ADC_CTRL2: DIV_ADC8 Mask  */
#define NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC9_Pos 8                                                      /*!< NT_COMMON_REG ADC_CTRL2: CLKEN_ADC9 Position */
#define NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC9_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC9_Pos)     /*!< NT_COMMON_REG ADC_CTRL2: CLKEN_ADC9 Mask */
#define NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC9_Pos 9                                                      /*!< NT_COMMON_REG ADC_CTRL2: DIVEN_ADC9 Position */
#define NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC9_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC9_Pos)     /*!< NT_COMMON_REG ADC_CTRL2: DIVEN_ADC9 Mask */
#define NT_COMMON_REG_ADC_CTRL2_DIV_ADC9_Pos  10                                                      /*!< NT_COMMON_REG ADC_CTRL2: DIV_ADC9 Position */
#define NT_COMMON_REG_ADC_CTRL2_DIV_ADC9_Msk  (0x3fUL << NT_COMMON_REG_ADC_CTRL2_DIV_ADC9_Pos)        /*!< NT_COMMON_REG ADC_CTRL2: DIV_ADC9 Mask  */
#define NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC10_Pos 16                                                    /*!< NT_COMMON_REG ADC_CTRL2: CLKEN_ADC10 Position */
#define NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC10_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC10_Pos)   /*!< NT_COMMON_REG ADC_CTRL2: CLKEN_ADC10 Mask */
#define NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC10_Pos 17                                                    /*!< NT_COMMON_REG ADC_CTRL2: DIVEN_ADC10 Position */
#define NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC10_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC10_Pos)   /*!< NT_COMMON_REG ADC_CTRL2: DIVEN_ADC10 Mask */
#define NT_COMMON_REG_ADC_CTRL2_DIV_ADC10_Pos 18                                                      /*!< NT_COMMON_REG ADC_CTRL2: DIV_ADC10 Position */
#define NT_COMMON_REG_ADC_CTRL2_DIV_ADC10_Msk (0x3fUL << NT_COMMON_REG_ADC_CTRL2_DIV_ADC10_Pos)       /*!< NT_COMMON_REG ADC_CTRL2: DIV_ADC10 Mask */
#define NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC11_Pos 24                                                    /*!< NT_COMMON_REG ADC_CTRL2: CLKEN_ADC11 Position */
#define NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC11_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL2_CLKEN_ADC11_Pos)   /*!< NT_COMMON_REG ADC_CTRL2: CLKEN_ADC11 Mask */
#define NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC11_Pos 25                                                    /*!< NT_COMMON_REG ADC_CTRL2: DIVEN_ADC11 Position */
#define NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC11_Msk (0x01UL << NT_COMMON_REG_ADC_CTRL2_DIVEN_ADC11_Pos)   /*!< NT_COMMON_REG ADC_CTRL2: DIVEN_ADC11 Mask */
#define NT_COMMON_REG_ADC_CTRL2_DIV_ADC11_Pos 26                                                      /*!< NT_COMMON_REG ADC_CTRL2: DIV_ADC11 Position */
#define NT_COMMON_REG_ADC_CTRL2_DIV_ADC11_Msk (0x3fUL << NT_COMMON_REG_ADC_CTRL2_DIV_ADC11_Pos)       /*!< NT_COMMON_REG ADC_CTRL2: DIV_ADC11 Mask */

/* -----------------------  NT_COMMON_REG_FLASH_FULL_ERASE  ----------------------- */
#define NT_COMMON_REG_FLASH_FULL_ERASE_ERASE_FLASH_Pos 0                                              /*!< NT_COMMON_REG FLASH_FULL_ERASE: ERASE_FLASH Position */
#define NT_COMMON_REG_FLASH_FULL_ERASE_ERASE_FLASH_Msk (0x01UL << NT_COMMON_REG_FLASH_FULL_ERASE_ERASE_FLASH_Pos)/*!< NT_COMMON_REG FLASH_FULL_ERASE: ERASE_FLASH Mask */


/* ================================================================================ */
/* ================         struct 'NT_CAN' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  NT_CAN_CLC  --------------------------------- */
#define NT_CAN_CLC_DISR_Pos                   0                                                       /*!< NT_CAN CLC: DISR Position               */
#define NT_CAN_CLC_DISR_Msk                   (0x01UL << NT_CAN_CLC_DISR_Pos)                         /*!< NT_CAN CLC: DISR Mask                   */
#define NT_CAN_CLC_DISS_Pos                   1                                                       /*!< NT_CAN CLC: DISS Position               */
#define NT_CAN_CLC_DISS_Msk                   (0x01UL << NT_CAN_CLC_DISS_Pos)                         /*!< NT_CAN CLC: DISS Mask                   */
#define NT_CAN_CLC_SPEN_Pos                   2                                                       /*!< NT_CAN CLC: SPEN Position               */
#define NT_CAN_CLC_SPEN_Msk                   (0x01UL << NT_CAN_CLC_SPEN_Pos)                         /*!< NT_CAN CLC: SPEN Mask                   */
#define NT_CAN_CLC_SBWE_Pos                   4                                                       /*!< NT_CAN CLC: SBWE Position               */
#define NT_CAN_CLC_SBWE_Msk                   (0x01UL << NT_CAN_CLC_SBWE_Pos)                         /*!< NT_CAN CLC: SBWE Mask                   */
#define NT_CAN_CLC_FSOE_Pos                   5                                                       /*!< NT_CAN CLC: FSOE Position               */
#define NT_CAN_CLC_FSOE_Msk                   (0x01UL << NT_CAN_CLC_FSOE_Pos)                         /*!< NT_CAN CLC: FSOE Mask                   */

/* ----------------------------------  NT_CAN_ID  --------------------------------- */
#define NT_CAN_ID_MOD_REV_Pos                 0                                                       /*!< NT_CAN ID: MOD_REV Position             */
#define NT_CAN_ID_MOD_REV_Msk                 (0x000000ffUL << NT_CAN_ID_MOD_REV_Pos)                 /*!< NT_CAN ID: MOD_REV Mask                 */
#define NT_CAN_ID_MOD_TYPE_Pos                8                                                       /*!< NT_CAN ID: MOD_TYPE Position            */
#define NT_CAN_ID_MOD_TYPE_Msk                (0x000000ffUL << NT_CAN_ID_MOD_TYPE_Pos)                /*!< NT_CAN ID: MOD_TYPE Mask                */
#define NT_CAN_ID_MOD_NUMBER_Pos              16                                                      /*!< NT_CAN ID: MOD_NUMBER Position          */
#define NT_CAN_ID_MOD_NUMBER_Msk              (0x0000ffffUL << NT_CAN_ID_MOD_NUMBER_Pos)              /*!< NT_CAN ID: MOD_NUMBER Mask              */

/* ---------------------------------  NT_CAN_FDR  --------------------------------- */
#define NT_CAN_FDR_STEP_Pos                   0                                                       /*!< NT_CAN FDR: STEP Position               */
#define NT_CAN_FDR_STEP_Msk                   (0x000003ffUL << NT_CAN_FDR_STEP_Pos)                   /*!< NT_CAN FDR: STEP Mask                   */
#define NT_CAN_FDR_SM_Pos                     11                                                      /*!< NT_CAN FDR: SM Position                 */
#define NT_CAN_FDR_SM_Msk                     (0x01UL << NT_CAN_FDR_SM_Pos)                           /*!< NT_CAN FDR: SM Mask                     */
#define NT_CAN_FDR_SC_Pos                     12                                                      /*!< NT_CAN FDR: SC Position                 */
#define NT_CAN_FDR_SC_Msk                     (0x03UL << NT_CAN_FDR_SC_Pos)                           /*!< NT_CAN FDR: SC Mask                     */
#define NT_CAN_FDR_DM_Pos                     14                                                      /*!< NT_CAN FDR: DM Position                 */
#define NT_CAN_FDR_DM_Msk                     (0x03UL << NT_CAN_FDR_DM_Pos)                           /*!< NT_CAN FDR: DM Mask                     */
#define NT_CAN_FDR_RESULT_Pos                 16                                                      /*!< NT_CAN FDR: RESULT Position             */
#define NT_CAN_FDR_RESULT_Msk                 (0x000003ffUL << NT_CAN_FDR_RESULT_Pos)                 /*!< NT_CAN FDR: RESULT Mask                 */
#define NT_CAN_FDR_SUSACK_Pos                 28                                                      /*!< NT_CAN FDR: SUSACK Position             */
#define NT_CAN_FDR_SUSACK_Msk                 (0x01UL << NT_CAN_FDR_SUSACK_Pos)                       /*!< NT_CAN FDR: SUSACK Mask                 */
#define NT_CAN_FDR_SUSREQ_Pos                 29                                                      /*!< NT_CAN FDR: SUSREQ Position             */
#define NT_CAN_FDR_SUSREQ_Msk                 (0x01UL << NT_CAN_FDR_SUSREQ_Pos)                       /*!< NT_CAN FDR: SUSREQ Mask                 */
#define NT_CAN_FDR_ENHW_Pos                   30                                                      /*!< NT_CAN FDR: ENHW Position               */
#define NT_CAN_FDR_ENHW_Msk                   (0x01UL << NT_CAN_FDR_ENHW_Pos)                         /*!< NT_CAN FDR: ENHW Mask                   */
#define NT_CAN_FDR_DISCLK_Pos                 31                                                      /*!< NT_CAN FDR: DISCLK Position             */
#define NT_CAN_FDR_DISCLK_Msk                 (0x01UL << NT_CAN_FDR_DISCLK_Pos)                       /*!< NT_CAN FDR: DISCLK Mask                 */


/* ================================================================================ */
/* ================          struct 'LIST' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  LIST_LIST  --------------------------------- */
#define LIST_LIST_BEGIN_Pos                   0                                                       /*!< LIST LIST: BEGIN Position               */
#define LIST_LIST_BEGIN_Msk                   (0x000000ffUL << LIST_LIST_BEGIN_Pos)                   /*!< LIST LIST: BEGIN Mask                   */
#define LIST_LIST_END_Pos                     8                                                       /*!< LIST LIST: END Position                 */
#define LIST_LIST_END_Msk                     (0x000000ffUL << LIST_LIST_END_Pos)                     /*!< LIST LIST: END Mask                     */
#define LIST_LIST_SIZE_Pos                    16                                                      /*!< LIST LIST: SIZE Position                */
#define LIST_LIST_SIZE_Msk                    (0x000000ffUL << LIST_LIST_SIZE_Pos)                    /*!< LIST LIST: SIZE Mask                    */
#define LIST_LIST_EMPTY_Pos                   24                                                      /*!< LIST LIST: EMPTY Position               */
#define LIST_LIST_EMPTY_Msk                   (0x01UL << LIST_LIST_EMPTY_Pos)                         /*!< LIST LIST: EMPTY Mask                   */


/* ================================================================================ */
/* ================         struct 'MSPND' Position & Mask         ================ */
/* ================================================================================ */


/* ---------------------------------  MSPND_MSPND  -------------------------------- */
#define MSPND_MSPND_PND_Pos                   0                                                       /*!< MSPND MSPND: PND Position               */
#define MSPND_MSPND_PND_Msk                   (0xffffffffUL << MSPND_MSPND_PND_Pos)                   /*!< MSPND MSPND: PND Mask                   */


/* ================================================================================ */
/* ================          struct 'MSID' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  MSID_MSID  --------------------------------- */
#define MSID_MSID_INDEX_Pos                   0                                                       /*!< MSID MSID: INDEX Position               */
#define MSID_MSID_INDEX_Msk                   (0x000000ffUL << MSID_MSID_INDEX_Pos)                   /*!< MSID MSID: INDEX Mask                   */

/* -------------------------------  NT_CAN_MSIMASK  ------------------------------- */
#define NT_CAN_MSIMASK_IM_Pos                 0                                                       /*!< NT_CAN MSIMASK: IM Position             */
#define NT_CAN_MSIMASK_IM_Msk                 (0xffffffffUL << NT_CAN_MSIMASK_IM_Pos)                 /*!< NT_CAN MSIMASK: IM Mask                 */

/* --------------------------------  NT_CAN_PANCTR  ------------------------------- */
#define NT_CAN_PANCTR_PANCMD_Pos              0                                                       /*!< NT_CAN PANCTR: PANCMD Position          */
#define NT_CAN_PANCTR_PANCMD_Msk              (0x000000ffUL << NT_CAN_PANCTR_PANCMD_Pos)              /*!< NT_CAN PANCTR: PANCMD Mask              */
#define NT_CAN_PANCTR_BUSY_Pos                8                                                       /*!< NT_CAN PANCTR: BUSY Position            */
#define NT_CAN_PANCTR_BUSY_Msk                (0x01UL << NT_CAN_PANCTR_BUSY_Pos)                      /*!< NT_CAN PANCTR: BUSY Mask                */
#define NT_CAN_PANCTR_RBUSY_Pos               9                                                       /*!< NT_CAN PANCTR: RBUSY Position           */
#define NT_CAN_PANCTR_RBUSY_Msk               (0x01UL << NT_CAN_PANCTR_RBUSY_Pos)                     /*!< NT_CAN PANCTR: RBUSY Mask               */
#define NT_CAN_PANCTR_PANAR1_Pos              16                                                      /*!< NT_CAN PANCTR: PANAR1 Position          */
#define NT_CAN_PANCTR_PANAR1_Msk              (0x000000ffUL << NT_CAN_PANCTR_PANAR1_Pos)              /*!< NT_CAN PANCTR: PANAR1 Mask              */
#define NT_CAN_PANCTR_PANAR2_Pos              24                                                      /*!< NT_CAN PANCTR: PANAR2 Position          */
#define NT_CAN_PANCTR_PANAR2_Msk              (0x000000ffUL << NT_CAN_PANCTR_PANAR2_Pos)              /*!< NT_CAN PANCTR: PANAR2 Mask              */

/* -------------------------------  NT_CAN_MCR_REG  ------------------------------- */
#define NT_CAN_MCR_REG_MPSEL_Pos              12                                                      /*!< NT_CAN MCR_REG: MPSEL Position          */
#define NT_CAN_MCR_REG_MPSEL_Msk              (0x0fUL << NT_CAN_MCR_REG_MPSEL_Pos)                    /*!< NT_CAN MCR_REG: MPSEL Mask              */

/* ---------------------------------  NT_CAN_MITR  -------------------------------- */
#define NT_CAN_MITR_IT_Pos                    0                                                       /*!< NT_CAN MITR: IT Position                */
#define NT_CAN_MITR_IT_Msk                    (0x0000ffffUL << NT_CAN_MITR_IT_Pos)                    /*!< NT_CAN MITR: IT Mask                    */


/* ================================================================================ */
/* ================        struct 'CAN_Node' Position & Mask       ================ */
/* ================================================================================ */


/* --------------------------------  CAN_Node_NCR  -------------------------------- */
#define CAN_Node_NCR_INIT_Pos                 0                                                       /*!< CAN_Node NCR: INIT Position             */
#define CAN_Node_NCR_INIT_Msk                 (0x01UL << CAN_Node_NCR_INIT_Pos)                       /*!< CAN_Node NCR: INIT Mask                 */
#define CAN_Node_NCR_TRIE_Pos                 1                                                       /*!< CAN_Node NCR: TRIE Position             */
#define CAN_Node_NCR_TRIE_Msk                 (0x01UL << CAN_Node_NCR_TRIE_Pos)                       /*!< CAN_Node NCR: TRIE Mask                 */
#define CAN_Node_NCR_LECIE_Pos                2                                                       /*!< CAN_Node NCR: LECIE Position            */
#define CAN_Node_NCR_LECIE_Msk                (0x01UL << CAN_Node_NCR_LECIE_Pos)                      /*!< CAN_Node NCR: LECIE Mask                */
#define CAN_Node_NCR_ALIE_Pos                 3                                                       /*!< CAN_Node NCR: ALIE Position             */
#define CAN_Node_NCR_ALIE_Msk                 (0x01UL << CAN_Node_NCR_ALIE_Pos)                       /*!< CAN_Node NCR: ALIE Mask                 */
#define CAN_Node_NCR_CANDIS_Pos               4                                                       /*!< CAN_Node NCR: CANDIS Position           */
#define CAN_Node_NCR_CANDIS_Msk               (0x01UL << CAN_Node_NCR_CANDIS_Pos)                     /*!< CAN_Node NCR: CANDIS Mask               */
#define CAN_Node_NCR_CCE_Pos                  6                                                       /*!< CAN_Node NCR: CCE Position              */
#define CAN_Node_NCR_CCE_Msk                  (0x01UL << CAN_Node_NCR_CCE_Pos)                        /*!< CAN_Node NCR: CCE Mask                  */
#define CAN_Node_NCR_CALM_Pos                 7                                                       /*!< CAN_Node NCR: CALM Position             */
#define CAN_Node_NCR_CALM_Msk                 (0x01UL << CAN_Node_NCR_CALM_Pos)                       /*!< CAN_Node NCR: CALM Mask                 */
#define CAN_Node_NCR_SUSEN_Pos                8                                                       /*!< CAN_Node NCR: SUSEN Position            */
#define CAN_Node_NCR_SUSEN_Msk                (0x01UL << CAN_Node_NCR_SUSEN_Pos)                      /*!< CAN_Node NCR: SUSEN Mask                */

/* --------------------------------  CAN_Node_NSR  -------------------------------- */
#define CAN_Node_NSR_LEC_Pos                  0                                                       /*!< CAN_Node NSR: LEC Position              */
#define CAN_Node_NSR_LEC_Msk                  (0x07UL << CAN_Node_NSR_LEC_Pos)                        /*!< CAN_Node NSR: LEC Mask                  */
#define CAN_Node_NSR_TXOK_Pos                 3                                                       /*!< CAN_Node NSR: TXOK Position             */
#define CAN_Node_NSR_TXOK_Msk                 (0x01UL << CAN_Node_NSR_TXOK_Pos)                       /*!< CAN_Node NSR: TXOK Mask                 */
#define CAN_Node_NSR_RXOK_Pos                 4                                                       /*!< CAN_Node NSR: RXOK Position             */
#define CAN_Node_NSR_RXOK_Msk                 (0x01UL << CAN_Node_NSR_RXOK_Pos)                       /*!< CAN_Node NSR: RXOK Mask                 */
#define CAN_Node_NSR_ALERT_Pos                5                                                       /*!< CAN_Node NSR: ALERT Position            */
#define CAN_Node_NSR_ALERT_Msk                (0x01UL << CAN_Node_NSR_ALERT_Pos)                      /*!< CAN_Node NSR: ALERT Mask                */
#define CAN_Node_NSR_EWRN_Pos                 6                                                       /*!< CAN_Node NSR: EWRN Position             */
#define CAN_Node_NSR_EWRN_Msk                 (0x01UL << CAN_Node_NSR_EWRN_Pos)                       /*!< CAN_Node NSR: EWRN Mask                 */
#define CAN_Node_NSR_BOFF_Pos                 7                                                       /*!< CAN_Node NSR: BOFF Position             */
#define CAN_Node_NSR_BOFF_Msk                 (0x01UL << CAN_Node_NSR_BOFF_Pos)                       /*!< CAN_Node NSR: BOFF Mask                 */
#define CAN_Node_NSR_LLE_Pos                  8                                                       /*!< CAN_Node NSR: LLE Position              */
#define CAN_Node_NSR_LLE_Msk                  (0x01UL << CAN_Node_NSR_LLE_Pos)                        /*!< CAN_Node NSR: LLE Mask                  */
#define CAN_Node_NSR_LOE_Pos                  9                                                       /*!< CAN_Node NSR: LOE Position              */
#define CAN_Node_NSR_LOE_Msk                  (0x01UL << CAN_Node_NSR_LOE_Pos)                        /*!< CAN_Node NSR: LOE Mask                  */
#define CAN_Node_NSR_SUSACK_Pos               10                                                      /*!< CAN_Node NSR: SUSACK Position           */
#define CAN_Node_NSR_SUSACK_Msk               (0x01UL << CAN_Node_NSR_SUSACK_Pos)                     /*!< CAN_Node NSR: SUSACK Mask               */

/* --------------------------------  CAN_Node_NIPR  ------------------------------- */
#define CAN_Node_NIPR_ALINP_Pos               0                                                       /*!< CAN_Node NIPR: ALINP Position           */
#define CAN_Node_NIPR_ALINP_Msk               (0x0fUL << CAN_Node_NIPR_ALINP_Pos)                     /*!< CAN_Node NIPR: ALINP Mask               */
#define CAN_Node_NIPR_LECINP_Pos              4                                                       /*!< CAN_Node NIPR: LECINP Position          */
#define CAN_Node_NIPR_LECINP_Msk              (0x0fUL << CAN_Node_NIPR_LECINP_Pos)                    /*!< CAN_Node NIPR: LECINP Mask              */
#define CAN_Node_NIPR_TRINP_Pos               8                                                       /*!< CAN_Node NIPR: TRINP Position           */
#define CAN_Node_NIPR_TRINP_Msk               (0x0fUL << CAN_Node_NIPR_TRINP_Pos)                     /*!< CAN_Node NIPR: TRINP Mask               */
#define CAN_Node_NIPR_CFCINP_Pos              12                                                      /*!< CAN_Node NIPR: CFCINP Position          */
#define CAN_Node_NIPR_CFCINP_Msk              (0x0fUL << CAN_Node_NIPR_CFCINP_Pos)                    /*!< CAN_Node NIPR: CFCINP Mask              */

/* --------------------------------  CAN_Node_NPCR  ------------------------------- */
#define CAN_Node_NPCR_RXSEL_Pos               0                                                       /*!< CAN_Node NPCR: RXSEL Position           */
#define CAN_Node_NPCR_RXSEL_Msk               (0x07UL << CAN_Node_NPCR_RXSEL_Pos)                     /*!< CAN_Node NPCR: RXSEL Mask               */
#define CAN_Node_NPCR_LBM_Pos                 8                                                       /*!< CAN_Node NPCR: LBM Position             */
#define CAN_Node_NPCR_LBM_Msk                 (0x01UL << CAN_Node_NPCR_LBM_Pos)                       /*!< CAN_Node NPCR: LBM Mask                 */

/* --------------------------------  CAN_Node_NBTR  ------------------------------- */
#define CAN_Node_NBTR_BRP_Pos                 0                                                       /*!< CAN_Node NBTR: BRP Position             */
#define CAN_Node_NBTR_BRP_Msk                 (0x3fUL << CAN_Node_NBTR_BRP_Pos)                       /*!< CAN_Node NBTR: BRP Mask                 */
#define CAN_Node_NBTR_SJW_Pos                 6                                                       /*!< CAN_Node NBTR: SJW Position             */
#define CAN_Node_NBTR_SJW_Msk                 (0x03UL << CAN_Node_NBTR_SJW_Pos)                       /*!< CAN_Node NBTR: SJW Mask                 */
#define CAN_Node_NBTR_TSEG1_Pos               8                                                       /*!< CAN_Node NBTR: TSEG1 Position           */
#define CAN_Node_NBTR_TSEG1_Msk               (0x0fUL << CAN_Node_NBTR_TSEG1_Pos)                     /*!< CAN_Node NBTR: TSEG1 Mask               */
#define CAN_Node_NBTR_TSEG2_Pos               12                                                      /*!< CAN_Node NBTR: TSEG2 Position           */
#define CAN_Node_NBTR_TSEG2_Msk               (0x07UL << CAN_Node_NBTR_TSEG2_Pos)                     /*!< CAN_Node NBTR: TSEG2 Mask               */
#define CAN_Node_NBTR_DIV8_Pos                15                                                      /*!< CAN_Node NBTR: DIV8 Position            */
#define CAN_Node_NBTR_DIV8_Msk                (0x01UL << CAN_Node_NBTR_DIV8_Pos)                      /*!< CAN_Node NBTR: DIV8 Mask                */

/* -------------------------------  CAN_Node_NECNT  ------------------------------- */
#define CAN_Node_NECNT_REC_Pos                0                                                       /*!< CAN_Node NECNT: REC Position            */
#define CAN_Node_NECNT_REC_Msk                (0x000000ffUL << CAN_Node_NECNT_REC_Pos)                /*!< CAN_Node NECNT: REC Mask                */
#define CAN_Node_NECNT_TEC_Pos                8                                                       /*!< CAN_Node NECNT: TEC Position            */
#define CAN_Node_NECNT_TEC_Msk                (0x000000ffUL << CAN_Node_NECNT_TEC_Pos)                /*!< CAN_Node NECNT: TEC Mask                */
#define CAN_Node_NECNT_EWRNLVL_Pos            16                                                      /*!< CAN_Node NECNT: EWRNLVL Position        */
#define CAN_Node_NECNT_EWRNLVL_Msk            (0x000000ffUL << CAN_Node_NECNT_EWRNLVL_Pos)            /*!< CAN_Node NECNT: EWRNLVL Mask            */
#define CAN_Node_NECNT_LETD_Pos               24                                                      /*!< CAN_Node NECNT: LETD Position           */
#define CAN_Node_NECNT_LETD_Msk               (0x01UL << CAN_Node_NECNT_LETD_Pos)                     /*!< CAN_Node NECNT: LETD Mask               */
#define CAN_Node_NECNT_LEINC_Pos              25                                                      /*!< CAN_Node NECNT: LEINC Position          */
#define CAN_Node_NECNT_LEINC_Msk              (0x01UL << CAN_Node_NECNT_LEINC_Pos)                    /*!< CAN_Node NECNT: LEINC Mask              */

/* --------------------------------  CAN_Node_NFCR  ------------------------------- */
#define CAN_Node_NFCR_CFC_Pos                 0                                                       /*!< CAN_Node NFCR: CFC Position             */
#define CAN_Node_NFCR_CFC_Msk                 (0x0000ffffUL << CAN_Node_NFCR_CFC_Pos)                 /*!< CAN_Node NFCR: CFC Mask                 */
#define CAN_Node_NFCR_CFSEL_Pos               16                                                      /*!< CAN_Node NFCR: CFSEL Position           */
#define CAN_Node_NFCR_CFSEL_Msk               (0x07UL << CAN_Node_NFCR_CFSEL_Pos)                     /*!< CAN_Node NFCR: CFSEL Mask               */
#define CAN_Node_NFCR_CFMOD_Pos               19                                                      /*!< CAN_Node NFCR: CFMOD Position           */
#define CAN_Node_NFCR_CFMOD_Msk               (0x03UL << CAN_Node_NFCR_CFMOD_Pos)                     /*!< CAN_Node NFCR: CFMOD Mask               */
#define CAN_Node_NFCR_CFCIE_Pos               22                                                      /*!< CAN_Node NFCR: CFCIE Position           */
#define CAN_Node_NFCR_CFCIE_Msk               (0x01UL << CAN_Node_NFCR_CFCIE_Pos)                     /*!< CAN_Node NFCR: CFCIE Mask               */
#define CAN_Node_NFCR_CFCOV_Pos               23                                                      /*!< CAN_Node NFCR: CFCOV Position           */
#define CAN_Node_NFCR_CFCOV_Msk               (0x01UL << CAN_Node_NFCR_CFCOV_Pos)                     /*!< CAN_Node NFCR: CFCOV Mask               */


/* ================================================================================ */
/* ================        struct 'CAN_Msg' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  CAN_Msg_MOFCR  ------------------------------- */
#define CAN_Msg_MOFCR_MMC_Pos                 0                                                       /*!< CAN_Msg MOFCR: MMC Position             */
#define CAN_Msg_MOFCR_MMC_Msk                 (0x0fUL << CAN_Msg_MOFCR_MMC_Pos)                       /*!< CAN_Msg MOFCR: MMC Mask                 */
#define CAN_Msg_MOFCR_GDFS_Pos                8                                                       /*!< CAN_Msg MOFCR: GDFS Position            */
#define CAN_Msg_MOFCR_GDFS_Msk                (0x01UL << CAN_Msg_MOFCR_GDFS_Pos)                      /*!< CAN_Msg MOFCR: GDFS Mask                */
#define CAN_Msg_MOFCR_IDC_Pos                 9                                                       /*!< CAN_Msg MOFCR: IDC Position             */
#define CAN_Msg_MOFCR_IDC_Msk                 (0x01UL << CAN_Msg_MOFCR_IDC_Pos)                       /*!< CAN_Msg MOFCR: IDC Mask                 */
#define CAN_Msg_MOFCR_DLCC_Pos                10                                                      /*!< CAN_Msg MOFCR: DLCC Position            */
#define CAN_Msg_MOFCR_DLCC_Msk                (0x01UL << CAN_Msg_MOFCR_DLCC_Pos)                      /*!< CAN_Msg MOFCR: DLCC Mask                */
#define CAN_Msg_MOFCR_DATC_Pos                11                                                      /*!< CAN_Msg MOFCR: DATC Position            */
#define CAN_Msg_MOFCR_DATC_Msk                (0x01UL << CAN_Msg_MOFCR_DATC_Pos)                      /*!< CAN_Msg MOFCR: DATC Mask                */
#define CAN_Msg_MOFCR_RXIE_Pos                16                                                      /*!< CAN_Msg MOFCR: RXIE Position            */
#define CAN_Msg_MOFCR_RXIE_Msk                (0x01UL << CAN_Msg_MOFCR_RXIE_Pos)                      /*!< CAN_Msg MOFCR: RXIE Mask                */
#define CAN_Msg_MOFCR_TXIE_Pos                17                                                      /*!< CAN_Msg MOFCR: TXIE Position            */
#define CAN_Msg_MOFCR_TXIE_Msk                (0x01UL << CAN_Msg_MOFCR_TXIE_Pos)                      /*!< CAN_Msg MOFCR: TXIE Mask                */
#define CAN_Msg_MOFCR_OVIE_Pos                18                                                      /*!< CAN_Msg MOFCR: OVIE Position            */
#define CAN_Msg_MOFCR_OVIE_Msk                (0x01UL << CAN_Msg_MOFCR_OVIE_Pos)                      /*!< CAN_Msg MOFCR: OVIE Mask                */
#define CAN_Msg_MOFCR_FRREN_Pos               20                                                      /*!< CAN_Msg MOFCR: FRREN Position           */
#define CAN_Msg_MOFCR_FRREN_Msk               (0x01UL << CAN_Msg_MOFCR_FRREN_Pos)                     /*!< CAN_Msg MOFCR: FRREN Mask               */
#define CAN_Msg_MOFCR_RMM_Pos                 21                                                      /*!< CAN_Msg MOFCR: RMM Position             */
#define CAN_Msg_MOFCR_RMM_Msk                 (0x01UL << CAN_Msg_MOFCR_RMM_Pos)                       /*!< CAN_Msg MOFCR: RMM Mask                 */
#define CAN_Msg_MOFCR_SDT_Pos                 22                                                      /*!< CAN_Msg MOFCR: SDT Position             */
#define CAN_Msg_MOFCR_SDT_Msk                 (0x01UL << CAN_Msg_MOFCR_SDT_Pos)                       /*!< CAN_Msg MOFCR: SDT Mask                 */
#define CAN_Msg_MOFCR_STT_Pos                 23                                                      /*!< CAN_Msg MOFCR: STT Position             */
#define CAN_Msg_MOFCR_STT_Msk                 (0x01UL << CAN_Msg_MOFCR_STT_Pos)                       /*!< CAN_Msg MOFCR: STT Mask                 */
#define CAN_Msg_MOFCR_DLC_Pos                 24                                                      /*!< CAN_Msg MOFCR: DLC Position             */
#define CAN_Msg_MOFCR_DLC_Msk                 (0x0fUL << CAN_Msg_MOFCR_DLC_Pos)                       /*!< CAN_Msg MOFCR: DLC Mask                 */

/* -------------------------------  CAN_Msg_MOFGPR  ------------------------------- */
#define CAN_Msg_MOFGPR_BOT_Pos                0                                                       /*!< CAN_Msg MOFGPR: BOT Position            */
#define CAN_Msg_MOFGPR_BOT_Msk                (0x000000ffUL << CAN_Msg_MOFGPR_BOT_Pos)                /*!< CAN_Msg MOFGPR: BOT Mask                */
#define CAN_Msg_MOFGPR_TOP_Pos                8                                                       /*!< CAN_Msg MOFGPR: TOP Position            */
#define CAN_Msg_MOFGPR_TOP_Msk                (0x000000ffUL << CAN_Msg_MOFGPR_TOP_Pos)                /*!< CAN_Msg MOFGPR: TOP Mask                */
#define CAN_Msg_MOFGPR_CUR_Pos                16                                                      /*!< CAN_Msg MOFGPR: CUR Position            */
#define CAN_Msg_MOFGPR_CUR_Msk                (0x000000ffUL << CAN_Msg_MOFGPR_CUR_Pos)                /*!< CAN_Msg MOFGPR: CUR Mask                */
#define CAN_Msg_MOFGPR_SEL_Pos                24                                                      /*!< CAN_Msg MOFGPR: SEL Position            */
#define CAN_Msg_MOFGPR_SEL_Msk                (0x000000ffUL << CAN_Msg_MOFGPR_SEL_Pos)                /*!< CAN_Msg MOFGPR: SEL Mask                */

/* --------------------------------  CAN_Msg_MOIPR  ------------------------------- */
#define CAN_Msg_MOIPR_RXINP_Pos               0                                                       /*!< CAN_Msg MOIPR: RXINP Position           */
#define CAN_Msg_MOIPR_RXINP_Msk               (0x0fUL << CAN_Msg_MOIPR_RXINP_Pos)                     /*!< CAN_Msg MOIPR: RXINP Mask               */
#define CAN_Msg_MOIPR_TXINP_Pos               4                                                       /*!< CAN_Msg MOIPR: TXINP Position           */
#define CAN_Msg_MOIPR_TXINP_Msk               (0x0fUL << CAN_Msg_MOIPR_TXINP_Pos)                     /*!< CAN_Msg MOIPR: TXINP Mask               */
#define CAN_Msg_MOIPR_MPN_Pos                 8                                                       /*!< CAN_Msg MOIPR: MPN Position             */
#define CAN_Msg_MOIPR_MPN_Msk                 (0x000000ffUL << CAN_Msg_MOIPR_MPN_Pos)                 /*!< CAN_Msg MOIPR: MPN Mask                 */
#define CAN_Msg_MOIPR_CFCVAL_Pos              16                                                      /*!< CAN_Msg MOIPR: CFCVAL Position          */
#define CAN_Msg_MOIPR_CFCVAL_Msk              (0x0000ffffUL << CAN_Msg_MOIPR_CFCVAL_Pos)              /*!< CAN_Msg MOIPR: CFCVAL Mask              */

/* --------------------------------  CAN_Msg_MOAMR  ------------------------------- */
#define CAN_Msg_MOAMR_AM_Pos                  0                                                       /*!< CAN_Msg MOAMR: AM Position              */
#define CAN_Msg_MOAMR_AM_Msk                  (0x1fffffffUL << CAN_Msg_MOAMR_AM_Pos)                  /*!< CAN_Msg MOAMR: AM Mask                  */
#define CAN_Msg_MOAMR_MIDE_Pos                29                                                      /*!< CAN_Msg MOAMR: MIDE Position            */
#define CAN_Msg_MOAMR_MIDE_Msk                (0x01UL << CAN_Msg_MOAMR_MIDE_Pos)                      /*!< CAN_Msg MOAMR: MIDE Mask                */

/* -------------------------------  CAN_Msg_MODATAL  ------------------------------ */
#define CAN_Msg_MODATAL_DB0_Pos               0                                                       /*!< CAN_Msg MODATAL: DB0 Position           */
#define CAN_Msg_MODATAL_DB0_Msk               (0x000000ffUL << CAN_Msg_MODATAL_DB0_Pos)               /*!< CAN_Msg MODATAL: DB0 Mask               */
#define CAN_Msg_MODATAL_DB1_Pos               8                                                       /*!< CAN_Msg MODATAL: DB1 Position           */
#define CAN_Msg_MODATAL_DB1_Msk               (0x000000ffUL << CAN_Msg_MODATAL_DB1_Pos)               /*!< CAN_Msg MODATAL: DB1 Mask               */
#define CAN_Msg_MODATAL_DB2_Pos               16                                                      /*!< CAN_Msg MODATAL: DB2 Position           */
#define CAN_Msg_MODATAL_DB2_Msk               (0x000000ffUL << CAN_Msg_MODATAL_DB2_Pos)               /*!< CAN_Msg MODATAL: DB2 Mask               */
#define CAN_Msg_MODATAL_DB3_Pos               24                                                      /*!< CAN_Msg MODATAL: DB3 Position           */
#define CAN_Msg_MODATAL_DB3_Msk               (0x000000ffUL << CAN_Msg_MODATAL_DB3_Pos)               /*!< CAN_Msg MODATAL: DB3 Mask               */

/* -------------------------------  CAN_Msg_MODATAH  ------------------------------ */
#define CAN_Msg_MODATAH_DB4_Pos               0                                                       /*!< CAN_Msg MODATAH: DB4 Position           */
#define CAN_Msg_MODATAH_DB4_Msk               (0x000000ffUL << CAN_Msg_MODATAH_DB4_Pos)               /*!< CAN_Msg MODATAH: DB4 Mask               */
#define CAN_Msg_MODATAH_DB5_Pos               8                                                       /*!< CAN_Msg MODATAH: DB5 Position           */
#define CAN_Msg_MODATAH_DB5_Msk               (0x000000ffUL << CAN_Msg_MODATAH_DB5_Pos)               /*!< CAN_Msg MODATAH: DB5 Mask               */
#define CAN_Msg_MODATAH_DB6_Pos               16                                                      /*!< CAN_Msg MODATAH: DB6 Position           */
#define CAN_Msg_MODATAH_DB6_Msk               (0x000000ffUL << CAN_Msg_MODATAH_DB6_Pos)               /*!< CAN_Msg MODATAH: DB6 Mask               */
#define CAN_Msg_MODATAH_DB7_Pos               24                                                      /*!< CAN_Msg MODATAH: DB7 Position           */
#define CAN_Msg_MODATAH_DB7_Msk               (0x000000ffUL << CAN_Msg_MODATAH_DB7_Pos)               /*!< CAN_Msg MODATAH: DB7 Mask               */

/* --------------------------------  CAN_Msg_MOAR  -------------------------------- */
#define CAN_Msg_MOAR_ID_Pos                   0                                                       /*!< CAN_Msg MOAR: ID Position               */
#define CAN_Msg_MOAR_ID_Msk                   (0x1fffffffUL << CAN_Msg_MOAR_ID_Pos)                   /*!< CAN_Msg MOAR: ID Mask                   */
#define CAN_Msg_MOAR_IDE_Pos                  29                                                      /*!< CAN_Msg MOAR: IDE Position              */
#define CAN_Msg_MOAR_IDE_Msk                  (0x01UL << CAN_Msg_MOAR_IDE_Pos)                        /*!< CAN_Msg MOAR: IDE Mask                  */
#define CAN_Msg_MOAR_PRI_Pos                  30                                                      /*!< CAN_Msg MOAR: PRI Position              */
#define CAN_Msg_MOAR_PRI_Msk                  (0x03UL << CAN_Msg_MOAR_PRI_Pos)                        /*!< CAN_Msg MOAR: PRI Mask                  */

/* --------------------------------  CAN_Msg_MOCTR  ------------------------------- */
#define CAN_Msg_MOCTR_RESRXPND_Pos            0                                                       /*!< CAN_Msg MOCTR: RESRXPND Position        */
#define CAN_Msg_MOCTR_RESRXPND_Msk            (0x01UL << CAN_Msg_MOCTR_RESRXPND_Pos)                  /*!< CAN_Msg MOCTR: RESRXPND Mask            */
#define CAN_Msg_MOCTR_RESTXPND_Pos            1                                                       /*!< CAN_Msg MOCTR: RESTXPND Position        */
#define CAN_Msg_MOCTR_RESTXPND_Msk            (0x01UL << CAN_Msg_MOCTR_RESTXPND_Pos)                  /*!< CAN_Msg MOCTR: RESTXPND Mask            */
#define CAN_Msg_MOCTR_RESRXUPD_Pos            2                                                       /*!< CAN_Msg MOCTR: RESRXUPD Position        */
#define CAN_Msg_MOCTR_RESRXUPD_Msk            (0x01UL << CAN_Msg_MOCTR_RESRXUPD_Pos)                  /*!< CAN_Msg MOCTR: RESRXUPD Mask            */
#define CAN_Msg_MOCTR_RESNEWDAT_Pos           3                                                       /*!< CAN_Msg MOCTR: RESNEWDAT Position       */
#define CAN_Msg_MOCTR_RESNEWDAT_Msk           (0x01UL << CAN_Msg_MOCTR_RESNEWDAT_Pos)                 /*!< CAN_Msg MOCTR: RESNEWDAT Mask           */
#define CAN_Msg_MOCTR_RESMSGLST_Pos           4                                                       /*!< CAN_Msg MOCTR: RESMSGLST Position       */
#define CAN_Msg_MOCTR_RESMSGLST_Msk           (0x01UL << CAN_Msg_MOCTR_RESMSGLST_Pos)                 /*!< CAN_Msg MOCTR: RESMSGLST Mask           */
#define CAN_Msg_MOCTR_RESMSGVAL_Pos           5                                                       /*!< CAN_Msg MOCTR: RESMSGVAL Position       */
#define CAN_Msg_MOCTR_RESMSGVAL_Msk           (0x01UL << CAN_Msg_MOCTR_RESMSGVAL_Pos)                 /*!< CAN_Msg MOCTR: RESMSGVAL Mask           */
#define CAN_Msg_MOCTR_RESRTSEL_Pos            6                                                       /*!< CAN_Msg MOCTR: RESRTSEL Position        */
#define CAN_Msg_MOCTR_RESRTSEL_Msk            (0x01UL << CAN_Msg_MOCTR_RESRTSEL_Pos)                  /*!< CAN_Msg MOCTR: RESRTSEL Mask            */
#define CAN_Msg_MOCTR_RESRXEN_Pos             7                                                       /*!< CAN_Msg MOCTR: RESRXEN Position         */
#define CAN_Msg_MOCTR_RESRXEN_Msk             (0x01UL << CAN_Msg_MOCTR_RESRXEN_Pos)                   /*!< CAN_Msg MOCTR: RESRXEN Mask             */
#define CAN_Msg_MOCTR_RESTXRQ_Pos             8                                                       /*!< CAN_Msg MOCTR: RESTXRQ Position         */
#define CAN_Msg_MOCTR_RESTXRQ_Msk             (0x01UL << CAN_Msg_MOCTR_RESTXRQ_Pos)                   /*!< CAN_Msg MOCTR: RESTXRQ Mask             */
#define CAN_Msg_MOCTR_RESTXEN0_Pos            9                                                       /*!< CAN_Msg MOCTR: RESTXEN0 Position        */
#define CAN_Msg_MOCTR_RESTXEN0_Msk            (0x01UL << CAN_Msg_MOCTR_RESTXEN0_Pos)                  /*!< CAN_Msg MOCTR: RESTXEN0 Mask            */
#define CAN_Msg_MOCTR_RESTXEN1_Pos            10                                                      /*!< CAN_Msg MOCTR: RESTXEN1 Position        */
#define CAN_Msg_MOCTR_RESTXEN1_Msk            (0x01UL << CAN_Msg_MOCTR_RESTXEN1_Pos)                  /*!< CAN_Msg MOCTR: RESTXEN1 Mask            */
#define CAN_Msg_MOCTR_RESDIR_Pos              11                                                      /*!< CAN_Msg MOCTR: RESDIR Position          */
#define CAN_Msg_MOCTR_RESDIR_Msk              (0x01UL << CAN_Msg_MOCTR_RESDIR_Pos)                    /*!< CAN_Msg MOCTR: RESDIR Mask              */
#define CAN_Msg_MOCTR_SETRXPND_Pos            16                                                      /*!< CAN_Msg MOCTR: SETRXPND Position        */
#define CAN_Msg_MOCTR_SETRXPND_Msk            (0x01UL << CAN_Msg_MOCTR_SETRXPND_Pos)                  /*!< CAN_Msg MOCTR: SETRXPND Mask            */
#define CAN_Msg_MOCTR_SETTXPND_Pos            17                                                      /*!< CAN_Msg MOCTR: SETTXPND Position        */
#define CAN_Msg_MOCTR_SETTXPND_Msk            (0x01UL << CAN_Msg_MOCTR_SETTXPND_Pos)                  /*!< CAN_Msg MOCTR: SETTXPND Mask            */
#define CAN_Msg_MOCTR_SETRXUPD_Pos            18                                                      /*!< CAN_Msg MOCTR: SETRXUPD Position        */
#define CAN_Msg_MOCTR_SETRXUPD_Msk            (0x01UL << CAN_Msg_MOCTR_SETRXUPD_Pos)                  /*!< CAN_Msg MOCTR: SETRXUPD Mask            */
#define CAN_Msg_MOCTR_SETNEWDAT_Pos           19                                                      /*!< CAN_Msg MOCTR: SETNEWDAT Position       */
#define CAN_Msg_MOCTR_SETNEWDAT_Msk           (0x01UL << CAN_Msg_MOCTR_SETNEWDAT_Pos)                 /*!< CAN_Msg MOCTR: SETNEWDAT Mask           */
#define CAN_Msg_MOCTR_SETMSGLST_Pos           20                                                      /*!< CAN_Msg MOCTR: SETMSGLST Position       */
#define CAN_Msg_MOCTR_SETMSGLST_Msk           (0x01UL << CAN_Msg_MOCTR_SETMSGLST_Pos)                 /*!< CAN_Msg MOCTR: SETMSGLST Mask           */
#define CAN_Msg_MOCTR_SETMSGVAL_Pos           21                                                      /*!< CAN_Msg MOCTR: SETMSGVAL Position       */
#define CAN_Msg_MOCTR_SETMSGVAL_Msk           (0x01UL << CAN_Msg_MOCTR_SETMSGVAL_Pos)                 /*!< CAN_Msg MOCTR: SETMSGVAL Mask           */
#define CAN_Msg_MOCTR_SETRTSEL_Pos            22                                                      /*!< CAN_Msg MOCTR: SETRTSEL Position        */
#define CAN_Msg_MOCTR_SETRTSEL_Msk            (0x01UL << CAN_Msg_MOCTR_SETRTSEL_Pos)                  /*!< CAN_Msg MOCTR: SETRTSEL Mask            */
#define CAN_Msg_MOCTR_SETRXEN_Pos             23                                                      /*!< CAN_Msg MOCTR: SETRXEN Position         */
#define CAN_Msg_MOCTR_SETRXEN_Msk             (0x01UL << CAN_Msg_MOCTR_SETRXEN_Pos)                   /*!< CAN_Msg MOCTR: SETRXEN Mask             */
#define CAN_Msg_MOCTR_SETTXRQ_Pos             24                                                      /*!< CAN_Msg MOCTR: SETTXRQ Position         */
#define CAN_Msg_MOCTR_SETTXRQ_Msk             (0x01UL << CAN_Msg_MOCTR_SETTXRQ_Pos)                   /*!< CAN_Msg MOCTR: SETTXRQ Mask             */
#define CAN_Msg_MOCTR_SETTXEN0_Pos            25                                                      /*!< CAN_Msg MOCTR: SETTXEN0 Position        */
#define CAN_Msg_MOCTR_SETTXEN0_Msk            (0x01UL << CAN_Msg_MOCTR_SETTXEN0_Pos)                  /*!< CAN_Msg MOCTR: SETTXEN0 Mask            */
#define CAN_Msg_MOCTR_SETTXEN1_Pos            26                                                      /*!< CAN_Msg MOCTR: SETTXEN1 Position        */
#define CAN_Msg_MOCTR_SETTXEN1_Msk            (0x01UL << CAN_Msg_MOCTR_SETTXEN1_Pos)                  /*!< CAN_Msg MOCTR: SETTXEN1 Mask            */
#define CAN_Msg_MOCTR_SETDIR_Pos              27                                                      /*!< CAN_Msg MOCTR: SETDIR Position          */
#define CAN_Msg_MOCTR_SETDIR_Msk              (0x01UL << CAN_Msg_MOCTR_SETDIR_Pos)                    /*!< CAN_Msg MOCTR: SETDIR Mask              */


/* ================================================================================ */
/* ================      struct 'NT_ETHERNET' Position & Mask      ================ */
/* ================================================================================ */


/* ------------------------------  NT_ETHERNET_MAC1  ------------------------------ */
#define NT_ETHERNET_MAC1_RXENABLE_Pos         0                                                       /*!< NT_ETHERNET MAC1: RXENABLE Position     */
#define NT_ETHERNET_MAC1_RXENABLE_Msk         (0x01UL << NT_ETHERNET_MAC1_RXENABLE_Pos)               /*!< NT_ETHERNET MAC1: RXENABLE Mask         */
#define NT_ETHERNET_MAC1_PASSALL_Pos          1                                                       /*!< NT_ETHERNET MAC1: PASSALL Position      */
#define NT_ETHERNET_MAC1_PASSALL_Msk          (0x01UL << NT_ETHERNET_MAC1_PASSALL_Pos)                /*!< NT_ETHERNET MAC1: PASSALL Mask          */
#define NT_ETHERNET_MAC1_RXPAUSE_Pos          2                                                       /*!< NT_ETHERNET MAC1: RXPAUSE Position      */
#define NT_ETHERNET_MAC1_RXPAUSE_Msk          (0x01UL << NT_ETHERNET_MAC1_RXPAUSE_Pos)                /*!< NT_ETHERNET MAC1: RXPAUSE Mask          */
#define NT_ETHERNET_MAC1_TXPAUSE_Pos          3                                                       /*!< NT_ETHERNET MAC1: TXPAUSE Position      */
#define NT_ETHERNET_MAC1_TXPAUSE_Msk          (0x01UL << NT_ETHERNET_MAC1_TXPAUSE_Pos)                /*!< NT_ETHERNET MAC1: TXPAUSE Mask          */
#define NT_ETHERNET_MAC1_LOOPBACK_Pos         4                                                       /*!< NT_ETHERNET MAC1: LOOPBACK Position     */
#define NT_ETHERNET_MAC1_LOOPBACK_Msk         (0x01UL << NT_ETHERNET_MAC1_LOOPBACK_Pos)               /*!< NT_ETHERNET MAC1: LOOPBACK Mask         */
#define NT_ETHERNET_MAC1_RESETTFUN_Pos        8                                                       /*!< NT_ETHERNET MAC1: RESETTFUN Position    */
#define NT_ETHERNET_MAC1_RESETTFUN_Msk        (0x01UL << NT_ETHERNET_MAC1_RESETTFUN_Pos)              /*!< NT_ETHERNET MAC1: RESETTFUN Mask        */
#define NT_ETHERNET_MAC1_RESETTMCS_Pos        9                                                       /*!< NT_ETHERNET MAC1: RESETTMCS Position    */
#define NT_ETHERNET_MAC1_RESETTMCS_Msk        (0x01UL << NT_ETHERNET_MAC1_RESETTMCS_Pos)              /*!< NT_ETHERNET MAC1: RESETTMCS Mask        */
#define NT_ETHERNET_MAC1_RESETRFUN_Pos        10                                                      /*!< NT_ETHERNET MAC1: RESETRFUN Position    */
#define NT_ETHERNET_MAC1_RESETRFUN_Msk        (0x01UL << NT_ETHERNET_MAC1_RESETRFUN_Pos)              /*!< NT_ETHERNET MAC1: RESETRFUN Mask        */
#define NT_ETHERNET_MAC1_RESETRMCS_Pos        11                                                      /*!< NT_ETHERNET MAC1: RESETRMCS Position    */
#define NT_ETHERNET_MAC1_RESETRMCS_Msk        (0x01UL << NT_ETHERNET_MAC1_RESETRMCS_Pos)              /*!< NT_ETHERNET MAC1: RESETRMCS Mask        */
#define NT_ETHERNET_MAC1_SIMRESET_Pos         14                                                      /*!< NT_ETHERNET MAC1: SIMRESET Position     */
#define NT_ETHERNET_MAC1_SIMRESET_Msk         (0x01UL << NT_ETHERNET_MAC1_SIMRESET_Pos)               /*!< NT_ETHERNET MAC1: SIMRESET Mask         */
#define NT_ETHERNET_MAC1_SOFTRESET_Pos        15                                                      /*!< NT_ETHERNET MAC1: SOFTRESET Position    */
#define NT_ETHERNET_MAC1_SOFTRESET_Msk        (0x01UL << NT_ETHERNET_MAC1_SOFTRESET_Pos)              /*!< NT_ETHERNET MAC1: SOFTRESET Mask        */

/* ------------------------------  NT_ETHERNET_MAC2  ------------------------------ */
#define NT_ETHERNET_MAC2_FULLDUPLEX_Pos       0                                                       /*!< NT_ETHERNET MAC2: FULLDUPLEX Position   */
#define NT_ETHERNET_MAC2_FULLDUPLEX_Msk       (0x01UL << NT_ETHERNET_MAC2_FULLDUPLEX_Pos)             /*!< NT_ETHERNET MAC2: FULLDUPLEX Mask       */
#define NT_ETHERNET_MAC2_LENGTHCHECK_Pos      1                                                       /*!< NT_ETHERNET MAC2: LENGTHCHECK Position  */
#define NT_ETHERNET_MAC2_LENGTHCHECK_Msk      (0x01UL << NT_ETHERNET_MAC2_LENGTHCHECK_Pos)            /*!< NT_ETHERNET MAC2: LENGTHCHECK Mask      */
#define NT_ETHERNET_MAC2_HUGEFRAME_Pos        2                                                       /*!< NT_ETHERNET MAC2: HUGEFRAME Position    */
#define NT_ETHERNET_MAC2_HUGEFRAME_Msk        (0x01UL << NT_ETHERNET_MAC2_HUGEFRAME_Pos)              /*!< NT_ETHERNET MAC2: HUGEFRAME Mask        */
#define NT_ETHERNET_MAC2_DALAYCRC_Pos         3                                                       /*!< NT_ETHERNET MAC2: DALAYCRC Position     */
#define NT_ETHERNET_MAC2_DALAYCRC_Msk         (0x01UL << NT_ETHERNET_MAC2_DALAYCRC_Pos)               /*!< NT_ETHERNET MAC2: DALAYCRC Mask         */
#define NT_ETHERNET_MAC2_CRCENABLE_Pos        4                                                       /*!< NT_ETHERNET MAC2: CRCENABLE Position    */
#define NT_ETHERNET_MAC2_CRCENABLE_Msk        (0x01UL << NT_ETHERNET_MAC2_CRCENABLE_Pos)              /*!< NT_ETHERNET MAC2: CRCENABLE Mask        */
#define NT_ETHERNET_MAC2_PADENABLE_Pos        5                                                       /*!< NT_ETHERNET MAC2: PADENABLE Position    */
#define NT_ETHERNET_MAC2_PADENABLE_Msk        (0x01UL << NT_ETHERNET_MAC2_PADENABLE_Pos)              /*!< NT_ETHERNET MAC2: PADENABLE Mask        */
#define NT_ETHERNET_MAC2_VLANPAD_Pos          6                                                       /*!< NT_ETHERNET MAC2: VLANPAD Position      */
#define NT_ETHERNET_MAC2_VLANPAD_Msk          (0x01UL << NT_ETHERNET_MAC2_VLANPAD_Pos)                /*!< NT_ETHERNET MAC2: VLANPAD Mask          */
#define NT_ETHERNET_MAC2_AUTOPAD_Pos          7                                                       /*!< NT_ETHERNET MAC2: AUTOPAD Position      */
#define NT_ETHERNET_MAC2_AUTOPAD_Msk          (0x01UL << NT_ETHERNET_MAC2_AUTOPAD_Pos)                /*!< NT_ETHERNET MAC2: AUTOPAD Mask          */
#define NT_ETHERNET_MAC2_PUREPRE_Pos          8                                                       /*!< NT_ETHERNET MAC2: PUREPRE Position      */
#define NT_ETHERNET_MAC2_PUREPRE_Msk          (0x01UL << NT_ETHERNET_MAC2_PUREPRE_Pos)                /*!< NT_ETHERNET MAC2: PUREPRE Mask          */
#define NT_ETHERNET_MAC2_LONGPRE_Pos          9                                                       /*!< NT_ETHERNET MAC2: LONGPRE Position      */
#define NT_ETHERNET_MAC2_LONGPRE_Msk          (0x01UL << NT_ETHERNET_MAC2_LONGPRE_Pos)                /*!< NT_ETHERNET MAC2: LONGPRE Mask          */
#define NT_ETHERNET_MAC2_NOBACKOFF_Pos        12                                                      /*!< NT_ETHERNET MAC2: NOBACKOFF Position    */
#define NT_ETHERNET_MAC2_NOBACKOFF_Msk        (0x01UL << NT_ETHERNET_MAC2_NOBACKOFF_Pos)              /*!< NT_ETHERNET MAC2: NOBACKOFF Mask        */
#define NT_ETHERNET_MAC2_BP_NOBACKOFF_Pos     13                                                      /*!< NT_ETHERNET MAC2: BP_NOBACKOFF Position */
#define NT_ETHERNET_MAC2_BP_NOBACKOFF_Msk     (0x01UL << NT_ETHERNET_MAC2_BP_NOBACKOFF_Pos)           /*!< NT_ETHERNET MAC2: BP_NOBACKOFF Mask     */
#define NT_ETHERNET_MAC2_EXCESSDEF_Pos        14                                                      /*!< NT_ETHERNET MAC2: EXCESSDEF Position    */
#define NT_ETHERNET_MAC2_EXCESSDEF_Msk        (0x01UL << NT_ETHERNET_MAC2_EXCESSDEF_Pos)              /*!< NT_ETHERNET MAC2: EXCESSDEF Mask        */

/* ------------------------------  NT_ETHERNET_IPGT  ------------------------------ */
#define NT_ETHERNET_IPGT_BTBIPG_TRANS_Pos     0                                                       /*!< NT_ETHERNET IPGT: BTBIPG_TRANS Position */
#define NT_ETHERNET_IPGT_BTBIPG_TRANS_Msk     (0x7fUL << NT_ETHERNET_IPGT_BTBIPG_TRANS_Pos)           /*!< NT_ETHERNET IPGT: BTBIPG_TRANS Mask     */

/* ------------------------------  NT_ETHERNET_IPGR  ------------------------------ */
#define NT_ETHERNET_IPGR_NBTBIPG_TRANS_PART2_Pos 0                                                    /*!< NT_ETHERNET IPGR: NBTBIPG_TRANS_PART2 Position */
#define NT_ETHERNET_IPGR_NBTBIPG_TRANS_PART2_Msk (0x7fUL << NT_ETHERNET_IPGR_NBTBIPG_TRANS_PART2_Pos) /*!< NT_ETHERNET IPGR: NBTBIPG_TRANS_PART2 Mask */
#define NT_ETHERNET_IPGR_NBTBIPG_TRANS_PART1_Pos 8                                                    /*!< NT_ETHERNET IPGR: NBTBIPG_TRANS_PART1 Position */
#define NT_ETHERNET_IPGR_NBTBIPG_TRANS_PART1_Msk (0x7fUL << NT_ETHERNET_IPGR_NBTBIPG_TRANS_PART1_Pos) /*!< NT_ETHERNET IPGR: NBTBIPG_TRANS_PART1 Mask */

/* ------------------------------  NT_ETHERNET_CLRT  ------------------------------ */
#define NT_ETHERNET_CLRT_RETRANS_MAX_Pos      0                                                       /*!< NT_ETHERNET CLRT: RETRANS_MAX Position  */
#define NT_ETHERNET_CLRT_RETRANS_MAX_Msk      (0x0fUL << NT_ETHERNET_CLRT_RETRANS_MAX_Pos)            /*!< NT_ETHERNET CLRT: RETRANS_MAX Mask      */
#define NT_ETHERNET_CLRT_COLLISION_WINDOW_Pos 8                                                       /*!< NT_ETHERNET CLRT: COLLISION_WINDOW Position */
#define NT_ETHERNET_CLRT_COLLISION_WINDOW_Msk (0x3fUL << NT_ETHERNET_CLRT_COLLISION_WINDOW_Pos)       /*!< NT_ETHERNET CLRT: COLLISION_WINDOW Mask */

/* ------------------------------  NT_ETHERNET_MAXF  ------------------------------ */
#define NT_ETHERNET_MAXF_MAXFRAME_LENGTH_Pos  0                                                       /*!< NT_ETHERNET MAXF: MAXFRAME_LENGTH Position */
#define NT_ETHERNET_MAXF_MAXFRAME_LENGTH_Msk  (0x0000ffffUL << NT_ETHERNET_MAXF_MAXFRAME_LENGTH_Pos)  /*!< NT_ETHERNET MAXF: MAXFRAME_LENGTH Mask  */

/* ------------------------------  NT_ETHERNET_SUPP  ------------------------------ */
#define NT_ETHERNET_SUPP_BITMODE_Pos          0                                                       /*!< NT_ETHERNET SUPP: BITMODE Position      */
#define NT_ETHERNET_SUPP_BITMODE_Msk          (0x01UL << NT_ETHERNET_SUPP_BITMODE_Pos)                /*!< NT_ETHERNET SUPP: BITMODE Mask          */
#define NT_ETHERNET_SUPP_ENBLJABBER_Pos       1                                                       /*!< NT_ETHERNET SUPP: ENBLJABBER Position   */
#define NT_ETHERNET_SUPP_ENBLJABBER_Msk       (0x01UL << NT_ETHERNET_SUPP_ENBLJABBER_Pos)             /*!< NT_ETHERNET SUPP: ENBLJABBER Mask       */
#define NT_ETHERNET_SUPP_RESET10T_Pos         3                                                       /*!< NT_ETHERNET SUPP: RESET10T Position     */
#define NT_ETHERNET_SUPP_RESET10T_Msk         (0x01UL << NT_ETHERNET_SUPP_RESET10T_Pos)               /*!< NT_ETHERNET SUPP: RESET10T Mask         */
#define NT_ETHERNET_SUPP_LINKFAIL_Pos         4                                                       /*!< NT_ETHERNET SUPP: LINKFAIL Position     */
#define NT_ETHERNET_SUPP_LINKFAIL_Msk         (0x01UL << NT_ETHERNET_SUPP_LINKFAIL_Pos)               /*!< NT_ETHERNET SUPP: LINKFAIL Mask         */
#define NT_ETHERNET_SUPP_NOCIPHER_Pos         5                                                       /*!< NT_ETHERNET SUPP: NOCIPHER Position     */
#define NT_ETHERNET_SUPP_NOCIPHER_Msk         (0x01UL << NT_ETHERNET_SUPP_NOCIPHER_Pos)               /*!< NT_ETHERNET SUPP: NOCIPHER Mask         */
#define NT_ETHERNET_SUPP_FORCEQUIET_Pos       6                                                       /*!< NT_ETHERNET SUPP: FORCEQUIET Position   */
#define NT_ETHERNET_SUPP_FORCEQUIET_Msk       (0x01UL << NT_ETHERNET_SUPP_FORCEQUIET_Pos)             /*!< NT_ETHERNET SUPP: FORCEQUIET Mask       */
#define NT_ETHERNET_SUPP_RESET100X_Pos        7                                                       /*!< NT_ETHERNET SUPP: RESET100X Position    */
#define NT_ETHERNET_SUPP_RESET100X_Msk        (0x01UL << NT_ETHERNET_SUPP_RESET100X_Pos)              /*!< NT_ETHERNET SUPP: RESET100X Mask        */
#define NT_ETHERNET_SUPP_SPEED_Pos            8                                                       /*!< NT_ETHERNET SUPP: SPEED Position        */
#define NT_ETHERNET_SUPP_SPEED_Msk            (0x01UL << NT_ETHERNET_SUPP_SPEED_Pos)                  /*!< NT_ETHERNET SUPP: SPEED Mask            */
#define NT_ETHERNET_SUPP_RESETRMII_Pos        11                                                      /*!< NT_ETHERNET SUPP: RESETRMII Position    */
#define NT_ETHERNET_SUPP_RESETRMII_Msk        (0x01UL << NT_ETHERNET_SUPP_RESETRMII_Pos)              /*!< NT_ETHERNET SUPP: RESETRMII Mask        */
#define NT_ETHERNET_SUPP_PHYMODE_Pos          12                                                      /*!< NT_ETHERNET SUPP: PHYMODE Position      */
#define NT_ETHERNET_SUPP_PHYMODE_Msk          (0x01UL << NT_ETHERNET_SUPP_PHYMODE_Pos)                /*!< NT_ETHERNET SUPP: PHYMODE Mask          */
#define NT_ETHERNET_SUPP_RESETINT_Pos         15                                                      /*!< NT_ETHERNET SUPP: RESETINT Position     */
#define NT_ETHERNET_SUPP_RESETINT_Msk         (0x01UL << NT_ETHERNET_SUPP_RESETINT_Pos)               /*!< NT_ETHERNET SUPP: RESETINT Mask         */

/* ------------------------------  NT_ETHERNET_MCFG  ------------------------------ */
#define NT_ETHERNET_MCFG_SCANINC_Pos          0                                                       /*!< NT_ETHERNET MCFG: SCANINC Position      */
#define NT_ETHERNET_MCFG_SCANINC_Msk          (0x01UL << NT_ETHERNET_MCFG_SCANINC_Pos)                /*!< NT_ETHERNET MCFG: SCANINC Mask          */
#define NT_ETHERNET_MCFG_NOPRE_Pos            1                                                       /*!< NT_ETHERNET MCFG: NOPRE Position        */
#define NT_ETHERNET_MCFG_NOPRE_Msk            (0x01UL << NT_ETHERNET_MCFG_NOPRE_Pos)                  /*!< NT_ETHERNET MCFG: NOPRE Mask            */
#define NT_ETHERNET_MCFG_CLOCK_SELECT_Pos     2                                                       /*!< NT_ETHERNET MCFG: CLOCK_SELECT Position */
#define NT_ETHERNET_MCFG_CLOCK_SELECT_Msk     (0x07UL << NT_ETHERNET_MCFG_CLOCK_SELECT_Pos)           /*!< NT_ETHERNET MCFG: CLOCK_SELECT Mask     */
#define NT_ETHERNET_MCFG_RESETMGMT_Pos        15                                                      /*!< NT_ETHERNET MCFG: RESETMGMT Position    */
#define NT_ETHERNET_MCFG_RESETMGMT_Msk        (0x01UL << NT_ETHERNET_MCFG_RESETMGMT_Pos)              /*!< NT_ETHERNET MCFG: RESETMGMT Mask        */

/* ------------------------------  NT_ETHERNET_MCMD  ------------------------------ */
#define NT_ETHERNET_MCMD_READ_Pos             0                                                       /*!< NT_ETHERNET MCMD: READ Position         */
#define NT_ETHERNET_MCMD_READ_Msk             (0x01UL << NT_ETHERNET_MCMD_READ_Pos)                   /*!< NT_ETHERNET MCMD: READ Mask             */
#define NT_ETHERNET_MCMD_SCAN_Pos             1                                                       /*!< NT_ETHERNET MCMD: SCAN Position         */
#define NT_ETHERNET_MCMD_SCAN_Msk             (0x01UL << NT_ETHERNET_MCMD_SCAN_Pos)                   /*!< NT_ETHERNET MCMD: SCAN Mask             */

/* ------------------------------  NT_ETHERNET_MADR  ------------------------------ */
#define NT_ETHERNET_MADR_REG_ADDRESS_Pos      0                                                       /*!< NT_ETHERNET MADR: REG_ADDRESS Position  */
#define NT_ETHERNET_MADR_REG_ADDRESS_Msk      (0x1fUL << NT_ETHERNET_MADR_REG_ADDRESS_Pos)            /*!< NT_ETHERNET MADR: REG_ADDRESS Mask      */
#define NT_ETHERNET_MADR_PHY_ADDRESS_Pos      8                                                       /*!< NT_ETHERNET MADR: PHY_ADDRESS Position  */
#define NT_ETHERNET_MADR_PHY_ADDRESS_Msk      (0x1fUL << NT_ETHERNET_MADR_PHY_ADDRESS_Pos)            /*!< NT_ETHERNET MADR: PHY_ADDRESS Mask      */

/* ------------------------------  NT_ETHERNET_MWTD  ------------------------------ */
#define NT_ETHERNET_MWTD_WRITE_DATA_Pos       0                                                       /*!< NT_ETHERNET MWTD: WRITE_DATA Position   */
#define NT_ETHERNET_MWTD_WRITE_DATA_Msk       (0x0000ffffUL << NT_ETHERNET_MWTD_WRITE_DATA_Pos)       /*!< NT_ETHERNET MWTD: WRITE_DATA Mask       */

/* ------------------------------  NT_ETHERNET_MRDD  ------------------------------ */
#define NT_ETHERNET_MRDD_READ_DATA_Pos        0                                                       /*!< NT_ETHERNET MRDD: READ_DATA Position    */
#define NT_ETHERNET_MRDD_READ_DATA_Msk        (0x0000ffffUL << NT_ETHERNET_MRDD_READ_DATA_Pos)        /*!< NT_ETHERNET MRDD: READ_DATA Mask        */

/* ------------------------------  NT_ETHERNET_MIND  ------------------------------ */
#define NT_ETHERNET_MIND_BUSY_Pos             0                                                       /*!< NT_ETHERNET MIND: BUSY Position         */
#define NT_ETHERNET_MIND_BUSY_Msk             (0x01UL << NT_ETHERNET_MIND_BUSY_Pos)                   /*!< NT_ETHERNET MIND: BUSY Mask             */
#define NT_ETHERNET_MIND_SCAN_Pos             1                                                       /*!< NT_ETHERNET MIND: SCAN Position         */
#define NT_ETHERNET_MIND_SCAN_Msk             (0x01UL << NT_ETHERNET_MIND_SCAN_Pos)                   /*!< NT_ETHERNET MIND: SCAN Mask             */
#define NT_ETHERNET_MIND_NOTVALID_Pos         2                                                       /*!< NT_ETHERNET MIND: NOTVALID Position     */
#define NT_ETHERNET_MIND_NOTVALID_Msk         (0x01UL << NT_ETHERNET_MIND_NOTVALID_Pos)               /*!< NT_ETHERNET MIND: NOTVALID Mask         */
#define NT_ETHERNET_MIND_LINKFAIL_Pos         3                                                       /*!< NT_ETHERNET MIND: LINKFAIL Position     */
#define NT_ETHERNET_MIND_LINKFAIL_Msk         (0x01UL << NT_ETHERNET_MIND_LINKFAIL_Pos)               /*!< NT_ETHERNET MIND: LINKFAIL Mask         */

/* ------------------------------  NT_ETHERNET_SMII  ------------------------------ */
#define NT_ETHERNET_SMII_SPEED_Pos            0                                                       /*!< NT_ETHERNET SMII: SPEED Position        */
#define NT_ETHERNET_SMII_SPEED_Msk            (0x01UL << NT_ETHERNET_SMII_SPEED_Pos)                  /*!< NT_ETHERNET SMII: SPEED Mask            */
#define NT_ETHERNET_SMII_DUPLEX_Pos           1                                                       /*!< NT_ETHERNET SMII: DUPLEX Position       */
#define NT_ETHERNET_SMII_DUPLEX_Msk           (0x01UL << NT_ETHERNET_SMII_DUPLEX_Pos)                 /*!< NT_ETHERNET SMII: DUPLEX Mask           */
#define NT_ETHERNET_SMII_LINK_Pos             2                                                       /*!< NT_ETHERNET SMII: LINK Position         */
#define NT_ETHERNET_SMII_LINK_Msk             (0x01UL << NT_ETHERNET_SMII_LINK_Pos)                   /*!< NT_ETHERNET SMII: LINK Mask             */
#define NT_ETHERNET_SMII_JABBER_Pos           3                                                       /*!< NT_ETHERNET SMII: JABBER Position       */
#define NT_ETHERNET_SMII_JABBER_Msk           (0x01UL << NT_ETHERNET_SMII_JABBER_Pos)                 /*!< NT_ETHERNET SMII: JABBER Mask           */
#define NT_ETHERNET_SMII_CLASH_Pos            4                                                       /*!< NT_ETHERNET SMII: CLASH Position        */
#define NT_ETHERNET_SMII_CLASH_Msk            (0x01UL << NT_ETHERNET_SMII_CLASH_Pos)                  /*!< NT_ETHERNET SMII: CLASH Mask            */

/* -----------------------------  NT_ETHERNET_FIFOCFG  ---------------------------- */
#define NT_ETHERNET_FIFOCFG_RST_Pos           0                                                       /*!< NT_ETHERNET FIFOCFG: RST Position       */
#define NT_ETHERNET_FIFOCFG_RST_Msk           (0x1fUL << NT_ETHERNET_FIFOCFG_RST_Pos)                 /*!< NT_ETHERNET FIFOCFG: RST Mask           */
#define NT_ETHERNET_FIFOCFG_ENREQ_Pos         8                                                       /*!< NT_ETHERNET FIFOCFG: ENREQ Position     */
#define NT_ETHERNET_FIFOCFG_ENREQ_Msk         (0x1fUL << NT_ETHERNET_FIFOCFG_ENREQ_Pos)               /*!< NT_ETHERNET FIFOCFG: ENREQ Mask         */
#define NT_ETHERNET_FIFOCFG_ENRPLY_Pos        16                                                      /*!< NT_ETHERNET FIFOCFG: ENRPLY Position    */
#define NT_ETHERNET_FIFOCFG_ENRPLY_Msk        (0x1fUL << NT_ETHERNET_FIFOCFG_ENRPLY_Pos)              /*!< NT_ETHERNET FIFOCFG: ENRPLY Mask        */

/* -------------------------------  NT_ETHERNET_SA0  ------------------------------ */
#define NT_ETHERNET_SA0_STATION_ADDRESS_2B_Pos 0                                                      /*!< NT_ETHERNET SA0: STATION_ADDRESS_2B Position */
#define NT_ETHERNET_SA0_STATION_ADDRESS_2B_Msk (0x000000ffUL << NT_ETHERNET_SA0_STATION_ADDRESS_2B_Pos)/*!< NT_ETHERNET SA0: STATION_ADDRESS_2B Mask */
#define NT_ETHERNET_SA0_STATION_ADDRESS_1B_Pos 8                                                      /*!< NT_ETHERNET SA0: STATION_ADDRESS_1B Position */
#define NT_ETHERNET_SA0_STATION_ADDRESS_1B_Msk (0x000000ffUL << NT_ETHERNET_SA0_STATION_ADDRESS_1B_Pos)/*!< NT_ETHERNET SA0: STATION_ADDRESS_1B Mask */

/* -------------------------------  NT_ETHERNET_SA1  ------------------------------ */
#define NT_ETHERNET_SA1_STATION_ADDRESS_4B_Pos 0                                                      /*!< NT_ETHERNET SA1: STATION_ADDRESS_4B Position */
#define NT_ETHERNET_SA1_STATION_ADDRESS_4B_Msk (0x000000ffUL << NT_ETHERNET_SA1_STATION_ADDRESS_4B_Pos)/*!< NT_ETHERNET SA1: STATION_ADDRESS_4B Mask */
#define NT_ETHERNET_SA1_STATION_ADDRESS_3B_Pos 8                                                      /*!< NT_ETHERNET SA1: STATION_ADDRESS_3B Position */
#define NT_ETHERNET_SA1_STATION_ADDRESS_3B_Msk (0x000000ffUL << NT_ETHERNET_SA1_STATION_ADDRESS_3B_Pos)/*!< NT_ETHERNET SA1: STATION_ADDRESS_3B Mask */

/* -------------------------------  NT_ETHERNET_SA2  ------------------------------ */
#define NT_ETHERNET_SA2_STATION_ADDRESS_6B_Pos 0                                                      /*!< NT_ETHERNET SA2: STATION_ADDRESS_6B Position */
#define NT_ETHERNET_SA2_STATION_ADDRESS_6B_Msk (0x000000ffUL << NT_ETHERNET_SA2_STATION_ADDRESS_6B_Pos)/*!< NT_ETHERNET SA2: STATION_ADDRESS_6B Mask */
#define NT_ETHERNET_SA2_STATION_ADDRESS_5B_Pos 8                                                      /*!< NT_ETHERNET SA2: STATION_ADDRESS_5B Position */
#define NT_ETHERNET_SA2_STATION_ADDRESS_5B_Msk (0x000000ffUL << NT_ETHERNET_SA2_STATION_ADDRESS_5B_Pos)/*!< NT_ETHERNET SA2: STATION_ADDRESS_5B Mask */

/* ----------------------------  NT_ETHERNET_DMATxCtrl  --------------------------- */
#define NT_ETHERNET_DMATxCtrl_RXENABLE_Pos    0                                                       /*!< NT_ETHERNET DMATxCtrl: RXENABLE Position */
#define NT_ETHERNET_DMATxCtrl_RXENABLE_Msk    (0x01UL << NT_ETHERNET_DMATxCtrl_RXENABLE_Pos)          /*!< NT_ETHERNET DMATxCtrl: RXENABLE Mask    */

/* -------------------------  NT_ETHERNET_DMATxDescriptor  ------------------------ */
#define NT_ETHERNET_DMATxDescriptor_DADDR_Pos 2                                                       /*!< NT_ETHERNET DMATxDescriptor: DADDR Position */
#define NT_ETHERNET_DMATxDescriptor_DADDR_Msk (0x3fffffffUL << NT_ETHERNET_DMATxDescriptor_DADDR_Pos) /*!< NT_ETHERNET DMATxDescriptor: DADDR Mask */

/* ---------------------------  NT_ETHERNET_DMATxStatus  -------------------------- */
#define NT_ETHERNET_DMATxStatus_TXPKTREC_Pos  0                                                       /*!< NT_ETHERNET DMATxStatus: TXPKTREC Position */
#define NT_ETHERNET_DMATxStatus_TXPKTREC_Msk  (0x01UL << NT_ETHERNET_DMATxStatus_TXPKTREC_Pos)        /*!< NT_ETHERNET DMATxStatus: TXPKTREC Mask  */
#define NT_ETHERNET_DMATxStatus_TXOVERFLOW_Pos 2                                                      /*!< NT_ETHERNET DMATxStatus: TXOVERFLOW Position */
#define NT_ETHERNET_DMATxStatus_TXOVERFLOW_Msk (0x01UL << NT_ETHERNET_DMATxStatus_TXOVERFLOW_Pos)     /*!< NT_ETHERNET DMATxStatus: TXOVERFLOW Mask */
#define NT_ETHERNET_DMATxStatus_BUSERROR_Pos  3                                                       /*!< NT_ETHERNET DMATxStatus: BUSERROR Position */
#define NT_ETHERNET_DMATxStatus_BUSERROR_Msk  (0x01UL << NT_ETHERNET_DMATxStatus_BUSERROR_Pos)        /*!< NT_ETHERNET DMATxStatus: BUSERROR Mask  */
#define NT_ETHERNET_DMATxStatus_TX_PKT_COUNT_Pos 16                                                   /*!< NT_ETHERNET DMATxStatus: TX_PKT_COUNT Position */
#define NT_ETHERNET_DMATxStatus_TX_PKT_COUNT_Msk (0x000000ffUL << NT_ETHERNET_DMATxStatus_TX_PKT_COUNT_Pos)/*!< NT_ETHERNET DMATxStatus: TX_PKT_COUNT Mask */

/* ----------------------------  NT_ETHERNET_DMARxCtrl  --------------------------- */
#define NT_ETHERNET_DMARxCtrl_RXENABLE_Pos    0                                                       /*!< NT_ETHERNET DMARxCtrl: RXENABLE Position */
#define NT_ETHERNET_DMARxCtrl_RXENABLE_Msk    (0x01UL << NT_ETHERNET_DMARxCtrl_RXENABLE_Pos)          /*!< NT_ETHERNET DMARxCtrl: RXENABLE Mask    */

/* -------------------------  NT_ETHERNET_DMARxDescriptor  ------------------------ */
#define NT_ETHERNET_DMARxDescriptor_DADDR_Pos 2                                                       /*!< NT_ETHERNET DMARxDescriptor: DADDR Position */
#define NT_ETHERNET_DMARxDescriptor_DADDR_Msk (0x3fffffffUL << NT_ETHERNET_DMARxDescriptor_DADDR_Pos) /*!< NT_ETHERNET DMARxDescriptor: DADDR Mask */

/* ---------------------------  NT_ETHERNET_DMARxStatus  -------------------------- */
#define NT_ETHERNET_DMARxStatus_RXPKTREC_Pos  0                                                       /*!< NT_ETHERNET DMARxStatus: RXPKTREC Position */
#define NT_ETHERNET_DMARxStatus_RXPKTREC_Msk  (0x01UL << NT_ETHERNET_DMARxStatus_RXPKTREC_Pos)        /*!< NT_ETHERNET DMARxStatus: RXPKTREC Mask  */
#define NT_ETHERNET_DMARxStatus_TXOVERFLOW_Pos 2                                                      /*!< NT_ETHERNET DMARxStatus: TXOVERFLOW Position */
#define NT_ETHERNET_DMARxStatus_TXOVERFLOW_Msk (0x01UL << NT_ETHERNET_DMARxStatus_TXOVERFLOW_Pos)     /*!< NT_ETHERNET DMARxStatus: TXOVERFLOW Mask */
#define NT_ETHERNET_DMARxStatus_BUSERROR_Pos  3                                                       /*!< NT_ETHERNET DMARxStatus: BUSERROR Position */
#define NT_ETHERNET_DMARxStatus_BUSERROR_Msk  (0x01UL << NT_ETHERNET_DMARxStatus_BUSERROR_Pos)        /*!< NT_ETHERNET DMARxStatus: BUSERROR Mask  */
#define NT_ETHERNET_DMARxStatus_RX_PKT_COUNT_Pos 16                                                   /*!< NT_ETHERNET DMARxStatus: RX_PKT_COUNT Position */
#define NT_ETHERNET_DMARxStatus_RX_PKT_COUNT_Msk (0x000000ffUL << NT_ETHERNET_DMARxStatus_RX_PKT_COUNT_Pos)/*!< NT_ETHERNET DMARxStatus: RX_PKT_COUNT Mask */

/* ---------------------------  NT_ETHERNET_DMAINTMASK  --------------------------- */
#define NT_ETHERNET_DMAINTMASK_TXPKTSENT_Pos  0                                                       /*!< NT_ETHERNET DMAINTMASK: TXPKTSENT Position */
#define NT_ETHERNET_DMAINTMASK_TXPKTSENT_Msk  (0x01UL << NT_ETHERNET_DMAINTMASK_TXPKTSENT_Pos)        /*!< NT_ETHERNET DMAINTMASK: TXPKTSENT Mask  */
#define NT_ETHERNET_DMAINTMASK_TXUNDERRRUN_Pos 1                                                      /*!< NT_ETHERNET DMAINTMASK: TXUNDERRRUN Position */
#define NT_ETHERNET_DMAINTMASK_TXUNDERRRUN_Msk (0x01UL << NT_ETHERNET_DMAINTMASK_TXUNDERRRUN_Pos)     /*!< NT_ETHERNET DMAINTMASK: TXUNDERRRUN Mask */
#define NT_ETHERNET_DMAINTMASK_BUSERR_TX_Pos  3                                                       /*!< NT_ETHERNET DMAINTMASK: BUSERR_TX Position */
#define NT_ETHERNET_DMAINTMASK_BUSERR_TX_Msk  (0x01UL << NT_ETHERNET_DMAINTMASK_BUSERR_TX_Pos)        /*!< NT_ETHERNET DMAINTMASK: BUSERR_TX Mask  */
#define NT_ETHERNET_DMAINTMASK_RXPKTREC_Pos   4                                                       /*!< NT_ETHERNET DMAINTMASK: RXPKTREC Position */
#define NT_ETHERNET_DMAINTMASK_RXPKTREC_Msk   (0x01UL << NT_ETHERNET_DMAINTMASK_RXPKTREC_Pos)         /*!< NT_ETHERNET DMAINTMASK: RXPKTREC Mask   */
#define NT_ETHERNET_DMAINTMASK_RXOVER_Pos     6                                                       /*!< NT_ETHERNET DMAINTMASK: RXOVER Position */
#define NT_ETHERNET_DMAINTMASK_RXOVER_Msk     (0x01UL << NT_ETHERNET_DMAINTMASK_RXOVER_Pos)           /*!< NT_ETHERNET DMAINTMASK: RXOVER Mask     */
#define NT_ETHERNET_DMAINTMASK_BUSERR_RX_Pos  7                                                       /*!< NT_ETHERNET DMAINTMASK: BUSERR_RX Position */
#define NT_ETHERNET_DMAINTMASK_BUSERR_RX_Msk  (0x01UL << NT_ETHERNET_DMAINTMASK_BUSERR_RX_Pos)        /*!< NT_ETHERNET DMAINTMASK: BUSERR_RX Mask  */

/* -----------------------------  NT_ETHERNET_DMAINT  ----------------------------- */
#define NT_ETHERNET_DMAINT_TXPKTSENT_Pos      0                                                       /*!< NT_ETHERNET DMAINT: TXPKTSENT Position  */
#define NT_ETHERNET_DMAINT_TXPKTSENT_Msk      (0x01UL << NT_ETHERNET_DMAINT_TXPKTSENT_Pos)            /*!< NT_ETHERNET DMAINT: TXPKTSENT Mask      */
#define NT_ETHERNET_DMAINT_TXUNDERRRUN_Pos    1                                                       /*!< NT_ETHERNET DMAINT: TXUNDERRRUN Position */
#define NT_ETHERNET_DMAINT_TXUNDERRRUN_Msk    (0x01UL << NT_ETHERNET_DMAINT_TXUNDERRRUN_Pos)          /*!< NT_ETHERNET DMAINT: TXUNDERRRUN Mask    */
#define NT_ETHERNET_DMAINT_BUSERR_TX_Pos      3                                                       /*!< NT_ETHERNET DMAINT: BUSERR_TX Position  */
#define NT_ETHERNET_DMAINT_BUSERR_TX_Msk      (0x01UL << NT_ETHERNET_DMAINT_BUSERR_TX_Pos)            /*!< NT_ETHERNET DMAINT: BUSERR_TX Mask      */
#define NT_ETHERNET_DMAINT_RXPKTREC_Pos       4                                                       /*!< NT_ETHERNET DMAINT: RXPKTREC Position   */
#define NT_ETHERNET_DMAINT_RXPKTREC_Msk       (0x01UL << NT_ETHERNET_DMAINT_RXPKTREC_Pos)             /*!< NT_ETHERNET DMAINT: RXPKTREC Mask       */
#define NT_ETHERNET_DMAINT_RXOVER_Pos         6                                                       /*!< NT_ETHERNET DMAINT: RXOVER Position     */
#define NT_ETHERNET_DMAINT_RXOVER_Msk         (0x01UL << NT_ETHERNET_DMAINT_RXOVER_Pos)               /*!< NT_ETHERNET DMAINT: RXOVER Mask         */
#define NT_ETHERNET_DMAINT_BUSERR_RX_Pos      7                                                       /*!< NT_ETHERNET DMAINT: BUSERR_RX Position  */
#define NT_ETHERNET_DMAINT_BUSERR_RX_Msk      (0x01UL << NT_ETHERNET_DMAINT_BUSERR_RX_Pos)            /*!< NT_ETHERNET DMAINT: BUSERR_RX Mask      */


/* ================================================================================ */
/* ================       struct 'NT_USBHost' Position & Mask      ================ */
/* ================================================================================ */


/* -----------------------------  NT_USBHost_VERSION  ----------------------------- */
#define NT_USBHost_VERSION_VERSION_Pos        0                                                       /*!< NT_USBHost VERSION: VERSION Position    */
#define NT_USBHost_VERSION_VERSION_Msk        (0x000000ffUL << NT_USBHost_VERSION_VERSION_Pos)        /*!< NT_USBHost VERSION: VERSION Mask        */

/* -------------------------  NT_USBHost_USBCMD_STS_INTR  ------------------------- */
#define NT_USBHost_USBCMD_STS_INTR_OUTSPACEINTEN_Pos 1                                                /*!< NT_USBHost USBCMD_STS_INTR: OUTSPACEINTEN Position */
#define NT_USBHost_USBCMD_STS_INTR_OUTSPACEINTEN_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_OUTSPACEINTEN_Pos)/*!< NT_USBHost USBCMD_STS_INTR: OUTSPACEINTEN Mask */
#define NT_USBHost_USBCMD_STS_INTR_INDATAREADYINTEN_Pos 2                                             /*!< NT_USBHost USBCMD_STS_INTR: INDATAREADYINTEN Position */
#define NT_USBHost_USBCMD_STS_INTR_INDATAREADYINTEN_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_INDATAREADYINTEN_Pos)/*!< NT_USBHost USBCMD_STS_INTR: INDATAREADYINTEN Mask */
#define NT_USBHost_USBCMD_STS_INTR_FRAMESOFINTEN_Pos 3                                                /*!< NT_USBHost USBCMD_STS_INTR: FRAMESOFINTEN Position */
#define NT_USBHost_USBCMD_STS_INTR_FRAMESOFINTEN_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_FRAMESOFINTEN_Pos)/*!< NT_USBHost USBCMD_STS_INTR: FRAMESOFINTEN Mask */
#define NT_USBHost_USBCMD_STS_INTR_MICROFRAMEINTEN_Pos 4                                              /*!< NT_USBHost USBCMD_STS_INTR: MICROFRAMEINTEN Position */
#define NT_USBHost_USBCMD_STS_INTR_MICROFRAMEINTEN_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_MICROFRAMEINTEN_Pos)/*!< NT_USBHost USBCMD_STS_INTR: MICROFRAMEINTEN Mask */
#define NT_USBHost_USBCMD_STS_INTR_PORTCHANGINTEN_Pos 6                                               /*!< NT_USBHost USBCMD_STS_INTR: PORTCHANGINTEN Position */
#define NT_USBHost_USBCMD_STS_INTR_PORTCHANGINTEN_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_PORTCHANGINTEN_Pos)/*!< NT_USBHost USBCMD_STS_INTR: PORTCHANGINTEN Mask */
#define NT_USBHost_USBCMD_STS_INTR_FRAMESOFINT_Pos 10                                                 /*!< NT_USBHost USBCMD_STS_INTR: FRAMESOFINT Position */
#define NT_USBHost_USBCMD_STS_INTR_FRAMESOFINT_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_FRAMESOFINT_Pos)/*!< NT_USBHost USBCMD_STS_INTR: FRAMESOFINT Mask */
#define NT_USBHost_USBCMD_STS_INTR_MICROFRAMEINT_Pos 11                                               /*!< NT_USBHost USBCMD_STS_INTR: MICROFRAMEINT Position */
#define NT_USBHost_USBCMD_STS_INTR_MICROFRAMEINT_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_MICROFRAMEINT_Pos)/*!< NT_USBHost USBCMD_STS_INTR: MICROFRAMEINT Mask */
#define NT_USBHost_USBCMD_STS_INTR_PORTCHANGINT_Pos 13                                                /*!< NT_USBHost USBCMD_STS_INTR: PORTCHANGINT Position */
#define NT_USBHost_USBCMD_STS_INTR_PORTCHANGINT_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_PORTCHANGINT_Pos)/*!< NT_USBHost USBCMD_STS_INTR: PORTCHANGINT Mask */
#define NT_USBHost_USBCMD_STS_INTR_HCHALTED_Pos 15                                                    /*!< NT_USBHost USBCMD_STS_INTR: HCHALTED Position */
#define NT_USBHost_USBCMD_STS_INTR_HCHALTED_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_HCHALTED_Pos)   /*!< NT_USBHost USBCMD_STS_INTR: HCHALTED Mask */
#define NT_USBHost_USBCMD_STS_INTR_RUN_STOP_Pos 16                                                    /*!< NT_USBHost USBCMD_STS_INTR: RUN_STOP Position */
#define NT_USBHost_USBCMD_STS_INTR_RUN_STOP_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_RUN_STOP_Pos)   /*!< NT_USBHost USBCMD_STS_INTR: RUN_STOP Mask */
#define NT_USBHost_USBCMD_STS_INTR_HOSTRESET_Pos 17                                                   /*!< NT_USBHost USBCMD_STS_INTR: HOSTRESET Position */
#define NT_USBHost_USBCMD_STS_INTR_HOSTRESET_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_HOSTRESET_Pos) /*!< NT_USBHost USBCMD_STS_INTR: HOSTRESET Mask */
#define NT_USBHost_USBCMD_STS_INTR_CONFIGFLAG_Pos 18                                                  /*!< NT_USBHost USBCMD_STS_INTR: CONFIGFLAG Position */
#define NT_USBHost_USBCMD_STS_INTR_CONFIGFLAG_Msk (0x01UL << NT_USBHost_USBCMD_STS_INTR_CONFIGFLAG_Pos)/*!< NT_USBHost USBCMD_STS_INTR: CONFIGFLAG Mask */
#define NT_USBHost_USBCMD_STS_INTR_INT_SPACE_Pos 24                                                   /*!< NT_USBHost USBCMD_STS_INTR: INT_SPACE Position */
#define NT_USBHost_USBCMD_STS_INTR_INT_SPACE_Msk (0x000000ffUL << NT_USBHost_USBCMD_STS_INTR_INT_SPACE_Pos)/*!< NT_USBHost USBCMD_STS_INTR: INT_SPACE Mask */

/* ----------------------------  NT_USBHost_FRAME_REG  ---------------------------- */
#define NT_USBHost_FRAME_REG_FRAMEINDEX_Pos   0                                                       /*!< NT_USBHost FRAME_REG: FRAMEINDEX Position */
#define NT_USBHost_FRAME_REG_FRAMEINDEX_Msk   (0x00003fffUL << NT_USBHost_FRAME_REG_FRAMEINDEX_Pos)   /*!< NT_USBHost FRAME_REG: FRAMEINDEX Mask   */
#define NT_USBHost_FRAME_REG_FRAMELENGTH_Pos  16                                                      /*!< NT_USBHost FRAME_REG: FRAMELENGTH Position */
#define NT_USBHost_FRAME_REG_FRAMELENGTH_Msk  (0x3fUL << NT_USBHost_FRAME_REG_FRAMELENGTH_Pos)        /*!< NT_USBHost FRAME_REG: FRAMELENGTH Mask  */

/* -----------------------------  NT_USBHost_PORT_STS  ---------------------------- */
#define NT_USBHost_PORT_STS_PORTCONNECT_Pos   0                                                       /*!< NT_USBHost PORT_STS: PORTCONNECT Position */
#define NT_USBHost_PORT_STS_PORTCONNECT_Msk   (0x01UL << NT_USBHost_PORT_STS_PORTCONNECT_Pos)         /*!< NT_USBHost PORT_STS: PORTCONNECT Mask   */
#define NT_USBHost_PORT_STS_PORTCONCHNG_Pos   1                                                       /*!< NT_USBHost PORT_STS: PORTCONCHNG Position */
#define NT_USBHost_PORT_STS_PORTCONCHNG_Msk   (0x01UL << NT_USBHost_PORT_STS_PORTCONCHNG_Pos)         /*!< NT_USBHost PORT_STS: PORTCONCHNG Mask   */
#define NT_USBHost_PORT_STS_PORTENABLE_Pos    2                                                       /*!< NT_USBHost PORT_STS: PORTENABLE Position */
#define NT_USBHost_PORT_STS_PORTENABLE_Msk    (0x01UL << NT_USBHost_PORT_STS_PORTENABLE_Pos)          /*!< NT_USBHost PORT_STS: PORTENABLE Mask    */
#define NT_USBHost_PORT_STS_PORTEN_DISCHNG_Pos 3                                                      /*!< NT_USBHost PORT_STS: PORTEN_DISCHNG Position */
#define NT_USBHost_PORT_STS_PORTEN_DISCHNG_Msk (0x01UL << NT_USBHost_PORT_STS_PORTEN_DISCHNG_Pos)     /*!< NT_USBHost PORT_STS: PORTEN_DISCHNG Mask */
#define NT_USBHost_PORT_STS_PORTRESET_Pos     4                                                       /*!< NT_USBHost PORT_STS: PORTRESET Position */
#define NT_USBHost_PORT_STS_PORTRESET_Msk     (0x01UL << NT_USBHost_PORT_STS_PORTRESET_Pos)           /*!< NT_USBHost PORT_STS: PORTRESET Mask     */
#define NT_USBHost_PORT_STS_LINESTATE_Pos     5                                                       /*!< NT_USBHost PORT_STS: LINESTATE Position */
#define NT_USBHost_PORT_STS_LINESTATE_Msk     (0x03UL << NT_USBHost_PORT_STS_LINESTATE_Pos)           /*!< NT_USBHost PORT_STS: LINESTATE Mask     */
#define NT_USBHost_PORT_STS_PORTOWNER0_Pos    7                                                       /*!< NT_USBHost PORT_STS: PORTOWNER0 Position */
#define NT_USBHost_PORT_STS_PORTOWNER0_Msk    (0x01UL << NT_USBHost_PORT_STS_PORTOWNER0_Pos)          /*!< NT_USBHost PORT_STS: PORTOWNER0 Mask    */
#define NT_USBHost_PORT_STS_SUSPEND_Pos       8                                                       /*!< NT_USBHost PORT_STS: SUSPEND Position   */
#define NT_USBHost_PORT_STS_SUSPEND_Msk       (0x01UL << NT_USBHost_PORT_STS_SUSPEND_Pos)             /*!< NT_USBHost PORT_STS: SUSPEND Mask       */
#define NT_USBHost_PORT_STS_FORCEPORTRESUME_Pos 9                                                     /*!< NT_USBHost PORT_STS: FORCEPORTRESUME Position */
#define NT_USBHost_PORT_STS_FORCEPORTRESUME_Msk (0x01UL << NT_USBHost_PORT_STS_FORCEPORTRESUME_Pos)   /*!< NT_USBHost PORT_STS: FORCEPORTRESUME Mask */
#define NT_USBHost_PORT_STS_XCVRRESET_Pos     10                                                      /*!< NT_USBHost PORT_STS: XCVRRESET Position */
#define NT_USBHost_PORT_STS_XCVRRESET_Msk     (0x01UL << NT_USBHost_PORT_STS_XCVRRESET_Pos)           /*!< NT_USBHost PORT_STS: XCVRRESET Mask     */
#define NT_USBHost_PORT_STS_XCVRRESLEVEL_Pos  11                                                      /*!< NT_USBHost PORT_STS: XCVRRESLEVEL Position */
#define NT_USBHost_PORT_STS_XCVRRESLEVEL_Msk  (0x01UL << NT_USBHost_PORT_STS_XCVRRESLEVEL_Pos)        /*!< NT_USBHost PORT_STS: XCVRRESLEVEL Mask  */
#define NT_USBHost_PORT_STS_XCVRSUSPEND_Pos   12                                                      /*!< NT_USBHost PORT_STS: XCVRSUSPEND Position */
#define NT_USBHost_PORT_STS_XCVRSUSPEND_Msk   (0x01UL << NT_USBHost_PORT_STS_XCVRSUSPEND_Pos)         /*!< NT_USBHost PORT_STS: XCVRSUSPEND Mask   */
#define NT_USBHost_PORT_STS_TESTJ_Pos         13                                                      /*!< NT_USBHost PORT_STS: TESTJ Position     */
#define NT_USBHost_PORT_STS_TESTJ_Msk         (0x01UL << NT_USBHost_PORT_STS_TESTJ_Pos)               /*!< NT_USBHost PORT_STS: TESTJ Mask         */
#define NT_USBHost_PORT_STS_TESTK_Pos         14                                                      /*!< NT_USBHost PORT_STS: TESTK Position     */
#define NT_USBHost_PORT_STS_TESTK_Msk         (0x01UL << NT_USBHost_PORT_STS_TESTK_Pos)               /*!< NT_USBHost PORT_STS: TESTK Mask         */
#define NT_USBHost_PORT_STS_TESTSEO_Pos       15                                                      /*!< NT_USBHost PORT_STS: TESTSEO Position   */
#define NT_USBHost_PORT_STS_TESTSEO_Msk       (0x01UL << NT_USBHost_PORT_STS_TESTSEO_Pos)             /*!< NT_USBHost PORT_STS: TESTSEO Mask       */
#define NT_USBHost_PORT_STS_TESTFORCEEN_Pos   16                                                      /*!< NT_USBHost PORT_STS: TESTFORCEEN Position */
#define NT_USBHost_PORT_STS_TESTFORCEEN_Msk   (0x01UL << NT_USBHost_PORT_STS_TESTFORCEEN_Pos)         /*!< NT_USBHost PORT_STS: TESTFORCEEN Mask   */
#define NT_USBHost_PORT_STS_TESTPKT_Pos       17                                                      /*!< NT_USBHost PORT_STS: TESTPKT Position   */
#define NT_USBHost_PORT_STS_TESTPKT_Msk       (0x01UL << NT_USBHost_PORT_STS_TESTPKT_Pos)             /*!< NT_USBHost PORT_STS: TESTPKT Mask       */
#define NT_USBHost_PORT_STS_PORTOWNER1_Pos    18                                                      /*!< NT_USBHost PORT_STS: PORTOWNER1 Position */
#define NT_USBHost_PORT_STS_PORTOWNER1_Msk    (0x01UL << NT_USBHost_PORT_STS_PORTOWNER1_Pos)          /*!< NT_USBHost PORT_STS: PORTOWNER1 Mask    */

/* -------------------------  NT_USBHost_USB_PKT_FIELDS_A  ------------------------ */
#define NT_USBHost_USB_PKT_FIELDS_A_EP_ADDR_Pos 0                                                     /*!< NT_USBHost USB_PKT_FIELDS_A: EP_ADDR Position */
#define NT_USBHost_USB_PKT_FIELDS_A_EP_ADDR_Msk (0x0fUL << NT_USBHost_USB_PKT_FIELDS_A_EP_ADDR_Pos)   /*!< NT_USBHost USB_PKT_FIELDS_A: EP_ADDR Mask */
#define NT_USBHost_USB_PKT_FIELDS_A_PID_Pos   4                                                       /*!< NT_USBHost USB_PKT_FIELDS_A: PID Position */
#define NT_USBHost_USB_PKT_FIELDS_A_PID_Msk   (0x03UL << NT_USBHost_USB_PKT_FIELDS_A_PID_Pos)         /*!< NT_USBHost USB_PKT_FIELDS_A: PID Mask   */
#define NT_USBHost_USB_PKT_FIELDS_A_ENDPOINTTYPE_Pos 6                                                /*!< NT_USBHost USB_PKT_FIELDS_A: ENDPOINTTYPE Position */
#define NT_USBHost_USB_PKT_FIELDS_A_ENDPOINTTYPE_Msk (0x03UL << NT_USBHost_USB_PKT_FIELDS_A_ENDPOINTTYPE_Pos)/*!< NT_USBHost USB_PKT_FIELDS_A: ENDPOINTTYPE Mask */
#define NT_USBHost_USB_PKT_FIELDS_A_DEV_ADDR_Pos 8                                                    /*!< NT_USBHost USB_PKT_FIELDS_A: DEV_ADDR Position */
#define NT_USBHost_USB_PKT_FIELDS_A_DEV_ADDR_Msk (0x7fUL << NT_USBHost_USB_PKT_FIELDS_A_DEV_ADDR_Pos) /*!< NT_USBHost USB_PKT_FIELDS_A: DEV_ADDR Mask */
#define NT_USBHost_USB_PKT_FIELDS_A_IOC_Pos   15                                                      /*!< NT_USBHost USB_PKT_FIELDS_A: IOC Position */
#define NT_USBHost_USB_PKT_FIELDS_A_IOC_Msk   (0x01UL << NT_USBHost_USB_PKT_FIELDS_A_IOC_Pos)         /*!< NT_USBHost USB_PKT_FIELDS_A: IOC Mask   */
#define NT_USBHost_USB_PKT_FIELDS_A_PORT_NUMBER_Pos 16                                                /*!< NT_USBHost USB_PKT_FIELDS_A: PORT_NUMBER Position */
#define NT_USBHost_USB_PKT_FIELDS_A_PORT_NUMBER_Msk (0x7fUL << NT_USBHost_USB_PKT_FIELDS_A_PORT_NUMBER_Pos)/*!< NT_USBHost USB_PKT_FIELDS_A: PORT_NUMBER Mask */
#define NT_USBHost_USB_PKT_FIELDS_A_DATATOGGLE_Pos 23                                                 /*!< NT_USBHost USB_PKT_FIELDS_A: DATATOGGLE Position */
#define NT_USBHost_USB_PKT_FIELDS_A_DATATOGGLE_Msk (0x01UL << NT_USBHost_USB_PKT_FIELDS_A_DATATOGGLE_Pos)/*!< NT_USBHost USB_PKT_FIELDS_A: DATATOGGLE Mask */
#define NT_USBHost_USB_PKT_FIELDS_A_HUB_ADDRESS_Pos 24                                                /*!< NT_USBHost USB_PKT_FIELDS_A: HUB_ADDRESS Position */
#define NT_USBHost_USB_PKT_FIELDS_A_HUB_ADDRESS_Msk (0x7fUL << NT_USBHost_USB_PKT_FIELDS_A_HUB_ADDRESS_Pos)/*!< NT_USBHost USB_PKT_FIELDS_A: HUB_ADDRESS Mask */
#define NT_USBHost_USB_PKT_FIELDS_A_ENTRANSFER_Pos 31                                                 /*!< NT_USBHost USB_PKT_FIELDS_A: ENTRANSFER Position */
#define NT_USBHost_USB_PKT_FIELDS_A_ENTRANSFER_Msk (0x01UL << NT_USBHost_USB_PKT_FIELDS_A_ENTRANSFER_Pos)/*!< NT_USBHost USB_PKT_FIELDS_A: ENTRANSFER Mask */

/* -------------------------  NT_USBHost_USB_PKT_FIELDS_B  ------------------------ */
#define NT_USBHost_USB_PKT_FIELDS_B_MPS_Pos   0                                                       /*!< NT_USBHost USB_PKT_FIELDS_B: MPS Position */
#define NT_USBHost_USB_PKT_FIELDS_B_MPS_Msk   (0x000007ffUL << NT_USBHost_USB_PKT_FIELDS_B_MPS_Pos)   /*!< NT_USBHost USB_PKT_FIELDS_B: MPS Mask   */
#define NT_USBHost_USB_PKT_FIELDS_B_ABORTTRANSFER_Pos 11                                              /*!< NT_USBHost USB_PKT_FIELDS_B: ABORTTRANSFER Position */
#define NT_USBHost_USB_PKT_FIELDS_B_ABORTTRANSFER_Msk (0x01UL << NT_USBHost_USB_PKT_FIELDS_B_ABORTTRANSFER_Pos)/*!< NT_USBHost USB_PKT_FIELDS_B: ABORTTRANSFER Mask */
#define NT_USBHost_USB_PKT_FIELDS_B_XFRLEVEL_Pos 12                                                   /*!< NT_USBHost USB_PKT_FIELDS_B: XFRLEVEL Position */
#define NT_USBHost_USB_PKT_FIELDS_B_XFRLEVEL_Msk (0x01UL << NT_USBHost_USB_PKT_FIELDS_B_XFRLEVEL_Pos) /*!< NT_USBHost USB_PKT_FIELDS_B: XFRLEVEL Mask */
#define NT_USBHost_USB_PKT_FIELDS_B_IGNORSHORTPKT_Pos 13                                              /*!< NT_USBHost USB_PKT_FIELDS_B: IGNORSHORTPKT Position */
#define NT_USBHost_USB_PKT_FIELDS_B_IGNORSHORTPKT_Msk (0x01UL << NT_USBHost_USB_PKT_FIELDS_B_IGNORSHORTPKT_Pos)/*!< NT_USBHost USB_PKT_FIELDS_B: IGNORSHORTPKT Mask */
#define NT_USBHost_USB_PKT_FIELDS_B_EFIELD_Pos 14                                                     /*!< NT_USBHost USB_PKT_FIELDS_B: EFIELD Position */
#define NT_USBHost_USB_PKT_FIELDS_B_EFIELD_Msk (0x01UL << NT_USBHost_USB_PKT_FIELDS_B_EFIELD_Pos)     /*!< NT_USBHost USB_PKT_FIELDS_B: EFIELD Mask */
#define NT_USBHost_USB_PKT_FIELDS_B_SPEED_Pos 15                                                      /*!< NT_USBHost USB_PKT_FIELDS_B: SPEED Position */
#define NT_USBHost_USB_PKT_FIELDS_B_SPEED_Msk (0x01UL << NT_USBHost_USB_PKT_FIELDS_B_SPEED_Pos)       /*!< NT_USBHost USB_PKT_FIELDS_B: SPEED Mask */
#define NT_USBHost_USB_PKT_FIELDS_B_COMPLETESPLIT_Pos 16                                              /*!< NT_USBHost USB_PKT_FIELDS_B: COMPLETESPLIT Position */
#define NT_USBHost_USB_PKT_FIELDS_B_COMPLETESPLIT_Msk (0x01UL << NT_USBHost_USB_PKT_FIELDS_B_COMPLETESPLIT_Pos)/*!< NT_USBHost USB_PKT_FIELDS_B: COMPLETESPLIT Mask */
#define NT_USBHost_USB_PKT_FIELDS_B_STARTSPLIT_Pos 17                                                 /*!< NT_USBHost USB_PKT_FIELDS_B: STARTSPLIT Position */
#define NT_USBHost_USB_PKT_FIELDS_B_STARTSPLIT_Msk (0x01UL << NT_USBHost_USB_PKT_FIELDS_B_STARTSPLIT_Pos)/*!< NT_USBHost USB_PKT_FIELDS_B: STARTSPLIT Mask */
#define NT_USBHost_USB_PKT_FIELDS_B_MAX_ERR_CNT_Pos 20                                                /*!< NT_USBHost USB_PKT_FIELDS_B: MAX_ERR_CNT Position */
#define NT_USBHost_USB_PKT_FIELDS_B_MAX_ERR_CNT_Msk (0x0fUL << NT_USBHost_USB_PKT_FIELDS_B_MAX_ERR_CNT_Pos)/*!< NT_USBHost USB_PKT_FIELDS_B: MAX_ERR_CNT Mask */
#define NT_USBHost_USB_PKT_FIELDS_B_MAX_NAK_CNT_Pos 24                                                /*!< NT_USBHost USB_PKT_FIELDS_B: MAX_NAK_CNT Position */
#define NT_USBHost_USB_PKT_FIELDS_B_MAX_NAK_CNT_Msk (0x0fUL << NT_USBHost_USB_PKT_FIELDS_B_MAX_NAK_CNT_Pos)/*!< NT_USBHost USB_PKT_FIELDS_B: MAX_NAK_CNT Mask */
#define NT_USBHost_USB_PKT_FIELDS_B_SLAVEMODE_Pos 28                                                  /*!< NT_USBHost USB_PKT_FIELDS_B: SLAVEMODE Position */
#define NT_USBHost_USB_PKT_FIELDS_B_SLAVEMODE_Msk (0x01UL << NT_USBHost_USB_PKT_FIELDS_B_SLAVEMODE_Pos)/*!< NT_USBHost USB_PKT_FIELDS_B: SLAVEMODE Mask */
#define NT_USBHost_USB_PKT_FIELDS_B_OHCIENABLE_Pos 31                                                 /*!< NT_USBHost USB_PKT_FIELDS_B: OHCIENABLE Position */
#define NT_USBHost_USB_PKT_FIELDS_B_OHCIENABLE_Msk (0x01UL << NT_USBHost_USB_PKT_FIELDS_B_OHCIENABLE_Pos)/*!< NT_USBHost USB_PKT_FIELDS_B: OHCIENABLE Mask */

/* -------------------------  NT_USBHost_BUFF_START_ADDR  ------------------------- */
#define NT_USBHost_BUFF_START_ADDR_BUFFSTARTADDR_Pos 0                                                /*!< NT_USBHost BUFF_START_ADDR: BUFFSTARTADDR Position */
#define NT_USBHost_BUFF_START_ADDR_BUFFSTARTADDR_Msk (0xffffffffUL << NT_USBHost_BUFF_START_ADDR_BUFFSTARTADDR_Pos)/*!< NT_USBHost BUFF_START_ADDR: BUFFSTARTADDR Mask */

/* -------------------------------  NT_USBHost_TBT  ------------------------------- */
#define NT_USBHost_TBT_TOTALBTRANS_Pos        0                                                       /*!< NT_USBHost TBT: TOTALBTRANS Position    */
#define NT_USBHost_TBT_TOTALBTRANS_Msk        (0x000fffffUL << NT_USBHost_TBT_TOTALBTRANS_Pos)        /*!< NT_USBHost TBT: TOTALBTRANS Mask        */

/* ----------------------------  NT_USBHost_USB_STATUS  --------------------------- */
#define NT_USBHost_USB_STATUS_UNEXPPID_Pos    8                                                       /*!< NT_USBHost USB_STATUS: UNEXPPID Position */
#define NT_USBHost_USB_STATUS_UNEXPPID_Msk    (0x01UL << NT_USBHost_USB_STATUS_UNEXPPID_Pos)          /*!< NT_USBHost USB_STATUS: UNEXPPID Mask    */
#define NT_USBHost_USB_STATUS_SHORTPKT_Pos    9                                                       /*!< NT_USBHost USB_STATUS: SHORTPKT Position */
#define NT_USBHost_USB_STATUS_SHORTPKT_Msk    (0x01UL << NT_USBHost_USB_STATUS_SHORTPKT_Pos)          /*!< NT_USBHost USB_STATUS: SHORTPKT Mask    */
#define NT_USBHost_USB_STATUS_ERRPID_Pos      10                                                      /*!< NT_USBHost USB_STATUS: ERRPID Position  */
#define NT_USBHost_USB_STATUS_ERRPID_Msk      (0x01UL << NT_USBHost_USB_STATUS_ERRPID_Pos)            /*!< NT_USBHost USB_STATUS: ERRPID Mask      */
#define NT_USBHost_USB_STATUS_OUTSPACEVAILABLE_Pos 11                                                 /*!< NT_USBHost USB_STATUS: OUTSPACEVAILABLE Position */
#define NT_USBHost_USB_STATUS_OUTSPACEVAILABLE_Msk (0x01UL << NT_USBHost_USB_STATUS_OUTSPACEVAILABLE_Pos)/*!< NT_USBHost USB_STATUS: OUTSPACEVAILABLE Mask */
#define NT_USBHost_USB_STATUS_INDATAREADY_Pos 12                                                      /*!< NT_USBHost USB_STATUS: INDATAREADY Position */
#define NT_USBHost_USB_STATUS_INDATAREADY_Msk (0x01UL << NT_USBHost_USB_STATUS_INDATAREADY_Pos)       /*!< NT_USBHost USB_STATUS: INDATAREADY Mask */
#define NT_USBHost_USB_STATUS_PIDERR_Pos      13                                                      /*!< NT_USBHost USB_STATUS: PIDERR Position  */
#define NT_USBHost_USB_STATUS_PIDERR_Msk      (0x01UL << NT_USBHost_USB_STATUS_PIDERR_Pos)            /*!< NT_USBHost USB_STATUS: PIDERR Mask      */
#define NT_USBHost_USB_STATUS_CRCERR_Pos      14                                                      /*!< NT_USBHost USB_STATUS: CRCERR Position  */
#define NT_USBHost_USB_STATUS_CRCERR_Msk      (0x01UL << NT_USBHost_USB_STATUS_CRCERR_Pos)            /*!< NT_USBHost USB_STATUS: CRCERR Mask      */
#define NT_USBHost_USB_STATUS_TOGGLEERR_Pos   15                                                      /*!< NT_USBHost USB_STATUS: TOGGLEERR Position */
#define NT_USBHost_USB_STATUS_TOGGLEERR_Msk   (0x01UL << NT_USBHost_USB_STATUS_TOGGLEERR_Pos)         /*!< NT_USBHost USB_STATUS: TOGGLEERR Mask   */
#define NT_USBHost_USB_STATUS_TIMEOUT_Pos     16                                                      /*!< NT_USBHost USB_STATUS: TIMEOUT Position */
#define NT_USBHost_USB_STATUS_TIMEOUT_Msk     (0x01UL << NT_USBHost_USB_STATUS_TIMEOUT_Pos)           /*!< NT_USBHost USB_STATUS: TIMEOUT Mask     */
#define NT_USBHost_USB_STATUS_NYET_Pos        17                                                      /*!< NT_USBHost USB_STATUS: NYET Position    */
#define NT_USBHost_USB_STATUS_NYET_Msk        (0x01UL << NT_USBHost_USB_STATUS_NYET_Pos)              /*!< NT_USBHost USB_STATUS: NYET Mask        */
#define NT_USBHost_USB_STATUS_NAK_Pos         18                                                      /*!< NT_USBHost USB_STATUS: NAK Position     */
#define NT_USBHost_USB_STATUS_NAK_Msk         (0x01UL << NT_USBHost_USB_STATUS_NAK_Pos)               /*!< NT_USBHost USB_STATUS: NAK Mask         */
#define NT_USBHost_USB_STATUS_PAGECROSS_Pos   19                                                      /*!< NT_USBHost USB_STATUS: PAGECROSS Position */
#define NT_USBHost_USB_STATUS_PAGECROSS_Msk   (0x01UL << NT_USBHost_USB_STATUS_PAGECROSS_Pos)         /*!< NT_USBHost USB_STATUS: PAGECROSS Mask   */
#define NT_USBHost_USB_STATUS_PING_Pos        20                                                      /*!< NT_USBHost USB_STATUS: PING Position    */
#define NT_USBHost_USB_STATUS_PING_Msk        (0x01UL << NT_USBHost_USB_STATUS_PING_Pos)              /*!< NT_USBHost USB_STATUS: PING Mask        */
#define NT_USBHost_USB_STATUS_XACTNERR_Pos    21                                                      /*!< NT_USBHost USB_STATUS: XACTNERR Position */
#define NT_USBHost_USB_STATUS_XACTNERR_Msk    (0x01UL << NT_USBHost_USB_STATUS_XACTNERR_Pos)          /*!< NT_USBHost USB_STATUS: XACTNERR Mask    */
#define NT_USBHost_USB_STATUS_BABBLE_Pos      22                                                      /*!< NT_USBHost USB_STATUS: BABBLE Position  */
#define NT_USBHost_USB_STATUS_BABBLE_Msk      (0x01UL << NT_USBHost_USB_STATUS_BABBLE_Pos)            /*!< NT_USBHost USB_STATUS: BABBLE Mask      */
#define NT_USBHost_USB_STATUS_HALTED_Pos      23                                                      /*!< NT_USBHost USB_STATUS: HALTED Position  */
#define NT_USBHost_USB_STATUS_HALTED_Msk      (0x01UL << NT_USBHost_USB_STATUS_HALTED_Pos)            /*!< NT_USBHost USB_STATUS: HALTED Mask      */
#define NT_USBHost_USB_STATUS_USBINT_Pos      24                                                      /*!< NT_USBHost USB_STATUS: USBINT Position  */
#define NT_USBHost_USB_STATUS_USBINT_Msk      (0x01UL << NT_USBHost_USB_STATUS_USBINT_Pos)            /*!< NT_USBHost USB_STATUS: USBINT Mask      */
#define NT_USBHost_USB_STATUS_USBERRINT_Pos   25                                                      /*!< NT_USBHost USB_STATUS: USBERRINT Position */
#define NT_USBHost_USB_STATUS_USBERRINT_Msk   (0x01UL << NT_USBHost_USB_STATUS_USBERRINT_Pos)         /*!< NT_USBHost USB_STATUS: USBERRINT Mask   */

/* ---------------------------  NT_USBHost_Data_Buffer  --------------------------- */
#define NT_USBHost_Data_Buffer_DATA_Pos       0                                                       /*!< NT_USBHost Data_Buffer: DATA Position   */
#define NT_USBHost_Data_Buffer_DATA_Msk       (0xffffffffUL << NT_USBHost_Data_Buffer_DATA_Pos)       /*!< NT_USBHost Data_Buffer: DATA Mask       */

/* --------------------------  NT_USBHost_SLAVE_IN_COUNT  ------------------------- */
#define NT_USBHost_SLAVE_IN_COUNT_BYTECOUNT_Pos 0                                                     /*!< NT_USBHost SLAVE_IN_COUNT: BYTECOUNT Position */
#define NT_USBHost_SLAVE_IN_COUNT_BYTECOUNT_Msk (0x000007ffUL << NT_USBHost_SLAVE_IN_COUNT_BYTECOUNT_Pos)/*!< NT_USBHost SLAVE_IN_COUNT: BYTECOUNT Mask */


/* ================================================================================ */
/* ================      struct 'NT_USBDevice' Position & Mask     ================ */
/* ================================================================================ */


/* ---------------------------  NT_USBDevice_IRQ_STAT_L  -------------------------- */
#define NT_USBDevice_IRQ_STAT_L_USBBUSINT_Pos 0                                                       /*!< NT_USBDevice IRQ_STAT_L: USBBUSINT Position */
#define NT_USBDevice_IRQ_STAT_L_USBBUSINT_Msk (0x01UL << NT_USBDevice_IRQ_STAT_L_USBBUSINT_Pos)       /*!< NT_USBDevice IRQ_STAT_L: USBBUSINT Mask */
#define NT_USBDevice_IRQ_STAT_L_CEP_INT_Pos   1                                                       /*!< NT_USBDevice IRQ_STAT_L: CEP_INT Position */
#define NT_USBDevice_IRQ_STAT_L_CEP_INT_Msk   (0x01UL << NT_USBDevice_IRQ_STAT_L_CEP_INT_Pos)         /*!< NT_USBDevice IRQ_STAT_L: CEP_INT Mask   */
#define NT_USBDevice_IRQ_STAT_L_EP0_INT_Pos   2                                                       /*!< NT_USBDevice IRQ_STAT_L: EP0_INT Position */
#define NT_USBDevice_IRQ_STAT_L_EP0_INT_Msk   (0x01UL << NT_USBDevice_IRQ_STAT_L_EP0_INT_Pos)         /*!< NT_USBDevice IRQ_STAT_L: EP0_INT Mask   */
#define NT_USBDevice_IRQ_STAT_L_EP1_INT_Pos   3                                                       /*!< NT_USBDevice IRQ_STAT_L: EP1_INT Position */
#define NT_USBDevice_IRQ_STAT_L_EP1_INT_Msk   (0x01UL << NT_USBDevice_IRQ_STAT_L_EP1_INT_Pos)         /*!< NT_USBDevice IRQ_STAT_L: EP1_INT Mask   */

/* ---------------------------  NT_USBDevice_IRQ_ENB_L  --------------------------- */
#define NT_USBDevice_IRQ_ENB_L_USBBUSINTEN_Pos 0                                                      /*!< NT_USBDevice IRQ_ENB_L: USBBUSINTEN Position */
#define NT_USBDevice_IRQ_ENB_L_USBBUSINTEN_Msk (0x01UL << NT_USBDevice_IRQ_ENB_L_USBBUSINTEN_Pos)     /*!< NT_USBDevice IRQ_ENB_L: USBBUSINTEN Mask */
#define NT_USBDevice_IRQ_ENB_L_CEP_INTEN_Pos  1                                                       /*!< NT_USBDevice IRQ_ENB_L: CEP_INTEN Position */
#define NT_USBDevice_IRQ_ENB_L_CEP_INTEN_Msk  (0x01UL << NT_USBDevice_IRQ_ENB_L_CEP_INTEN_Pos)        /*!< NT_USBDevice IRQ_ENB_L: CEP_INTEN Mask  */
#define NT_USBDevice_IRQ_ENB_L_EP0_INTEN_Pos  2                                                       /*!< NT_USBDevice IRQ_ENB_L: EP0_INTEN Position */
#define NT_USBDevice_IRQ_ENB_L_EP0_INTEN_Msk  (0x01UL << NT_USBDevice_IRQ_ENB_L_EP0_INTEN_Pos)        /*!< NT_USBDevice IRQ_ENB_L: EP0_INTEN Mask  */
#define NT_USBDevice_IRQ_ENB_L_EP1_INTEN_Pos  3                                                       /*!< NT_USBDevice IRQ_ENB_L: EP1_INTEN Position */
#define NT_USBDevice_IRQ_ENB_L_EP1_INTEN_Msk  (0x01UL << NT_USBDevice_IRQ_ENB_L_EP1_INTEN_Pos)        /*!< NT_USBDevice IRQ_ENB_L: EP1_INTEN Mask  */

/* --------------------------  NT_USBDevice_USB_IRQ_STAT  ------------------------- */
#define NT_USBDevice_USB_IRQ_STAT_SOF_Pos     0                                                       /*!< NT_USBDevice USB_IRQ_STAT: SOF Position */
#define NT_USBDevice_USB_IRQ_STAT_SOF_Msk     (0x01UL << NT_USBDevice_USB_IRQ_STAT_SOF_Pos)           /*!< NT_USBDevice USB_IRQ_STAT: SOF Mask     */
#define NT_USBDevice_USB_IRQ_STAT_RESSTATUS_Pos 1                                                     /*!< NT_USBDevice USB_IRQ_STAT: RESSTATUS Position */
#define NT_USBDevice_USB_IRQ_STAT_RESSTATUS_Msk (0x01UL << NT_USBDevice_USB_IRQ_STAT_RESSTATUS_Pos)   /*!< NT_USBDevice USB_IRQ_STAT: RESSTATUS Mask */
#define NT_USBDevice_USB_IRQ_STAT_RESUME_Pos  2                                                       /*!< NT_USBDevice USB_IRQ_STAT: RESUME Position */
#define NT_USBDevice_USB_IRQ_STAT_RESUME_Msk  (0x01UL << NT_USBDevice_USB_IRQ_STAT_RESUME_Pos)        /*!< NT_USBDevice USB_IRQ_STAT: RESUME Mask  */
#define NT_USBDevice_USB_IRQ_STAT_SUSPENDREQ_Pos 3                                                    /*!< NT_USBDevice USB_IRQ_STAT: SUSPENDREQ Position */
#define NT_USBDevice_USB_IRQ_STAT_SUSPENDREQ_Msk (0x01UL << NT_USBDevice_USB_IRQ_STAT_SUSPENDREQ_Pos) /*!< NT_USBDevice USB_IRQ_STAT: SUSPENDREQ Mask */
#define NT_USBDevice_USB_IRQ_STAT_HIGHSPEEDSETTLE_Pos 4                                               /*!< NT_USBDevice USB_IRQ_STAT: HIGHSPEEDSETTLE Position */
#define NT_USBDevice_USB_IRQ_STAT_HIGHSPEEDSETTLE_Msk (0x01UL << NT_USBDevice_USB_IRQ_STAT_HIGHSPEEDSETTLE_Pos)/*!< NT_USBDevice USB_IRQ_STAT: HIGHSPEEDSETTLE Mask */
#define NT_USBDevice_USB_IRQ_STAT_DMACMPLINT_Pos 5                                                    /*!< NT_USBDevice USB_IRQ_STAT: DMACMPLINT Position */
#define NT_USBDevice_USB_IRQ_STAT_DMACMPLINT_Msk (0x01UL << NT_USBDevice_USB_IRQ_STAT_DMACMPLINT_Pos) /*!< NT_USBDevice USB_IRQ_STAT: DMACMPLINT Mask */
#define NT_USBDevice_USB_IRQ_STAT_CLKUNSTBLINT_Pos 6                                                  /*!< NT_USBDevice USB_IRQ_STAT: CLKUNSTBLINT Position */
#define NT_USBDevice_USB_IRQ_STAT_CLKUNSTBLINT_Msk (0x01UL << NT_USBDevice_USB_IRQ_STAT_CLKUNSTBLINT_Pos)/*!< NT_USBDevice USB_IRQ_STAT: CLKUNSTBLINT Mask */

/* --------------------------  NT_USBDevice_USB_IRQ_ENB  -------------------------- */
#define NT_USBDevice_USB_IRQ_ENB_SOFINTEN_Pos 0                                                       /*!< NT_USBDevice USB_IRQ_ENB: SOFINTEN Position */
#define NT_USBDevice_USB_IRQ_ENB_SOFINTEN_Msk (0x01UL << NT_USBDevice_USB_IRQ_ENB_SOFINTEN_Pos)       /*!< NT_USBDevice USB_IRQ_ENB: SOFINTEN Mask */
#define NT_USBDevice_USB_IRQ_ENB_RESSTATUSINTEN_Pos 1                                                 /*!< NT_USBDevice USB_IRQ_ENB: RESSTATUSINTEN Position */
#define NT_USBDevice_USB_IRQ_ENB_RESSTATUSINTEN_Msk (0x01UL << NT_USBDevice_USB_IRQ_ENB_RESSTATUSINTEN_Pos)/*!< NT_USBDevice USB_IRQ_ENB: RESSTATUSINTEN Mask */
#define NT_USBDevice_USB_IRQ_ENB_RESUMEINTEN_Pos 2                                                    /*!< NT_USBDevice USB_IRQ_ENB: RESUMEINTEN Position */
#define NT_USBDevice_USB_IRQ_ENB_RESUMEINTEN_Msk (0x01UL << NT_USBDevice_USB_IRQ_ENB_RESUMEINTEN_Pos) /*!< NT_USBDevice USB_IRQ_ENB: RESUMEINTEN Mask */
#define NT_USBDevice_USB_IRQ_ENB_SUSPENDINTEN_Pos 3                                                   /*!< NT_USBDevice USB_IRQ_ENB: SUSPENDINTEN Position */
#define NT_USBDevice_USB_IRQ_ENB_SUSPENDINTEN_Msk (0x01UL << NT_USBDevice_USB_IRQ_ENB_SUSPENDINTEN_Pos)/*!< NT_USBDevice USB_IRQ_ENB: SUSPENDINTEN Mask */
#define NT_USBDevice_USB_IRQ_ENB_HISPEEDINTEN_Pos 4                                                   /*!< NT_USBDevice USB_IRQ_ENB: HISPEEDINTEN Position */
#define NT_USBDevice_USB_IRQ_ENB_HISPEEDINTEN_Msk (0x01UL << NT_USBDevice_USB_IRQ_ENB_HISPEEDINTEN_Pos)/*!< NT_USBDevice USB_IRQ_ENB: HISPEEDINTEN Mask */
#define NT_USBDevice_USB_IRQ_ENB_DMACMPLINTEN_Pos 5                                                   /*!< NT_USBDevice USB_IRQ_ENB: DMACMPLINTEN Position */
#define NT_USBDevice_USB_IRQ_ENB_DMACMPLINTEN_Msk (0x01UL << NT_USBDevice_USB_IRQ_ENB_DMACMPLINTEN_Pos)/*!< NT_USBDevice USB_IRQ_ENB: DMACMPLINTEN Mask */
#define NT_USBDevice_USB_IRQ_ENB_CLKUNSTBLINTEN_Pos 6                                                 /*!< NT_USBDevice USB_IRQ_ENB: CLKUNSTBLINTEN Position */
#define NT_USBDevice_USB_IRQ_ENB_CLKUNSTBLINTEN_Msk (0x01UL << NT_USBDevice_USB_IRQ_ENB_CLKUNSTBLINTEN_Pos)/*!< NT_USBDevice USB_IRQ_ENB: CLKUNSTBLINTEN Mask */

/* ----------------------------  NT_USBDevice_USB_OPER  --------------------------- */
#define NT_USBDevice_USB_OPER_GEN_RESUME_Pos  0                                                       /*!< NT_USBDevice USB_OPER: GEN_RESUME Position */
#define NT_USBDevice_USB_OPER_GEN_RESUME_Msk  (0x01UL << NT_USBDevice_USB_OPER_GEN_RESUME_Pos)        /*!< NT_USBDevice USB_OPER: GEN_RESUME Mask  */
#define NT_USBDevice_USB_OPER_HIGHSPEED_Pos   1                                                       /*!< NT_USBDevice USB_OPER: HIGHSPEED Position */
#define NT_USBDevice_USB_OPER_HIGHSPEED_Msk   (0x01UL << NT_USBDevice_USB_OPER_HIGHSPEED_Pos)         /*!< NT_USBDevice USB_OPER: HIGHSPEED Mask   */
#define NT_USBDevice_USB_OPER_CURRENTSPEED_Pos 2                                                      /*!< NT_USBDevice USB_OPER: CURRENTSPEED Position */
#define NT_USBDevice_USB_OPER_CURRENTSPEED_Msk (0x01UL << NT_USBDevice_USB_OPER_CURRENTSPEED_Pos)     /*!< NT_USBDevice USB_OPER: CURRENTSPEED Mask */

/* -------------------------  NT_USBDevice_USB_FRAME_CNT  ------------------------- */
#define NT_USBDevice_USB_FRAME_CNT_MICRO_FRAME_COUNTER_Pos 0                                          /*!< NT_USBDevice USB_FRAME_CNT: MICRO_FRAME_COUNTER Position */
#define NT_USBDevice_USB_FRAME_CNT_MICRO_FRAME_COUNTER_Msk (0x07UL << NT_USBDevice_USB_FRAME_CNT_MICRO_FRAME_COUNTER_Pos)/*!< NT_USBDevice USB_FRAME_CNT: MICRO_FRAME_COUNTER Mask */
#define NT_USBDevice_USB_FRAME_CNT_FRAME_COUNTER_Pos 3                                                /*!< NT_USBDevice USB_FRAME_CNT: FRAME_COUNTER Position */
#define NT_USBDevice_USB_FRAME_CNT_FRAME_COUNTER_Msk (0x000007ffUL << NT_USBDevice_USB_FRAME_CNT_FRAME_COUNTER_Pos)/*!< NT_USBDevice USB_FRAME_CNT: FRAME_COUNTER Mask */

/* ----------------------------  NT_USBDevice_USB_ADDR  --------------------------- */
#define NT_USBDevice_USB_ADDR_CURRENT_ADDR_Pos 0                                                      /*!< NT_USBDevice USB_ADDR: CURRENT_ADDR Position */
#define NT_USBDevice_USB_ADDR_CURRENT_ADDR_Msk (0x3fUL << NT_USBDevice_USB_ADDR_CURRENT_ADDR_Pos)     /*!< NT_USBDevice USB_ADDR: CURRENT_ADDR Mask */
#define NT_USBDevice_USB_ADDR_USBADDR_Pos     6                                                       /*!< NT_USBDevice USB_ADDR: USBADDR Position */
#define NT_USBDevice_USB_ADDR_USBADDR_Msk     (0x01UL << NT_USBDevice_USB_ADDR_USBADDR_Pos)           /*!< NT_USBDevice USB_ADDR: USBADDR Mask     */

/* --------------------------  NT_USBDevice_CEP_DATA_BUF  ------------------------- */
#define NT_USBDevice_CEP_DATA_BUF_DATA_BUF_Pos 0                                                      /*!< NT_USBDevice CEP_DATA_BUF: DATA_BUF Position */
#define NT_USBDevice_CEP_DATA_BUF_DATA_BUF_Msk (0x0000ffffUL << NT_USBDevice_CEP_DATA_BUF_DATA_BUF_Pos)/*!< NT_USBDevice CEP_DATA_BUF: DATA_BUF Mask */

/* -------------------------  NT_USBDevice_CEP_CTRL_STAT  ------------------------- */
#define NT_USBDevice_CEP_CTRL_STAT_NAKCLEAR_Pos 0                                                     /*!< NT_USBDevice CEP_CTRL_STAT: NAKCLEAR Position */
#define NT_USBDevice_CEP_CTRL_STAT_NAKCLEAR_Msk (0x01UL << NT_USBDevice_CEP_CTRL_STAT_NAKCLEAR_Pos)   /*!< NT_USBDevice CEP_CTRL_STAT: NAKCLEAR Mask */
#define NT_USBDevice_CEP_CTRL_STAT_STALL_Pos  1                                                       /*!< NT_USBDevice CEP_CTRL_STAT: STALL Position */
#define NT_USBDevice_CEP_CTRL_STAT_STALL_Msk  (0x01UL << NT_USBDevice_CEP_CTRL_STAT_STALL_Pos)        /*!< NT_USBDevice CEP_CTRL_STAT: STALL Mask  */
#define NT_USBDevice_CEP_CTRL_STAT_ZEROLEN_Pos 2                                                      /*!< NT_USBDevice CEP_CTRL_STAT: ZEROLEN Position */
#define NT_USBDevice_CEP_CTRL_STAT_ZEROLEN_Msk (0x01UL << NT_USBDevice_CEP_CTRL_STAT_ZEROLEN_Pos)     /*!< NT_USBDevice CEP_CTRL_STAT: ZEROLEN Mask */
#define NT_USBDevice_CEP_CTRL_STAT_CEPFLUSH_Pos 3                                                     /*!< NT_USBDevice CEP_CTRL_STAT: CEPFLUSH Position */
#define NT_USBDevice_CEP_CTRL_STAT_CEPFLUSH_Msk (0x01UL << NT_USBDevice_CEP_CTRL_STAT_CEPFLUSH_Pos)   /*!< NT_USBDevice CEP_CTRL_STAT: CEPFLUSH Mask */

/* --------------------------  NT_USBDevice_CEP_IRQ_ENB  -------------------------- */
#define NT_USBDevice_CEP_IRQ_ENB_SETUPTOKENINT_Pos 0                                                  /*!< NT_USBDevice CEP_IRQ_ENB: SETUPTOKENINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_SETUPTOKENINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_SETUPTOKENINT_Pos)/*!< NT_USBDevice CEP_IRQ_ENB: SETUPTOKENINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_SETUPPKTINT_Pos 1                                                    /*!< NT_USBDevice CEP_IRQ_ENB: SETUPPKTINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_SETUPPKTINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_SETUPPKTINT_Pos) /*!< NT_USBDevice CEP_IRQ_ENB: SETUPPKTINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_OUTTOKENINT_Pos 2                                                    /*!< NT_USBDevice CEP_IRQ_ENB: OUTTOKENINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_OUTTOKENINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_OUTTOKENINT_Pos) /*!< NT_USBDevice CEP_IRQ_ENB: OUTTOKENINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_INTOKENINT_Pos 3                                                     /*!< NT_USBDevice CEP_IRQ_ENB: INTOKENINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_INTOKENINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_INTOKENINT_Pos)   /*!< NT_USBDevice CEP_IRQ_ENB: INTOKENINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_PINGTOKENINT_Pos 4                                                   /*!< NT_USBDevice CEP_IRQ_ENB: PINGTOKENINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_PINGTOKENINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_PINGTOKENINT_Pos)/*!< NT_USBDevice CEP_IRQ_ENB: PINGTOKENINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_DATAPKTTRINT_Pos 5                                                   /*!< NT_USBDevice CEP_IRQ_ENB: DATAPKTTRINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_DATAPKTTRINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_DATAPKTTRINT_Pos)/*!< NT_USBDevice CEP_IRQ_ENB: DATAPKTTRINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_DATAPKTRECINT_Pos 6                                                  /*!< NT_USBDevice CEP_IRQ_ENB: DATAPKTRECINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_DATAPKTRECINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_DATAPKTRECINT_Pos)/*!< NT_USBDevice CEP_IRQ_ENB: DATAPKTRECINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_NAKSENTINT_Pos 7                                                     /*!< NT_USBDevice CEP_IRQ_ENB: NAKSENTINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_NAKSENTINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_NAKSENTINT_Pos)   /*!< NT_USBDevice CEP_IRQ_ENB: NAKSENTINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_STALLSENTINT_Pos 8                                                   /*!< NT_USBDevice CEP_IRQ_ENB: STALLSENTINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_STALLSENTINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_STALLSENTINT_Pos)/*!< NT_USBDevice CEP_IRQ_ENB: STALLSENTINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_USBERRINT_Pos 9                                                      /*!< NT_USBDevice CEP_IRQ_ENB: USBERRINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_USBERRINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_USBERRINT_Pos)     /*!< NT_USBDevice CEP_IRQ_ENB: USBERRINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_STATCMPLNINT_Pos 10                                                  /*!< NT_USBDevice CEP_IRQ_ENB: STATCMPLNINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_STATCMPLNINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_STATCMPLNINT_Pos)/*!< NT_USBDevice CEP_IRQ_ENB: STATCMPLNINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_BUFFFULLINT_Pos 11                                                   /*!< NT_USBDevice CEP_IRQ_ENB: BUFFFULLINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_BUFFFULLINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_BUFFFULLINT_Pos) /*!< NT_USBDevice CEP_IRQ_ENB: BUFFFULLINT Mask */
#define NT_USBDevice_CEP_IRQ_ENB_BUFFEMPTYINT_Pos 12                                                  /*!< NT_USBDevice CEP_IRQ_ENB: BUFFEMPTYINT Position */
#define NT_USBDevice_CEP_IRQ_ENB_BUFFEMPTYINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_ENB_BUFFEMPTYINT_Pos)/*!< NT_USBDevice CEP_IRQ_ENB: BUFFEMPTYINT Mask */

/* --------------------------  NT_USBDevice_CEP_IRQ_STAT  ------------------------- */
#define NT_USBDevice_CEP_IRQ_STAT_SETUPTOKENINT_Pos 0                                                 /*!< NT_USBDevice CEP_IRQ_STAT: SETUPTOKENINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_SETUPTOKENINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_SETUPTOKENINT_Pos)/*!< NT_USBDevice CEP_IRQ_STAT: SETUPTOKENINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_SETUPPKTINT_Pos 1                                                   /*!< NT_USBDevice CEP_IRQ_STAT: SETUPPKTINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_SETUPPKTINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_SETUPPKTINT_Pos)/*!< NT_USBDevice CEP_IRQ_STAT: SETUPPKTINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_OUTTOKENINT_Pos 2                                                   /*!< NT_USBDevice CEP_IRQ_STAT: OUTTOKENINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_OUTTOKENINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_OUTTOKENINT_Pos)/*!< NT_USBDevice CEP_IRQ_STAT: OUTTOKENINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_INTOKENINT_Pos 3                                                    /*!< NT_USBDevice CEP_IRQ_STAT: INTOKENINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_INTOKENINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_INTOKENINT_Pos) /*!< NT_USBDevice CEP_IRQ_STAT: INTOKENINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_PINGTOKENINT_Pos 4                                                  /*!< NT_USBDevice CEP_IRQ_STAT: PINGTOKENINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_PINGTOKENINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_PINGTOKENINT_Pos)/*!< NT_USBDevice CEP_IRQ_STAT: PINGTOKENINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_DATAPKTTRINT_Pos 5                                                  /*!< NT_USBDevice CEP_IRQ_STAT: DATAPKTTRINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_DATAPKTTRINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_DATAPKTTRINT_Pos)/*!< NT_USBDevice CEP_IRQ_STAT: DATAPKTTRINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_DATAPKTRECINT_Pos 6                                                 /*!< NT_USBDevice CEP_IRQ_STAT: DATAPKTRECINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_DATAPKTRECINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_DATAPKTRECINT_Pos)/*!< NT_USBDevice CEP_IRQ_STAT: DATAPKTRECINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_NAKSENTINT_Pos 7                                                    /*!< NT_USBDevice CEP_IRQ_STAT: NAKSENTINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_NAKSENTINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_NAKSENTINT_Pos) /*!< NT_USBDevice CEP_IRQ_STAT: NAKSENTINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_STALLSENTINT_Pos 8                                                  /*!< NT_USBDevice CEP_IRQ_STAT: STALLSENTINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_STALLSENTINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_STALLSENTINT_Pos)/*!< NT_USBDevice CEP_IRQ_STAT: STALLSENTINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_USBERRINT_Pos 9                                                     /*!< NT_USBDevice CEP_IRQ_STAT: USBERRINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_USBERRINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_USBERRINT_Pos)   /*!< NT_USBDevice CEP_IRQ_STAT: USBERRINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_STATCMPLNINT_Pos 10                                                 /*!< NT_USBDevice CEP_IRQ_STAT: STATCMPLNINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_STATCMPLNINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_STATCMPLNINT_Pos)/*!< NT_USBDevice CEP_IRQ_STAT: STATCMPLNINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_BUFFFULLINT_Pos 11                                                  /*!< NT_USBDevice CEP_IRQ_STAT: BUFFFULLINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_BUFFFULLINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_BUFFFULLINT_Pos)/*!< NT_USBDevice CEP_IRQ_STAT: BUFFFULLINT Mask */
#define NT_USBDevice_CEP_IRQ_STAT_BUFFEMPTYINT_Pos 12                                                 /*!< NT_USBDevice CEP_IRQ_STAT: BUFFEMPTYINT Position */
#define NT_USBDevice_CEP_IRQ_STAT_BUFFEMPTYINT_Msk (0x01UL << NT_USBDevice_CEP_IRQ_STAT_BUFFEMPTYINT_Pos)/*!< NT_USBDevice CEP_IRQ_STAT: BUFFEMPTYINT Mask */

/* -------------------------  NT_USBDevice_CEP_IN_XFRCNT  ------------------------- */
#define NT_USBDevice_CEP_IN_XFRCNT_DATACOUNT_Pos 0                                                    /*!< NT_USBDevice CEP_IN_XFRCNT: DATACOUNT Position */
#define NT_USBDevice_CEP_IN_XFRCNT_DATACOUNT_Msk (0x0000ffffUL << NT_USBDevice_CEP_IN_XFRCNT_DATACOUNT_Pos)/*!< NT_USBDevice CEP_IN_XFRCNT: DATACOUNT Mask */

/* -------------------------  NT_USBDevice_CEP_OUT_XFRCNT  ------------------------ */
#define NT_USBDevice_CEP_OUT_XFRCNT_DATACOUNT_Pos 0                                                   /*!< NT_USBDevice CEP_OUT_XFRCNT: DATACOUNT Position */
#define NT_USBDevice_CEP_OUT_XFRCNT_DATACOUNT_Msk (0x0000ffffUL << NT_USBDevice_CEP_OUT_XFRCNT_DATACOUNT_Pos)/*!< NT_USBDevice CEP_OUT_XFRCNT: DATACOUNT Mask */

/* --------------------------  NT_USBDevice_CEP_SETUP1_0  ------------------------- */
#define NT_USBDevice_CEP_SETUP1_0_SETUPPKT_0B_Pos 0                                                   /*!< NT_USBDevice CEP_SETUP1_0: SETUPPKT_0B Position */
#define NT_USBDevice_CEP_SETUP1_0_SETUPPKT_0B_Msk (0x000000ffUL << NT_USBDevice_CEP_SETUP1_0_SETUPPKT_0B_Pos)/*!< NT_USBDevice CEP_SETUP1_0: SETUPPKT_0B Mask */
#define NT_USBDevice_CEP_SETUP1_0_SETUPPKT_1B_Pos 8                                                   /*!< NT_USBDevice CEP_SETUP1_0: SETUPPKT_1B Position */
#define NT_USBDevice_CEP_SETUP1_0_SETUPPKT_1B_Msk (0x000000ffUL << NT_USBDevice_CEP_SETUP1_0_SETUPPKT_1B_Pos)/*!< NT_USBDevice CEP_SETUP1_0: SETUPPKT_1B Mask */

/* --------------------------  NT_USBDevice_CEP_SETUP3_2  ------------------------- */
#define NT_USBDevice_CEP_SETUP3_2_SETUPPKT_2B_Pos 0                                                   /*!< NT_USBDevice CEP_SETUP3_2: SETUPPKT_2B Position */
#define NT_USBDevice_CEP_SETUP3_2_SETUPPKT_2B_Msk (0x000000ffUL << NT_USBDevice_CEP_SETUP3_2_SETUPPKT_2B_Pos)/*!< NT_USBDevice CEP_SETUP3_2: SETUPPKT_2B Mask */
#define NT_USBDevice_CEP_SETUP3_2_SETUPPKT_3B_Pos 8                                                   /*!< NT_USBDevice CEP_SETUP3_2: SETUPPKT_3B Position */
#define NT_USBDevice_CEP_SETUP3_2_SETUPPKT_3B_Msk (0x000000ffUL << NT_USBDevice_CEP_SETUP3_2_SETUPPKT_3B_Pos)/*!< NT_USBDevice CEP_SETUP3_2: SETUPPKT_3B Mask */

/* --------------------------  NT_USBDevice_CEP_SETUP5_4  ------------------------- */
#define NT_USBDevice_CEP_SETUP5_4_SETUPPKT_4B_Pos 0                                                   /*!< NT_USBDevice CEP_SETUP5_4: SETUPPKT_4B Position */
#define NT_USBDevice_CEP_SETUP5_4_SETUPPKT_4B_Msk (0x000000ffUL << NT_USBDevice_CEP_SETUP5_4_SETUPPKT_4B_Pos)/*!< NT_USBDevice CEP_SETUP5_4: SETUPPKT_4B Mask */
#define NT_USBDevice_CEP_SETUP5_4_SETUPPKT_5B_Pos 8                                                   /*!< NT_USBDevice CEP_SETUP5_4: SETUPPKT_5B Position */
#define NT_USBDevice_CEP_SETUP5_4_SETUPPKT_5B_Msk (0x000000ffUL << NT_USBDevice_CEP_SETUP5_4_SETUPPKT_5B_Pos)/*!< NT_USBDevice CEP_SETUP5_4: SETUPPKT_5B Mask */

/* --------------------------  NT_USBDevice_CEP_SETUP7_6  ------------------------- */
#define NT_USBDevice_CEP_SETUP7_6_SETUPPKT_6B_Pos 0                                                   /*!< NT_USBDevice CEP_SETUP7_6: SETUPPKT_6B Position */
#define NT_USBDevice_CEP_SETUP7_6_SETUPPKT_6B_Msk (0x000000ffUL << NT_USBDevice_CEP_SETUP7_6_SETUPPKT_6B_Pos)/*!< NT_USBDevice CEP_SETUP7_6: SETUPPKT_6B Mask */
#define NT_USBDevice_CEP_SETUP7_6_SETUPPKT_7B_Pos 8                                                   /*!< NT_USBDevice CEP_SETUP7_6: SETUPPKT_7B Position */
#define NT_USBDevice_CEP_SETUP7_6_SETUPPKT_7B_Msk (0x000000ffUL << NT_USBDevice_CEP_SETUP7_6_SETUPPKT_7B_Pos)/*!< NT_USBDevice CEP_SETUP7_6: SETUPPKT_7B Mask */

/* -------------------------  NT_USBDevice_CEP_START_ADDR  ------------------------ */
#define NT_USBDevice_CEP_START_ADDR_STARTADDR_Pos 0                                                   /*!< NT_USBDevice CEP_START_ADDR: STARTADDR Position */
#define NT_USBDevice_CEP_START_ADDR_STARTADDR_Msk (0x0000ffffUL << NT_USBDevice_CEP_START_ADDR_STARTADDR_Pos)/*!< NT_USBDevice CEP_START_ADDR: STARTADDR Mask */

/* --------------------------  NT_USBDevice_CEP_END_ADDR  ------------------------- */
#define NT_USBDevice_CEP_END_ADDR_ENDADDR_Pos 0                                                       /*!< NT_USBDevice CEP_END_ADDR: ENDADDR Position */
#define NT_USBDevice_CEP_END_ADDR_ENDADDR_Msk (0x0000ffffUL << NT_USBDevice_CEP_END_ADDR_ENDADDR_Pos) /*!< NT_USBDevice CEP_END_ADDR: ENDADDR Mask */

/* --------------------------  NT_USBDevice_DMA_CTRL_STS  ------------------------- */
#define NT_USBDevice_DMA_CTRL_STS_DMA_EP_ADDR_Pos 0                                                   /*!< NT_USBDevice DMA_CTRL_STS: DMA_EP_ADDR Position */
#define NT_USBDevice_DMA_CTRL_STS_DMA_EP_ADDR_Msk (0x0fUL << NT_USBDevice_DMA_CTRL_STS_DMA_EP_ADDR_Pos)/*!< NT_USBDevice DMA_CTRL_STS: DMA_EP_ADDR Mask */
#define NT_USBDevice_DMA_CTRL_STS_DMARW_Pos   4                                                       /*!< NT_USBDevice DMA_CTRL_STS: DMARW Position */
#define NT_USBDevice_DMA_CTRL_STS_DMARW_Msk   (0x01UL << NT_USBDevice_DMA_CTRL_STS_DMARW_Pos)         /*!< NT_USBDevice DMA_CTRL_STS: DMARW Mask   */
#define NT_USBDevice_DMA_CTRL_STS_DMAEN_Pos   5                                                       /*!< NT_USBDevice DMA_CTRL_STS: DMAEN Position */
#define NT_USBDevice_DMA_CTRL_STS_DMAEN_Msk   (0x01UL << NT_USBDevice_DMA_CTRL_STS_DMAEN_Pos)         /*!< NT_USBDevice DMA_CTRL_STS: DMAEN Mask   */

/* ----------------------------  NT_USBDevice_DMA_CNT  ---------------------------- */
#define NT_USBDevice_DMA_CNT_DMA_CNT_Pos      0                                                       /*!< NT_USBDevice DMA_CNT: DMA_CNT Position  */
#define NT_USBDevice_DMA_CNT_DMA_CNT_Msk      (0x0000ffffUL << NT_USBDevice_DMA_CNT_DMA_CNT_Pos)      /*!< NT_USBDevice DMA_CNT: DMA_CNT Mask      */


/* ================================================================================ */
/* ================         struct 'USB_EP' Position & Mask        ================ */
/* ================================================================================ */


/* -------------------------------  USB_EP_DATA_BUF  ------------------------------ */
#define USB_EP_DATA_BUF_DATA_Pos              0                                                       /*!< USB_EP DATA_BUF: DATA Position          */
#define USB_EP_DATA_BUF_DATA_Msk              (0x0000ffffUL << USB_EP_DATA_BUF_DATA_Pos)              /*!< USB_EP DATA_BUF: DATA Mask              */

/* -------------------------------  USB_EP_IRQ_STAT  ------------------------------ */
#define USB_EP_IRQ_STAT_BUFFFULLINT_Pos       0                                                       /*!< USB_EP IRQ_STAT: BUFFFULLINT Position   */
#define USB_EP_IRQ_STAT_BUFFFULLINT_Msk       (0x01UL << USB_EP_IRQ_STAT_BUFFFULLINT_Pos)             /*!< USB_EP IRQ_STAT: BUFFFULLINT Mask       */
#define USB_EP_IRQ_STAT_BUFFEMPTYINT_Pos      1                                                       /*!< USB_EP IRQ_STAT: BUFFEMPTYINT Position  */
#define USB_EP_IRQ_STAT_BUFFEMPTYINT_Msk      (0x01UL << USB_EP_IRQ_STAT_BUFFEMPTYINT_Pos)            /*!< USB_EP IRQ_STAT: BUFFEMPTYINT Mask      */
#define USB_EP_IRQ_STAT_SHORTPKTTRINT_Pos     2                                                       /*!< USB_EP IRQ_STAT: SHORTPKTTRINT Position */
#define USB_EP_IRQ_STAT_SHORTPKTTRINT_Msk     (0x01UL << USB_EP_IRQ_STAT_SHORTPKTTRINT_Pos)           /*!< USB_EP IRQ_STAT: SHORTPKTTRINT Mask     */
#define USB_EP_IRQ_STAT_DATAPKTTRINT_Pos      3                                                       /*!< USB_EP IRQ_STAT: DATAPKTTRINT Position  */
#define USB_EP_IRQ_STAT_DATAPKTTRINT_Msk      (0x01UL << USB_EP_IRQ_STAT_DATAPKTTRINT_Pos)            /*!< USB_EP IRQ_STAT: DATAPKTTRINT Mask      */
#define USB_EP_IRQ_STAT_DATAPKTRECINT_Pos     4                                                       /*!< USB_EP IRQ_STAT: DATAPKTRECINT Position */
#define USB_EP_IRQ_STAT_DATAPKTRECINT_Msk     (0x01UL << USB_EP_IRQ_STAT_DATAPKTRECINT_Pos)           /*!< USB_EP IRQ_STAT: DATAPKTRECINT Mask     */
#define USB_EP_IRQ_STAT_OUTTOKENINT_Pos       5                                                       /*!< USB_EP IRQ_STAT: OUTTOKENINT Position   */
#define USB_EP_IRQ_STAT_OUTTOKENINT_Msk       (0x01UL << USB_EP_IRQ_STAT_OUTTOKENINT_Pos)             /*!< USB_EP IRQ_STAT: OUTTOKENINT Mask       */
#define USB_EP_IRQ_STAT_INTOKENINT_Pos        6                                                       /*!< USB_EP IRQ_STAT: INTOKENINT Position    */
#define USB_EP_IRQ_STAT_INTOKENINT_Msk        (0x01UL << USB_EP_IRQ_STAT_INTOKENINT_Pos)              /*!< USB_EP IRQ_STAT: INTOKENINT Mask        */
#define USB_EP_IRQ_STAT_PINGTOKENINT_Pos      7                                                       /*!< USB_EP IRQ_STAT: PINGTOKENINT Position  */
#define USB_EP_IRQ_STAT_PINGTOKENINT_Msk      (0x01UL << USB_EP_IRQ_STAT_PINGTOKENINT_Pos)            /*!< USB_EP IRQ_STAT: PINGTOKENINT Mask      */
#define USB_EP_IRQ_STAT_NACKSENTINT_Pos       8                                                       /*!< USB_EP IRQ_STAT: NACKSENTINT Position   */
#define USB_EP_IRQ_STAT_NACKSENTINT_Msk       (0x01UL << USB_EP_IRQ_STAT_NACKSENTINT_Pos)             /*!< USB_EP IRQ_STAT: NACKSENTINT Mask       */
#define USB_EP_IRQ_STAT_STALLSENTINT_Pos      9                                                       /*!< USB_EP IRQ_STAT: STALLSENTINT Position  */
#define USB_EP_IRQ_STAT_STALLSENTINT_Msk      (0x01UL << USB_EP_IRQ_STAT_STALLSENTINT_Pos)            /*!< USB_EP IRQ_STAT: STALLSENTINT Mask      */
#define USB_EP_IRQ_STAT_NYETSENTINT_Pos       10                                                      /*!< USB_EP IRQ_STAT: NYETSENTINT Position   */
#define USB_EP_IRQ_STAT_NYETSENTINT_Msk       (0x01UL << USB_EP_IRQ_STAT_NYETSENTINT_Pos)             /*!< USB_EP IRQ_STAT: NYETSENTINT Mask       */
#define USB_EP_IRQ_STAT_ERRSENTINT_Pos        11                                                      /*!< USB_EP IRQ_STAT: ERRSENTINT Position    */
#define USB_EP_IRQ_STAT_ERRSENTINT_Msk        (0x01UL << USB_EP_IRQ_STAT_ERRSENTINT_Pos)              /*!< USB_EP IRQ_STAT: ERRSENTINT Mask        */

/* -------------------------------  USB_EP_IRQ_ENB  ------------------------------- */
#define USB_EP_IRQ_ENB_BUFFFULLINTEN_Pos      0                                                       /*!< USB_EP IRQ_ENB: BUFFFULLINTEN Position  */
#define USB_EP_IRQ_ENB_BUFFFULLINTEN_Msk      (0x01UL << USB_EP_IRQ_ENB_BUFFFULLINTEN_Pos)            /*!< USB_EP IRQ_ENB: BUFFFULLINTEN Mask      */
#define USB_EP_IRQ_ENB_BUFFEMPTYINTEN_Pos     1                                                       /*!< USB_EP IRQ_ENB: BUFFEMPTYINTEN Position */
#define USB_EP_IRQ_ENB_BUFFEMPTYINTEN_Msk     (0x01UL << USB_EP_IRQ_ENB_BUFFEMPTYINTEN_Pos)           /*!< USB_EP IRQ_ENB: BUFFEMPTYINTEN Mask     */
#define USB_EP_IRQ_ENB_SHORTPKTTRINTEN_Pos    2                                                       /*!< USB_EP IRQ_ENB: SHORTPKTTRINTEN Position */
#define USB_EP_IRQ_ENB_SHORTPKTTRINTEN_Msk    (0x01UL << USB_EP_IRQ_ENB_SHORTPKTTRINTEN_Pos)          /*!< USB_EP IRQ_ENB: SHORTPKTTRINTEN Mask    */
#define USB_EP_IRQ_ENB_DATAPKTTRINTEN_Pos     3                                                       /*!< USB_EP IRQ_ENB: DATAPKTTRINTEN Position */
#define USB_EP_IRQ_ENB_DATAPKTTRINTEN_Msk     (0x01UL << USB_EP_IRQ_ENB_DATAPKTTRINTEN_Pos)           /*!< USB_EP IRQ_ENB: DATAPKTTRINTEN Mask     */
#define USB_EP_IRQ_ENB_DATAPKTRECINTEN_Pos    4                                                       /*!< USB_EP IRQ_ENB: DATAPKTRECINTEN Position */
#define USB_EP_IRQ_ENB_DATAPKTRECINTEN_Msk    (0x01UL << USB_EP_IRQ_ENB_DATAPKTRECINTEN_Pos)          /*!< USB_EP IRQ_ENB: DATAPKTRECINTEN Mask    */
#define USB_EP_IRQ_ENB_OUTTOKENINTEN_Pos      5                                                       /*!< USB_EP IRQ_ENB: OUTTOKENINTEN Position  */
#define USB_EP_IRQ_ENB_OUTTOKENINTEN_Msk      (0x01UL << USB_EP_IRQ_ENB_OUTTOKENINTEN_Pos)            /*!< USB_EP IRQ_ENB: OUTTOKENINTEN Mask      */
#define USB_EP_IRQ_ENB_INTOKENINTEN_Pos       6                                                       /*!< USB_EP IRQ_ENB: INTOKENINTEN Position   */
#define USB_EP_IRQ_ENB_INTOKENINTEN_Msk       (0x01UL << USB_EP_IRQ_ENB_INTOKENINTEN_Pos)             /*!< USB_EP IRQ_ENB: INTOKENINTEN Mask       */
#define USB_EP_IRQ_ENB_PINGTOKENINTEN_Pos     7                                                       /*!< USB_EP IRQ_ENB: PINGTOKENINTEN Position */
#define USB_EP_IRQ_ENB_PINGTOKENINTEN_Msk     (0x01UL << USB_EP_IRQ_ENB_PINGTOKENINTEN_Pos)           /*!< USB_EP IRQ_ENB: PINGTOKENINTEN Mask     */
#define USB_EP_IRQ_ENB_NACKSENTINTEN_Pos      8                                                       /*!< USB_EP IRQ_ENB: NACKSENTINTEN Position  */
#define USB_EP_IRQ_ENB_NACKSENTINTEN_Msk      (0x01UL << USB_EP_IRQ_ENB_NACKSENTINTEN_Pos)            /*!< USB_EP IRQ_ENB: NACKSENTINTEN Mask      */
#define USB_EP_IRQ_ENB_STALLSENTINTEN_Pos     9                                                       /*!< USB_EP IRQ_ENB: STALLSENTINTEN Position */
#define USB_EP_IRQ_ENB_STALLSENTINTEN_Msk     (0x01UL << USB_EP_IRQ_ENB_STALLSENTINTEN_Pos)           /*!< USB_EP IRQ_ENB: STALLSENTINTEN Mask     */
#define USB_EP_IRQ_ENB_NYETSENTINTEN_Pos      10                                                      /*!< USB_EP IRQ_ENB: NYETSENTINTEN Position  */
#define USB_EP_IRQ_ENB_NYETSENTINTEN_Msk      (0x01UL << USB_EP_IRQ_ENB_NYETSENTINTEN_Pos)            /*!< USB_EP IRQ_ENB: NYETSENTINTEN Mask      */
#define USB_EP_IRQ_ENB_ERRSENTINTEN_Pos       11                                                      /*!< USB_EP IRQ_ENB: ERRSENTINTEN Position   */
#define USB_EP_IRQ_ENB_ERRSENTINTEN_Msk       (0x01UL << USB_EP_IRQ_ENB_ERRSENTINTEN_Pos)             /*!< USB_EP IRQ_ENB: ERRSENTINTEN Mask       */

/* ------------------------------  USB_EP_AVAIL_CNT  ------------------------------ */
#define USB_EP_AVAIL_CNT_BUFFBYTENUM_Pos      0                                                       /*!< USB_EP AVAIL_CNT: BUFFBYTENUM Position  */
#define USB_EP_AVAIL_CNT_BUFFBYTENUM_Msk      (0x00000fffUL << USB_EP_AVAIL_CNT_BUFFBYTENUM_Pos)      /*!< USB_EP AVAIL_CNT: BUFFBYTENUM Mask      */

/* --------------------------------  USB_EP_RSP_SC  ------------------------------- */
#define USB_EP_RSP_SC_BUFFFLUSH_Pos           0                                                       /*!< USB_EP RSP_SC: BUFFFLUSH Position       */
#define USB_EP_RSP_SC_BUFFFLUSH_Msk           (0x01UL << USB_EP_RSP_SC_BUFFFLUSH_Pos)                 /*!< USB_EP RSP_SC: BUFFFLUSH Mask           */
#define USB_EP_RSP_SC_MODE_Pos                1                                                       /*!< USB_EP RSP_SC: MODE Position            */
#define USB_EP_RSP_SC_MODE_Msk                (0x03UL << USB_EP_RSP_SC_MODE_Pos)                      /*!< USB_EP RSP_SC: MODE Mask                */
#define USB_EP_RSP_SC_ENDPOINTTOGGL_Pos       3                                                       /*!< USB_EP RSP_SC: ENDPOINTTOGGL Position   */
#define USB_EP_RSP_SC_ENDPOINTTOGGL_Msk       (0x01UL << USB_EP_RSP_SC_ENDPOINTTOGGL_Pos)             /*!< USB_EP RSP_SC: ENDPOINTTOGGL Mask       */
#define USB_EP_RSP_SC_ENDPOINTHALT_Pos        4                                                       /*!< USB_EP RSP_SC: ENDPOINTHALT Position    */
#define USB_EP_RSP_SC_ENDPOINTHALT_Msk        (0x01UL << USB_EP_RSP_SC_ENDPOINTHALT_Pos)              /*!< USB_EP RSP_SC: ENDPOINTHALT Mask        */
#define USB_EP_RSP_SC_ZEROLENIN_Pos           5                                                       /*!< USB_EP RSP_SC: ZEROLENIN Position       */
#define USB_EP_RSP_SC_ZEROLENIN_Msk           (0x01UL << USB_EP_RSP_SC_ZEROLENIN_Pos)                 /*!< USB_EP RSP_SC: ZEROLENIN Mask           */
#define USB_EP_RSP_SC_PKTEND_Pos              6                                                       /*!< USB_EP RSP_SC: PKTEND Position          */
#define USB_EP_RSP_SC_PKTEND_Msk              (0x01UL << USB_EP_RSP_SC_PKTEND_Pos)                    /*!< USB_EP RSP_SC: PKTEND Mask              */

/* ---------------------------------  USB_EP_MPS  --------------------------------- */
#define USB_EP_MPS_MAXPKTSIZE_Pos             0                                                       /*!< USB_EP MPS: MAXPKTSIZE Position         */
#define USB_EP_MPS_MAXPKTSIZE_Msk             (0x0000ffffUL << USB_EP_MPS_MAXPKTSIZE_Pos)             /*!< USB_EP MPS: MAXPKTSIZE Mask             */

/* ---------------------------------  USB_EP_CNT  --------------------------------- */
#define USB_EP_CNT_EP_TFR_CNT_Pos             0                                                       /*!< USB_EP CNT: EP_TFR_CNT Position         */
#define USB_EP_CNT_EP_TFR_CNT_Msk             (0x000000ffUL << USB_EP_CNT_EP_TFR_CNT_Pos)             /*!< USB_EP CNT: EP_TFR_CNT Mask             */

/* ------------------------------  USB_EP_USB_EP_CFG  ----------------------------- */
#define USB_EP_USB_EP_CFG_EP_VALID_Pos        0                                                       /*!< USB_EP USB_EP_CFG: EP_VALID Position    */
#define USB_EP_USB_EP_CFG_EP_VALID_Msk        (0x01UL << USB_EP_USB_EP_CFG_EP_VALID_Pos)              /*!< USB_EP USB_EP_CFG: EP_VALID Mask        */
#define USB_EP_USB_EP_CFG_EP_TYPE_Pos         1                                                       /*!< USB_EP USB_EP_CFG: EP_TYPE Position     */
#define USB_EP_USB_EP_CFG_EP_TYPE_Msk         (0x03UL << USB_EP_USB_EP_CFG_EP_TYPE_Pos)               /*!< USB_EP USB_EP_CFG: EP_TYPE Mask         */
#define USB_EP_USB_EP_CFG_EP_DIR_Pos          3                                                       /*!< USB_EP USB_EP_CFG: EP_DIR Position      */
#define USB_EP_USB_EP_CFG_EP_DIR_Msk          (0x01UL << USB_EP_USB_EP_CFG_EP_DIR_Pos)                /*!< USB_EP USB_EP_CFG: EP_DIR Mask          */
#define USB_EP_USB_EP_CFG_EP_NUM_Pos          4                                                       /*!< USB_EP USB_EP_CFG: EP_NUM Position      */
#define USB_EP_USB_EP_CFG_EP_NUM_Msk          (0x0fUL << USB_EP_USB_EP_CFG_EP_NUM_Pos)                /*!< USB_EP USB_EP_CFG: EP_NUM Mask          */
#define USB_EP_USB_EP_CFG_MULT_Pos            8                                                       /*!< USB_EP USB_EP_CFG: MULT Position        */
#define USB_EP_USB_EP_CFG_MULT_Msk            (0x03UL << USB_EP_USB_EP_CFG_MULT_Pos)                  /*!< USB_EP USB_EP_CFG: MULT Mask            */

/* ------------------------------  USB_EP_START_ADDR  ----------------------------- */
#define USB_EP_START_ADDR_STARTADDR_Pos       0                                                       /*!< USB_EP START_ADDR: STARTADDR Position   */
#define USB_EP_START_ADDR_STARTADDR_Msk       (0x0000ffffUL << USB_EP_START_ADDR_STARTADDR_Pos)       /*!< USB_EP START_ADDR: STARTADDR Mask       */

/* -------------------------------  USB_EP_END_ADDR  ------------------------------ */
#define USB_EP_END_ADDR_ENDADDR_Pos           0                                                       /*!< USB_EP END_ADDR: ENDADDR Position       */
#define USB_EP_END_ADDR_ENDADDR_Msk           (0x0000ffffUL << USB_EP_END_ADDR_ENDADDR_Pos)           /*!< USB_EP END_ADDR: ENDADDR Mask           */

/* --------------------------  NT_USBDevice_AHB_DMA_ADDR  ------------------------- */
#define NT_USBDevice_AHB_DMA_ADDR_AHBADDR_Pos 0                                                       /*!< NT_USBDevice AHB_DMA_ADDR: AHBADDR Position */
#define NT_USBDevice_AHB_DMA_ADDR_AHBADDR_Msk (0xffffffffUL << NT_USBDevice_AHB_DMA_ADDR_AHBADDR_Pos) /*!< NT_USBDevice AHB_DMA_ADDR: AHBADDR Mask */


/* ================================================================================ */
/* ================       struct 'NT_USBOTG' Position & Mask       ================ */
/* ================================================================================ */


/* ---------------------------  NT_USBOTG_OTG_IRQ_STAT  --------------------------- */
#define NT_USBOTG_OTG_IRQ_STAT_VBUSERR_Pos    0                                                       /*!< NT_USBOTG OTG_IRQ_STAT: VBUSERR Position */
#define NT_USBOTG_OTG_IRQ_STAT_VBUSERR_Msk    (0x01UL << NT_USBOTG_OTG_IRQ_STAT_VBUSERR_Pos)          /*!< NT_USBOTG OTG_IRQ_STAT: VBUSERR Mask    */
#define NT_USBOTG_OTG_IRQ_STAT_SPRDETECTED_Pos 1                                                      /*!< NT_USBOTG OTG_IRQ_STAT: SPRDETECTED Position */
#define NT_USBOTG_OTG_IRQ_STAT_SPRDETECTED_Msk (0x01UL << NT_USBOTG_OTG_IRQ_STAT_SPRDETECTED_Pos)     /*!< NT_USBOTG OTG_IRQ_STAT: SPRDETECTED Mask */
#define NT_USBOTG_OTG_IRQ_STAT_HANDOFF_INTR_Pos 2                                                     /*!< NT_USBOTG OTG_IRQ_STAT: HANDOFF_INTR Position */
#define NT_USBOTG_OTG_IRQ_STAT_HANDOFF_INTR_Msk (0x01UL << NT_USBOTG_OTG_IRQ_STAT_HANDOFF_INTR_Pos)   /*!< NT_USBOTG OTG_IRQ_STAT: HANDOFF_INTR Mask */
#define NT_USBOTG_OTG_IRQ_STAT_SPR_FAIL_Pos   3                                                       /*!< NT_USBOTG OTG_IRQ_STAT: SPR_FAIL Position */
#define NT_USBOTG_OTG_IRQ_STAT_SPR_FAIL_Msk   (0x01UL << NT_USBOTG_OTG_IRQ_STAT_SPR_FAIL_Pos)         /*!< NT_USBOTG OTG_IRQ_STAT: SPR_FAIL Mask   */
#define NT_USBOTG_OTG_IRQ_STAT_DEVICE_Pos     4                                                       /*!< NT_USBOTG OTG_IRQ_STAT: DEVICE Position */
#define NT_USBOTG_OTG_IRQ_STAT_DEVICE_Msk     (0x01UL << NT_USBOTG_OTG_IRQ_STAT_DEVICE_Pos)           /*!< NT_USBOTG OTG_IRQ_STAT: DEVICE Mask     */
#define NT_USBOTG_OTG_IRQ_STAT_HOST_Pos       5                                                       /*!< NT_USBOTG OTG_IRQ_STAT: HOST Position   */
#define NT_USBOTG_OTG_IRQ_STAT_HOST_Msk       (0x01UL << NT_USBOTG_OTG_IRQ_STAT_HOST_Pos)             /*!< NT_USBOTG OTG_IRQ_STAT: HOST Mask       */
#define NT_USBOTG_OTG_IRQ_STAT_A_BUSREQ_Pos   6                                                       /*!< NT_USBOTG OTG_IRQ_STAT: A_BUSREQ Position */
#define NT_USBOTG_OTG_IRQ_STAT_A_BUSREQ_Msk   (0x01UL << NT_USBOTG_OTG_IRQ_STAT_A_BUSREQ_Pos)         /*!< NT_USBOTG OTG_IRQ_STAT: A_BUSREQ Mask   */
#define NT_USBOTG_OTG_IRQ_STAT_A_BUSDROP_Pos  7                                                       /*!< NT_USBOTG OTG_IRQ_STAT: A_BUSDROP Position */
#define NT_USBOTG_OTG_IRQ_STAT_A_BUSDROP_Msk  (0x01UL << NT_USBOTG_OTG_IRQ_STAT_A_BUSDROP_Pos)        /*!< NT_USBOTG OTG_IRQ_STAT: A_BUSDROP Mask  */
#define NT_USBOTG_OTG_IRQ_STAT_A_HNPEN_Pos    8                                                       /*!< NT_USBOTG OTG_IRQ_STAT: A_HNPEN Position */
#define NT_USBOTG_OTG_IRQ_STAT_A_HNPEN_Msk    (0x01UL << NT_USBOTG_OTG_IRQ_STAT_A_HNPEN_Pos)          /*!< NT_USBOTG OTG_IRQ_STAT: A_HNPEN Mask    */
#define NT_USBOTG_OTG_IRQ_STAT_B_HNPEN_Pos    9                                                       /*!< NT_USBOTG OTG_IRQ_STAT: B_HNPEN Position */
#define NT_USBOTG_OTG_IRQ_STAT_B_HNPEN_Msk    (0x01UL << NT_USBOTG_OTG_IRQ_STAT_B_HNPEN_Pos)          /*!< NT_USBOTG OTG_IRQ_STAT: B_HNPEN Mask    */
#define NT_USBOTG_OTG_IRQ_STAT_B_BUSREQ_Pos   10                                                      /*!< NT_USBOTG OTG_IRQ_STAT: B_BUSREQ Position */
#define NT_USBOTG_OTG_IRQ_STAT_B_BUSREQ_Msk   (0x01UL << NT_USBOTG_OTG_IRQ_STAT_B_BUSREQ_Pos)         /*!< NT_USBOTG OTG_IRQ_STAT: B_BUSREQ Mask   */
#define NT_USBOTG_OTG_IRQ_STAT_A_SUSPENDREQ_Pos 11                                                    /*!< NT_USBOTG OTG_IRQ_STAT: A_SUSPENDREQ Position */
#define NT_USBOTG_OTG_IRQ_STAT_A_SUSPENDREQ_Msk (0x01UL << NT_USBOTG_OTG_IRQ_STAT_A_SUSPENDREQ_Pos)   /*!< NT_USBOTG OTG_IRQ_STAT: A_SUSPENDREQ Mask */
#define NT_USBOTG_OTG_IRQ_STAT_A_DEVICE_Pos   12                                                      /*!< NT_USBOTG OTG_IRQ_STAT: A_DEVICE Position */
#define NT_USBOTG_OTG_IRQ_STAT_A_DEVICE_Msk   (0x01UL << NT_USBOTG_OTG_IRQ_STAT_A_DEVICE_Pos)         /*!< NT_USBOTG OTG_IRQ_STAT: A_DEVICE Mask   */
#define NT_USBOTG_OTG_IRQ_STAT_B_DEVICE_Pos   13                                                      /*!< NT_USBOTG OTG_IRQ_STAT: B_DEVICE Position */
#define NT_USBOTG_OTG_IRQ_STAT_B_DEVICE_Msk   (0x01UL << NT_USBOTG_OTG_IRQ_STAT_B_DEVICE_Pos)         /*!< NT_USBOTG OTG_IRQ_STAT: B_DEVICE Mask   */
#define NT_USBOTG_OTG_IRQ_STAT_SESSION_FAIL_Pos 14                                                    /*!< NT_USBOTG OTG_IRQ_STAT: SESSION_FAIL Position */
#define NT_USBOTG_OTG_IRQ_STAT_SESSION_FAIL_Msk (0x01UL << NT_USBOTG_OTG_IRQ_STAT_SESSION_FAIL_Pos)   /*!< NT_USBOTG OTG_IRQ_STAT: SESSION_FAIL Mask */
#define NT_USBOTG_OTG_IRQ_STAT_SUSPENDEN_Pos  15                                                      /*!< NT_USBOTG OTG_IRQ_STAT: SUSPENDEN Position */
#define NT_USBOTG_OTG_IRQ_STAT_SUSPENDEN_Msk  (0x01UL << NT_USBOTG_OTG_IRQ_STAT_SUSPENDEN_Pos)        /*!< NT_USBOTG OTG_IRQ_STAT: SUSPENDEN Mask  */
#define NT_USBOTG_OTG_IRQ_STAT_A_DEVCHANGE_Pos 16                                                     /*!< NT_USBOTG OTG_IRQ_STAT: A_DEVCHANGE Position */
#define NT_USBOTG_OTG_IRQ_STAT_A_DEVCHANGE_Msk (0x01UL << NT_USBOTG_OTG_IRQ_STAT_A_DEVCHANGE_Pos)     /*!< NT_USBOTG OTG_IRQ_STAT: A_DEVCHANGE Mask */
#define NT_USBOTG_OTG_IRQ_STAT_B_DEVCHANGE_Pos 17                                                     /*!< NT_USBOTG OTG_IRQ_STAT: B_DEVCHANGE Position */
#define NT_USBOTG_OTG_IRQ_STAT_B_DEVCHANGE_Msk (0x01UL << NT_USBOTG_OTG_IRQ_STAT_B_DEVCHANGE_Pos)     /*!< NT_USBOTG OTG_IRQ_STAT: B_DEVCHANGE Mask */
#define NT_USBOTG_OTG_IRQ_STAT_DEVSYNC_Pos    18                                                      /*!< NT_USBOTG OTG_IRQ_STAT: DEVSYNC Position */
#define NT_USBOTG_OTG_IRQ_STAT_DEVSYNC_Msk    (0x01UL << NT_USBOTG_OTG_IRQ_STAT_DEVSYNC_Pos)          /*!< NT_USBOTG OTG_IRQ_STAT: DEVSYNC Mask    */
#define NT_USBOTG_OTG_IRQ_STAT_HOSTSYNC_Pos   19                                                      /*!< NT_USBOTG OTG_IRQ_STAT: HOSTSYNC Position */
#define NT_USBOTG_OTG_IRQ_STAT_HOSTSYNC_Msk   (0x01UL << NT_USBOTG_OTG_IRQ_STAT_HOSTSYNC_Pos)         /*!< NT_USBOTG OTG_IRQ_STAT: HOSTSYNC Mask   */
#define NT_USBOTG_OTG_IRQ_STAT_DISCON_Pos     20                                                      /*!< NT_USBOTG OTG_IRQ_STAT: DISCON Position */
#define NT_USBOTG_OTG_IRQ_STAT_DISCON_Msk     (0x01UL << NT_USBOTG_OTG_IRQ_STAT_DISCON_Pos)           /*!< NT_USBOTG OTG_IRQ_STAT: DISCON Mask     */

/* ----------------------------  NT_USBOTG_OTG_IRQ_EN  ---------------------------- */
#define NT_USBOTG_OTG_IRQ_EN_VBUSERREN_Pos    0                                                       /*!< NT_USBOTG OTG_IRQ_EN: VBUSERREN Position */
#define NT_USBOTG_OTG_IRQ_EN_VBUSERREN_Msk    (0x01UL << NT_USBOTG_OTG_IRQ_EN_VBUSERREN_Pos)          /*!< NT_USBOTG OTG_IRQ_EN: VBUSERREN Mask    */
#define NT_USBOTG_OTG_IRQ_EN_SPRDETECTEDEN_Pos 1                                                      /*!< NT_USBOTG OTG_IRQ_EN: SPRDETECTEDEN Position */
#define NT_USBOTG_OTG_IRQ_EN_SPRDETECTEDEN_Msk (0x01UL << NT_USBOTG_OTG_IRQ_EN_SPRDETECTEDEN_Pos)     /*!< NT_USBOTG OTG_IRQ_EN: SPRDETECTEDEN Mask */
#define NT_USBOTG_OTG_IRQ_EN_TRANSINTREN_Pos  2                                                       /*!< NT_USBOTG OTG_IRQ_EN: TRANSINTREN Position */
#define NT_USBOTG_OTG_IRQ_EN_TRANSINTREN_Msk  (0x01UL << NT_USBOTG_OTG_IRQ_EN_TRANSINTREN_Pos)        /*!< NT_USBOTG OTG_IRQ_EN: TRANSINTREN Mask  */
#define NT_USBOTG_OTG_IRQ_EN_SRPFAILEN_Pos    3                                                       /*!< NT_USBOTG OTG_IRQ_EN: SRPFAILEN Position */
#define NT_USBOTG_OTG_IRQ_EN_SRPFAILEN_Msk    (0x01UL << NT_USBOTG_OTG_IRQ_EN_SRPFAILEN_Pos)          /*!< NT_USBOTG OTG_IRQ_EN: SRPFAILEN Mask    */
#define NT_USBOTG_OTG_IRQ_EN_SESSIONFAILEN_Pos 4                                                      /*!< NT_USBOTG OTG_IRQ_EN: SESSIONFAILEN Position */
#define NT_USBOTG_OTG_IRQ_EN_SESSIONFAILEN_Msk (0x01UL << NT_USBOTG_OTG_IRQ_EN_SESSIONFAILEN_Pos)     /*!< NT_USBOTG OTG_IRQ_EN: SESSIONFAILEN Mask */
#define NT_USBOTG_OTG_IRQ_EN_A_DEVCHANGEEN_Pos 5                                                      /*!< NT_USBOTG OTG_IRQ_EN: A_DEVCHANGEEN Position */
#define NT_USBOTG_OTG_IRQ_EN_A_DEVCHANGEEN_Msk (0x01UL << NT_USBOTG_OTG_IRQ_EN_A_DEVCHANGEEN_Pos)     /*!< NT_USBOTG OTG_IRQ_EN: A_DEVCHANGEEN Mask */
#define NT_USBOTG_OTG_IRQ_EN_B_DEVCHANGEEN_Pos 6                                                      /*!< NT_USBOTG OTG_IRQ_EN: B_DEVCHANGEEN Position */
#define NT_USBOTG_OTG_IRQ_EN_B_DEVCHANGEEN_Msk (0x01UL << NT_USBOTG_OTG_IRQ_EN_B_DEVCHANGEEN_Pos)     /*!< NT_USBOTG OTG_IRQ_EN: B_DEVCHANGEEN Mask */
#define NT_USBOTG_OTG_IRQ_EN_DEVSYNCEN_Pos    7                                                       /*!< NT_USBOTG OTG_IRQ_EN: DEVSYNCEN Position */
#define NT_USBOTG_OTG_IRQ_EN_DEVSYNCEN_Msk    (0x01UL << NT_USBOTG_OTG_IRQ_EN_DEVSYNCEN_Pos)          /*!< NT_USBOTG OTG_IRQ_EN: DEVSYNCEN Mask    */
#define NT_USBOTG_OTG_IRQ_EN_HOSTSYNCEN_Pos   8                                                       /*!< NT_USBOTG OTG_IRQ_EN: HOSTSYNCEN Position */
#define NT_USBOTG_OTG_IRQ_EN_HOSTSYNCEN_Msk   (0x01UL << NT_USBOTG_OTG_IRQ_EN_HOSTSYNCEN_Pos)         /*!< NT_USBOTG OTG_IRQ_EN: HOSTSYNCEN Mask   */
#define NT_USBOTG_OTG_IRQ_EN_DISCONEN_Pos     9                                                       /*!< NT_USBOTG OTG_IRQ_EN: DISCONEN Position */
#define NT_USBOTG_OTG_IRQ_EN_DISCONEN_Msk     (0x01UL << NT_USBOTG_OTG_IRQ_EN_DISCONEN_Pos)           /*!< NT_USBOTG OTG_IRQ_EN: DISCONEN Mask     */


/* ================================================================================ */
/* ================         struct 'NT_WDT' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  NT_WDT_LOAD  -------------------------------- */
#define NT_WDT_LOAD_COUNT_Pos                 0                                                       /*!< NT_WDT LOAD: COUNT Position             */
#define NT_WDT_LOAD_COUNT_Msk                 (0xffffffffUL << NT_WDT_LOAD_COUNT_Pos)                 /*!< NT_WDT LOAD: COUNT Mask                 */

/* --------------------------------  NT_WDT_VALUE  -------------------------------- */
#define NT_WDT_VALUE_WDTVAL_Pos               0                                                       /*!< NT_WDT VALUE: WDTVAL Position           */
#define NT_WDT_VALUE_WDTVAL_Msk               (0xffffffffUL << NT_WDT_VALUE_WDTVAL_Pos)               /*!< NT_WDT VALUE: WDTVAL Mask               */

/* ---------------------------------  NT_WDT_CTRL  -------------------------------- */
#define NT_WDT_CTRL_INTEN_Pos                 0                                                       /*!< NT_WDT CTRL: INTEN Position             */
#define NT_WDT_CTRL_INTEN_Msk                 (0x01UL << NT_WDT_CTRL_INTEN_Pos)                       /*!< NT_WDT CTRL: INTEN Mask                 */
#define NT_WDT_CTRL_RESEN_Pos                 1                                                       /*!< NT_WDT CTRL: RESEN Position             */
#define NT_WDT_CTRL_RESEN_Msk                 (0x01UL << NT_WDT_CTRL_RESEN_Pos)                       /*!< NT_WDT CTRL: RESEN Mask                 */

/* --------------------------------  NT_WDT_INTCLR  ------------------------------- */
#define NT_WDT_INTCLR_WDTCLR_Pos              0                                                       /*!< NT_WDT INTCLR: WDTCLR Position          */
#define NT_WDT_INTCLR_WDTCLR_Msk              (0xffffffffUL << NT_WDT_INTCLR_WDTCLR_Pos)              /*!< NT_WDT INTCLR: WDTCLR Mask              */

/* ---------------------------------  NT_WDT_RIS  --------------------------------- */
#define NT_WDT_RIS_RAWWDTINT_Pos              0                                                       /*!< NT_WDT RIS: RAWWDTINT Position          */
#define NT_WDT_RIS_RAWWDTINT_Msk              (0x01UL << NT_WDT_RIS_RAWWDTINT_Pos)                    /*!< NT_WDT RIS: RAWWDTINT Mask              */

/* ---------------------------------  NT_WDT_MIS  --------------------------------- */
#define NT_WDT_MIS_WDTINT_Pos                 0                                                       /*!< NT_WDT MIS: WDTINT Position             */
#define NT_WDT_MIS_WDTINT_Msk                 (0x01UL << NT_WDT_MIS_WDTINT_Pos)                       /*!< NT_WDT MIS: WDTINT Mask                 */

/* ---------------------------------  NT_WDT_LOCK  -------------------------------- */
#define NT_WDT_LOCK_REG_WR_DIS_Pos            0                                                       /*!< NT_WDT LOCK: REG_WR_DIS Position        */
#define NT_WDT_LOCK_REG_WR_DIS_Msk            (0x01UL << NT_WDT_LOCK_REG_WR_DIS_Pos)                  /*!< NT_WDT LOCK: REG_WR_DIS Mask            */


/* ================================================================================ */
/* ================        struct 'NT_I2C0' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  NT_I2C0_SDA  -------------------------------- */
#define NT_I2C0_SDA_DATA_Pos                  0                                                       /*!< NT_I2C0 SDA: DATA Position              */
#define NT_I2C0_SDA_DATA_Msk                  (0x000000ffUL << NT_I2C0_SDA_DATA_Pos)                  /*!< NT_I2C0 SDA: DATA Mask                  */

/* ---------------------------------  NT_I2C0_ST  --------------------------------- */
#define NT_I2C0_ST_MODE_Pos                   0                                                       /*!< NT_I2C0 ST: MODE Position               */
#define NT_I2C0_ST_MODE_Msk                   (0x3fUL << NT_I2C0_ST_MODE_Pos)                         /*!< NT_I2C0 ST: MODE Mask                   */
#define NT_I2C0_ST_INT_Pos                    7                                                       /*!< NT_I2C0 ST: INT Position                */
#define NT_I2C0_ST_INT_Msk                    (0x01UL << NT_I2C0_ST_INT_Pos)                          /*!< NT_I2C0 ST: INT Mask                    */

/* ---------------------------------  NT_I2C0_CST  -------------------------------- */
#define NT_I2C0_CST_BB_Pos                    0                                                       /*!< NT_I2C0 CST: BB Position                */
#define NT_I2C0_CST_BB_Msk                    (0x01UL << NT_I2C0_CST_BB_Pos)                          /*!< NT_I2C0 CST: BB Mask                    */
#define NT_I2C0_CST_TOCDIV_Pos                1                                                       /*!< NT_I2C0 CST: TOCDIV Position            */
#define NT_I2C0_CST_TOCDIV_Msk                (0x03UL << NT_I2C0_CST_TOCDIV_Pos)                      /*!< NT_I2C0 CST: TOCDIV Mask                */
#define NT_I2C0_CST_TOERR_Pos                 3                                                       /*!< NT_I2C0 CST: TOERR Position             */
#define NT_I2C0_CST_TOERR_Msk                 (0x01UL << NT_I2C0_CST_TOERR_Pos)                       /*!< NT_I2C0 CST: TOERR Mask                 */
#define NT_I2C0_CST_TSDA_Pos                  4                                                       /*!< NT_I2C0 CST: TSDA Position              */
#define NT_I2C0_CST_TSDA_Msk                  (0x01UL << NT_I2C0_CST_TSDA_Pos)                        /*!< NT_I2C0 CST: TSDA Mask                  */
#define NT_I2C0_CST_TGSCL_Pos                 5                                                       /*!< NT_I2C0 CST: TGSCL Position             */
#define NT_I2C0_CST_TGSCL_Msk                 (0x01UL << NT_I2C0_CST_TGSCL_Pos)                       /*!< NT_I2C0 CST: TGSCL Mask                 */
#define NT_I2C0_CST_PECNEXT_Pos               6                                                       /*!< NT_I2C0 CST: PECNEXT Position           */
#define NT_I2C0_CST_PECNEXT_Msk               (0x01UL << NT_I2C0_CST_PECNEXT_Pos)                     /*!< NT_I2C0 CST: PECNEXT Mask               */
#define NT_I2C0_CST_PECFAULT_Pos              7                                                       /*!< NT_I2C0 CST: PECFAULT Position          */
#define NT_I2C0_CST_PECFAULT_Msk              (0x01UL << NT_I2C0_CST_PECFAULT_Pos)                    /*!< NT_I2C0 CST: PECFAULT Mask              */

/* --------------------------------  NT_I2C0_CTL0  -------------------------------- */
#define NT_I2C0_CTL0_START_Pos                0                                                       /*!< NT_I2C0 CTL0: START Position            */
#define NT_I2C0_CTL0_START_Msk                (0x01UL << NT_I2C0_CTL0_START_Pos)                      /*!< NT_I2C0 CTL0: START Mask                */
#define NT_I2C0_CTL0_STOP_Pos                 1                                                       /*!< NT_I2C0 CTL0: STOP Position             */
#define NT_I2C0_CTL0_STOP_Msk                 (0x01UL << NT_I2C0_CTL0_STOP_Pos)                       /*!< NT_I2C0 CTL0: STOP Mask                 */
#define NT_I2C0_CTL0_INTEN_Pos                2                                                       /*!< NT_I2C0 CTL0: INTEN Position            */
#define NT_I2C0_CTL0_INTEN_Msk                (0x01UL << NT_I2C0_CTL0_INTEN_Pos)                      /*!< NT_I2C0 CTL0: INTEN Mask                */
#define NT_I2C0_CTL0_ACK_Pos                  4                                                       /*!< NT_I2C0 CTL0: ACK Position              */
#define NT_I2C0_CTL0_ACK_Msk                  (0x01UL << NT_I2C0_CTL0_ACK_Pos)                        /*!< NT_I2C0 CTL0: ACK Mask                  */
#define NT_I2C0_CTL0_GCMEN_Pos                5                                                       /*!< NT_I2C0 CTL0: GCMEN Position            */
#define NT_I2C0_CTL0_GCMEN_Msk                (0x01UL << NT_I2C0_CTL0_GCMEN_Pos)                      /*!< NT_I2C0 CTL0: GCMEN Mask                */
#define NT_I2C0_CTL0_SMBARE_Pos               6                                                       /*!< NT_I2C0 CTL0: SMBARE Position           */
#define NT_I2C0_CTL0_SMBARE_Msk               (0x01UL << NT_I2C0_CTL0_SMBARE_Pos)                     /*!< NT_I2C0 CTL0: SMBARE Mask               */
#define NT_I2C0_CTL0_CLRST_Pos                7                                                       /*!< NT_I2C0 CTL0: CLRST Position            */
#define NT_I2C0_CTL0_CLRST_Msk                (0x01UL << NT_I2C0_CTL0_CLRST_Pos)                      /*!< NT_I2C0 CTL0: CLRST Mask                */

/* --------------------------------  NT_I2C0_ADDR  -------------------------------- */
#define NT_I2C0_ADDR_ADDR_Pos                 0                                                       /*!< NT_I2C0 ADDR: ADDR Position             */
#define NT_I2C0_ADDR_ADDR_Msk                 (0x7fUL << NT_I2C0_ADDR_ADDR_Pos)                       /*!< NT_I2C0 ADDR: ADDR Mask                 */
#define NT_I2C0_ADDR_SAEN_Pos                 7                                                       /*!< NT_I2C0 ADDR: SAEN Position             */
#define NT_I2C0_ADDR_SAEN_Msk                 (0x01UL << NT_I2C0_ADDR_SAEN_Pos)                       /*!< NT_I2C0 ADDR: SAEN Mask                 */

/* --------------------------------  NT_I2C0_CTL1  -------------------------------- */
#define NT_I2C0_CTL1_ENABLE_Pos               0                                                       /*!< NT_I2C0 CTL1: ENABLE Position           */
#define NT_I2C0_CTL1_ENABLE_Msk               (0x01UL << NT_I2C0_CTL1_ENABLE_Pos)                     /*!< NT_I2C0 CTL1: ENABLE Mask               */
#define NT_I2C0_CTL1_SCLFRQ_Pos               1                                                       /*!< NT_I2C0 CTL1: SCLFRQ Position           */
#define NT_I2C0_CTL1_SCLFRQ_Msk               (0x7fUL << NT_I2C0_CTL1_SCLFRQ_Pos)                     /*!< NT_I2C0 CTL1: SCLFRQ Mask               */

/* --------------------------------  NT_I2C0_TOPR  -------------------------------- */
#define NT_I2C0_TOPR_SMBTOPR_Pos              0                                                       /*!< NT_I2C0 TOPR: SMBTOPR Position          */
#define NT_I2C0_TOPR_SMBTOPR_Msk              (0x000000ffUL << NT_I2C0_TOPR_SMBTOPR_Pos)              /*!< NT_I2C0 TOPR: SMBTOPR Mask              */

/* --------------------------------  NT_I2C0_CTL2  -------------------------------- */
#define NT_I2C0_CTL2_S10ADR_Pos               0                                                       /*!< NT_I2C0 CTL2: S10ADR Position           */
#define NT_I2C0_CTL2_S10ADR_Msk               (0x07UL << NT_I2C0_CTL2_S10ADR_Pos)                     /*!< NT_I2C0 CTL2: S10ADR Mask               */
#define NT_I2C0_CTL2_S10EN_Pos                3                                                       /*!< NT_I2C0 CTL2: S10EN Position            */
#define NT_I2C0_CTL2_S10EN_Msk                (0x01UL << NT_I2C0_CTL2_S10EN_Pos)                      /*!< NT_I2C0 CTL2: S10EN Mask                */
#define NT_I2C0_CTL2_HSDIV_Pos                4                                                       /*!< NT_I2C0 CTL2: HSDIV Position            */
#define NT_I2C0_CTL2_HSDIV_Msk                (0x0fUL << NT_I2C0_CTL2_HSDIV_Pos)                      /*!< NT_I2C0 CTL2: HSDIV Mask                */


/* ================================================================================ */
/* ================        struct 'NT_I2C1' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  NT_I2C1_SDA  -------------------------------- */
#define NT_I2C1_SDA_DATA_Pos                  0                                                       /*!< NT_I2C1 SDA: DATA Position              */
#define NT_I2C1_SDA_DATA_Msk                  (0x000000ffUL << NT_I2C1_SDA_DATA_Pos)                  /*!< NT_I2C1 SDA: DATA Mask                  */

/* ---------------------------------  NT_I2C1_ST  --------------------------------- */
#define NT_I2C1_ST_MODE_Pos                   0                                                       /*!< NT_I2C1 ST: MODE Position               */
#define NT_I2C1_ST_MODE_Msk                   (0x3fUL << NT_I2C1_ST_MODE_Pos)                         /*!< NT_I2C1 ST: MODE Mask                   */
#define NT_I2C1_ST_INT_Pos                    7                                                       /*!< NT_I2C1 ST: INT Position                */
#define NT_I2C1_ST_INT_Msk                    (0x01UL << NT_I2C1_ST_INT_Pos)                          /*!< NT_I2C1 ST: INT Mask                    */

/* ---------------------------------  NT_I2C1_CST  -------------------------------- */
#define NT_I2C1_CST_BB_Pos                    0                                                       /*!< NT_I2C1 CST: BB Position                */
#define NT_I2C1_CST_BB_Msk                    (0x01UL << NT_I2C1_CST_BB_Pos)                          /*!< NT_I2C1 CST: BB Mask                    */
#define NT_I2C1_CST_TOCDIV_Pos                1                                                       /*!< NT_I2C1 CST: TOCDIV Position            */
#define NT_I2C1_CST_TOCDIV_Msk                (0x03UL << NT_I2C1_CST_TOCDIV_Pos)                      /*!< NT_I2C1 CST: TOCDIV Mask                */
#define NT_I2C1_CST_TOERR_Pos                 3                                                       /*!< NT_I2C1 CST: TOERR Position             */
#define NT_I2C1_CST_TOERR_Msk                 (0x01UL << NT_I2C1_CST_TOERR_Pos)                       /*!< NT_I2C1 CST: TOERR Mask                 */
#define NT_I2C1_CST_TSDA_Pos                  4                                                       /*!< NT_I2C1 CST: TSDA Position              */
#define NT_I2C1_CST_TSDA_Msk                  (0x01UL << NT_I2C1_CST_TSDA_Pos)                        /*!< NT_I2C1 CST: TSDA Mask                  */
#define NT_I2C1_CST_TGSCL_Pos                 5                                                       /*!< NT_I2C1 CST: TGSCL Position             */
#define NT_I2C1_CST_TGSCL_Msk                 (0x01UL << NT_I2C1_CST_TGSCL_Pos)                       /*!< NT_I2C1 CST: TGSCL Mask                 */
#define NT_I2C1_CST_PECNEXT_Pos               6                                                       /*!< NT_I2C1 CST: PECNEXT Position           */
#define NT_I2C1_CST_PECNEXT_Msk               (0x01UL << NT_I2C1_CST_PECNEXT_Pos)                     /*!< NT_I2C1 CST: PECNEXT Mask               */
#define NT_I2C1_CST_PECFAULT_Pos              7                                                       /*!< NT_I2C1 CST: PECFAULT Position          */
#define NT_I2C1_CST_PECFAULT_Msk              (0x01UL << NT_I2C1_CST_PECFAULT_Pos)                    /*!< NT_I2C1 CST: PECFAULT Mask              */

/* --------------------------------  NT_I2C1_CTL0  -------------------------------- */
#define NT_I2C1_CTL0_START_Pos                0                                                       /*!< NT_I2C1 CTL0: START Position            */
#define NT_I2C1_CTL0_START_Msk                (0x01UL << NT_I2C1_CTL0_START_Pos)                      /*!< NT_I2C1 CTL0: START Mask                */
#define NT_I2C1_CTL0_STOP_Pos                 1                                                       /*!< NT_I2C1 CTL0: STOP Position             */
#define NT_I2C1_CTL0_STOP_Msk                 (0x01UL << NT_I2C1_CTL0_STOP_Pos)                       /*!< NT_I2C1 CTL0: STOP Mask                 */
#define NT_I2C1_CTL0_INTEN_Pos                2                                                       /*!< NT_I2C1 CTL0: INTEN Position            */
#define NT_I2C1_CTL0_INTEN_Msk                (0x01UL << NT_I2C1_CTL0_INTEN_Pos)                      /*!< NT_I2C1 CTL0: INTEN Mask                */
#define NT_I2C1_CTL0_ACK_Pos                  4                                                       /*!< NT_I2C1 CTL0: ACK Position              */
#define NT_I2C1_CTL0_ACK_Msk                  (0x01UL << NT_I2C1_CTL0_ACK_Pos)                        /*!< NT_I2C1 CTL0: ACK Mask                  */
#define NT_I2C1_CTL0_GCMEN_Pos                5                                                       /*!< NT_I2C1 CTL0: GCMEN Position            */
#define NT_I2C1_CTL0_GCMEN_Msk                (0x01UL << NT_I2C1_CTL0_GCMEN_Pos)                      /*!< NT_I2C1 CTL0: GCMEN Mask                */
#define NT_I2C1_CTL0_SMBARE_Pos               6                                                       /*!< NT_I2C1 CTL0: SMBARE Position           */
#define NT_I2C1_CTL0_SMBARE_Msk               (0x01UL << NT_I2C1_CTL0_SMBARE_Pos)                     /*!< NT_I2C1 CTL0: SMBARE Mask               */
#define NT_I2C1_CTL0_CLRST_Pos                7                                                       /*!< NT_I2C1 CTL0: CLRST Position            */
#define NT_I2C1_CTL0_CLRST_Msk                (0x01UL << NT_I2C1_CTL0_CLRST_Pos)                      /*!< NT_I2C1 CTL0: CLRST Mask                */

/* --------------------------------  NT_I2C1_ADDR  -------------------------------- */
#define NT_I2C1_ADDR_ADDR_Pos                 0                                                       /*!< NT_I2C1 ADDR: ADDR Position             */
#define NT_I2C1_ADDR_ADDR_Msk                 (0x7fUL << NT_I2C1_ADDR_ADDR_Pos)                       /*!< NT_I2C1 ADDR: ADDR Mask                 */
#define NT_I2C1_ADDR_SAEN_Pos                 7                                                       /*!< NT_I2C1 ADDR: SAEN Position             */
#define NT_I2C1_ADDR_SAEN_Msk                 (0x01UL << NT_I2C1_ADDR_SAEN_Pos)                       /*!< NT_I2C1 ADDR: SAEN Mask                 */

/* --------------------------------  NT_I2C1_CTL1  -------------------------------- */
#define NT_I2C1_CTL1_ENABLE_Pos               0                                                       /*!< NT_I2C1 CTL1: ENABLE Position           */
#define NT_I2C1_CTL1_ENABLE_Msk               (0x01UL << NT_I2C1_CTL1_ENABLE_Pos)                     /*!< NT_I2C1 CTL1: ENABLE Mask               */
#define NT_I2C1_CTL1_SCLFRQ_Pos               1                                                       /*!< NT_I2C1 CTL1: SCLFRQ Position           */
#define NT_I2C1_CTL1_SCLFRQ_Msk               (0x7fUL << NT_I2C1_CTL1_SCLFRQ_Pos)                     /*!< NT_I2C1 CTL1: SCLFRQ Mask               */

/* --------------------------------  NT_I2C1_TOPR  -------------------------------- */
#define NT_I2C1_TOPR_SMBTOPR_Pos              0                                                       /*!< NT_I2C1 TOPR: SMBTOPR Position          */
#define NT_I2C1_TOPR_SMBTOPR_Msk              (0x000000ffUL << NT_I2C1_TOPR_SMBTOPR_Pos)              /*!< NT_I2C1 TOPR: SMBTOPR Mask              */

/* --------------------------------  NT_I2C1_CTL2  -------------------------------- */
#define NT_I2C1_CTL2_S10ADR_Pos               0                                                       /*!< NT_I2C1 CTL2: S10ADR Position           */
#define NT_I2C1_CTL2_S10ADR_Msk               (0x07UL << NT_I2C1_CTL2_S10ADR_Pos)                     /*!< NT_I2C1 CTL2: S10ADR Mask               */
#define NT_I2C1_CTL2_S10EN_Pos                3                                                       /*!< NT_I2C1 CTL2: S10EN Position            */
#define NT_I2C1_CTL2_S10EN_Msk                (0x01UL << NT_I2C1_CTL2_S10EN_Pos)                      /*!< NT_I2C1 CTL2: S10EN Mask                */
#define NT_I2C1_CTL2_HSDIV_Pos                4                                                       /*!< NT_I2C1 CTL2: HSDIV Position            */
#define NT_I2C1_CTL2_HSDIV_Msk                (0x0fUL << NT_I2C1_CTL2_HSDIV_Pos)                      /*!< NT_I2C1 CTL2: HSDIV Mask                */


/* ================================================================================ */
/* ================       struct 'NT_TIMER0' Position & Mask       ================ */
/* ================================================================================ */


/* -------------------------------  NT_TIMER0_CTRL  ------------------------------- */
#define NT_TIMER0_CTRL_ON_Pos                 0                                                       /*!< NT_TIMER0 CTRL: ON Position             */
#define NT_TIMER0_CTRL_ON_Msk                 (0x01UL << NT_TIMER0_CTRL_ON_Pos)                       /*!< NT_TIMER0 CTRL: ON Mask                 */
#define NT_TIMER0_CTRL_EXTINPUT_EN_Pos        1                                                       /*!< NT_TIMER0 CTRL: EXTINPUT_EN Position    */
#define NT_TIMER0_CTRL_EXTINPUT_EN_Msk        (0x01UL << NT_TIMER0_CTRL_EXTINPUT_EN_Pos)              /*!< NT_TIMER0 CTRL: EXTINPUT_EN Mask        */
#define NT_TIMER0_CTRL_EXTINPUT_CLK_Pos       2                                                       /*!< NT_TIMER0 CTRL: EXTINPUT_CLK Position   */
#define NT_TIMER0_CTRL_EXTINPUT_CLK_Msk       (0x01UL << NT_TIMER0_CTRL_EXTINPUT_CLK_Pos)             /*!< NT_TIMER0 CTRL: EXTINPUT_CLK Mask       */
#define NT_TIMER0_CTRL_INTEN_Pos              3                                                       /*!< NT_TIMER0 CTRL: INTEN Position          */
#define NT_TIMER0_CTRL_INTEN_Msk              (0x01UL << NT_TIMER0_CTRL_INTEN_Pos)                    /*!< NT_TIMER0 CTRL: INTEN Mask              */

/* -------------------------------  NT_TIMER0_VALUE  ------------------------------ */
#define NT_TIMER0_VALUE_VALUE_Pos             0                                                       /*!< NT_TIMER0 VALUE: VALUE Position         */
#define NT_TIMER0_VALUE_VALUE_Msk             (0xffffffffUL << NT_TIMER0_VALUE_VALUE_Pos)             /*!< NT_TIMER0 VALUE: VALUE Mask             */

/* ------------------------------  NT_TIMER0_RELOAD  ------------------------------ */
#define NT_TIMER0_RELOAD_RELOAD_Pos           0                                                       /*!< NT_TIMER0 RELOAD: RELOAD Position       */
#define NT_TIMER0_RELOAD_RELOAD_Msk           (0xffffffffUL << NT_TIMER0_RELOAD_RELOAD_Pos)           /*!< NT_TIMER0 RELOAD: RELOAD Mask           */

/* ------------------------  NT_TIMER0_INTSTATUS_INTCLEAR  ------------------------ */
#define NT_TIMER0_INTSTATUS_INTCLEAR_INT_Pos  0                                                       /*!< NT_TIMER0 INTSTATUS_INTCLEAR: INT Position */
#define NT_TIMER0_INTSTATUS_INTCLEAR_INT_Msk  (0x01UL << NT_TIMER0_INTSTATUS_INTCLEAR_INT_Pos)        /*!< NT_TIMER0 INTSTATUS_INTCLEAR: INT Mask  */


/* ================================================================================ */
/* ================       struct 'NT_TIMER1' Position & Mask       ================ */
/* ================================================================================ */


/* -------------------------------  NT_TIMER1_CTRL  ------------------------------- */
#define NT_TIMER1_CTRL_ON_Pos                 0                                                       /*!< NT_TIMER1 CTRL: ON Position             */
#define NT_TIMER1_CTRL_ON_Msk                 (0x01UL << NT_TIMER1_CTRL_ON_Pos)                       /*!< NT_TIMER1 CTRL: ON Mask                 */
#define NT_TIMER1_CTRL_EXTINPUT_EN_Pos        1                                                       /*!< NT_TIMER1 CTRL: EXTINPUT_EN Position    */
#define NT_TIMER1_CTRL_EXTINPUT_EN_Msk        (0x01UL << NT_TIMER1_CTRL_EXTINPUT_EN_Pos)              /*!< NT_TIMER1 CTRL: EXTINPUT_EN Mask        */
#define NT_TIMER1_CTRL_EXTINPUT_CLK_Pos       2                                                       /*!< NT_TIMER1 CTRL: EXTINPUT_CLK Position   */
#define NT_TIMER1_CTRL_EXTINPUT_CLK_Msk       (0x01UL << NT_TIMER1_CTRL_EXTINPUT_CLK_Pos)             /*!< NT_TIMER1 CTRL: EXTINPUT_CLK Mask       */
#define NT_TIMER1_CTRL_INTEN_Pos              3                                                       /*!< NT_TIMER1 CTRL: INTEN Position          */
#define NT_TIMER1_CTRL_INTEN_Msk              (0x01UL << NT_TIMER1_CTRL_INTEN_Pos)                    /*!< NT_TIMER1 CTRL: INTEN Mask              */

/* -------------------------------  NT_TIMER1_VALUE  ------------------------------ */
#define NT_TIMER1_VALUE_VALUE_Pos             0                                                       /*!< NT_TIMER1 VALUE: VALUE Position         */
#define NT_TIMER1_VALUE_VALUE_Msk             (0xffffffffUL << NT_TIMER1_VALUE_VALUE_Pos)             /*!< NT_TIMER1 VALUE: VALUE Mask             */

/* ------------------------------  NT_TIMER1_RELOAD  ------------------------------ */
#define NT_TIMER1_RELOAD_RELOAD_Pos           0                                                       /*!< NT_TIMER1 RELOAD: RELOAD Position       */
#define NT_TIMER1_RELOAD_RELOAD_Msk           (0xffffffffUL << NT_TIMER1_RELOAD_RELOAD_Pos)           /*!< NT_TIMER1 RELOAD: RELOAD Mask           */

/* ------------------------  NT_TIMER1_INTSTATUS_INTCLEAR  ------------------------ */
#define NT_TIMER1_INTSTATUS_INTCLEAR_INT_Pos  0                                                       /*!< NT_TIMER1 INTSTATUS_INTCLEAR: INT Position */
#define NT_TIMER1_INTSTATUS_INTCLEAR_INT_Msk  (0x01UL << NT_TIMER1_INTSTATUS_INTCLEAR_INT_Pos)        /*!< NT_TIMER1 INTSTATUS_INTCLEAR: INT Mask  */


/* ================================================================================ */
/* ================       struct 'NT_TIMER2' Position & Mask       ================ */
/* ================================================================================ */


/* -------------------------------  NT_TIMER2_CTRL  ------------------------------- */
#define NT_TIMER2_CTRL_ON_Pos                 0                                                       /*!< NT_TIMER2 CTRL: ON Position             */
#define NT_TIMER2_CTRL_ON_Msk                 (0x01UL << NT_TIMER2_CTRL_ON_Pos)                       /*!< NT_TIMER2 CTRL: ON Mask                 */
#define NT_TIMER2_CTRL_EXTINPUT_EN_Pos        1                                                       /*!< NT_TIMER2 CTRL: EXTINPUT_EN Position    */
#define NT_TIMER2_CTRL_EXTINPUT_EN_Msk        (0x01UL << NT_TIMER2_CTRL_EXTINPUT_EN_Pos)              /*!< NT_TIMER2 CTRL: EXTINPUT_EN Mask        */
#define NT_TIMER2_CTRL_EXTINPUT_CLK_Pos       2                                                       /*!< NT_TIMER2 CTRL: EXTINPUT_CLK Position   */
#define NT_TIMER2_CTRL_EXTINPUT_CLK_Msk       (0x01UL << NT_TIMER2_CTRL_EXTINPUT_CLK_Pos)             /*!< NT_TIMER2 CTRL: EXTINPUT_CLK Mask       */
#define NT_TIMER2_CTRL_INTEN_Pos              3                                                       /*!< NT_TIMER2 CTRL: INTEN Position          */
#define NT_TIMER2_CTRL_INTEN_Msk              (0x01UL << NT_TIMER2_CTRL_INTEN_Pos)                    /*!< NT_TIMER2 CTRL: INTEN Mask              */

/* -------------------------------  NT_TIMER2_VALUE  ------------------------------ */
#define NT_TIMER2_VALUE_VALUE_Pos             0                                                       /*!< NT_TIMER2 VALUE: VALUE Position         */
#define NT_TIMER2_VALUE_VALUE_Msk             (0xffffffffUL << NT_TIMER2_VALUE_VALUE_Pos)             /*!< NT_TIMER2 VALUE: VALUE Mask             */

/* ------------------------------  NT_TIMER2_RELOAD  ------------------------------ */
#define NT_TIMER2_RELOAD_RELOAD_Pos           0                                                       /*!< NT_TIMER2 RELOAD: RELOAD Position       */
#define NT_TIMER2_RELOAD_RELOAD_Msk           (0xffffffffUL << NT_TIMER2_RELOAD_RELOAD_Pos)           /*!< NT_TIMER2 RELOAD: RELOAD Mask           */

/* ------------------------  NT_TIMER2_INTSTATUS_INTCLEAR  ------------------------ */
#define NT_TIMER2_INTSTATUS_INTCLEAR_INT_Pos  0                                                       /*!< NT_TIMER2 INTSTATUS_INTCLEAR: INT Position */
#define NT_TIMER2_INTSTATUS_INTCLEAR_INT_Msk  (0x01UL << NT_TIMER2_INTSTATUS_INTCLEAR_INT_Pos)        /*!< NT_TIMER2 INTSTATUS_INTCLEAR: INT Mask  */


/* ================================================================================ */
/* ================         struct 'NT_DMA' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_DMA_STATUS  ------------------------------- */
#define NT_DMA_STATUS_MASTER_EN_Pos           0                                                       /*!< NT_DMA STATUS: MASTER_EN Position       */
#define NT_DMA_STATUS_MASTER_EN_Msk           (0x01UL << NT_DMA_STATUS_MASTER_EN_Pos)                 /*!< NT_DMA STATUS: MASTER_EN Mask           */
#define NT_DMA_STATUS_STATE_Pos               4                                                       /*!< NT_DMA STATUS: STATE Position           */
#define NT_DMA_STATUS_STATE_Msk               (0x0fUL << NT_DMA_STATUS_STATE_Pos)                     /*!< NT_DMA STATUS: STATE Mask               */
#define NT_DMA_STATUS_CHNLS_Pos               16                                                      /*!< NT_DMA STATUS: CHNLS Position           */
#define NT_DMA_STATUS_CHNLS_Msk               (0x1fUL << NT_DMA_STATUS_CHNLS_Pos)                     /*!< NT_DMA STATUS: CHNLS Mask               */

/* ---------------------------------  NT_DMA_CFG  --------------------------------- */
#define NT_DMA_CFG_MASTER_EN_Pos              0                                                       /*!< NT_DMA CFG: MASTER_EN Position          */
#define NT_DMA_CFG_MASTER_EN_Msk              (0x01UL << NT_DMA_CFG_MASTER_EN_Pos)                    /*!< NT_DMA CFG: MASTER_EN Mask              */
#define NT_DMA_CFG_CHNL_PROT_CTRL_Pos         5                                                       /*!< NT_DMA CFG: CHNL_PROT_CTRL Position     */
#define NT_DMA_CFG_CHNL_PROT_CTRL_Msk         (0x07UL << NT_DMA_CFG_CHNL_PROT_CTRL_Pos)               /*!< NT_DMA CFG: CHNL_PROT_CTRL Mask         */

/* ----------------------------  NT_DMA_CTRL_BASE_PTR  ---------------------------- */
#define NT_DMA_CTRL_BASE_PTR_CTRL_BASE_PTR_Pos 10                                                     /*!< NT_DMA CTRL_BASE_PTR: CTRL_BASE_PTR Position */
#define NT_DMA_CTRL_BASE_PTR_CTRL_BASE_PTR_Msk (0x003fffffUL << NT_DMA_CTRL_BASE_PTR_CTRL_BASE_PTR_Pos)/*!< NT_DMA CTRL_BASE_PTR: CTRL_BASE_PTR Mask */

/* --------------------------  NT_DMA_ALT_CTRL_BASE_PTR  -------------------------- */
#define NT_DMA_ALT_CTRL_BASE_PTR_ALT_CTRL_BASE_PTR_Pos 0                                              /*!< NT_DMA ALT_CTRL_BASE_PTR: ALT_CTRL_BASE_PTR Position */
#define NT_DMA_ALT_CTRL_BASE_PTR_ALT_CTRL_BASE_PTR_Msk (0xffffffffUL << NT_DMA_ALT_CTRL_BASE_PTR_ALT_CTRL_BASE_PTR_Pos)/*!< NT_DMA ALT_CTRL_BASE_PTR: ALT_CTRL_BASE_PTR Mask */

/* ---------------------------  NT_DMA_WAITONREQ_STATUS  -------------------------- */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ0_Pos 0                                                    /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ0 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ0_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ0_Pos) /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ0 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ1_Pos 1                                                    /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ1 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ1_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ1_Pos) /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ1 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ2_Pos 2                                                    /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ2 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ2_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ2_Pos) /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ2 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ3_Pos 3                                                    /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ3 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ3_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ3_Pos) /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ3 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ4_Pos 4                                                    /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ4 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ4_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ4_Pos) /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ4 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ5_Pos 5                                                    /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ5 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ5_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ5_Pos) /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ5 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ6_Pos 6                                                    /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ6 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ6_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ6_Pos) /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ6 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ7_Pos 7                                                    /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ7 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ7_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ7_Pos) /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ7 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ8_Pos 8                                                    /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ8 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ8_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ8_Pos) /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ8 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ9_Pos 9                                                    /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ9 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ9_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ9_Pos) /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ9 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ10_Pos 10                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ10 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ10_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ10_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ10 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ11_Pos 11                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ11 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ11_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ11_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ11 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ12_Pos 12                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ12 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ12_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ12_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ12 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ13_Pos 13                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ13 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ13_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ13_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ13 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ14_Pos 14                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ14 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ14_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ14_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ14 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ15_Pos 15                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ15 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ15_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ15_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ15 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ16_Pos 16                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ16 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ16_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ16_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ16 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ17_Pos 17                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ17 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ17_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ17_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ17 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ18_Pos 18                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ18 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ18_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ18_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ18 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ19_Pos 19                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ19 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ19_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ19_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ19 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ20_Pos 20                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ20 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ20_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ20_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ20 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ21_Pos 21                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ21 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ21_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ21_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ21 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ22_Pos 22                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ22 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ22_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ22_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ22 Mask */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ23_Pos 23                                                  /*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ23 Position */
#define NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ23_Msk (0x01UL << NT_DMA_WAITONREQ_STATUS_DMA_WAITREQ23_Pos)/*!< NT_DMA WAITONREQ_STATUS: DMA_WAITREQ23 Mask */

/* ---------------------------  NT_DMA_CHNL_SW_REQUEST  --------------------------- */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ0_Pos 0                                                       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ0 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ0_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ0_Pos)       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ0 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ1_Pos 1                                                       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ1 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ1_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ1_Pos)       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ1 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ2_Pos 2                                                       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ2 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ2_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ2_Pos)       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ2 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ3_Pos 3                                                       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ3 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ3_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ3_Pos)       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ3 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ4_Pos 4                                                       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ4 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ4_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ4_Pos)       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ4 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ5_Pos 5                                                       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ5 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ5_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ5_Pos)       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ5 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ6_Pos 6                                                       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ6 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ6_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ6_Pos)       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ6 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ7_Pos 7                                                       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ7 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ7_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ7_Pos)       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ7 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ8_Pos 8                                                       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ8 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ8_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ8_Pos)       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ8 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ9_Pos 9                                                       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ9 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ9_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ9_Pos)       /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ9 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ10_Pos 10                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ10 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ10_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ10_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ10 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ11_Pos 11                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ11 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ11_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ11_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ11 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ12_Pos 12                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ12 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ12_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ12_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ12 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ13_Pos 13                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ13 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ13_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ13_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ13 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ14_Pos 14                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ14 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ14_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ14_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ14 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ15_Pos 15                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ15 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ15_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ15_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ15 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ16_Pos 16                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ16 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ16_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ16_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ16 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ17_Pos 17                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ17 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ17_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ17_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ17 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ18_Pos 18                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ18 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ18_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ18_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ18 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ19_Pos 19                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ19 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ19_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ19_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ19 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ20_Pos 20                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ20 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ20_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ20_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ20 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ21_Pos 21                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ21 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ21_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ21_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ21 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ22_Pos 22                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ22 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ22_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ22_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ22 Mask */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ23_Pos 23                                                     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ23 Position */
#define NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ23_Msk (0x01UL << NT_DMA_CHNL_SW_REQUEST_DMA_SWREQ23_Pos)     /*!< NT_DMA CHNL_SW_REQUEST: DMA_SWREQ23 Mask */

/* --------------------------  NT_DMA_CHNL_USEBURST_SET  -------------------------- */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET0_Pos 0                                                  /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET0 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET0_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET0_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET0 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET1_Pos 1                                                  /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET1 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET1_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET1_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET1 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET2_Pos 2                                                  /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET2 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET2_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET2_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET2 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET3_Pos 3                                                  /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET3 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET3_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET3_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET3 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET4_Pos 4                                                  /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET4 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET4_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET4_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET4 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET5_Pos 5                                                  /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET5 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET5_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET5_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET5 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET6_Pos 6                                                  /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET6 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET6_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET6_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET6 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET7_Pos 7                                                  /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET7 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET7_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET7_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET7 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET8_Pos 8                                                  /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET8 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET8_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET8_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET8 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET9_Pos 9                                                  /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET9 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET9_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET9_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET9 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET10_Pos 10                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET10 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET10_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET10_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET10 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET11_Pos 11                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET11 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET11_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET11_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET11 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET12_Pos 12                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET12 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET12_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET12_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET12 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET13_Pos 13                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET13 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET13_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET13_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET13 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET14_Pos 14                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET14 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET14_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET14_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET14 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET15_Pos 15                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET15 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET15_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET15_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET15 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET16_Pos 16                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET16 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET16_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET16_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET16 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET17_Pos 17                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET17 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET17_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET17_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET17 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET18_Pos 18                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET18 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET18_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET18_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET18 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET19_Pos 19                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET19 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET19_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET19_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET19 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET20_Pos 20                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET20 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET20_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET20_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET20 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET21_Pos 21                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET21 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET21_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET21_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET21 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET22_Pos 22                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET22 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET22_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET22_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET22 Mask */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET23_Pos 23                                                /*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET23 Position */
#define NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET23_Msk (0x01UL << NT_DMA_CHNL_USEBURST_SET_DMA_BURSTSET23_Pos)/*!< NT_DMA CHNL_USEBURST_SET: DMA_BURSTSET23 Mask */

/* --------------------------  NT_DMA_CHNL_USEBURST_CLR  -------------------------- */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR0_Pos 0                                                  /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR0 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR0_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR0_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR0 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR1_Pos 1                                                  /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR1 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR1_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR1_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR1 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR2_Pos 2                                                  /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR2 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR2_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR2_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR2 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR3_Pos 3                                                  /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR3 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR3_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR3_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR3 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR4_Pos 4                                                  /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR4 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR4_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR4_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR4 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR5_Pos 5                                                  /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR5 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR5_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR5_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR5 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR6_Pos 6                                                  /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR6 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR6_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR6_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR6 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR7_Pos 7                                                  /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR7 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR7_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR7_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR7 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR8_Pos 8                                                  /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR8 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR8_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR8_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR8 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR9_Pos 9                                                  /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR9 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR9_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR9_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR9 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR10_Pos 10                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR10 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR10_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR10_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR10 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR11_Pos 11                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR11 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR11_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR11_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR11 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR12_Pos 12                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR12 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR12_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR12_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR12 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR13_Pos 13                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR13 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR13_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR13_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR13 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR14_Pos 14                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR14 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR14_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR14_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR14 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR15_Pos 15                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR15 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR15_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR15_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR15 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR16_Pos 16                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR16 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR16_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR16_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR16 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR17_Pos 17                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR17 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR17_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR17_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR17 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR18_Pos 18                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR18 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR18_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR18_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR18 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR19_Pos 19                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR19 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR19_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR19_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR19 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR20_Pos 20                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR20 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR20_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR20_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR20 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR21_Pos 21                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR21 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR21_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR21_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR21 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR22_Pos 22                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR22 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR22_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR22_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR22 Mask */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR23_Pos 23                                                /*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR23 Position */
#define NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR23_Msk (0x01UL << NT_DMA_CHNL_USEBURST_CLR_DMA_BURSTCLR23_Pos)/*!< NT_DMA CHNL_USEBURST_CLR: DMA_BURSTCLR23 Mask */

/* --------------------------  NT_DMA_CHNL_REQ_MASK_SET  -------------------------- */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET0_Pos 0                                                /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET0 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET0_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET0_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET0 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET1_Pos 1                                                /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET1 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET1_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET1_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET1 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET2_Pos 2                                                /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET2 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET2_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET2_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET2 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET3_Pos 3                                                /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET3 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET3_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET3_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET3 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET4_Pos 4                                                /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET4 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET4_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET4_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET4 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET5_Pos 5                                                /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET5 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET5_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET5_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET5 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET6_Pos 6                                                /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET6 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET6_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET6_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET6 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET7_Pos 7                                                /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET7 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET7_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET7_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET7 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET8_Pos 8                                                /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET8 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET8_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET8_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET8 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET9_Pos 9                                                /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET9 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET9_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET9_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET9 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET10_Pos 10                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET10 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET10_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET10_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET10 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET11_Pos 11                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET11 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET11_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET11_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET11 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET12_Pos 12                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET12 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET12_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET12_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET12 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET13_Pos 13                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET13 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET13_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET13_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET13 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET14_Pos 14                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET14 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET14_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET14_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET14 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET15_Pos 15                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET15 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET15_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET15_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET15 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET16_Pos 16                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET16 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET16_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET16_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET16 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET17_Pos 17                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET17 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET17_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET17_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET17 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET18_Pos 18                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET18 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET18_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET18_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET18 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET19_Pos 19                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET19 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET19_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET19_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET19 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET20_Pos 20                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET20 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET20_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET20_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET20 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET21_Pos 21                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET21 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET21_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET21_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET21 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET22_Pos 22                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET22 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET22_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET22_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET22 Mask */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET23_Pos 23                                              /*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET23 Position */
#define NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET23_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_SET_DMA_REQMASKSET23_Pos)/*!< NT_DMA CHNL_REQ_MASK_SET: DMA_REQMASKSET23 Mask */

/* --------------------------  NT_DMA_CHNL_REQ_MASK_CLR  -------------------------- */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR0_Pos 0                                                /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR0 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR0_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR0_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR0 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR1_Pos 1                                                /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR1 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR1_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR1_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR1 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR2_Pos 2                                                /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR2 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR2_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR2_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR2 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR3_Pos 3                                                /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR3 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR3_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR3_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR3 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR4_Pos 4                                                /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR4 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR4_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR4_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR4 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR5_Pos 5                                                /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR5 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR5_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR5_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR5 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR6_Pos 6                                                /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR6 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR6_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR6_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR6 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR7_Pos 7                                                /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR7 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR7_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR7_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR7 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR8_Pos 8                                                /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR8 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR8_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR8_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR8 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR9_Pos 9                                                /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR9 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR9_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR9_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR9 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR10_Pos 10                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR10 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR10_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR10_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR10 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR11_Pos 11                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR11 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR11_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR11_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR11 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR12_Pos 12                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR12 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR12_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR12_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR12 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR13_Pos 13                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR13 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR13_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR13_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR13 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR14_Pos 14                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR14 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR14_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR14_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR14 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR15_Pos 15                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR15 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR15_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR15_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR15 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR16_Pos 16                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR16 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR16_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR16_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR16 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR17_Pos 17                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR17 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR17_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR17_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR17 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR18_Pos 18                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR18 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR18_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR18_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR18 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR19_Pos 19                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR19 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR19_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR19_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR19 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR20_Pos 20                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR20 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR20_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR20_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR20 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR21_Pos 21                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR21 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR21_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR21_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR21 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR22_Pos 22                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR22 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR22_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR22_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR22 Mask */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR23_Pos 23                                              /*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR23 Position */
#define NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR23_Msk (0x01UL << NT_DMA_CHNL_REQ_MASK_CLR_DMA_REQMASKCLR23_Pos)/*!< NT_DMA CHNL_REQ_MASK_CLR: DMA_REQMASKCLR23 Mask */

/* ---------------------------  NT_DMA_CHNL_ENABLE_SET  --------------------------- */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET0_Pos 0                                                       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET0 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET0_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET0_Pos)       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET0 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET1_Pos 1                                                       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET1 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET1_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET1_Pos)       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET1 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET2_Pos 2                                                       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET2 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET2_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET2_Pos)       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET2 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET3_Pos 3                                                       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET3 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET3_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET3_Pos)       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET3 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET4_Pos 4                                                       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET4 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET4_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET4_Pos)       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET4 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET5_Pos 5                                                       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET5 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET5_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET5_Pos)       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET5 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET6_Pos 6                                                       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET6 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET6_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET6_Pos)       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET6 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET7_Pos 7                                                       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET7 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET7_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET7_Pos)       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET7 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET8_Pos 8                                                       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET8 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET8_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET8_Pos)       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET8 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET9_Pos 9                                                       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET9 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET9_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET9_Pos)       /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET9 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET10_Pos 10                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET10 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET10_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET10_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET10 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET11_Pos 11                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET11 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET11_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET11_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET11 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET12_Pos 12                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET12 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET12_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET12_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET12 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET13_Pos 13                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET13 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET13_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET13_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET13 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET14_Pos 14                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET14 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET14_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET14_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET14 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET15_Pos 15                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET15 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET15_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET15_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET15 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET16_Pos 16                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET16 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET16_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET16_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET16 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET17_Pos 17                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET17 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET17_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET17_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET17 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET18_Pos 18                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET18 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET18_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET18_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET18 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET19_Pos 19                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET19 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET19_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET19_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET19 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET20_Pos 20                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET20 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET20_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET20_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET20 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET21_Pos 21                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET21 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET21_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET21_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET21 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET22_Pos 22                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET22 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET22_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET22_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET22 Mask */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET23_Pos 23                                                     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET23 Position */
#define NT_DMA_CHNL_ENABLE_SET_DMA_ENSET23_Msk (0x01UL << NT_DMA_CHNL_ENABLE_SET_DMA_ENSET23_Pos)     /*!< NT_DMA CHNL_ENABLE_SET: DMA_ENSET23 Mask */

/* ---------------------------  NT_DMA_CHNL_ENABLE_CLR  --------------------------- */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR0_Pos 0                                                       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR0 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR0_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR0_Pos)       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR0 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR1_Pos 1                                                       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR1 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR1_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR1_Pos)       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR1 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR2_Pos 2                                                       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR2 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR2_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR2_Pos)       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR2 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR3_Pos 3                                                       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR3 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR3_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR3_Pos)       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR3 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR4_Pos 4                                                       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR4 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR4_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR4_Pos)       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR4 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR5_Pos 5                                                       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR5 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR5_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR5_Pos)       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR5 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR6_Pos 6                                                       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR6 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR6_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR6_Pos)       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR6 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR7_Pos 7                                                       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR7 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR7_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR7_Pos)       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR7 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR8_Pos 8                                                       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR8 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR8_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR8_Pos)       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR8 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR9_Pos 9                                                       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR9 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR9_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR9_Pos)       /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR9 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR10_Pos 10                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR10 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR10_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR10_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR10 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR11_Pos 11                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR11 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR11_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR11_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR11 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR12_Pos 12                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR12 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR12_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR12_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR12 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR13_Pos 13                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR13 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR13_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR13_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR13 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR14_Pos 14                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR14 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR14_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR14_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR14 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR15_Pos 15                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR15 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR15_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR15_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR15 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR16_Pos 16                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR16 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR16_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR16_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR16 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR17_Pos 17                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR17 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR17_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR17_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR17 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR18_Pos 18                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR18 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR18_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR18_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR18 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR19_Pos 19                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR19 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR19_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR19_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR19 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR20_Pos 20                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR20 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR20_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR20_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR20 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR21_Pos 21                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR21 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR21_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR21_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR21 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR22_Pos 22                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR22 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR22_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR22_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR22 Mask */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR23_Pos 23                                                     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR23 Position */
#define NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR23_Msk (0x01UL << NT_DMA_CHNL_ENABLE_CLR_DMA_ENCLR23_Pos)     /*!< NT_DMA CHNL_ENABLE_CLR: DMA_ENCLR23 Mask */

/* ---------------------------  NT_DMA_CHNL_PRI_ALT_SET  -------------------------- */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET0_Pos 0                                                     /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET0 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET0_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET0_Pos)   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET0 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET1_Pos 1                                                     /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET1 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET1_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET1_Pos)   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET1 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET2_Pos 2                                                     /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET2 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET2_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET2_Pos)   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET2 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET3_Pos 3                                                     /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET3 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET3_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET3_Pos)   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET3 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET4_Pos 4                                                     /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET4 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET4_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET4_Pos)   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET4 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET5_Pos 5                                                     /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET5 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET5_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET5_Pos)   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET5 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET6_Pos 6                                                     /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET6 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET6_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET6_Pos)   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET6 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET7_Pos 7                                                     /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET7 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET7_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET7_Pos)   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET7 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET8_Pos 8                                                     /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET8 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET8_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET8_Pos)   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET8 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET9_Pos 9                                                     /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET9 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET9_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET9_Pos)   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET9 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET10_Pos 10                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET10 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET10_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET10_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET10 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET11_Pos 11                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET11 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET11_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET11_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET11 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET12_Pos 12                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET12 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET12_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET12_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET12 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET13_Pos 13                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET13 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET13_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET13_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET13 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET14_Pos 14                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET14 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET14_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET14_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET14 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET15_Pos 15                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET15 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET15_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET15_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET15 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET16_Pos 16                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET16 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET16_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET16_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET16 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET17_Pos 17                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET17 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET17_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET17_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET17 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET18_Pos 18                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET18 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET18_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET18_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET18 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET19_Pos 19                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET19 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET19_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET19_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET19 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET20_Pos 20                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET20 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET20_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET20_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET20 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET21_Pos 21                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET21 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET21_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET21_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET21 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET22_Pos 22                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET22 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET22_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET22_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET22 Mask */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET23_Pos 23                                                   /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET23 Position */
#define NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET23_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_SET_DMA_ALTSET23_Pos) /*!< NT_DMA CHNL_PRI_ALT_SET: DMA_ALTSET23 Mask */

/* ---------------------------  NT_DMA_CHNL_PRI_ALT_CLR  -------------------------- */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR0_Pos 0                                                     /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR0 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR0_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR0_Pos)   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR0 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR1_Pos 1                                                     /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR1 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR1_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR1_Pos)   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR1 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR2_Pos 2                                                     /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR2 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR2_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR2_Pos)   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR2 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR3_Pos 3                                                     /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR3 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR3_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR3_Pos)   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR3 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR4_Pos 4                                                     /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR4 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR4_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR4_Pos)   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR4 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR5_Pos 5                                                     /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR5 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR5_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR5_Pos)   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR5 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR6_Pos 6                                                     /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR6 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR6_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR6_Pos)   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR6 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR7_Pos 7                                                     /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR7 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR7_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR7_Pos)   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR7 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR8_Pos 8                                                     /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR8 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR8_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR8_Pos)   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR8 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR9_Pos 9                                                     /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR9 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR9_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR9_Pos)   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR9 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR10_Pos 10                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR10 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR10_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR10_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR10 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR11_Pos 11                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR11 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR11_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR11_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR11 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR12_Pos 12                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR12 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR12_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR12_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR12 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR13_Pos 13                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR13 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR13_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR13_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR13 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR14_Pos 14                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR14 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR14_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR14_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR14 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR15_Pos 15                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR15 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR15_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR15_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR15 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR16_Pos 16                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR16 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR16_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR16_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR16 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR17_Pos 17                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR17 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR17_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR17_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR17 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR18_Pos 18                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR18 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR18_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR18_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR18 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR19_Pos 19                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR19 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR19_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR19_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR19 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR20_Pos 20                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR20 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR20_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR20_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR20 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR21_Pos 21                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR21 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR21_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR21_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR21 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR22_Pos 22                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR22 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR22_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR22_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR22 Mask */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR23_Pos 23                                                   /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR23 Position */
#define NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR23_Msk (0x01UL << NT_DMA_CHNL_PRI_ALT_CLR_DMA_ALTCLR23_Pos) /*!< NT_DMA CHNL_PRI_ALT_CLR: DMA_ALTCLR23 Mask */

/* --------------------------  NT_DMA_CHNL_PRIORITY_SET  -------------------------- */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET0_Pos 0                                                    /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET0 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET0_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET0_Pos) /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET0 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET1_Pos 1                                                    /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET1 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET1_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET1_Pos) /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET1 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET2_Pos 2                                                    /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET2 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET2_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET2_Pos) /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET2 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET3_Pos 3                                                    /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET3 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET3_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET3_Pos) /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET3 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET4_Pos 4                                                    /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET4 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET4_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET4_Pos) /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET4 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET5_Pos 5                                                    /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET5 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET5_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET5_Pos) /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET5 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET6_Pos 6                                                    /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET6 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET6_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET6_Pos) /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET6 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET7_Pos 7                                                    /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET7 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET7_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET7_Pos) /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET7 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET8_Pos 8                                                    /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET8 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET8_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET8_Pos) /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET8 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET9_Pos 9                                                    /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET9 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET9_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET9_Pos) /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET9 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET10_Pos 10                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET10 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET10_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET10_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET10 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET11_Pos 11                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET11 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET11_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET11_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET11 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET12_Pos 12                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET12 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET12_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET12_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET12 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET13_Pos 13                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET13 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET13_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET13_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET13 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET14_Pos 14                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET14 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET14_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET14_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET14 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET15_Pos 15                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET15 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET15_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET15_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET15 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET16_Pos 16                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET16 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET16_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET16_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET16 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET17_Pos 17                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET17 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET17_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET17_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET17 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET18_Pos 18                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET18 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET18_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET18_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET18 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET19_Pos 19                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET19 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET19_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET19_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET19 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET20_Pos 20                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET20 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET20_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET20_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET20 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET21_Pos 21                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET21 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET21_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET21_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET21 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET22_Pos 22                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET22 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET22_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET22_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET22 Mask */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET23_Pos 23                                                  /*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET23 Position */
#define NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET23_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_SET_DMA_PRISET23_Pos)/*!< NT_DMA CHNL_PRIORITY_SET: DMA_PRISET23 Mask */

/* --------------------------  NT_DMA_CHNL_PRIORITY_CLR  -------------------------- */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR0_Pos 0                                                    /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR0 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR0_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR0_Pos) /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR0 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR1_Pos 1                                                    /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR1 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR1_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR1_Pos) /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR1 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR2_Pos 2                                                    /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR2 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR2_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR2_Pos) /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR2 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR3_Pos 3                                                    /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR3 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR3_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR3_Pos) /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR3 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR4_Pos 4                                                    /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR4 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR4_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR4_Pos) /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR4 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR5_Pos 5                                                    /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR5 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR5_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR5_Pos) /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR5 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR6_Pos 6                                                    /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR6 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR6_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR6_Pos) /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR6 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR7_Pos 7                                                    /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR7 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR7_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR7_Pos) /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR7 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR8_Pos 8                                                    /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR8 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR8_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR8_Pos) /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR8 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR9_Pos 9                                                    /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR9 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR9_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR9_Pos) /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR9 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR10_Pos 10                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR10 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR10_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR10_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR10 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR11_Pos 11                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR11 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR11_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR11_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR11 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR12_Pos 12                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR12 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR12_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR12_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR12 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR13_Pos 13                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR13 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR13_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR13_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR13 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR14_Pos 14                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR14 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR14_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR14_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR14 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR15_Pos 15                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR15 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR15_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR15_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR15 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR16_Pos 16                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR16 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR16_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR16_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR16 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR17_Pos 17                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR17 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR17_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR17_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR17 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR18_Pos 18                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR18 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR18_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR18_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR18 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR19_Pos 19                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR19 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR19_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR19_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR19 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR20_Pos 20                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR20 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR20_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR20_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR20 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR21_Pos 21                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR21 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR21_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR21_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR21 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR22_Pos 22                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR22 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR22_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR22_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR22 Mask */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR23_Pos 23                                                  /*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR23 Position */
#define NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR23_Msk (0x01UL << NT_DMA_CHNL_PRIORITY_CLR_DMA_PRICLR23_Pos)/*!< NT_DMA CHNL_PRIORITY_CLR: DMA_PRICLR23 Mask */

/* -------------------------------  NT_DMA_ERR_CLR  ------------------------------- */
#define NT_DMA_ERR_CLR_ERR_CLR_Pos            0                                                       /*!< NT_DMA ERR_CLR: ERR_CLR Position        */
#define NT_DMA_ERR_CLR_ERR_CLR_Msk            (0x01UL << NT_DMA_ERR_CLR_ERR_CLR_Pos)                  /*!< NT_DMA ERR_CLR: ERR_CLR Mask            */


/* ================================================================================ */
/* ================        struct 'NT_PWM0' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_PWM0_TBCTL  ------------------------------- */
#define NT_PWM0_TBCTL_CTRMODE_Pos             0                                                       /*!< NT_PWM0 TBCTL: CTRMODE Position         */
#define NT_PWM0_TBCTL_CTRMODE_Msk             (0x03UL << NT_PWM0_TBCTL_CTRMODE_Pos)                   /*!< NT_PWM0 TBCTL: CTRMODE Mask             */
#define NT_PWM0_TBCTL_PHSEN_Pos               2                                                       /*!< NT_PWM0 TBCTL: PHSEN Position           */
#define NT_PWM0_TBCTL_PHSEN_Msk               (0x01UL << NT_PWM0_TBCTL_PHSEN_Pos)                     /*!< NT_PWM0 TBCTL: PHSEN Mask               */
#define NT_PWM0_TBCTL_PRDLD_Pos               3                                                       /*!< NT_PWM0 TBCTL: PRDLD Position           */
#define NT_PWM0_TBCTL_PRDLD_Msk               (0x01UL << NT_PWM0_TBCTL_PRDLD_Pos)                     /*!< NT_PWM0 TBCTL: PRDLD Mask               */
#define NT_PWM0_TBCTL_SYNCOSEL_Pos            4                                                       /*!< NT_PWM0 TBCTL: SYNCOSEL Position        */
#define NT_PWM0_TBCTL_SYNCOSEL_Msk            (0x03UL << NT_PWM0_TBCTL_SYNCOSEL_Pos)                  /*!< NT_PWM0 TBCTL: SYNCOSEL Mask            */
#define NT_PWM0_TBCTL_SWFSYNC_Pos             6                                                       /*!< NT_PWM0 TBCTL: SWFSYNC Position         */
#define NT_PWM0_TBCTL_SWFSYNC_Msk             (0x01UL << NT_PWM0_TBCTL_SWFSYNC_Pos)                   /*!< NT_PWM0 TBCTL: SWFSYNC Mask             */
#define NT_PWM0_TBCTL_HSPCLKDIV_Pos           7                                                       /*!< NT_PWM0 TBCTL: HSPCLKDIV Position       */
#define NT_PWM0_TBCTL_HSPCLKDIV_Msk           (0x07UL << NT_PWM0_TBCTL_HSPCLKDIV_Pos)                 /*!< NT_PWM0 TBCTL: HSPCLKDIV Mask           */
#define NT_PWM0_TBCTL_CLKDIV_Pos              10                                                      /*!< NT_PWM0 TBCTL: CLKDIV Position          */
#define NT_PWM0_TBCTL_CLKDIV_Msk              (0x07UL << NT_PWM0_TBCTL_CLKDIV_Pos)                    /*!< NT_PWM0 TBCTL: CLKDIV Mask              */
#define NT_PWM0_TBCTL_PHSDIR_Pos              13                                                      /*!< NT_PWM0 TBCTL: PHSDIR Position          */
#define NT_PWM0_TBCTL_PHSDIR_Msk              (0x01UL << NT_PWM0_TBCTL_PHSDIR_Pos)                    /*!< NT_PWM0 TBCTL: PHSDIR Mask              */
#define NT_PWM0_TBCTL_FREE_SOFT_Pos           14                                                      /*!< NT_PWM0 TBCTL: FREE_SOFT Position       */
#define NT_PWM0_TBCTL_FREE_SOFT_Msk           (0x03UL << NT_PWM0_TBCTL_FREE_SOFT_Pos)                 /*!< NT_PWM0 TBCTL: FREE_SOFT Mask           */

/* --------------------------------  NT_PWM0_TBSTS  ------------------------------- */
#define NT_PWM0_TBSTS_CTRDIR_Pos              0                                                       /*!< NT_PWM0 TBSTS: CTRDIR Position          */
#define NT_PWM0_TBSTS_CTRDIR_Msk              (0x01UL << NT_PWM0_TBSTS_CTRDIR_Pos)                    /*!< NT_PWM0 TBSTS: CTRDIR Mask              */
#define NT_PWM0_TBSTS_SYNCI_Pos               1                                                       /*!< NT_PWM0 TBSTS: SYNCI Position           */
#define NT_PWM0_TBSTS_SYNCI_Msk               (0x01UL << NT_PWM0_TBSTS_SYNCI_Pos)                     /*!< NT_PWM0 TBSTS: SYNCI Mask               */
#define NT_PWM0_TBSTS_CTRMAX_Pos              2                                                       /*!< NT_PWM0 TBSTS: CTRMAX Position          */
#define NT_PWM0_TBSTS_CTRMAX_Msk              (0x01UL << NT_PWM0_TBSTS_CTRMAX_Pos)                    /*!< NT_PWM0 TBSTS: CTRMAX Mask              */

/* --------------------------------  NT_PWM0_TBPHS  ------------------------------- */
#define NT_PWM0_TBPHS_TBPHSHR_Pos             8                                                       /*!< NT_PWM0 TBPHS: TBPHSHR Position         */
#define NT_PWM0_TBPHS_TBPHSHR_Msk             (0x000000ffUL << NT_PWM0_TBPHS_TBPHSHR_Pos)             /*!< NT_PWM0 TBPHS: TBPHSHR Mask             */
#define NT_PWM0_TBPHS_TBPHS_Pos               16                                                      /*!< NT_PWM0 TBPHS: TBPHS Position           */
#define NT_PWM0_TBPHS_TBPHS_Msk               (0x0000ffffUL << NT_PWM0_TBPHS_TBPHS_Pos)               /*!< NT_PWM0 TBPHS: TBPHS Mask               */

/* --------------------------------  NT_PWM0_TBCTR  ------------------------------- */
#define NT_PWM0_TBCTR_TBCTR_Pos               0                                                       /*!< NT_PWM0 TBCTR: TBCTR Position           */
#define NT_PWM0_TBCTR_TBCTR_Msk               (0x0000ffffUL << NT_PWM0_TBCTR_TBCTR_Pos)               /*!< NT_PWM0 TBCTR: TBCTR Mask               */

/* --------------------------------  NT_PWM0_TBPRD  ------------------------------- */
#define NT_PWM0_TBPRD_TBPRD_Pos               0                                                       /*!< NT_PWM0 TBPRD: TBPRD Position           */
#define NT_PWM0_TBPRD_TBPRD_Msk               (0x0000ffffUL << NT_PWM0_TBPRD_TBPRD_Pos)               /*!< NT_PWM0 TBPRD: TBPRD Mask               */

/* -------------------------------  NT_PWM0_CMPCTL  ------------------------------- */
#define NT_PWM0_CMPCTL_LOADAMODE_Pos          0                                                       /*!< NT_PWM0 CMPCTL: LOADAMODE Position      */
#define NT_PWM0_CMPCTL_LOADAMODE_Msk          (0x03UL << NT_PWM0_CMPCTL_LOADAMODE_Pos)                /*!< NT_PWM0 CMPCTL: LOADAMODE Mask          */
#define NT_PWM0_CMPCTL_LOADBMODE_Pos          2                                                       /*!< NT_PWM0 CMPCTL: LOADBMODE Position      */
#define NT_PWM0_CMPCTL_LOADBMODE_Msk          (0x03UL << NT_PWM0_CMPCTL_LOADBMODE_Pos)                /*!< NT_PWM0 CMPCTL: LOADBMODE Mask          */
#define NT_PWM0_CMPCTL_SHDWAMODE_Pos          4                                                       /*!< NT_PWM0 CMPCTL: SHDWAMODE Position      */
#define NT_PWM0_CMPCTL_SHDWAMODE_Msk          (0x01UL << NT_PWM0_CMPCTL_SHDWAMODE_Pos)                /*!< NT_PWM0 CMPCTL: SHDWAMODE Mask          */
#define NT_PWM0_CMPCTL_SHDWBMODE_Pos          6                                                       /*!< NT_PWM0 CMPCTL: SHDWBMODE Position      */
#define NT_PWM0_CMPCTL_SHDWBMODE_Msk          (0x01UL << NT_PWM0_CMPCTL_SHDWBMODE_Pos)                /*!< NT_PWM0 CMPCTL: SHDWBMODE Mask          */
#define NT_PWM0_CMPCTL_SHDWAFULL_Pos          8                                                       /*!< NT_PWM0 CMPCTL: SHDWAFULL Position      */
#define NT_PWM0_CMPCTL_SHDWAFULL_Msk          (0x01UL << NT_PWM0_CMPCTL_SHDWAFULL_Pos)                /*!< NT_PWM0 CMPCTL: SHDWAFULL Mask          */
#define NT_PWM0_CMPCTL_SHDWBFULL_Pos          9                                                       /*!< NT_PWM0 CMPCTL: SHDWBFULL Position      */
#define NT_PWM0_CMPCTL_SHDWBFULL_Msk          (0x01UL << NT_PWM0_CMPCTL_SHDWBFULL_Pos)                /*!< NT_PWM0 CMPCTL: SHDWBFULL Mask          */

/* --------------------------------  NT_PWM0_CMPA  -------------------------------- */
#define NT_PWM0_CMPA_CMPAHR_Pos               8                                                       /*!< NT_PWM0 CMPA: CMPAHR Position           */
#define NT_PWM0_CMPA_CMPAHR_Msk               (0x000000ffUL << NT_PWM0_CMPA_CMPAHR_Pos)               /*!< NT_PWM0 CMPA: CMPAHR Mask               */
#define NT_PWM0_CMPA_CMPA_Pos                 16                                                      /*!< NT_PWM0 CMPA: CMPA Position             */
#define NT_PWM0_CMPA_CMPA_Msk                 (0x0000ffffUL << NT_PWM0_CMPA_CMPA_Pos)                 /*!< NT_PWM0 CMPA: CMPA Mask                 */

/* --------------------------------  NT_PWM0_CMPB  -------------------------------- */
#define NT_PWM0_CMPB_CMPB_Pos                 16                                                      /*!< NT_PWM0 CMPB: CMPB Position             */
#define NT_PWM0_CMPB_CMPB_Msk                 (0x0000ffffUL << NT_PWM0_CMPB_CMPB_Pos)                 /*!< NT_PWM0 CMPB: CMPB Mask                 */

/* -------------------------------  NT_PWM0_AQCTLA  ------------------------------- */
#define NT_PWM0_AQCTLA_ZRO_Pos                0                                                       /*!< NT_PWM0 AQCTLA: ZRO Position            */
#define NT_PWM0_AQCTLA_ZRO_Msk                (0x03UL << NT_PWM0_AQCTLA_ZRO_Pos)                      /*!< NT_PWM0 AQCTLA: ZRO Mask                */
#define NT_PWM0_AQCTLA_PRD_Pos                2                                                       /*!< NT_PWM0 AQCTLA: PRD Position            */
#define NT_PWM0_AQCTLA_PRD_Msk                (0x03UL << NT_PWM0_AQCTLA_PRD_Pos)                      /*!< NT_PWM0 AQCTLA: PRD Mask                */
#define NT_PWM0_AQCTLA_CAU_Pos                4                                                       /*!< NT_PWM0 AQCTLA: CAU Position            */
#define NT_PWM0_AQCTLA_CAU_Msk                (0x03UL << NT_PWM0_AQCTLA_CAU_Pos)                      /*!< NT_PWM0 AQCTLA: CAU Mask                */
#define NT_PWM0_AQCTLA_CAD_Pos                6                                                       /*!< NT_PWM0 AQCTLA: CAD Position            */
#define NT_PWM0_AQCTLA_CAD_Msk                (0x03UL << NT_PWM0_AQCTLA_CAD_Pos)                      /*!< NT_PWM0 AQCTLA: CAD Mask                */
#define NT_PWM0_AQCTLA_CBU_Pos                8                                                       /*!< NT_PWM0 AQCTLA: CBU Position            */
#define NT_PWM0_AQCTLA_CBU_Msk                (0x03UL << NT_PWM0_AQCTLA_CBU_Pos)                      /*!< NT_PWM0 AQCTLA: CBU Mask                */
#define NT_PWM0_AQCTLA_CBD_Pos                10                                                      /*!< NT_PWM0 AQCTLA: CBD Position            */
#define NT_PWM0_AQCTLA_CBD_Msk                (0x03UL << NT_PWM0_AQCTLA_CBD_Pos)                      /*!< NT_PWM0 AQCTLA: CBD Mask                */

/* -------------------------------  NT_PWM0_AQCTLB  ------------------------------- */
#define NT_PWM0_AQCTLB_ZRO_Pos                0                                                       /*!< NT_PWM0 AQCTLB: ZRO Position            */
#define NT_PWM0_AQCTLB_ZRO_Msk                (0x03UL << NT_PWM0_AQCTLB_ZRO_Pos)                      /*!< NT_PWM0 AQCTLB: ZRO Mask                */
#define NT_PWM0_AQCTLB_PRD_Pos                2                                                       /*!< NT_PWM0 AQCTLB: PRD Position            */
#define NT_PWM0_AQCTLB_PRD_Msk                (0x03UL << NT_PWM0_AQCTLB_PRD_Pos)                      /*!< NT_PWM0 AQCTLB: PRD Mask                */
#define NT_PWM0_AQCTLB_CAU_Pos                4                                                       /*!< NT_PWM0 AQCTLB: CAU Position            */
#define NT_PWM0_AQCTLB_CAU_Msk                (0x03UL << NT_PWM0_AQCTLB_CAU_Pos)                      /*!< NT_PWM0 AQCTLB: CAU Mask                */
#define NT_PWM0_AQCTLB_CAD_Pos                6                                                       /*!< NT_PWM0 AQCTLB: CAD Position            */
#define NT_PWM0_AQCTLB_CAD_Msk                (0x03UL << NT_PWM0_AQCTLB_CAD_Pos)                      /*!< NT_PWM0 AQCTLB: CAD Mask                */
#define NT_PWM0_AQCTLB_CBU_Pos                8                                                       /*!< NT_PWM0 AQCTLB: CBU Position            */
#define NT_PWM0_AQCTLB_CBU_Msk                (0x03UL << NT_PWM0_AQCTLB_CBU_Pos)                      /*!< NT_PWM0 AQCTLB: CBU Mask                */
#define NT_PWM0_AQCTLB_CBD_Pos                10                                                      /*!< NT_PWM0 AQCTLB: CBD Position            */
#define NT_PWM0_AQCTLB_CBD_Msk                (0x03UL << NT_PWM0_AQCTLB_CBD_Pos)                      /*!< NT_PWM0 AQCTLB: CBD Mask                */

/* -------------------------------  NT_PWM0_AQSFRC  ------------------------------- */
#define NT_PWM0_AQSFRC_ACTSFA_Pos             0                                                       /*!< NT_PWM0 AQSFRC: ACTSFA Position         */
#define NT_PWM0_AQSFRC_ACTSFA_Msk             (0x03UL << NT_PWM0_AQSFRC_ACTSFA_Pos)                   /*!< NT_PWM0 AQSFRC: ACTSFA Mask             */
#define NT_PWM0_AQSFRC_OTSFA_Pos              2                                                       /*!< NT_PWM0 AQSFRC: OTSFA Position          */
#define NT_PWM0_AQSFRC_OTSFA_Msk              (0x01UL << NT_PWM0_AQSFRC_OTSFA_Pos)                    /*!< NT_PWM0 AQSFRC: OTSFA Mask              */
#define NT_PWM0_AQSFRC_ACTSFB_Pos             3                                                       /*!< NT_PWM0 AQSFRC: ACTSFB Position         */
#define NT_PWM0_AQSFRC_ACTSFB_Msk             (0x03UL << NT_PWM0_AQSFRC_ACTSFB_Pos)                   /*!< NT_PWM0 AQSFRC: ACTSFB Mask             */
#define NT_PWM0_AQSFRC_OTSFB_Pos              5                                                       /*!< NT_PWM0 AQSFRC: OTSFB Position          */
#define NT_PWM0_AQSFRC_OTSFB_Msk              (0x01UL << NT_PWM0_AQSFRC_OTSFB_Pos)                    /*!< NT_PWM0 AQSFRC: OTSFB Mask              */
#define NT_PWM0_AQSFRC_RLDCSF_Pos             6                                                       /*!< NT_PWM0 AQSFRC: RLDCSF Position         */
#define NT_PWM0_AQSFRC_RLDCSF_Msk             (0x03UL << NT_PWM0_AQSFRC_RLDCSF_Pos)                   /*!< NT_PWM0 AQSFRC: RLDCSF Mask             */

/* -------------------------------  NT_PWM0_AQCSFRC  ------------------------------ */
#define NT_PWM0_AQCSFRC_CSFA_Pos              0                                                       /*!< NT_PWM0 AQCSFRC: CSFA Position          */
#define NT_PWM0_AQCSFRC_CSFA_Msk              (0x03UL << NT_PWM0_AQCSFRC_CSFA_Pos)                    /*!< NT_PWM0 AQCSFRC: CSFA Mask              */
#define NT_PWM0_AQCSFRC_CSFB_Pos              2                                                       /*!< NT_PWM0 AQCSFRC: CSFB Position          */
#define NT_PWM0_AQCSFRC_CSFB_Msk              (0x03UL << NT_PWM0_AQCSFRC_CSFB_Pos)                    /*!< NT_PWM0 AQCSFRC: CSFB Mask              */

/* --------------------------------  NT_PWM0_DBCTL  ------------------------------- */
#define NT_PWM0_DBCTL_OUT_MODE_Pos            0                                                       /*!< NT_PWM0 DBCTL: OUT_MODE Position        */
#define NT_PWM0_DBCTL_OUT_MODE_Msk            (0x03UL << NT_PWM0_DBCTL_OUT_MODE_Pos)                  /*!< NT_PWM0 DBCTL: OUT_MODE Mask            */
#define NT_PWM0_DBCTL_POLSEL_Pos              2                                                       /*!< NT_PWM0 DBCTL: POLSEL Position          */
#define NT_PWM0_DBCTL_POLSEL_Msk              (0x03UL << NT_PWM0_DBCTL_POLSEL_Pos)                    /*!< NT_PWM0 DBCTL: POLSEL Mask              */
#define NT_PWM0_DBCTL_IN_MODE_Pos             4                                                       /*!< NT_PWM0 DBCTL: IN_MODE Position         */
#define NT_PWM0_DBCTL_IN_MODE_Msk             (0x03UL << NT_PWM0_DBCTL_IN_MODE_Pos)                   /*!< NT_PWM0 DBCTL: IN_MODE Mask             */

/* --------------------------------  NT_PWM0_DBRED  ------------------------------- */
#define NT_PWM0_DBRED_DEL_Pos                 0                                                       /*!< NT_PWM0 DBRED: DEL Position             */
#define NT_PWM0_DBRED_DEL_Msk                 (0x000003ffUL << NT_PWM0_DBRED_DEL_Pos)                 /*!< NT_PWM0 DBRED: DEL Mask                 */

/* --------------------------------  NT_PWM0_DBFED  ------------------------------- */
#define NT_PWM0_DBFED_DEL_Pos                 0                                                       /*!< NT_PWM0 DBFED: DEL Position             */
#define NT_PWM0_DBFED_DEL_Msk                 (0x000003ffUL << NT_PWM0_DBFED_DEL_Pos)                 /*!< NT_PWM0 DBFED: DEL Mask                 */

/* --------------------------------  NT_PWM0_TZSEL  ------------------------------- */
#define NT_PWM0_TZSEL_CBC0_Pos                0                                                       /*!< NT_PWM0 TZSEL: CBC0 Position            */
#define NT_PWM0_TZSEL_CBC0_Msk                (0x01UL << NT_PWM0_TZSEL_CBC0_Pos)                      /*!< NT_PWM0 TZSEL: CBC0 Mask                */
#define NT_PWM0_TZSEL_CBC1_Pos                1                                                       /*!< NT_PWM0 TZSEL: CBC1 Position            */
#define NT_PWM0_TZSEL_CBC1_Msk                (0x01UL << NT_PWM0_TZSEL_CBC1_Pos)                      /*!< NT_PWM0 TZSEL: CBC1 Mask                */
#define NT_PWM0_TZSEL_CBC2_Pos                2                                                       /*!< NT_PWM0 TZSEL: CBC2 Position            */
#define NT_PWM0_TZSEL_CBC2_Msk                (0x01UL << NT_PWM0_TZSEL_CBC2_Pos)                      /*!< NT_PWM0 TZSEL: CBC2 Mask                */
#define NT_PWM0_TZSEL_CBC3_Pos                3                                                       /*!< NT_PWM0 TZSEL: CBC3 Position            */
#define NT_PWM0_TZSEL_CBC3_Msk                (0x01UL << NT_PWM0_TZSEL_CBC3_Pos)                      /*!< NT_PWM0 TZSEL: CBC3 Mask                */
#define NT_PWM0_TZSEL_CBC4_Pos                4                                                       /*!< NT_PWM0 TZSEL: CBC4 Position            */
#define NT_PWM0_TZSEL_CBC4_Msk                (0x01UL << NT_PWM0_TZSEL_CBC4_Pos)                      /*!< NT_PWM0 TZSEL: CBC4 Mask                */
#define NT_PWM0_TZSEL_CBC5_Pos                5                                                       /*!< NT_PWM0 TZSEL: CBC5 Position            */
#define NT_PWM0_TZSEL_CBC5_Msk                (0x01UL << NT_PWM0_TZSEL_CBC5_Pos)                      /*!< NT_PWM0 TZSEL: CBC5 Mask                */
#define NT_PWM0_TZSEL_OSHT0_Pos               8                                                       /*!< NT_PWM0 TZSEL: OSHT0 Position           */
#define NT_PWM0_TZSEL_OSHT0_Msk               (0x01UL << NT_PWM0_TZSEL_OSHT0_Pos)                     /*!< NT_PWM0 TZSEL: OSHT0 Mask               */
#define NT_PWM0_TZSEL_OSHT1_Pos               9                                                       /*!< NT_PWM0 TZSEL: OSHT1 Position           */
#define NT_PWM0_TZSEL_OSHT1_Msk               (0x01UL << NT_PWM0_TZSEL_OSHT1_Pos)                     /*!< NT_PWM0 TZSEL: OSHT1 Mask               */
#define NT_PWM0_TZSEL_OSHT2_Pos               10                                                      /*!< NT_PWM0 TZSEL: OSHT2 Position           */
#define NT_PWM0_TZSEL_OSHT2_Msk               (0x01UL << NT_PWM0_TZSEL_OSHT2_Pos)                     /*!< NT_PWM0 TZSEL: OSHT2 Mask               */
#define NT_PWM0_TZSEL_OSHT3_Pos               11                                                      /*!< NT_PWM0 TZSEL: OSHT3 Position           */
#define NT_PWM0_TZSEL_OSHT3_Msk               (0x01UL << NT_PWM0_TZSEL_OSHT3_Pos)                     /*!< NT_PWM0 TZSEL: OSHT3 Mask               */
#define NT_PWM0_TZSEL_OSHT4_Pos               12                                                      /*!< NT_PWM0 TZSEL: OSHT4 Position           */
#define NT_PWM0_TZSEL_OSHT4_Msk               (0x01UL << NT_PWM0_TZSEL_OSHT4_Pos)                     /*!< NT_PWM0 TZSEL: OSHT4 Mask               */
#define NT_PWM0_TZSEL_OSHT5_Pos               13                                                      /*!< NT_PWM0 TZSEL: OSHT5 Position           */
#define NT_PWM0_TZSEL_OSHT5_Msk               (0x01UL << NT_PWM0_TZSEL_OSHT5_Pos)                     /*!< NT_PWM0 TZSEL: OSHT5 Mask               */

/* --------------------------------  NT_PWM0_TZCTL  ------------------------------- */
#define NT_PWM0_TZCTL_TZA_Pos                 0                                                       /*!< NT_PWM0 TZCTL: TZA Position             */
#define NT_PWM0_TZCTL_TZA_Msk                 (0x03UL << NT_PWM0_TZCTL_TZA_Pos)                       /*!< NT_PWM0 TZCTL: TZA Mask                 */
#define NT_PWM0_TZCTL_TZB_Pos                 2                                                       /*!< NT_PWM0 TZCTL: TZB Position             */
#define NT_PWM0_TZCTL_TZB_Msk                 (0x03UL << NT_PWM0_TZCTL_TZB_Pos)                       /*!< NT_PWM0 TZCTL: TZB Mask                 */

/* -------------------------------  NT_PWM0_TZEINT  ------------------------------- */
#define NT_PWM0_TZEINT_CBC_Pos                1                                                       /*!< NT_PWM0 TZEINT: CBC Position            */
#define NT_PWM0_TZEINT_CBC_Msk                (0x01UL << NT_PWM0_TZEINT_CBC_Pos)                      /*!< NT_PWM0 TZEINT: CBC Mask                */
#define NT_PWM0_TZEINT_OST_Pos                2                                                       /*!< NT_PWM0 TZEINT: OST Position            */
#define NT_PWM0_TZEINT_OST_Msk                (0x01UL << NT_PWM0_TZEINT_OST_Pos)                      /*!< NT_PWM0 TZEINT: OST Mask                */

/* --------------------------------  NT_PWM0_TZFLG  ------------------------------- */
#define NT_PWM0_TZFLG_INT_Pos                 0                                                       /*!< NT_PWM0 TZFLG: INT Position             */
#define NT_PWM0_TZFLG_INT_Msk                 (0x01UL << NT_PWM0_TZFLG_INT_Pos)                       /*!< NT_PWM0 TZFLG: INT Mask                 */
#define NT_PWM0_TZFLG_CBC_Pos                 1                                                       /*!< NT_PWM0 TZFLG: CBC Position             */
#define NT_PWM0_TZFLG_CBC_Msk                 (0x01UL << NT_PWM0_TZFLG_CBC_Pos)                       /*!< NT_PWM0 TZFLG: CBC Mask                 */
#define NT_PWM0_TZFLG_OST_Pos                 2                                                       /*!< NT_PWM0 TZFLG: OST Position             */
#define NT_PWM0_TZFLG_OST_Msk                 (0x01UL << NT_PWM0_TZFLG_OST_Pos)                       /*!< NT_PWM0 TZFLG: OST Mask                 */

/* --------------------------------  NT_PWM0_TZCLR  ------------------------------- */
#define NT_PWM0_TZCLR_INT_Pos                 0                                                       /*!< NT_PWM0 TZCLR: INT Position             */
#define NT_PWM0_TZCLR_INT_Msk                 (0x01UL << NT_PWM0_TZCLR_INT_Pos)                       /*!< NT_PWM0 TZCLR: INT Mask                 */
#define NT_PWM0_TZCLR_CBC_Pos                 1                                                       /*!< NT_PWM0 TZCLR: CBC Position             */
#define NT_PWM0_TZCLR_CBC_Msk                 (0x01UL << NT_PWM0_TZCLR_CBC_Pos)                       /*!< NT_PWM0 TZCLR: CBC Mask                 */
#define NT_PWM0_TZCLR_OST_Pos                 2                                                       /*!< NT_PWM0 TZCLR: OST Position             */
#define NT_PWM0_TZCLR_OST_Msk                 (0x01UL << NT_PWM0_TZCLR_OST_Pos)                       /*!< NT_PWM0 TZCLR: OST Mask                 */

/* --------------------------------  NT_PWM0_TZFRC  ------------------------------- */
#define NT_PWM0_TZFRC_CBC_Pos                 1                                                       /*!< NT_PWM0 TZFRC: CBC Position             */
#define NT_PWM0_TZFRC_CBC_Msk                 (0x01UL << NT_PWM0_TZFRC_CBC_Pos)                       /*!< NT_PWM0 TZFRC: CBC Mask                 */
#define NT_PWM0_TZFRC_OST_Pos                 2                                                       /*!< NT_PWM0 TZFRC: OST Position             */
#define NT_PWM0_TZFRC_OST_Msk                 (0x01UL << NT_PWM0_TZFRC_OST_Pos)                       /*!< NT_PWM0 TZFRC: OST Mask                 */

/* --------------------------------  NT_PWM0_ETSEL  ------------------------------- */
#define NT_PWM0_ETSEL_INTSEL_Pos              0                                                       /*!< NT_PWM0 ETSEL: INTSEL Position          */
#define NT_PWM0_ETSEL_INTSEL_Msk              (0x07UL << NT_PWM0_ETSEL_INTSEL_Pos)                    /*!< NT_PWM0 ETSEL: INTSEL Mask              */
#define NT_PWM0_ETSEL_INTEN_Pos               3                                                       /*!< NT_PWM0 ETSEL: INTEN Position           */
#define NT_PWM0_ETSEL_INTEN_Msk               (0x01UL << NT_PWM0_ETSEL_INTEN_Pos)                     /*!< NT_PWM0 ETSEL: INTEN Mask               */
#define NT_PWM0_ETSEL_SOCASEL_Pos             8                                                       /*!< NT_PWM0 ETSEL: SOCASEL Position         */
#define NT_PWM0_ETSEL_SOCASEL_Msk             (0x07UL << NT_PWM0_ETSEL_SOCASEL_Pos)                   /*!< NT_PWM0 ETSEL: SOCASEL Mask             */
#define NT_PWM0_ETSEL_SOCAEN_Pos              11                                                      /*!< NT_PWM0 ETSEL: SOCAEN Position          */
#define NT_PWM0_ETSEL_SOCAEN_Msk              (0x01UL << NT_PWM0_ETSEL_SOCAEN_Pos)                    /*!< NT_PWM0 ETSEL: SOCAEN Mask              */
#define NT_PWM0_ETSEL_SOCBSEL_Pos             12                                                      /*!< NT_PWM0 ETSEL: SOCBSEL Position         */
#define NT_PWM0_ETSEL_SOCBSEL_Msk             (0x07UL << NT_PWM0_ETSEL_SOCBSEL_Pos)                   /*!< NT_PWM0 ETSEL: SOCBSEL Mask             */
#define NT_PWM0_ETSEL_SOCBEN_Pos              15                                                      /*!< NT_PWM0 ETSEL: SOCBEN Position          */
#define NT_PWM0_ETSEL_SOCBEN_Msk              (0x01UL << NT_PWM0_ETSEL_SOCBEN_Pos)                    /*!< NT_PWM0 ETSEL: SOCBEN Mask              */

/* --------------------------------  NT_PWM0_ETPS  -------------------------------- */
#define NT_PWM0_ETPS_INTPRD_Pos               0                                                       /*!< NT_PWM0 ETPS: INTPRD Position           */
#define NT_PWM0_ETPS_INTPRD_Msk               (0x03UL << NT_PWM0_ETPS_INTPRD_Pos)                     /*!< NT_PWM0 ETPS: INTPRD Mask               */
#define NT_PWM0_ETPS_INTCNT_Pos               2                                                       /*!< NT_PWM0 ETPS: INTCNT Position           */
#define NT_PWM0_ETPS_INTCNT_Msk               (0x03UL << NT_PWM0_ETPS_INTCNT_Pos)                     /*!< NT_PWM0 ETPS: INTCNT Mask               */
#define NT_PWM0_ETPS_SOCAPRD_Pos              8                                                       /*!< NT_PWM0 ETPS: SOCAPRD Position          */
#define NT_PWM0_ETPS_SOCAPRD_Msk              (0x03UL << NT_PWM0_ETPS_SOCAPRD_Pos)                    /*!< NT_PWM0 ETPS: SOCAPRD Mask              */
#define NT_PWM0_ETPS_SOCACNT_Pos              10                                                      /*!< NT_PWM0 ETPS: SOCACNT Position          */
#define NT_PWM0_ETPS_SOCACNT_Msk              (0x03UL << NT_PWM0_ETPS_SOCACNT_Pos)                    /*!< NT_PWM0 ETPS: SOCACNT Mask              */
#define NT_PWM0_ETPS_SOCPRD_Pos               12                                                      /*!< NT_PWM0 ETPS: SOCPRD Position           */
#define NT_PWM0_ETPS_SOCPRD_Msk               (0x03UL << NT_PWM0_ETPS_SOCPRD_Pos)                     /*!< NT_PWM0 ETPS: SOCPRD Mask               */
#define NT_PWM0_ETPS_SOCBCNT_Pos              14                                                      /*!< NT_PWM0 ETPS: SOCBCNT Position          */
#define NT_PWM0_ETPS_SOCBCNT_Msk              (0x03UL << NT_PWM0_ETPS_SOCBCNT_Pos)                    /*!< NT_PWM0 ETPS: SOCBCNT Mask              */

/* --------------------------------  NT_PWM0_ETFLG  ------------------------------- */
#define NT_PWM0_ETFLG_INT_Pos                 0                                                       /*!< NT_PWM0 ETFLG: INT Position             */
#define NT_PWM0_ETFLG_INT_Msk                 (0x01UL << NT_PWM0_ETFLG_INT_Pos)                       /*!< NT_PWM0 ETFLG: INT Mask                 */
#define NT_PWM0_ETFLG_SOCA_Pos                2                                                       /*!< NT_PWM0 ETFLG: SOCA Position            */
#define NT_PWM0_ETFLG_SOCA_Msk                (0x01UL << NT_PWM0_ETFLG_SOCA_Pos)                      /*!< NT_PWM0 ETFLG: SOCA Mask                */
#define NT_PWM0_ETFLG_SOCB_Pos                3                                                       /*!< NT_PWM0 ETFLG: SOCB Position            */
#define NT_PWM0_ETFLG_SOCB_Msk                (0x01UL << NT_PWM0_ETFLG_SOCB_Pos)                      /*!< NT_PWM0 ETFLG: SOCB Mask                */

/* --------------------------------  NT_PWM0_ETCLR  ------------------------------- */
#define NT_PWM0_ETCLR_INT_Pos                 0                                                       /*!< NT_PWM0 ETCLR: INT Position             */
#define NT_PWM0_ETCLR_INT_Msk                 (0x01UL << NT_PWM0_ETCLR_INT_Pos)                       /*!< NT_PWM0 ETCLR: INT Mask                 */
#define NT_PWM0_ETCLR_SOCA_Pos                2                                                       /*!< NT_PWM0 ETCLR: SOCA Position            */
#define NT_PWM0_ETCLR_SOCA_Msk                (0x01UL << NT_PWM0_ETCLR_SOCA_Pos)                      /*!< NT_PWM0 ETCLR: SOCA Mask                */
#define NT_PWM0_ETCLR_SOCB_Pos                3                                                       /*!< NT_PWM0 ETCLR: SOCB Position            */
#define NT_PWM0_ETCLR_SOCB_Msk                (0x01UL << NT_PWM0_ETCLR_SOCB_Pos)                      /*!< NT_PWM0 ETCLR: SOCB Mask                */

/* --------------------------------  NT_PWM0_ETFRC  ------------------------------- */
#define NT_PWM0_ETFRC_INT_Pos                 0                                                       /*!< NT_PWM0 ETFRC: INT Position             */
#define NT_PWM0_ETFRC_INT_Msk                 (0x01UL << NT_PWM0_ETFRC_INT_Pos)                       /*!< NT_PWM0 ETFRC: INT Mask                 */
#define NT_PWM0_ETFRC_SOCA_Pos                2                                                       /*!< NT_PWM0 ETFRC: SOCA Position            */
#define NT_PWM0_ETFRC_SOCA_Msk                (0x01UL << NT_PWM0_ETFRC_SOCA_Pos)                      /*!< NT_PWM0 ETFRC: SOCA Mask                */
#define NT_PWM0_ETFRC_SOCB_Pos                3                                                       /*!< NT_PWM0 ETFRC: SOCB Position            */
#define NT_PWM0_ETFRC_SOCB_Msk                (0x01UL << NT_PWM0_ETFRC_SOCB_Pos)                      /*!< NT_PWM0 ETFRC: SOCB Mask                */

/* --------------------------------  NT_PWM0_PCCTL  ------------------------------- */
#define NT_PWM0_PCCTL_CHPEN_Pos               0                                                       /*!< NT_PWM0 PCCTL: CHPEN Position           */
#define NT_PWM0_PCCTL_CHPEN_Msk               (0x01UL << NT_PWM0_PCCTL_CHPEN_Pos)                     /*!< NT_PWM0 PCCTL: CHPEN Mask               */
#define NT_PWM0_PCCTL_OSHTWTH_Pos             1                                                       /*!< NT_PWM0 PCCTL: OSHTWTH Position         */
#define NT_PWM0_PCCTL_OSHTWTH_Msk             (0x0fUL << NT_PWM0_PCCTL_OSHTWTH_Pos)                   /*!< NT_PWM0 PCCTL: OSHTWTH Mask             */
#define NT_PWM0_PCCTL_SHRFREQ_Pos             5                                                       /*!< NT_PWM0 PCCTL: SHRFREQ Position         */
#define NT_PWM0_PCCTL_SHRFREQ_Msk             (0x07UL << NT_PWM0_PCCTL_SHRFREQ_Pos)                   /*!< NT_PWM0 PCCTL: SHRFREQ Mask             */
#define NT_PWM0_PCCTL_CHPDUTY_Pos             8                                                       /*!< NT_PWM0 PCCTL: CHPDUTY Position         */
#define NT_PWM0_PCCTL_CHPDUTY_Msk             (0x07UL << NT_PWM0_PCCTL_CHPDUTY_Pos)                   /*!< NT_PWM0 PCCTL: CHPDUTY Mask             */

/* -------------------------------  NT_PWM0_HRCNFG  ------------------------------- */
#define NT_PWM0_HRCNFG_EDGMODE_Pos            0                                                       /*!< NT_PWM0 HRCNFG: EDGMODE Position        */
#define NT_PWM0_HRCNFG_EDGMODE_Msk            (0x03UL << NT_PWM0_HRCNFG_EDGMODE_Pos)                  /*!< NT_PWM0 HRCNFG: EDGMODE Mask            */
#define NT_PWM0_HRCNFG_CTLMODE_Pos            2                                                       /*!< NT_PWM0 HRCNFG: CTLMODE Position        */
#define NT_PWM0_HRCNFG_CTLMODE_Msk            (0x01UL << NT_PWM0_HRCNFG_CTLMODE_Pos)                  /*!< NT_PWM0 HRCNFG: CTLMODE Mask            */
#define NT_PWM0_HRCNFG_HR_LOAD_Pos            3                                                       /*!< NT_PWM0 HRCNFG: HR_LOAD Position        */
#define NT_PWM0_HRCNFG_HR_LOAD_Msk            (0x01UL << NT_PWM0_HRCNFG_HR_LOAD_Pos)                  /*!< NT_PWM0 HRCNFG: HR_LOAD Mask            */
#define NT_PWM0_HRCNFG_MEP_SCALEFACTOR_Pos    16                                                      /*!< NT_PWM0 HRCNFG: MEP_SCALEFACTOR Position */
#define NT_PWM0_HRCNFG_MEP_SCALEFACTOR_Msk    (0x000000ffUL << NT_PWM0_HRCNFG_MEP_SCALEFACTOR_Pos)    /*!< NT_PWM0 HRCNFG: MEP_SCALEFACTOR Mask    */

/* --------------------------------  NT_PWM0_FWDTH  ------------------------------- */
#define NT_PWM0_FWDTH_FWDTH_Pos               0                                                       /*!< NT_PWM0 FWDTH: FWDTH Position           */
#define NT_PWM0_FWDTH_FWDTH_Msk               (0x000000ffUL << NT_PWM0_FWDTH_FWDTH_Pos)               /*!< NT_PWM0 FWDTH: FWDTH Mask               */

/* --------------------------------  NT_PWM0_HDSEL  ------------------------------- */
#define NT_PWM0_HDSEL_DCMP_Pos                0                                                       /*!< NT_PWM0 HDSEL: DCMP Position            */
#define NT_PWM0_HDSEL_DCMP_Msk                (0x00ffffffUL << NT_PWM0_HDSEL_DCMP_Pos)                /*!< NT_PWM0 HDSEL: DCMP Mask                */
#define NT_PWM0_HDSEL_ACMP_Pos                24                                                      /*!< NT_PWM0 HDSEL: ACMP Position            */
#define NT_PWM0_HDSEL_ACMP_Msk                (0x07UL << NT_PWM0_HDSEL_ACMP_Pos)                      /*!< NT_PWM0 HDSEL: ACMP Mask                */

/* --------------------------------  NT_PWM0_HDCTL  ------------------------------- */
#define NT_PWM0_HDCTL_HDA_Pos                 0                                                       /*!< NT_PWM0 HDCTL: HDA Position             */
#define NT_PWM0_HDCTL_HDA_Msk                 (0x03UL << NT_PWM0_HDCTL_HDA_Pos)                       /*!< NT_PWM0 HDCTL: HDA Mask                 */
#define NT_PWM0_HDCTL_HDB_Pos                 2                                                       /*!< NT_PWM0 HDCTL: HDB Position             */
#define NT_PWM0_HDCTL_HDB_Msk                 (0x03UL << NT_PWM0_HDCTL_HDB_Pos)                       /*!< NT_PWM0 HDCTL: HDB Mask                 */

/* -------------------------------  NT_PWM0_HDEINT  ------------------------------- */
#define NT_PWM0_HDEINT_CBC_Pos                1                                                       /*!< NT_PWM0 HDEINT: CBC Position            */
#define NT_PWM0_HDEINT_CBC_Msk                (0x01UL << NT_PWM0_HDEINT_CBC_Pos)                      /*!< NT_PWM0 HDEINT: CBC Mask                */
#define NT_PWM0_HDEINT_OST_Pos                2                                                       /*!< NT_PWM0 HDEINT: OST Position            */
#define NT_PWM0_HDEINT_OST_Msk                (0x01UL << NT_PWM0_HDEINT_OST_Pos)                      /*!< NT_PWM0 HDEINT: OST Mask                */

/* --------------------------------  NT_PWM0_HDFLG  ------------------------------- */
#define NT_PWM0_HDFLG_HDINT_Pos               0                                                       /*!< NT_PWM0 HDFLG: HDINT Position           */
#define NT_PWM0_HDFLG_HDINT_Msk               (0x01UL << NT_PWM0_HDFLG_HDINT_Pos)                     /*!< NT_PWM0 HDFLG: HDINT Mask               */
#define NT_PWM0_HDFLG_CBC_Pos                 1                                                       /*!< NT_PWM0 HDFLG: CBC Position             */
#define NT_PWM0_HDFLG_CBC_Msk                 (0x01UL << NT_PWM0_HDFLG_CBC_Pos)                       /*!< NT_PWM0 HDFLG: CBC Mask                 */
#define NT_PWM0_HDFLG_OST_Pos                 2                                                       /*!< NT_PWM0 HDFLG: OST Position             */
#define NT_PWM0_HDFLG_OST_Msk                 (0x01UL << NT_PWM0_HDFLG_OST_Pos)                       /*!< NT_PWM0 HDFLG: OST Mask                 */

/* --------------------------------  NT_PWM0_HDCLR  ------------------------------- */
#define NT_PWM0_HDCLR_HDINT_Pos               0                                                       /*!< NT_PWM0 HDCLR: HDINT Position           */
#define NT_PWM0_HDCLR_HDINT_Msk               (0x01UL << NT_PWM0_HDCLR_HDINT_Pos)                     /*!< NT_PWM0 HDCLR: HDINT Mask               */

/* --------------------------------  NT_PWM0_HDFRC  ------------------------------- */
#define NT_PWM0_HDFRC_CBC_Pos                 1                                                       /*!< NT_PWM0 HDFRC: CBC Position             */
#define NT_PWM0_HDFRC_CBC_Msk                 (0x01UL << NT_PWM0_HDFRC_CBC_Pos)                       /*!< NT_PWM0 HDFRC: CBC Mask                 */
#define NT_PWM0_HDFRC_OST_Pos                 2                                                       /*!< NT_PWM0 HDFRC: OST Position             */
#define NT_PWM0_HDFRC_OST_Msk                 (0x01UL << NT_PWM0_HDFRC_OST_Pos)                       /*!< NT_PWM0 HDFRC: OST Mask                 */

/* ------------------------------  NT_PWM0_HDINTCLR  ------------------------------ */
#define NT_PWM0_HDINTCLR_HDINT_Pos            0                                                       /*!< NT_PWM0 HDINTCLR: HDINT Position        */
#define NT_PWM0_HDINTCLR_HDINT_Msk            (0x01UL << NT_PWM0_HDINTCLR_HDINT_Pos)                  /*!< NT_PWM0 HDINTCLR: HDINT Mask            */

/* ------------------------------  NT_PWM0_TZINTCLR  ------------------------------ */
#define NT_PWM0_TZINTCLR_TZINT_Pos            0                                                       /*!< NT_PWM0 TZINTCLR: TZINT Position        */
#define NT_PWM0_TZINTCLR_TZINT_Msk            (0x01UL << NT_PWM0_TZINTCLR_TZINT_Pos)                  /*!< NT_PWM0 TZINTCLR: TZINT Mask            */

/* -------------------------------  NT_PWM0_INTCLR  ------------------------------- */
#define NT_PWM0_INTCLR_INT_Pos                0                                                       /*!< NT_PWM0 INTCLR: INT Position            */
#define NT_PWM0_INTCLR_INT_Msk                (0x01UL << NT_PWM0_INTCLR_INT_Pos)                      /*!< NT_PWM0 INTCLR: INT Mask                */


/* ================================================================================ */
/* ================        struct 'NT_PWM1' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_PWM1_TBCTL  ------------------------------- */
#define NT_PWM1_TBCTL_CTRMODE_Pos             0                                                       /*!< NT_PWM1 TBCTL: CTRMODE Position         */
#define NT_PWM1_TBCTL_CTRMODE_Msk             (0x03UL << NT_PWM1_TBCTL_CTRMODE_Pos)                   /*!< NT_PWM1 TBCTL: CTRMODE Mask             */
#define NT_PWM1_TBCTL_PHSEN_Pos               2                                                       /*!< NT_PWM1 TBCTL: PHSEN Position           */
#define NT_PWM1_TBCTL_PHSEN_Msk               (0x01UL << NT_PWM1_TBCTL_PHSEN_Pos)                     /*!< NT_PWM1 TBCTL: PHSEN Mask               */
#define NT_PWM1_TBCTL_PRDLD_Pos               3                                                       /*!< NT_PWM1 TBCTL: PRDLD Position           */
#define NT_PWM1_TBCTL_PRDLD_Msk               (0x01UL << NT_PWM1_TBCTL_PRDLD_Pos)                     /*!< NT_PWM1 TBCTL: PRDLD Mask               */
#define NT_PWM1_TBCTL_SYNCOSEL_Pos            4                                                       /*!< NT_PWM1 TBCTL: SYNCOSEL Position        */
#define NT_PWM1_TBCTL_SYNCOSEL_Msk            (0x03UL << NT_PWM1_TBCTL_SYNCOSEL_Pos)                  /*!< NT_PWM1 TBCTL: SYNCOSEL Mask            */
#define NT_PWM1_TBCTL_SWFSYNC_Pos             6                                                       /*!< NT_PWM1 TBCTL: SWFSYNC Position         */
#define NT_PWM1_TBCTL_SWFSYNC_Msk             (0x01UL << NT_PWM1_TBCTL_SWFSYNC_Pos)                   /*!< NT_PWM1 TBCTL: SWFSYNC Mask             */
#define NT_PWM1_TBCTL_HSPCLKDIV_Pos           7                                                       /*!< NT_PWM1 TBCTL: HSPCLKDIV Position       */
#define NT_PWM1_TBCTL_HSPCLKDIV_Msk           (0x07UL << NT_PWM1_TBCTL_HSPCLKDIV_Pos)                 /*!< NT_PWM1 TBCTL: HSPCLKDIV Mask           */
#define NT_PWM1_TBCTL_CLKDIV_Pos              10                                                      /*!< NT_PWM1 TBCTL: CLKDIV Position          */
#define NT_PWM1_TBCTL_CLKDIV_Msk              (0x07UL << NT_PWM1_TBCTL_CLKDIV_Pos)                    /*!< NT_PWM1 TBCTL: CLKDIV Mask              */
#define NT_PWM1_TBCTL_PHSDIR_Pos              13                                                      /*!< NT_PWM1 TBCTL: PHSDIR Position          */
#define NT_PWM1_TBCTL_PHSDIR_Msk              (0x01UL << NT_PWM1_TBCTL_PHSDIR_Pos)                    /*!< NT_PWM1 TBCTL: PHSDIR Mask              */
#define NT_PWM1_TBCTL_FREE_SOFT_Pos           14                                                      /*!< NT_PWM1 TBCTL: FREE_SOFT Position       */
#define NT_PWM1_TBCTL_FREE_SOFT_Msk           (0x03UL << NT_PWM1_TBCTL_FREE_SOFT_Pos)                 /*!< NT_PWM1 TBCTL: FREE_SOFT Mask           */

/* --------------------------------  NT_PWM1_TBSTS  ------------------------------- */
#define NT_PWM1_TBSTS_CTRDIR_Pos              0                                                       /*!< NT_PWM1 TBSTS: CTRDIR Position          */
#define NT_PWM1_TBSTS_CTRDIR_Msk              (0x01UL << NT_PWM1_TBSTS_CTRDIR_Pos)                    /*!< NT_PWM1 TBSTS: CTRDIR Mask              */
#define NT_PWM1_TBSTS_SYNCI_Pos               1                                                       /*!< NT_PWM1 TBSTS: SYNCI Position           */
#define NT_PWM1_TBSTS_SYNCI_Msk               (0x01UL << NT_PWM1_TBSTS_SYNCI_Pos)                     /*!< NT_PWM1 TBSTS: SYNCI Mask               */
#define NT_PWM1_TBSTS_CTRMAX_Pos              2                                                       /*!< NT_PWM1 TBSTS: CTRMAX Position          */
#define NT_PWM1_TBSTS_CTRMAX_Msk              (0x01UL << NT_PWM1_TBSTS_CTRMAX_Pos)                    /*!< NT_PWM1 TBSTS: CTRMAX Mask              */

/* --------------------------------  NT_PWM1_TBPHS  ------------------------------- */
#define NT_PWM1_TBPHS_TBPHSHR_Pos             8                                                       /*!< NT_PWM1 TBPHS: TBPHSHR Position         */
#define NT_PWM1_TBPHS_TBPHSHR_Msk             (0x000000ffUL << NT_PWM1_TBPHS_TBPHSHR_Pos)             /*!< NT_PWM1 TBPHS: TBPHSHR Mask             */
#define NT_PWM1_TBPHS_TBPHS_Pos               16                                                      /*!< NT_PWM1 TBPHS: TBPHS Position           */
#define NT_PWM1_TBPHS_TBPHS_Msk               (0x0000ffffUL << NT_PWM1_TBPHS_TBPHS_Pos)               /*!< NT_PWM1 TBPHS: TBPHS Mask               */

/* --------------------------------  NT_PWM1_TBCTR  ------------------------------- */
#define NT_PWM1_TBCTR_TBCTR_Pos               0                                                       /*!< NT_PWM1 TBCTR: TBCTR Position           */
#define NT_PWM1_TBCTR_TBCTR_Msk               (0x0000ffffUL << NT_PWM1_TBCTR_TBCTR_Pos)               /*!< NT_PWM1 TBCTR: TBCTR Mask               */

/* --------------------------------  NT_PWM1_TBPRD  ------------------------------- */
#define NT_PWM1_TBPRD_TBPRD_Pos               0                                                       /*!< NT_PWM1 TBPRD: TBPRD Position           */
#define NT_PWM1_TBPRD_TBPRD_Msk               (0x0000ffffUL << NT_PWM1_TBPRD_TBPRD_Pos)               /*!< NT_PWM1 TBPRD: TBPRD Mask               */

/* -------------------------------  NT_PWM1_CMPCTL  ------------------------------- */
#define NT_PWM1_CMPCTL_LOADAMODE_Pos          0                                                       /*!< NT_PWM1 CMPCTL: LOADAMODE Position      */
#define NT_PWM1_CMPCTL_LOADAMODE_Msk          (0x03UL << NT_PWM1_CMPCTL_LOADAMODE_Pos)                /*!< NT_PWM1 CMPCTL: LOADAMODE Mask          */
#define NT_PWM1_CMPCTL_LOADBMODE_Pos          2                                                       /*!< NT_PWM1 CMPCTL: LOADBMODE Position      */
#define NT_PWM1_CMPCTL_LOADBMODE_Msk          (0x03UL << NT_PWM1_CMPCTL_LOADBMODE_Pos)                /*!< NT_PWM1 CMPCTL: LOADBMODE Mask          */
#define NT_PWM1_CMPCTL_SHDWAMODE_Pos          4                                                       /*!< NT_PWM1 CMPCTL: SHDWAMODE Position      */
#define NT_PWM1_CMPCTL_SHDWAMODE_Msk          (0x01UL << NT_PWM1_CMPCTL_SHDWAMODE_Pos)                /*!< NT_PWM1 CMPCTL: SHDWAMODE Mask          */
#define NT_PWM1_CMPCTL_SHDWBMODE_Pos          6                                                       /*!< NT_PWM1 CMPCTL: SHDWBMODE Position      */
#define NT_PWM1_CMPCTL_SHDWBMODE_Msk          (0x01UL << NT_PWM1_CMPCTL_SHDWBMODE_Pos)                /*!< NT_PWM1 CMPCTL: SHDWBMODE Mask          */
#define NT_PWM1_CMPCTL_SHDWAFULL_Pos          8                                                       /*!< NT_PWM1 CMPCTL: SHDWAFULL Position      */
#define NT_PWM1_CMPCTL_SHDWAFULL_Msk          (0x01UL << NT_PWM1_CMPCTL_SHDWAFULL_Pos)                /*!< NT_PWM1 CMPCTL: SHDWAFULL Mask          */
#define NT_PWM1_CMPCTL_SHDWBFULL_Pos          9                                                       /*!< NT_PWM1 CMPCTL: SHDWBFULL Position      */
#define NT_PWM1_CMPCTL_SHDWBFULL_Msk          (0x01UL << NT_PWM1_CMPCTL_SHDWBFULL_Pos)                /*!< NT_PWM1 CMPCTL: SHDWBFULL Mask          */

/* --------------------------------  NT_PWM1_CMPA  -------------------------------- */
#define NT_PWM1_CMPA_CMPAHR_Pos               8                                                       /*!< NT_PWM1 CMPA: CMPAHR Position           */
#define NT_PWM1_CMPA_CMPAHR_Msk               (0x000000ffUL << NT_PWM1_CMPA_CMPAHR_Pos)               /*!< NT_PWM1 CMPA: CMPAHR Mask               */
#define NT_PWM1_CMPA_CMPA_Pos                 16                                                      /*!< NT_PWM1 CMPA: CMPA Position             */
#define NT_PWM1_CMPA_CMPA_Msk                 (0x0000ffffUL << NT_PWM1_CMPA_CMPA_Pos)                 /*!< NT_PWM1 CMPA: CMPA Mask                 */

/* --------------------------------  NT_PWM1_CMPB  -------------------------------- */
#define NT_PWM1_CMPB_CMPB_Pos                 16                                                      /*!< NT_PWM1 CMPB: CMPB Position             */
#define NT_PWM1_CMPB_CMPB_Msk                 (0x0000ffffUL << NT_PWM1_CMPB_CMPB_Pos)                 /*!< NT_PWM1 CMPB: CMPB Mask                 */

/* -------------------------------  NT_PWM1_AQCTLA  ------------------------------- */
#define NT_PWM1_AQCTLA_ZRO_Pos                0                                                       /*!< NT_PWM1 AQCTLA: ZRO Position            */
#define NT_PWM1_AQCTLA_ZRO_Msk                (0x03UL << NT_PWM1_AQCTLA_ZRO_Pos)                      /*!< NT_PWM1 AQCTLA: ZRO Mask                */
#define NT_PWM1_AQCTLA_PRD_Pos                2                                                       /*!< NT_PWM1 AQCTLA: PRD Position            */
#define NT_PWM1_AQCTLA_PRD_Msk                (0x03UL << NT_PWM1_AQCTLA_PRD_Pos)                      /*!< NT_PWM1 AQCTLA: PRD Mask                */
#define NT_PWM1_AQCTLA_CAU_Pos                4                                                       /*!< NT_PWM1 AQCTLA: CAU Position            */
#define NT_PWM1_AQCTLA_CAU_Msk                (0x03UL << NT_PWM1_AQCTLA_CAU_Pos)                      /*!< NT_PWM1 AQCTLA: CAU Mask                */
#define NT_PWM1_AQCTLA_CAD_Pos                6                                                       /*!< NT_PWM1 AQCTLA: CAD Position            */
#define NT_PWM1_AQCTLA_CAD_Msk                (0x03UL << NT_PWM1_AQCTLA_CAD_Pos)                      /*!< NT_PWM1 AQCTLA: CAD Mask                */
#define NT_PWM1_AQCTLA_CBU_Pos                8                                                       /*!< NT_PWM1 AQCTLA: CBU Position            */
#define NT_PWM1_AQCTLA_CBU_Msk                (0x03UL << NT_PWM1_AQCTLA_CBU_Pos)                      /*!< NT_PWM1 AQCTLA: CBU Mask                */
#define NT_PWM1_AQCTLA_CBD_Pos                10                                                      /*!< NT_PWM1 AQCTLA: CBD Position            */
#define NT_PWM1_AQCTLA_CBD_Msk                (0x03UL << NT_PWM1_AQCTLA_CBD_Pos)                      /*!< NT_PWM1 AQCTLA: CBD Mask                */

/* -------------------------------  NT_PWM1_AQCTLB  ------------------------------- */
#define NT_PWM1_AQCTLB_ZRO_Pos                0                                                       /*!< NT_PWM1 AQCTLB: ZRO Position            */
#define NT_PWM1_AQCTLB_ZRO_Msk                (0x03UL << NT_PWM1_AQCTLB_ZRO_Pos)                      /*!< NT_PWM1 AQCTLB: ZRO Mask                */
#define NT_PWM1_AQCTLB_PRD_Pos                2                                                       /*!< NT_PWM1 AQCTLB: PRD Position            */
#define NT_PWM1_AQCTLB_PRD_Msk                (0x03UL << NT_PWM1_AQCTLB_PRD_Pos)                      /*!< NT_PWM1 AQCTLB: PRD Mask                */
#define NT_PWM1_AQCTLB_CAU_Pos                4                                                       /*!< NT_PWM1 AQCTLB: CAU Position            */
#define NT_PWM1_AQCTLB_CAU_Msk                (0x03UL << NT_PWM1_AQCTLB_CAU_Pos)                      /*!< NT_PWM1 AQCTLB: CAU Mask                */
#define NT_PWM1_AQCTLB_CAD_Pos                6                                                       /*!< NT_PWM1 AQCTLB: CAD Position            */
#define NT_PWM1_AQCTLB_CAD_Msk                (0x03UL << NT_PWM1_AQCTLB_CAD_Pos)                      /*!< NT_PWM1 AQCTLB: CAD Mask                */
#define NT_PWM1_AQCTLB_CBU_Pos                8                                                       /*!< NT_PWM1 AQCTLB: CBU Position            */
#define NT_PWM1_AQCTLB_CBU_Msk                (0x03UL << NT_PWM1_AQCTLB_CBU_Pos)                      /*!< NT_PWM1 AQCTLB: CBU Mask                */
#define NT_PWM1_AQCTLB_CBD_Pos                10                                                      /*!< NT_PWM1 AQCTLB: CBD Position            */
#define NT_PWM1_AQCTLB_CBD_Msk                (0x03UL << NT_PWM1_AQCTLB_CBD_Pos)                      /*!< NT_PWM1 AQCTLB: CBD Mask                */

/* -------------------------------  NT_PWM1_AQSFRC  ------------------------------- */
#define NT_PWM1_AQSFRC_ACTSFA_Pos             0                                                       /*!< NT_PWM1 AQSFRC: ACTSFA Position         */
#define NT_PWM1_AQSFRC_ACTSFA_Msk             (0x03UL << NT_PWM1_AQSFRC_ACTSFA_Pos)                   /*!< NT_PWM1 AQSFRC: ACTSFA Mask             */
#define NT_PWM1_AQSFRC_OTSFA_Pos              2                                                       /*!< NT_PWM1 AQSFRC: OTSFA Position          */
#define NT_PWM1_AQSFRC_OTSFA_Msk              (0x01UL << NT_PWM1_AQSFRC_OTSFA_Pos)                    /*!< NT_PWM1 AQSFRC: OTSFA Mask              */
#define NT_PWM1_AQSFRC_ACTSFB_Pos             3                                                       /*!< NT_PWM1 AQSFRC: ACTSFB Position         */
#define NT_PWM1_AQSFRC_ACTSFB_Msk             (0x03UL << NT_PWM1_AQSFRC_ACTSFB_Pos)                   /*!< NT_PWM1 AQSFRC: ACTSFB Mask             */
#define NT_PWM1_AQSFRC_OTSFB_Pos              5                                                       /*!< NT_PWM1 AQSFRC: OTSFB Position          */
#define NT_PWM1_AQSFRC_OTSFB_Msk              (0x01UL << NT_PWM1_AQSFRC_OTSFB_Pos)                    /*!< NT_PWM1 AQSFRC: OTSFB Mask              */
#define NT_PWM1_AQSFRC_RLDCSF_Pos             6                                                       /*!< NT_PWM1 AQSFRC: RLDCSF Position         */
#define NT_PWM1_AQSFRC_RLDCSF_Msk             (0x03UL << NT_PWM1_AQSFRC_RLDCSF_Pos)                   /*!< NT_PWM1 AQSFRC: RLDCSF Mask             */

/* -------------------------------  NT_PWM1_AQCSFRC  ------------------------------ */
#define NT_PWM1_AQCSFRC_CSFA_Pos              0                                                       /*!< NT_PWM1 AQCSFRC: CSFA Position          */
#define NT_PWM1_AQCSFRC_CSFA_Msk              (0x03UL << NT_PWM1_AQCSFRC_CSFA_Pos)                    /*!< NT_PWM1 AQCSFRC: CSFA Mask              */
#define NT_PWM1_AQCSFRC_CSFB_Pos              2                                                       /*!< NT_PWM1 AQCSFRC: CSFB Position          */
#define NT_PWM1_AQCSFRC_CSFB_Msk              (0x03UL << NT_PWM1_AQCSFRC_CSFB_Pos)                    /*!< NT_PWM1 AQCSFRC: CSFB Mask              */

/* --------------------------------  NT_PWM1_DBCTL  ------------------------------- */
#define NT_PWM1_DBCTL_OUT_MODE_Pos            0                                                       /*!< NT_PWM1 DBCTL: OUT_MODE Position        */
#define NT_PWM1_DBCTL_OUT_MODE_Msk            (0x03UL << NT_PWM1_DBCTL_OUT_MODE_Pos)                  /*!< NT_PWM1 DBCTL: OUT_MODE Mask            */
#define NT_PWM1_DBCTL_POLSEL_Pos              2                                                       /*!< NT_PWM1 DBCTL: POLSEL Position          */
#define NT_PWM1_DBCTL_POLSEL_Msk              (0x03UL << NT_PWM1_DBCTL_POLSEL_Pos)                    /*!< NT_PWM1 DBCTL: POLSEL Mask              */
#define NT_PWM1_DBCTL_IN_MODE_Pos             4                                                       /*!< NT_PWM1 DBCTL: IN_MODE Position         */
#define NT_PWM1_DBCTL_IN_MODE_Msk             (0x03UL << NT_PWM1_DBCTL_IN_MODE_Pos)                   /*!< NT_PWM1 DBCTL: IN_MODE Mask             */

/* --------------------------------  NT_PWM1_DBRED  ------------------------------- */
#define NT_PWM1_DBRED_DEL_Pos                 0                                                       /*!< NT_PWM1 DBRED: DEL Position             */
#define NT_PWM1_DBRED_DEL_Msk                 (0x000003ffUL << NT_PWM1_DBRED_DEL_Pos)                 /*!< NT_PWM1 DBRED: DEL Mask                 */

/* --------------------------------  NT_PWM1_DBFED  ------------------------------- */
#define NT_PWM1_DBFED_DEL_Pos                 0                                                       /*!< NT_PWM1 DBFED: DEL Position             */
#define NT_PWM1_DBFED_DEL_Msk                 (0x000003ffUL << NT_PWM1_DBFED_DEL_Pos)                 /*!< NT_PWM1 DBFED: DEL Mask                 */

/* --------------------------------  NT_PWM1_TZSEL  ------------------------------- */
#define NT_PWM1_TZSEL_CBC0_Pos                0                                                       /*!< NT_PWM1 TZSEL: CBC0 Position            */
#define NT_PWM1_TZSEL_CBC0_Msk                (0x01UL << NT_PWM1_TZSEL_CBC0_Pos)                      /*!< NT_PWM1 TZSEL: CBC0 Mask                */
#define NT_PWM1_TZSEL_CBC1_Pos                1                                                       /*!< NT_PWM1 TZSEL: CBC1 Position            */
#define NT_PWM1_TZSEL_CBC1_Msk                (0x01UL << NT_PWM1_TZSEL_CBC1_Pos)                      /*!< NT_PWM1 TZSEL: CBC1 Mask                */
#define NT_PWM1_TZSEL_CBC2_Pos                2                                                       /*!< NT_PWM1 TZSEL: CBC2 Position            */
#define NT_PWM1_TZSEL_CBC2_Msk                (0x01UL << NT_PWM1_TZSEL_CBC2_Pos)                      /*!< NT_PWM1 TZSEL: CBC2 Mask                */
#define NT_PWM1_TZSEL_CBC3_Pos                3                                                       /*!< NT_PWM1 TZSEL: CBC3 Position            */
#define NT_PWM1_TZSEL_CBC3_Msk                (0x01UL << NT_PWM1_TZSEL_CBC3_Pos)                      /*!< NT_PWM1 TZSEL: CBC3 Mask                */
#define NT_PWM1_TZSEL_CBC4_Pos                4                                                       /*!< NT_PWM1 TZSEL: CBC4 Position            */
#define NT_PWM1_TZSEL_CBC4_Msk                (0x01UL << NT_PWM1_TZSEL_CBC4_Pos)                      /*!< NT_PWM1 TZSEL: CBC4 Mask                */
#define NT_PWM1_TZSEL_CBC5_Pos                5                                                       /*!< NT_PWM1 TZSEL: CBC5 Position            */
#define NT_PWM1_TZSEL_CBC5_Msk                (0x01UL << NT_PWM1_TZSEL_CBC5_Pos)                      /*!< NT_PWM1 TZSEL: CBC5 Mask                */
#define NT_PWM1_TZSEL_OSHT0_Pos               8                                                       /*!< NT_PWM1 TZSEL: OSHT0 Position           */
#define NT_PWM1_TZSEL_OSHT0_Msk               (0x01UL << NT_PWM1_TZSEL_OSHT0_Pos)                     /*!< NT_PWM1 TZSEL: OSHT0 Mask               */
#define NT_PWM1_TZSEL_OSHT1_Pos               9                                                       /*!< NT_PWM1 TZSEL: OSHT1 Position           */
#define NT_PWM1_TZSEL_OSHT1_Msk               (0x01UL << NT_PWM1_TZSEL_OSHT1_Pos)                     /*!< NT_PWM1 TZSEL: OSHT1 Mask               */
#define NT_PWM1_TZSEL_OSHT2_Pos               10                                                      /*!< NT_PWM1 TZSEL: OSHT2 Position           */
#define NT_PWM1_TZSEL_OSHT2_Msk               (0x01UL << NT_PWM1_TZSEL_OSHT2_Pos)                     /*!< NT_PWM1 TZSEL: OSHT2 Mask               */
#define NT_PWM1_TZSEL_OSHT3_Pos               11                                                      /*!< NT_PWM1 TZSEL: OSHT3 Position           */
#define NT_PWM1_TZSEL_OSHT3_Msk               (0x01UL << NT_PWM1_TZSEL_OSHT3_Pos)                     /*!< NT_PWM1 TZSEL: OSHT3 Mask               */
#define NT_PWM1_TZSEL_OSHT4_Pos               12                                                      /*!< NT_PWM1 TZSEL: OSHT4 Position           */
#define NT_PWM1_TZSEL_OSHT4_Msk               (0x01UL << NT_PWM1_TZSEL_OSHT4_Pos)                     /*!< NT_PWM1 TZSEL: OSHT4 Mask               */
#define NT_PWM1_TZSEL_OSHT5_Pos               13                                                      /*!< NT_PWM1 TZSEL: OSHT5 Position           */
#define NT_PWM1_TZSEL_OSHT5_Msk               (0x01UL << NT_PWM1_TZSEL_OSHT5_Pos)                     /*!< NT_PWM1 TZSEL: OSHT5 Mask               */

/* --------------------------------  NT_PWM1_TZCTL  ------------------------------- */
#define NT_PWM1_TZCTL_TZA_Pos                 0                                                       /*!< NT_PWM1 TZCTL: TZA Position             */
#define NT_PWM1_TZCTL_TZA_Msk                 (0x03UL << NT_PWM1_TZCTL_TZA_Pos)                       /*!< NT_PWM1 TZCTL: TZA Mask                 */
#define NT_PWM1_TZCTL_TZB_Pos                 2                                                       /*!< NT_PWM1 TZCTL: TZB Position             */
#define NT_PWM1_TZCTL_TZB_Msk                 (0x03UL << NT_PWM1_TZCTL_TZB_Pos)                       /*!< NT_PWM1 TZCTL: TZB Mask                 */

/* -------------------------------  NT_PWM1_TZEINT  ------------------------------- */
#define NT_PWM1_TZEINT_CBC_Pos                1                                                       /*!< NT_PWM1 TZEINT: CBC Position            */
#define NT_PWM1_TZEINT_CBC_Msk                (0x01UL << NT_PWM1_TZEINT_CBC_Pos)                      /*!< NT_PWM1 TZEINT: CBC Mask                */
#define NT_PWM1_TZEINT_OST_Pos                2                                                       /*!< NT_PWM1 TZEINT: OST Position            */
#define NT_PWM1_TZEINT_OST_Msk                (0x01UL << NT_PWM1_TZEINT_OST_Pos)                      /*!< NT_PWM1 TZEINT: OST Mask                */

/* --------------------------------  NT_PWM1_TZFLG  ------------------------------- */
#define NT_PWM1_TZFLG_INT_Pos                 0                                                       /*!< NT_PWM1 TZFLG: INT Position             */
#define NT_PWM1_TZFLG_INT_Msk                 (0x01UL << NT_PWM1_TZFLG_INT_Pos)                       /*!< NT_PWM1 TZFLG: INT Mask                 */
#define NT_PWM1_TZFLG_CBC_Pos                 1                                                       /*!< NT_PWM1 TZFLG: CBC Position             */
#define NT_PWM1_TZFLG_CBC_Msk                 (0x01UL << NT_PWM1_TZFLG_CBC_Pos)                       /*!< NT_PWM1 TZFLG: CBC Mask                 */
#define NT_PWM1_TZFLG_OST_Pos                 2                                                       /*!< NT_PWM1 TZFLG: OST Position             */
#define NT_PWM1_TZFLG_OST_Msk                 (0x01UL << NT_PWM1_TZFLG_OST_Pos)                       /*!< NT_PWM1 TZFLG: OST Mask                 */

/* --------------------------------  NT_PWM1_TZCLR  ------------------------------- */
#define NT_PWM1_TZCLR_INT_Pos                 0                                                       /*!< NT_PWM1 TZCLR: INT Position             */
#define NT_PWM1_TZCLR_INT_Msk                 (0x01UL << NT_PWM1_TZCLR_INT_Pos)                       /*!< NT_PWM1 TZCLR: INT Mask                 */
#define NT_PWM1_TZCLR_CBC_Pos                 1                                                       /*!< NT_PWM1 TZCLR: CBC Position             */
#define NT_PWM1_TZCLR_CBC_Msk                 (0x01UL << NT_PWM1_TZCLR_CBC_Pos)                       /*!< NT_PWM1 TZCLR: CBC Mask                 */
#define NT_PWM1_TZCLR_OST_Pos                 2                                                       /*!< NT_PWM1 TZCLR: OST Position             */
#define NT_PWM1_TZCLR_OST_Msk                 (0x01UL << NT_PWM1_TZCLR_OST_Pos)                       /*!< NT_PWM1 TZCLR: OST Mask                 */

/* --------------------------------  NT_PWM1_TZFRC  ------------------------------- */
#define NT_PWM1_TZFRC_CBC_Pos                 1                                                       /*!< NT_PWM1 TZFRC: CBC Position             */
#define NT_PWM1_TZFRC_CBC_Msk                 (0x01UL << NT_PWM1_TZFRC_CBC_Pos)                       /*!< NT_PWM1 TZFRC: CBC Mask                 */
#define NT_PWM1_TZFRC_OST_Pos                 2                                                       /*!< NT_PWM1 TZFRC: OST Position             */
#define NT_PWM1_TZFRC_OST_Msk                 (0x01UL << NT_PWM1_TZFRC_OST_Pos)                       /*!< NT_PWM1 TZFRC: OST Mask                 */

/* --------------------------------  NT_PWM1_ETSEL  ------------------------------- */
#define NT_PWM1_ETSEL_INTSEL_Pos              0                                                       /*!< NT_PWM1 ETSEL: INTSEL Position          */
#define NT_PWM1_ETSEL_INTSEL_Msk              (0x07UL << NT_PWM1_ETSEL_INTSEL_Pos)                    /*!< NT_PWM1 ETSEL: INTSEL Mask              */
#define NT_PWM1_ETSEL_INTEN_Pos               3                                                       /*!< NT_PWM1 ETSEL: INTEN Position           */
#define NT_PWM1_ETSEL_INTEN_Msk               (0x01UL << NT_PWM1_ETSEL_INTEN_Pos)                     /*!< NT_PWM1 ETSEL: INTEN Mask               */
#define NT_PWM1_ETSEL_SOCASEL_Pos             8                                                       /*!< NT_PWM1 ETSEL: SOCASEL Position         */
#define NT_PWM1_ETSEL_SOCASEL_Msk             (0x07UL << NT_PWM1_ETSEL_SOCASEL_Pos)                   /*!< NT_PWM1 ETSEL: SOCASEL Mask             */
#define NT_PWM1_ETSEL_SOCAEN_Pos              11                                                      /*!< NT_PWM1 ETSEL: SOCAEN Position          */
#define NT_PWM1_ETSEL_SOCAEN_Msk              (0x01UL << NT_PWM1_ETSEL_SOCAEN_Pos)                    /*!< NT_PWM1 ETSEL: SOCAEN Mask              */
#define NT_PWM1_ETSEL_SOCBSEL_Pos             12                                                      /*!< NT_PWM1 ETSEL: SOCBSEL Position         */
#define NT_PWM1_ETSEL_SOCBSEL_Msk             (0x07UL << NT_PWM1_ETSEL_SOCBSEL_Pos)                   /*!< NT_PWM1 ETSEL: SOCBSEL Mask             */
#define NT_PWM1_ETSEL_SOCBEN_Pos              15                                                      /*!< NT_PWM1 ETSEL: SOCBEN Position          */
#define NT_PWM1_ETSEL_SOCBEN_Msk              (0x01UL << NT_PWM1_ETSEL_SOCBEN_Pos)                    /*!< NT_PWM1 ETSEL: SOCBEN Mask              */

/* --------------------------------  NT_PWM1_ETPS  -------------------------------- */
#define NT_PWM1_ETPS_INTPRD_Pos               0                                                       /*!< NT_PWM1 ETPS: INTPRD Position           */
#define NT_PWM1_ETPS_INTPRD_Msk               (0x03UL << NT_PWM1_ETPS_INTPRD_Pos)                     /*!< NT_PWM1 ETPS: INTPRD Mask               */
#define NT_PWM1_ETPS_INTCNT_Pos               2                                                       /*!< NT_PWM1 ETPS: INTCNT Position           */
#define NT_PWM1_ETPS_INTCNT_Msk               (0x03UL << NT_PWM1_ETPS_INTCNT_Pos)                     /*!< NT_PWM1 ETPS: INTCNT Mask               */
#define NT_PWM1_ETPS_SOCAPRD_Pos              8                                                       /*!< NT_PWM1 ETPS: SOCAPRD Position          */
#define NT_PWM1_ETPS_SOCAPRD_Msk              (0x03UL << NT_PWM1_ETPS_SOCAPRD_Pos)                    /*!< NT_PWM1 ETPS: SOCAPRD Mask              */
#define NT_PWM1_ETPS_SOCACNT_Pos              10                                                      /*!< NT_PWM1 ETPS: SOCACNT Position          */
#define NT_PWM1_ETPS_SOCACNT_Msk              (0x03UL << NT_PWM1_ETPS_SOCACNT_Pos)                    /*!< NT_PWM1 ETPS: SOCACNT Mask              */
#define NT_PWM1_ETPS_SOCPRD_Pos               12                                                      /*!< NT_PWM1 ETPS: SOCPRD Position           */
#define NT_PWM1_ETPS_SOCPRD_Msk               (0x03UL << NT_PWM1_ETPS_SOCPRD_Pos)                     /*!< NT_PWM1 ETPS: SOCPRD Mask               */
#define NT_PWM1_ETPS_SOCBCNT_Pos              14                                                      /*!< NT_PWM1 ETPS: SOCBCNT Position          */
#define NT_PWM1_ETPS_SOCBCNT_Msk              (0x03UL << NT_PWM1_ETPS_SOCBCNT_Pos)                    /*!< NT_PWM1 ETPS: SOCBCNT Mask              */

/* --------------------------------  NT_PWM1_ETFLG  ------------------------------- */
#define NT_PWM1_ETFLG_INT_Pos                 0                                                       /*!< NT_PWM1 ETFLG: INT Position             */
#define NT_PWM1_ETFLG_INT_Msk                 (0x01UL << NT_PWM1_ETFLG_INT_Pos)                       /*!< NT_PWM1 ETFLG: INT Mask                 */
#define NT_PWM1_ETFLG_SOCA_Pos                2                                                       /*!< NT_PWM1 ETFLG: SOCA Position            */
#define NT_PWM1_ETFLG_SOCA_Msk                (0x01UL << NT_PWM1_ETFLG_SOCA_Pos)                      /*!< NT_PWM1 ETFLG: SOCA Mask                */
#define NT_PWM1_ETFLG_SOCB_Pos                3                                                       /*!< NT_PWM1 ETFLG: SOCB Position            */
#define NT_PWM1_ETFLG_SOCB_Msk                (0x01UL << NT_PWM1_ETFLG_SOCB_Pos)                      /*!< NT_PWM1 ETFLG: SOCB Mask                */

/* --------------------------------  NT_PWM1_ETCLR  ------------------------------- */
#define NT_PWM1_ETCLR_INT_Pos                 0                                                       /*!< NT_PWM1 ETCLR: INT Position             */
#define NT_PWM1_ETCLR_INT_Msk                 (0x01UL << NT_PWM1_ETCLR_INT_Pos)                       /*!< NT_PWM1 ETCLR: INT Mask                 */
#define NT_PWM1_ETCLR_SOCA_Pos                2                                                       /*!< NT_PWM1 ETCLR: SOCA Position            */
#define NT_PWM1_ETCLR_SOCA_Msk                (0x01UL << NT_PWM1_ETCLR_SOCA_Pos)                      /*!< NT_PWM1 ETCLR: SOCA Mask                */
#define NT_PWM1_ETCLR_SOCB_Pos                3                                                       /*!< NT_PWM1 ETCLR: SOCB Position            */
#define NT_PWM1_ETCLR_SOCB_Msk                (0x01UL << NT_PWM1_ETCLR_SOCB_Pos)                      /*!< NT_PWM1 ETCLR: SOCB Mask                */

/* --------------------------------  NT_PWM1_ETFRC  ------------------------------- */
#define NT_PWM1_ETFRC_INT_Pos                 0                                                       /*!< NT_PWM1 ETFRC: INT Position             */
#define NT_PWM1_ETFRC_INT_Msk                 (0x01UL << NT_PWM1_ETFRC_INT_Pos)                       /*!< NT_PWM1 ETFRC: INT Mask                 */
#define NT_PWM1_ETFRC_SOCA_Pos                2                                                       /*!< NT_PWM1 ETFRC: SOCA Position            */
#define NT_PWM1_ETFRC_SOCA_Msk                (0x01UL << NT_PWM1_ETFRC_SOCA_Pos)                      /*!< NT_PWM1 ETFRC: SOCA Mask                */
#define NT_PWM1_ETFRC_SOCB_Pos                3                                                       /*!< NT_PWM1 ETFRC: SOCB Position            */
#define NT_PWM1_ETFRC_SOCB_Msk                (0x01UL << NT_PWM1_ETFRC_SOCB_Pos)                      /*!< NT_PWM1 ETFRC: SOCB Mask                */

/* --------------------------------  NT_PWM1_PCCTL  ------------------------------- */
#define NT_PWM1_PCCTL_CHPEN_Pos               0                                                       /*!< NT_PWM1 PCCTL: CHPEN Position           */
#define NT_PWM1_PCCTL_CHPEN_Msk               (0x01UL << NT_PWM1_PCCTL_CHPEN_Pos)                     /*!< NT_PWM1 PCCTL: CHPEN Mask               */
#define NT_PWM1_PCCTL_OSHTWTH_Pos             1                                                       /*!< NT_PWM1 PCCTL: OSHTWTH Position         */
#define NT_PWM1_PCCTL_OSHTWTH_Msk             (0x0fUL << NT_PWM1_PCCTL_OSHTWTH_Pos)                   /*!< NT_PWM1 PCCTL: OSHTWTH Mask             */
#define NT_PWM1_PCCTL_SHRFREQ_Pos             5                                                       /*!< NT_PWM1 PCCTL: SHRFREQ Position         */
#define NT_PWM1_PCCTL_SHRFREQ_Msk             (0x07UL << NT_PWM1_PCCTL_SHRFREQ_Pos)                   /*!< NT_PWM1 PCCTL: SHRFREQ Mask             */
#define NT_PWM1_PCCTL_CHPDUTY_Pos             8                                                       /*!< NT_PWM1 PCCTL: CHPDUTY Position         */
#define NT_PWM1_PCCTL_CHPDUTY_Msk             (0x07UL << NT_PWM1_PCCTL_CHPDUTY_Pos)                   /*!< NT_PWM1 PCCTL: CHPDUTY Mask             */

/* -------------------------------  NT_PWM1_HRCNFG  ------------------------------- */
#define NT_PWM1_HRCNFG_EDGMODE_Pos            0                                                       /*!< NT_PWM1 HRCNFG: EDGMODE Position        */
#define NT_PWM1_HRCNFG_EDGMODE_Msk            (0x03UL << NT_PWM1_HRCNFG_EDGMODE_Pos)                  /*!< NT_PWM1 HRCNFG: EDGMODE Mask            */
#define NT_PWM1_HRCNFG_CTLMODE_Pos            2                                                       /*!< NT_PWM1 HRCNFG: CTLMODE Position        */
#define NT_PWM1_HRCNFG_CTLMODE_Msk            (0x01UL << NT_PWM1_HRCNFG_CTLMODE_Pos)                  /*!< NT_PWM1 HRCNFG: CTLMODE Mask            */
#define NT_PWM1_HRCNFG_HR_LOAD_Pos            3                                                       /*!< NT_PWM1 HRCNFG: HR_LOAD Position        */
#define NT_PWM1_HRCNFG_HR_LOAD_Msk            (0x01UL << NT_PWM1_HRCNFG_HR_LOAD_Pos)                  /*!< NT_PWM1 HRCNFG: HR_LOAD Mask            */
#define NT_PWM1_HRCNFG_MEP_SCALEFACTOR_Pos    16                                                      /*!< NT_PWM1 HRCNFG: MEP_SCALEFACTOR Position */
#define NT_PWM1_HRCNFG_MEP_SCALEFACTOR_Msk    (0x000000ffUL << NT_PWM1_HRCNFG_MEP_SCALEFACTOR_Pos)    /*!< NT_PWM1 HRCNFG: MEP_SCALEFACTOR Mask    */

/* --------------------------------  NT_PWM1_FWDTH  ------------------------------- */
#define NT_PWM1_FWDTH_FWDTH_Pos               0                                                       /*!< NT_PWM1 FWDTH: FWDTH Position           */
#define NT_PWM1_FWDTH_FWDTH_Msk               (0x000000ffUL << NT_PWM1_FWDTH_FWDTH_Pos)               /*!< NT_PWM1 FWDTH: FWDTH Mask               */

/* --------------------------------  NT_PWM1_HDSEL  ------------------------------- */
#define NT_PWM1_HDSEL_DCMP_Pos                0                                                       /*!< NT_PWM1 HDSEL: DCMP Position            */
#define NT_PWM1_HDSEL_DCMP_Msk                (0x00ffffffUL << NT_PWM1_HDSEL_DCMP_Pos)                /*!< NT_PWM1 HDSEL: DCMP Mask                */
#define NT_PWM1_HDSEL_ACMP_Pos                24                                                      /*!< NT_PWM1 HDSEL: ACMP Position            */
#define NT_PWM1_HDSEL_ACMP_Msk                (0x07UL << NT_PWM1_HDSEL_ACMP_Pos)                      /*!< NT_PWM1 HDSEL: ACMP Mask                */

/* --------------------------------  NT_PWM1_HDCTL  ------------------------------- */
#define NT_PWM1_HDCTL_HDA_Pos                 0                                                       /*!< NT_PWM1 HDCTL: HDA Position             */
#define NT_PWM1_HDCTL_HDA_Msk                 (0x03UL << NT_PWM1_HDCTL_HDA_Pos)                       /*!< NT_PWM1 HDCTL: HDA Mask                 */
#define NT_PWM1_HDCTL_HDB_Pos                 2                                                       /*!< NT_PWM1 HDCTL: HDB Position             */
#define NT_PWM1_HDCTL_HDB_Msk                 (0x03UL << NT_PWM1_HDCTL_HDB_Pos)                       /*!< NT_PWM1 HDCTL: HDB Mask                 */

/* -------------------------------  NT_PWM1_HDEINT  ------------------------------- */
#define NT_PWM1_HDEINT_CBC_Pos                1                                                       /*!< NT_PWM1 HDEINT: CBC Position            */
#define NT_PWM1_HDEINT_CBC_Msk                (0x01UL << NT_PWM1_HDEINT_CBC_Pos)                      /*!< NT_PWM1 HDEINT: CBC Mask                */
#define NT_PWM1_HDEINT_OST_Pos                2                                                       /*!< NT_PWM1 HDEINT: OST Position            */
#define NT_PWM1_HDEINT_OST_Msk                (0x01UL << NT_PWM1_HDEINT_OST_Pos)                      /*!< NT_PWM1 HDEINT: OST Mask                */

/* --------------------------------  NT_PWM1_HDFLG  ------------------------------- */
#define NT_PWM1_HDFLG_HDINT_Pos               0                                                       /*!< NT_PWM1 HDFLG: HDINT Position           */
#define NT_PWM1_HDFLG_HDINT_Msk               (0x01UL << NT_PWM1_HDFLG_HDINT_Pos)                     /*!< NT_PWM1 HDFLG: HDINT Mask               */
#define NT_PWM1_HDFLG_CBC_Pos                 1                                                       /*!< NT_PWM1 HDFLG: CBC Position             */
#define NT_PWM1_HDFLG_CBC_Msk                 (0x01UL << NT_PWM1_HDFLG_CBC_Pos)                       /*!< NT_PWM1 HDFLG: CBC Mask                 */
#define NT_PWM1_HDFLG_OST_Pos                 2                                                       /*!< NT_PWM1 HDFLG: OST Position             */
#define NT_PWM1_HDFLG_OST_Msk                 (0x01UL << NT_PWM1_HDFLG_OST_Pos)                       /*!< NT_PWM1 HDFLG: OST Mask                 */

/* --------------------------------  NT_PWM1_HDCLR  ------------------------------- */
#define NT_PWM1_HDCLR_HDINT_Pos               0                                                       /*!< NT_PWM1 HDCLR: HDINT Position           */
#define NT_PWM1_HDCLR_HDINT_Msk               (0x01UL << NT_PWM1_HDCLR_HDINT_Pos)                     /*!< NT_PWM1 HDCLR: HDINT Mask               */

/* --------------------------------  NT_PWM1_HDFRC  ------------------------------- */
#define NT_PWM1_HDFRC_CBC_Pos                 1                                                       /*!< NT_PWM1 HDFRC: CBC Position             */
#define NT_PWM1_HDFRC_CBC_Msk                 (0x01UL << NT_PWM1_HDFRC_CBC_Pos)                       /*!< NT_PWM1 HDFRC: CBC Mask                 */
#define NT_PWM1_HDFRC_OST_Pos                 2                                                       /*!< NT_PWM1 HDFRC: OST Position             */
#define NT_PWM1_HDFRC_OST_Msk                 (0x01UL << NT_PWM1_HDFRC_OST_Pos)                       /*!< NT_PWM1 HDFRC: OST Mask                 */

/* ------------------------------  NT_PWM1_HDINTCLR  ------------------------------ */
#define NT_PWM1_HDINTCLR_HDINT_Pos            0                                                       /*!< NT_PWM1 HDINTCLR: HDINT Position        */
#define NT_PWM1_HDINTCLR_HDINT_Msk            (0x01UL << NT_PWM1_HDINTCLR_HDINT_Pos)                  /*!< NT_PWM1 HDINTCLR: HDINT Mask            */

/* ------------------------------  NT_PWM1_TZINTCLR  ------------------------------ */
#define NT_PWM1_TZINTCLR_TZINT_Pos            0                                                       /*!< NT_PWM1 TZINTCLR: TZINT Position        */
#define NT_PWM1_TZINTCLR_TZINT_Msk            (0x01UL << NT_PWM1_TZINTCLR_TZINT_Pos)                  /*!< NT_PWM1 TZINTCLR: TZINT Mask            */

/* -------------------------------  NT_PWM1_INTCLR  ------------------------------- */
#define NT_PWM1_INTCLR_INT_Pos                0                                                       /*!< NT_PWM1 INTCLR: INT Position            */
#define NT_PWM1_INTCLR_INT_Msk                (0x01UL << NT_PWM1_INTCLR_INT_Pos)                      /*!< NT_PWM1 INTCLR: INT Mask                */


/* ================================================================================ */
/* ================        struct 'NT_PWM2' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_PWM2_TBCTL  ------------------------------- */
#define NT_PWM2_TBCTL_CTRMODE_Pos             0                                                       /*!< NT_PWM2 TBCTL: CTRMODE Position         */
#define NT_PWM2_TBCTL_CTRMODE_Msk             (0x03UL << NT_PWM2_TBCTL_CTRMODE_Pos)                   /*!< NT_PWM2 TBCTL: CTRMODE Mask             */
#define NT_PWM2_TBCTL_PHSEN_Pos               2                                                       /*!< NT_PWM2 TBCTL: PHSEN Position           */
#define NT_PWM2_TBCTL_PHSEN_Msk               (0x01UL << NT_PWM2_TBCTL_PHSEN_Pos)                     /*!< NT_PWM2 TBCTL: PHSEN Mask               */
#define NT_PWM2_TBCTL_PRDLD_Pos               3                                                       /*!< NT_PWM2 TBCTL: PRDLD Position           */
#define NT_PWM2_TBCTL_PRDLD_Msk               (0x01UL << NT_PWM2_TBCTL_PRDLD_Pos)                     /*!< NT_PWM2 TBCTL: PRDLD Mask               */
#define NT_PWM2_TBCTL_SYNCOSEL_Pos            4                                                       /*!< NT_PWM2 TBCTL: SYNCOSEL Position        */
#define NT_PWM2_TBCTL_SYNCOSEL_Msk            (0x03UL << NT_PWM2_TBCTL_SYNCOSEL_Pos)                  /*!< NT_PWM2 TBCTL: SYNCOSEL Mask            */
#define NT_PWM2_TBCTL_SWFSYNC_Pos             6                                                       /*!< NT_PWM2 TBCTL: SWFSYNC Position         */
#define NT_PWM2_TBCTL_SWFSYNC_Msk             (0x01UL << NT_PWM2_TBCTL_SWFSYNC_Pos)                   /*!< NT_PWM2 TBCTL: SWFSYNC Mask             */
#define NT_PWM2_TBCTL_HSPCLKDIV_Pos           7                                                       /*!< NT_PWM2 TBCTL: HSPCLKDIV Position       */
#define NT_PWM2_TBCTL_HSPCLKDIV_Msk           (0x07UL << NT_PWM2_TBCTL_HSPCLKDIV_Pos)                 /*!< NT_PWM2 TBCTL: HSPCLKDIV Mask           */
#define NT_PWM2_TBCTL_CLKDIV_Pos              10                                                      /*!< NT_PWM2 TBCTL: CLKDIV Position          */
#define NT_PWM2_TBCTL_CLKDIV_Msk              (0x07UL << NT_PWM2_TBCTL_CLKDIV_Pos)                    /*!< NT_PWM2 TBCTL: CLKDIV Mask              */
#define NT_PWM2_TBCTL_PHSDIR_Pos              13                                                      /*!< NT_PWM2 TBCTL: PHSDIR Position          */
#define NT_PWM2_TBCTL_PHSDIR_Msk              (0x01UL << NT_PWM2_TBCTL_PHSDIR_Pos)                    /*!< NT_PWM2 TBCTL: PHSDIR Mask              */
#define NT_PWM2_TBCTL_FREE_SOFT_Pos           14                                                      /*!< NT_PWM2 TBCTL: FREE_SOFT Position       */
#define NT_PWM2_TBCTL_FREE_SOFT_Msk           (0x03UL << NT_PWM2_TBCTL_FREE_SOFT_Pos)                 /*!< NT_PWM2 TBCTL: FREE_SOFT Mask           */

/* --------------------------------  NT_PWM2_TBSTS  ------------------------------- */
#define NT_PWM2_TBSTS_CTRDIR_Pos              0                                                       /*!< NT_PWM2 TBSTS: CTRDIR Position          */
#define NT_PWM2_TBSTS_CTRDIR_Msk              (0x01UL << NT_PWM2_TBSTS_CTRDIR_Pos)                    /*!< NT_PWM2 TBSTS: CTRDIR Mask              */
#define NT_PWM2_TBSTS_SYNCI_Pos               1                                                       /*!< NT_PWM2 TBSTS: SYNCI Position           */
#define NT_PWM2_TBSTS_SYNCI_Msk               (0x01UL << NT_PWM2_TBSTS_SYNCI_Pos)                     /*!< NT_PWM2 TBSTS: SYNCI Mask               */
#define NT_PWM2_TBSTS_CTRMAX_Pos              2                                                       /*!< NT_PWM2 TBSTS: CTRMAX Position          */
#define NT_PWM2_TBSTS_CTRMAX_Msk              (0x01UL << NT_PWM2_TBSTS_CTRMAX_Pos)                    /*!< NT_PWM2 TBSTS: CTRMAX Mask              */

/* --------------------------------  NT_PWM2_TBPHS  ------------------------------- */
#define NT_PWM2_TBPHS_TBPHSHR_Pos             8                                                       /*!< NT_PWM2 TBPHS: TBPHSHR Position         */
#define NT_PWM2_TBPHS_TBPHSHR_Msk             (0x000000ffUL << NT_PWM2_TBPHS_TBPHSHR_Pos)             /*!< NT_PWM2 TBPHS: TBPHSHR Mask             */
#define NT_PWM2_TBPHS_TBPHS_Pos               16                                                      /*!< NT_PWM2 TBPHS: TBPHS Position           */
#define NT_PWM2_TBPHS_TBPHS_Msk               (0x0000ffffUL << NT_PWM2_TBPHS_TBPHS_Pos)               /*!< NT_PWM2 TBPHS: TBPHS Mask               */

/* --------------------------------  NT_PWM2_TBCTR  ------------------------------- */
#define NT_PWM2_TBCTR_TBCTR_Pos               0                                                       /*!< NT_PWM2 TBCTR: TBCTR Position           */
#define NT_PWM2_TBCTR_TBCTR_Msk               (0x0000ffffUL << NT_PWM2_TBCTR_TBCTR_Pos)               /*!< NT_PWM2 TBCTR: TBCTR Mask               */

/* --------------------------------  NT_PWM2_TBPRD  ------------------------------- */
#define NT_PWM2_TBPRD_TBPRD_Pos               0                                                       /*!< NT_PWM2 TBPRD: TBPRD Position           */
#define NT_PWM2_TBPRD_TBPRD_Msk               (0x0000ffffUL << NT_PWM2_TBPRD_TBPRD_Pos)               /*!< NT_PWM2 TBPRD: TBPRD Mask               */

/* -------------------------------  NT_PWM2_CMPCTL  ------------------------------- */
#define NT_PWM2_CMPCTL_LOADAMODE_Pos          0                                                       /*!< NT_PWM2 CMPCTL: LOADAMODE Position      */
#define NT_PWM2_CMPCTL_LOADAMODE_Msk          (0x03UL << NT_PWM2_CMPCTL_LOADAMODE_Pos)                /*!< NT_PWM2 CMPCTL: LOADAMODE Mask          */
#define NT_PWM2_CMPCTL_LOADBMODE_Pos          2                                                       /*!< NT_PWM2 CMPCTL: LOADBMODE Position      */
#define NT_PWM2_CMPCTL_LOADBMODE_Msk          (0x03UL << NT_PWM2_CMPCTL_LOADBMODE_Pos)                /*!< NT_PWM2 CMPCTL: LOADBMODE Mask          */
#define NT_PWM2_CMPCTL_SHDWAMODE_Pos          4                                                       /*!< NT_PWM2 CMPCTL: SHDWAMODE Position      */
#define NT_PWM2_CMPCTL_SHDWAMODE_Msk          (0x01UL << NT_PWM2_CMPCTL_SHDWAMODE_Pos)                /*!< NT_PWM2 CMPCTL: SHDWAMODE Mask          */
#define NT_PWM2_CMPCTL_SHDWBMODE_Pos          6                                                       /*!< NT_PWM2 CMPCTL: SHDWBMODE Position      */
#define NT_PWM2_CMPCTL_SHDWBMODE_Msk          (0x01UL << NT_PWM2_CMPCTL_SHDWBMODE_Pos)                /*!< NT_PWM2 CMPCTL: SHDWBMODE Mask          */
#define NT_PWM2_CMPCTL_SHDWAFULL_Pos          8                                                       /*!< NT_PWM2 CMPCTL: SHDWAFULL Position      */
#define NT_PWM2_CMPCTL_SHDWAFULL_Msk          (0x01UL << NT_PWM2_CMPCTL_SHDWAFULL_Pos)                /*!< NT_PWM2 CMPCTL: SHDWAFULL Mask          */
#define NT_PWM2_CMPCTL_SHDWBFULL_Pos          9                                                       /*!< NT_PWM2 CMPCTL: SHDWBFULL Position      */
#define NT_PWM2_CMPCTL_SHDWBFULL_Msk          (0x01UL << NT_PWM2_CMPCTL_SHDWBFULL_Pos)                /*!< NT_PWM2 CMPCTL: SHDWBFULL Mask          */

/* --------------------------------  NT_PWM2_CMPA  -------------------------------- */
#define NT_PWM2_CMPA_CMPAHR_Pos               8                                                       /*!< NT_PWM2 CMPA: CMPAHR Position           */
#define NT_PWM2_CMPA_CMPAHR_Msk               (0x000000ffUL << NT_PWM2_CMPA_CMPAHR_Pos)               /*!< NT_PWM2 CMPA: CMPAHR Mask               */
#define NT_PWM2_CMPA_CMPA_Pos                 16                                                      /*!< NT_PWM2 CMPA: CMPA Position             */
#define NT_PWM2_CMPA_CMPA_Msk                 (0x0000ffffUL << NT_PWM2_CMPA_CMPA_Pos)                 /*!< NT_PWM2 CMPA: CMPA Mask                 */

/* --------------------------------  NT_PWM2_CMPB  -------------------------------- */
#define NT_PWM2_CMPB_CMPB_Pos                 16                                                      /*!< NT_PWM2 CMPB: CMPB Position             */
#define NT_PWM2_CMPB_CMPB_Msk                 (0x0000ffffUL << NT_PWM2_CMPB_CMPB_Pos)                 /*!< NT_PWM2 CMPB: CMPB Mask                 */

/* -------------------------------  NT_PWM2_AQCTLA  ------------------------------- */
#define NT_PWM2_AQCTLA_ZRO_Pos                0                                                       /*!< NT_PWM2 AQCTLA: ZRO Position            */
#define NT_PWM2_AQCTLA_ZRO_Msk                (0x03UL << NT_PWM2_AQCTLA_ZRO_Pos)                      /*!< NT_PWM2 AQCTLA: ZRO Mask                */
#define NT_PWM2_AQCTLA_PRD_Pos                2                                                       /*!< NT_PWM2 AQCTLA: PRD Position            */
#define NT_PWM2_AQCTLA_PRD_Msk                (0x03UL << NT_PWM2_AQCTLA_PRD_Pos)                      /*!< NT_PWM2 AQCTLA: PRD Mask                */
#define NT_PWM2_AQCTLA_CAU_Pos                4                                                       /*!< NT_PWM2 AQCTLA: CAU Position            */
#define NT_PWM2_AQCTLA_CAU_Msk                (0x03UL << NT_PWM2_AQCTLA_CAU_Pos)                      /*!< NT_PWM2 AQCTLA: CAU Mask                */
#define NT_PWM2_AQCTLA_CAD_Pos                6                                                       /*!< NT_PWM2 AQCTLA: CAD Position            */
#define NT_PWM2_AQCTLA_CAD_Msk                (0x03UL << NT_PWM2_AQCTLA_CAD_Pos)                      /*!< NT_PWM2 AQCTLA: CAD Mask                */
#define NT_PWM2_AQCTLA_CBU_Pos                8                                                       /*!< NT_PWM2 AQCTLA: CBU Position            */
#define NT_PWM2_AQCTLA_CBU_Msk                (0x03UL << NT_PWM2_AQCTLA_CBU_Pos)                      /*!< NT_PWM2 AQCTLA: CBU Mask                */
#define NT_PWM2_AQCTLA_CBD_Pos                10                                                      /*!< NT_PWM2 AQCTLA: CBD Position            */
#define NT_PWM2_AQCTLA_CBD_Msk                (0x03UL << NT_PWM2_AQCTLA_CBD_Pos)                      /*!< NT_PWM2 AQCTLA: CBD Mask                */

/* -------------------------------  NT_PWM2_AQCTLB  ------------------------------- */
#define NT_PWM2_AQCTLB_ZRO_Pos                0                                                       /*!< NT_PWM2 AQCTLB: ZRO Position            */
#define NT_PWM2_AQCTLB_ZRO_Msk                (0x03UL << NT_PWM2_AQCTLB_ZRO_Pos)                      /*!< NT_PWM2 AQCTLB: ZRO Mask                */
#define NT_PWM2_AQCTLB_PRD_Pos                2                                                       /*!< NT_PWM2 AQCTLB: PRD Position            */
#define NT_PWM2_AQCTLB_PRD_Msk                (0x03UL << NT_PWM2_AQCTLB_PRD_Pos)                      /*!< NT_PWM2 AQCTLB: PRD Mask                */
#define NT_PWM2_AQCTLB_CAU_Pos                4                                                       /*!< NT_PWM2 AQCTLB: CAU Position            */
#define NT_PWM2_AQCTLB_CAU_Msk                (0x03UL << NT_PWM2_AQCTLB_CAU_Pos)                      /*!< NT_PWM2 AQCTLB: CAU Mask                */
#define NT_PWM2_AQCTLB_CAD_Pos                6                                                       /*!< NT_PWM2 AQCTLB: CAD Position            */
#define NT_PWM2_AQCTLB_CAD_Msk                (0x03UL << NT_PWM2_AQCTLB_CAD_Pos)                      /*!< NT_PWM2 AQCTLB: CAD Mask                */
#define NT_PWM2_AQCTLB_CBU_Pos                8                                                       /*!< NT_PWM2 AQCTLB: CBU Position            */
#define NT_PWM2_AQCTLB_CBU_Msk                (0x03UL << NT_PWM2_AQCTLB_CBU_Pos)                      /*!< NT_PWM2 AQCTLB: CBU Mask                */
#define NT_PWM2_AQCTLB_CBD_Pos                10                                                      /*!< NT_PWM2 AQCTLB: CBD Position            */
#define NT_PWM2_AQCTLB_CBD_Msk                (0x03UL << NT_PWM2_AQCTLB_CBD_Pos)                      /*!< NT_PWM2 AQCTLB: CBD Mask                */

/* -------------------------------  NT_PWM2_AQSFRC  ------------------------------- */
#define NT_PWM2_AQSFRC_ACTSFA_Pos             0                                                       /*!< NT_PWM2 AQSFRC: ACTSFA Position         */
#define NT_PWM2_AQSFRC_ACTSFA_Msk             (0x03UL << NT_PWM2_AQSFRC_ACTSFA_Pos)                   /*!< NT_PWM2 AQSFRC: ACTSFA Mask             */
#define NT_PWM2_AQSFRC_OTSFA_Pos              2                                                       /*!< NT_PWM2 AQSFRC: OTSFA Position          */
#define NT_PWM2_AQSFRC_OTSFA_Msk              (0x01UL << NT_PWM2_AQSFRC_OTSFA_Pos)                    /*!< NT_PWM2 AQSFRC: OTSFA Mask              */
#define NT_PWM2_AQSFRC_ACTSFB_Pos             3                                                       /*!< NT_PWM2 AQSFRC: ACTSFB Position         */
#define NT_PWM2_AQSFRC_ACTSFB_Msk             (0x03UL << NT_PWM2_AQSFRC_ACTSFB_Pos)                   /*!< NT_PWM2 AQSFRC: ACTSFB Mask             */
#define NT_PWM2_AQSFRC_OTSFB_Pos              5                                                       /*!< NT_PWM2 AQSFRC: OTSFB Position          */
#define NT_PWM2_AQSFRC_OTSFB_Msk              (0x01UL << NT_PWM2_AQSFRC_OTSFB_Pos)                    /*!< NT_PWM2 AQSFRC: OTSFB Mask              */
#define NT_PWM2_AQSFRC_RLDCSF_Pos             6                                                       /*!< NT_PWM2 AQSFRC: RLDCSF Position         */
#define NT_PWM2_AQSFRC_RLDCSF_Msk             (0x03UL << NT_PWM2_AQSFRC_RLDCSF_Pos)                   /*!< NT_PWM2 AQSFRC: RLDCSF Mask             */

/* -------------------------------  NT_PWM2_AQCSFRC  ------------------------------ */
#define NT_PWM2_AQCSFRC_CSFA_Pos              0                                                       /*!< NT_PWM2 AQCSFRC: CSFA Position          */
#define NT_PWM2_AQCSFRC_CSFA_Msk              (0x03UL << NT_PWM2_AQCSFRC_CSFA_Pos)                    /*!< NT_PWM2 AQCSFRC: CSFA Mask              */
#define NT_PWM2_AQCSFRC_CSFB_Pos              2                                                       /*!< NT_PWM2 AQCSFRC: CSFB Position          */
#define NT_PWM2_AQCSFRC_CSFB_Msk              (0x03UL << NT_PWM2_AQCSFRC_CSFB_Pos)                    /*!< NT_PWM2 AQCSFRC: CSFB Mask              */

/* --------------------------------  NT_PWM2_DBCTL  ------------------------------- */
#define NT_PWM2_DBCTL_OUT_MODE_Pos            0                                                       /*!< NT_PWM2 DBCTL: OUT_MODE Position        */
#define NT_PWM2_DBCTL_OUT_MODE_Msk            (0x03UL << NT_PWM2_DBCTL_OUT_MODE_Pos)                  /*!< NT_PWM2 DBCTL: OUT_MODE Mask            */
#define NT_PWM2_DBCTL_POLSEL_Pos              2                                                       /*!< NT_PWM2 DBCTL: POLSEL Position          */
#define NT_PWM2_DBCTL_POLSEL_Msk              (0x03UL << NT_PWM2_DBCTL_POLSEL_Pos)                    /*!< NT_PWM2 DBCTL: POLSEL Mask              */
#define NT_PWM2_DBCTL_IN_MODE_Pos             4                                                       /*!< NT_PWM2 DBCTL: IN_MODE Position         */
#define NT_PWM2_DBCTL_IN_MODE_Msk             (0x03UL << NT_PWM2_DBCTL_IN_MODE_Pos)                   /*!< NT_PWM2 DBCTL: IN_MODE Mask             */

/* --------------------------------  NT_PWM2_DBRED  ------------------------------- */
#define NT_PWM2_DBRED_DEL_Pos                 0                                                       /*!< NT_PWM2 DBRED: DEL Position             */
#define NT_PWM2_DBRED_DEL_Msk                 (0x000003ffUL << NT_PWM2_DBRED_DEL_Pos)                 /*!< NT_PWM2 DBRED: DEL Mask                 */

/* --------------------------------  NT_PWM2_DBFED  ------------------------------- */
#define NT_PWM2_DBFED_DEL_Pos                 0                                                       /*!< NT_PWM2 DBFED: DEL Position             */
#define NT_PWM2_DBFED_DEL_Msk                 (0x000003ffUL << NT_PWM2_DBFED_DEL_Pos)                 /*!< NT_PWM2 DBFED: DEL Mask                 */

/* --------------------------------  NT_PWM2_TZSEL  ------------------------------- */
#define NT_PWM2_TZSEL_CBC0_Pos                0                                                       /*!< NT_PWM2 TZSEL: CBC0 Position            */
#define NT_PWM2_TZSEL_CBC0_Msk                (0x01UL << NT_PWM2_TZSEL_CBC0_Pos)                      /*!< NT_PWM2 TZSEL: CBC0 Mask                */
#define NT_PWM2_TZSEL_CBC1_Pos                1                                                       /*!< NT_PWM2 TZSEL: CBC1 Position            */
#define NT_PWM2_TZSEL_CBC1_Msk                (0x01UL << NT_PWM2_TZSEL_CBC1_Pos)                      /*!< NT_PWM2 TZSEL: CBC1 Mask                */
#define NT_PWM2_TZSEL_CBC2_Pos                2                                                       /*!< NT_PWM2 TZSEL: CBC2 Position            */
#define NT_PWM2_TZSEL_CBC2_Msk                (0x01UL << NT_PWM2_TZSEL_CBC2_Pos)                      /*!< NT_PWM2 TZSEL: CBC2 Mask                */
#define NT_PWM2_TZSEL_CBC3_Pos                3                                                       /*!< NT_PWM2 TZSEL: CBC3 Position            */
#define NT_PWM2_TZSEL_CBC3_Msk                (0x01UL << NT_PWM2_TZSEL_CBC3_Pos)                      /*!< NT_PWM2 TZSEL: CBC3 Mask                */
#define NT_PWM2_TZSEL_CBC4_Pos                4                                                       /*!< NT_PWM2 TZSEL: CBC4 Position            */
#define NT_PWM2_TZSEL_CBC4_Msk                (0x01UL << NT_PWM2_TZSEL_CBC4_Pos)                      /*!< NT_PWM2 TZSEL: CBC4 Mask                */
#define NT_PWM2_TZSEL_CBC5_Pos                5                                                       /*!< NT_PWM2 TZSEL: CBC5 Position            */
#define NT_PWM2_TZSEL_CBC5_Msk                (0x01UL << NT_PWM2_TZSEL_CBC5_Pos)                      /*!< NT_PWM2 TZSEL: CBC5 Mask                */
#define NT_PWM2_TZSEL_OSHT0_Pos               8                                                       /*!< NT_PWM2 TZSEL: OSHT0 Position           */
#define NT_PWM2_TZSEL_OSHT0_Msk               (0x01UL << NT_PWM2_TZSEL_OSHT0_Pos)                     /*!< NT_PWM2 TZSEL: OSHT0 Mask               */
#define NT_PWM2_TZSEL_OSHT1_Pos               9                                                       /*!< NT_PWM2 TZSEL: OSHT1 Position           */
#define NT_PWM2_TZSEL_OSHT1_Msk               (0x01UL << NT_PWM2_TZSEL_OSHT1_Pos)                     /*!< NT_PWM2 TZSEL: OSHT1 Mask               */
#define NT_PWM2_TZSEL_OSHT2_Pos               10                                                      /*!< NT_PWM2 TZSEL: OSHT2 Position           */
#define NT_PWM2_TZSEL_OSHT2_Msk               (0x01UL << NT_PWM2_TZSEL_OSHT2_Pos)                     /*!< NT_PWM2 TZSEL: OSHT2 Mask               */
#define NT_PWM2_TZSEL_OSHT3_Pos               11                                                      /*!< NT_PWM2 TZSEL: OSHT3 Position           */
#define NT_PWM2_TZSEL_OSHT3_Msk               (0x01UL << NT_PWM2_TZSEL_OSHT3_Pos)                     /*!< NT_PWM2 TZSEL: OSHT3 Mask               */
#define NT_PWM2_TZSEL_OSHT4_Pos               12                                                      /*!< NT_PWM2 TZSEL: OSHT4 Position           */
#define NT_PWM2_TZSEL_OSHT4_Msk               (0x01UL << NT_PWM2_TZSEL_OSHT4_Pos)                     /*!< NT_PWM2 TZSEL: OSHT4 Mask               */
#define NT_PWM2_TZSEL_OSHT5_Pos               13                                                      /*!< NT_PWM2 TZSEL: OSHT5 Position           */
#define NT_PWM2_TZSEL_OSHT5_Msk               (0x01UL << NT_PWM2_TZSEL_OSHT5_Pos)                     /*!< NT_PWM2 TZSEL: OSHT5 Mask               */

/* --------------------------------  NT_PWM2_TZCTL  ------------------------------- */
#define NT_PWM2_TZCTL_TZA_Pos                 0                                                       /*!< NT_PWM2 TZCTL: TZA Position             */
#define NT_PWM2_TZCTL_TZA_Msk                 (0x03UL << NT_PWM2_TZCTL_TZA_Pos)                       /*!< NT_PWM2 TZCTL: TZA Mask                 */
#define NT_PWM2_TZCTL_TZB_Pos                 2                                                       /*!< NT_PWM2 TZCTL: TZB Position             */
#define NT_PWM2_TZCTL_TZB_Msk                 (0x03UL << NT_PWM2_TZCTL_TZB_Pos)                       /*!< NT_PWM2 TZCTL: TZB Mask                 */

/* -------------------------------  NT_PWM2_TZEINT  ------------------------------- */
#define NT_PWM2_TZEINT_CBC_Pos                1                                                       /*!< NT_PWM2 TZEINT: CBC Position            */
#define NT_PWM2_TZEINT_CBC_Msk                (0x01UL << NT_PWM2_TZEINT_CBC_Pos)                      /*!< NT_PWM2 TZEINT: CBC Mask                */
#define NT_PWM2_TZEINT_OST_Pos                2                                                       /*!< NT_PWM2 TZEINT: OST Position            */
#define NT_PWM2_TZEINT_OST_Msk                (0x01UL << NT_PWM2_TZEINT_OST_Pos)                      /*!< NT_PWM2 TZEINT: OST Mask                */

/* --------------------------------  NT_PWM2_TZFLG  ------------------------------- */
#define NT_PWM2_TZFLG_INT_Pos                 0                                                       /*!< NT_PWM2 TZFLG: INT Position             */
#define NT_PWM2_TZFLG_INT_Msk                 (0x01UL << NT_PWM2_TZFLG_INT_Pos)                       /*!< NT_PWM2 TZFLG: INT Mask                 */
#define NT_PWM2_TZFLG_CBC_Pos                 1                                                       /*!< NT_PWM2 TZFLG: CBC Position             */
#define NT_PWM2_TZFLG_CBC_Msk                 (0x01UL << NT_PWM2_TZFLG_CBC_Pos)                       /*!< NT_PWM2 TZFLG: CBC Mask                 */
#define NT_PWM2_TZFLG_OST_Pos                 2                                                       /*!< NT_PWM2 TZFLG: OST Position             */
#define NT_PWM2_TZFLG_OST_Msk                 (0x01UL << NT_PWM2_TZFLG_OST_Pos)                       /*!< NT_PWM2 TZFLG: OST Mask                 */

/* --------------------------------  NT_PWM2_TZCLR  ------------------------------- */
#define NT_PWM2_TZCLR_INT_Pos                 0                                                       /*!< NT_PWM2 TZCLR: INT Position             */
#define NT_PWM2_TZCLR_INT_Msk                 (0x01UL << NT_PWM2_TZCLR_INT_Pos)                       /*!< NT_PWM2 TZCLR: INT Mask                 */
#define NT_PWM2_TZCLR_CBC_Pos                 1                                                       /*!< NT_PWM2 TZCLR: CBC Position             */
#define NT_PWM2_TZCLR_CBC_Msk                 (0x01UL << NT_PWM2_TZCLR_CBC_Pos)                       /*!< NT_PWM2 TZCLR: CBC Mask                 */
#define NT_PWM2_TZCLR_OST_Pos                 2                                                       /*!< NT_PWM2 TZCLR: OST Position             */
#define NT_PWM2_TZCLR_OST_Msk                 (0x01UL << NT_PWM2_TZCLR_OST_Pos)                       /*!< NT_PWM2 TZCLR: OST Mask                 */

/* --------------------------------  NT_PWM2_TZFRC  ------------------------------- */
#define NT_PWM2_TZFRC_CBC_Pos                 1                                                       /*!< NT_PWM2 TZFRC: CBC Position             */
#define NT_PWM2_TZFRC_CBC_Msk                 (0x01UL << NT_PWM2_TZFRC_CBC_Pos)                       /*!< NT_PWM2 TZFRC: CBC Mask                 */
#define NT_PWM2_TZFRC_OST_Pos                 2                                                       /*!< NT_PWM2 TZFRC: OST Position             */
#define NT_PWM2_TZFRC_OST_Msk                 (0x01UL << NT_PWM2_TZFRC_OST_Pos)                       /*!< NT_PWM2 TZFRC: OST Mask                 */

/* --------------------------------  NT_PWM2_ETSEL  ------------------------------- */
#define NT_PWM2_ETSEL_INTSEL_Pos              0                                                       /*!< NT_PWM2 ETSEL: INTSEL Position          */
#define NT_PWM2_ETSEL_INTSEL_Msk              (0x07UL << NT_PWM2_ETSEL_INTSEL_Pos)                    /*!< NT_PWM2 ETSEL: INTSEL Mask              */
#define NT_PWM2_ETSEL_INTEN_Pos               3                                                       /*!< NT_PWM2 ETSEL: INTEN Position           */
#define NT_PWM2_ETSEL_INTEN_Msk               (0x01UL << NT_PWM2_ETSEL_INTEN_Pos)                     /*!< NT_PWM2 ETSEL: INTEN Mask               */
#define NT_PWM2_ETSEL_SOCASEL_Pos             8                                                       /*!< NT_PWM2 ETSEL: SOCASEL Position         */
#define NT_PWM2_ETSEL_SOCASEL_Msk             (0x07UL << NT_PWM2_ETSEL_SOCASEL_Pos)                   /*!< NT_PWM2 ETSEL: SOCASEL Mask             */
#define NT_PWM2_ETSEL_SOCAEN_Pos              11                                                      /*!< NT_PWM2 ETSEL: SOCAEN Position          */
#define NT_PWM2_ETSEL_SOCAEN_Msk              (0x01UL << NT_PWM2_ETSEL_SOCAEN_Pos)                    /*!< NT_PWM2 ETSEL: SOCAEN Mask              */
#define NT_PWM2_ETSEL_SOCBSEL_Pos             12                                                      /*!< NT_PWM2 ETSEL: SOCBSEL Position         */
#define NT_PWM2_ETSEL_SOCBSEL_Msk             (0x07UL << NT_PWM2_ETSEL_SOCBSEL_Pos)                   /*!< NT_PWM2 ETSEL: SOCBSEL Mask             */
#define NT_PWM2_ETSEL_SOCBEN_Pos              15                                                      /*!< NT_PWM2 ETSEL: SOCBEN Position          */
#define NT_PWM2_ETSEL_SOCBEN_Msk              (0x01UL << NT_PWM2_ETSEL_SOCBEN_Pos)                    /*!< NT_PWM2 ETSEL: SOCBEN Mask              */

/* --------------------------------  NT_PWM2_ETPS  -------------------------------- */
#define NT_PWM2_ETPS_INTPRD_Pos               0                                                       /*!< NT_PWM2 ETPS: INTPRD Position           */
#define NT_PWM2_ETPS_INTPRD_Msk               (0x03UL << NT_PWM2_ETPS_INTPRD_Pos)                     /*!< NT_PWM2 ETPS: INTPRD Mask               */
#define NT_PWM2_ETPS_INTCNT_Pos               2                                                       /*!< NT_PWM2 ETPS: INTCNT Position           */
#define NT_PWM2_ETPS_INTCNT_Msk               (0x03UL << NT_PWM2_ETPS_INTCNT_Pos)                     /*!< NT_PWM2 ETPS: INTCNT Mask               */
#define NT_PWM2_ETPS_SOCAPRD_Pos              8                                                       /*!< NT_PWM2 ETPS: SOCAPRD Position          */
#define NT_PWM2_ETPS_SOCAPRD_Msk              (0x03UL << NT_PWM2_ETPS_SOCAPRD_Pos)                    /*!< NT_PWM2 ETPS: SOCAPRD Mask              */
#define NT_PWM2_ETPS_SOCACNT_Pos              10                                                      /*!< NT_PWM2 ETPS: SOCACNT Position          */
#define NT_PWM2_ETPS_SOCACNT_Msk              (0x03UL << NT_PWM2_ETPS_SOCACNT_Pos)                    /*!< NT_PWM2 ETPS: SOCACNT Mask              */
#define NT_PWM2_ETPS_SOCPRD_Pos               12                                                      /*!< NT_PWM2 ETPS: SOCPRD Position           */
#define NT_PWM2_ETPS_SOCPRD_Msk               (0x03UL << NT_PWM2_ETPS_SOCPRD_Pos)                     /*!< NT_PWM2 ETPS: SOCPRD Mask               */
#define NT_PWM2_ETPS_SOCBCNT_Pos              14                                                      /*!< NT_PWM2 ETPS: SOCBCNT Position          */
#define NT_PWM2_ETPS_SOCBCNT_Msk              (0x03UL << NT_PWM2_ETPS_SOCBCNT_Pos)                    /*!< NT_PWM2 ETPS: SOCBCNT Mask              */

/* --------------------------------  NT_PWM2_ETFLG  ------------------------------- */
#define NT_PWM2_ETFLG_INT_Pos                 0                                                       /*!< NT_PWM2 ETFLG: INT Position             */
#define NT_PWM2_ETFLG_INT_Msk                 (0x01UL << NT_PWM2_ETFLG_INT_Pos)                       /*!< NT_PWM2 ETFLG: INT Mask                 */
#define NT_PWM2_ETFLG_SOCA_Pos                2                                                       /*!< NT_PWM2 ETFLG: SOCA Position            */
#define NT_PWM2_ETFLG_SOCA_Msk                (0x01UL << NT_PWM2_ETFLG_SOCA_Pos)                      /*!< NT_PWM2 ETFLG: SOCA Mask                */
#define NT_PWM2_ETFLG_SOCB_Pos                3                                                       /*!< NT_PWM2 ETFLG: SOCB Position            */
#define NT_PWM2_ETFLG_SOCB_Msk                (0x01UL << NT_PWM2_ETFLG_SOCB_Pos)                      /*!< NT_PWM2 ETFLG: SOCB Mask                */

/* --------------------------------  NT_PWM2_ETCLR  ------------------------------- */
#define NT_PWM2_ETCLR_INT_Pos                 0                                                       /*!< NT_PWM2 ETCLR: INT Position             */
#define NT_PWM2_ETCLR_INT_Msk                 (0x01UL << NT_PWM2_ETCLR_INT_Pos)                       /*!< NT_PWM2 ETCLR: INT Mask                 */
#define NT_PWM2_ETCLR_SOCA_Pos                2                                                       /*!< NT_PWM2 ETCLR: SOCA Position            */
#define NT_PWM2_ETCLR_SOCA_Msk                (0x01UL << NT_PWM2_ETCLR_SOCA_Pos)                      /*!< NT_PWM2 ETCLR: SOCA Mask                */
#define NT_PWM2_ETCLR_SOCB_Pos                3                                                       /*!< NT_PWM2 ETCLR: SOCB Position            */
#define NT_PWM2_ETCLR_SOCB_Msk                (0x01UL << NT_PWM2_ETCLR_SOCB_Pos)                      /*!< NT_PWM2 ETCLR: SOCB Mask                */

/* --------------------------------  NT_PWM2_ETFRC  ------------------------------- */
#define NT_PWM2_ETFRC_INT_Pos                 0                                                       /*!< NT_PWM2 ETFRC: INT Position             */
#define NT_PWM2_ETFRC_INT_Msk                 (0x01UL << NT_PWM2_ETFRC_INT_Pos)                       /*!< NT_PWM2 ETFRC: INT Mask                 */
#define NT_PWM2_ETFRC_SOCA_Pos                2                                                       /*!< NT_PWM2 ETFRC: SOCA Position            */
#define NT_PWM2_ETFRC_SOCA_Msk                (0x01UL << NT_PWM2_ETFRC_SOCA_Pos)                      /*!< NT_PWM2 ETFRC: SOCA Mask                */
#define NT_PWM2_ETFRC_SOCB_Pos                3                                                       /*!< NT_PWM2 ETFRC: SOCB Position            */
#define NT_PWM2_ETFRC_SOCB_Msk                (0x01UL << NT_PWM2_ETFRC_SOCB_Pos)                      /*!< NT_PWM2 ETFRC: SOCB Mask                */

/* --------------------------------  NT_PWM2_PCCTL  ------------------------------- */
#define NT_PWM2_PCCTL_CHPEN_Pos               0                                                       /*!< NT_PWM2 PCCTL: CHPEN Position           */
#define NT_PWM2_PCCTL_CHPEN_Msk               (0x01UL << NT_PWM2_PCCTL_CHPEN_Pos)                     /*!< NT_PWM2 PCCTL: CHPEN Mask               */
#define NT_PWM2_PCCTL_OSHTWTH_Pos             1                                                       /*!< NT_PWM2 PCCTL: OSHTWTH Position         */
#define NT_PWM2_PCCTL_OSHTWTH_Msk             (0x0fUL << NT_PWM2_PCCTL_OSHTWTH_Pos)                   /*!< NT_PWM2 PCCTL: OSHTWTH Mask             */
#define NT_PWM2_PCCTL_SHRFREQ_Pos             5                                                       /*!< NT_PWM2 PCCTL: SHRFREQ Position         */
#define NT_PWM2_PCCTL_SHRFREQ_Msk             (0x07UL << NT_PWM2_PCCTL_SHRFREQ_Pos)                   /*!< NT_PWM2 PCCTL: SHRFREQ Mask             */
#define NT_PWM2_PCCTL_CHPDUTY_Pos             8                                                       /*!< NT_PWM2 PCCTL: CHPDUTY Position         */
#define NT_PWM2_PCCTL_CHPDUTY_Msk             (0x07UL << NT_PWM2_PCCTL_CHPDUTY_Pos)                   /*!< NT_PWM2 PCCTL: CHPDUTY Mask             */

/* -------------------------------  NT_PWM2_HRCNFG  ------------------------------- */
#define NT_PWM2_HRCNFG_EDGMODE_Pos            0                                                       /*!< NT_PWM2 HRCNFG: EDGMODE Position        */
#define NT_PWM2_HRCNFG_EDGMODE_Msk            (0x03UL << NT_PWM2_HRCNFG_EDGMODE_Pos)                  /*!< NT_PWM2 HRCNFG: EDGMODE Mask            */
#define NT_PWM2_HRCNFG_CTLMODE_Pos            2                                                       /*!< NT_PWM2 HRCNFG: CTLMODE Position        */
#define NT_PWM2_HRCNFG_CTLMODE_Msk            (0x01UL << NT_PWM2_HRCNFG_CTLMODE_Pos)                  /*!< NT_PWM2 HRCNFG: CTLMODE Mask            */
#define NT_PWM2_HRCNFG_HR_LOAD_Pos            3                                                       /*!< NT_PWM2 HRCNFG: HR_LOAD Position        */
#define NT_PWM2_HRCNFG_HR_LOAD_Msk            (0x01UL << NT_PWM2_HRCNFG_HR_LOAD_Pos)                  /*!< NT_PWM2 HRCNFG: HR_LOAD Mask            */
#define NT_PWM2_HRCNFG_MEP_SCALEFACTOR_Pos    16                                                      /*!< NT_PWM2 HRCNFG: MEP_SCALEFACTOR Position */
#define NT_PWM2_HRCNFG_MEP_SCALEFACTOR_Msk    (0x000000ffUL << NT_PWM2_HRCNFG_MEP_SCALEFACTOR_Pos)    /*!< NT_PWM2 HRCNFG: MEP_SCALEFACTOR Mask    */

/* --------------------------------  NT_PWM2_FWDTH  ------------------------------- */
#define NT_PWM2_FWDTH_FWDTH_Pos               0                                                       /*!< NT_PWM2 FWDTH: FWDTH Position           */
#define NT_PWM2_FWDTH_FWDTH_Msk               (0x000000ffUL << NT_PWM2_FWDTH_FWDTH_Pos)               /*!< NT_PWM2 FWDTH: FWDTH Mask               */

/* --------------------------------  NT_PWM2_HDSEL  ------------------------------- */
#define NT_PWM2_HDSEL_DCMP_Pos                0                                                       /*!< NT_PWM2 HDSEL: DCMP Position            */
#define NT_PWM2_HDSEL_DCMP_Msk                (0x00ffffffUL << NT_PWM2_HDSEL_DCMP_Pos)                /*!< NT_PWM2 HDSEL: DCMP Mask                */
#define NT_PWM2_HDSEL_ACMP_Pos                24                                                      /*!< NT_PWM2 HDSEL: ACMP Position            */
#define NT_PWM2_HDSEL_ACMP_Msk                (0x07UL << NT_PWM2_HDSEL_ACMP_Pos)                      /*!< NT_PWM2 HDSEL: ACMP Mask                */

/* --------------------------------  NT_PWM2_HDCTL  ------------------------------- */
#define NT_PWM2_HDCTL_HDA_Pos                 0                                                       /*!< NT_PWM2 HDCTL: HDA Position             */
#define NT_PWM2_HDCTL_HDA_Msk                 (0x03UL << NT_PWM2_HDCTL_HDA_Pos)                       /*!< NT_PWM2 HDCTL: HDA Mask                 */
#define NT_PWM2_HDCTL_HDB_Pos                 2                                                       /*!< NT_PWM2 HDCTL: HDB Position             */
#define NT_PWM2_HDCTL_HDB_Msk                 (0x03UL << NT_PWM2_HDCTL_HDB_Pos)                       /*!< NT_PWM2 HDCTL: HDB Mask                 */

/* -------------------------------  NT_PWM2_HDEINT  ------------------------------- */
#define NT_PWM2_HDEINT_CBC_Pos                1                                                       /*!< NT_PWM2 HDEINT: CBC Position            */
#define NT_PWM2_HDEINT_CBC_Msk                (0x01UL << NT_PWM2_HDEINT_CBC_Pos)                      /*!< NT_PWM2 HDEINT: CBC Mask                */
#define NT_PWM2_HDEINT_OST_Pos                2                                                       /*!< NT_PWM2 HDEINT: OST Position            */
#define NT_PWM2_HDEINT_OST_Msk                (0x01UL << NT_PWM2_HDEINT_OST_Pos)                      /*!< NT_PWM2 HDEINT: OST Mask                */

/* --------------------------------  NT_PWM2_HDFLG  ------------------------------- */
#define NT_PWM2_HDFLG_HDINT_Pos               0                                                       /*!< NT_PWM2 HDFLG: HDINT Position           */
#define NT_PWM2_HDFLG_HDINT_Msk               (0x01UL << NT_PWM2_HDFLG_HDINT_Pos)                     /*!< NT_PWM2 HDFLG: HDINT Mask               */
#define NT_PWM2_HDFLG_CBC_Pos                 1                                                       /*!< NT_PWM2 HDFLG: CBC Position             */
#define NT_PWM2_HDFLG_CBC_Msk                 (0x01UL << NT_PWM2_HDFLG_CBC_Pos)                       /*!< NT_PWM2 HDFLG: CBC Mask                 */
#define NT_PWM2_HDFLG_OST_Pos                 2                                                       /*!< NT_PWM2 HDFLG: OST Position             */
#define NT_PWM2_HDFLG_OST_Msk                 (0x01UL << NT_PWM2_HDFLG_OST_Pos)                       /*!< NT_PWM2 HDFLG: OST Mask                 */

/* --------------------------------  NT_PWM2_HDCLR  ------------------------------- */
#define NT_PWM2_HDCLR_HDINT_Pos               0                                                       /*!< NT_PWM2 HDCLR: HDINT Position           */
#define NT_PWM2_HDCLR_HDINT_Msk               (0x01UL << NT_PWM2_HDCLR_HDINT_Pos)                     /*!< NT_PWM2 HDCLR: HDINT Mask               */

/* --------------------------------  NT_PWM2_HDFRC  ------------------------------- */
#define NT_PWM2_HDFRC_CBC_Pos                 1                                                       /*!< NT_PWM2 HDFRC: CBC Position             */
#define NT_PWM2_HDFRC_CBC_Msk                 (0x01UL << NT_PWM2_HDFRC_CBC_Pos)                       /*!< NT_PWM2 HDFRC: CBC Mask                 */
#define NT_PWM2_HDFRC_OST_Pos                 2                                                       /*!< NT_PWM2 HDFRC: OST Position             */
#define NT_PWM2_HDFRC_OST_Msk                 (0x01UL << NT_PWM2_HDFRC_OST_Pos)                       /*!< NT_PWM2 HDFRC: OST Mask                 */

/* ------------------------------  NT_PWM2_HDINTCLR  ------------------------------ */
#define NT_PWM2_HDINTCLR_HDINT_Pos            0                                                       /*!< NT_PWM2 HDINTCLR: HDINT Position        */
#define NT_PWM2_HDINTCLR_HDINT_Msk            (0x01UL << NT_PWM2_HDINTCLR_HDINT_Pos)                  /*!< NT_PWM2 HDINTCLR: HDINT Mask            */

/* ------------------------------  NT_PWM2_TZINTCLR  ------------------------------ */
#define NT_PWM2_TZINTCLR_TZINT_Pos            0                                                       /*!< NT_PWM2 TZINTCLR: TZINT Position        */
#define NT_PWM2_TZINTCLR_TZINT_Msk            (0x01UL << NT_PWM2_TZINTCLR_TZINT_Pos)                  /*!< NT_PWM2 TZINTCLR: TZINT Mask            */

/* -------------------------------  NT_PWM2_INTCLR  ------------------------------- */
#define NT_PWM2_INTCLR_INT_Pos                0                                                       /*!< NT_PWM2 INTCLR: INT Position            */
#define NT_PWM2_INTCLR_INT_Msk                (0x01UL << NT_PWM2_INTCLR_INT_Pos)                      /*!< NT_PWM2 INTCLR: INT Mask                */


/* ================================================================================ */
/* ================        struct 'NT_PWM3' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_PWM3_TBCTL  ------------------------------- */
#define NT_PWM3_TBCTL_CTRMODE_Pos             0                                                       /*!< NT_PWM3 TBCTL: CTRMODE Position         */
#define NT_PWM3_TBCTL_CTRMODE_Msk             (0x03UL << NT_PWM3_TBCTL_CTRMODE_Pos)                   /*!< NT_PWM3 TBCTL: CTRMODE Mask             */
#define NT_PWM3_TBCTL_PHSEN_Pos               2                                                       /*!< NT_PWM3 TBCTL: PHSEN Position           */
#define NT_PWM3_TBCTL_PHSEN_Msk               (0x01UL << NT_PWM3_TBCTL_PHSEN_Pos)                     /*!< NT_PWM3 TBCTL: PHSEN Mask               */
#define NT_PWM3_TBCTL_PRDLD_Pos               3                                                       /*!< NT_PWM3 TBCTL: PRDLD Position           */
#define NT_PWM3_TBCTL_PRDLD_Msk               (0x01UL << NT_PWM3_TBCTL_PRDLD_Pos)                     /*!< NT_PWM3 TBCTL: PRDLD Mask               */
#define NT_PWM3_TBCTL_SYNCOSEL_Pos            4                                                       /*!< NT_PWM3 TBCTL: SYNCOSEL Position        */
#define NT_PWM3_TBCTL_SYNCOSEL_Msk            (0x03UL << NT_PWM3_TBCTL_SYNCOSEL_Pos)                  /*!< NT_PWM3 TBCTL: SYNCOSEL Mask            */
#define NT_PWM3_TBCTL_SWFSYNC_Pos             6                                                       /*!< NT_PWM3 TBCTL: SWFSYNC Position         */
#define NT_PWM3_TBCTL_SWFSYNC_Msk             (0x01UL << NT_PWM3_TBCTL_SWFSYNC_Pos)                   /*!< NT_PWM3 TBCTL: SWFSYNC Mask             */
#define NT_PWM3_TBCTL_HSPCLKDIV_Pos           7                                                       /*!< NT_PWM3 TBCTL: HSPCLKDIV Position       */
#define NT_PWM3_TBCTL_HSPCLKDIV_Msk           (0x07UL << NT_PWM3_TBCTL_HSPCLKDIV_Pos)                 /*!< NT_PWM3 TBCTL: HSPCLKDIV Mask           */
#define NT_PWM3_TBCTL_CLKDIV_Pos              10                                                      /*!< NT_PWM3 TBCTL: CLKDIV Position          */
#define NT_PWM3_TBCTL_CLKDIV_Msk              (0x07UL << NT_PWM3_TBCTL_CLKDIV_Pos)                    /*!< NT_PWM3 TBCTL: CLKDIV Mask              */
#define NT_PWM3_TBCTL_PHSDIR_Pos              13                                                      /*!< NT_PWM3 TBCTL: PHSDIR Position          */
#define NT_PWM3_TBCTL_PHSDIR_Msk              (0x01UL << NT_PWM3_TBCTL_PHSDIR_Pos)                    /*!< NT_PWM3 TBCTL: PHSDIR Mask              */
#define NT_PWM3_TBCTL_FREE_SOFT_Pos           14                                                      /*!< NT_PWM3 TBCTL: FREE_SOFT Position       */
#define NT_PWM3_TBCTL_FREE_SOFT_Msk           (0x03UL << NT_PWM3_TBCTL_FREE_SOFT_Pos)                 /*!< NT_PWM3 TBCTL: FREE_SOFT Mask           */

/* --------------------------------  NT_PWM3_TBSTS  ------------------------------- */
#define NT_PWM3_TBSTS_CTRDIR_Pos              0                                                       /*!< NT_PWM3 TBSTS: CTRDIR Position          */
#define NT_PWM3_TBSTS_CTRDIR_Msk              (0x01UL << NT_PWM3_TBSTS_CTRDIR_Pos)                    /*!< NT_PWM3 TBSTS: CTRDIR Mask              */
#define NT_PWM3_TBSTS_SYNCI_Pos               1                                                       /*!< NT_PWM3 TBSTS: SYNCI Position           */
#define NT_PWM3_TBSTS_SYNCI_Msk               (0x01UL << NT_PWM3_TBSTS_SYNCI_Pos)                     /*!< NT_PWM3 TBSTS: SYNCI Mask               */
#define NT_PWM3_TBSTS_CTRMAX_Pos              2                                                       /*!< NT_PWM3 TBSTS: CTRMAX Position          */
#define NT_PWM3_TBSTS_CTRMAX_Msk              (0x01UL << NT_PWM3_TBSTS_CTRMAX_Pos)                    /*!< NT_PWM3 TBSTS: CTRMAX Mask              */

/* --------------------------------  NT_PWM3_TBPHS  ------------------------------- */
#define NT_PWM3_TBPHS_TBPHSHR_Pos             8                                                       /*!< NT_PWM3 TBPHS: TBPHSHR Position         */
#define NT_PWM3_TBPHS_TBPHSHR_Msk             (0x000000ffUL << NT_PWM3_TBPHS_TBPHSHR_Pos)             /*!< NT_PWM3 TBPHS: TBPHSHR Mask             */
#define NT_PWM3_TBPHS_TBPHS_Pos               16                                                      /*!< NT_PWM3 TBPHS: TBPHS Position           */
#define NT_PWM3_TBPHS_TBPHS_Msk               (0x0000ffffUL << NT_PWM3_TBPHS_TBPHS_Pos)               /*!< NT_PWM3 TBPHS: TBPHS Mask               */

/* --------------------------------  NT_PWM3_TBCTR  ------------------------------- */
#define NT_PWM3_TBCTR_TBCTR_Pos               0                                                       /*!< NT_PWM3 TBCTR: TBCTR Position           */
#define NT_PWM3_TBCTR_TBCTR_Msk               (0x0000ffffUL << NT_PWM3_TBCTR_TBCTR_Pos)               /*!< NT_PWM3 TBCTR: TBCTR Mask               */

/* --------------------------------  NT_PWM3_TBPRD  ------------------------------- */
#define NT_PWM3_TBPRD_TBPRD_Pos               0                                                       /*!< NT_PWM3 TBPRD: TBPRD Position           */
#define NT_PWM3_TBPRD_TBPRD_Msk               (0x0000ffffUL << NT_PWM3_TBPRD_TBPRD_Pos)               /*!< NT_PWM3 TBPRD: TBPRD Mask               */

/* -------------------------------  NT_PWM3_CMPCTL  ------------------------------- */
#define NT_PWM3_CMPCTL_LOADAMODE_Pos          0                                                       /*!< NT_PWM3 CMPCTL: LOADAMODE Position      */
#define NT_PWM3_CMPCTL_LOADAMODE_Msk          (0x03UL << NT_PWM3_CMPCTL_LOADAMODE_Pos)                /*!< NT_PWM3 CMPCTL: LOADAMODE Mask          */
#define NT_PWM3_CMPCTL_LOADBMODE_Pos          2                                                       /*!< NT_PWM3 CMPCTL: LOADBMODE Position      */
#define NT_PWM3_CMPCTL_LOADBMODE_Msk          (0x03UL << NT_PWM3_CMPCTL_LOADBMODE_Pos)                /*!< NT_PWM3 CMPCTL: LOADBMODE Mask          */
#define NT_PWM3_CMPCTL_SHDWAMODE_Pos          4                                                       /*!< NT_PWM3 CMPCTL: SHDWAMODE Position      */
#define NT_PWM3_CMPCTL_SHDWAMODE_Msk          (0x01UL << NT_PWM3_CMPCTL_SHDWAMODE_Pos)                /*!< NT_PWM3 CMPCTL: SHDWAMODE Mask          */
#define NT_PWM3_CMPCTL_SHDWBMODE_Pos          6                                                       /*!< NT_PWM3 CMPCTL: SHDWBMODE Position      */
#define NT_PWM3_CMPCTL_SHDWBMODE_Msk          (0x01UL << NT_PWM3_CMPCTL_SHDWBMODE_Pos)                /*!< NT_PWM3 CMPCTL: SHDWBMODE Mask          */
#define NT_PWM3_CMPCTL_SHDWAFULL_Pos          8                                                       /*!< NT_PWM3 CMPCTL: SHDWAFULL Position      */
#define NT_PWM3_CMPCTL_SHDWAFULL_Msk          (0x01UL << NT_PWM3_CMPCTL_SHDWAFULL_Pos)                /*!< NT_PWM3 CMPCTL: SHDWAFULL Mask          */
#define NT_PWM3_CMPCTL_SHDWBFULL_Pos          9                                                       /*!< NT_PWM3 CMPCTL: SHDWBFULL Position      */
#define NT_PWM3_CMPCTL_SHDWBFULL_Msk          (0x01UL << NT_PWM3_CMPCTL_SHDWBFULL_Pos)                /*!< NT_PWM3 CMPCTL: SHDWBFULL Mask          */

/* --------------------------------  NT_PWM3_CMPA  -------------------------------- */
#define NT_PWM3_CMPA_CMPAHR_Pos               8                                                       /*!< NT_PWM3 CMPA: CMPAHR Position           */
#define NT_PWM3_CMPA_CMPAHR_Msk               (0x000000ffUL << NT_PWM3_CMPA_CMPAHR_Pos)               /*!< NT_PWM3 CMPA: CMPAHR Mask               */
#define NT_PWM3_CMPA_CMPA_Pos                 16                                                      /*!< NT_PWM3 CMPA: CMPA Position             */
#define NT_PWM3_CMPA_CMPA_Msk                 (0x0000ffffUL << NT_PWM3_CMPA_CMPA_Pos)                 /*!< NT_PWM3 CMPA: CMPA Mask                 */

/* --------------------------------  NT_PWM3_CMPB  -------------------------------- */
#define NT_PWM3_CMPB_CMPB_Pos                 16                                                      /*!< NT_PWM3 CMPB: CMPB Position             */
#define NT_PWM3_CMPB_CMPB_Msk                 (0x0000ffffUL << NT_PWM3_CMPB_CMPB_Pos)                 /*!< NT_PWM3 CMPB: CMPB Mask                 */

/* -------------------------------  NT_PWM3_AQCTLA  ------------------------------- */
#define NT_PWM3_AQCTLA_ZRO_Pos                0                                                       /*!< NT_PWM3 AQCTLA: ZRO Position            */
#define NT_PWM3_AQCTLA_ZRO_Msk                (0x03UL << NT_PWM3_AQCTLA_ZRO_Pos)                      /*!< NT_PWM3 AQCTLA: ZRO Mask                */
#define NT_PWM3_AQCTLA_PRD_Pos                2                                                       /*!< NT_PWM3 AQCTLA: PRD Position            */
#define NT_PWM3_AQCTLA_PRD_Msk                (0x03UL << NT_PWM3_AQCTLA_PRD_Pos)                      /*!< NT_PWM3 AQCTLA: PRD Mask                */
#define NT_PWM3_AQCTLA_CAU_Pos                4                                                       /*!< NT_PWM3 AQCTLA: CAU Position            */
#define NT_PWM3_AQCTLA_CAU_Msk                (0x03UL << NT_PWM3_AQCTLA_CAU_Pos)                      /*!< NT_PWM3 AQCTLA: CAU Mask                */
#define NT_PWM3_AQCTLA_CAD_Pos                6                                                       /*!< NT_PWM3 AQCTLA: CAD Position            */
#define NT_PWM3_AQCTLA_CAD_Msk                (0x03UL << NT_PWM3_AQCTLA_CAD_Pos)                      /*!< NT_PWM3 AQCTLA: CAD Mask                */
#define NT_PWM3_AQCTLA_CBU_Pos                8                                                       /*!< NT_PWM3 AQCTLA: CBU Position            */
#define NT_PWM3_AQCTLA_CBU_Msk                (0x03UL << NT_PWM3_AQCTLA_CBU_Pos)                      /*!< NT_PWM3 AQCTLA: CBU Mask                */
#define NT_PWM3_AQCTLA_CBD_Pos                10                                                      /*!< NT_PWM3 AQCTLA: CBD Position            */
#define NT_PWM3_AQCTLA_CBD_Msk                (0x03UL << NT_PWM3_AQCTLA_CBD_Pos)                      /*!< NT_PWM3 AQCTLA: CBD Mask                */

/* -------------------------------  NT_PWM3_AQCTLB  ------------------------------- */
#define NT_PWM3_AQCTLB_ZRO_Pos                0                                                       /*!< NT_PWM3 AQCTLB: ZRO Position            */
#define NT_PWM3_AQCTLB_ZRO_Msk                (0x03UL << NT_PWM3_AQCTLB_ZRO_Pos)                      /*!< NT_PWM3 AQCTLB: ZRO Mask                */
#define NT_PWM3_AQCTLB_PRD_Pos                2                                                       /*!< NT_PWM3 AQCTLB: PRD Position            */
#define NT_PWM3_AQCTLB_PRD_Msk                (0x03UL << NT_PWM3_AQCTLB_PRD_Pos)                      /*!< NT_PWM3 AQCTLB: PRD Mask                */
#define NT_PWM3_AQCTLB_CAU_Pos                4                                                       /*!< NT_PWM3 AQCTLB: CAU Position            */
#define NT_PWM3_AQCTLB_CAU_Msk                (0x03UL << NT_PWM3_AQCTLB_CAU_Pos)                      /*!< NT_PWM3 AQCTLB: CAU Mask                */
#define NT_PWM3_AQCTLB_CAD_Pos                6                                                       /*!< NT_PWM3 AQCTLB: CAD Position            */
#define NT_PWM3_AQCTLB_CAD_Msk                (0x03UL << NT_PWM3_AQCTLB_CAD_Pos)                      /*!< NT_PWM3 AQCTLB: CAD Mask                */
#define NT_PWM3_AQCTLB_CBU_Pos                8                                                       /*!< NT_PWM3 AQCTLB: CBU Position            */
#define NT_PWM3_AQCTLB_CBU_Msk                (0x03UL << NT_PWM3_AQCTLB_CBU_Pos)                      /*!< NT_PWM3 AQCTLB: CBU Mask                */
#define NT_PWM3_AQCTLB_CBD_Pos                10                                                      /*!< NT_PWM3 AQCTLB: CBD Position            */
#define NT_PWM3_AQCTLB_CBD_Msk                (0x03UL << NT_PWM3_AQCTLB_CBD_Pos)                      /*!< NT_PWM3 AQCTLB: CBD Mask                */

/* -------------------------------  NT_PWM3_AQSFRC  ------------------------------- */
#define NT_PWM3_AQSFRC_ACTSFA_Pos             0                                                       /*!< NT_PWM3 AQSFRC: ACTSFA Position         */
#define NT_PWM3_AQSFRC_ACTSFA_Msk             (0x03UL << NT_PWM3_AQSFRC_ACTSFA_Pos)                   /*!< NT_PWM3 AQSFRC: ACTSFA Mask             */
#define NT_PWM3_AQSFRC_OTSFA_Pos              2                                                       /*!< NT_PWM3 AQSFRC: OTSFA Position          */
#define NT_PWM3_AQSFRC_OTSFA_Msk              (0x01UL << NT_PWM3_AQSFRC_OTSFA_Pos)                    /*!< NT_PWM3 AQSFRC: OTSFA Mask              */
#define NT_PWM3_AQSFRC_ACTSFB_Pos             3                                                       /*!< NT_PWM3 AQSFRC: ACTSFB Position         */
#define NT_PWM3_AQSFRC_ACTSFB_Msk             (0x03UL << NT_PWM3_AQSFRC_ACTSFB_Pos)                   /*!< NT_PWM3 AQSFRC: ACTSFB Mask             */
#define NT_PWM3_AQSFRC_OTSFB_Pos              5                                                       /*!< NT_PWM3 AQSFRC: OTSFB Position          */
#define NT_PWM3_AQSFRC_OTSFB_Msk              (0x01UL << NT_PWM3_AQSFRC_OTSFB_Pos)                    /*!< NT_PWM3 AQSFRC: OTSFB Mask              */
#define NT_PWM3_AQSFRC_RLDCSF_Pos             6                                                       /*!< NT_PWM3 AQSFRC: RLDCSF Position         */
#define NT_PWM3_AQSFRC_RLDCSF_Msk             (0x03UL << NT_PWM3_AQSFRC_RLDCSF_Pos)                   /*!< NT_PWM3 AQSFRC: RLDCSF Mask             */

/* -------------------------------  NT_PWM3_AQCSFRC  ------------------------------ */
#define NT_PWM3_AQCSFRC_CSFA_Pos              0                                                       /*!< NT_PWM3 AQCSFRC: CSFA Position          */
#define NT_PWM3_AQCSFRC_CSFA_Msk              (0x03UL << NT_PWM3_AQCSFRC_CSFA_Pos)                    /*!< NT_PWM3 AQCSFRC: CSFA Mask              */
#define NT_PWM3_AQCSFRC_CSFB_Pos              2                                                       /*!< NT_PWM3 AQCSFRC: CSFB Position          */
#define NT_PWM3_AQCSFRC_CSFB_Msk              (0x03UL << NT_PWM3_AQCSFRC_CSFB_Pos)                    /*!< NT_PWM3 AQCSFRC: CSFB Mask              */

/* --------------------------------  NT_PWM3_DBCTL  ------------------------------- */
#define NT_PWM3_DBCTL_OUT_MODE_Pos            0                                                       /*!< NT_PWM3 DBCTL: OUT_MODE Position        */
#define NT_PWM3_DBCTL_OUT_MODE_Msk            (0x03UL << NT_PWM3_DBCTL_OUT_MODE_Pos)                  /*!< NT_PWM3 DBCTL: OUT_MODE Mask            */
#define NT_PWM3_DBCTL_POLSEL_Pos              2                                                       /*!< NT_PWM3 DBCTL: POLSEL Position          */
#define NT_PWM3_DBCTL_POLSEL_Msk              (0x03UL << NT_PWM3_DBCTL_POLSEL_Pos)                    /*!< NT_PWM3 DBCTL: POLSEL Mask              */
#define NT_PWM3_DBCTL_IN_MODE_Pos             4                                                       /*!< NT_PWM3 DBCTL: IN_MODE Position         */
#define NT_PWM3_DBCTL_IN_MODE_Msk             (0x03UL << NT_PWM3_DBCTL_IN_MODE_Pos)                   /*!< NT_PWM3 DBCTL: IN_MODE Mask             */

/* --------------------------------  NT_PWM3_DBRED  ------------------------------- */
#define NT_PWM3_DBRED_DEL_Pos                 0                                                       /*!< NT_PWM3 DBRED: DEL Position             */
#define NT_PWM3_DBRED_DEL_Msk                 (0x000003ffUL << NT_PWM3_DBRED_DEL_Pos)                 /*!< NT_PWM3 DBRED: DEL Mask                 */

/* --------------------------------  NT_PWM3_DBFED  ------------------------------- */
#define NT_PWM3_DBFED_DEL_Pos                 0                                                       /*!< NT_PWM3 DBFED: DEL Position             */
#define NT_PWM3_DBFED_DEL_Msk                 (0x000003ffUL << NT_PWM3_DBFED_DEL_Pos)                 /*!< NT_PWM3 DBFED: DEL Mask                 */

/* --------------------------------  NT_PWM3_TZSEL  ------------------------------- */
#define NT_PWM3_TZSEL_CBC0_Pos                0                                                       /*!< NT_PWM3 TZSEL: CBC0 Position            */
#define NT_PWM3_TZSEL_CBC0_Msk                (0x01UL << NT_PWM3_TZSEL_CBC0_Pos)                      /*!< NT_PWM3 TZSEL: CBC0 Mask                */
#define NT_PWM3_TZSEL_CBC1_Pos                1                                                       /*!< NT_PWM3 TZSEL: CBC1 Position            */
#define NT_PWM3_TZSEL_CBC1_Msk                (0x01UL << NT_PWM3_TZSEL_CBC1_Pos)                      /*!< NT_PWM3 TZSEL: CBC1 Mask                */
#define NT_PWM3_TZSEL_CBC2_Pos                2                                                       /*!< NT_PWM3 TZSEL: CBC2 Position            */
#define NT_PWM3_TZSEL_CBC2_Msk                (0x01UL << NT_PWM3_TZSEL_CBC2_Pos)                      /*!< NT_PWM3 TZSEL: CBC2 Mask                */
#define NT_PWM3_TZSEL_CBC3_Pos                3                                                       /*!< NT_PWM3 TZSEL: CBC3 Position            */
#define NT_PWM3_TZSEL_CBC3_Msk                (0x01UL << NT_PWM3_TZSEL_CBC3_Pos)                      /*!< NT_PWM3 TZSEL: CBC3 Mask                */
#define NT_PWM3_TZSEL_CBC4_Pos                4                                                       /*!< NT_PWM3 TZSEL: CBC4 Position            */
#define NT_PWM3_TZSEL_CBC4_Msk                (0x01UL << NT_PWM3_TZSEL_CBC4_Pos)                      /*!< NT_PWM3 TZSEL: CBC4 Mask                */
#define NT_PWM3_TZSEL_CBC5_Pos                5                                                       /*!< NT_PWM3 TZSEL: CBC5 Position            */
#define NT_PWM3_TZSEL_CBC5_Msk                (0x01UL << NT_PWM3_TZSEL_CBC5_Pos)                      /*!< NT_PWM3 TZSEL: CBC5 Mask                */
#define NT_PWM3_TZSEL_OSHT0_Pos               8                                                       /*!< NT_PWM3 TZSEL: OSHT0 Position           */
#define NT_PWM3_TZSEL_OSHT0_Msk               (0x01UL << NT_PWM3_TZSEL_OSHT0_Pos)                     /*!< NT_PWM3 TZSEL: OSHT0 Mask               */
#define NT_PWM3_TZSEL_OSHT1_Pos               9                                                       /*!< NT_PWM3 TZSEL: OSHT1 Position           */
#define NT_PWM3_TZSEL_OSHT1_Msk               (0x01UL << NT_PWM3_TZSEL_OSHT1_Pos)                     /*!< NT_PWM3 TZSEL: OSHT1 Mask               */
#define NT_PWM3_TZSEL_OSHT2_Pos               10                                                      /*!< NT_PWM3 TZSEL: OSHT2 Position           */
#define NT_PWM3_TZSEL_OSHT2_Msk               (0x01UL << NT_PWM3_TZSEL_OSHT2_Pos)                     /*!< NT_PWM3 TZSEL: OSHT2 Mask               */
#define NT_PWM3_TZSEL_OSHT3_Pos               11                                                      /*!< NT_PWM3 TZSEL: OSHT3 Position           */
#define NT_PWM3_TZSEL_OSHT3_Msk               (0x01UL << NT_PWM3_TZSEL_OSHT3_Pos)                     /*!< NT_PWM3 TZSEL: OSHT3 Mask               */
#define NT_PWM3_TZSEL_OSHT4_Pos               12                                                      /*!< NT_PWM3 TZSEL: OSHT4 Position           */
#define NT_PWM3_TZSEL_OSHT4_Msk               (0x01UL << NT_PWM3_TZSEL_OSHT4_Pos)                     /*!< NT_PWM3 TZSEL: OSHT4 Mask               */
#define NT_PWM3_TZSEL_OSHT5_Pos               13                                                      /*!< NT_PWM3 TZSEL: OSHT5 Position           */
#define NT_PWM3_TZSEL_OSHT5_Msk               (0x01UL << NT_PWM3_TZSEL_OSHT5_Pos)                     /*!< NT_PWM3 TZSEL: OSHT5 Mask               */

/* --------------------------------  NT_PWM3_TZCTL  ------------------------------- */
#define NT_PWM3_TZCTL_TZA_Pos                 0                                                       /*!< NT_PWM3 TZCTL: TZA Position             */
#define NT_PWM3_TZCTL_TZA_Msk                 (0x03UL << NT_PWM3_TZCTL_TZA_Pos)                       /*!< NT_PWM3 TZCTL: TZA Mask                 */
#define NT_PWM3_TZCTL_TZB_Pos                 2                                                       /*!< NT_PWM3 TZCTL: TZB Position             */
#define NT_PWM3_TZCTL_TZB_Msk                 (0x03UL << NT_PWM3_TZCTL_TZB_Pos)                       /*!< NT_PWM3 TZCTL: TZB Mask                 */

/* -------------------------------  NT_PWM3_TZEINT  ------------------------------- */
#define NT_PWM3_TZEINT_CBC_Pos                1                                                       /*!< NT_PWM3 TZEINT: CBC Position            */
#define NT_PWM3_TZEINT_CBC_Msk                (0x01UL << NT_PWM3_TZEINT_CBC_Pos)                      /*!< NT_PWM3 TZEINT: CBC Mask                */
#define NT_PWM3_TZEINT_OST_Pos                2                                                       /*!< NT_PWM3 TZEINT: OST Position            */
#define NT_PWM3_TZEINT_OST_Msk                (0x01UL << NT_PWM3_TZEINT_OST_Pos)                      /*!< NT_PWM3 TZEINT: OST Mask                */

/* --------------------------------  NT_PWM3_TZFLG  ------------------------------- */
#define NT_PWM3_TZFLG_INT_Pos                 0                                                       /*!< NT_PWM3 TZFLG: INT Position             */
#define NT_PWM3_TZFLG_INT_Msk                 (0x01UL << NT_PWM3_TZFLG_INT_Pos)                       /*!< NT_PWM3 TZFLG: INT Mask                 */
#define NT_PWM3_TZFLG_CBC_Pos                 1                                                       /*!< NT_PWM3 TZFLG: CBC Position             */
#define NT_PWM3_TZFLG_CBC_Msk                 (0x01UL << NT_PWM3_TZFLG_CBC_Pos)                       /*!< NT_PWM3 TZFLG: CBC Mask                 */
#define NT_PWM3_TZFLG_OST_Pos                 2                                                       /*!< NT_PWM3 TZFLG: OST Position             */
#define NT_PWM3_TZFLG_OST_Msk                 (0x01UL << NT_PWM3_TZFLG_OST_Pos)                       /*!< NT_PWM3 TZFLG: OST Mask                 */

/* --------------------------------  NT_PWM3_TZCLR  ------------------------------- */
#define NT_PWM3_TZCLR_INT_Pos                 0                                                       /*!< NT_PWM3 TZCLR: INT Position             */
#define NT_PWM3_TZCLR_INT_Msk                 (0x01UL << NT_PWM3_TZCLR_INT_Pos)                       /*!< NT_PWM3 TZCLR: INT Mask                 */
#define NT_PWM3_TZCLR_CBC_Pos                 1                                                       /*!< NT_PWM3 TZCLR: CBC Position             */
#define NT_PWM3_TZCLR_CBC_Msk                 (0x01UL << NT_PWM3_TZCLR_CBC_Pos)                       /*!< NT_PWM3 TZCLR: CBC Mask                 */
#define NT_PWM3_TZCLR_OST_Pos                 2                                                       /*!< NT_PWM3 TZCLR: OST Position             */
#define NT_PWM3_TZCLR_OST_Msk                 (0x01UL << NT_PWM3_TZCLR_OST_Pos)                       /*!< NT_PWM3 TZCLR: OST Mask                 */

/* --------------------------------  NT_PWM3_TZFRC  ------------------------------- */
#define NT_PWM3_TZFRC_CBC_Pos                 1                                                       /*!< NT_PWM3 TZFRC: CBC Position             */
#define NT_PWM3_TZFRC_CBC_Msk                 (0x01UL << NT_PWM3_TZFRC_CBC_Pos)                       /*!< NT_PWM3 TZFRC: CBC Mask                 */
#define NT_PWM3_TZFRC_OST_Pos                 2                                                       /*!< NT_PWM3 TZFRC: OST Position             */
#define NT_PWM3_TZFRC_OST_Msk                 (0x01UL << NT_PWM3_TZFRC_OST_Pos)                       /*!< NT_PWM3 TZFRC: OST Mask                 */

/* --------------------------------  NT_PWM3_ETSEL  ------------------------------- */
#define NT_PWM3_ETSEL_INTSEL_Pos              0                                                       /*!< NT_PWM3 ETSEL: INTSEL Position          */
#define NT_PWM3_ETSEL_INTSEL_Msk              (0x07UL << NT_PWM3_ETSEL_INTSEL_Pos)                    /*!< NT_PWM3 ETSEL: INTSEL Mask              */
#define NT_PWM3_ETSEL_INTEN_Pos               3                                                       /*!< NT_PWM3 ETSEL: INTEN Position           */
#define NT_PWM3_ETSEL_INTEN_Msk               (0x01UL << NT_PWM3_ETSEL_INTEN_Pos)                     /*!< NT_PWM3 ETSEL: INTEN Mask               */
#define NT_PWM3_ETSEL_SOCASEL_Pos             8                                                       /*!< NT_PWM3 ETSEL: SOCASEL Position         */
#define NT_PWM3_ETSEL_SOCASEL_Msk             (0x07UL << NT_PWM3_ETSEL_SOCASEL_Pos)                   /*!< NT_PWM3 ETSEL: SOCASEL Mask             */
#define NT_PWM3_ETSEL_SOCAEN_Pos              11                                                      /*!< NT_PWM3 ETSEL: SOCAEN Position          */
#define NT_PWM3_ETSEL_SOCAEN_Msk              (0x01UL << NT_PWM3_ETSEL_SOCAEN_Pos)                    /*!< NT_PWM3 ETSEL: SOCAEN Mask              */
#define NT_PWM3_ETSEL_SOCBSEL_Pos             12                                                      /*!< NT_PWM3 ETSEL: SOCBSEL Position         */
#define NT_PWM3_ETSEL_SOCBSEL_Msk             (0x07UL << NT_PWM3_ETSEL_SOCBSEL_Pos)                   /*!< NT_PWM3 ETSEL: SOCBSEL Mask             */
#define NT_PWM3_ETSEL_SOCBEN_Pos              15                                                      /*!< NT_PWM3 ETSEL: SOCBEN Position          */
#define NT_PWM3_ETSEL_SOCBEN_Msk              (0x01UL << NT_PWM3_ETSEL_SOCBEN_Pos)                    /*!< NT_PWM3 ETSEL: SOCBEN Mask              */

/* --------------------------------  NT_PWM3_ETPS  -------------------------------- */
#define NT_PWM3_ETPS_INTPRD_Pos               0                                                       /*!< NT_PWM3 ETPS: INTPRD Position           */
#define NT_PWM3_ETPS_INTPRD_Msk               (0x03UL << NT_PWM3_ETPS_INTPRD_Pos)                     /*!< NT_PWM3 ETPS: INTPRD Mask               */
#define NT_PWM3_ETPS_INTCNT_Pos               2                                                       /*!< NT_PWM3 ETPS: INTCNT Position           */
#define NT_PWM3_ETPS_INTCNT_Msk               (0x03UL << NT_PWM3_ETPS_INTCNT_Pos)                     /*!< NT_PWM3 ETPS: INTCNT Mask               */
#define NT_PWM3_ETPS_SOCAPRD_Pos              8                                                       /*!< NT_PWM3 ETPS: SOCAPRD Position          */
#define NT_PWM3_ETPS_SOCAPRD_Msk              (0x03UL << NT_PWM3_ETPS_SOCAPRD_Pos)                    /*!< NT_PWM3 ETPS: SOCAPRD Mask              */
#define NT_PWM3_ETPS_SOCACNT_Pos              10                                                      /*!< NT_PWM3 ETPS: SOCACNT Position          */
#define NT_PWM3_ETPS_SOCACNT_Msk              (0x03UL << NT_PWM3_ETPS_SOCACNT_Pos)                    /*!< NT_PWM3 ETPS: SOCACNT Mask              */
#define NT_PWM3_ETPS_SOCPRD_Pos               12                                                      /*!< NT_PWM3 ETPS: SOCPRD Position           */
#define NT_PWM3_ETPS_SOCPRD_Msk               (0x03UL << NT_PWM3_ETPS_SOCPRD_Pos)                     /*!< NT_PWM3 ETPS: SOCPRD Mask               */
#define NT_PWM3_ETPS_SOCBCNT_Pos              14                                                      /*!< NT_PWM3 ETPS: SOCBCNT Position          */
#define NT_PWM3_ETPS_SOCBCNT_Msk              (0x03UL << NT_PWM3_ETPS_SOCBCNT_Pos)                    /*!< NT_PWM3 ETPS: SOCBCNT Mask              */

/* --------------------------------  NT_PWM3_ETFLG  ------------------------------- */
#define NT_PWM3_ETFLG_INT_Pos                 0                                                       /*!< NT_PWM3 ETFLG: INT Position             */
#define NT_PWM3_ETFLG_INT_Msk                 (0x01UL << NT_PWM3_ETFLG_INT_Pos)                       /*!< NT_PWM3 ETFLG: INT Mask                 */
#define NT_PWM3_ETFLG_SOCA_Pos                2                                                       /*!< NT_PWM3 ETFLG: SOCA Position            */
#define NT_PWM3_ETFLG_SOCA_Msk                (0x01UL << NT_PWM3_ETFLG_SOCA_Pos)                      /*!< NT_PWM3 ETFLG: SOCA Mask                */
#define NT_PWM3_ETFLG_SOCB_Pos                3                                                       /*!< NT_PWM3 ETFLG: SOCB Position            */
#define NT_PWM3_ETFLG_SOCB_Msk                (0x01UL << NT_PWM3_ETFLG_SOCB_Pos)                      /*!< NT_PWM3 ETFLG: SOCB Mask                */

/* --------------------------------  NT_PWM3_ETCLR  ------------------------------- */
#define NT_PWM3_ETCLR_INT_Pos                 0                                                       /*!< NT_PWM3 ETCLR: INT Position             */
#define NT_PWM3_ETCLR_INT_Msk                 (0x01UL << NT_PWM3_ETCLR_INT_Pos)                       /*!< NT_PWM3 ETCLR: INT Mask                 */
#define NT_PWM3_ETCLR_SOCA_Pos                2                                                       /*!< NT_PWM3 ETCLR: SOCA Position            */
#define NT_PWM3_ETCLR_SOCA_Msk                (0x01UL << NT_PWM3_ETCLR_SOCA_Pos)                      /*!< NT_PWM3 ETCLR: SOCA Mask                */
#define NT_PWM3_ETCLR_SOCB_Pos                3                                                       /*!< NT_PWM3 ETCLR: SOCB Position            */
#define NT_PWM3_ETCLR_SOCB_Msk                (0x01UL << NT_PWM3_ETCLR_SOCB_Pos)                      /*!< NT_PWM3 ETCLR: SOCB Mask                */

/* --------------------------------  NT_PWM3_ETFRC  ------------------------------- */
#define NT_PWM3_ETFRC_INT_Pos                 0                                                       /*!< NT_PWM3 ETFRC: INT Position             */
#define NT_PWM3_ETFRC_INT_Msk                 (0x01UL << NT_PWM3_ETFRC_INT_Pos)                       /*!< NT_PWM3 ETFRC: INT Mask                 */
#define NT_PWM3_ETFRC_SOCA_Pos                2                                                       /*!< NT_PWM3 ETFRC: SOCA Position            */
#define NT_PWM3_ETFRC_SOCA_Msk                (0x01UL << NT_PWM3_ETFRC_SOCA_Pos)                      /*!< NT_PWM3 ETFRC: SOCA Mask                */
#define NT_PWM3_ETFRC_SOCB_Pos                3                                                       /*!< NT_PWM3 ETFRC: SOCB Position            */
#define NT_PWM3_ETFRC_SOCB_Msk                (0x01UL << NT_PWM3_ETFRC_SOCB_Pos)                      /*!< NT_PWM3 ETFRC: SOCB Mask                */

/* --------------------------------  NT_PWM3_PCCTL  ------------------------------- */
#define NT_PWM3_PCCTL_CHPEN_Pos               0                                                       /*!< NT_PWM3 PCCTL: CHPEN Position           */
#define NT_PWM3_PCCTL_CHPEN_Msk               (0x01UL << NT_PWM3_PCCTL_CHPEN_Pos)                     /*!< NT_PWM3 PCCTL: CHPEN Mask               */
#define NT_PWM3_PCCTL_OSHTWTH_Pos             1                                                       /*!< NT_PWM3 PCCTL: OSHTWTH Position         */
#define NT_PWM3_PCCTL_OSHTWTH_Msk             (0x0fUL << NT_PWM3_PCCTL_OSHTWTH_Pos)                   /*!< NT_PWM3 PCCTL: OSHTWTH Mask             */
#define NT_PWM3_PCCTL_SHRFREQ_Pos             5                                                       /*!< NT_PWM3 PCCTL: SHRFREQ Position         */
#define NT_PWM3_PCCTL_SHRFREQ_Msk             (0x07UL << NT_PWM3_PCCTL_SHRFREQ_Pos)                   /*!< NT_PWM3 PCCTL: SHRFREQ Mask             */
#define NT_PWM3_PCCTL_CHPDUTY_Pos             8                                                       /*!< NT_PWM3 PCCTL: CHPDUTY Position         */
#define NT_PWM3_PCCTL_CHPDUTY_Msk             (0x07UL << NT_PWM3_PCCTL_CHPDUTY_Pos)                   /*!< NT_PWM3 PCCTL: CHPDUTY Mask             */

/* -------------------------------  NT_PWM3_HRCNFG  ------------------------------- */
#define NT_PWM3_HRCNFG_EDGMODE_Pos            0                                                       /*!< NT_PWM3 HRCNFG: EDGMODE Position        */
#define NT_PWM3_HRCNFG_EDGMODE_Msk            (0x03UL << NT_PWM3_HRCNFG_EDGMODE_Pos)                  /*!< NT_PWM3 HRCNFG: EDGMODE Mask            */
#define NT_PWM3_HRCNFG_CTLMODE_Pos            2                                                       /*!< NT_PWM3 HRCNFG: CTLMODE Position        */
#define NT_PWM3_HRCNFG_CTLMODE_Msk            (0x01UL << NT_PWM3_HRCNFG_CTLMODE_Pos)                  /*!< NT_PWM3 HRCNFG: CTLMODE Mask            */
#define NT_PWM3_HRCNFG_HR_LOAD_Pos            3                                                       /*!< NT_PWM3 HRCNFG: HR_LOAD Position        */
#define NT_PWM3_HRCNFG_HR_LOAD_Msk            (0x01UL << NT_PWM3_HRCNFG_HR_LOAD_Pos)                  /*!< NT_PWM3 HRCNFG: HR_LOAD Mask            */
#define NT_PWM3_HRCNFG_MEP_SCALEFACTOR_Pos    16                                                      /*!< NT_PWM3 HRCNFG: MEP_SCALEFACTOR Position */
#define NT_PWM3_HRCNFG_MEP_SCALEFACTOR_Msk    (0x000000ffUL << NT_PWM3_HRCNFG_MEP_SCALEFACTOR_Pos)    /*!< NT_PWM3 HRCNFG: MEP_SCALEFACTOR Mask    */

/* --------------------------------  NT_PWM3_FWDTH  ------------------------------- */
#define NT_PWM3_FWDTH_FWDTH_Pos               0                                                       /*!< NT_PWM3 FWDTH: FWDTH Position           */
#define NT_PWM3_FWDTH_FWDTH_Msk               (0x000000ffUL << NT_PWM3_FWDTH_FWDTH_Pos)               /*!< NT_PWM3 FWDTH: FWDTH Mask               */

/* --------------------------------  NT_PWM3_HDSEL  ------------------------------- */
#define NT_PWM3_HDSEL_DCMP_Pos                0                                                       /*!< NT_PWM3 HDSEL: DCMP Position            */
#define NT_PWM3_HDSEL_DCMP_Msk                (0x00ffffffUL << NT_PWM3_HDSEL_DCMP_Pos)                /*!< NT_PWM3 HDSEL: DCMP Mask                */
#define NT_PWM3_HDSEL_ACMP_Pos                24                                                      /*!< NT_PWM3 HDSEL: ACMP Position            */
#define NT_PWM3_HDSEL_ACMP_Msk                (0x07UL << NT_PWM3_HDSEL_ACMP_Pos)                      /*!< NT_PWM3 HDSEL: ACMP Mask                */

/* --------------------------------  NT_PWM3_HDCTL  ------------------------------- */
#define NT_PWM3_HDCTL_HDA_Pos                 0                                                       /*!< NT_PWM3 HDCTL: HDA Position             */
#define NT_PWM3_HDCTL_HDA_Msk                 (0x03UL << NT_PWM3_HDCTL_HDA_Pos)                       /*!< NT_PWM3 HDCTL: HDA Mask                 */
#define NT_PWM3_HDCTL_HDB_Pos                 2                                                       /*!< NT_PWM3 HDCTL: HDB Position             */
#define NT_PWM3_HDCTL_HDB_Msk                 (0x03UL << NT_PWM3_HDCTL_HDB_Pos)                       /*!< NT_PWM3 HDCTL: HDB Mask                 */

/* -------------------------------  NT_PWM3_HDEINT  ------------------------------- */
#define NT_PWM3_HDEINT_CBC_Pos                1                                                       /*!< NT_PWM3 HDEINT: CBC Position            */
#define NT_PWM3_HDEINT_CBC_Msk                (0x01UL << NT_PWM3_HDEINT_CBC_Pos)                      /*!< NT_PWM3 HDEINT: CBC Mask                */
#define NT_PWM3_HDEINT_OST_Pos                2                                                       /*!< NT_PWM3 HDEINT: OST Position            */
#define NT_PWM3_HDEINT_OST_Msk                (0x01UL << NT_PWM3_HDEINT_OST_Pos)                      /*!< NT_PWM3 HDEINT: OST Mask                */

/* --------------------------------  NT_PWM3_HDFLG  ------------------------------- */
#define NT_PWM3_HDFLG_HDINT_Pos               0                                                       /*!< NT_PWM3 HDFLG: HDINT Position           */
#define NT_PWM3_HDFLG_HDINT_Msk               (0x01UL << NT_PWM3_HDFLG_HDINT_Pos)                     /*!< NT_PWM3 HDFLG: HDINT Mask               */
#define NT_PWM3_HDFLG_CBC_Pos                 1                                                       /*!< NT_PWM3 HDFLG: CBC Position             */
#define NT_PWM3_HDFLG_CBC_Msk                 (0x01UL << NT_PWM3_HDFLG_CBC_Pos)                       /*!< NT_PWM3 HDFLG: CBC Mask                 */
#define NT_PWM3_HDFLG_OST_Pos                 2                                                       /*!< NT_PWM3 HDFLG: OST Position             */
#define NT_PWM3_HDFLG_OST_Msk                 (0x01UL << NT_PWM3_HDFLG_OST_Pos)                       /*!< NT_PWM3 HDFLG: OST Mask                 */

/* --------------------------------  NT_PWM3_HDCLR  ------------------------------- */
#define NT_PWM3_HDCLR_HDINT_Pos               0                                                       /*!< NT_PWM3 HDCLR: HDINT Position           */
#define NT_PWM3_HDCLR_HDINT_Msk               (0x01UL << NT_PWM3_HDCLR_HDINT_Pos)                     /*!< NT_PWM3 HDCLR: HDINT Mask               */

/* --------------------------------  NT_PWM3_HDFRC  ------------------------------- */
#define NT_PWM3_HDFRC_CBC_Pos                 1                                                       /*!< NT_PWM3 HDFRC: CBC Position             */
#define NT_PWM3_HDFRC_CBC_Msk                 (0x01UL << NT_PWM3_HDFRC_CBC_Pos)                       /*!< NT_PWM3 HDFRC: CBC Mask                 */
#define NT_PWM3_HDFRC_OST_Pos                 2                                                       /*!< NT_PWM3 HDFRC: OST Position             */
#define NT_PWM3_HDFRC_OST_Msk                 (0x01UL << NT_PWM3_HDFRC_OST_Pos)                       /*!< NT_PWM3 HDFRC: OST Mask                 */

/* ------------------------------  NT_PWM3_HDINTCLR  ------------------------------ */
#define NT_PWM3_HDINTCLR_HDINT_Pos            0                                                       /*!< NT_PWM3 HDINTCLR: HDINT Position        */
#define NT_PWM3_HDINTCLR_HDINT_Msk            (0x01UL << NT_PWM3_HDINTCLR_HDINT_Pos)                  /*!< NT_PWM3 HDINTCLR: HDINT Mask            */

/* ------------------------------  NT_PWM3_TZINTCLR  ------------------------------ */
#define NT_PWM3_TZINTCLR_TZINT_Pos            0                                                       /*!< NT_PWM3 TZINTCLR: TZINT Position        */
#define NT_PWM3_TZINTCLR_TZINT_Msk            (0x01UL << NT_PWM3_TZINTCLR_TZINT_Pos)                  /*!< NT_PWM3 TZINTCLR: TZINT Mask            */

/* -------------------------------  NT_PWM3_INTCLR  ------------------------------- */
#define NT_PWM3_INTCLR_INT_Pos                0                                                       /*!< NT_PWM3 INTCLR: INT Position            */
#define NT_PWM3_INTCLR_INT_Msk                (0x01UL << NT_PWM3_INTCLR_INT_Pos)                      /*!< NT_PWM3 INTCLR: INT Mask                */


/* ================================================================================ */
/* ================        struct 'NT_PWM4' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_PWM4_TBCTL  ------------------------------- */
#define NT_PWM4_TBCTL_CTRMODE_Pos             0                                                       /*!< NT_PWM4 TBCTL: CTRMODE Position         */
#define NT_PWM4_TBCTL_CTRMODE_Msk             (0x03UL << NT_PWM4_TBCTL_CTRMODE_Pos)                   /*!< NT_PWM4 TBCTL: CTRMODE Mask             */
#define NT_PWM4_TBCTL_PHSEN_Pos               2                                                       /*!< NT_PWM4 TBCTL: PHSEN Position           */
#define NT_PWM4_TBCTL_PHSEN_Msk               (0x01UL << NT_PWM4_TBCTL_PHSEN_Pos)                     /*!< NT_PWM4 TBCTL: PHSEN Mask               */
#define NT_PWM4_TBCTL_PRDLD_Pos               3                                                       /*!< NT_PWM4 TBCTL: PRDLD Position           */
#define NT_PWM4_TBCTL_PRDLD_Msk               (0x01UL << NT_PWM4_TBCTL_PRDLD_Pos)                     /*!< NT_PWM4 TBCTL: PRDLD Mask               */
#define NT_PWM4_TBCTL_SYNCOSEL_Pos            4                                                       /*!< NT_PWM4 TBCTL: SYNCOSEL Position        */
#define NT_PWM4_TBCTL_SYNCOSEL_Msk            (0x03UL << NT_PWM4_TBCTL_SYNCOSEL_Pos)                  /*!< NT_PWM4 TBCTL: SYNCOSEL Mask            */
#define NT_PWM4_TBCTL_SWFSYNC_Pos             6                                                       /*!< NT_PWM4 TBCTL: SWFSYNC Position         */
#define NT_PWM4_TBCTL_SWFSYNC_Msk             (0x01UL << NT_PWM4_TBCTL_SWFSYNC_Pos)                   /*!< NT_PWM4 TBCTL: SWFSYNC Mask             */
#define NT_PWM4_TBCTL_HSPCLKDIV_Pos           7                                                       /*!< NT_PWM4 TBCTL: HSPCLKDIV Position       */
#define NT_PWM4_TBCTL_HSPCLKDIV_Msk           (0x07UL << NT_PWM4_TBCTL_HSPCLKDIV_Pos)                 /*!< NT_PWM4 TBCTL: HSPCLKDIV Mask           */
#define NT_PWM4_TBCTL_CLKDIV_Pos              10                                                      /*!< NT_PWM4 TBCTL: CLKDIV Position          */
#define NT_PWM4_TBCTL_CLKDIV_Msk              (0x07UL << NT_PWM4_TBCTL_CLKDIV_Pos)                    /*!< NT_PWM4 TBCTL: CLKDIV Mask              */
#define NT_PWM4_TBCTL_PHSDIR_Pos              13                                                      /*!< NT_PWM4 TBCTL: PHSDIR Position          */
#define NT_PWM4_TBCTL_PHSDIR_Msk              (0x01UL << NT_PWM4_TBCTL_PHSDIR_Pos)                    /*!< NT_PWM4 TBCTL: PHSDIR Mask              */
#define NT_PWM4_TBCTL_FREE_SOFT_Pos           14                                                      /*!< NT_PWM4 TBCTL: FREE_SOFT Position       */
#define NT_PWM4_TBCTL_FREE_SOFT_Msk           (0x03UL << NT_PWM4_TBCTL_FREE_SOFT_Pos)                 /*!< NT_PWM4 TBCTL: FREE_SOFT Mask           */

/* --------------------------------  NT_PWM4_TBSTS  ------------------------------- */
#define NT_PWM4_TBSTS_CTRDIR_Pos              0                                                       /*!< NT_PWM4 TBSTS: CTRDIR Position          */
#define NT_PWM4_TBSTS_CTRDIR_Msk              (0x01UL << NT_PWM4_TBSTS_CTRDIR_Pos)                    /*!< NT_PWM4 TBSTS: CTRDIR Mask              */
#define NT_PWM4_TBSTS_SYNCI_Pos               1                                                       /*!< NT_PWM4 TBSTS: SYNCI Position           */
#define NT_PWM4_TBSTS_SYNCI_Msk               (0x01UL << NT_PWM4_TBSTS_SYNCI_Pos)                     /*!< NT_PWM4 TBSTS: SYNCI Mask               */
#define NT_PWM4_TBSTS_CTRMAX_Pos              2                                                       /*!< NT_PWM4 TBSTS: CTRMAX Position          */
#define NT_PWM4_TBSTS_CTRMAX_Msk              (0x01UL << NT_PWM4_TBSTS_CTRMAX_Pos)                    /*!< NT_PWM4 TBSTS: CTRMAX Mask              */

/* --------------------------------  NT_PWM4_TBPHS  ------------------------------- */
#define NT_PWM4_TBPHS_TBPHSHR_Pos             8                                                       /*!< NT_PWM4 TBPHS: TBPHSHR Position         */
#define NT_PWM4_TBPHS_TBPHSHR_Msk             (0x000000ffUL << NT_PWM4_TBPHS_TBPHSHR_Pos)             /*!< NT_PWM4 TBPHS: TBPHSHR Mask             */
#define NT_PWM4_TBPHS_TBPHS_Pos               16                                                      /*!< NT_PWM4 TBPHS: TBPHS Position           */
#define NT_PWM4_TBPHS_TBPHS_Msk               (0x0000ffffUL << NT_PWM4_TBPHS_TBPHS_Pos)               /*!< NT_PWM4 TBPHS: TBPHS Mask               */

/* --------------------------------  NT_PWM4_TBCTR  ------------------------------- */
#define NT_PWM4_TBCTR_TBCTR_Pos               0                                                       /*!< NT_PWM4 TBCTR: TBCTR Position           */
#define NT_PWM4_TBCTR_TBCTR_Msk               (0x0000ffffUL << NT_PWM4_TBCTR_TBCTR_Pos)               /*!< NT_PWM4 TBCTR: TBCTR Mask               */

/* --------------------------------  NT_PWM4_TBPRD  ------------------------------- */
#define NT_PWM4_TBPRD_TBPRD_Pos               0                                                       /*!< NT_PWM4 TBPRD: TBPRD Position           */
#define NT_PWM4_TBPRD_TBPRD_Msk               (0x0000ffffUL << NT_PWM4_TBPRD_TBPRD_Pos)               /*!< NT_PWM4 TBPRD: TBPRD Mask               */

/* -------------------------------  NT_PWM4_CMPCTL  ------------------------------- */
#define NT_PWM4_CMPCTL_LOADAMODE_Pos          0                                                       /*!< NT_PWM4 CMPCTL: LOADAMODE Position      */
#define NT_PWM4_CMPCTL_LOADAMODE_Msk          (0x03UL << NT_PWM4_CMPCTL_LOADAMODE_Pos)                /*!< NT_PWM4 CMPCTL: LOADAMODE Mask          */
#define NT_PWM4_CMPCTL_LOADBMODE_Pos          2                                                       /*!< NT_PWM4 CMPCTL: LOADBMODE Position      */
#define NT_PWM4_CMPCTL_LOADBMODE_Msk          (0x03UL << NT_PWM4_CMPCTL_LOADBMODE_Pos)                /*!< NT_PWM4 CMPCTL: LOADBMODE Mask          */
#define NT_PWM4_CMPCTL_SHDWAMODE_Pos          4                                                       /*!< NT_PWM4 CMPCTL: SHDWAMODE Position      */
#define NT_PWM4_CMPCTL_SHDWAMODE_Msk          (0x01UL << NT_PWM4_CMPCTL_SHDWAMODE_Pos)                /*!< NT_PWM4 CMPCTL: SHDWAMODE Mask          */
#define NT_PWM4_CMPCTL_SHDWBMODE_Pos          6                                                       /*!< NT_PWM4 CMPCTL: SHDWBMODE Position      */
#define NT_PWM4_CMPCTL_SHDWBMODE_Msk          (0x01UL << NT_PWM4_CMPCTL_SHDWBMODE_Pos)                /*!< NT_PWM4 CMPCTL: SHDWBMODE Mask          */
#define NT_PWM4_CMPCTL_SHDWAFULL_Pos          8                                                       /*!< NT_PWM4 CMPCTL: SHDWAFULL Position      */
#define NT_PWM4_CMPCTL_SHDWAFULL_Msk          (0x01UL << NT_PWM4_CMPCTL_SHDWAFULL_Pos)                /*!< NT_PWM4 CMPCTL: SHDWAFULL Mask          */
#define NT_PWM4_CMPCTL_SHDWBFULL_Pos          9                                                       /*!< NT_PWM4 CMPCTL: SHDWBFULL Position      */
#define NT_PWM4_CMPCTL_SHDWBFULL_Msk          (0x01UL << NT_PWM4_CMPCTL_SHDWBFULL_Pos)                /*!< NT_PWM4 CMPCTL: SHDWBFULL Mask          */

/* --------------------------------  NT_PWM4_CMPA  -------------------------------- */
#define NT_PWM4_CMPA_CMPAHR_Pos               8                                                       /*!< NT_PWM4 CMPA: CMPAHR Position           */
#define NT_PWM4_CMPA_CMPAHR_Msk               (0x000000ffUL << NT_PWM4_CMPA_CMPAHR_Pos)               /*!< NT_PWM4 CMPA: CMPAHR Mask               */
#define NT_PWM4_CMPA_CMPA_Pos                 16                                                      /*!< NT_PWM4 CMPA: CMPA Position             */
#define NT_PWM4_CMPA_CMPA_Msk                 (0x0000ffffUL << NT_PWM4_CMPA_CMPA_Pos)                 /*!< NT_PWM4 CMPA: CMPA Mask                 */

/* --------------------------------  NT_PWM4_CMPB  -------------------------------- */
#define NT_PWM4_CMPB_CMPB_Pos                 16                                                      /*!< NT_PWM4 CMPB: CMPB Position             */
#define NT_PWM4_CMPB_CMPB_Msk                 (0x0000ffffUL << NT_PWM4_CMPB_CMPB_Pos)                 /*!< NT_PWM4 CMPB: CMPB Mask                 */

/* -------------------------------  NT_PWM4_AQCTLA  ------------------------------- */
#define NT_PWM4_AQCTLA_ZRO_Pos                0                                                       /*!< NT_PWM4 AQCTLA: ZRO Position            */
#define NT_PWM4_AQCTLA_ZRO_Msk                (0x03UL << NT_PWM4_AQCTLA_ZRO_Pos)                      /*!< NT_PWM4 AQCTLA: ZRO Mask                */
#define NT_PWM4_AQCTLA_PRD_Pos                2                                                       /*!< NT_PWM4 AQCTLA: PRD Position            */
#define NT_PWM4_AQCTLA_PRD_Msk                (0x03UL << NT_PWM4_AQCTLA_PRD_Pos)                      /*!< NT_PWM4 AQCTLA: PRD Mask                */
#define NT_PWM4_AQCTLA_CAU_Pos                4                                                       /*!< NT_PWM4 AQCTLA: CAU Position            */
#define NT_PWM4_AQCTLA_CAU_Msk                (0x03UL << NT_PWM4_AQCTLA_CAU_Pos)                      /*!< NT_PWM4 AQCTLA: CAU Mask                */
#define NT_PWM4_AQCTLA_CAD_Pos                6                                                       /*!< NT_PWM4 AQCTLA: CAD Position            */
#define NT_PWM4_AQCTLA_CAD_Msk                (0x03UL << NT_PWM4_AQCTLA_CAD_Pos)                      /*!< NT_PWM4 AQCTLA: CAD Mask                */
#define NT_PWM4_AQCTLA_CBU_Pos                8                                                       /*!< NT_PWM4 AQCTLA: CBU Position            */
#define NT_PWM4_AQCTLA_CBU_Msk                (0x03UL << NT_PWM4_AQCTLA_CBU_Pos)                      /*!< NT_PWM4 AQCTLA: CBU Mask                */
#define NT_PWM4_AQCTLA_CBD_Pos                10                                                      /*!< NT_PWM4 AQCTLA: CBD Position            */
#define NT_PWM4_AQCTLA_CBD_Msk                (0x03UL << NT_PWM4_AQCTLA_CBD_Pos)                      /*!< NT_PWM4 AQCTLA: CBD Mask                */

/* -------------------------------  NT_PWM4_AQCTLB  ------------------------------- */
#define NT_PWM4_AQCTLB_ZRO_Pos                0                                                       /*!< NT_PWM4 AQCTLB: ZRO Position            */
#define NT_PWM4_AQCTLB_ZRO_Msk                (0x03UL << NT_PWM4_AQCTLB_ZRO_Pos)                      /*!< NT_PWM4 AQCTLB: ZRO Mask                */
#define NT_PWM4_AQCTLB_PRD_Pos                2                                                       /*!< NT_PWM4 AQCTLB: PRD Position            */
#define NT_PWM4_AQCTLB_PRD_Msk                (0x03UL << NT_PWM4_AQCTLB_PRD_Pos)                      /*!< NT_PWM4 AQCTLB: PRD Mask                */
#define NT_PWM4_AQCTLB_CAU_Pos                4                                                       /*!< NT_PWM4 AQCTLB: CAU Position            */
#define NT_PWM4_AQCTLB_CAU_Msk                (0x03UL << NT_PWM4_AQCTLB_CAU_Pos)                      /*!< NT_PWM4 AQCTLB: CAU Mask                */
#define NT_PWM4_AQCTLB_CAD_Pos                6                                                       /*!< NT_PWM4 AQCTLB: CAD Position            */
#define NT_PWM4_AQCTLB_CAD_Msk                (0x03UL << NT_PWM4_AQCTLB_CAD_Pos)                      /*!< NT_PWM4 AQCTLB: CAD Mask                */
#define NT_PWM4_AQCTLB_CBU_Pos                8                                                       /*!< NT_PWM4 AQCTLB: CBU Position            */
#define NT_PWM4_AQCTLB_CBU_Msk                (0x03UL << NT_PWM4_AQCTLB_CBU_Pos)                      /*!< NT_PWM4 AQCTLB: CBU Mask                */
#define NT_PWM4_AQCTLB_CBD_Pos                10                                                      /*!< NT_PWM4 AQCTLB: CBD Position            */
#define NT_PWM4_AQCTLB_CBD_Msk                (0x03UL << NT_PWM4_AQCTLB_CBD_Pos)                      /*!< NT_PWM4 AQCTLB: CBD Mask                */

/* -------------------------------  NT_PWM4_AQSFRC  ------------------------------- */
#define NT_PWM4_AQSFRC_ACTSFA_Pos             0                                                       /*!< NT_PWM4 AQSFRC: ACTSFA Position         */
#define NT_PWM4_AQSFRC_ACTSFA_Msk             (0x03UL << NT_PWM4_AQSFRC_ACTSFA_Pos)                   /*!< NT_PWM4 AQSFRC: ACTSFA Mask             */
#define NT_PWM4_AQSFRC_OTSFA_Pos              2                                                       /*!< NT_PWM4 AQSFRC: OTSFA Position          */
#define NT_PWM4_AQSFRC_OTSFA_Msk              (0x01UL << NT_PWM4_AQSFRC_OTSFA_Pos)                    /*!< NT_PWM4 AQSFRC: OTSFA Mask              */
#define NT_PWM4_AQSFRC_ACTSFB_Pos             3                                                       /*!< NT_PWM4 AQSFRC: ACTSFB Position         */
#define NT_PWM4_AQSFRC_ACTSFB_Msk             (0x03UL << NT_PWM4_AQSFRC_ACTSFB_Pos)                   /*!< NT_PWM4 AQSFRC: ACTSFB Mask             */
#define NT_PWM4_AQSFRC_OTSFB_Pos              5                                                       /*!< NT_PWM4 AQSFRC: OTSFB Position          */
#define NT_PWM4_AQSFRC_OTSFB_Msk              (0x01UL << NT_PWM4_AQSFRC_OTSFB_Pos)                    /*!< NT_PWM4 AQSFRC: OTSFB Mask              */
#define NT_PWM4_AQSFRC_RLDCSF_Pos             6                                                       /*!< NT_PWM4 AQSFRC: RLDCSF Position         */
#define NT_PWM4_AQSFRC_RLDCSF_Msk             (0x03UL << NT_PWM4_AQSFRC_RLDCSF_Pos)                   /*!< NT_PWM4 AQSFRC: RLDCSF Mask             */

/* -------------------------------  NT_PWM4_AQCSFRC  ------------------------------ */
#define NT_PWM4_AQCSFRC_CSFA_Pos              0                                                       /*!< NT_PWM4 AQCSFRC: CSFA Position          */
#define NT_PWM4_AQCSFRC_CSFA_Msk              (0x03UL << NT_PWM4_AQCSFRC_CSFA_Pos)                    /*!< NT_PWM4 AQCSFRC: CSFA Mask              */
#define NT_PWM4_AQCSFRC_CSFB_Pos              2                                                       /*!< NT_PWM4 AQCSFRC: CSFB Position          */
#define NT_PWM4_AQCSFRC_CSFB_Msk              (0x03UL << NT_PWM4_AQCSFRC_CSFB_Pos)                    /*!< NT_PWM4 AQCSFRC: CSFB Mask              */

/* --------------------------------  NT_PWM4_DBCTL  ------------------------------- */
#define NT_PWM4_DBCTL_OUT_MODE_Pos            0                                                       /*!< NT_PWM4 DBCTL: OUT_MODE Position        */
#define NT_PWM4_DBCTL_OUT_MODE_Msk            (0x03UL << NT_PWM4_DBCTL_OUT_MODE_Pos)                  /*!< NT_PWM4 DBCTL: OUT_MODE Mask            */
#define NT_PWM4_DBCTL_POLSEL_Pos              2                                                       /*!< NT_PWM4 DBCTL: POLSEL Position          */
#define NT_PWM4_DBCTL_POLSEL_Msk              (0x03UL << NT_PWM4_DBCTL_POLSEL_Pos)                    /*!< NT_PWM4 DBCTL: POLSEL Mask              */
#define NT_PWM4_DBCTL_IN_MODE_Pos             4                                                       /*!< NT_PWM4 DBCTL: IN_MODE Position         */
#define NT_PWM4_DBCTL_IN_MODE_Msk             (0x03UL << NT_PWM4_DBCTL_IN_MODE_Pos)                   /*!< NT_PWM4 DBCTL: IN_MODE Mask             */

/* --------------------------------  NT_PWM4_DBRED  ------------------------------- */
#define NT_PWM4_DBRED_DEL_Pos                 0                                                       /*!< NT_PWM4 DBRED: DEL Position             */
#define NT_PWM4_DBRED_DEL_Msk                 (0x000003ffUL << NT_PWM4_DBRED_DEL_Pos)                 /*!< NT_PWM4 DBRED: DEL Mask                 */

/* --------------------------------  NT_PWM4_DBFED  ------------------------------- */
#define NT_PWM4_DBFED_DEL_Pos                 0                                                       /*!< NT_PWM4 DBFED: DEL Position             */
#define NT_PWM4_DBFED_DEL_Msk                 (0x000003ffUL << NT_PWM4_DBFED_DEL_Pos)                 /*!< NT_PWM4 DBFED: DEL Mask                 */

/* --------------------------------  NT_PWM4_TZSEL  ------------------------------- */
#define NT_PWM4_TZSEL_CBC0_Pos                0                                                       /*!< NT_PWM4 TZSEL: CBC0 Position            */
#define NT_PWM4_TZSEL_CBC0_Msk                (0x01UL << NT_PWM4_TZSEL_CBC0_Pos)                      /*!< NT_PWM4 TZSEL: CBC0 Mask                */
#define NT_PWM4_TZSEL_CBC1_Pos                1                                                       /*!< NT_PWM4 TZSEL: CBC1 Position            */
#define NT_PWM4_TZSEL_CBC1_Msk                (0x01UL << NT_PWM4_TZSEL_CBC1_Pos)                      /*!< NT_PWM4 TZSEL: CBC1 Mask                */
#define NT_PWM4_TZSEL_CBC2_Pos                2                                                       /*!< NT_PWM4 TZSEL: CBC2 Position            */
#define NT_PWM4_TZSEL_CBC2_Msk                (0x01UL << NT_PWM4_TZSEL_CBC2_Pos)                      /*!< NT_PWM4 TZSEL: CBC2 Mask                */
#define NT_PWM4_TZSEL_CBC3_Pos                3                                                       /*!< NT_PWM4 TZSEL: CBC3 Position            */
#define NT_PWM4_TZSEL_CBC3_Msk                (0x01UL << NT_PWM4_TZSEL_CBC3_Pos)                      /*!< NT_PWM4 TZSEL: CBC3 Mask                */
#define NT_PWM4_TZSEL_CBC4_Pos                4                                                       /*!< NT_PWM4 TZSEL: CBC4 Position            */
#define NT_PWM4_TZSEL_CBC4_Msk                (0x01UL << NT_PWM4_TZSEL_CBC4_Pos)                      /*!< NT_PWM4 TZSEL: CBC4 Mask                */
#define NT_PWM4_TZSEL_CBC5_Pos                5                                                       /*!< NT_PWM4 TZSEL: CBC5 Position            */
#define NT_PWM4_TZSEL_CBC5_Msk                (0x01UL << NT_PWM4_TZSEL_CBC5_Pos)                      /*!< NT_PWM4 TZSEL: CBC5 Mask                */
#define NT_PWM4_TZSEL_OSHT0_Pos               8                                                       /*!< NT_PWM4 TZSEL: OSHT0 Position           */
#define NT_PWM4_TZSEL_OSHT0_Msk               (0x01UL << NT_PWM4_TZSEL_OSHT0_Pos)                     /*!< NT_PWM4 TZSEL: OSHT0 Mask               */
#define NT_PWM4_TZSEL_OSHT1_Pos               9                                                       /*!< NT_PWM4 TZSEL: OSHT1 Position           */
#define NT_PWM4_TZSEL_OSHT1_Msk               (0x01UL << NT_PWM4_TZSEL_OSHT1_Pos)                     /*!< NT_PWM4 TZSEL: OSHT1 Mask               */
#define NT_PWM4_TZSEL_OSHT2_Pos               10                                                      /*!< NT_PWM4 TZSEL: OSHT2 Position           */
#define NT_PWM4_TZSEL_OSHT2_Msk               (0x01UL << NT_PWM4_TZSEL_OSHT2_Pos)                     /*!< NT_PWM4 TZSEL: OSHT2 Mask               */
#define NT_PWM4_TZSEL_OSHT3_Pos               11                                                      /*!< NT_PWM4 TZSEL: OSHT3 Position           */
#define NT_PWM4_TZSEL_OSHT3_Msk               (0x01UL << NT_PWM4_TZSEL_OSHT3_Pos)                     /*!< NT_PWM4 TZSEL: OSHT3 Mask               */
#define NT_PWM4_TZSEL_OSHT4_Pos               12                                                      /*!< NT_PWM4 TZSEL: OSHT4 Position           */
#define NT_PWM4_TZSEL_OSHT4_Msk               (0x01UL << NT_PWM4_TZSEL_OSHT4_Pos)                     /*!< NT_PWM4 TZSEL: OSHT4 Mask               */
#define NT_PWM4_TZSEL_OSHT5_Pos               13                                                      /*!< NT_PWM4 TZSEL: OSHT5 Position           */
#define NT_PWM4_TZSEL_OSHT5_Msk               (0x01UL << NT_PWM4_TZSEL_OSHT5_Pos)                     /*!< NT_PWM4 TZSEL: OSHT5 Mask               */

/* --------------------------------  NT_PWM4_TZCTL  ------------------------------- */
#define NT_PWM4_TZCTL_TZA_Pos                 0                                                       /*!< NT_PWM4 TZCTL: TZA Position             */
#define NT_PWM4_TZCTL_TZA_Msk                 (0x03UL << NT_PWM4_TZCTL_TZA_Pos)                       /*!< NT_PWM4 TZCTL: TZA Mask                 */
#define NT_PWM4_TZCTL_TZB_Pos                 2                                                       /*!< NT_PWM4 TZCTL: TZB Position             */
#define NT_PWM4_TZCTL_TZB_Msk                 (0x03UL << NT_PWM4_TZCTL_TZB_Pos)                       /*!< NT_PWM4 TZCTL: TZB Mask                 */

/* -------------------------------  NT_PWM4_TZEINT  ------------------------------- */
#define NT_PWM4_TZEINT_CBC_Pos                1                                                       /*!< NT_PWM4 TZEINT: CBC Position            */
#define NT_PWM4_TZEINT_CBC_Msk                (0x01UL << NT_PWM4_TZEINT_CBC_Pos)                      /*!< NT_PWM4 TZEINT: CBC Mask                */
#define NT_PWM4_TZEINT_OST_Pos                2                                                       /*!< NT_PWM4 TZEINT: OST Position            */
#define NT_PWM4_TZEINT_OST_Msk                (0x01UL << NT_PWM4_TZEINT_OST_Pos)                      /*!< NT_PWM4 TZEINT: OST Mask                */

/* --------------------------------  NT_PWM4_TZFLG  ------------------------------- */
#define NT_PWM4_TZFLG_INT_Pos                 0                                                       /*!< NT_PWM4 TZFLG: INT Position             */
#define NT_PWM4_TZFLG_INT_Msk                 (0x01UL << NT_PWM4_TZFLG_INT_Pos)                       /*!< NT_PWM4 TZFLG: INT Mask                 */
#define NT_PWM4_TZFLG_CBC_Pos                 1                                                       /*!< NT_PWM4 TZFLG: CBC Position             */
#define NT_PWM4_TZFLG_CBC_Msk                 (0x01UL << NT_PWM4_TZFLG_CBC_Pos)                       /*!< NT_PWM4 TZFLG: CBC Mask                 */
#define NT_PWM4_TZFLG_OST_Pos                 2                                                       /*!< NT_PWM4 TZFLG: OST Position             */
#define NT_PWM4_TZFLG_OST_Msk                 (0x01UL << NT_PWM4_TZFLG_OST_Pos)                       /*!< NT_PWM4 TZFLG: OST Mask                 */

/* --------------------------------  NT_PWM4_TZCLR  ------------------------------- */
#define NT_PWM4_TZCLR_INT_Pos                 0                                                       /*!< NT_PWM4 TZCLR: INT Position             */
#define NT_PWM4_TZCLR_INT_Msk                 (0x01UL << NT_PWM4_TZCLR_INT_Pos)                       /*!< NT_PWM4 TZCLR: INT Mask                 */
#define NT_PWM4_TZCLR_CBC_Pos                 1                                                       /*!< NT_PWM4 TZCLR: CBC Position             */
#define NT_PWM4_TZCLR_CBC_Msk                 (0x01UL << NT_PWM4_TZCLR_CBC_Pos)                       /*!< NT_PWM4 TZCLR: CBC Mask                 */
#define NT_PWM4_TZCLR_OST_Pos                 2                                                       /*!< NT_PWM4 TZCLR: OST Position             */
#define NT_PWM4_TZCLR_OST_Msk                 (0x01UL << NT_PWM4_TZCLR_OST_Pos)                       /*!< NT_PWM4 TZCLR: OST Mask                 */

/* --------------------------------  NT_PWM4_TZFRC  ------------------------------- */
#define NT_PWM4_TZFRC_CBC_Pos                 1                                                       /*!< NT_PWM4 TZFRC: CBC Position             */
#define NT_PWM4_TZFRC_CBC_Msk                 (0x01UL << NT_PWM4_TZFRC_CBC_Pos)                       /*!< NT_PWM4 TZFRC: CBC Mask                 */
#define NT_PWM4_TZFRC_OST_Pos                 2                                                       /*!< NT_PWM4 TZFRC: OST Position             */
#define NT_PWM4_TZFRC_OST_Msk                 (0x01UL << NT_PWM4_TZFRC_OST_Pos)                       /*!< NT_PWM4 TZFRC: OST Mask                 */

/* --------------------------------  NT_PWM4_ETSEL  ------------------------------- */
#define NT_PWM4_ETSEL_INTSEL_Pos              0                                                       /*!< NT_PWM4 ETSEL: INTSEL Position          */
#define NT_PWM4_ETSEL_INTSEL_Msk              (0x07UL << NT_PWM4_ETSEL_INTSEL_Pos)                    /*!< NT_PWM4 ETSEL: INTSEL Mask              */
#define NT_PWM4_ETSEL_INTEN_Pos               3                                                       /*!< NT_PWM4 ETSEL: INTEN Position           */
#define NT_PWM4_ETSEL_INTEN_Msk               (0x01UL << NT_PWM4_ETSEL_INTEN_Pos)                     /*!< NT_PWM4 ETSEL: INTEN Mask               */
#define NT_PWM4_ETSEL_SOCASEL_Pos             8                                                       /*!< NT_PWM4 ETSEL: SOCASEL Position         */
#define NT_PWM4_ETSEL_SOCASEL_Msk             (0x07UL << NT_PWM4_ETSEL_SOCASEL_Pos)                   /*!< NT_PWM4 ETSEL: SOCASEL Mask             */
#define NT_PWM4_ETSEL_SOCAEN_Pos              11                                                      /*!< NT_PWM4 ETSEL: SOCAEN Position          */
#define NT_PWM4_ETSEL_SOCAEN_Msk              (0x01UL << NT_PWM4_ETSEL_SOCAEN_Pos)                    /*!< NT_PWM4 ETSEL: SOCAEN Mask              */
#define NT_PWM4_ETSEL_SOCBSEL_Pos             12                                                      /*!< NT_PWM4 ETSEL: SOCBSEL Position         */
#define NT_PWM4_ETSEL_SOCBSEL_Msk             (0x07UL << NT_PWM4_ETSEL_SOCBSEL_Pos)                   /*!< NT_PWM4 ETSEL: SOCBSEL Mask             */
#define NT_PWM4_ETSEL_SOCBEN_Pos              15                                                      /*!< NT_PWM4 ETSEL: SOCBEN Position          */
#define NT_PWM4_ETSEL_SOCBEN_Msk              (0x01UL << NT_PWM4_ETSEL_SOCBEN_Pos)                    /*!< NT_PWM4 ETSEL: SOCBEN Mask              */

/* --------------------------------  NT_PWM4_ETPS  -------------------------------- */
#define NT_PWM4_ETPS_INTPRD_Pos               0                                                       /*!< NT_PWM4 ETPS: INTPRD Position           */
#define NT_PWM4_ETPS_INTPRD_Msk               (0x03UL << NT_PWM4_ETPS_INTPRD_Pos)                     /*!< NT_PWM4 ETPS: INTPRD Mask               */
#define NT_PWM4_ETPS_INTCNT_Pos               2                                                       /*!< NT_PWM4 ETPS: INTCNT Position           */
#define NT_PWM4_ETPS_INTCNT_Msk               (0x03UL << NT_PWM4_ETPS_INTCNT_Pos)                     /*!< NT_PWM4 ETPS: INTCNT Mask               */
#define NT_PWM4_ETPS_SOCAPRD_Pos              8                                                       /*!< NT_PWM4 ETPS: SOCAPRD Position          */
#define NT_PWM4_ETPS_SOCAPRD_Msk              (0x03UL << NT_PWM4_ETPS_SOCAPRD_Pos)                    /*!< NT_PWM4 ETPS: SOCAPRD Mask              */
#define NT_PWM4_ETPS_SOCACNT_Pos              10                                                      /*!< NT_PWM4 ETPS: SOCACNT Position          */
#define NT_PWM4_ETPS_SOCACNT_Msk              (0x03UL << NT_PWM4_ETPS_SOCACNT_Pos)                    /*!< NT_PWM4 ETPS: SOCACNT Mask              */
#define NT_PWM4_ETPS_SOCPRD_Pos               12                                                      /*!< NT_PWM4 ETPS: SOCPRD Position           */
#define NT_PWM4_ETPS_SOCPRD_Msk               (0x03UL << NT_PWM4_ETPS_SOCPRD_Pos)                     /*!< NT_PWM4 ETPS: SOCPRD Mask               */
#define NT_PWM4_ETPS_SOCBCNT_Pos              14                                                      /*!< NT_PWM4 ETPS: SOCBCNT Position          */
#define NT_PWM4_ETPS_SOCBCNT_Msk              (0x03UL << NT_PWM4_ETPS_SOCBCNT_Pos)                    /*!< NT_PWM4 ETPS: SOCBCNT Mask              */

/* --------------------------------  NT_PWM4_ETFLG  ------------------------------- */
#define NT_PWM4_ETFLG_INT_Pos                 0                                                       /*!< NT_PWM4 ETFLG: INT Position             */
#define NT_PWM4_ETFLG_INT_Msk                 (0x01UL << NT_PWM4_ETFLG_INT_Pos)                       /*!< NT_PWM4 ETFLG: INT Mask                 */
#define NT_PWM4_ETFLG_SOCA_Pos                2                                                       /*!< NT_PWM4 ETFLG: SOCA Position            */
#define NT_PWM4_ETFLG_SOCA_Msk                (0x01UL << NT_PWM4_ETFLG_SOCA_Pos)                      /*!< NT_PWM4 ETFLG: SOCA Mask                */
#define NT_PWM4_ETFLG_SOCB_Pos                3                                                       /*!< NT_PWM4 ETFLG: SOCB Position            */
#define NT_PWM4_ETFLG_SOCB_Msk                (0x01UL << NT_PWM4_ETFLG_SOCB_Pos)                      /*!< NT_PWM4 ETFLG: SOCB Mask                */

/* --------------------------------  NT_PWM4_ETCLR  ------------------------------- */
#define NT_PWM4_ETCLR_INT_Pos                 0                                                       /*!< NT_PWM4 ETCLR: INT Position             */
#define NT_PWM4_ETCLR_INT_Msk                 (0x01UL << NT_PWM4_ETCLR_INT_Pos)                       /*!< NT_PWM4 ETCLR: INT Mask                 */
#define NT_PWM4_ETCLR_SOCA_Pos                2                                                       /*!< NT_PWM4 ETCLR: SOCA Position            */
#define NT_PWM4_ETCLR_SOCA_Msk                (0x01UL << NT_PWM4_ETCLR_SOCA_Pos)                      /*!< NT_PWM4 ETCLR: SOCA Mask                */
#define NT_PWM4_ETCLR_SOCB_Pos                3                                                       /*!< NT_PWM4 ETCLR: SOCB Position            */
#define NT_PWM4_ETCLR_SOCB_Msk                (0x01UL << NT_PWM4_ETCLR_SOCB_Pos)                      /*!< NT_PWM4 ETCLR: SOCB Mask                */

/* --------------------------------  NT_PWM4_ETFRC  ------------------------------- */
#define NT_PWM4_ETFRC_INT_Pos                 0                                                       /*!< NT_PWM4 ETFRC: INT Position             */
#define NT_PWM4_ETFRC_INT_Msk                 (0x01UL << NT_PWM4_ETFRC_INT_Pos)                       /*!< NT_PWM4 ETFRC: INT Mask                 */
#define NT_PWM4_ETFRC_SOCA_Pos                2                                                       /*!< NT_PWM4 ETFRC: SOCA Position            */
#define NT_PWM4_ETFRC_SOCA_Msk                (0x01UL << NT_PWM4_ETFRC_SOCA_Pos)                      /*!< NT_PWM4 ETFRC: SOCA Mask                */
#define NT_PWM4_ETFRC_SOCB_Pos                3                                                       /*!< NT_PWM4 ETFRC: SOCB Position            */
#define NT_PWM4_ETFRC_SOCB_Msk                (0x01UL << NT_PWM4_ETFRC_SOCB_Pos)                      /*!< NT_PWM4 ETFRC: SOCB Mask                */

/* --------------------------------  NT_PWM4_PCCTL  ------------------------------- */
#define NT_PWM4_PCCTL_CHPEN_Pos               0                                                       /*!< NT_PWM4 PCCTL: CHPEN Position           */
#define NT_PWM4_PCCTL_CHPEN_Msk               (0x01UL << NT_PWM4_PCCTL_CHPEN_Pos)                     /*!< NT_PWM4 PCCTL: CHPEN Mask               */
#define NT_PWM4_PCCTL_OSHTWTH_Pos             1                                                       /*!< NT_PWM4 PCCTL: OSHTWTH Position         */
#define NT_PWM4_PCCTL_OSHTWTH_Msk             (0x0fUL << NT_PWM4_PCCTL_OSHTWTH_Pos)                   /*!< NT_PWM4 PCCTL: OSHTWTH Mask             */
#define NT_PWM4_PCCTL_SHRFREQ_Pos             5                                                       /*!< NT_PWM4 PCCTL: SHRFREQ Position         */
#define NT_PWM4_PCCTL_SHRFREQ_Msk             (0x07UL << NT_PWM4_PCCTL_SHRFREQ_Pos)                   /*!< NT_PWM4 PCCTL: SHRFREQ Mask             */
#define NT_PWM4_PCCTL_CHPDUTY_Pos             8                                                       /*!< NT_PWM4 PCCTL: CHPDUTY Position         */
#define NT_PWM4_PCCTL_CHPDUTY_Msk             (0x07UL << NT_PWM4_PCCTL_CHPDUTY_Pos)                   /*!< NT_PWM4 PCCTL: CHPDUTY Mask             */

/* -------------------------------  NT_PWM4_HRCNFG  ------------------------------- */
#define NT_PWM4_HRCNFG_EDGMODE_Pos            0                                                       /*!< NT_PWM4 HRCNFG: EDGMODE Position        */
#define NT_PWM4_HRCNFG_EDGMODE_Msk            (0x03UL << NT_PWM4_HRCNFG_EDGMODE_Pos)                  /*!< NT_PWM4 HRCNFG: EDGMODE Mask            */
#define NT_PWM4_HRCNFG_CTLMODE_Pos            2                                                       /*!< NT_PWM4 HRCNFG: CTLMODE Position        */
#define NT_PWM4_HRCNFG_CTLMODE_Msk            (0x01UL << NT_PWM4_HRCNFG_CTLMODE_Pos)                  /*!< NT_PWM4 HRCNFG: CTLMODE Mask            */
#define NT_PWM4_HRCNFG_HR_LOAD_Pos            3                                                       /*!< NT_PWM4 HRCNFG: HR_LOAD Position        */
#define NT_PWM4_HRCNFG_HR_LOAD_Msk            (0x01UL << NT_PWM4_HRCNFG_HR_LOAD_Pos)                  /*!< NT_PWM4 HRCNFG: HR_LOAD Mask            */
#define NT_PWM4_HRCNFG_MEP_SCALEFACTOR_Pos    16                                                      /*!< NT_PWM4 HRCNFG: MEP_SCALEFACTOR Position */
#define NT_PWM4_HRCNFG_MEP_SCALEFACTOR_Msk    (0x000000ffUL << NT_PWM4_HRCNFG_MEP_SCALEFACTOR_Pos)    /*!< NT_PWM4 HRCNFG: MEP_SCALEFACTOR Mask    */

/* --------------------------------  NT_PWM4_FWDTH  ------------------------------- */
#define NT_PWM4_FWDTH_FWDTH_Pos               0                                                       /*!< NT_PWM4 FWDTH: FWDTH Position           */
#define NT_PWM4_FWDTH_FWDTH_Msk               (0x000000ffUL << NT_PWM4_FWDTH_FWDTH_Pos)               /*!< NT_PWM4 FWDTH: FWDTH Mask               */

/* --------------------------------  NT_PWM4_HDSEL  ------------------------------- */
#define NT_PWM4_HDSEL_DCMP_Pos                0                                                       /*!< NT_PWM4 HDSEL: DCMP Position            */
#define NT_PWM4_HDSEL_DCMP_Msk                (0x00ffffffUL << NT_PWM4_HDSEL_DCMP_Pos)                /*!< NT_PWM4 HDSEL: DCMP Mask                */
#define NT_PWM4_HDSEL_ACMP_Pos                24                                                      /*!< NT_PWM4 HDSEL: ACMP Position            */
#define NT_PWM4_HDSEL_ACMP_Msk                (0x07UL << NT_PWM4_HDSEL_ACMP_Pos)                      /*!< NT_PWM4 HDSEL: ACMP Mask                */

/* --------------------------------  NT_PWM4_HDCTL  ------------------------------- */
#define NT_PWM4_HDCTL_HDA_Pos                 0                                                       /*!< NT_PWM4 HDCTL: HDA Position             */
#define NT_PWM4_HDCTL_HDA_Msk                 (0x03UL << NT_PWM4_HDCTL_HDA_Pos)                       /*!< NT_PWM4 HDCTL: HDA Mask                 */
#define NT_PWM4_HDCTL_HDB_Pos                 2                                                       /*!< NT_PWM4 HDCTL: HDB Position             */
#define NT_PWM4_HDCTL_HDB_Msk                 (0x03UL << NT_PWM4_HDCTL_HDB_Pos)                       /*!< NT_PWM4 HDCTL: HDB Mask                 */

/* -------------------------------  NT_PWM4_HDEINT  ------------------------------- */
#define NT_PWM4_HDEINT_CBC_Pos                1                                                       /*!< NT_PWM4 HDEINT: CBC Position            */
#define NT_PWM4_HDEINT_CBC_Msk                (0x01UL << NT_PWM4_HDEINT_CBC_Pos)                      /*!< NT_PWM4 HDEINT: CBC Mask                */
#define NT_PWM4_HDEINT_OST_Pos                2                                                       /*!< NT_PWM4 HDEINT: OST Position            */
#define NT_PWM4_HDEINT_OST_Msk                (0x01UL << NT_PWM4_HDEINT_OST_Pos)                      /*!< NT_PWM4 HDEINT: OST Mask                */

/* --------------------------------  NT_PWM4_HDFLG  ------------------------------- */
#define NT_PWM4_HDFLG_HDINT_Pos               0                                                       /*!< NT_PWM4 HDFLG: HDINT Position           */
#define NT_PWM4_HDFLG_HDINT_Msk               (0x01UL << NT_PWM4_HDFLG_HDINT_Pos)                     /*!< NT_PWM4 HDFLG: HDINT Mask               */
#define NT_PWM4_HDFLG_CBC_Pos                 1                                                       /*!< NT_PWM4 HDFLG: CBC Position             */
#define NT_PWM4_HDFLG_CBC_Msk                 (0x01UL << NT_PWM4_HDFLG_CBC_Pos)                       /*!< NT_PWM4 HDFLG: CBC Mask                 */
#define NT_PWM4_HDFLG_OST_Pos                 2                                                       /*!< NT_PWM4 HDFLG: OST Position             */
#define NT_PWM4_HDFLG_OST_Msk                 (0x01UL << NT_PWM4_HDFLG_OST_Pos)                       /*!< NT_PWM4 HDFLG: OST Mask                 */

/* --------------------------------  NT_PWM4_HDCLR  ------------------------------- */
#define NT_PWM4_HDCLR_HDINT_Pos               0                                                       /*!< NT_PWM4 HDCLR: HDINT Position           */
#define NT_PWM4_HDCLR_HDINT_Msk               (0x01UL << NT_PWM4_HDCLR_HDINT_Pos)                     /*!< NT_PWM4 HDCLR: HDINT Mask               */

/* --------------------------------  NT_PWM4_HDFRC  ------------------------------- */
#define NT_PWM4_HDFRC_CBC_Pos                 1                                                       /*!< NT_PWM4 HDFRC: CBC Position             */
#define NT_PWM4_HDFRC_CBC_Msk                 (0x01UL << NT_PWM4_HDFRC_CBC_Pos)                       /*!< NT_PWM4 HDFRC: CBC Mask                 */
#define NT_PWM4_HDFRC_OST_Pos                 2                                                       /*!< NT_PWM4 HDFRC: OST Position             */
#define NT_PWM4_HDFRC_OST_Msk                 (0x01UL << NT_PWM4_HDFRC_OST_Pos)                       /*!< NT_PWM4 HDFRC: OST Mask                 */

/* ------------------------------  NT_PWM4_HDINTCLR  ------------------------------ */
#define NT_PWM4_HDINTCLR_HDINT_Pos            0                                                       /*!< NT_PWM4 HDINTCLR: HDINT Position        */
#define NT_PWM4_HDINTCLR_HDINT_Msk            (0x01UL << NT_PWM4_HDINTCLR_HDINT_Pos)                  /*!< NT_PWM4 HDINTCLR: HDINT Mask            */

/* ------------------------------  NT_PWM4_TZINTCLR  ------------------------------ */
#define NT_PWM4_TZINTCLR_TZINT_Pos            0                                                       /*!< NT_PWM4 TZINTCLR: TZINT Position        */
#define NT_PWM4_TZINTCLR_TZINT_Msk            (0x01UL << NT_PWM4_TZINTCLR_TZINT_Pos)                  /*!< NT_PWM4 TZINTCLR: TZINT Mask            */

/* -------------------------------  NT_PWM4_INTCLR  ------------------------------- */
#define NT_PWM4_INTCLR_INT_Pos                0                                                       /*!< NT_PWM4 INTCLR: INT Position            */
#define NT_PWM4_INTCLR_INT_Msk                (0x01UL << NT_PWM4_INTCLR_INT_Pos)                      /*!< NT_PWM4 INTCLR: INT Mask                */


/* ================================================================================ */
/* ================        struct 'NT_PWM5' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_PWM5_TBCTL  ------------------------------- */
#define NT_PWM5_TBCTL_CTRMODE_Pos             0                                                       /*!< NT_PWM5 TBCTL: CTRMODE Position         */
#define NT_PWM5_TBCTL_CTRMODE_Msk             (0x03UL << NT_PWM5_TBCTL_CTRMODE_Pos)                   /*!< NT_PWM5 TBCTL: CTRMODE Mask             */
#define NT_PWM5_TBCTL_PHSEN_Pos               2                                                       /*!< NT_PWM5 TBCTL: PHSEN Position           */
#define NT_PWM5_TBCTL_PHSEN_Msk               (0x01UL << NT_PWM5_TBCTL_PHSEN_Pos)                     /*!< NT_PWM5 TBCTL: PHSEN Mask               */
#define NT_PWM5_TBCTL_PRDLD_Pos               3                                                       /*!< NT_PWM5 TBCTL: PRDLD Position           */
#define NT_PWM5_TBCTL_PRDLD_Msk               (0x01UL << NT_PWM5_TBCTL_PRDLD_Pos)                     /*!< NT_PWM5 TBCTL: PRDLD Mask               */
#define NT_PWM5_TBCTL_SYNCOSEL_Pos            4                                                       /*!< NT_PWM5 TBCTL: SYNCOSEL Position        */
#define NT_PWM5_TBCTL_SYNCOSEL_Msk            (0x03UL << NT_PWM5_TBCTL_SYNCOSEL_Pos)                  /*!< NT_PWM5 TBCTL: SYNCOSEL Mask            */
#define NT_PWM5_TBCTL_SWFSYNC_Pos             6                                                       /*!< NT_PWM5 TBCTL: SWFSYNC Position         */
#define NT_PWM5_TBCTL_SWFSYNC_Msk             (0x01UL << NT_PWM5_TBCTL_SWFSYNC_Pos)                   /*!< NT_PWM5 TBCTL: SWFSYNC Mask             */
#define NT_PWM5_TBCTL_HSPCLKDIV_Pos           7                                                       /*!< NT_PWM5 TBCTL: HSPCLKDIV Position       */
#define NT_PWM5_TBCTL_HSPCLKDIV_Msk           (0x07UL << NT_PWM5_TBCTL_HSPCLKDIV_Pos)                 /*!< NT_PWM5 TBCTL: HSPCLKDIV Mask           */
#define NT_PWM5_TBCTL_CLKDIV_Pos              10                                                      /*!< NT_PWM5 TBCTL: CLKDIV Position          */
#define NT_PWM5_TBCTL_CLKDIV_Msk              (0x07UL << NT_PWM5_TBCTL_CLKDIV_Pos)                    /*!< NT_PWM5 TBCTL: CLKDIV Mask              */
#define NT_PWM5_TBCTL_PHSDIR_Pos              13                                                      /*!< NT_PWM5 TBCTL: PHSDIR Position          */
#define NT_PWM5_TBCTL_PHSDIR_Msk              (0x01UL << NT_PWM5_TBCTL_PHSDIR_Pos)                    /*!< NT_PWM5 TBCTL: PHSDIR Mask              */
#define NT_PWM5_TBCTL_FREE_SOFT_Pos           14                                                      /*!< NT_PWM5 TBCTL: FREE_SOFT Position       */
#define NT_PWM5_TBCTL_FREE_SOFT_Msk           (0x03UL << NT_PWM5_TBCTL_FREE_SOFT_Pos)                 /*!< NT_PWM5 TBCTL: FREE_SOFT Mask           */

/* --------------------------------  NT_PWM5_TBSTS  ------------------------------- */
#define NT_PWM5_TBSTS_CTRDIR_Pos              0                                                       /*!< NT_PWM5 TBSTS: CTRDIR Position          */
#define NT_PWM5_TBSTS_CTRDIR_Msk              (0x01UL << NT_PWM5_TBSTS_CTRDIR_Pos)                    /*!< NT_PWM5 TBSTS: CTRDIR Mask              */
#define NT_PWM5_TBSTS_SYNCI_Pos               1                                                       /*!< NT_PWM5 TBSTS: SYNCI Position           */
#define NT_PWM5_TBSTS_SYNCI_Msk               (0x01UL << NT_PWM5_TBSTS_SYNCI_Pos)                     /*!< NT_PWM5 TBSTS: SYNCI Mask               */
#define NT_PWM5_TBSTS_CTRMAX_Pos              2                                                       /*!< NT_PWM5 TBSTS: CTRMAX Position          */
#define NT_PWM5_TBSTS_CTRMAX_Msk              (0x01UL << NT_PWM5_TBSTS_CTRMAX_Pos)                    /*!< NT_PWM5 TBSTS: CTRMAX Mask              */

/* --------------------------------  NT_PWM5_TBPHS  ------------------------------- */
#define NT_PWM5_TBPHS_TBPHSHR_Pos             8                                                       /*!< NT_PWM5 TBPHS: TBPHSHR Position         */
#define NT_PWM5_TBPHS_TBPHSHR_Msk             (0x000000ffUL << NT_PWM5_TBPHS_TBPHSHR_Pos)             /*!< NT_PWM5 TBPHS: TBPHSHR Mask             */
#define NT_PWM5_TBPHS_TBPHS_Pos               16                                                      /*!< NT_PWM5 TBPHS: TBPHS Position           */
#define NT_PWM5_TBPHS_TBPHS_Msk               (0x0000ffffUL << NT_PWM5_TBPHS_TBPHS_Pos)               /*!< NT_PWM5 TBPHS: TBPHS Mask               */

/* --------------------------------  NT_PWM5_TBCTR  ------------------------------- */
#define NT_PWM5_TBCTR_TBCTR_Pos               0                                                       /*!< NT_PWM5 TBCTR: TBCTR Position           */
#define NT_PWM5_TBCTR_TBCTR_Msk               (0x0000ffffUL << NT_PWM5_TBCTR_TBCTR_Pos)               /*!< NT_PWM5 TBCTR: TBCTR Mask               */

/* --------------------------------  NT_PWM5_TBPRD  ------------------------------- */
#define NT_PWM5_TBPRD_TBPRD_Pos               0                                                       /*!< NT_PWM5 TBPRD: TBPRD Position           */
#define NT_PWM5_TBPRD_TBPRD_Msk               (0x0000ffffUL << NT_PWM5_TBPRD_TBPRD_Pos)               /*!< NT_PWM5 TBPRD: TBPRD Mask               */

/* -------------------------------  NT_PWM5_CMPCTL  ------------------------------- */
#define NT_PWM5_CMPCTL_LOADAMODE_Pos          0                                                       /*!< NT_PWM5 CMPCTL: LOADAMODE Position      */
#define NT_PWM5_CMPCTL_LOADAMODE_Msk          (0x03UL << NT_PWM5_CMPCTL_LOADAMODE_Pos)                /*!< NT_PWM5 CMPCTL: LOADAMODE Mask          */
#define NT_PWM5_CMPCTL_LOADBMODE_Pos          2                                                       /*!< NT_PWM5 CMPCTL: LOADBMODE Position      */
#define NT_PWM5_CMPCTL_LOADBMODE_Msk          (0x03UL << NT_PWM5_CMPCTL_LOADBMODE_Pos)                /*!< NT_PWM5 CMPCTL: LOADBMODE Mask          */
#define NT_PWM5_CMPCTL_SHDWAMODE_Pos          4                                                       /*!< NT_PWM5 CMPCTL: SHDWAMODE Position      */
#define NT_PWM5_CMPCTL_SHDWAMODE_Msk          (0x01UL << NT_PWM5_CMPCTL_SHDWAMODE_Pos)                /*!< NT_PWM5 CMPCTL: SHDWAMODE Mask          */
#define NT_PWM5_CMPCTL_SHDWBMODE_Pos          6                                                       /*!< NT_PWM5 CMPCTL: SHDWBMODE Position      */
#define NT_PWM5_CMPCTL_SHDWBMODE_Msk          (0x01UL << NT_PWM5_CMPCTL_SHDWBMODE_Pos)                /*!< NT_PWM5 CMPCTL: SHDWBMODE Mask          */
#define NT_PWM5_CMPCTL_SHDWAFULL_Pos          8                                                       /*!< NT_PWM5 CMPCTL: SHDWAFULL Position      */
#define NT_PWM5_CMPCTL_SHDWAFULL_Msk          (0x01UL << NT_PWM5_CMPCTL_SHDWAFULL_Pos)                /*!< NT_PWM5 CMPCTL: SHDWAFULL Mask          */
#define NT_PWM5_CMPCTL_SHDWBFULL_Pos          9                                                       /*!< NT_PWM5 CMPCTL: SHDWBFULL Position      */
#define NT_PWM5_CMPCTL_SHDWBFULL_Msk          (0x01UL << NT_PWM5_CMPCTL_SHDWBFULL_Pos)                /*!< NT_PWM5 CMPCTL: SHDWBFULL Mask          */

/* --------------------------------  NT_PWM5_CMPA  -------------------------------- */
#define NT_PWM5_CMPA_CMPAHR_Pos               8                                                       /*!< NT_PWM5 CMPA: CMPAHR Position           */
#define NT_PWM5_CMPA_CMPAHR_Msk               (0x000000ffUL << NT_PWM5_CMPA_CMPAHR_Pos)               /*!< NT_PWM5 CMPA: CMPAHR Mask               */
#define NT_PWM5_CMPA_CMPA_Pos                 16                                                      /*!< NT_PWM5 CMPA: CMPA Position             */
#define NT_PWM5_CMPA_CMPA_Msk                 (0x0000ffffUL << NT_PWM5_CMPA_CMPA_Pos)                 /*!< NT_PWM5 CMPA: CMPA Mask                 */

/* --------------------------------  NT_PWM5_CMPB  -------------------------------- */
#define NT_PWM5_CMPB_CMPB_Pos                 16                                                      /*!< NT_PWM5 CMPB: CMPB Position             */
#define NT_PWM5_CMPB_CMPB_Msk                 (0x0000ffffUL << NT_PWM5_CMPB_CMPB_Pos)                 /*!< NT_PWM5 CMPB: CMPB Mask                 */

/* -------------------------------  NT_PWM5_AQCTLA  ------------------------------- */
#define NT_PWM5_AQCTLA_ZRO_Pos                0                                                       /*!< NT_PWM5 AQCTLA: ZRO Position            */
#define NT_PWM5_AQCTLA_ZRO_Msk                (0x03UL << NT_PWM5_AQCTLA_ZRO_Pos)                      /*!< NT_PWM5 AQCTLA: ZRO Mask                */
#define NT_PWM5_AQCTLA_PRD_Pos                2                                                       /*!< NT_PWM5 AQCTLA: PRD Position            */
#define NT_PWM5_AQCTLA_PRD_Msk                (0x03UL << NT_PWM5_AQCTLA_PRD_Pos)                      /*!< NT_PWM5 AQCTLA: PRD Mask                */
#define NT_PWM5_AQCTLA_CAU_Pos                4                                                       /*!< NT_PWM5 AQCTLA: CAU Position            */
#define NT_PWM5_AQCTLA_CAU_Msk                (0x03UL << NT_PWM5_AQCTLA_CAU_Pos)                      /*!< NT_PWM5 AQCTLA: CAU Mask                */
#define NT_PWM5_AQCTLA_CAD_Pos                6                                                       /*!< NT_PWM5 AQCTLA: CAD Position            */
#define NT_PWM5_AQCTLA_CAD_Msk                (0x03UL << NT_PWM5_AQCTLA_CAD_Pos)                      /*!< NT_PWM5 AQCTLA: CAD Mask                */
#define NT_PWM5_AQCTLA_CBU_Pos                8                                                       /*!< NT_PWM5 AQCTLA: CBU Position            */
#define NT_PWM5_AQCTLA_CBU_Msk                (0x03UL << NT_PWM5_AQCTLA_CBU_Pos)                      /*!< NT_PWM5 AQCTLA: CBU Mask                */
#define NT_PWM5_AQCTLA_CBD_Pos                10                                                      /*!< NT_PWM5 AQCTLA: CBD Position            */
#define NT_PWM5_AQCTLA_CBD_Msk                (0x03UL << NT_PWM5_AQCTLA_CBD_Pos)                      /*!< NT_PWM5 AQCTLA: CBD Mask                */

/* -------------------------------  NT_PWM5_AQCTLB  ------------------------------- */
#define NT_PWM5_AQCTLB_ZRO_Pos                0                                                       /*!< NT_PWM5 AQCTLB: ZRO Position            */
#define NT_PWM5_AQCTLB_ZRO_Msk                (0x03UL << NT_PWM5_AQCTLB_ZRO_Pos)                      /*!< NT_PWM5 AQCTLB: ZRO Mask                */
#define NT_PWM5_AQCTLB_PRD_Pos                2                                                       /*!< NT_PWM5 AQCTLB: PRD Position            */
#define NT_PWM5_AQCTLB_PRD_Msk                (0x03UL << NT_PWM5_AQCTLB_PRD_Pos)                      /*!< NT_PWM5 AQCTLB: PRD Mask                */
#define NT_PWM5_AQCTLB_CAU_Pos                4                                                       /*!< NT_PWM5 AQCTLB: CAU Position            */
#define NT_PWM5_AQCTLB_CAU_Msk                (0x03UL << NT_PWM5_AQCTLB_CAU_Pos)                      /*!< NT_PWM5 AQCTLB: CAU Mask                */
#define NT_PWM5_AQCTLB_CAD_Pos                6                                                       /*!< NT_PWM5 AQCTLB: CAD Position            */
#define NT_PWM5_AQCTLB_CAD_Msk                (0x03UL << NT_PWM5_AQCTLB_CAD_Pos)                      /*!< NT_PWM5 AQCTLB: CAD Mask                */
#define NT_PWM5_AQCTLB_CBU_Pos                8                                                       /*!< NT_PWM5 AQCTLB: CBU Position            */
#define NT_PWM5_AQCTLB_CBU_Msk                (0x03UL << NT_PWM5_AQCTLB_CBU_Pos)                      /*!< NT_PWM5 AQCTLB: CBU Mask                */
#define NT_PWM5_AQCTLB_CBD_Pos                10                                                      /*!< NT_PWM5 AQCTLB: CBD Position            */
#define NT_PWM5_AQCTLB_CBD_Msk                (0x03UL << NT_PWM5_AQCTLB_CBD_Pos)                      /*!< NT_PWM5 AQCTLB: CBD Mask                */

/* -------------------------------  NT_PWM5_AQSFRC  ------------------------------- */
#define NT_PWM5_AQSFRC_ACTSFA_Pos             0                                                       /*!< NT_PWM5 AQSFRC: ACTSFA Position         */
#define NT_PWM5_AQSFRC_ACTSFA_Msk             (0x03UL << NT_PWM5_AQSFRC_ACTSFA_Pos)                   /*!< NT_PWM5 AQSFRC: ACTSFA Mask             */
#define NT_PWM5_AQSFRC_OTSFA_Pos              2                                                       /*!< NT_PWM5 AQSFRC: OTSFA Position          */
#define NT_PWM5_AQSFRC_OTSFA_Msk              (0x01UL << NT_PWM5_AQSFRC_OTSFA_Pos)                    /*!< NT_PWM5 AQSFRC: OTSFA Mask              */
#define NT_PWM5_AQSFRC_ACTSFB_Pos             3                                                       /*!< NT_PWM5 AQSFRC: ACTSFB Position         */
#define NT_PWM5_AQSFRC_ACTSFB_Msk             (0x03UL << NT_PWM5_AQSFRC_ACTSFB_Pos)                   /*!< NT_PWM5 AQSFRC: ACTSFB Mask             */
#define NT_PWM5_AQSFRC_OTSFB_Pos              5                                                       /*!< NT_PWM5 AQSFRC: OTSFB Position          */
#define NT_PWM5_AQSFRC_OTSFB_Msk              (0x01UL << NT_PWM5_AQSFRC_OTSFB_Pos)                    /*!< NT_PWM5 AQSFRC: OTSFB Mask              */
#define NT_PWM5_AQSFRC_RLDCSF_Pos             6                                                       /*!< NT_PWM5 AQSFRC: RLDCSF Position         */
#define NT_PWM5_AQSFRC_RLDCSF_Msk             (0x03UL << NT_PWM5_AQSFRC_RLDCSF_Pos)                   /*!< NT_PWM5 AQSFRC: RLDCSF Mask             */

/* -------------------------------  NT_PWM5_AQCSFRC  ------------------------------ */
#define NT_PWM5_AQCSFRC_CSFA_Pos              0                                                       /*!< NT_PWM5 AQCSFRC: CSFA Position          */
#define NT_PWM5_AQCSFRC_CSFA_Msk              (0x03UL << NT_PWM5_AQCSFRC_CSFA_Pos)                    /*!< NT_PWM5 AQCSFRC: CSFA Mask              */
#define NT_PWM5_AQCSFRC_CSFB_Pos              2                                                       /*!< NT_PWM5 AQCSFRC: CSFB Position          */
#define NT_PWM5_AQCSFRC_CSFB_Msk              (0x03UL << NT_PWM5_AQCSFRC_CSFB_Pos)                    /*!< NT_PWM5 AQCSFRC: CSFB Mask              */

/* --------------------------------  NT_PWM5_DBCTL  ------------------------------- */
#define NT_PWM5_DBCTL_OUT_MODE_Pos            0                                                       /*!< NT_PWM5 DBCTL: OUT_MODE Position        */
#define NT_PWM5_DBCTL_OUT_MODE_Msk            (0x03UL << NT_PWM5_DBCTL_OUT_MODE_Pos)                  /*!< NT_PWM5 DBCTL: OUT_MODE Mask            */
#define NT_PWM5_DBCTL_POLSEL_Pos              2                                                       /*!< NT_PWM5 DBCTL: POLSEL Position          */
#define NT_PWM5_DBCTL_POLSEL_Msk              (0x03UL << NT_PWM5_DBCTL_POLSEL_Pos)                    /*!< NT_PWM5 DBCTL: POLSEL Mask              */
#define NT_PWM5_DBCTL_IN_MODE_Pos             4                                                       /*!< NT_PWM5 DBCTL: IN_MODE Position         */
#define NT_PWM5_DBCTL_IN_MODE_Msk             (0x03UL << NT_PWM5_DBCTL_IN_MODE_Pos)                   /*!< NT_PWM5 DBCTL: IN_MODE Mask             */

/* --------------------------------  NT_PWM5_DBRED  ------------------------------- */
#define NT_PWM5_DBRED_DEL_Pos                 0                                                       /*!< NT_PWM5 DBRED: DEL Position             */
#define NT_PWM5_DBRED_DEL_Msk                 (0x000003ffUL << NT_PWM5_DBRED_DEL_Pos)                 /*!< NT_PWM5 DBRED: DEL Mask                 */

/* --------------------------------  NT_PWM5_DBFED  ------------------------------- */
#define NT_PWM5_DBFED_DEL_Pos                 0                                                       /*!< NT_PWM5 DBFED: DEL Position             */
#define NT_PWM5_DBFED_DEL_Msk                 (0x000003ffUL << NT_PWM5_DBFED_DEL_Pos)                 /*!< NT_PWM5 DBFED: DEL Mask                 */

/* --------------------------------  NT_PWM5_TZSEL  ------------------------------- */
#define NT_PWM5_TZSEL_CBC0_Pos                0                                                       /*!< NT_PWM5 TZSEL: CBC0 Position            */
#define NT_PWM5_TZSEL_CBC0_Msk                (0x01UL << NT_PWM5_TZSEL_CBC0_Pos)                      /*!< NT_PWM5 TZSEL: CBC0 Mask                */
#define NT_PWM5_TZSEL_CBC1_Pos                1                                                       /*!< NT_PWM5 TZSEL: CBC1 Position            */
#define NT_PWM5_TZSEL_CBC1_Msk                (0x01UL << NT_PWM5_TZSEL_CBC1_Pos)                      /*!< NT_PWM5 TZSEL: CBC1 Mask                */
#define NT_PWM5_TZSEL_CBC2_Pos                2                                                       /*!< NT_PWM5 TZSEL: CBC2 Position            */
#define NT_PWM5_TZSEL_CBC2_Msk                (0x01UL << NT_PWM5_TZSEL_CBC2_Pos)                      /*!< NT_PWM5 TZSEL: CBC2 Mask                */
#define NT_PWM5_TZSEL_CBC3_Pos                3                                                       /*!< NT_PWM5 TZSEL: CBC3 Position            */
#define NT_PWM5_TZSEL_CBC3_Msk                (0x01UL << NT_PWM5_TZSEL_CBC3_Pos)                      /*!< NT_PWM5 TZSEL: CBC3 Mask                */
#define NT_PWM5_TZSEL_CBC4_Pos                4                                                       /*!< NT_PWM5 TZSEL: CBC4 Position            */
#define NT_PWM5_TZSEL_CBC4_Msk                (0x01UL << NT_PWM5_TZSEL_CBC4_Pos)                      /*!< NT_PWM5 TZSEL: CBC4 Mask                */
#define NT_PWM5_TZSEL_CBC5_Pos                5                                                       /*!< NT_PWM5 TZSEL: CBC5 Position            */
#define NT_PWM5_TZSEL_CBC5_Msk                (0x01UL << NT_PWM5_TZSEL_CBC5_Pos)                      /*!< NT_PWM5 TZSEL: CBC5 Mask                */
#define NT_PWM5_TZSEL_OSHT0_Pos               8                                                       /*!< NT_PWM5 TZSEL: OSHT0 Position           */
#define NT_PWM5_TZSEL_OSHT0_Msk               (0x01UL << NT_PWM5_TZSEL_OSHT0_Pos)                     /*!< NT_PWM5 TZSEL: OSHT0 Mask               */
#define NT_PWM5_TZSEL_OSHT1_Pos               9                                                       /*!< NT_PWM5 TZSEL: OSHT1 Position           */
#define NT_PWM5_TZSEL_OSHT1_Msk               (0x01UL << NT_PWM5_TZSEL_OSHT1_Pos)                     /*!< NT_PWM5 TZSEL: OSHT1 Mask               */
#define NT_PWM5_TZSEL_OSHT2_Pos               10                                                      /*!< NT_PWM5 TZSEL: OSHT2 Position           */
#define NT_PWM5_TZSEL_OSHT2_Msk               (0x01UL << NT_PWM5_TZSEL_OSHT2_Pos)                     /*!< NT_PWM5 TZSEL: OSHT2 Mask               */
#define NT_PWM5_TZSEL_OSHT3_Pos               11                                                      /*!< NT_PWM5 TZSEL: OSHT3 Position           */
#define NT_PWM5_TZSEL_OSHT3_Msk               (0x01UL << NT_PWM5_TZSEL_OSHT3_Pos)                     /*!< NT_PWM5 TZSEL: OSHT3 Mask               */
#define NT_PWM5_TZSEL_OSHT4_Pos               12                                                      /*!< NT_PWM5 TZSEL: OSHT4 Position           */
#define NT_PWM5_TZSEL_OSHT4_Msk               (0x01UL << NT_PWM5_TZSEL_OSHT4_Pos)                     /*!< NT_PWM5 TZSEL: OSHT4 Mask               */
#define NT_PWM5_TZSEL_OSHT5_Pos               13                                                      /*!< NT_PWM5 TZSEL: OSHT5 Position           */
#define NT_PWM5_TZSEL_OSHT5_Msk               (0x01UL << NT_PWM5_TZSEL_OSHT5_Pos)                     /*!< NT_PWM5 TZSEL: OSHT5 Mask               */

/* --------------------------------  NT_PWM5_TZCTL  ------------------------------- */
#define NT_PWM5_TZCTL_TZA_Pos                 0                                                       /*!< NT_PWM5 TZCTL: TZA Position             */
#define NT_PWM5_TZCTL_TZA_Msk                 (0x03UL << NT_PWM5_TZCTL_TZA_Pos)                       /*!< NT_PWM5 TZCTL: TZA Mask                 */
#define NT_PWM5_TZCTL_TZB_Pos                 2                                                       /*!< NT_PWM5 TZCTL: TZB Position             */
#define NT_PWM5_TZCTL_TZB_Msk                 (0x03UL << NT_PWM5_TZCTL_TZB_Pos)                       /*!< NT_PWM5 TZCTL: TZB Mask                 */

/* -------------------------------  NT_PWM5_TZEINT  ------------------------------- */
#define NT_PWM5_TZEINT_CBC_Pos                1                                                       /*!< NT_PWM5 TZEINT: CBC Position            */
#define NT_PWM5_TZEINT_CBC_Msk                (0x01UL << NT_PWM5_TZEINT_CBC_Pos)                      /*!< NT_PWM5 TZEINT: CBC Mask                */
#define NT_PWM5_TZEINT_OST_Pos                2                                                       /*!< NT_PWM5 TZEINT: OST Position            */
#define NT_PWM5_TZEINT_OST_Msk                (0x01UL << NT_PWM5_TZEINT_OST_Pos)                      /*!< NT_PWM5 TZEINT: OST Mask                */

/* --------------------------------  NT_PWM5_TZFLG  ------------------------------- */
#define NT_PWM5_TZFLG_INT_Pos                 0                                                       /*!< NT_PWM5 TZFLG: INT Position             */
#define NT_PWM5_TZFLG_INT_Msk                 (0x01UL << NT_PWM5_TZFLG_INT_Pos)                       /*!< NT_PWM5 TZFLG: INT Mask                 */
#define NT_PWM5_TZFLG_CBC_Pos                 1                                                       /*!< NT_PWM5 TZFLG: CBC Position             */
#define NT_PWM5_TZFLG_CBC_Msk                 (0x01UL << NT_PWM5_TZFLG_CBC_Pos)                       /*!< NT_PWM5 TZFLG: CBC Mask                 */
#define NT_PWM5_TZFLG_OST_Pos                 2                                                       /*!< NT_PWM5 TZFLG: OST Position             */
#define NT_PWM5_TZFLG_OST_Msk                 (0x01UL << NT_PWM5_TZFLG_OST_Pos)                       /*!< NT_PWM5 TZFLG: OST Mask                 */

/* --------------------------------  NT_PWM5_TZCLR  ------------------------------- */
#define NT_PWM5_TZCLR_INT_Pos                 0                                                       /*!< NT_PWM5 TZCLR: INT Position             */
#define NT_PWM5_TZCLR_INT_Msk                 (0x01UL << NT_PWM5_TZCLR_INT_Pos)                       /*!< NT_PWM5 TZCLR: INT Mask                 */
#define NT_PWM5_TZCLR_CBC_Pos                 1                                                       /*!< NT_PWM5 TZCLR: CBC Position             */
#define NT_PWM5_TZCLR_CBC_Msk                 (0x01UL << NT_PWM5_TZCLR_CBC_Pos)                       /*!< NT_PWM5 TZCLR: CBC Mask                 */
#define NT_PWM5_TZCLR_OST_Pos                 2                                                       /*!< NT_PWM5 TZCLR: OST Position             */
#define NT_PWM5_TZCLR_OST_Msk                 (0x01UL << NT_PWM5_TZCLR_OST_Pos)                       /*!< NT_PWM5 TZCLR: OST Mask                 */

/* --------------------------------  NT_PWM5_TZFRC  ------------------------------- */
#define NT_PWM5_TZFRC_CBC_Pos                 1                                                       /*!< NT_PWM5 TZFRC: CBC Position             */
#define NT_PWM5_TZFRC_CBC_Msk                 (0x01UL << NT_PWM5_TZFRC_CBC_Pos)                       /*!< NT_PWM5 TZFRC: CBC Mask                 */
#define NT_PWM5_TZFRC_OST_Pos                 2                                                       /*!< NT_PWM5 TZFRC: OST Position             */
#define NT_PWM5_TZFRC_OST_Msk                 (0x01UL << NT_PWM5_TZFRC_OST_Pos)                       /*!< NT_PWM5 TZFRC: OST Mask                 */

/* --------------------------------  NT_PWM5_ETSEL  ------------------------------- */
#define NT_PWM5_ETSEL_INTSEL_Pos              0                                                       /*!< NT_PWM5 ETSEL: INTSEL Position          */
#define NT_PWM5_ETSEL_INTSEL_Msk              (0x07UL << NT_PWM5_ETSEL_INTSEL_Pos)                    /*!< NT_PWM5 ETSEL: INTSEL Mask              */
#define NT_PWM5_ETSEL_INTEN_Pos               3                                                       /*!< NT_PWM5 ETSEL: INTEN Position           */
#define NT_PWM5_ETSEL_INTEN_Msk               (0x01UL << NT_PWM5_ETSEL_INTEN_Pos)                     /*!< NT_PWM5 ETSEL: INTEN Mask               */
#define NT_PWM5_ETSEL_SOCASEL_Pos             8                                                       /*!< NT_PWM5 ETSEL: SOCASEL Position         */
#define NT_PWM5_ETSEL_SOCASEL_Msk             (0x07UL << NT_PWM5_ETSEL_SOCASEL_Pos)                   /*!< NT_PWM5 ETSEL: SOCASEL Mask             */
#define NT_PWM5_ETSEL_SOCAEN_Pos              11                                                      /*!< NT_PWM5 ETSEL: SOCAEN Position          */
#define NT_PWM5_ETSEL_SOCAEN_Msk              (0x01UL << NT_PWM5_ETSEL_SOCAEN_Pos)                    /*!< NT_PWM5 ETSEL: SOCAEN Mask              */
#define NT_PWM5_ETSEL_SOCBSEL_Pos             12                                                      /*!< NT_PWM5 ETSEL: SOCBSEL Position         */
#define NT_PWM5_ETSEL_SOCBSEL_Msk             (0x07UL << NT_PWM5_ETSEL_SOCBSEL_Pos)                   /*!< NT_PWM5 ETSEL: SOCBSEL Mask             */
#define NT_PWM5_ETSEL_SOCBEN_Pos              15                                                      /*!< NT_PWM5 ETSEL: SOCBEN Position          */
#define NT_PWM5_ETSEL_SOCBEN_Msk              (0x01UL << NT_PWM5_ETSEL_SOCBEN_Pos)                    /*!< NT_PWM5 ETSEL: SOCBEN Mask              */

/* --------------------------------  NT_PWM5_ETPS  -------------------------------- */
#define NT_PWM5_ETPS_INTPRD_Pos               0                                                       /*!< NT_PWM5 ETPS: INTPRD Position           */
#define NT_PWM5_ETPS_INTPRD_Msk               (0x03UL << NT_PWM5_ETPS_INTPRD_Pos)                     /*!< NT_PWM5 ETPS: INTPRD Mask               */
#define NT_PWM5_ETPS_INTCNT_Pos               2                                                       /*!< NT_PWM5 ETPS: INTCNT Position           */
#define NT_PWM5_ETPS_INTCNT_Msk               (0x03UL << NT_PWM5_ETPS_INTCNT_Pos)                     /*!< NT_PWM5 ETPS: INTCNT Mask               */
#define NT_PWM5_ETPS_SOCAPRD_Pos              8                                                       /*!< NT_PWM5 ETPS: SOCAPRD Position          */
#define NT_PWM5_ETPS_SOCAPRD_Msk              (0x03UL << NT_PWM5_ETPS_SOCAPRD_Pos)                    /*!< NT_PWM5 ETPS: SOCAPRD Mask              */
#define NT_PWM5_ETPS_SOCACNT_Pos              10                                                      /*!< NT_PWM5 ETPS: SOCACNT Position          */
#define NT_PWM5_ETPS_SOCACNT_Msk              (0x03UL << NT_PWM5_ETPS_SOCACNT_Pos)                    /*!< NT_PWM5 ETPS: SOCACNT Mask              */
#define NT_PWM5_ETPS_SOCPRD_Pos               12                                                      /*!< NT_PWM5 ETPS: SOCPRD Position           */
#define NT_PWM5_ETPS_SOCPRD_Msk               (0x03UL << NT_PWM5_ETPS_SOCPRD_Pos)                     /*!< NT_PWM5 ETPS: SOCPRD Mask               */
#define NT_PWM5_ETPS_SOCBCNT_Pos              14                                                      /*!< NT_PWM5 ETPS: SOCBCNT Position          */
#define NT_PWM5_ETPS_SOCBCNT_Msk              (0x03UL << NT_PWM5_ETPS_SOCBCNT_Pos)                    /*!< NT_PWM5 ETPS: SOCBCNT Mask              */

/* --------------------------------  NT_PWM5_ETFLG  ------------------------------- */
#define NT_PWM5_ETFLG_INT_Pos                 0                                                       /*!< NT_PWM5 ETFLG: INT Position             */
#define NT_PWM5_ETFLG_INT_Msk                 (0x01UL << NT_PWM5_ETFLG_INT_Pos)                       /*!< NT_PWM5 ETFLG: INT Mask                 */
#define NT_PWM5_ETFLG_SOCA_Pos                2                                                       /*!< NT_PWM5 ETFLG: SOCA Position            */
#define NT_PWM5_ETFLG_SOCA_Msk                (0x01UL << NT_PWM5_ETFLG_SOCA_Pos)                      /*!< NT_PWM5 ETFLG: SOCA Mask                */
#define NT_PWM5_ETFLG_SOCB_Pos                3                                                       /*!< NT_PWM5 ETFLG: SOCB Position            */
#define NT_PWM5_ETFLG_SOCB_Msk                (0x01UL << NT_PWM5_ETFLG_SOCB_Pos)                      /*!< NT_PWM5 ETFLG: SOCB Mask                */

/* --------------------------------  NT_PWM5_ETCLR  ------------------------------- */
#define NT_PWM5_ETCLR_INT_Pos                 0                                                       /*!< NT_PWM5 ETCLR: INT Position             */
#define NT_PWM5_ETCLR_INT_Msk                 (0x01UL << NT_PWM5_ETCLR_INT_Pos)                       /*!< NT_PWM5 ETCLR: INT Mask                 */
#define NT_PWM5_ETCLR_SOCA_Pos                2                                                       /*!< NT_PWM5 ETCLR: SOCA Position            */
#define NT_PWM5_ETCLR_SOCA_Msk                (0x01UL << NT_PWM5_ETCLR_SOCA_Pos)                      /*!< NT_PWM5 ETCLR: SOCA Mask                */
#define NT_PWM5_ETCLR_SOCB_Pos                3                                                       /*!< NT_PWM5 ETCLR: SOCB Position            */
#define NT_PWM5_ETCLR_SOCB_Msk                (0x01UL << NT_PWM5_ETCLR_SOCB_Pos)                      /*!< NT_PWM5 ETCLR: SOCB Mask                */

/* --------------------------------  NT_PWM5_ETFRC  ------------------------------- */
#define NT_PWM5_ETFRC_INT_Pos                 0                                                       /*!< NT_PWM5 ETFRC: INT Position             */
#define NT_PWM5_ETFRC_INT_Msk                 (0x01UL << NT_PWM5_ETFRC_INT_Pos)                       /*!< NT_PWM5 ETFRC: INT Mask                 */
#define NT_PWM5_ETFRC_SOCA_Pos                2                                                       /*!< NT_PWM5 ETFRC: SOCA Position            */
#define NT_PWM5_ETFRC_SOCA_Msk                (0x01UL << NT_PWM5_ETFRC_SOCA_Pos)                      /*!< NT_PWM5 ETFRC: SOCA Mask                */
#define NT_PWM5_ETFRC_SOCB_Pos                3                                                       /*!< NT_PWM5 ETFRC: SOCB Position            */
#define NT_PWM5_ETFRC_SOCB_Msk                (0x01UL << NT_PWM5_ETFRC_SOCB_Pos)                      /*!< NT_PWM5 ETFRC: SOCB Mask                */

/* --------------------------------  NT_PWM5_PCCTL  ------------------------------- */
#define NT_PWM5_PCCTL_CHPEN_Pos               0                                                       /*!< NT_PWM5 PCCTL: CHPEN Position           */
#define NT_PWM5_PCCTL_CHPEN_Msk               (0x01UL << NT_PWM5_PCCTL_CHPEN_Pos)                     /*!< NT_PWM5 PCCTL: CHPEN Mask               */
#define NT_PWM5_PCCTL_OSHTWTH_Pos             1                                                       /*!< NT_PWM5 PCCTL: OSHTWTH Position         */
#define NT_PWM5_PCCTL_OSHTWTH_Msk             (0x0fUL << NT_PWM5_PCCTL_OSHTWTH_Pos)                   /*!< NT_PWM5 PCCTL: OSHTWTH Mask             */
#define NT_PWM5_PCCTL_SHRFREQ_Pos             5                                                       /*!< NT_PWM5 PCCTL: SHRFREQ Position         */
#define NT_PWM5_PCCTL_SHRFREQ_Msk             (0x07UL << NT_PWM5_PCCTL_SHRFREQ_Pos)                   /*!< NT_PWM5 PCCTL: SHRFREQ Mask             */
#define NT_PWM5_PCCTL_CHPDUTY_Pos             8                                                       /*!< NT_PWM5 PCCTL: CHPDUTY Position         */
#define NT_PWM5_PCCTL_CHPDUTY_Msk             (0x07UL << NT_PWM5_PCCTL_CHPDUTY_Pos)                   /*!< NT_PWM5 PCCTL: CHPDUTY Mask             */

/* -------------------------------  NT_PWM5_HRCNFG  ------------------------------- */
#define NT_PWM5_HRCNFG_EDGMODE_Pos            0                                                       /*!< NT_PWM5 HRCNFG: EDGMODE Position        */
#define NT_PWM5_HRCNFG_EDGMODE_Msk            (0x03UL << NT_PWM5_HRCNFG_EDGMODE_Pos)                  /*!< NT_PWM5 HRCNFG: EDGMODE Mask            */
#define NT_PWM5_HRCNFG_CTLMODE_Pos            2                                                       /*!< NT_PWM5 HRCNFG: CTLMODE Position        */
#define NT_PWM5_HRCNFG_CTLMODE_Msk            (0x01UL << NT_PWM5_HRCNFG_CTLMODE_Pos)                  /*!< NT_PWM5 HRCNFG: CTLMODE Mask            */
#define NT_PWM5_HRCNFG_HR_LOAD_Pos            3                                                       /*!< NT_PWM5 HRCNFG: HR_LOAD Position        */
#define NT_PWM5_HRCNFG_HR_LOAD_Msk            (0x01UL << NT_PWM5_HRCNFG_HR_LOAD_Pos)                  /*!< NT_PWM5 HRCNFG: HR_LOAD Mask            */
#define NT_PWM5_HRCNFG_MEP_SCALEFACTOR_Pos    16                                                      /*!< NT_PWM5 HRCNFG: MEP_SCALEFACTOR Position */
#define NT_PWM5_HRCNFG_MEP_SCALEFACTOR_Msk    (0x000000ffUL << NT_PWM5_HRCNFG_MEP_SCALEFACTOR_Pos)    /*!< NT_PWM5 HRCNFG: MEP_SCALEFACTOR Mask    */

/* --------------------------------  NT_PWM5_FWDTH  ------------------------------- */
#define NT_PWM5_FWDTH_FWDTH_Pos               0                                                       /*!< NT_PWM5 FWDTH: FWDTH Position           */
#define NT_PWM5_FWDTH_FWDTH_Msk               (0x000000ffUL << NT_PWM5_FWDTH_FWDTH_Pos)               /*!< NT_PWM5 FWDTH: FWDTH Mask               */

/* --------------------------------  NT_PWM5_HDSEL  ------------------------------- */
#define NT_PWM5_HDSEL_DCMP_Pos                0                                                       /*!< NT_PWM5 HDSEL: DCMP Position            */
#define NT_PWM5_HDSEL_DCMP_Msk                (0x00ffffffUL << NT_PWM5_HDSEL_DCMP_Pos)                /*!< NT_PWM5 HDSEL: DCMP Mask                */
#define NT_PWM5_HDSEL_ACMP_Pos                24                                                      /*!< NT_PWM5 HDSEL: ACMP Position            */
#define NT_PWM5_HDSEL_ACMP_Msk                (0x07UL << NT_PWM5_HDSEL_ACMP_Pos)                      /*!< NT_PWM5 HDSEL: ACMP Mask                */

/* --------------------------------  NT_PWM5_HDCTL  ------------------------------- */
#define NT_PWM5_HDCTL_HDA_Pos                 0                                                       /*!< NT_PWM5 HDCTL: HDA Position             */
#define NT_PWM5_HDCTL_HDA_Msk                 (0x03UL << NT_PWM5_HDCTL_HDA_Pos)                       /*!< NT_PWM5 HDCTL: HDA Mask                 */
#define NT_PWM5_HDCTL_HDB_Pos                 2                                                       /*!< NT_PWM5 HDCTL: HDB Position             */
#define NT_PWM5_HDCTL_HDB_Msk                 (0x03UL << NT_PWM5_HDCTL_HDB_Pos)                       /*!< NT_PWM5 HDCTL: HDB Mask                 */

/* -------------------------------  NT_PWM5_HDEINT  ------------------------------- */
#define NT_PWM5_HDEINT_CBC_Pos                1                                                       /*!< NT_PWM5 HDEINT: CBC Position            */
#define NT_PWM5_HDEINT_CBC_Msk                (0x01UL << NT_PWM5_HDEINT_CBC_Pos)                      /*!< NT_PWM5 HDEINT: CBC Mask                */
#define NT_PWM5_HDEINT_OST_Pos                2                                                       /*!< NT_PWM5 HDEINT: OST Position            */
#define NT_PWM5_HDEINT_OST_Msk                (0x01UL << NT_PWM5_HDEINT_OST_Pos)                      /*!< NT_PWM5 HDEINT: OST Mask                */

/* --------------------------------  NT_PWM5_HDFLG  ------------------------------- */
#define NT_PWM5_HDFLG_HDINT_Pos               0                                                       /*!< NT_PWM5 HDFLG: HDINT Position           */
#define NT_PWM5_HDFLG_HDINT_Msk               (0x01UL << NT_PWM5_HDFLG_HDINT_Pos)                     /*!< NT_PWM5 HDFLG: HDINT Mask               */
#define NT_PWM5_HDFLG_CBC_Pos                 1                                                       /*!< NT_PWM5 HDFLG: CBC Position             */
#define NT_PWM5_HDFLG_CBC_Msk                 (0x01UL << NT_PWM5_HDFLG_CBC_Pos)                       /*!< NT_PWM5 HDFLG: CBC Mask                 */
#define NT_PWM5_HDFLG_OST_Pos                 2                                                       /*!< NT_PWM5 HDFLG: OST Position             */
#define NT_PWM5_HDFLG_OST_Msk                 (0x01UL << NT_PWM5_HDFLG_OST_Pos)                       /*!< NT_PWM5 HDFLG: OST Mask                 */

/* --------------------------------  NT_PWM5_HDCLR  ------------------------------- */
#define NT_PWM5_HDCLR_HDINT_Pos               0                                                       /*!< NT_PWM5 HDCLR: HDINT Position           */
#define NT_PWM5_HDCLR_HDINT_Msk               (0x01UL << NT_PWM5_HDCLR_HDINT_Pos)                     /*!< NT_PWM5 HDCLR: HDINT Mask               */

/* --------------------------------  NT_PWM5_HDFRC  ------------------------------- */
#define NT_PWM5_HDFRC_CBC_Pos                 1                                                       /*!< NT_PWM5 HDFRC: CBC Position             */
#define NT_PWM5_HDFRC_CBC_Msk                 (0x01UL << NT_PWM5_HDFRC_CBC_Pos)                       /*!< NT_PWM5 HDFRC: CBC Mask                 */
#define NT_PWM5_HDFRC_OST_Pos                 2                                                       /*!< NT_PWM5 HDFRC: OST Position             */
#define NT_PWM5_HDFRC_OST_Msk                 (0x01UL << NT_PWM5_HDFRC_OST_Pos)                       /*!< NT_PWM5 HDFRC: OST Mask                 */

/* ------------------------------  NT_PWM5_HDINTCLR  ------------------------------ */
#define NT_PWM5_HDINTCLR_HDINT_Pos            0                                                       /*!< NT_PWM5 HDINTCLR: HDINT Position        */
#define NT_PWM5_HDINTCLR_HDINT_Msk            (0x01UL << NT_PWM5_HDINTCLR_HDINT_Pos)                  /*!< NT_PWM5 HDINTCLR: HDINT Mask            */

/* ------------------------------  NT_PWM5_TZINTCLR  ------------------------------ */
#define NT_PWM5_TZINTCLR_TZINT_Pos            0                                                       /*!< NT_PWM5 TZINTCLR: TZINT Position        */
#define NT_PWM5_TZINTCLR_TZINT_Msk            (0x01UL << NT_PWM5_TZINTCLR_TZINT_Pos)                  /*!< NT_PWM5 TZINTCLR: TZINT Mask            */

/* -------------------------------  NT_PWM5_INTCLR  ------------------------------- */
#define NT_PWM5_INTCLR_INT_Pos                0                                                       /*!< NT_PWM5 INTCLR: INT Position            */
#define NT_PWM5_INTCLR_INT_Msk                (0x01UL << NT_PWM5_INTCLR_INT_Pos)                      /*!< NT_PWM5 INTCLR: INT Mask                */


/* ================================================================================ */
/* ================        struct 'NT_PWM6' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_PWM6_TBCTL  ------------------------------- */
#define NT_PWM6_TBCTL_CTRMODE_Pos             0                                                       /*!< NT_PWM6 TBCTL: CTRMODE Position         */
#define NT_PWM6_TBCTL_CTRMODE_Msk             (0x03UL << NT_PWM6_TBCTL_CTRMODE_Pos)                   /*!< NT_PWM6 TBCTL: CTRMODE Mask             */
#define NT_PWM6_TBCTL_PHSEN_Pos               2                                                       /*!< NT_PWM6 TBCTL: PHSEN Position           */
#define NT_PWM6_TBCTL_PHSEN_Msk               (0x01UL << NT_PWM6_TBCTL_PHSEN_Pos)                     /*!< NT_PWM6 TBCTL: PHSEN Mask               */
#define NT_PWM6_TBCTL_PRDLD_Pos               3                                                       /*!< NT_PWM6 TBCTL: PRDLD Position           */
#define NT_PWM6_TBCTL_PRDLD_Msk               (0x01UL << NT_PWM6_TBCTL_PRDLD_Pos)                     /*!< NT_PWM6 TBCTL: PRDLD Mask               */
#define NT_PWM6_TBCTL_SYNCOSEL_Pos            4                                                       /*!< NT_PWM6 TBCTL: SYNCOSEL Position        */
#define NT_PWM6_TBCTL_SYNCOSEL_Msk            (0x03UL << NT_PWM6_TBCTL_SYNCOSEL_Pos)                  /*!< NT_PWM6 TBCTL: SYNCOSEL Mask            */
#define NT_PWM6_TBCTL_SWFSYNC_Pos             6                                                       /*!< NT_PWM6 TBCTL: SWFSYNC Position         */
#define NT_PWM6_TBCTL_SWFSYNC_Msk             (0x01UL << NT_PWM6_TBCTL_SWFSYNC_Pos)                   /*!< NT_PWM6 TBCTL: SWFSYNC Mask             */
#define NT_PWM6_TBCTL_HSPCLKDIV_Pos           7                                                       /*!< NT_PWM6 TBCTL: HSPCLKDIV Position       */
#define NT_PWM6_TBCTL_HSPCLKDIV_Msk           (0x07UL << NT_PWM6_TBCTL_HSPCLKDIV_Pos)                 /*!< NT_PWM6 TBCTL: HSPCLKDIV Mask           */
#define NT_PWM6_TBCTL_CLKDIV_Pos              10                                                      /*!< NT_PWM6 TBCTL: CLKDIV Position          */
#define NT_PWM6_TBCTL_CLKDIV_Msk              (0x07UL << NT_PWM6_TBCTL_CLKDIV_Pos)                    /*!< NT_PWM6 TBCTL: CLKDIV Mask              */
#define NT_PWM6_TBCTL_PHSDIR_Pos              13                                                      /*!< NT_PWM6 TBCTL: PHSDIR Position          */
#define NT_PWM6_TBCTL_PHSDIR_Msk              (0x01UL << NT_PWM6_TBCTL_PHSDIR_Pos)                    /*!< NT_PWM6 TBCTL: PHSDIR Mask              */
#define NT_PWM6_TBCTL_FREE_SOFT_Pos           14                                                      /*!< NT_PWM6 TBCTL: FREE_SOFT Position       */
#define NT_PWM6_TBCTL_FREE_SOFT_Msk           (0x03UL << NT_PWM6_TBCTL_FREE_SOFT_Pos)                 /*!< NT_PWM6 TBCTL: FREE_SOFT Mask           */

/* --------------------------------  NT_PWM6_TBSTS  ------------------------------- */
#define NT_PWM6_TBSTS_CTRDIR_Pos              0                                                       /*!< NT_PWM6 TBSTS: CTRDIR Position          */
#define NT_PWM6_TBSTS_CTRDIR_Msk              (0x01UL << NT_PWM6_TBSTS_CTRDIR_Pos)                    /*!< NT_PWM6 TBSTS: CTRDIR Mask              */
#define NT_PWM6_TBSTS_SYNCI_Pos               1                                                       /*!< NT_PWM6 TBSTS: SYNCI Position           */
#define NT_PWM6_TBSTS_SYNCI_Msk               (0x01UL << NT_PWM6_TBSTS_SYNCI_Pos)                     /*!< NT_PWM6 TBSTS: SYNCI Mask               */
#define NT_PWM6_TBSTS_CTRMAX_Pos              2                                                       /*!< NT_PWM6 TBSTS: CTRMAX Position          */
#define NT_PWM6_TBSTS_CTRMAX_Msk              (0x01UL << NT_PWM6_TBSTS_CTRMAX_Pos)                    /*!< NT_PWM6 TBSTS: CTRMAX Mask              */

/* --------------------------------  NT_PWM6_TBPHS  ------------------------------- */
#define NT_PWM6_TBPHS_TBPHSHR_Pos             8                                                       /*!< NT_PWM6 TBPHS: TBPHSHR Position         */
#define NT_PWM6_TBPHS_TBPHSHR_Msk             (0x000000ffUL << NT_PWM6_TBPHS_TBPHSHR_Pos)             /*!< NT_PWM6 TBPHS: TBPHSHR Mask             */
#define NT_PWM6_TBPHS_TBPHS_Pos               16                                                      /*!< NT_PWM6 TBPHS: TBPHS Position           */
#define NT_PWM6_TBPHS_TBPHS_Msk               (0x0000ffffUL << NT_PWM6_TBPHS_TBPHS_Pos)               /*!< NT_PWM6 TBPHS: TBPHS Mask               */

/* --------------------------------  NT_PWM6_TBCTR  ------------------------------- */
#define NT_PWM6_TBCTR_TBCTR_Pos               0                                                       /*!< NT_PWM6 TBCTR: TBCTR Position           */
#define NT_PWM6_TBCTR_TBCTR_Msk               (0x0000ffffUL << NT_PWM6_TBCTR_TBCTR_Pos)               /*!< NT_PWM6 TBCTR: TBCTR Mask               */

/* --------------------------------  NT_PWM6_TBPRD  ------------------------------- */
#define NT_PWM6_TBPRD_TBPRD_Pos               0                                                       /*!< NT_PWM6 TBPRD: TBPRD Position           */
#define NT_PWM6_TBPRD_TBPRD_Msk               (0x0000ffffUL << NT_PWM6_TBPRD_TBPRD_Pos)               /*!< NT_PWM6 TBPRD: TBPRD Mask               */

/* -------------------------------  NT_PWM6_CMPCTL  ------------------------------- */
#define NT_PWM6_CMPCTL_LOADAMODE_Pos          0                                                       /*!< NT_PWM6 CMPCTL: LOADAMODE Position      */
#define NT_PWM6_CMPCTL_LOADAMODE_Msk          (0x03UL << NT_PWM6_CMPCTL_LOADAMODE_Pos)                /*!< NT_PWM6 CMPCTL: LOADAMODE Mask          */
#define NT_PWM6_CMPCTL_LOADBMODE_Pos          2                                                       /*!< NT_PWM6 CMPCTL: LOADBMODE Position      */
#define NT_PWM6_CMPCTL_LOADBMODE_Msk          (0x03UL << NT_PWM6_CMPCTL_LOADBMODE_Pos)                /*!< NT_PWM6 CMPCTL: LOADBMODE Mask          */
#define NT_PWM6_CMPCTL_SHDWAMODE_Pos          4                                                       /*!< NT_PWM6 CMPCTL: SHDWAMODE Position      */
#define NT_PWM6_CMPCTL_SHDWAMODE_Msk          (0x01UL << NT_PWM6_CMPCTL_SHDWAMODE_Pos)                /*!< NT_PWM6 CMPCTL: SHDWAMODE Mask          */
#define NT_PWM6_CMPCTL_SHDWBMODE_Pos          6                                                       /*!< NT_PWM6 CMPCTL: SHDWBMODE Position      */
#define NT_PWM6_CMPCTL_SHDWBMODE_Msk          (0x01UL << NT_PWM6_CMPCTL_SHDWBMODE_Pos)                /*!< NT_PWM6 CMPCTL: SHDWBMODE Mask          */
#define NT_PWM6_CMPCTL_SHDWAFULL_Pos          8                                                       /*!< NT_PWM6 CMPCTL: SHDWAFULL Position      */
#define NT_PWM6_CMPCTL_SHDWAFULL_Msk          (0x01UL << NT_PWM6_CMPCTL_SHDWAFULL_Pos)                /*!< NT_PWM6 CMPCTL: SHDWAFULL Mask          */
#define NT_PWM6_CMPCTL_SHDWBFULL_Pos          9                                                       /*!< NT_PWM6 CMPCTL: SHDWBFULL Position      */
#define NT_PWM6_CMPCTL_SHDWBFULL_Msk          (0x01UL << NT_PWM6_CMPCTL_SHDWBFULL_Pos)                /*!< NT_PWM6 CMPCTL: SHDWBFULL Mask          */

/* --------------------------------  NT_PWM6_CMPA  -------------------------------- */
#define NT_PWM6_CMPA_CMPAHR_Pos               8                                                       /*!< NT_PWM6 CMPA: CMPAHR Position           */
#define NT_PWM6_CMPA_CMPAHR_Msk               (0x000000ffUL << NT_PWM6_CMPA_CMPAHR_Pos)               /*!< NT_PWM6 CMPA: CMPAHR Mask               */
#define NT_PWM6_CMPA_CMPA_Pos                 16                                                      /*!< NT_PWM6 CMPA: CMPA Position             */
#define NT_PWM6_CMPA_CMPA_Msk                 (0x0000ffffUL << NT_PWM6_CMPA_CMPA_Pos)                 /*!< NT_PWM6 CMPA: CMPA Mask                 */

/* --------------------------------  NT_PWM6_CMPB  -------------------------------- */
#define NT_PWM6_CMPB_CMPB_Pos                 16                                                      /*!< NT_PWM6 CMPB: CMPB Position             */
#define NT_PWM6_CMPB_CMPB_Msk                 (0x0000ffffUL << NT_PWM6_CMPB_CMPB_Pos)                 /*!< NT_PWM6 CMPB: CMPB Mask                 */

/* -------------------------------  NT_PWM6_AQCTLA  ------------------------------- */
#define NT_PWM6_AQCTLA_ZRO_Pos                0                                                       /*!< NT_PWM6 AQCTLA: ZRO Position            */
#define NT_PWM6_AQCTLA_ZRO_Msk                (0x03UL << NT_PWM6_AQCTLA_ZRO_Pos)                      /*!< NT_PWM6 AQCTLA: ZRO Mask                */
#define NT_PWM6_AQCTLA_PRD_Pos                2                                                       /*!< NT_PWM6 AQCTLA: PRD Position            */
#define NT_PWM6_AQCTLA_PRD_Msk                (0x03UL << NT_PWM6_AQCTLA_PRD_Pos)                      /*!< NT_PWM6 AQCTLA: PRD Mask                */
#define NT_PWM6_AQCTLA_CAU_Pos                4                                                       /*!< NT_PWM6 AQCTLA: CAU Position            */
#define NT_PWM6_AQCTLA_CAU_Msk                (0x03UL << NT_PWM6_AQCTLA_CAU_Pos)                      /*!< NT_PWM6 AQCTLA: CAU Mask                */
#define NT_PWM6_AQCTLA_CAD_Pos                6                                                       /*!< NT_PWM6 AQCTLA: CAD Position            */
#define NT_PWM6_AQCTLA_CAD_Msk                (0x03UL << NT_PWM6_AQCTLA_CAD_Pos)                      /*!< NT_PWM6 AQCTLA: CAD Mask                */
#define NT_PWM6_AQCTLA_CBU_Pos                8                                                       /*!< NT_PWM6 AQCTLA: CBU Position            */
#define NT_PWM6_AQCTLA_CBU_Msk                (0x03UL << NT_PWM6_AQCTLA_CBU_Pos)                      /*!< NT_PWM6 AQCTLA: CBU Mask                */
#define NT_PWM6_AQCTLA_CBD_Pos                10                                                      /*!< NT_PWM6 AQCTLA: CBD Position            */
#define NT_PWM6_AQCTLA_CBD_Msk                (0x03UL << NT_PWM6_AQCTLA_CBD_Pos)                      /*!< NT_PWM6 AQCTLA: CBD Mask                */

/* -------------------------------  NT_PWM6_AQCTLB  ------------------------------- */
#define NT_PWM6_AQCTLB_ZRO_Pos                0                                                       /*!< NT_PWM6 AQCTLB: ZRO Position            */
#define NT_PWM6_AQCTLB_ZRO_Msk                (0x03UL << NT_PWM6_AQCTLB_ZRO_Pos)                      /*!< NT_PWM6 AQCTLB: ZRO Mask                */
#define NT_PWM6_AQCTLB_PRD_Pos                2                                                       /*!< NT_PWM6 AQCTLB: PRD Position            */
#define NT_PWM6_AQCTLB_PRD_Msk                (0x03UL << NT_PWM6_AQCTLB_PRD_Pos)                      /*!< NT_PWM6 AQCTLB: PRD Mask                */
#define NT_PWM6_AQCTLB_CAU_Pos                4                                                       /*!< NT_PWM6 AQCTLB: CAU Position            */
#define NT_PWM6_AQCTLB_CAU_Msk                (0x03UL << NT_PWM6_AQCTLB_CAU_Pos)                      /*!< NT_PWM6 AQCTLB: CAU Mask                */
#define NT_PWM6_AQCTLB_CAD_Pos                6                                                       /*!< NT_PWM6 AQCTLB: CAD Position            */
#define NT_PWM6_AQCTLB_CAD_Msk                (0x03UL << NT_PWM6_AQCTLB_CAD_Pos)                      /*!< NT_PWM6 AQCTLB: CAD Mask                */
#define NT_PWM6_AQCTLB_CBU_Pos                8                                                       /*!< NT_PWM6 AQCTLB: CBU Position            */
#define NT_PWM6_AQCTLB_CBU_Msk                (0x03UL << NT_PWM6_AQCTLB_CBU_Pos)                      /*!< NT_PWM6 AQCTLB: CBU Mask                */
#define NT_PWM6_AQCTLB_CBD_Pos                10                                                      /*!< NT_PWM6 AQCTLB: CBD Position            */
#define NT_PWM6_AQCTLB_CBD_Msk                (0x03UL << NT_PWM6_AQCTLB_CBD_Pos)                      /*!< NT_PWM6 AQCTLB: CBD Mask                */

/* -------------------------------  NT_PWM6_AQSFRC  ------------------------------- */
#define NT_PWM6_AQSFRC_ACTSFA_Pos             0                                                       /*!< NT_PWM6 AQSFRC: ACTSFA Position         */
#define NT_PWM6_AQSFRC_ACTSFA_Msk             (0x03UL << NT_PWM6_AQSFRC_ACTSFA_Pos)                   /*!< NT_PWM6 AQSFRC: ACTSFA Mask             */
#define NT_PWM6_AQSFRC_OTSFA_Pos              2                                                       /*!< NT_PWM6 AQSFRC: OTSFA Position          */
#define NT_PWM6_AQSFRC_OTSFA_Msk              (0x01UL << NT_PWM6_AQSFRC_OTSFA_Pos)                    /*!< NT_PWM6 AQSFRC: OTSFA Mask              */
#define NT_PWM6_AQSFRC_ACTSFB_Pos             3                                                       /*!< NT_PWM6 AQSFRC: ACTSFB Position         */
#define NT_PWM6_AQSFRC_ACTSFB_Msk             (0x03UL << NT_PWM6_AQSFRC_ACTSFB_Pos)                   /*!< NT_PWM6 AQSFRC: ACTSFB Mask             */
#define NT_PWM6_AQSFRC_OTSFB_Pos              5                                                       /*!< NT_PWM6 AQSFRC: OTSFB Position          */
#define NT_PWM6_AQSFRC_OTSFB_Msk              (0x01UL << NT_PWM6_AQSFRC_OTSFB_Pos)                    /*!< NT_PWM6 AQSFRC: OTSFB Mask              */
#define NT_PWM6_AQSFRC_RLDCSF_Pos             6                                                       /*!< NT_PWM6 AQSFRC: RLDCSF Position         */
#define NT_PWM6_AQSFRC_RLDCSF_Msk             (0x03UL << NT_PWM6_AQSFRC_RLDCSF_Pos)                   /*!< NT_PWM6 AQSFRC: RLDCSF Mask             */

/* -------------------------------  NT_PWM6_AQCSFRC  ------------------------------ */
#define NT_PWM6_AQCSFRC_CSFA_Pos              0                                                       /*!< NT_PWM6 AQCSFRC: CSFA Position          */
#define NT_PWM6_AQCSFRC_CSFA_Msk              (0x03UL << NT_PWM6_AQCSFRC_CSFA_Pos)                    /*!< NT_PWM6 AQCSFRC: CSFA Mask              */
#define NT_PWM6_AQCSFRC_CSFB_Pos              2                                                       /*!< NT_PWM6 AQCSFRC: CSFB Position          */
#define NT_PWM6_AQCSFRC_CSFB_Msk              (0x03UL << NT_PWM6_AQCSFRC_CSFB_Pos)                    /*!< NT_PWM6 AQCSFRC: CSFB Mask              */

/* --------------------------------  NT_PWM6_DBCTL  ------------------------------- */
#define NT_PWM6_DBCTL_OUT_MODE_Pos            0                                                       /*!< NT_PWM6 DBCTL: OUT_MODE Position        */
#define NT_PWM6_DBCTL_OUT_MODE_Msk            (0x03UL << NT_PWM6_DBCTL_OUT_MODE_Pos)                  /*!< NT_PWM6 DBCTL: OUT_MODE Mask            */
#define NT_PWM6_DBCTL_POLSEL_Pos              2                                                       /*!< NT_PWM6 DBCTL: POLSEL Position          */
#define NT_PWM6_DBCTL_POLSEL_Msk              (0x03UL << NT_PWM6_DBCTL_POLSEL_Pos)                    /*!< NT_PWM6 DBCTL: POLSEL Mask              */
#define NT_PWM6_DBCTL_IN_MODE_Pos             4                                                       /*!< NT_PWM6 DBCTL: IN_MODE Position         */
#define NT_PWM6_DBCTL_IN_MODE_Msk             (0x03UL << NT_PWM6_DBCTL_IN_MODE_Pos)                   /*!< NT_PWM6 DBCTL: IN_MODE Mask             */

/* --------------------------------  NT_PWM6_DBRED  ------------------------------- */
#define NT_PWM6_DBRED_DEL_Pos                 0                                                       /*!< NT_PWM6 DBRED: DEL Position             */
#define NT_PWM6_DBRED_DEL_Msk                 (0x000003ffUL << NT_PWM6_DBRED_DEL_Pos)                 /*!< NT_PWM6 DBRED: DEL Mask                 */

/* --------------------------------  NT_PWM6_DBFED  ------------------------------- */
#define NT_PWM6_DBFED_DEL_Pos                 0                                                       /*!< NT_PWM6 DBFED: DEL Position             */
#define NT_PWM6_DBFED_DEL_Msk                 (0x000003ffUL << NT_PWM6_DBFED_DEL_Pos)                 /*!< NT_PWM6 DBFED: DEL Mask                 */

/* --------------------------------  NT_PWM6_TZSEL  ------------------------------- */
#define NT_PWM6_TZSEL_CBC0_Pos                0                                                       /*!< NT_PWM6 TZSEL: CBC0 Position            */
#define NT_PWM6_TZSEL_CBC0_Msk                (0x01UL << NT_PWM6_TZSEL_CBC0_Pos)                      /*!< NT_PWM6 TZSEL: CBC0 Mask                */
#define NT_PWM6_TZSEL_CBC1_Pos                1                                                       /*!< NT_PWM6 TZSEL: CBC1 Position            */
#define NT_PWM6_TZSEL_CBC1_Msk                (0x01UL << NT_PWM6_TZSEL_CBC1_Pos)                      /*!< NT_PWM6 TZSEL: CBC1 Mask                */
#define NT_PWM6_TZSEL_CBC2_Pos                2                                                       /*!< NT_PWM6 TZSEL: CBC2 Position            */
#define NT_PWM6_TZSEL_CBC2_Msk                (0x01UL << NT_PWM6_TZSEL_CBC2_Pos)                      /*!< NT_PWM6 TZSEL: CBC2 Mask                */
#define NT_PWM6_TZSEL_CBC3_Pos                3                                                       /*!< NT_PWM6 TZSEL: CBC3 Position            */
#define NT_PWM6_TZSEL_CBC3_Msk                (0x01UL << NT_PWM6_TZSEL_CBC3_Pos)                      /*!< NT_PWM6 TZSEL: CBC3 Mask                */
#define NT_PWM6_TZSEL_CBC4_Pos                4                                                       /*!< NT_PWM6 TZSEL: CBC4 Position            */
#define NT_PWM6_TZSEL_CBC4_Msk                (0x01UL << NT_PWM6_TZSEL_CBC4_Pos)                      /*!< NT_PWM6 TZSEL: CBC4 Mask                */
#define NT_PWM6_TZSEL_CBC5_Pos                5                                                       /*!< NT_PWM6 TZSEL: CBC5 Position            */
#define NT_PWM6_TZSEL_CBC5_Msk                (0x01UL << NT_PWM6_TZSEL_CBC5_Pos)                      /*!< NT_PWM6 TZSEL: CBC5 Mask                */
#define NT_PWM6_TZSEL_OSHT0_Pos               8                                                       /*!< NT_PWM6 TZSEL: OSHT0 Position           */
#define NT_PWM6_TZSEL_OSHT0_Msk               (0x01UL << NT_PWM6_TZSEL_OSHT0_Pos)                     /*!< NT_PWM6 TZSEL: OSHT0 Mask               */
#define NT_PWM6_TZSEL_OSHT1_Pos               9                                                       /*!< NT_PWM6 TZSEL: OSHT1 Position           */
#define NT_PWM6_TZSEL_OSHT1_Msk               (0x01UL << NT_PWM6_TZSEL_OSHT1_Pos)                     /*!< NT_PWM6 TZSEL: OSHT1 Mask               */
#define NT_PWM6_TZSEL_OSHT2_Pos               10                                                      /*!< NT_PWM6 TZSEL: OSHT2 Position           */
#define NT_PWM6_TZSEL_OSHT2_Msk               (0x01UL << NT_PWM6_TZSEL_OSHT2_Pos)                     /*!< NT_PWM6 TZSEL: OSHT2 Mask               */
#define NT_PWM6_TZSEL_OSHT3_Pos               11                                                      /*!< NT_PWM6 TZSEL: OSHT3 Position           */
#define NT_PWM6_TZSEL_OSHT3_Msk               (0x01UL << NT_PWM6_TZSEL_OSHT3_Pos)                     /*!< NT_PWM6 TZSEL: OSHT3 Mask               */
#define NT_PWM6_TZSEL_OSHT4_Pos               12                                                      /*!< NT_PWM6 TZSEL: OSHT4 Position           */
#define NT_PWM6_TZSEL_OSHT4_Msk               (0x01UL << NT_PWM6_TZSEL_OSHT4_Pos)                     /*!< NT_PWM6 TZSEL: OSHT4 Mask               */
#define NT_PWM6_TZSEL_OSHT5_Pos               13                                                      /*!< NT_PWM6 TZSEL: OSHT5 Position           */
#define NT_PWM6_TZSEL_OSHT5_Msk               (0x01UL << NT_PWM6_TZSEL_OSHT5_Pos)                     /*!< NT_PWM6 TZSEL: OSHT5 Mask               */

/* --------------------------------  NT_PWM6_TZCTL  ------------------------------- */
#define NT_PWM6_TZCTL_TZA_Pos                 0                                                       /*!< NT_PWM6 TZCTL: TZA Position             */
#define NT_PWM6_TZCTL_TZA_Msk                 (0x03UL << NT_PWM6_TZCTL_TZA_Pos)                       /*!< NT_PWM6 TZCTL: TZA Mask                 */
#define NT_PWM6_TZCTL_TZB_Pos                 2                                                       /*!< NT_PWM6 TZCTL: TZB Position             */
#define NT_PWM6_TZCTL_TZB_Msk                 (0x03UL << NT_PWM6_TZCTL_TZB_Pos)                       /*!< NT_PWM6 TZCTL: TZB Mask                 */

/* -------------------------------  NT_PWM6_TZEINT  ------------------------------- */
#define NT_PWM6_TZEINT_CBC_Pos                1                                                       /*!< NT_PWM6 TZEINT: CBC Position            */
#define NT_PWM6_TZEINT_CBC_Msk                (0x01UL << NT_PWM6_TZEINT_CBC_Pos)                      /*!< NT_PWM6 TZEINT: CBC Mask                */
#define NT_PWM6_TZEINT_OST_Pos                2                                                       /*!< NT_PWM6 TZEINT: OST Position            */
#define NT_PWM6_TZEINT_OST_Msk                (0x01UL << NT_PWM6_TZEINT_OST_Pos)                      /*!< NT_PWM6 TZEINT: OST Mask                */

/* --------------------------------  NT_PWM6_TZFLG  ------------------------------- */
#define NT_PWM6_TZFLG_INT_Pos                 0                                                       /*!< NT_PWM6 TZFLG: INT Position             */
#define NT_PWM6_TZFLG_INT_Msk                 (0x01UL << NT_PWM6_TZFLG_INT_Pos)                       /*!< NT_PWM6 TZFLG: INT Mask                 */
#define NT_PWM6_TZFLG_CBC_Pos                 1                                                       /*!< NT_PWM6 TZFLG: CBC Position             */
#define NT_PWM6_TZFLG_CBC_Msk                 (0x01UL << NT_PWM6_TZFLG_CBC_Pos)                       /*!< NT_PWM6 TZFLG: CBC Mask                 */
#define NT_PWM6_TZFLG_OST_Pos                 2                                                       /*!< NT_PWM6 TZFLG: OST Position             */
#define NT_PWM6_TZFLG_OST_Msk                 (0x01UL << NT_PWM6_TZFLG_OST_Pos)                       /*!< NT_PWM6 TZFLG: OST Mask                 */

/* --------------------------------  NT_PWM6_TZCLR  ------------------------------- */
#define NT_PWM6_TZCLR_INT_Pos                 0                                                       /*!< NT_PWM6 TZCLR: INT Position             */
#define NT_PWM6_TZCLR_INT_Msk                 (0x01UL << NT_PWM6_TZCLR_INT_Pos)                       /*!< NT_PWM6 TZCLR: INT Mask                 */
#define NT_PWM6_TZCLR_CBC_Pos                 1                                                       /*!< NT_PWM6 TZCLR: CBC Position             */
#define NT_PWM6_TZCLR_CBC_Msk                 (0x01UL << NT_PWM6_TZCLR_CBC_Pos)                       /*!< NT_PWM6 TZCLR: CBC Mask                 */
#define NT_PWM6_TZCLR_OST_Pos                 2                                                       /*!< NT_PWM6 TZCLR: OST Position             */
#define NT_PWM6_TZCLR_OST_Msk                 (0x01UL << NT_PWM6_TZCLR_OST_Pos)                       /*!< NT_PWM6 TZCLR: OST Mask                 */

/* --------------------------------  NT_PWM6_TZFRC  ------------------------------- */
#define NT_PWM6_TZFRC_CBC_Pos                 1                                                       /*!< NT_PWM6 TZFRC: CBC Position             */
#define NT_PWM6_TZFRC_CBC_Msk                 (0x01UL << NT_PWM6_TZFRC_CBC_Pos)                       /*!< NT_PWM6 TZFRC: CBC Mask                 */
#define NT_PWM6_TZFRC_OST_Pos                 2                                                       /*!< NT_PWM6 TZFRC: OST Position             */
#define NT_PWM6_TZFRC_OST_Msk                 (0x01UL << NT_PWM6_TZFRC_OST_Pos)                       /*!< NT_PWM6 TZFRC: OST Mask                 */

/* --------------------------------  NT_PWM6_ETSEL  ------------------------------- */
#define NT_PWM6_ETSEL_INTSEL_Pos              0                                                       /*!< NT_PWM6 ETSEL: INTSEL Position          */
#define NT_PWM6_ETSEL_INTSEL_Msk              (0x07UL << NT_PWM6_ETSEL_INTSEL_Pos)                    /*!< NT_PWM6 ETSEL: INTSEL Mask              */
#define NT_PWM6_ETSEL_INTEN_Pos               3                                                       /*!< NT_PWM6 ETSEL: INTEN Position           */
#define NT_PWM6_ETSEL_INTEN_Msk               (0x01UL << NT_PWM6_ETSEL_INTEN_Pos)                     /*!< NT_PWM6 ETSEL: INTEN Mask               */
#define NT_PWM6_ETSEL_SOCASEL_Pos             8                                                       /*!< NT_PWM6 ETSEL: SOCASEL Position         */
#define NT_PWM6_ETSEL_SOCASEL_Msk             (0x07UL << NT_PWM6_ETSEL_SOCASEL_Pos)                   /*!< NT_PWM6 ETSEL: SOCASEL Mask             */
#define NT_PWM6_ETSEL_SOCAEN_Pos              11                                                      /*!< NT_PWM6 ETSEL: SOCAEN Position          */
#define NT_PWM6_ETSEL_SOCAEN_Msk              (0x01UL << NT_PWM6_ETSEL_SOCAEN_Pos)                    /*!< NT_PWM6 ETSEL: SOCAEN Mask              */
#define NT_PWM6_ETSEL_SOCBSEL_Pos             12                                                      /*!< NT_PWM6 ETSEL: SOCBSEL Position         */
#define NT_PWM6_ETSEL_SOCBSEL_Msk             (0x07UL << NT_PWM6_ETSEL_SOCBSEL_Pos)                   /*!< NT_PWM6 ETSEL: SOCBSEL Mask             */
#define NT_PWM6_ETSEL_SOCBEN_Pos              15                                                      /*!< NT_PWM6 ETSEL: SOCBEN Position          */
#define NT_PWM6_ETSEL_SOCBEN_Msk              (0x01UL << NT_PWM6_ETSEL_SOCBEN_Pos)                    /*!< NT_PWM6 ETSEL: SOCBEN Mask              */

/* --------------------------------  NT_PWM6_ETPS  -------------------------------- */
#define NT_PWM6_ETPS_INTPRD_Pos               0                                                       /*!< NT_PWM6 ETPS: INTPRD Position           */
#define NT_PWM6_ETPS_INTPRD_Msk               (0x03UL << NT_PWM6_ETPS_INTPRD_Pos)                     /*!< NT_PWM6 ETPS: INTPRD Mask               */
#define NT_PWM6_ETPS_INTCNT_Pos               2                                                       /*!< NT_PWM6 ETPS: INTCNT Position           */
#define NT_PWM6_ETPS_INTCNT_Msk               (0x03UL << NT_PWM6_ETPS_INTCNT_Pos)                     /*!< NT_PWM6 ETPS: INTCNT Mask               */
#define NT_PWM6_ETPS_SOCAPRD_Pos              8                                                       /*!< NT_PWM6 ETPS: SOCAPRD Position          */
#define NT_PWM6_ETPS_SOCAPRD_Msk              (0x03UL << NT_PWM6_ETPS_SOCAPRD_Pos)                    /*!< NT_PWM6 ETPS: SOCAPRD Mask              */
#define NT_PWM6_ETPS_SOCACNT_Pos              10                                                      /*!< NT_PWM6 ETPS: SOCACNT Position          */
#define NT_PWM6_ETPS_SOCACNT_Msk              (0x03UL << NT_PWM6_ETPS_SOCACNT_Pos)                    /*!< NT_PWM6 ETPS: SOCACNT Mask              */
#define NT_PWM6_ETPS_SOCPRD_Pos               12                                                      /*!< NT_PWM6 ETPS: SOCPRD Position           */
#define NT_PWM6_ETPS_SOCPRD_Msk               (0x03UL << NT_PWM6_ETPS_SOCPRD_Pos)                     /*!< NT_PWM6 ETPS: SOCPRD Mask               */
#define NT_PWM6_ETPS_SOCBCNT_Pos              14                                                      /*!< NT_PWM6 ETPS: SOCBCNT Position          */
#define NT_PWM6_ETPS_SOCBCNT_Msk              (0x03UL << NT_PWM6_ETPS_SOCBCNT_Pos)                    /*!< NT_PWM6 ETPS: SOCBCNT Mask              */

/* --------------------------------  NT_PWM6_ETFLG  ------------------------------- */
#define NT_PWM6_ETFLG_INT_Pos                 0                                                       /*!< NT_PWM6 ETFLG: INT Position             */
#define NT_PWM6_ETFLG_INT_Msk                 (0x01UL << NT_PWM6_ETFLG_INT_Pos)                       /*!< NT_PWM6 ETFLG: INT Mask                 */
#define NT_PWM6_ETFLG_SOCA_Pos                2                                                       /*!< NT_PWM6 ETFLG: SOCA Position            */
#define NT_PWM6_ETFLG_SOCA_Msk                (0x01UL << NT_PWM6_ETFLG_SOCA_Pos)                      /*!< NT_PWM6 ETFLG: SOCA Mask                */
#define NT_PWM6_ETFLG_SOCB_Pos                3                                                       /*!< NT_PWM6 ETFLG: SOCB Position            */
#define NT_PWM6_ETFLG_SOCB_Msk                (0x01UL << NT_PWM6_ETFLG_SOCB_Pos)                      /*!< NT_PWM6 ETFLG: SOCB Mask                */

/* --------------------------------  NT_PWM6_ETCLR  ------------------------------- */
#define NT_PWM6_ETCLR_INT_Pos                 0                                                       /*!< NT_PWM6 ETCLR: INT Position             */
#define NT_PWM6_ETCLR_INT_Msk                 (0x01UL << NT_PWM6_ETCLR_INT_Pos)                       /*!< NT_PWM6 ETCLR: INT Mask                 */
#define NT_PWM6_ETCLR_SOCA_Pos                2                                                       /*!< NT_PWM6 ETCLR: SOCA Position            */
#define NT_PWM6_ETCLR_SOCA_Msk                (0x01UL << NT_PWM6_ETCLR_SOCA_Pos)                      /*!< NT_PWM6 ETCLR: SOCA Mask                */
#define NT_PWM6_ETCLR_SOCB_Pos                3                                                       /*!< NT_PWM6 ETCLR: SOCB Position            */
#define NT_PWM6_ETCLR_SOCB_Msk                (0x01UL << NT_PWM6_ETCLR_SOCB_Pos)                      /*!< NT_PWM6 ETCLR: SOCB Mask                */

/* --------------------------------  NT_PWM6_ETFRC  ------------------------------- */
#define NT_PWM6_ETFRC_INT_Pos                 0                                                       /*!< NT_PWM6 ETFRC: INT Position             */
#define NT_PWM6_ETFRC_INT_Msk                 (0x01UL << NT_PWM6_ETFRC_INT_Pos)                       /*!< NT_PWM6 ETFRC: INT Mask                 */
#define NT_PWM6_ETFRC_SOCA_Pos                2                                                       /*!< NT_PWM6 ETFRC: SOCA Position            */
#define NT_PWM6_ETFRC_SOCA_Msk                (0x01UL << NT_PWM6_ETFRC_SOCA_Pos)                      /*!< NT_PWM6 ETFRC: SOCA Mask                */
#define NT_PWM6_ETFRC_SOCB_Pos                3                                                       /*!< NT_PWM6 ETFRC: SOCB Position            */
#define NT_PWM6_ETFRC_SOCB_Msk                (0x01UL << NT_PWM6_ETFRC_SOCB_Pos)                      /*!< NT_PWM6 ETFRC: SOCB Mask                */

/* --------------------------------  NT_PWM6_PCCTL  ------------------------------- */
#define NT_PWM6_PCCTL_CHPEN_Pos               0                                                       /*!< NT_PWM6 PCCTL: CHPEN Position           */
#define NT_PWM6_PCCTL_CHPEN_Msk               (0x01UL << NT_PWM6_PCCTL_CHPEN_Pos)                     /*!< NT_PWM6 PCCTL: CHPEN Mask               */
#define NT_PWM6_PCCTL_OSHTWTH_Pos             1                                                       /*!< NT_PWM6 PCCTL: OSHTWTH Position         */
#define NT_PWM6_PCCTL_OSHTWTH_Msk             (0x0fUL << NT_PWM6_PCCTL_OSHTWTH_Pos)                   /*!< NT_PWM6 PCCTL: OSHTWTH Mask             */
#define NT_PWM6_PCCTL_SHRFREQ_Pos             5                                                       /*!< NT_PWM6 PCCTL: SHRFREQ Position         */
#define NT_PWM6_PCCTL_SHRFREQ_Msk             (0x07UL << NT_PWM6_PCCTL_SHRFREQ_Pos)                   /*!< NT_PWM6 PCCTL: SHRFREQ Mask             */
#define NT_PWM6_PCCTL_CHPDUTY_Pos             8                                                       /*!< NT_PWM6 PCCTL: CHPDUTY Position         */
#define NT_PWM6_PCCTL_CHPDUTY_Msk             (0x07UL << NT_PWM6_PCCTL_CHPDUTY_Pos)                   /*!< NT_PWM6 PCCTL: CHPDUTY Mask             */

/* -------------------------------  NT_PWM6_HRCNFG  ------------------------------- */
#define NT_PWM6_HRCNFG_EDGMODE_Pos            0                                                       /*!< NT_PWM6 HRCNFG: EDGMODE Position        */
#define NT_PWM6_HRCNFG_EDGMODE_Msk            (0x03UL << NT_PWM6_HRCNFG_EDGMODE_Pos)                  /*!< NT_PWM6 HRCNFG: EDGMODE Mask            */
#define NT_PWM6_HRCNFG_CTLMODE_Pos            2                                                       /*!< NT_PWM6 HRCNFG: CTLMODE Position        */
#define NT_PWM6_HRCNFG_CTLMODE_Msk            (0x01UL << NT_PWM6_HRCNFG_CTLMODE_Pos)                  /*!< NT_PWM6 HRCNFG: CTLMODE Mask            */
#define NT_PWM6_HRCNFG_HR_LOAD_Pos            3                                                       /*!< NT_PWM6 HRCNFG: HR_LOAD Position        */
#define NT_PWM6_HRCNFG_HR_LOAD_Msk            (0x01UL << NT_PWM6_HRCNFG_HR_LOAD_Pos)                  /*!< NT_PWM6 HRCNFG: HR_LOAD Mask            */
#define NT_PWM6_HRCNFG_MEP_SCALEFACTOR_Pos    16                                                      /*!< NT_PWM6 HRCNFG: MEP_SCALEFACTOR Position */
#define NT_PWM6_HRCNFG_MEP_SCALEFACTOR_Msk    (0x000000ffUL << NT_PWM6_HRCNFG_MEP_SCALEFACTOR_Pos)    /*!< NT_PWM6 HRCNFG: MEP_SCALEFACTOR Mask    */

/* --------------------------------  NT_PWM6_FWDTH  ------------------------------- */
#define NT_PWM6_FWDTH_FWDTH_Pos               0                                                       /*!< NT_PWM6 FWDTH: FWDTH Position           */
#define NT_PWM6_FWDTH_FWDTH_Msk               (0x000000ffUL << NT_PWM6_FWDTH_FWDTH_Pos)               /*!< NT_PWM6 FWDTH: FWDTH Mask               */

/* --------------------------------  NT_PWM6_HDSEL  ------------------------------- */
#define NT_PWM6_HDSEL_DCMP_Pos                0                                                       /*!< NT_PWM6 HDSEL: DCMP Position            */
#define NT_PWM6_HDSEL_DCMP_Msk                (0x00ffffffUL << NT_PWM6_HDSEL_DCMP_Pos)                /*!< NT_PWM6 HDSEL: DCMP Mask                */
#define NT_PWM6_HDSEL_ACMP_Pos                24                                                      /*!< NT_PWM6 HDSEL: ACMP Position            */
#define NT_PWM6_HDSEL_ACMP_Msk                (0x07UL << NT_PWM6_HDSEL_ACMP_Pos)                      /*!< NT_PWM6 HDSEL: ACMP Mask                */

/* --------------------------------  NT_PWM6_HDCTL  ------------------------------- */
#define NT_PWM6_HDCTL_HDA_Pos                 0                                                       /*!< NT_PWM6 HDCTL: HDA Position             */
#define NT_PWM6_HDCTL_HDA_Msk                 (0x03UL << NT_PWM6_HDCTL_HDA_Pos)                       /*!< NT_PWM6 HDCTL: HDA Mask                 */
#define NT_PWM6_HDCTL_HDB_Pos                 2                                                       /*!< NT_PWM6 HDCTL: HDB Position             */
#define NT_PWM6_HDCTL_HDB_Msk                 (0x03UL << NT_PWM6_HDCTL_HDB_Pos)                       /*!< NT_PWM6 HDCTL: HDB Mask                 */

/* -------------------------------  NT_PWM6_HDEINT  ------------------------------- */
#define NT_PWM6_HDEINT_CBC_Pos                1                                                       /*!< NT_PWM6 HDEINT: CBC Position            */
#define NT_PWM6_HDEINT_CBC_Msk                (0x01UL << NT_PWM6_HDEINT_CBC_Pos)                      /*!< NT_PWM6 HDEINT: CBC Mask                */
#define NT_PWM6_HDEINT_OST_Pos                2                                                       /*!< NT_PWM6 HDEINT: OST Position            */
#define NT_PWM6_HDEINT_OST_Msk                (0x01UL << NT_PWM6_HDEINT_OST_Pos)                      /*!< NT_PWM6 HDEINT: OST Mask                */

/* --------------------------------  NT_PWM6_HDFLG  ------------------------------- */
#define NT_PWM6_HDFLG_HDINT_Pos               0                                                       /*!< NT_PWM6 HDFLG: HDINT Position           */
#define NT_PWM6_HDFLG_HDINT_Msk               (0x01UL << NT_PWM6_HDFLG_HDINT_Pos)                     /*!< NT_PWM6 HDFLG: HDINT Mask               */
#define NT_PWM6_HDFLG_CBC_Pos                 1                                                       /*!< NT_PWM6 HDFLG: CBC Position             */
#define NT_PWM6_HDFLG_CBC_Msk                 (0x01UL << NT_PWM6_HDFLG_CBC_Pos)                       /*!< NT_PWM6 HDFLG: CBC Mask                 */
#define NT_PWM6_HDFLG_OST_Pos                 2                                                       /*!< NT_PWM6 HDFLG: OST Position             */
#define NT_PWM6_HDFLG_OST_Msk                 (0x01UL << NT_PWM6_HDFLG_OST_Pos)                       /*!< NT_PWM6 HDFLG: OST Mask                 */

/* --------------------------------  NT_PWM6_HDCLR  ------------------------------- */
#define NT_PWM6_HDCLR_HDINT_Pos               0                                                       /*!< NT_PWM6 HDCLR: HDINT Position           */
#define NT_PWM6_HDCLR_HDINT_Msk               (0x01UL << NT_PWM6_HDCLR_HDINT_Pos)                     /*!< NT_PWM6 HDCLR: HDINT Mask               */

/* --------------------------------  NT_PWM6_HDFRC  ------------------------------- */
#define NT_PWM6_HDFRC_CBC_Pos                 1                                                       /*!< NT_PWM6 HDFRC: CBC Position             */
#define NT_PWM6_HDFRC_CBC_Msk                 (0x01UL << NT_PWM6_HDFRC_CBC_Pos)                       /*!< NT_PWM6 HDFRC: CBC Mask                 */
#define NT_PWM6_HDFRC_OST_Pos                 2                                                       /*!< NT_PWM6 HDFRC: OST Position             */
#define NT_PWM6_HDFRC_OST_Msk                 (0x01UL << NT_PWM6_HDFRC_OST_Pos)                       /*!< NT_PWM6 HDFRC: OST Mask                 */

/* ------------------------------  NT_PWM6_HDINTCLR  ------------------------------ */
#define NT_PWM6_HDINTCLR_HDINT_Pos            0                                                       /*!< NT_PWM6 HDINTCLR: HDINT Position        */
#define NT_PWM6_HDINTCLR_HDINT_Msk            (0x01UL << NT_PWM6_HDINTCLR_HDINT_Pos)                  /*!< NT_PWM6 HDINTCLR: HDINT Mask            */

/* ------------------------------  NT_PWM6_TZINTCLR  ------------------------------ */
#define NT_PWM6_TZINTCLR_TZINT_Pos            0                                                       /*!< NT_PWM6 TZINTCLR: TZINT Position        */
#define NT_PWM6_TZINTCLR_TZINT_Msk            (0x01UL << NT_PWM6_TZINTCLR_TZINT_Pos)                  /*!< NT_PWM6 TZINTCLR: TZINT Mask            */

/* -------------------------------  NT_PWM6_INTCLR  ------------------------------- */
#define NT_PWM6_INTCLR_INT_Pos                0                                                       /*!< NT_PWM6 INTCLR: INT Position            */
#define NT_PWM6_INTCLR_INT_Msk                (0x01UL << NT_PWM6_INTCLR_INT_Pos)                      /*!< NT_PWM6 INTCLR: INT Mask                */


/* ================================================================================ */
/* ================        struct 'NT_PWM7' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_PWM7_TBCTL  ------------------------------- */
#define NT_PWM7_TBCTL_CTRMODE_Pos             0                                                       /*!< NT_PWM7 TBCTL: CTRMODE Position         */
#define NT_PWM7_TBCTL_CTRMODE_Msk             (0x03UL << NT_PWM7_TBCTL_CTRMODE_Pos)                   /*!< NT_PWM7 TBCTL: CTRMODE Mask             */
#define NT_PWM7_TBCTL_PHSEN_Pos               2                                                       /*!< NT_PWM7 TBCTL: PHSEN Position           */
#define NT_PWM7_TBCTL_PHSEN_Msk               (0x01UL << NT_PWM7_TBCTL_PHSEN_Pos)                     /*!< NT_PWM7 TBCTL: PHSEN Mask               */
#define NT_PWM7_TBCTL_PRDLD_Pos               3                                                       /*!< NT_PWM7 TBCTL: PRDLD Position           */
#define NT_PWM7_TBCTL_PRDLD_Msk               (0x01UL << NT_PWM7_TBCTL_PRDLD_Pos)                     /*!< NT_PWM7 TBCTL: PRDLD Mask               */
#define NT_PWM7_TBCTL_SYNCOSEL_Pos            4                                                       /*!< NT_PWM7 TBCTL: SYNCOSEL Position        */
#define NT_PWM7_TBCTL_SYNCOSEL_Msk            (0x03UL << NT_PWM7_TBCTL_SYNCOSEL_Pos)                  /*!< NT_PWM7 TBCTL: SYNCOSEL Mask            */
#define NT_PWM7_TBCTL_SWFSYNC_Pos             6                                                       /*!< NT_PWM7 TBCTL: SWFSYNC Position         */
#define NT_PWM7_TBCTL_SWFSYNC_Msk             (0x01UL << NT_PWM7_TBCTL_SWFSYNC_Pos)                   /*!< NT_PWM7 TBCTL: SWFSYNC Mask             */
#define NT_PWM7_TBCTL_HSPCLKDIV_Pos           7                                                       /*!< NT_PWM7 TBCTL: HSPCLKDIV Position       */
#define NT_PWM7_TBCTL_HSPCLKDIV_Msk           (0x07UL << NT_PWM7_TBCTL_HSPCLKDIV_Pos)                 /*!< NT_PWM7 TBCTL: HSPCLKDIV Mask           */
#define NT_PWM7_TBCTL_CLKDIV_Pos              10                                                      /*!< NT_PWM7 TBCTL: CLKDIV Position          */
#define NT_PWM7_TBCTL_CLKDIV_Msk              (0x07UL << NT_PWM7_TBCTL_CLKDIV_Pos)                    /*!< NT_PWM7 TBCTL: CLKDIV Mask              */
#define NT_PWM7_TBCTL_PHSDIR_Pos              13                                                      /*!< NT_PWM7 TBCTL: PHSDIR Position          */
#define NT_PWM7_TBCTL_PHSDIR_Msk              (0x01UL << NT_PWM7_TBCTL_PHSDIR_Pos)                    /*!< NT_PWM7 TBCTL: PHSDIR Mask              */
#define NT_PWM7_TBCTL_FREE_SOFT_Pos           14                                                      /*!< NT_PWM7 TBCTL: FREE_SOFT Position       */
#define NT_PWM7_TBCTL_FREE_SOFT_Msk           (0x03UL << NT_PWM7_TBCTL_FREE_SOFT_Pos)                 /*!< NT_PWM7 TBCTL: FREE_SOFT Mask           */

/* --------------------------------  NT_PWM7_TBSTS  ------------------------------- */
#define NT_PWM7_TBSTS_CTRDIR_Pos              0                                                       /*!< NT_PWM7 TBSTS: CTRDIR Position          */
#define NT_PWM7_TBSTS_CTRDIR_Msk              (0x01UL << NT_PWM7_TBSTS_CTRDIR_Pos)                    /*!< NT_PWM7 TBSTS: CTRDIR Mask              */
#define NT_PWM7_TBSTS_SYNCI_Pos               1                                                       /*!< NT_PWM7 TBSTS: SYNCI Position           */
#define NT_PWM7_TBSTS_SYNCI_Msk               (0x01UL << NT_PWM7_TBSTS_SYNCI_Pos)                     /*!< NT_PWM7 TBSTS: SYNCI Mask               */
#define NT_PWM7_TBSTS_CTRMAX_Pos              2                                                       /*!< NT_PWM7 TBSTS: CTRMAX Position          */
#define NT_PWM7_TBSTS_CTRMAX_Msk              (0x01UL << NT_PWM7_TBSTS_CTRMAX_Pos)                    /*!< NT_PWM7 TBSTS: CTRMAX Mask              */

/* --------------------------------  NT_PWM7_TBPHS  ------------------------------- */
#define NT_PWM7_TBPHS_TBPHSHR_Pos             8                                                       /*!< NT_PWM7 TBPHS: TBPHSHR Position         */
#define NT_PWM7_TBPHS_TBPHSHR_Msk             (0x000000ffUL << NT_PWM7_TBPHS_TBPHSHR_Pos)             /*!< NT_PWM7 TBPHS: TBPHSHR Mask             */
#define NT_PWM7_TBPHS_TBPHS_Pos               16                                                      /*!< NT_PWM7 TBPHS: TBPHS Position           */
#define NT_PWM7_TBPHS_TBPHS_Msk               (0x0000ffffUL << NT_PWM7_TBPHS_TBPHS_Pos)               /*!< NT_PWM7 TBPHS: TBPHS Mask               */

/* --------------------------------  NT_PWM7_TBCTR  ------------------------------- */
#define NT_PWM7_TBCTR_TBCTR_Pos               0                                                       /*!< NT_PWM7 TBCTR: TBCTR Position           */
#define NT_PWM7_TBCTR_TBCTR_Msk               (0x0000ffffUL << NT_PWM7_TBCTR_TBCTR_Pos)               /*!< NT_PWM7 TBCTR: TBCTR Mask               */

/* --------------------------------  NT_PWM7_TBPRD  ------------------------------- */
#define NT_PWM7_TBPRD_TBPRD_Pos               0                                                       /*!< NT_PWM7 TBPRD: TBPRD Position           */
#define NT_PWM7_TBPRD_TBPRD_Msk               (0x0000ffffUL << NT_PWM7_TBPRD_TBPRD_Pos)               /*!< NT_PWM7 TBPRD: TBPRD Mask               */

/* -------------------------------  NT_PWM7_CMPCTL  ------------------------------- */
#define NT_PWM7_CMPCTL_LOADAMODE_Pos          0                                                       /*!< NT_PWM7 CMPCTL: LOADAMODE Position      */
#define NT_PWM7_CMPCTL_LOADAMODE_Msk          (0x03UL << NT_PWM7_CMPCTL_LOADAMODE_Pos)                /*!< NT_PWM7 CMPCTL: LOADAMODE Mask          */
#define NT_PWM7_CMPCTL_LOADBMODE_Pos          2                                                       /*!< NT_PWM7 CMPCTL: LOADBMODE Position      */
#define NT_PWM7_CMPCTL_LOADBMODE_Msk          (0x03UL << NT_PWM7_CMPCTL_LOADBMODE_Pos)                /*!< NT_PWM7 CMPCTL: LOADBMODE Mask          */
#define NT_PWM7_CMPCTL_SHDWAMODE_Pos          4                                                       /*!< NT_PWM7 CMPCTL: SHDWAMODE Position      */
#define NT_PWM7_CMPCTL_SHDWAMODE_Msk          (0x01UL << NT_PWM7_CMPCTL_SHDWAMODE_Pos)                /*!< NT_PWM7 CMPCTL: SHDWAMODE Mask          */
#define NT_PWM7_CMPCTL_SHDWBMODE_Pos          6                                                       /*!< NT_PWM7 CMPCTL: SHDWBMODE Position      */
#define NT_PWM7_CMPCTL_SHDWBMODE_Msk          (0x01UL << NT_PWM7_CMPCTL_SHDWBMODE_Pos)                /*!< NT_PWM7 CMPCTL: SHDWBMODE Mask          */
#define NT_PWM7_CMPCTL_SHDWAFULL_Pos          8                                                       /*!< NT_PWM7 CMPCTL: SHDWAFULL Position      */
#define NT_PWM7_CMPCTL_SHDWAFULL_Msk          (0x01UL << NT_PWM7_CMPCTL_SHDWAFULL_Pos)                /*!< NT_PWM7 CMPCTL: SHDWAFULL Mask          */
#define NT_PWM7_CMPCTL_SHDWBFULL_Pos          9                                                       /*!< NT_PWM7 CMPCTL: SHDWBFULL Position      */
#define NT_PWM7_CMPCTL_SHDWBFULL_Msk          (0x01UL << NT_PWM7_CMPCTL_SHDWBFULL_Pos)                /*!< NT_PWM7 CMPCTL: SHDWBFULL Mask          */

/* --------------------------------  NT_PWM7_CMPA  -------------------------------- */
#define NT_PWM7_CMPA_CMPAHR_Pos               8                                                       /*!< NT_PWM7 CMPA: CMPAHR Position           */
#define NT_PWM7_CMPA_CMPAHR_Msk               (0x000000ffUL << NT_PWM7_CMPA_CMPAHR_Pos)               /*!< NT_PWM7 CMPA: CMPAHR Mask               */
#define NT_PWM7_CMPA_CMPA_Pos                 16                                                      /*!< NT_PWM7 CMPA: CMPA Position             */
#define NT_PWM7_CMPA_CMPA_Msk                 (0x0000ffffUL << NT_PWM7_CMPA_CMPA_Pos)                 /*!< NT_PWM7 CMPA: CMPA Mask                 */

/* --------------------------------  NT_PWM7_CMPB  -------------------------------- */
#define NT_PWM7_CMPB_CMPB_Pos                 16                                                      /*!< NT_PWM7 CMPB: CMPB Position             */
#define NT_PWM7_CMPB_CMPB_Msk                 (0x0000ffffUL << NT_PWM7_CMPB_CMPB_Pos)                 /*!< NT_PWM7 CMPB: CMPB Mask                 */

/* -------------------------------  NT_PWM7_AQCTLA  ------------------------------- */
#define NT_PWM7_AQCTLA_ZRO_Pos                0                                                       /*!< NT_PWM7 AQCTLA: ZRO Position            */
#define NT_PWM7_AQCTLA_ZRO_Msk                (0x03UL << NT_PWM7_AQCTLA_ZRO_Pos)                      /*!< NT_PWM7 AQCTLA: ZRO Mask                */
#define NT_PWM7_AQCTLA_PRD_Pos                2                                                       /*!< NT_PWM7 AQCTLA: PRD Position            */
#define NT_PWM7_AQCTLA_PRD_Msk                (0x03UL << NT_PWM7_AQCTLA_PRD_Pos)                      /*!< NT_PWM7 AQCTLA: PRD Mask                */
#define NT_PWM7_AQCTLA_CAU_Pos                4                                                       /*!< NT_PWM7 AQCTLA: CAU Position            */
#define NT_PWM7_AQCTLA_CAU_Msk                (0x03UL << NT_PWM7_AQCTLA_CAU_Pos)                      /*!< NT_PWM7 AQCTLA: CAU Mask                */
#define NT_PWM7_AQCTLA_CAD_Pos                6                                                       /*!< NT_PWM7 AQCTLA: CAD Position            */
#define NT_PWM7_AQCTLA_CAD_Msk                (0x03UL << NT_PWM7_AQCTLA_CAD_Pos)                      /*!< NT_PWM7 AQCTLA: CAD Mask                */
#define NT_PWM7_AQCTLA_CBU_Pos                8                                                       /*!< NT_PWM7 AQCTLA: CBU Position            */
#define NT_PWM7_AQCTLA_CBU_Msk                (0x03UL << NT_PWM7_AQCTLA_CBU_Pos)                      /*!< NT_PWM7 AQCTLA: CBU Mask                */
#define NT_PWM7_AQCTLA_CBD_Pos                10                                                      /*!< NT_PWM7 AQCTLA: CBD Position            */
#define NT_PWM7_AQCTLA_CBD_Msk                (0x03UL << NT_PWM7_AQCTLA_CBD_Pos)                      /*!< NT_PWM7 AQCTLA: CBD Mask                */

/* -------------------------------  NT_PWM7_AQCTLB  ------------------------------- */
#define NT_PWM7_AQCTLB_ZRO_Pos                0                                                       /*!< NT_PWM7 AQCTLB: ZRO Position            */
#define NT_PWM7_AQCTLB_ZRO_Msk                (0x03UL << NT_PWM7_AQCTLB_ZRO_Pos)                      /*!< NT_PWM7 AQCTLB: ZRO Mask                */
#define NT_PWM7_AQCTLB_PRD_Pos                2                                                       /*!< NT_PWM7 AQCTLB: PRD Position            */
#define NT_PWM7_AQCTLB_PRD_Msk                (0x03UL << NT_PWM7_AQCTLB_PRD_Pos)                      /*!< NT_PWM7 AQCTLB: PRD Mask                */
#define NT_PWM7_AQCTLB_CAU_Pos                4                                                       /*!< NT_PWM7 AQCTLB: CAU Position            */
#define NT_PWM7_AQCTLB_CAU_Msk                (0x03UL << NT_PWM7_AQCTLB_CAU_Pos)                      /*!< NT_PWM7 AQCTLB: CAU Mask                */
#define NT_PWM7_AQCTLB_CAD_Pos                6                                                       /*!< NT_PWM7 AQCTLB: CAD Position            */
#define NT_PWM7_AQCTLB_CAD_Msk                (0x03UL << NT_PWM7_AQCTLB_CAD_Pos)                      /*!< NT_PWM7 AQCTLB: CAD Mask                */
#define NT_PWM7_AQCTLB_CBU_Pos                8                                                       /*!< NT_PWM7 AQCTLB: CBU Position            */
#define NT_PWM7_AQCTLB_CBU_Msk                (0x03UL << NT_PWM7_AQCTLB_CBU_Pos)                      /*!< NT_PWM7 AQCTLB: CBU Mask                */
#define NT_PWM7_AQCTLB_CBD_Pos                10                                                      /*!< NT_PWM7 AQCTLB: CBD Position            */
#define NT_PWM7_AQCTLB_CBD_Msk                (0x03UL << NT_PWM7_AQCTLB_CBD_Pos)                      /*!< NT_PWM7 AQCTLB: CBD Mask                */

/* -------------------------------  NT_PWM7_AQSFRC  ------------------------------- */
#define NT_PWM7_AQSFRC_ACTSFA_Pos             0                                                       /*!< NT_PWM7 AQSFRC: ACTSFA Position         */
#define NT_PWM7_AQSFRC_ACTSFA_Msk             (0x03UL << NT_PWM7_AQSFRC_ACTSFA_Pos)                   /*!< NT_PWM7 AQSFRC: ACTSFA Mask             */
#define NT_PWM7_AQSFRC_OTSFA_Pos              2                                                       /*!< NT_PWM7 AQSFRC: OTSFA Position          */
#define NT_PWM7_AQSFRC_OTSFA_Msk              (0x01UL << NT_PWM7_AQSFRC_OTSFA_Pos)                    /*!< NT_PWM7 AQSFRC: OTSFA Mask              */
#define NT_PWM7_AQSFRC_ACTSFB_Pos             3                                                       /*!< NT_PWM7 AQSFRC: ACTSFB Position         */
#define NT_PWM7_AQSFRC_ACTSFB_Msk             (0x03UL << NT_PWM7_AQSFRC_ACTSFB_Pos)                   /*!< NT_PWM7 AQSFRC: ACTSFB Mask             */
#define NT_PWM7_AQSFRC_OTSFB_Pos              5                                                       /*!< NT_PWM7 AQSFRC: OTSFB Position          */
#define NT_PWM7_AQSFRC_OTSFB_Msk              (0x01UL << NT_PWM7_AQSFRC_OTSFB_Pos)                    /*!< NT_PWM7 AQSFRC: OTSFB Mask              */
#define NT_PWM7_AQSFRC_RLDCSF_Pos             6                                                       /*!< NT_PWM7 AQSFRC: RLDCSF Position         */
#define NT_PWM7_AQSFRC_RLDCSF_Msk             (0x03UL << NT_PWM7_AQSFRC_RLDCSF_Pos)                   /*!< NT_PWM7 AQSFRC: RLDCSF Mask             */

/* -------------------------------  NT_PWM7_AQCSFRC  ------------------------------ */
#define NT_PWM7_AQCSFRC_CSFA_Pos              0                                                       /*!< NT_PWM7 AQCSFRC: CSFA Position          */
#define NT_PWM7_AQCSFRC_CSFA_Msk              (0x03UL << NT_PWM7_AQCSFRC_CSFA_Pos)                    /*!< NT_PWM7 AQCSFRC: CSFA Mask              */
#define NT_PWM7_AQCSFRC_CSFB_Pos              2                                                       /*!< NT_PWM7 AQCSFRC: CSFB Position          */
#define NT_PWM7_AQCSFRC_CSFB_Msk              (0x03UL << NT_PWM7_AQCSFRC_CSFB_Pos)                    /*!< NT_PWM7 AQCSFRC: CSFB Mask              */

/* --------------------------------  NT_PWM7_DBCTL  ------------------------------- */
#define NT_PWM7_DBCTL_OUT_MODE_Pos            0                                                       /*!< NT_PWM7 DBCTL: OUT_MODE Position        */
#define NT_PWM7_DBCTL_OUT_MODE_Msk            (0x03UL << NT_PWM7_DBCTL_OUT_MODE_Pos)                  /*!< NT_PWM7 DBCTL: OUT_MODE Mask            */
#define NT_PWM7_DBCTL_POLSEL_Pos              2                                                       /*!< NT_PWM7 DBCTL: POLSEL Position          */
#define NT_PWM7_DBCTL_POLSEL_Msk              (0x03UL << NT_PWM7_DBCTL_POLSEL_Pos)                    /*!< NT_PWM7 DBCTL: POLSEL Mask              */
#define NT_PWM7_DBCTL_IN_MODE_Pos             4                                                       /*!< NT_PWM7 DBCTL: IN_MODE Position         */
#define NT_PWM7_DBCTL_IN_MODE_Msk             (0x03UL << NT_PWM7_DBCTL_IN_MODE_Pos)                   /*!< NT_PWM7 DBCTL: IN_MODE Mask             */

/* --------------------------------  NT_PWM7_DBRED  ------------------------------- */
#define NT_PWM7_DBRED_DEL_Pos                 0                                                       /*!< NT_PWM7 DBRED: DEL Position             */
#define NT_PWM7_DBRED_DEL_Msk                 (0x000003ffUL << NT_PWM7_DBRED_DEL_Pos)                 /*!< NT_PWM7 DBRED: DEL Mask                 */

/* --------------------------------  NT_PWM7_DBFED  ------------------------------- */
#define NT_PWM7_DBFED_DEL_Pos                 0                                                       /*!< NT_PWM7 DBFED: DEL Position             */
#define NT_PWM7_DBFED_DEL_Msk                 (0x000003ffUL << NT_PWM7_DBFED_DEL_Pos)                 /*!< NT_PWM7 DBFED: DEL Mask                 */

/* --------------------------------  NT_PWM7_TZSEL  ------------------------------- */
#define NT_PWM7_TZSEL_CBC0_Pos                0                                                       /*!< NT_PWM7 TZSEL: CBC0 Position            */
#define NT_PWM7_TZSEL_CBC0_Msk                (0x01UL << NT_PWM7_TZSEL_CBC0_Pos)                      /*!< NT_PWM7 TZSEL: CBC0 Mask                */
#define NT_PWM7_TZSEL_CBC1_Pos                1                                                       /*!< NT_PWM7 TZSEL: CBC1 Position            */
#define NT_PWM7_TZSEL_CBC1_Msk                (0x01UL << NT_PWM7_TZSEL_CBC1_Pos)                      /*!< NT_PWM7 TZSEL: CBC1 Mask                */
#define NT_PWM7_TZSEL_CBC2_Pos                2                                                       /*!< NT_PWM7 TZSEL: CBC2 Position            */
#define NT_PWM7_TZSEL_CBC2_Msk                (0x01UL << NT_PWM7_TZSEL_CBC2_Pos)                      /*!< NT_PWM7 TZSEL: CBC2 Mask                */
#define NT_PWM7_TZSEL_CBC3_Pos                3                                                       /*!< NT_PWM7 TZSEL: CBC3 Position            */
#define NT_PWM7_TZSEL_CBC3_Msk                (0x01UL << NT_PWM7_TZSEL_CBC3_Pos)                      /*!< NT_PWM7 TZSEL: CBC3 Mask                */
#define NT_PWM7_TZSEL_CBC4_Pos                4                                                       /*!< NT_PWM7 TZSEL: CBC4 Position            */
#define NT_PWM7_TZSEL_CBC4_Msk                (0x01UL << NT_PWM7_TZSEL_CBC4_Pos)                      /*!< NT_PWM7 TZSEL: CBC4 Mask                */
#define NT_PWM7_TZSEL_CBC5_Pos                5                                                       /*!< NT_PWM7 TZSEL: CBC5 Position            */
#define NT_PWM7_TZSEL_CBC5_Msk                (0x01UL << NT_PWM7_TZSEL_CBC5_Pos)                      /*!< NT_PWM7 TZSEL: CBC5 Mask                */
#define NT_PWM7_TZSEL_OSHT0_Pos               8                                                       /*!< NT_PWM7 TZSEL: OSHT0 Position           */
#define NT_PWM7_TZSEL_OSHT0_Msk               (0x01UL << NT_PWM7_TZSEL_OSHT0_Pos)                     /*!< NT_PWM7 TZSEL: OSHT0 Mask               */
#define NT_PWM7_TZSEL_OSHT1_Pos               9                                                       /*!< NT_PWM7 TZSEL: OSHT1 Position           */
#define NT_PWM7_TZSEL_OSHT1_Msk               (0x01UL << NT_PWM7_TZSEL_OSHT1_Pos)                     /*!< NT_PWM7 TZSEL: OSHT1 Mask               */
#define NT_PWM7_TZSEL_OSHT2_Pos               10                                                      /*!< NT_PWM7 TZSEL: OSHT2 Position           */
#define NT_PWM7_TZSEL_OSHT2_Msk               (0x01UL << NT_PWM7_TZSEL_OSHT2_Pos)                     /*!< NT_PWM7 TZSEL: OSHT2 Mask               */
#define NT_PWM7_TZSEL_OSHT3_Pos               11                                                      /*!< NT_PWM7 TZSEL: OSHT3 Position           */
#define NT_PWM7_TZSEL_OSHT3_Msk               (0x01UL << NT_PWM7_TZSEL_OSHT3_Pos)                     /*!< NT_PWM7 TZSEL: OSHT3 Mask               */
#define NT_PWM7_TZSEL_OSHT4_Pos               12                                                      /*!< NT_PWM7 TZSEL: OSHT4 Position           */
#define NT_PWM7_TZSEL_OSHT4_Msk               (0x01UL << NT_PWM7_TZSEL_OSHT4_Pos)                     /*!< NT_PWM7 TZSEL: OSHT4 Mask               */
#define NT_PWM7_TZSEL_OSHT5_Pos               13                                                      /*!< NT_PWM7 TZSEL: OSHT5 Position           */
#define NT_PWM7_TZSEL_OSHT5_Msk               (0x01UL << NT_PWM7_TZSEL_OSHT5_Pos)                     /*!< NT_PWM7 TZSEL: OSHT5 Mask               */

/* --------------------------------  NT_PWM7_TZCTL  ------------------------------- */
#define NT_PWM7_TZCTL_TZA_Pos                 0                                                       /*!< NT_PWM7 TZCTL: TZA Position             */
#define NT_PWM7_TZCTL_TZA_Msk                 (0x03UL << NT_PWM7_TZCTL_TZA_Pos)                       /*!< NT_PWM7 TZCTL: TZA Mask                 */
#define NT_PWM7_TZCTL_TZB_Pos                 2                                                       /*!< NT_PWM7 TZCTL: TZB Position             */
#define NT_PWM7_TZCTL_TZB_Msk                 (0x03UL << NT_PWM7_TZCTL_TZB_Pos)                       /*!< NT_PWM7 TZCTL: TZB Mask                 */

/* -------------------------------  NT_PWM7_TZEINT  ------------------------------- */
#define NT_PWM7_TZEINT_CBC_Pos                1                                                       /*!< NT_PWM7 TZEINT: CBC Position            */
#define NT_PWM7_TZEINT_CBC_Msk                (0x01UL << NT_PWM7_TZEINT_CBC_Pos)                      /*!< NT_PWM7 TZEINT: CBC Mask                */
#define NT_PWM7_TZEINT_OST_Pos                2                                                       /*!< NT_PWM7 TZEINT: OST Position            */
#define NT_PWM7_TZEINT_OST_Msk                (0x01UL << NT_PWM7_TZEINT_OST_Pos)                      /*!< NT_PWM7 TZEINT: OST Mask                */

/* --------------------------------  NT_PWM7_TZFLG  ------------------------------- */
#define NT_PWM7_TZFLG_INT_Pos                 0                                                       /*!< NT_PWM7 TZFLG: INT Position             */
#define NT_PWM7_TZFLG_INT_Msk                 (0x01UL << NT_PWM7_TZFLG_INT_Pos)                       /*!< NT_PWM7 TZFLG: INT Mask                 */
#define NT_PWM7_TZFLG_CBC_Pos                 1                                                       /*!< NT_PWM7 TZFLG: CBC Position             */
#define NT_PWM7_TZFLG_CBC_Msk                 (0x01UL << NT_PWM7_TZFLG_CBC_Pos)                       /*!< NT_PWM7 TZFLG: CBC Mask                 */
#define NT_PWM7_TZFLG_OST_Pos                 2                                                       /*!< NT_PWM7 TZFLG: OST Position             */
#define NT_PWM7_TZFLG_OST_Msk                 (0x01UL << NT_PWM7_TZFLG_OST_Pos)                       /*!< NT_PWM7 TZFLG: OST Mask                 */

/* --------------------------------  NT_PWM7_TZCLR  ------------------------------- */
#define NT_PWM7_TZCLR_INT_Pos                 0                                                       /*!< NT_PWM7 TZCLR: INT Position             */
#define NT_PWM7_TZCLR_INT_Msk                 (0x01UL << NT_PWM7_TZCLR_INT_Pos)                       /*!< NT_PWM7 TZCLR: INT Mask                 */
#define NT_PWM7_TZCLR_CBC_Pos                 1                                                       /*!< NT_PWM7 TZCLR: CBC Position             */
#define NT_PWM7_TZCLR_CBC_Msk                 (0x01UL << NT_PWM7_TZCLR_CBC_Pos)                       /*!< NT_PWM7 TZCLR: CBC Mask                 */
#define NT_PWM7_TZCLR_OST_Pos                 2                                                       /*!< NT_PWM7 TZCLR: OST Position             */
#define NT_PWM7_TZCLR_OST_Msk                 (0x01UL << NT_PWM7_TZCLR_OST_Pos)                       /*!< NT_PWM7 TZCLR: OST Mask                 */

/* --------------------------------  NT_PWM7_TZFRC  ------------------------------- */
#define NT_PWM7_TZFRC_CBC_Pos                 1                                                       /*!< NT_PWM7 TZFRC: CBC Position             */
#define NT_PWM7_TZFRC_CBC_Msk                 (0x01UL << NT_PWM7_TZFRC_CBC_Pos)                       /*!< NT_PWM7 TZFRC: CBC Mask                 */
#define NT_PWM7_TZFRC_OST_Pos                 2                                                       /*!< NT_PWM7 TZFRC: OST Position             */
#define NT_PWM7_TZFRC_OST_Msk                 (0x01UL << NT_PWM7_TZFRC_OST_Pos)                       /*!< NT_PWM7 TZFRC: OST Mask                 */

/* --------------------------------  NT_PWM7_ETSEL  ------------------------------- */
#define NT_PWM7_ETSEL_INTSEL_Pos              0                                                       /*!< NT_PWM7 ETSEL: INTSEL Position          */
#define NT_PWM7_ETSEL_INTSEL_Msk              (0x07UL << NT_PWM7_ETSEL_INTSEL_Pos)                    /*!< NT_PWM7 ETSEL: INTSEL Mask              */
#define NT_PWM7_ETSEL_INTEN_Pos               3                                                       /*!< NT_PWM7 ETSEL: INTEN Position           */
#define NT_PWM7_ETSEL_INTEN_Msk               (0x01UL << NT_PWM7_ETSEL_INTEN_Pos)                     /*!< NT_PWM7 ETSEL: INTEN Mask               */
#define NT_PWM7_ETSEL_SOCASEL_Pos             8                                                       /*!< NT_PWM7 ETSEL: SOCASEL Position         */
#define NT_PWM7_ETSEL_SOCASEL_Msk             (0x07UL << NT_PWM7_ETSEL_SOCASEL_Pos)                   /*!< NT_PWM7 ETSEL: SOCASEL Mask             */
#define NT_PWM7_ETSEL_SOCAEN_Pos              11                                                      /*!< NT_PWM7 ETSEL: SOCAEN Position          */
#define NT_PWM7_ETSEL_SOCAEN_Msk              (0x01UL << NT_PWM7_ETSEL_SOCAEN_Pos)                    /*!< NT_PWM7 ETSEL: SOCAEN Mask              */
#define NT_PWM7_ETSEL_SOCBSEL_Pos             12                                                      /*!< NT_PWM7 ETSEL: SOCBSEL Position         */
#define NT_PWM7_ETSEL_SOCBSEL_Msk             (0x07UL << NT_PWM7_ETSEL_SOCBSEL_Pos)                   /*!< NT_PWM7 ETSEL: SOCBSEL Mask             */
#define NT_PWM7_ETSEL_SOCBEN_Pos              15                                                      /*!< NT_PWM7 ETSEL: SOCBEN Position          */
#define NT_PWM7_ETSEL_SOCBEN_Msk              (0x01UL << NT_PWM7_ETSEL_SOCBEN_Pos)                    /*!< NT_PWM7 ETSEL: SOCBEN Mask              */

/* --------------------------------  NT_PWM7_ETPS  -------------------------------- */
#define NT_PWM7_ETPS_INTPRD_Pos               0                                                       /*!< NT_PWM7 ETPS: INTPRD Position           */
#define NT_PWM7_ETPS_INTPRD_Msk               (0x03UL << NT_PWM7_ETPS_INTPRD_Pos)                     /*!< NT_PWM7 ETPS: INTPRD Mask               */
#define NT_PWM7_ETPS_INTCNT_Pos               2                                                       /*!< NT_PWM7 ETPS: INTCNT Position           */
#define NT_PWM7_ETPS_INTCNT_Msk               (0x03UL << NT_PWM7_ETPS_INTCNT_Pos)                     /*!< NT_PWM7 ETPS: INTCNT Mask               */
#define NT_PWM7_ETPS_SOCAPRD_Pos              8                                                       /*!< NT_PWM7 ETPS: SOCAPRD Position          */
#define NT_PWM7_ETPS_SOCAPRD_Msk              (0x03UL << NT_PWM7_ETPS_SOCAPRD_Pos)                    /*!< NT_PWM7 ETPS: SOCAPRD Mask              */
#define NT_PWM7_ETPS_SOCACNT_Pos              10                                                      /*!< NT_PWM7 ETPS: SOCACNT Position          */
#define NT_PWM7_ETPS_SOCACNT_Msk              (0x03UL << NT_PWM7_ETPS_SOCACNT_Pos)                    /*!< NT_PWM7 ETPS: SOCACNT Mask              */
#define NT_PWM7_ETPS_SOCPRD_Pos               12                                                      /*!< NT_PWM7 ETPS: SOCPRD Position           */
#define NT_PWM7_ETPS_SOCPRD_Msk               (0x03UL << NT_PWM7_ETPS_SOCPRD_Pos)                     /*!< NT_PWM7 ETPS: SOCPRD Mask               */
#define NT_PWM7_ETPS_SOCBCNT_Pos              14                                                      /*!< NT_PWM7 ETPS: SOCBCNT Position          */
#define NT_PWM7_ETPS_SOCBCNT_Msk              (0x03UL << NT_PWM7_ETPS_SOCBCNT_Pos)                    /*!< NT_PWM7 ETPS: SOCBCNT Mask              */

/* --------------------------------  NT_PWM7_ETFLG  ------------------------------- */
#define NT_PWM7_ETFLG_INT_Pos                 0                                                       /*!< NT_PWM7 ETFLG: INT Position             */
#define NT_PWM7_ETFLG_INT_Msk                 (0x01UL << NT_PWM7_ETFLG_INT_Pos)                       /*!< NT_PWM7 ETFLG: INT Mask                 */
#define NT_PWM7_ETFLG_SOCA_Pos                2                                                       /*!< NT_PWM7 ETFLG: SOCA Position            */
#define NT_PWM7_ETFLG_SOCA_Msk                (0x01UL << NT_PWM7_ETFLG_SOCA_Pos)                      /*!< NT_PWM7 ETFLG: SOCA Mask                */
#define NT_PWM7_ETFLG_SOCB_Pos                3                                                       /*!< NT_PWM7 ETFLG: SOCB Position            */
#define NT_PWM7_ETFLG_SOCB_Msk                (0x01UL << NT_PWM7_ETFLG_SOCB_Pos)                      /*!< NT_PWM7 ETFLG: SOCB Mask                */

/* --------------------------------  NT_PWM7_ETCLR  ------------------------------- */
#define NT_PWM7_ETCLR_INT_Pos                 0                                                       /*!< NT_PWM7 ETCLR: INT Position             */
#define NT_PWM7_ETCLR_INT_Msk                 (0x01UL << NT_PWM7_ETCLR_INT_Pos)                       /*!< NT_PWM7 ETCLR: INT Mask                 */
#define NT_PWM7_ETCLR_SOCA_Pos                2                                                       /*!< NT_PWM7 ETCLR: SOCA Position            */
#define NT_PWM7_ETCLR_SOCA_Msk                (0x01UL << NT_PWM7_ETCLR_SOCA_Pos)                      /*!< NT_PWM7 ETCLR: SOCA Mask                */
#define NT_PWM7_ETCLR_SOCB_Pos                3                                                       /*!< NT_PWM7 ETCLR: SOCB Position            */
#define NT_PWM7_ETCLR_SOCB_Msk                (0x01UL << NT_PWM7_ETCLR_SOCB_Pos)                      /*!< NT_PWM7 ETCLR: SOCB Mask                */

/* --------------------------------  NT_PWM7_ETFRC  ------------------------------- */
#define NT_PWM7_ETFRC_INT_Pos                 0                                                       /*!< NT_PWM7 ETFRC: INT Position             */
#define NT_PWM7_ETFRC_INT_Msk                 (0x01UL << NT_PWM7_ETFRC_INT_Pos)                       /*!< NT_PWM7 ETFRC: INT Mask                 */
#define NT_PWM7_ETFRC_SOCA_Pos                2                                                       /*!< NT_PWM7 ETFRC: SOCA Position            */
#define NT_PWM7_ETFRC_SOCA_Msk                (0x01UL << NT_PWM7_ETFRC_SOCA_Pos)                      /*!< NT_PWM7 ETFRC: SOCA Mask                */
#define NT_PWM7_ETFRC_SOCB_Pos                3                                                       /*!< NT_PWM7 ETFRC: SOCB Position            */
#define NT_PWM7_ETFRC_SOCB_Msk                (0x01UL << NT_PWM7_ETFRC_SOCB_Pos)                      /*!< NT_PWM7 ETFRC: SOCB Mask                */

/* --------------------------------  NT_PWM7_PCCTL  ------------------------------- */
#define NT_PWM7_PCCTL_CHPEN_Pos               0                                                       /*!< NT_PWM7 PCCTL: CHPEN Position           */
#define NT_PWM7_PCCTL_CHPEN_Msk               (0x01UL << NT_PWM7_PCCTL_CHPEN_Pos)                     /*!< NT_PWM7 PCCTL: CHPEN Mask               */
#define NT_PWM7_PCCTL_OSHTWTH_Pos             1                                                       /*!< NT_PWM7 PCCTL: OSHTWTH Position         */
#define NT_PWM7_PCCTL_OSHTWTH_Msk             (0x0fUL << NT_PWM7_PCCTL_OSHTWTH_Pos)                   /*!< NT_PWM7 PCCTL: OSHTWTH Mask             */
#define NT_PWM7_PCCTL_SHRFREQ_Pos             5                                                       /*!< NT_PWM7 PCCTL: SHRFREQ Position         */
#define NT_PWM7_PCCTL_SHRFREQ_Msk             (0x07UL << NT_PWM7_PCCTL_SHRFREQ_Pos)                   /*!< NT_PWM7 PCCTL: SHRFREQ Mask             */
#define NT_PWM7_PCCTL_CHPDUTY_Pos             8                                                       /*!< NT_PWM7 PCCTL: CHPDUTY Position         */
#define NT_PWM7_PCCTL_CHPDUTY_Msk             (0x07UL << NT_PWM7_PCCTL_CHPDUTY_Pos)                   /*!< NT_PWM7 PCCTL: CHPDUTY Mask             */

/* -------------------------------  NT_PWM7_HRCNFG  ------------------------------- */
#define NT_PWM7_HRCNFG_EDGMODE_Pos            0                                                       /*!< NT_PWM7 HRCNFG: EDGMODE Position        */
#define NT_PWM7_HRCNFG_EDGMODE_Msk            (0x03UL << NT_PWM7_HRCNFG_EDGMODE_Pos)                  /*!< NT_PWM7 HRCNFG: EDGMODE Mask            */
#define NT_PWM7_HRCNFG_CTLMODE_Pos            2                                                       /*!< NT_PWM7 HRCNFG: CTLMODE Position        */
#define NT_PWM7_HRCNFG_CTLMODE_Msk            (0x01UL << NT_PWM7_HRCNFG_CTLMODE_Pos)                  /*!< NT_PWM7 HRCNFG: CTLMODE Mask            */
#define NT_PWM7_HRCNFG_HR_LOAD_Pos            3                                                       /*!< NT_PWM7 HRCNFG: HR_LOAD Position        */
#define NT_PWM7_HRCNFG_HR_LOAD_Msk            (0x01UL << NT_PWM7_HRCNFG_HR_LOAD_Pos)                  /*!< NT_PWM7 HRCNFG: HR_LOAD Mask            */
#define NT_PWM7_HRCNFG_MEP_SCALEFACTOR_Pos    16                                                      /*!< NT_PWM7 HRCNFG: MEP_SCALEFACTOR Position */
#define NT_PWM7_HRCNFG_MEP_SCALEFACTOR_Msk    (0x000000ffUL << NT_PWM7_HRCNFG_MEP_SCALEFACTOR_Pos)    /*!< NT_PWM7 HRCNFG: MEP_SCALEFACTOR Mask    */

/* --------------------------------  NT_PWM7_FWDTH  ------------------------------- */
#define NT_PWM7_FWDTH_FWDTH_Pos               0                                                       /*!< NT_PWM7 FWDTH: FWDTH Position           */
#define NT_PWM7_FWDTH_FWDTH_Msk               (0x000000ffUL << NT_PWM7_FWDTH_FWDTH_Pos)               /*!< NT_PWM7 FWDTH: FWDTH Mask               */

/* --------------------------------  NT_PWM7_HDSEL  ------------------------------- */
#define NT_PWM7_HDSEL_DCMP_Pos                0                                                       /*!< NT_PWM7 HDSEL: DCMP Position            */
#define NT_PWM7_HDSEL_DCMP_Msk                (0x00ffffffUL << NT_PWM7_HDSEL_DCMP_Pos)                /*!< NT_PWM7 HDSEL: DCMP Mask                */
#define NT_PWM7_HDSEL_ACMP_Pos                24                                                      /*!< NT_PWM7 HDSEL: ACMP Position            */
#define NT_PWM7_HDSEL_ACMP_Msk                (0x07UL << NT_PWM7_HDSEL_ACMP_Pos)                      /*!< NT_PWM7 HDSEL: ACMP Mask                */

/* --------------------------------  NT_PWM7_HDCTL  ------------------------------- */
#define NT_PWM7_HDCTL_HDA_Pos                 0                                                       /*!< NT_PWM7 HDCTL: HDA Position             */
#define NT_PWM7_HDCTL_HDA_Msk                 (0x03UL << NT_PWM7_HDCTL_HDA_Pos)                       /*!< NT_PWM7 HDCTL: HDA Mask                 */
#define NT_PWM7_HDCTL_HDB_Pos                 2                                                       /*!< NT_PWM7 HDCTL: HDB Position             */
#define NT_PWM7_HDCTL_HDB_Msk                 (0x03UL << NT_PWM7_HDCTL_HDB_Pos)                       /*!< NT_PWM7 HDCTL: HDB Mask                 */

/* -------------------------------  NT_PWM7_HDEINT  ------------------------------- */
#define NT_PWM7_HDEINT_CBC_Pos                1                                                       /*!< NT_PWM7 HDEINT: CBC Position            */
#define NT_PWM7_HDEINT_CBC_Msk                (0x01UL << NT_PWM7_HDEINT_CBC_Pos)                      /*!< NT_PWM7 HDEINT: CBC Mask                */
#define NT_PWM7_HDEINT_OST_Pos                2                                                       /*!< NT_PWM7 HDEINT: OST Position            */
#define NT_PWM7_HDEINT_OST_Msk                (0x01UL << NT_PWM7_HDEINT_OST_Pos)                      /*!< NT_PWM7 HDEINT: OST Mask                */

/* --------------------------------  NT_PWM7_HDFLG  ------------------------------- */
#define NT_PWM7_HDFLG_HDINT_Pos               0                                                       /*!< NT_PWM7 HDFLG: HDINT Position           */
#define NT_PWM7_HDFLG_HDINT_Msk               (0x01UL << NT_PWM7_HDFLG_HDINT_Pos)                     /*!< NT_PWM7 HDFLG: HDINT Mask               */
#define NT_PWM7_HDFLG_CBC_Pos                 1                                                       /*!< NT_PWM7 HDFLG: CBC Position             */
#define NT_PWM7_HDFLG_CBC_Msk                 (0x01UL << NT_PWM7_HDFLG_CBC_Pos)                       /*!< NT_PWM7 HDFLG: CBC Mask                 */
#define NT_PWM7_HDFLG_OST_Pos                 2                                                       /*!< NT_PWM7 HDFLG: OST Position             */
#define NT_PWM7_HDFLG_OST_Msk                 (0x01UL << NT_PWM7_HDFLG_OST_Pos)                       /*!< NT_PWM7 HDFLG: OST Mask                 */

/* --------------------------------  NT_PWM7_HDCLR  ------------------------------- */
#define NT_PWM7_HDCLR_HDINT_Pos               0                                                       /*!< NT_PWM7 HDCLR: HDINT Position           */
#define NT_PWM7_HDCLR_HDINT_Msk               (0x01UL << NT_PWM7_HDCLR_HDINT_Pos)                     /*!< NT_PWM7 HDCLR: HDINT Mask               */

/* --------------------------------  NT_PWM7_HDFRC  ------------------------------- */
#define NT_PWM7_HDFRC_CBC_Pos                 1                                                       /*!< NT_PWM7 HDFRC: CBC Position             */
#define NT_PWM7_HDFRC_CBC_Msk                 (0x01UL << NT_PWM7_HDFRC_CBC_Pos)                       /*!< NT_PWM7 HDFRC: CBC Mask                 */
#define NT_PWM7_HDFRC_OST_Pos                 2                                                       /*!< NT_PWM7 HDFRC: OST Position             */
#define NT_PWM7_HDFRC_OST_Msk                 (0x01UL << NT_PWM7_HDFRC_OST_Pos)                       /*!< NT_PWM7 HDFRC: OST Mask                 */

/* ------------------------------  NT_PWM7_HDINTCLR  ------------------------------ */
#define NT_PWM7_HDINTCLR_HDINT_Pos            0                                                       /*!< NT_PWM7 HDINTCLR: HDINT Position        */
#define NT_PWM7_HDINTCLR_HDINT_Msk            (0x01UL << NT_PWM7_HDINTCLR_HDINT_Pos)                  /*!< NT_PWM7 HDINTCLR: HDINT Mask            */

/* ------------------------------  NT_PWM7_TZINTCLR  ------------------------------ */
#define NT_PWM7_TZINTCLR_TZINT_Pos            0                                                       /*!< NT_PWM7 TZINTCLR: TZINT Position        */
#define NT_PWM7_TZINTCLR_TZINT_Msk            (0x01UL << NT_PWM7_TZINTCLR_TZINT_Pos)                  /*!< NT_PWM7 TZINTCLR: TZINT Mask            */

/* -------------------------------  NT_PWM7_INTCLR  ------------------------------- */
#define NT_PWM7_INTCLR_INT_Pos                0                                                       /*!< NT_PWM7 INTCLR: INT Position            */
#define NT_PWM7_INTCLR_INT_Msk                (0x01UL << NT_PWM7_INTCLR_INT_Pos)                      /*!< NT_PWM7 INTCLR: INT Mask                */


/* ================================================================================ */
/* ================        struct 'NT_PWM8' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_PWM8_TBCTL  ------------------------------- */
#define NT_PWM8_TBCTL_CTRMODE_Pos             0                                                       /*!< NT_PWM8 TBCTL: CTRMODE Position         */
#define NT_PWM8_TBCTL_CTRMODE_Msk             (0x03UL << NT_PWM8_TBCTL_CTRMODE_Pos)                   /*!< NT_PWM8 TBCTL: CTRMODE Mask             */
#define NT_PWM8_TBCTL_PHSEN_Pos               2                                                       /*!< NT_PWM8 TBCTL: PHSEN Position           */
#define NT_PWM8_TBCTL_PHSEN_Msk               (0x01UL << NT_PWM8_TBCTL_PHSEN_Pos)                     /*!< NT_PWM8 TBCTL: PHSEN Mask               */
#define NT_PWM8_TBCTL_PRDLD_Pos               3                                                       /*!< NT_PWM8 TBCTL: PRDLD Position           */
#define NT_PWM8_TBCTL_PRDLD_Msk               (0x01UL << NT_PWM8_TBCTL_PRDLD_Pos)                     /*!< NT_PWM8 TBCTL: PRDLD Mask               */
#define NT_PWM8_TBCTL_SYNCOSEL_Pos            4                                                       /*!< NT_PWM8 TBCTL: SYNCOSEL Position        */
#define NT_PWM8_TBCTL_SYNCOSEL_Msk            (0x03UL << NT_PWM8_TBCTL_SYNCOSEL_Pos)                  /*!< NT_PWM8 TBCTL: SYNCOSEL Mask            */
#define NT_PWM8_TBCTL_SWFSYNC_Pos             6                                                       /*!< NT_PWM8 TBCTL: SWFSYNC Position         */
#define NT_PWM8_TBCTL_SWFSYNC_Msk             (0x01UL << NT_PWM8_TBCTL_SWFSYNC_Pos)                   /*!< NT_PWM8 TBCTL: SWFSYNC Mask             */
#define NT_PWM8_TBCTL_HSPCLKDIV_Pos           7                                                       /*!< NT_PWM8 TBCTL: HSPCLKDIV Position       */
#define NT_PWM8_TBCTL_HSPCLKDIV_Msk           (0x07UL << NT_PWM8_TBCTL_HSPCLKDIV_Pos)                 /*!< NT_PWM8 TBCTL: HSPCLKDIV Mask           */
#define NT_PWM8_TBCTL_CLKDIV_Pos              10                                                      /*!< NT_PWM8 TBCTL: CLKDIV Position          */
#define NT_PWM8_TBCTL_CLKDIV_Msk              (0x07UL << NT_PWM8_TBCTL_CLKDIV_Pos)                    /*!< NT_PWM8 TBCTL: CLKDIV Mask              */
#define NT_PWM8_TBCTL_PHSDIR_Pos              13                                                      /*!< NT_PWM8 TBCTL: PHSDIR Position          */
#define NT_PWM8_TBCTL_PHSDIR_Msk              (0x01UL << NT_PWM8_TBCTL_PHSDIR_Pos)                    /*!< NT_PWM8 TBCTL: PHSDIR Mask              */
#define NT_PWM8_TBCTL_FREE_SOFT_Pos           14                                                      /*!< NT_PWM8 TBCTL: FREE_SOFT Position       */
#define NT_PWM8_TBCTL_FREE_SOFT_Msk           (0x03UL << NT_PWM8_TBCTL_FREE_SOFT_Pos)                 /*!< NT_PWM8 TBCTL: FREE_SOFT Mask           */

/* --------------------------------  NT_PWM8_TBSTS  ------------------------------- */
#define NT_PWM8_TBSTS_CTRDIR_Pos              0                                                       /*!< NT_PWM8 TBSTS: CTRDIR Position          */
#define NT_PWM8_TBSTS_CTRDIR_Msk              (0x01UL << NT_PWM8_TBSTS_CTRDIR_Pos)                    /*!< NT_PWM8 TBSTS: CTRDIR Mask              */
#define NT_PWM8_TBSTS_SYNCI_Pos               1                                                       /*!< NT_PWM8 TBSTS: SYNCI Position           */
#define NT_PWM8_TBSTS_SYNCI_Msk               (0x01UL << NT_PWM8_TBSTS_SYNCI_Pos)                     /*!< NT_PWM8 TBSTS: SYNCI Mask               */
#define NT_PWM8_TBSTS_CTRMAX_Pos              2                                                       /*!< NT_PWM8 TBSTS: CTRMAX Position          */
#define NT_PWM8_TBSTS_CTRMAX_Msk              (0x01UL << NT_PWM8_TBSTS_CTRMAX_Pos)                    /*!< NT_PWM8 TBSTS: CTRMAX Mask              */

/* --------------------------------  NT_PWM8_TBPHS  ------------------------------- */
#define NT_PWM8_TBPHS_TBPHSHR_Pos             8                                                       /*!< NT_PWM8 TBPHS: TBPHSHR Position         */
#define NT_PWM8_TBPHS_TBPHSHR_Msk             (0x000000ffUL << NT_PWM8_TBPHS_TBPHSHR_Pos)             /*!< NT_PWM8 TBPHS: TBPHSHR Mask             */
#define NT_PWM8_TBPHS_TBPHS_Pos               16                                                      /*!< NT_PWM8 TBPHS: TBPHS Position           */
#define NT_PWM8_TBPHS_TBPHS_Msk               (0x0000ffffUL << NT_PWM8_TBPHS_TBPHS_Pos)               /*!< NT_PWM8 TBPHS: TBPHS Mask               */

/* --------------------------------  NT_PWM8_TBCTR  ------------------------------- */
#define NT_PWM8_TBCTR_TBCTR_Pos               0                                                       /*!< NT_PWM8 TBCTR: TBCTR Position           */
#define NT_PWM8_TBCTR_TBCTR_Msk               (0x0000ffffUL << NT_PWM8_TBCTR_TBCTR_Pos)               /*!< NT_PWM8 TBCTR: TBCTR Mask               */

/* --------------------------------  NT_PWM8_TBPRD  ------------------------------- */
#define NT_PWM8_TBPRD_TBPRD_Pos               0                                                       /*!< NT_PWM8 TBPRD: TBPRD Position           */
#define NT_PWM8_TBPRD_TBPRD_Msk               (0x0000ffffUL << NT_PWM8_TBPRD_TBPRD_Pos)               /*!< NT_PWM8 TBPRD: TBPRD Mask               */

/* -------------------------------  NT_PWM8_CMPCTL  ------------------------------- */
#define NT_PWM8_CMPCTL_LOADAMODE_Pos          0                                                       /*!< NT_PWM8 CMPCTL: LOADAMODE Position      */
#define NT_PWM8_CMPCTL_LOADAMODE_Msk          (0x03UL << NT_PWM8_CMPCTL_LOADAMODE_Pos)                /*!< NT_PWM8 CMPCTL: LOADAMODE Mask          */
#define NT_PWM8_CMPCTL_LOADBMODE_Pos          2                                                       /*!< NT_PWM8 CMPCTL: LOADBMODE Position      */
#define NT_PWM8_CMPCTL_LOADBMODE_Msk          (0x03UL << NT_PWM8_CMPCTL_LOADBMODE_Pos)                /*!< NT_PWM8 CMPCTL: LOADBMODE Mask          */
#define NT_PWM8_CMPCTL_SHDWAMODE_Pos          4                                                       /*!< NT_PWM8 CMPCTL: SHDWAMODE Position      */
#define NT_PWM8_CMPCTL_SHDWAMODE_Msk          (0x01UL << NT_PWM8_CMPCTL_SHDWAMODE_Pos)                /*!< NT_PWM8 CMPCTL: SHDWAMODE Mask          */
#define NT_PWM8_CMPCTL_SHDWBMODE_Pos          6                                                       /*!< NT_PWM8 CMPCTL: SHDWBMODE Position      */
#define NT_PWM8_CMPCTL_SHDWBMODE_Msk          (0x01UL << NT_PWM8_CMPCTL_SHDWBMODE_Pos)                /*!< NT_PWM8 CMPCTL: SHDWBMODE Mask          */
#define NT_PWM8_CMPCTL_SHDWAFULL_Pos          8                                                       /*!< NT_PWM8 CMPCTL: SHDWAFULL Position      */
#define NT_PWM8_CMPCTL_SHDWAFULL_Msk          (0x01UL << NT_PWM8_CMPCTL_SHDWAFULL_Pos)                /*!< NT_PWM8 CMPCTL: SHDWAFULL Mask          */
#define NT_PWM8_CMPCTL_SHDWBFULL_Pos          9                                                       /*!< NT_PWM8 CMPCTL: SHDWBFULL Position      */
#define NT_PWM8_CMPCTL_SHDWBFULL_Msk          (0x01UL << NT_PWM8_CMPCTL_SHDWBFULL_Pos)                /*!< NT_PWM8 CMPCTL: SHDWBFULL Mask          */

/* --------------------------------  NT_PWM8_CMPA  -------------------------------- */
#define NT_PWM8_CMPA_CMPAHR_Pos               8                                                       /*!< NT_PWM8 CMPA: CMPAHR Position           */
#define NT_PWM8_CMPA_CMPAHR_Msk               (0x000000ffUL << NT_PWM8_CMPA_CMPAHR_Pos)               /*!< NT_PWM8 CMPA: CMPAHR Mask               */
#define NT_PWM8_CMPA_CMPA_Pos                 16                                                      /*!< NT_PWM8 CMPA: CMPA Position             */
#define NT_PWM8_CMPA_CMPA_Msk                 (0x0000ffffUL << NT_PWM8_CMPA_CMPA_Pos)                 /*!< NT_PWM8 CMPA: CMPA Mask                 */

/* --------------------------------  NT_PWM8_CMPB  -------------------------------- */
#define NT_PWM8_CMPB_CMPB_Pos                 16                                                      /*!< NT_PWM8 CMPB: CMPB Position             */
#define NT_PWM8_CMPB_CMPB_Msk                 (0x0000ffffUL << NT_PWM8_CMPB_CMPB_Pos)                 /*!< NT_PWM8 CMPB: CMPB Mask                 */

/* -------------------------------  NT_PWM8_AQCTLA  ------------------------------- */
#define NT_PWM8_AQCTLA_ZRO_Pos                0                                                       /*!< NT_PWM8 AQCTLA: ZRO Position            */
#define NT_PWM8_AQCTLA_ZRO_Msk                (0x03UL << NT_PWM8_AQCTLA_ZRO_Pos)                      /*!< NT_PWM8 AQCTLA: ZRO Mask                */
#define NT_PWM8_AQCTLA_PRD_Pos                2                                                       /*!< NT_PWM8 AQCTLA: PRD Position            */
#define NT_PWM8_AQCTLA_PRD_Msk                (0x03UL << NT_PWM8_AQCTLA_PRD_Pos)                      /*!< NT_PWM8 AQCTLA: PRD Mask                */
#define NT_PWM8_AQCTLA_CAU_Pos                4                                                       /*!< NT_PWM8 AQCTLA: CAU Position            */
#define NT_PWM8_AQCTLA_CAU_Msk                (0x03UL << NT_PWM8_AQCTLA_CAU_Pos)                      /*!< NT_PWM8 AQCTLA: CAU Mask                */
#define NT_PWM8_AQCTLA_CAD_Pos                6                                                       /*!< NT_PWM8 AQCTLA: CAD Position            */
#define NT_PWM8_AQCTLA_CAD_Msk                (0x03UL << NT_PWM8_AQCTLA_CAD_Pos)                      /*!< NT_PWM8 AQCTLA: CAD Mask                */
#define NT_PWM8_AQCTLA_CBU_Pos                8                                                       /*!< NT_PWM8 AQCTLA: CBU Position            */
#define NT_PWM8_AQCTLA_CBU_Msk                (0x03UL << NT_PWM8_AQCTLA_CBU_Pos)                      /*!< NT_PWM8 AQCTLA: CBU Mask                */
#define NT_PWM8_AQCTLA_CBD_Pos                10                                                      /*!< NT_PWM8 AQCTLA: CBD Position            */
#define NT_PWM8_AQCTLA_CBD_Msk                (0x03UL << NT_PWM8_AQCTLA_CBD_Pos)                      /*!< NT_PWM8 AQCTLA: CBD Mask                */

/* -------------------------------  NT_PWM8_AQCTLB  ------------------------------- */
#define NT_PWM8_AQCTLB_ZRO_Pos                0                                                       /*!< NT_PWM8 AQCTLB: ZRO Position            */
#define NT_PWM8_AQCTLB_ZRO_Msk                (0x03UL << NT_PWM8_AQCTLB_ZRO_Pos)                      /*!< NT_PWM8 AQCTLB: ZRO Mask                */
#define NT_PWM8_AQCTLB_PRD_Pos                2                                                       /*!< NT_PWM8 AQCTLB: PRD Position            */
#define NT_PWM8_AQCTLB_PRD_Msk                (0x03UL << NT_PWM8_AQCTLB_PRD_Pos)                      /*!< NT_PWM8 AQCTLB: PRD Mask                */
#define NT_PWM8_AQCTLB_CAU_Pos                4                                                       /*!< NT_PWM8 AQCTLB: CAU Position            */
#define NT_PWM8_AQCTLB_CAU_Msk                (0x03UL << NT_PWM8_AQCTLB_CAU_Pos)                      /*!< NT_PWM8 AQCTLB: CAU Mask                */
#define NT_PWM8_AQCTLB_CAD_Pos                6                                                       /*!< NT_PWM8 AQCTLB: CAD Position            */
#define NT_PWM8_AQCTLB_CAD_Msk                (0x03UL << NT_PWM8_AQCTLB_CAD_Pos)                      /*!< NT_PWM8 AQCTLB: CAD Mask                */
#define NT_PWM8_AQCTLB_CBU_Pos                8                                                       /*!< NT_PWM8 AQCTLB: CBU Position            */
#define NT_PWM8_AQCTLB_CBU_Msk                (0x03UL << NT_PWM8_AQCTLB_CBU_Pos)                      /*!< NT_PWM8 AQCTLB: CBU Mask                */
#define NT_PWM8_AQCTLB_CBD_Pos                10                                                      /*!< NT_PWM8 AQCTLB: CBD Position            */
#define NT_PWM8_AQCTLB_CBD_Msk                (0x03UL << NT_PWM8_AQCTLB_CBD_Pos)                      /*!< NT_PWM8 AQCTLB: CBD Mask                */

/* -------------------------------  NT_PWM8_AQSFRC  ------------------------------- */
#define NT_PWM8_AQSFRC_ACTSFA_Pos             0                                                       /*!< NT_PWM8 AQSFRC: ACTSFA Position         */
#define NT_PWM8_AQSFRC_ACTSFA_Msk             (0x03UL << NT_PWM8_AQSFRC_ACTSFA_Pos)                   /*!< NT_PWM8 AQSFRC: ACTSFA Mask             */
#define NT_PWM8_AQSFRC_OTSFA_Pos              2                                                       /*!< NT_PWM8 AQSFRC: OTSFA Position          */
#define NT_PWM8_AQSFRC_OTSFA_Msk              (0x01UL << NT_PWM8_AQSFRC_OTSFA_Pos)                    /*!< NT_PWM8 AQSFRC: OTSFA Mask              */
#define NT_PWM8_AQSFRC_ACTSFB_Pos             3                                                       /*!< NT_PWM8 AQSFRC: ACTSFB Position         */
#define NT_PWM8_AQSFRC_ACTSFB_Msk             (0x03UL << NT_PWM8_AQSFRC_ACTSFB_Pos)                   /*!< NT_PWM8 AQSFRC: ACTSFB Mask             */
#define NT_PWM8_AQSFRC_OTSFB_Pos              5                                                       /*!< NT_PWM8 AQSFRC: OTSFB Position          */
#define NT_PWM8_AQSFRC_OTSFB_Msk              (0x01UL << NT_PWM8_AQSFRC_OTSFB_Pos)                    /*!< NT_PWM8 AQSFRC: OTSFB Mask              */
#define NT_PWM8_AQSFRC_RLDCSF_Pos             6                                                       /*!< NT_PWM8 AQSFRC: RLDCSF Position         */
#define NT_PWM8_AQSFRC_RLDCSF_Msk             (0x03UL << NT_PWM8_AQSFRC_RLDCSF_Pos)                   /*!< NT_PWM8 AQSFRC: RLDCSF Mask             */

/* -------------------------------  NT_PWM8_AQCSFRC  ------------------------------ */
#define NT_PWM8_AQCSFRC_CSFA_Pos              0                                                       /*!< NT_PWM8 AQCSFRC: CSFA Position          */
#define NT_PWM8_AQCSFRC_CSFA_Msk              (0x03UL << NT_PWM8_AQCSFRC_CSFA_Pos)                    /*!< NT_PWM8 AQCSFRC: CSFA Mask              */
#define NT_PWM8_AQCSFRC_CSFB_Pos              2                                                       /*!< NT_PWM8 AQCSFRC: CSFB Position          */
#define NT_PWM8_AQCSFRC_CSFB_Msk              (0x03UL << NT_PWM8_AQCSFRC_CSFB_Pos)                    /*!< NT_PWM8 AQCSFRC: CSFB Mask              */

/* --------------------------------  NT_PWM8_DBCTL  ------------------------------- */
#define NT_PWM8_DBCTL_OUT_MODE_Pos            0                                                       /*!< NT_PWM8 DBCTL: OUT_MODE Position        */
#define NT_PWM8_DBCTL_OUT_MODE_Msk            (0x03UL << NT_PWM8_DBCTL_OUT_MODE_Pos)                  /*!< NT_PWM8 DBCTL: OUT_MODE Mask            */
#define NT_PWM8_DBCTL_POLSEL_Pos              2                                                       /*!< NT_PWM8 DBCTL: POLSEL Position          */
#define NT_PWM8_DBCTL_POLSEL_Msk              (0x03UL << NT_PWM8_DBCTL_POLSEL_Pos)                    /*!< NT_PWM8 DBCTL: POLSEL Mask              */
#define NT_PWM8_DBCTL_IN_MODE_Pos             4                                                       /*!< NT_PWM8 DBCTL: IN_MODE Position         */
#define NT_PWM8_DBCTL_IN_MODE_Msk             (0x03UL << NT_PWM8_DBCTL_IN_MODE_Pos)                   /*!< NT_PWM8 DBCTL: IN_MODE Mask             */

/* --------------------------------  NT_PWM8_DBRED  ------------------------------- */
#define NT_PWM8_DBRED_DEL_Pos                 0                                                       /*!< NT_PWM8 DBRED: DEL Position             */
#define NT_PWM8_DBRED_DEL_Msk                 (0x000003ffUL << NT_PWM8_DBRED_DEL_Pos)                 /*!< NT_PWM8 DBRED: DEL Mask                 */

/* --------------------------------  NT_PWM8_DBFED  ------------------------------- */
#define NT_PWM8_DBFED_DEL_Pos                 0                                                       /*!< NT_PWM8 DBFED: DEL Position             */
#define NT_PWM8_DBFED_DEL_Msk                 (0x000003ffUL << NT_PWM8_DBFED_DEL_Pos)                 /*!< NT_PWM8 DBFED: DEL Mask                 */

/* --------------------------------  NT_PWM8_TZSEL  ------------------------------- */
#define NT_PWM8_TZSEL_CBC0_Pos                0                                                       /*!< NT_PWM8 TZSEL: CBC0 Position            */
#define NT_PWM8_TZSEL_CBC0_Msk                (0x01UL << NT_PWM8_TZSEL_CBC0_Pos)                      /*!< NT_PWM8 TZSEL: CBC0 Mask                */
#define NT_PWM8_TZSEL_CBC1_Pos                1                                                       /*!< NT_PWM8 TZSEL: CBC1 Position            */
#define NT_PWM8_TZSEL_CBC1_Msk                (0x01UL << NT_PWM8_TZSEL_CBC1_Pos)                      /*!< NT_PWM8 TZSEL: CBC1 Mask                */
#define NT_PWM8_TZSEL_CBC2_Pos                2                                                       /*!< NT_PWM8 TZSEL: CBC2 Position            */
#define NT_PWM8_TZSEL_CBC2_Msk                (0x01UL << NT_PWM8_TZSEL_CBC2_Pos)                      /*!< NT_PWM8 TZSEL: CBC2 Mask                */
#define NT_PWM8_TZSEL_CBC3_Pos                3                                                       /*!< NT_PWM8 TZSEL: CBC3 Position            */
#define NT_PWM8_TZSEL_CBC3_Msk                (0x01UL << NT_PWM8_TZSEL_CBC3_Pos)                      /*!< NT_PWM8 TZSEL: CBC3 Mask                */
#define NT_PWM8_TZSEL_CBC4_Pos                4                                                       /*!< NT_PWM8 TZSEL: CBC4 Position            */
#define NT_PWM8_TZSEL_CBC4_Msk                (0x01UL << NT_PWM8_TZSEL_CBC4_Pos)                      /*!< NT_PWM8 TZSEL: CBC4 Mask                */
#define NT_PWM8_TZSEL_CBC5_Pos                5                                                       /*!< NT_PWM8 TZSEL: CBC5 Position            */
#define NT_PWM8_TZSEL_CBC5_Msk                (0x01UL << NT_PWM8_TZSEL_CBC5_Pos)                      /*!< NT_PWM8 TZSEL: CBC5 Mask                */
#define NT_PWM8_TZSEL_OSHT0_Pos               8                                                       /*!< NT_PWM8 TZSEL: OSHT0 Position           */
#define NT_PWM8_TZSEL_OSHT0_Msk               (0x01UL << NT_PWM8_TZSEL_OSHT0_Pos)                     /*!< NT_PWM8 TZSEL: OSHT0 Mask               */
#define NT_PWM8_TZSEL_OSHT1_Pos               9                                                       /*!< NT_PWM8 TZSEL: OSHT1 Position           */
#define NT_PWM8_TZSEL_OSHT1_Msk               (0x01UL << NT_PWM8_TZSEL_OSHT1_Pos)                     /*!< NT_PWM8 TZSEL: OSHT1 Mask               */
#define NT_PWM8_TZSEL_OSHT2_Pos               10                                                      /*!< NT_PWM8 TZSEL: OSHT2 Position           */
#define NT_PWM8_TZSEL_OSHT2_Msk               (0x01UL << NT_PWM8_TZSEL_OSHT2_Pos)                     /*!< NT_PWM8 TZSEL: OSHT2 Mask               */
#define NT_PWM8_TZSEL_OSHT3_Pos               11                                                      /*!< NT_PWM8 TZSEL: OSHT3 Position           */
#define NT_PWM8_TZSEL_OSHT3_Msk               (0x01UL << NT_PWM8_TZSEL_OSHT3_Pos)                     /*!< NT_PWM8 TZSEL: OSHT3 Mask               */
#define NT_PWM8_TZSEL_OSHT4_Pos               12                                                      /*!< NT_PWM8 TZSEL: OSHT4 Position           */
#define NT_PWM8_TZSEL_OSHT4_Msk               (0x01UL << NT_PWM8_TZSEL_OSHT4_Pos)                     /*!< NT_PWM8 TZSEL: OSHT4 Mask               */
#define NT_PWM8_TZSEL_OSHT5_Pos               13                                                      /*!< NT_PWM8 TZSEL: OSHT5 Position           */
#define NT_PWM8_TZSEL_OSHT5_Msk               (0x01UL << NT_PWM8_TZSEL_OSHT5_Pos)                     /*!< NT_PWM8 TZSEL: OSHT5 Mask               */

/* --------------------------------  NT_PWM8_TZCTL  ------------------------------- */
#define NT_PWM8_TZCTL_TZA_Pos                 0                                                       /*!< NT_PWM8 TZCTL: TZA Position             */
#define NT_PWM8_TZCTL_TZA_Msk                 (0x03UL << NT_PWM8_TZCTL_TZA_Pos)                       /*!< NT_PWM8 TZCTL: TZA Mask                 */
#define NT_PWM8_TZCTL_TZB_Pos                 2                                                       /*!< NT_PWM8 TZCTL: TZB Position             */
#define NT_PWM8_TZCTL_TZB_Msk                 (0x03UL << NT_PWM8_TZCTL_TZB_Pos)                       /*!< NT_PWM8 TZCTL: TZB Mask                 */

/* -------------------------------  NT_PWM8_TZEINT  ------------------------------- */
#define NT_PWM8_TZEINT_CBC_Pos                1                                                       /*!< NT_PWM8 TZEINT: CBC Position            */
#define NT_PWM8_TZEINT_CBC_Msk                (0x01UL << NT_PWM8_TZEINT_CBC_Pos)                      /*!< NT_PWM8 TZEINT: CBC Mask                */
#define NT_PWM8_TZEINT_OST_Pos                2                                                       /*!< NT_PWM8 TZEINT: OST Position            */
#define NT_PWM8_TZEINT_OST_Msk                (0x01UL << NT_PWM8_TZEINT_OST_Pos)                      /*!< NT_PWM8 TZEINT: OST Mask                */

/* --------------------------------  NT_PWM8_TZFLG  ------------------------------- */
#define NT_PWM8_TZFLG_INT_Pos                 0                                                       /*!< NT_PWM8 TZFLG: INT Position             */
#define NT_PWM8_TZFLG_INT_Msk                 (0x01UL << NT_PWM8_TZFLG_INT_Pos)                       /*!< NT_PWM8 TZFLG: INT Mask                 */
#define NT_PWM8_TZFLG_CBC_Pos                 1                                                       /*!< NT_PWM8 TZFLG: CBC Position             */
#define NT_PWM8_TZFLG_CBC_Msk                 (0x01UL << NT_PWM8_TZFLG_CBC_Pos)                       /*!< NT_PWM8 TZFLG: CBC Mask                 */
#define NT_PWM8_TZFLG_OST_Pos                 2                                                       /*!< NT_PWM8 TZFLG: OST Position             */
#define NT_PWM8_TZFLG_OST_Msk                 (0x01UL << NT_PWM8_TZFLG_OST_Pos)                       /*!< NT_PWM8 TZFLG: OST Mask                 */

/* --------------------------------  NT_PWM8_TZCLR  ------------------------------- */
#define NT_PWM8_TZCLR_INT_Pos                 0                                                       /*!< NT_PWM8 TZCLR: INT Position             */
#define NT_PWM8_TZCLR_INT_Msk                 (0x01UL << NT_PWM8_TZCLR_INT_Pos)                       /*!< NT_PWM8 TZCLR: INT Mask                 */
#define NT_PWM8_TZCLR_CBC_Pos                 1                                                       /*!< NT_PWM8 TZCLR: CBC Position             */
#define NT_PWM8_TZCLR_CBC_Msk                 (0x01UL << NT_PWM8_TZCLR_CBC_Pos)                       /*!< NT_PWM8 TZCLR: CBC Mask                 */
#define NT_PWM8_TZCLR_OST_Pos                 2                                                       /*!< NT_PWM8 TZCLR: OST Position             */
#define NT_PWM8_TZCLR_OST_Msk                 (0x01UL << NT_PWM8_TZCLR_OST_Pos)                       /*!< NT_PWM8 TZCLR: OST Mask                 */

/* --------------------------------  NT_PWM8_TZFRC  ------------------------------- */
#define NT_PWM8_TZFRC_CBC_Pos                 1                                                       /*!< NT_PWM8 TZFRC: CBC Position             */
#define NT_PWM8_TZFRC_CBC_Msk                 (0x01UL << NT_PWM8_TZFRC_CBC_Pos)                       /*!< NT_PWM8 TZFRC: CBC Mask                 */
#define NT_PWM8_TZFRC_OST_Pos                 2                                                       /*!< NT_PWM8 TZFRC: OST Position             */
#define NT_PWM8_TZFRC_OST_Msk                 (0x01UL << NT_PWM8_TZFRC_OST_Pos)                       /*!< NT_PWM8 TZFRC: OST Mask                 */

/* --------------------------------  NT_PWM8_ETSEL  ------------------------------- */
#define NT_PWM8_ETSEL_INTSEL_Pos              0                                                       /*!< NT_PWM8 ETSEL: INTSEL Position          */
#define NT_PWM8_ETSEL_INTSEL_Msk              (0x07UL << NT_PWM8_ETSEL_INTSEL_Pos)                    /*!< NT_PWM8 ETSEL: INTSEL Mask              */
#define NT_PWM8_ETSEL_INTEN_Pos               3                                                       /*!< NT_PWM8 ETSEL: INTEN Position           */
#define NT_PWM8_ETSEL_INTEN_Msk               (0x01UL << NT_PWM8_ETSEL_INTEN_Pos)                     /*!< NT_PWM8 ETSEL: INTEN Mask               */
#define NT_PWM8_ETSEL_SOCASEL_Pos             8                                                       /*!< NT_PWM8 ETSEL: SOCASEL Position         */
#define NT_PWM8_ETSEL_SOCASEL_Msk             (0x07UL << NT_PWM8_ETSEL_SOCASEL_Pos)                   /*!< NT_PWM8 ETSEL: SOCASEL Mask             */
#define NT_PWM8_ETSEL_SOCAEN_Pos              11                                                      /*!< NT_PWM8 ETSEL: SOCAEN Position          */
#define NT_PWM8_ETSEL_SOCAEN_Msk              (0x01UL << NT_PWM8_ETSEL_SOCAEN_Pos)                    /*!< NT_PWM8 ETSEL: SOCAEN Mask              */
#define NT_PWM8_ETSEL_SOCBSEL_Pos             12                                                      /*!< NT_PWM8 ETSEL: SOCBSEL Position         */
#define NT_PWM8_ETSEL_SOCBSEL_Msk             (0x07UL << NT_PWM8_ETSEL_SOCBSEL_Pos)                   /*!< NT_PWM8 ETSEL: SOCBSEL Mask             */
#define NT_PWM8_ETSEL_SOCBEN_Pos              15                                                      /*!< NT_PWM8 ETSEL: SOCBEN Position          */
#define NT_PWM8_ETSEL_SOCBEN_Msk              (0x01UL << NT_PWM8_ETSEL_SOCBEN_Pos)                    /*!< NT_PWM8 ETSEL: SOCBEN Mask              */

/* --------------------------------  NT_PWM8_ETPS  -------------------------------- */
#define NT_PWM8_ETPS_INTPRD_Pos               0                                                       /*!< NT_PWM8 ETPS: INTPRD Position           */
#define NT_PWM8_ETPS_INTPRD_Msk               (0x03UL << NT_PWM8_ETPS_INTPRD_Pos)                     /*!< NT_PWM8 ETPS: INTPRD Mask               */
#define NT_PWM8_ETPS_INTCNT_Pos               2                                                       /*!< NT_PWM8 ETPS: INTCNT Position           */
#define NT_PWM8_ETPS_INTCNT_Msk               (0x03UL << NT_PWM8_ETPS_INTCNT_Pos)                     /*!< NT_PWM8 ETPS: INTCNT Mask               */
#define NT_PWM8_ETPS_SOCAPRD_Pos              8                                                       /*!< NT_PWM8 ETPS: SOCAPRD Position          */
#define NT_PWM8_ETPS_SOCAPRD_Msk              (0x03UL << NT_PWM8_ETPS_SOCAPRD_Pos)                    /*!< NT_PWM8 ETPS: SOCAPRD Mask              */
#define NT_PWM8_ETPS_SOCACNT_Pos              10                                                      /*!< NT_PWM8 ETPS: SOCACNT Position          */
#define NT_PWM8_ETPS_SOCACNT_Msk              (0x03UL << NT_PWM8_ETPS_SOCACNT_Pos)                    /*!< NT_PWM8 ETPS: SOCACNT Mask              */
#define NT_PWM8_ETPS_SOCPRD_Pos               12                                                      /*!< NT_PWM8 ETPS: SOCPRD Position           */
#define NT_PWM8_ETPS_SOCPRD_Msk               (0x03UL << NT_PWM8_ETPS_SOCPRD_Pos)                     /*!< NT_PWM8 ETPS: SOCPRD Mask               */
#define NT_PWM8_ETPS_SOCBCNT_Pos              14                                                      /*!< NT_PWM8 ETPS: SOCBCNT Position          */
#define NT_PWM8_ETPS_SOCBCNT_Msk              (0x03UL << NT_PWM8_ETPS_SOCBCNT_Pos)                    /*!< NT_PWM8 ETPS: SOCBCNT Mask              */

/* --------------------------------  NT_PWM8_ETFLG  ------------------------------- */
#define NT_PWM8_ETFLG_INT_Pos                 0                                                       /*!< NT_PWM8 ETFLG: INT Position             */
#define NT_PWM8_ETFLG_INT_Msk                 (0x01UL << NT_PWM8_ETFLG_INT_Pos)                       /*!< NT_PWM8 ETFLG: INT Mask                 */
#define NT_PWM8_ETFLG_SOCA_Pos                2                                                       /*!< NT_PWM8 ETFLG: SOCA Position            */
#define NT_PWM8_ETFLG_SOCA_Msk                (0x01UL << NT_PWM8_ETFLG_SOCA_Pos)                      /*!< NT_PWM8 ETFLG: SOCA Mask                */
#define NT_PWM8_ETFLG_SOCB_Pos                3                                                       /*!< NT_PWM8 ETFLG: SOCB Position            */
#define NT_PWM8_ETFLG_SOCB_Msk                (0x01UL << NT_PWM8_ETFLG_SOCB_Pos)                      /*!< NT_PWM8 ETFLG: SOCB Mask                */

/* --------------------------------  NT_PWM8_ETCLR  ------------------------------- */
#define NT_PWM8_ETCLR_INT_Pos                 0                                                       /*!< NT_PWM8 ETCLR: INT Position             */
#define NT_PWM8_ETCLR_INT_Msk                 (0x01UL << NT_PWM8_ETCLR_INT_Pos)                       /*!< NT_PWM8 ETCLR: INT Mask                 */
#define NT_PWM8_ETCLR_SOCA_Pos                2                                                       /*!< NT_PWM8 ETCLR: SOCA Position            */
#define NT_PWM8_ETCLR_SOCA_Msk                (0x01UL << NT_PWM8_ETCLR_SOCA_Pos)                      /*!< NT_PWM8 ETCLR: SOCA Mask                */
#define NT_PWM8_ETCLR_SOCB_Pos                3                                                       /*!< NT_PWM8 ETCLR: SOCB Position            */
#define NT_PWM8_ETCLR_SOCB_Msk                (0x01UL << NT_PWM8_ETCLR_SOCB_Pos)                      /*!< NT_PWM8 ETCLR: SOCB Mask                */

/* --------------------------------  NT_PWM8_ETFRC  ------------------------------- */
#define NT_PWM8_ETFRC_INT_Pos                 0                                                       /*!< NT_PWM8 ETFRC: INT Position             */
#define NT_PWM8_ETFRC_INT_Msk                 (0x01UL << NT_PWM8_ETFRC_INT_Pos)                       /*!< NT_PWM8 ETFRC: INT Mask                 */
#define NT_PWM8_ETFRC_SOCA_Pos                2                                                       /*!< NT_PWM8 ETFRC: SOCA Position            */
#define NT_PWM8_ETFRC_SOCA_Msk                (0x01UL << NT_PWM8_ETFRC_SOCA_Pos)                      /*!< NT_PWM8 ETFRC: SOCA Mask                */
#define NT_PWM8_ETFRC_SOCB_Pos                3                                                       /*!< NT_PWM8 ETFRC: SOCB Position            */
#define NT_PWM8_ETFRC_SOCB_Msk                (0x01UL << NT_PWM8_ETFRC_SOCB_Pos)                      /*!< NT_PWM8 ETFRC: SOCB Mask                */

/* --------------------------------  NT_PWM8_PCCTL  ------------------------------- */
#define NT_PWM8_PCCTL_CHPEN_Pos               0                                                       /*!< NT_PWM8 PCCTL: CHPEN Position           */
#define NT_PWM8_PCCTL_CHPEN_Msk               (0x01UL << NT_PWM8_PCCTL_CHPEN_Pos)                     /*!< NT_PWM8 PCCTL: CHPEN Mask               */
#define NT_PWM8_PCCTL_OSHTWTH_Pos             1                                                       /*!< NT_PWM8 PCCTL: OSHTWTH Position         */
#define NT_PWM8_PCCTL_OSHTWTH_Msk             (0x0fUL << NT_PWM8_PCCTL_OSHTWTH_Pos)                   /*!< NT_PWM8 PCCTL: OSHTWTH Mask             */
#define NT_PWM8_PCCTL_SHRFREQ_Pos             5                                                       /*!< NT_PWM8 PCCTL: SHRFREQ Position         */
#define NT_PWM8_PCCTL_SHRFREQ_Msk             (0x07UL << NT_PWM8_PCCTL_SHRFREQ_Pos)                   /*!< NT_PWM8 PCCTL: SHRFREQ Mask             */
#define NT_PWM8_PCCTL_CHPDUTY_Pos             8                                                       /*!< NT_PWM8 PCCTL: CHPDUTY Position         */
#define NT_PWM8_PCCTL_CHPDUTY_Msk             (0x07UL << NT_PWM8_PCCTL_CHPDUTY_Pos)                   /*!< NT_PWM8 PCCTL: CHPDUTY Mask             */

/* -------------------------------  NT_PWM8_HRCNFG  ------------------------------- */
#define NT_PWM8_HRCNFG_EDGMODE_Pos            0                                                       /*!< NT_PWM8 HRCNFG: EDGMODE Position        */
#define NT_PWM8_HRCNFG_EDGMODE_Msk            (0x03UL << NT_PWM8_HRCNFG_EDGMODE_Pos)                  /*!< NT_PWM8 HRCNFG: EDGMODE Mask            */
#define NT_PWM8_HRCNFG_CTLMODE_Pos            2                                                       /*!< NT_PWM8 HRCNFG: CTLMODE Position        */
#define NT_PWM8_HRCNFG_CTLMODE_Msk            (0x01UL << NT_PWM8_HRCNFG_CTLMODE_Pos)                  /*!< NT_PWM8 HRCNFG: CTLMODE Mask            */
#define NT_PWM8_HRCNFG_HR_LOAD_Pos            3                                                       /*!< NT_PWM8 HRCNFG: HR_LOAD Position        */
#define NT_PWM8_HRCNFG_HR_LOAD_Msk            (0x01UL << NT_PWM8_HRCNFG_HR_LOAD_Pos)                  /*!< NT_PWM8 HRCNFG: HR_LOAD Mask            */
#define NT_PWM8_HRCNFG_MEP_SCALEFACTOR_Pos    16                                                      /*!< NT_PWM8 HRCNFG: MEP_SCALEFACTOR Position */
#define NT_PWM8_HRCNFG_MEP_SCALEFACTOR_Msk    (0x000000ffUL << NT_PWM8_HRCNFG_MEP_SCALEFACTOR_Pos)    /*!< NT_PWM8 HRCNFG: MEP_SCALEFACTOR Mask    */

/* --------------------------------  NT_PWM8_FWDTH  ------------------------------- */
#define NT_PWM8_FWDTH_FWDTH_Pos               0                                                       /*!< NT_PWM8 FWDTH: FWDTH Position           */
#define NT_PWM8_FWDTH_FWDTH_Msk               (0x000000ffUL << NT_PWM8_FWDTH_FWDTH_Pos)               /*!< NT_PWM8 FWDTH: FWDTH Mask               */

/* --------------------------------  NT_PWM8_HDSEL  ------------------------------- */
#define NT_PWM8_HDSEL_DCMP_Pos                0                                                       /*!< NT_PWM8 HDSEL: DCMP Position            */
#define NT_PWM8_HDSEL_DCMP_Msk                (0x00ffffffUL << NT_PWM8_HDSEL_DCMP_Pos)                /*!< NT_PWM8 HDSEL: DCMP Mask                */
#define NT_PWM8_HDSEL_ACMP_Pos                24                                                      /*!< NT_PWM8 HDSEL: ACMP Position            */
#define NT_PWM8_HDSEL_ACMP_Msk                (0x07UL << NT_PWM8_HDSEL_ACMP_Pos)                      /*!< NT_PWM8 HDSEL: ACMP Mask                */

/* --------------------------------  NT_PWM8_HDCTL  ------------------------------- */
#define NT_PWM8_HDCTL_HDA_Pos                 0                                                       /*!< NT_PWM8 HDCTL: HDA Position             */
#define NT_PWM8_HDCTL_HDA_Msk                 (0x03UL << NT_PWM8_HDCTL_HDA_Pos)                       /*!< NT_PWM8 HDCTL: HDA Mask                 */
#define NT_PWM8_HDCTL_HDB_Pos                 2                                                       /*!< NT_PWM8 HDCTL: HDB Position             */
#define NT_PWM8_HDCTL_HDB_Msk                 (0x03UL << NT_PWM8_HDCTL_HDB_Pos)                       /*!< NT_PWM8 HDCTL: HDB Mask                 */

/* -------------------------------  NT_PWM8_HDEINT  ------------------------------- */
#define NT_PWM8_HDEINT_CBC_Pos                1                                                       /*!< NT_PWM8 HDEINT: CBC Position            */
#define NT_PWM8_HDEINT_CBC_Msk                (0x01UL << NT_PWM8_HDEINT_CBC_Pos)                      /*!< NT_PWM8 HDEINT: CBC Mask                */
#define NT_PWM8_HDEINT_OST_Pos                2                                                       /*!< NT_PWM8 HDEINT: OST Position            */
#define NT_PWM8_HDEINT_OST_Msk                (0x01UL << NT_PWM8_HDEINT_OST_Pos)                      /*!< NT_PWM8 HDEINT: OST Mask                */

/* --------------------------------  NT_PWM8_HDFLG  ------------------------------- */
#define NT_PWM8_HDFLG_HDINT_Pos               0                                                       /*!< NT_PWM8 HDFLG: HDINT Position           */
#define NT_PWM8_HDFLG_HDINT_Msk               (0x01UL << NT_PWM8_HDFLG_HDINT_Pos)                     /*!< NT_PWM8 HDFLG: HDINT Mask               */
#define NT_PWM8_HDFLG_CBC_Pos                 1                                                       /*!< NT_PWM8 HDFLG: CBC Position             */
#define NT_PWM8_HDFLG_CBC_Msk                 (0x01UL << NT_PWM8_HDFLG_CBC_Pos)                       /*!< NT_PWM8 HDFLG: CBC Mask                 */
#define NT_PWM8_HDFLG_OST_Pos                 2                                                       /*!< NT_PWM8 HDFLG: OST Position             */
#define NT_PWM8_HDFLG_OST_Msk                 (0x01UL << NT_PWM8_HDFLG_OST_Pos)                       /*!< NT_PWM8 HDFLG: OST Mask                 */

/* --------------------------------  NT_PWM8_HDCLR  ------------------------------- */
#define NT_PWM8_HDCLR_HDINT_Pos               0                                                       /*!< NT_PWM8 HDCLR: HDINT Position           */
#define NT_PWM8_HDCLR_HDINT_Msk               (0x01UL << NT_PWM8_HDCLR_HDINT_Pos)                     /*!< NT_PWM8 HDCLR: HDINT Mask               */

/* --------------------------------  NT_PWM8_HDFRC  ------------------------------- */
#define NT_PWM8_HDFRC_CBC_Pos                 1                                                       /*!< NT_PWM8 HDFRC: CBC Position             */
#define NT_PWM8_HDFRC_CBC_Msk                 (0x01UL << NT_PWM8_HDFRC_CBC_Pos)                       /*!< NT_PWM8 HDFRC: CBC Mask                 */
#define NT_PWM8_HDFRC_OST_Pos                 2                                                       /*!< NT_PWM8 HDFRC: OST Position             */
#define NT_PWM8_HDFRC_OST_Msk                 (0x01UL << NT_PWM8_HDFRC_OST_Pos)                       /*!< NT_PWM8 HDFRC: OST Mask                 */

/* ------------------------------  NT_PWM8_HDINTCLR  ------------------------------ */
#define NT_PWM8_HDINTCLR_HDINT_Pos            0                                                       /*!< NT_PWM8 HDINTCLR: HDINT Position        */
#define NT_PWM8_HDINTCLR_HDINT_Msk            (0x01UL << NT_PWM8_HDINTCLR_HDINT_Pos)                  /*!< NT_PWM8 HDINTCLR: HDINT Mask            */

/* ------------------------------  NT_PWM8_TZINTCLR  ------------------------------ */
#define NT_PWM8_TZINTCLR_TZINT_Pos            0                                                       /*!< NT_PWM8 TZINTCLR: TZINT Position        */
#define NT_PWM8_TZINTCLR_TZINT_Msk            (0x01UL << NT_PWM8_TZINTCLR_TZINT_Pos)                  /*!< NT_PWM8 TZINTCLR: TZINT Mask            */

/* -------------------------------  NT_PWM8_INTCLR  ------------------------------- */
#define NT_PWM8_INTCLR_INT_Pos                0                                                       /*!< NT_PWM8 INTCLR: INT Position            */
#define NT_PWM8_INTCLR_INT_Msk                (0x01UL << NT_PWM8_INTCLR_INT_Pos)                      /*!< NT_PWM8 INTCLR: INT Mask                */


/* ================================================================================ */
/* ================        struct 'NT_CAP0' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_CAP0_TSCTR  ------------------------------- */
#define NT_CAP0_TSCTR_VALUE_Pos               0                                                       /*!< NT_CAP0 TSCTR: VALUE Position           */
#define NT_CAP0_TSCTR_VALUE_Msk               (0xffffffffUL << NT_CAP0_TSCTR_VALUE_Pos)               /*!< NT_CAP0 TSCTR: VALUE Mask               */

/* -------------------------------  NT_CAP0_CTRPHS  ------------------------------- */
#define NT_CAP0_CTRPHS_VALUE_Pos              0                                                       /*!< NT_CAP0 CTRPHS: VALUE Position          */
#define NT_CAP0_CTRPHS_VALUE_Msk              (0xffffffffUL << NT_CAP0_CTRPHS_VALUE_Pos)              /*!< NT_CAP0 CTRPHS: VALUE Mask              */

/* --------------------------------  NT_CAP0_CAP0  -------------------------------- */
#define NT_CAP0_CAP0_VALUE_Pos                0                                                       /*!< NT_CAP0 CAP0: VALUE Position            */
#define NT_CAP0_CAP0_VALUE_Msk                (0xffffffffUL << NT_CAP0_CAP0_VALUE_Pos)                /*!< NT_CAP0 CAP0: VALUE Mask                */

/* --------------------------------  NT_CAP0_CAP1  -------------------------------- */
#define NT_CAP0_CAP1_VALUE_Pos                0                                                       /*!< NT_CAP0 CAP1: VALUE Position            */
#define NT_CAP0_CAP1_VALUE_Msk                (0xffffffffUL << NT_CAP0_CAP1_VALUE_Pos)                /*!< NT_CAP0 CAP1: VALUE Mask                */

/* --------------------------------  NT_CAP0_CAP2  -------------------------------- */
#define NT_CAP0_CAP2_VALUE_Pos                0                                                       /*!< NT_CAP0 CAP2: VALUE Position            */
#define NT_CAP0_CAP2_VALUE_Msk                (0xffffffffUL << NT_CAP0_CAP2_VALUE_Pos)                /*!< NT_CAP0 CAP2: VALUE Mask                */

/* --------------------------------  NT_CAP0_CAP3  -------------------------------- */
#define NT_CAP0_CAP3_VALUE_Pos                0                                                       /*!< NT_CAP0 CAP3: VALUE Position            */
#define NT_CAP0_CAP3_VALUE_Msk                (0xffffffffUL << NT_CAP0_CAP3_VALUE_Pos)                /*!< NT_CAP0 CAP3: VALUE Mask                */

/* -------------------------------  NT_CAP0_ECCTL0  ------------------------------- */
#define NT_CAP0_ECCTL0_CAP0_POL_Pos           0                                                       /*!< NT_CAP0 ECCTL0: CAP0_POL Position       */
#define NT_CAP0_ECCTL0_CAP0_POL_Msk           (0x01UL << NT_CAP0_ECCTL0_CAP0_POL_Pos)                 /*!< NT_CAP0 ECCTL0: CAP0_POL Mask           */
#define NT_CAP0_ECCTL0_CTR_RST0_Pos           1                                                       /*!< NT_CAP0 ECCTL0: CTR_RST0 Position       */
#define NT_CAP0_ECCTL0_CTR_RST0_Msk           (0x01UL << NT_CAP0_ECCTL0_CTR_RST0_Pos)                 /*!< NT_CAP0 ECCTL0: CTR_RST0 Mask           */
#define NT_CAP0_ECCTL0_CAP1_POL_Pos           2                                                       /*!< NT_CAP0 ECCTL0: CAP1_POL Position       */
#define NT_CAP0_ECCTL0_CAP1_POL_Msk           (0x01UL << NT_CAP0_ECCTL0_CAP1_POL_Pos)                 /*!< NT_CAP0 ECCTL0: CAP1_POL Mask           */
#define NT_CAP0_ECCTL0_CTR_RST1_Pos           3                                                       /*!< NT_CAP0 ECCTL0: CTR_RST1 Position       */
#define NT_CAP0_ECCTL0_CTR_RST1_Msk           (0x01UL << NT_CAP0_ECCTL0_CTR_RST1_Pos)                 /*!< NT_CAP0 ECCTL0: CTR_RST1 Mask           */
#define NT_CAP0_ECCTL0_CAP2_POL_Pos           4                                                       /*!< NT_CAP0 ECCTL0: CAP2_POL Position       */
#define NT_CAP0_ECCTL0_CAP2_POL_Msk           (0x01UL << NT_CAP0_ECCTL0_CAP2_POL_Pos)                 /*!< NT_CAP0 ECCTL0: CAP2_POL Mask           */
#define NT_CAP0_ECCTL0_CTR_RST2_Pos           5                                                       /*!< NT_CAP0 ECCTL0: CTR_RST2 Position       */
#define NT_CAP0_ECCTL0_CTR_RST2_Msk           (0x01UL << NT_CAP0_ECCTL0_CTR_RST2_Pos)                 /*!< NT_CAP0 ECCTL0: CTR_RST2 Mask           */
#define NT_CAP0_ECCTL0_CAP3_POL_Pos           6                                                       /*!< NT_CAP0 ECCTL0: CAP3_POL Position       */
#define NT_CAP0_ECCTL0_CAP3_POL_Msk           (0x01UL << NT_CAP0_ECCTL0_CAP3_POL_Pos)                 /*!< NT_CAP0 ECCTL0: CAP3_POL Mask           */
#define NT_CAP0_ECCTL0_CTR_RST3_Pos           7                                                       /*!< NT_CAP0 ECCTL0: CTR_RST3 Position       */
#define NT_CAP0_ECCTL0_CTR_RST3_Msk           (0x01UL << NT_CAP0_ECCTL0_CTR_RST3_Pos)                 /*!< NT_CAP0 ECCTL0: CTR_RST3 Mask           */
#define NT_CAP0_ECCTL0_CAPLDEN_Pos            8                                                       /*!< NT_CAP0 ECCTL0: CAPLDEN Position        */
#define NT_CAP0_ECCTL0_CAPLDEN_Msk            (0x01UL << NT_CAP0_ECCTL0_CAPLDEN_Pos)                  /*!< NT_CAP0 ECCTL0: CAPLDEN Mask            */
#define NT_CAP0_ECCTL0_PRESCALE_Pos           9                                                       /*!< NT_CAP0 ECCTL0: PRESCALE Position       */
#define NT_CAP0_ECCTL0_PRESCALE_Msk           (0x1fUL << NT_CAP0_ECCTL0_PRESCALE_Pos)                 /*!< NT_CAP0 ECCTL0: PRESCALE Mask           */
#define NT_CAP0_ECCTL0_FREE_SOFT_Pos          14                                                      /*!< NT_CAP0 ECCTL0: FREE_SOFT Position      */
#define NT_CAP0_ECCTL0_FREE_SOFT_Msk          (0x03UL << NT_CAP0_ECCTL0_FREE_SOFT_Pos)                /*!< NT_CAP0 ECCTL0: FREE_SOFT Mask          */

/* -------------------------------  NT_CAP0_ECCTL1  ------------------------------- */
#define NT_CAP0_ECCTL1_SWSYNC_Pos             0                                                       /*!< NT_CAP0 ECCTL1: SWSYNC Position         */
#define NT_CAP0_ECCTL1_SWSYNC_Msk             (0x01UL << NT_CAP0_ECCTL1_SWSYNC_Pos)                   /*!< NT_CAP0 ECCTL1: SWSYNC Mask             */
#define NT_CAP0_ECCTL1_CAP_APWM_Pos           1                                                       /*!< NT_CAP0 ECCTL1: CAP_APWM Position       */
#define NT_CAP0_ECCTL1_CAP_APWM_Msk           (0x01UL << NT_CAP0_ECCTL1_CAP_APWM_Pos)                 /*!< NT_CAP0 ECCTL1: CAP_APWM Mask           */
#define NT_CAP0_ECCTL1_APWM_POL_Pos           2                                                       /*!< NT_CAP0 ECCTL1: APWM_POL Position       */
#define NT_CAP0_ECCTL1_APWM_POL_Msk           (0x01UL << NT_CAP0_ECCTL1_APWM_POL_Pos)                 /*!< NT_CAP0 ECCTL1: APWM_POL Mask           */
#define NT_CAP0_ECCTL1_CONT_ONESHT_Pos        8                                                       /*!< NT_CAP0 ECCTL1: CONT_ONESHT Position    */
#define NT_CAP0_ECCTL1_CONT_ONESHT_Msk        (0x01UL << NT_CAP0_ECCTL1_CONT_ONESHT_Pos)              /*!< NT_CAP0 ECCTL1: CONT_ONESHT Mask        */
#define NT_CAP0_ECCTL1_STOP_WRAP_Pos          9                                                       /*!< NT_CAP0 ECCTL1: STOP_WRAP Position      */
#define NT_CAP0_ECCTL1_STOP_WRAP_Msk          (0x03UL << NT_CAP0_ECCTL1_STOP_WRAP_Pos)                /*!< NT_CAP0 ECCTL1: STOP_WRAP Mask          */
#define NT_CAP0_ECCTL1_REARM_Pos              11                                                      /*!< NT_CAP0 ECCTL1: REARM Position          */
#define NT_CAP0_ECCTL1_REARM_Msk              (0x01UL << NT_CAP0_ECCTL1_REARM_Pos)                    /*!< NT_CAP0 ECCTL1: REARM Mask              */
#define NT_CAP0_ECCTL1_TSCTRSTOP_Pos          12                                                      /*!< NT_CAP0 ECCTL1: TSCTRSTOP Position      */
#define NT_CAP0_ECCTL1_TSCTRSTOP_Msk          (0x01UL << NT_CAP0_ECCTL1_TSCTRSTOP_Pos)                /*!< NT_CAP0 ECCTL1: TSCTRSTOP Mask          */
#define NT_CAP0_ECCTL1_SYNCI_EN_Pos           13                                                      /*!< NT_CAP0 ECCTL1: SYNCI_EN Position       */
#define NT_CAP0_ECCTL1_SYNCI_EN_Msk           (0x01UL << NT_CAP0_ECCTL1_SYNCI_EN_Pos)                 /*!< NT_CAP0 ECCTL1: SYNCI_EN Mask           */
#define NT_CAP0_ECCTL1_SYNCO_SEL_Pos          14                                                      /*!< NT_CAP0 ECCTL1: SYNCO_SEL Position      */
#define NT_CAP0_ECCTL1_SYNCO_SEL_Msk          (0x03UL << NT_CAP0_ECCTL1_SYNCO_SEL_Pos)                /*!< NT_CAP0 ECCTL1: SYNCO_SEL Mask          */

/* -------------------------------  NT_CAP0_ECEINT  ------------------------------- */
#define NT_CAP0_ECEINT_CEVT0_Pos              1                                                       /*!< NT_CAP0 ECEINT: CEVT0 Position          */
#define NT_CAP0_ECEINT_CEVT0_Msk              (0x01UL << NT_CAP0_ECEINT_CEVT0_Pos)                    /*!< NT_CAP0 ECEINT: CEVT0 Mask              */
#define NT_CAP0_ECEINT_CEVT1_Pos              2                                                       /*!< NT_CAP0 ECEINT: CEVT1 Position          */
#define NT_CAP0_ECEINT_CEVT1_Msk              (0x01UL << NT_CAP0_ECEINT_CEVT1_Pos)                    /*!< NT_CAP0 ECEINT: CEVT1 Mask              */
#define NT_CAP0_ECEINT_CEVT2_Pos              3                                                       /*!< NT_CAP0 ECEINT: CEVT2 Position          */
#define NT_CAP0_ECEINT_CEVT2_Msk              (0x01UL << NT_CAP0_ECEINT_CEVT2_Pos)                    /*!< NT_CAP0 ECEINT: CEVT2 Mask              */
#define NT_CAP0_ECEINT_CEVT3_Pos              4                                                       /*!< NT_CAP0 ECEINT: CEVT3 Position          */
#define NT_CAP0_ECEINT_CEVT3_Msk              (0x01UL << NT_CAP0_ECEINT_CEVT3_Pos)                    /*!< NT_CAP0 ECEINT: CEVT3 Mask              */
#define NT_CAP0_ECEINT_CTR_OVF_Pos            5                                                       /*!< NT_CAP0 ECEINT: CTR_OVF Position        */
#define NT_CAP0_ECEINT_CTR_OVF_Msk            (0x01UL << NT_CAP0_ECEINT_CTR_OVF_Pos)                  /*!< NT_CAP0 ECEINT: CTR_OVF Mask            */
#define NT_CAP0_ECEINT_CTR_PRD_Pos            6                                                       /*!< NT_CAP0 ECEINT: CTR_PRD Position        */
#define NT_CAP0_ECEINT_CTR_PRD_Msk            (0x01UL << NT_CAP0_ECEINT_CTR_PRD_Pos)                  /*!< NT_CAP0 ECEINT: CTR_PRD Mask            */
#define NT_CAP0_ECEINT_CTR_CMP_Pos            7                                                       /*!< NT_CAP0 ECEINT: CTR_CMP Position        */
#define NT_CAP0_ECEINT_CTR_CMP_Msk            (0x01UL << NT_CAP0_ECEINT_CTR_CMP_Pos)                  /*!< NT_CAP0 ECEINT: CTR_CMP Mask            */

/* --------------------------------  NT_CAP0_ECFLG  ------------------------------- */
#define NT_CAP0_ECFLG_INT_Pos                 0                                                       /*!< NT_CAP0 ECFLG: INT Position             */
#define NT_CAP0_ECFLG_INT_Msk                 (0x01UL << NT_CAP0_ECFLG_INT_Pos)                       /*!< NT_CAP0 ECFLG: INT Mask                 */
#define NT_CAP0_ECFLG_CEVT0_Pos               1                                                       /*!< NT_CAP0 ECFLG: CEVT0 Position           */
#define NT_CAP0_ECFLG_CEVT0_Msk               (0x01UL << NT_CAP0_ECFLG_CEVT0_Pos)                     /*!< NT_CAP0 ECFLG: CEVT0 Mask               */
#define NT_CAP0_ECFLG_CEVT1_Pos               2                                                       /*!< NT_CAP0 ECFLG: CEVT1 Position           */
#define NT_CAP0_ECFLG_CEVT1_Msk               (0x01UL << NT_CAP0_ECFLG_CEVT1_Pos)                     /*!< NT_CAP0 ECFLG: CEVT1 Mask               */
#define NT_CAP0_ECFLG_CEVT2_Pos               3                                                       /*!< NT_CAP0 ECFLG: CEVT2 Position           */
#define NT_CAP0_ECFLG_CEVT2_Msk               (0x01UL << NT_CAP0_ECFLG_CEVT2_Pos)                     /*!< NT_CAP0 ECFLG: CEVT2 Mask               */
#define NT_CAP0_ECFLG_CEVT3_Pos               4                                                       /*!< NT_CAP0 ECFLG: CEVT3 Position           */
#define NT_CAP0_ECFLG_CEVT3_Msk               (0x01UL << NT_CAP0_ECFLG_CEVT3_Pos)                     /*!< NT_CAP0 ECFLG: CEVT3 Mask               */
#define NT_CAP0_ECFLG_CTR_OVF_Pos             5                                                       /*!< NT_CAP0 ECFLG: CTR_OVF Position         */
#define NT_CAP0_ECFLG_CTR_OVF_Msk             (0x01UL << NT_CAP0_ECFLG_CTR_OVF_Pos)                   /*!< NT_CAP0 ECFLG: CTR_OVF Mask             */
#define NT_CAP0_ECFLG_CTR_PRD_Pos             6                                                       /*!< NT_CAP0 ECFLG: CTR_PRD Position         */
#define NT_CAP0_ECFLG_CTR_PRD_Msk             (0x01UL << NT_CAP0_ECFLG_CTR_PRD_Pos)                   /*!< NT_CAP0 ECFLG: CTR_PRD Mask             */
#define NT_CAP0_ECFLG_CTR_CMP_Pos             7                                                       /*!< NT_CAP0 ECFLG: CTR_CMP Position         */
#define NT_CAP0_ECFLG_CTR_CMP_Msk             (0x01UL << NT_CAP0_ECFLG_CTR_CMP_Pos)                   /*!< NT_CAP0 ECFLG: CTR_CMP Mask             */

/* --------------------------------  NT_CAP0_ECCLR  ------------------------------- */
#define NT_CAP0_ECCLR_INT_Pos                 0                                                       /*!< NT_CAP0 ECCLR: INT Position             */
#define NT_CAP0_ECCLR_INT_Msk                 (0x01UL << NT_CAP0_ECCLR_INT_Pos)                       /*!< NT_CAP0 ECCLR: INT Mask                 */
#define NT_CAP0_ECCLR_CEVT0_Pos               1                                                       /*!< NT_CAP0 ECCLR: CEVT0 Position           */
#define NT_CAP0_ECCLR_CEVT0_Msk               (0x01UL << NT_CAP0_ECCLR_CEVT0_Pos)                     /*!< NT_CAP0 ECCLR: CEVT0 Mask               */
#define NT_CAP0_ECCLR_CEVT1_Pos               2                                                       /*!< NT_CAP0 ECCLR: CEVT1 Position           */
#define NT_CAP0_ECCLR_CEVT1_Msk               (0x01UL << NT_CAP0_ECCLR_CEVT1_Pos)                     /*!< NT_CAP0 ECCLR: CEVT1 Mask               */
#define NT_CAP0_ECCLR_CEVT2_Pos               3                                                       /*!< NT_CAP0 ECCLR: CEVT2 Position           */
#define NT_CAP0_ECCLR_CEVT2_Msk               (0x01UL << NT_CAP0_ECCLR_CEVT2_Pos)                     /*!< NT_CAP0 ECCLR: CEVT2 Mask               */
#define NT_CAP0_ECCLR_CEVT3_Pos               4                                                       /*!< NT_CAP0 ECCLR: CEVT3 Position           */
#define NT_CAP0_ECCLR_CEVT3_Msk               (0x01UL << NT_CAP0_ECCLR_CEVT3_Pos)                     /*!< NT_CAP0 ECCLR: CEVT3 Mask               */
#define NT_CAP0_ECCLR_CTR_OVF_Pos             5                                                       /*!< NT_CAP0 ECCLR: CTR_OVF Position         */
#define NT_CAP0_ECCLR_CTR_OVF_Msk             (0x01UL << NT_CAP0_ECCLR_CTR_OVF_Pos)                   /*!< NT_CAP0 ECCLR: CTR_OVF Mask             */
#define NT_CAP0_ECCLR_CTR_PRD_Pos             6                                                       /*!< NT_CAP0 ECCLR: CTR_PRD Position         */
#define NT_CAP0_ECCLR_CTR_PRD_Msk             (0x01UL << NT_CAP0_ECCLR_CTR_PRD_Pos)                   /*!< NT_CAP0 ECCLR: CTR_PRD Mask             */
#define NT_CAP0_ECCLR_CTR_CMP_Pos             7                                                       /*!< NT_CAP0 ECCLR: CTR_CMP Position         */
#define NT_CAP0_ECCLR_CTR_CMP_Msk             (0x01UL << NT_CAP0_ECCLR_CTR_CMP_Pos)                   /*!< NT_CAP0 ECCLR: CTR_CMP Mask             */

/* --------------------------------  NT_CAP0_ECFRC  ------------------------------- */
#define NT_CAP0_ECFRC_CEVT0_Pos               1                                                       /*!< NT_CAP0 ECFRC: CEVT0 Position           */
#define NT_CAP0_ECFRC_CEVT0_Msk               (0x01UL << NT_CAP0_ECFRC_CEVT0_Pos)                     /*!< NT_CAP0 ECFRC: CEVT0 Mask               */
#define NT_CAP0_ECFRC_CEVT1_Pos               2                                                       /*!< NT_CAP0 ECFRC: CEVT1 Position           */
#define NT_CAP0_ECFRC_CEVT1_Msk               (0x01UL << NT_CAP0_ECFRC_CEVT1_Pos)                     /*!< NT_CAP0 ECFRC: CEVT1 Mask               */
#define NT_CAP0_ECFRC_CEVT2_Pos               3                                                       /*!< NT_CAP0 ECFRC: CEVT2 Position           */
#define NT_CAP0_ECFRC_CEVT2_Msk               (0x01UL << NT_CAP0_ECFRC_CEVT2_Pos)                     /*!< NT_CAP0 ECFRC: CEVT2 Mask               */
#define NT_CAP0_ECFRC_CEVT3_Pos               4                                                       /*!< NT_CAP0 ECFRC: CEVT3 Position           */
#define NT_CAP0_ECFRC_CEVT3_Msk               (0x01UL << NT_CAP0_ECFRC_CEVT3_Pos)                     /*!< NT_CAP0 ECFRC: CEVT3 Mask               */
#define NT_CAP0_ECFRC_CTR_OVF_Pos             5                                                       /*!< NT_CAP0 ECFRC: CTR_OVF Position         */
#define NT_CAP0_ECFRC_CTR_OVF_Msk             (0x01UL << NT_CAP0_ECFRC_CTR_OVF_Pos)                   /*!< NT_CAP0 ECFRC: CTR_OVF Mask             */
#define NT_CAP0_ECFRC_CTR_PRD_Pos             6                                                       /*!< NT_CAP0 ECFRC: CTR_PRD Position         */
#define NT_CAP0_ECFRC_CTR_PRD_Msk             (0x01UL << NT_CAP0_ECFRC_CTR_PRD_Pos)                   /*!< NT_CAP0 ECFRC: CTR_PRD Mask             */
#define NT_CAP0_ECFRC_CTR_CMP_Pos             7                                                       /*!< NT_CAP0 ECFRC: CTR_CMP Position         */
#define NT_CAP0_ECFRC_CTR_CMP_Msk             (0x01UL << NT_CAP0_ECFRC_CTR_CMP_Pos)                   /*!< NT_CAP0 ECFRC: CTR_CMP Mask             */

/* --------------------------------  NT_CAP0_PEINT  ------------------------------- */
#define NT_CAP0_PEINT_PEINT_Pos               0                                                       /*!< NT_CAP0 PEINT: PEINT Position           */
#define NT_CAP0_PEINT_PEINT_Msk               (0x01UL << NT_CAP0_PEINT_PEINT_Pos)                     /*!< NT_CAP0 PEINT: PEINT Mask               */


/* ================================================================================ */
/* ================        struct 'NT_CAP1' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_CAP1_TSCTR  ------------------------------- */
#define NT_CAP1_TSCTR_VALUE_Pos               0                                                       /*!< NT_CAP1 TSCTR: VALUE Position           */
#define NT_CAP1_TSCTR_VALUE_Msk               (0xffffffffUL << NT_CAP1_TSCTR_VALUE_Pos)               /*!< NT_CAP1 TSCTR: VALUE Mask               */

/* -------------------------------  NT_CAP1_CTRPHS  ------------------------------- */
#define NT_CAP1_CTRPHS_VALUE_Pos              0                                                       /*!< NT_CAP1 CTRPHS: VALUE Position          */
#define NT_CAP1_CTRPHS_VALUE_Msk              (0xffffffffUL << NT_CAP1_CTRPHS_VALUE_Pos)              /*!< NT_CAP1 CTRPHS: VALUE Mask              */

/* --------------------------------  NT_CAP1_CAP0  -------------------------------- */
#define NT_CAP1_CAP0_VALUE_Pos                0                                                       /*!< NT_CAP1 CAP0: VALUE Position            */
#define NT_CAP1_CAP0_VALUE_Msk                (0xffffffffUL << NT_CAP1_CAP0_VALUE_Pos)                /*!< NT_CAP1 CAP0: VALUE Mask                */

/* --------------------------------  NT_CAP1_CAP1  -------------------------------- */
#define NT_CAP1_CAP1_VALUE_Pos                0                                                       /*!< NT_CAP1 CAP1: VALUE Position            */
#define NT_CAP1_CAP1_VALUE_Msk                (0xffffffffUL << NT_CAP1_CAP1_VALUE_Pos)                /*!< NT_CAP1 CAP1: VALUE Mask                */

/* --------------------------------  NT_CAP1_CAP2  -------------------------------- */
#define NT_CAP1_CAP2_VALUE_Pos                0                                                       /*!< NT_CAP1 CAP2: VALUE Position            */
#define NT_CAP1_CAP2_VALUE_Msk                (0xffffffffUL << NT_CAP1_CAP2_VALUE_Pos)                /*!< NT_CAP1 CAP2: VALUE Mask                */

/* --------------------------------  NT_CAP1_CAP3  -------------------------------- */
#define NT_CAP1_CAP3_VALUE_Pos                0                                                       /*!< NT_CAP1 CAP3: VALUE Position            */
#define NT_CAP1_CAP3_VALUE_Msk                (0xffffffffUL << NT_CAP1_CAP3_VALUE_Pos)                /*!< NT_CAP1 CAP3: VALUE Mask                */

/* -------------------------------  NT_CAP1_ECCTL0  ------------------------------- */
#define NT_CAP1_ECCTL0_CAP0_POL_Pos           0                                                       /*!< NT_CAP1 ECCTL0: CAP0_POL Position       */
#define NT_CAP1_ECCTL0_CAP0_POL_Msk           (0x01UL << NT_CAP1_ECCTL0_CAP0_POL_Pos)                 /*!< NT_CAP1 ECCTL0: CAP0_POL Mask           */
#define NT_CAP1_ECCTL0_CTR_RST0_Pos           1                                                       /*!< NT_CAP1 ECCTL0: CTR_RST0 Position       */
#define NT_CAP1_ECCTL0_CTR_RST0_Msk           (0x01UL << NT_CAP1_ECCTL0_CTR_RST0_Pos)                 /*!< NT_CAP1 ECCTL0: CTR_RST0 Mask           */
#define NT_CAP1_ECCTL0_CAP1_POL_Pos           2                                                       /*!< NT_CAP1 ECCTL0: CAP1_POL Position       */
#define NT_CAP1_ECCTL0_CAP1_POL_Msk           (0x01UL << NT_CAP1_ECCTL0_CAP1_POL_Pos)                 /*!< NT_CAP1 ECCTL0: CAP1_POL Mask           */
#define NT_CAP1_ECCTL0_CTR_RST1_Pos           3                                                       /*!< NT_CAP1 ECCTL0: CTR_RST1 Position       */
#define NT_CAP1_ECCTL0_CTR_RST1_Msk           (0x01UL << NT_CAP1_ECCTL0_CTR_RST1_Pos)                 /*!< NT_CAP1 ECCTL0: CTR_RST1 Mask           */
#define NT_CAP1_ECCTL0_CAP2_POL_Pos           4                                                       /*!< NT_CAP1 ECCTL0: CAP2_POL Position       */
#define NT_CAP1_ECCTL0_CAP2_POL_Msk           (0x01UL << NT_CAP1_ECCTL0_CAP2_POL_Pos)                 /*!< NT_CAP1 ECCTL0: CAP2_POL Mask           */
#define NT_CAP1_ECCTL0_CTR_RST2_Pos           5                                                       /*!< NT_CAP1 ECCTL0: CTR_RST2 Position       */
#define NT_CAP1_ECCTL0_CTR_RST2_Msk           (0x01UL << NT_CAP1_ECCTL0_CTR_RST2_Pos)                 /*!< NT_CAP1 ECCTL0: CTR_RST2 Mask           */
#define NT_CAP1_ECCTL0_CAP3_POL_Pos           6                                                       /*!< NT_CAP1 ECCTL0: CAP3_POL Position       */
#define NT_CAP1_ECCTL0_CAP3_POL_Msk           (0x01UL << NT_CAP1_ECCTL0_CAP3_POL_Pos)                 /*!< NT_CAP1 ECCTL0: CAP3_POL Mask           */
#define NT_CAP1_ECCTL0_CTR_RST3_Pos           7                                                       /*!< NT_CAP1 ECCTL0: CTR_RST3 Position       */
#define NT_CAP1_ECCTL0_CTR_RST3_Msk           (0x01UL << NT_CAP1_ECCTL0_CTR_RST3_Pos)                 /*!< NT_CAP1 ECCTL0: CTR_RST3 Mask           */
#define NT_CAP1_ECCTL0_CAPLDEN_Pos            8                                                       /*!< NT_CAP1 ECCTL0: CAPLDEN Position        */
#define NT_CAP1_ECCTL0_CAPLDEN_Msk            (0x01UL << NT_CAP1_ECCTL0_CAPLDEN_Pos)                  /*!< NT_CAP1 ECCTL0: CAPLDEN Mask            */
#define NT_CAP1_ECCTL0_PRESCALE_Pos           9                                                       /*!< NT_CAP1 ECCTL0: PRESCALE Position       */
#define NT_CAP1_ECCTL0_PRESCALE_Msk           (0x1fUL << NT_CAP1_ECCTL0_PRESCALE_Pos)                 /*!< NT_CAP1 ECCTL0: PRESCALE Mask           */
#define NT_CAP1_ECCTL0_FREE_SOFT_Pos          14                                                      /*!< NT_CAP1 ECCTL0: FREE_SOFT Position      */
#define NT_CAP1_ECCTL0_FREE_SOFT_Msk          (0x03UL << NT_CAP1_ECCTL0_FREE_SOFT_Pos)                /*!< NT_CAP1 ECCTL0: FREE_SOFT Mask          */

/* -------------------------------  NT_CAP1_ECCTL1  ------------------------------- */
#define NT_CAP1_ECCTL1_SWSYNC_Pos             0                                                       /*!< NT_CAP1 ECCTL1: SWSYNC Position         */
#define NT_CAP1_ECCTL1_SWSYNC_Msk             (0x01UL << NT_CAP1_ECCTL1_SWSYNC_Pos)                   /*!< NT_CAP1 ECCTL1: SWSYNC Mask             */
#define NT_CAP1_ECCTL1_CAP_APWM_Pos           1                                                       /*!< NT_CAP1 ECCTL1: CAP_APWM Position       */
#define NT_CAP1_ECCTL1_CAP_APWM_Msk           (0x01UL << NT_CAP1_ECCTL1_CAP_APWM_Pos)                 /*!< NT_CAP1 ECCTL1: CAP_APWM Mask           */
#define NT_CAP1_ECCTL1_APWM_POL_Pos           2                                                       /*!< NT_CAP1 ECCTL1: APWM_POL Position       */
#define NT_CAP1_ECCTL1_APWM_POL_Msk           (0x01UL << NT_CAP1_ECCTL1_APWM_POL_Pos)                 /*!< NT_CAP1 ECCTL1: APWM_POL Mask           */
#define NT_CAP1_ECCTL1_CONT_ONESHT_Pos        8                                                       /*!< NT_CAP1 ECCTL1: CONT_ONESHT Position    */
#define NT_CAP1_ECCTL1_CONT_ONESHT_Msk        (0x01UL << NT_CAP1_ECCTL1_CONT_ONESHT_Pos)              /*!< NT_CAP1 ECCTL1: CONT_ONESHT Mask        */
#define NT_CAP1_ECCTL1_STOP_WRAP_Pos          9                                                       /*!< NT_CAP1 ECCTL1: STOP_WRAP Position      */
#define NT_CAP1_ECCTL1_STOP_WRAP_Msk          (0x03UL << NT_CAP1_ECCTL1_STOP_WRAP_Pos)                /*!< NT_CAP1 ECCTL1: STOP_WRAP Mask          */
#define NT_CAP1_ECCTL1_REARM_Pos              11                                                      /*!< NT_CAP1 ECCTL1: REARM Position          */
#define NT_CAP1_ECCTL1_REARM_Msk              (0x01UL << NT_CAP1_ECCTL1_REARM_Pos)                    /*!< NT_CAP1 ECCTL1: REARM Mask              */
#define NT_CAP1_ECCTL1_TSCTRSTOP_Pos          12                                                      /*!< NT_CAP1 ECCTL1: TSCTRSTOP Position      */
#define NT_CAP1_ECCTL1_TSCTRSTOP_Msk          (0x01UL << NT_CAP1_ECCTL1_TSCTRSTOP_Pos)                /*!< NT_CAP1 ECCTL1: TSCTRSTOP Mask          */
#define NT_CAP1_ECCTL1_SYNCI_EN_Pos           13                                                      /*!< NT_CAP1 ECCTL1: SYNCI_EN Position       */
#define NT_CAP1_ECCTL1_SYNCI_EN_Msk           (0x01UL << NT_CAP1_ECCTL1_SYNCI_EN_Pos)                 /*!< NT_CAP1 ECCTL1: SYNCI_EN Mask           */
#define NT_CAP1_ECCTL1_SYNCO_SEL_Pos          14                                                      /*!< NT_CAP1 ECCTL1: SYNCO_SEL Position      */
#define NT_CAP1_ECCTL1_SYNCO_SEL_Msk          (0x03UL << NT_CAP1_ECCTL1_SYNCO_SEL_Pos)                /*!< NT_CAP1 ECCTL1: SYNCO_SEL Mask          */

/* -------------------------------  NT_CAP1_ECEINT  ------------------------------- */
#define NT_CAP1_ECEINT_CEVT0_Pos              1                                                       /*!< NT_CAP1 ECEINT: CEVT0 Position          */
#define NT_CAP1_ECEINT_CEVT0_Msk              (0x01UL << NT_CAP1_ECEINT_CEVT0_Pos)                    /*!< NT_CAP1 ECEINT: CEVT0 Mask              */
#define NT_CAP1_ECEINT_CEVT1_Pos              2                                                       /*!< NT_CAP1 ECEINT: CEVT1 Position          */
#define NT_CAP1_ECEINT_CEVT1_Msk              (0x01UL << NT_CAP1_ECEINT_CEVT1_Pos)                    /*!< NT_CAP1 ECEINT: CEVT1 Mask              */
#define NT_CAP1_ECEINT_CEVT2_Pos              3                                                       /*!< NT_CAP1 ECEINT: CEVT2 Position          */
#define NT_CAP1_ECEINT_CEVT2_Msk              (0x01UL << NT_CAP1_ECEINT_CEVT2_Pos)                    /*!< NT_CAP1 ECEINT: CEVT2 Mask              */
#define NT_CAP1_ECEINT_CEVT3_Pos              4                                                       /*!< NT_CAP1 ECEINT: CEVT3 Position          */
#define NT_CAP1_ECEINT_CEVT3_Msk              (0x01UL << NT_CAP1_ECEINT_CEVT3_Pos)                    /*!< NT_CAP1 ECEINT: CEVT3 Mask              */
#define NT_CAP1_ECEINT_CTR_OVF_Pos            5                                                       /*!< NT_CAP1 ECEINT: CTR_OVF Position        */
#define NT_CAP1_ECEINT_CTR_OVF_Msk            (0x01UL << NT_CAP1_ECEINT_CTR_OVF_Pos)                  /*!< NT_CAP1 ECEINT: CTR_OVF Mask            */
#define NT_CAP1_ECEINT_CTR_PRD_Pos            6                                                       /*!< NT_CAP1 ECEINT: CTR_PRD Position        */
#define NT_CAP1_ECEINT_CTR_PRD_Msk            (0x01UL << NT_CAP1_ECEINT_CTR_PRD_Pos)                  /*!< NT_CAP1 ECEINT: CTR_PRD Mask            */
#define NT_CAP1_ECEINT_CTR_CMP_Pos            7                                                       /*!< NT_CAP1 ECEINT: CTR_CMP Position        */
#define NT_CAP1_ECEINT_CTR_CMP_Msk            (0x01UL << NT_CAP1_ECEINT_CTR_CMP_Pos)                  /*!< NT_CAP1 ECEINT: CTR_CMP Mask            */

/* --------------------------------  NT_CAP1_ECFLG  ------------------------------- */
#define NT_CAP1_ECFLG_INT_Pos                 0                                                       /*!< NT_CAP1 ECFLG: INT Position             */
#define NT_CAP1_ECFLG_INT_Msk                 (0x01UL << NT_CAP1_ECFLG_INT_Pos)                       /*!< NT_CAP1 ECFLG: INT Mask                 */
#define NT_CAP1_ECFLG_CEVT0_Pos               1                                                       /*!< NT_CAP1 ECFLG: CEVT0 Position           */
#define NT_CAP1_ECFLG_CEVT0_Msk               (0x01UL << NT_CAP1_ECFLG_CEVT0_Pos)                     /*!< NT_CAP1 ECFLG: CEVT0 Mask               */
#define NT_CAP1_ECFLG_CEVT1_Pos               2                                                       /*!< NT_CAP1 ECFLG: CEVT1 Position           */
#define NT_CAP1_ECFLG_CEVT1_Msk               (0x01UL << NT_CAP1_ECFLG_CEVT1_Pos)                     /*!< NT_CAP1 ECFLG: CEVT1 Mask               */
#define NT_CAP1_ECFLG_CEVT2_Pos               3                                                       /*!< NT_CAP1 ECFLG: CEVT2 Position           */
#define NT_CAP1_ECFLG_CEVT2_Msk               (0x01UL << NT_CAP1_ECFLG_CEVT2_Pos)                     /*!< NT_CAP1 ECFLG: CEVT2 Mask               */
#define NT_CAP1_ECFLG_CEVT3_Pos               4                                                       /*!< NT_CAP1 ECFLG: CEVT3 Position           */
#define NT_CAP1_ECFLG_CEVT3_Msk               (0x01UL << NT_CAP1_ECFLG_CEVT3_Pos)                     /*!< NT_CAP1 ECFLG: CEVT3 Mask               */
#define NT_CAP1_ECFLG_CTR_OVF_Pos             5                                                       /*!< NT_CAP1 ECFLG: CTR_OVF Position         */
#define NT_CAP1_ECFLG_CTR_OVF_Msk             (0x01UL << NT_CAP1_ECFLG_CTR_OVF_Pos)                   /*!< NT_CAP1 ECFLG: CTR_OVF Mask             */
#define NT_CAP1_ECFLG_CTR_PRD_Pos             6                                                       /*!< NT_CAP1 ECFLG: CTR_PRD Position         */
#define NT_CAP1_ECFLG_CTR_PRD_Msk             (0x01UL << NT_CAP1_ECFLG_CTR_PRD_Pos)                   /*!< NT_CAP1 ECFLG: CTR_PRD Mask             */
#define NT_CAP1_ECFLG_CTR_CMP_Pos             7                                                       /*!< NT_CAP1 ECFLG: CTR_CMP Position         */
#define NT_CAP1_ECFLG_CTR_CMP_Msk             (0x01UL << NT_CAP1_ECFLG_CTR_CMP_Pos)                   /*!< NT_CAP1 ECFLG: CTR_CMP Mask             */

/* --------------------------------  NT_CAP1_ECCLR  ------------------------------- */
#define NT_CAP1_ECCLR_INT_Pos                 0                                                       /*!< NT_CAP1 ECCLR: INT Position             */
#define NT_CAP1_ECCLR_INT_Msk                 (0x01UL << NT_CAP1_ECCLR_INT_Pos)                       /*!< NT_CAP1 ECCLR: INT Mask                 */
#define NT_CAP1_ECCLR_CEVT0_Pos               1                                                       /*!< NT_CAP1 ECCLR: CEVT0 Position           */
#define NT_CAP1_ECCLR_CEVT0_Msk               (0x01UL << NT_CAP1_ECCLR_CEVT0_Pos)                     /*!< NT_CAP1 ECCLR: CEVT0 Mask               */
#define NT_CAP1_ECCLR_CEVT1_Pos               2                                                       /*!< NT_CAP1 ECCLR: CEVT1 Position           */
#define NT_CAP1_ECCLR_CEVT1_Msk               (0x01UL << NT_CAP1_ECCLR_CEVT1_Pos)                     /*!< NT_CAP1 ECCLR: CEVT1 Mask               */
#define NT_CAP1_ECCLR_CEVT2_Pos               3                                                       /*!< NT_CAP1 ECCLR: CEVT2 Position           */
#define NT_CAP1_ECCLR_CEVT2_Msk               (0x01UL << NT_CAP1_ECCLR_CEVT2_Pos)                     /*!< NT_CAP1 ECCLR: CEVT2 Mask               */
#define NT_CAP1_ECCLR_CEVT3_Pos               4                                                       /*!< NT_CAP1 ECCLR: CEVT3 Position           */
#define NT_CAP1_ECCLR_CEVT3_Msk               (0x01UL << NT_CAP1_ECCLR_CEVT3_Pos)                     /*!< NT_CAP1 ECCLR: CEVT3 Mask               */
#define NT_CAP1_ECCLR_CTR_OVF_Pos             5                                                       /*!< NT_CAP1 ECCLR: CTR_OVF Position         */
#define NT_CAP1_ECCLR_CTR_OVF_Msk             (0x01UL << NT_CAP1_ECCLR_CTR_OVF_Pos)                   /*!< NT_CAP1 ECCLR: CTR_OVF Mask             */
#define NT_CAP1_ECCLR_CTR_PRD_Pos             6                                                       /*!< NT_CAP1 ECCLR: CTR_PRD Position         */
#define NT_CAP1_ECCLR_CTR_PRD_Msk             (0x01UL << NT_CAP1_ECCLR_CTR_PRD_Pos)                   /*!< NT_CAP1 ECCLR: CTR_PRD Mask             */
#define NT_CAP1_ECCLR_CTR_CMP_Pos             7                                                       /*!< NT_CAP1 ECCLR: CTR_CMP Position         */
#define NT_CAP1_ECCLR_CTR_CMP_Msk             (0x01UL << NT_CAP1_ECCLR_CTR_CMP_Pos)                   /*!< NT_CAP1 ECCLR: CTR_CMP Mask             */

/* --------------------------------  NT_CAP1_ECFRC  ------------------------------- */
#define NT_CAP1_ECFRC_CEVT0_Pos               1                                                       /*!< NT_CAP1 ECFRC: CEVT0 Position           */
#define NT_CAP1_ECFRC_CEVT0_Msk               (0x01UL << NT_CAP1_ECFRC_CEVT0_Pos)                     /*!< NT_CAP1 ECFRC: CEVT0 Mask               */
#define NT_CAP1_ECFRC_CEVT1_Pos               2                                                       /*!< NT_CAP1 ECFRC: CEVT1 Position           */
#define NT_CAP1_ECFRC_CEVT1_Msk               (0x01UL << NT_CAP1_ECFRC_CEVT1_Pos)                     /*!< NT_CAP1 ECFRC: CEVT1 Mask               */
#define NT_CAP1_ECFRC_CEVT2_Pos               3                                                       /*!< NT_CAP1 ECFRC: CEVT2 Position           */
#define NT_CAP1_ECFRC_CEVT2_Msk               (0x01UL << NT_CAP1_ECFRC_CEVT2_Pos)                     /*!< NT_CAP1 ECFRC: CEVT2 Mask               */
#define NT_CAP1_ECFRC_CEVT3_Pos               4                                                       /*!< NT_CAP1 ECFRC: CEVT3 Position           */
#define NT_CAP1_ECFRC_CEVT3_Msk               (0x01UL << NT_CAP1_ECFRC_CEVT3_Pos)                     /*!< NT_CAP1 ECFRC: CEVT3 Mask               */
#define NT_CAP1_ECFRC_CTR_OVF_Pos             5                                                       /*!< NT_CAP1 ECFRC: CTR_OVF Position         */
#define NT_CAP1_ECFRC_CTR_OVF_Msk             (0x01UL << NT_CAP1_ECFRC_CTR_OVF_Pos)                   /*!< NT_CAP1 ECFRC: CTR_OVF Mask             */
#define NT_CAP1_ECFRC_CTR_PRD_Pos             6                                                       /*!< NT_CAP1 ECFRC: CTR_PRD Position         */
#define NT_CAP1_ECFRC_CTR_PRD_Msk             (0x01UL << NT_CAP1_ECFRC_CTR_PRD_Pos)                   /*!< NT_CAP1 ECFRC: CTR_PRD Mask             */
#define NT_CAP1_ECFRC_CTR_CMP_Pos             7                                                       /*!< NT_CAP1 ECFRC: CTR_CMP Position         */
#define NT_CAP1_ECFRC_CTR_CMP_Msk             (0x01UL << NT_CAP1_ECFRC_CTR_CMP_Pos)                   /*!< NT_CAP1 ECFRC: CTR_CMP Mask             */

/* --------------------------------  NT_CAP1_PEINT  ------------------------------- */
#define NT_CAP1_PEINT_PEINT_Pos               0                                                       /*!< NT_CAP1 PEINT: PEINT Position           */
#define NT_CAP1_PEINT_PEINT_Msk               (0x01UL << NT_CAP1_PEINT_PEINT_Pos)                     /*!< NT_CAP1 PEINT: PEINT Mask               */


/* ================================================================================ */
/* ================        struct 'NT_CAP2' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_CAP2_TSCTR  ------------------------------- */
#define NT_CAP2_TSCTR_VALUE_Pos               0                                                       /*!< NT_CAP2 TSCTR: VALUE Position           */
#define NT_CAP2_TSCTR_VALUE_Msk               (0xffffffffUL << NT_CAP2_TSCTR_VALUE_Pos)               /*!< NT_CAP2 TSCTR: VALUE Mask               */

/* -------------------------------  NT_CAP2_CTRPHS  ------------------------------- */
#define NT_CAP2_CTRPHS_VALUE_Pos              0                                                       /*!< NT_CAP2 CTRPHS: VALUE Position          */
#define NT_CAP2_CTRPHS_VALUE_Msk              (0xffffffffUL << NT_CAP2_CTRPHS_VALUE_Pos)              /*!< NT_CAP2 CTRPHS: VALUE Mask              */

/* --------------------------------  NT_CAP2_CAP0  -------------------------------- */
#define NT_CAP2_CAP0_VALUE_Pos                0                                                       /*!< NT_CAP2 CAP0: VALUE Position            */
#define NT_CAP2_CAP0_VALUE_Msk                (0xffffffffUL << NT_CAP2_CAP0_VALUE_Pos)                /*!< NT_CAP2 CAP0: VALUE Mask                */

/* --------------------------------  NT_CAP2_CAP1  -------------------------------- */
#define NT_CAP2_CAP1_VALUE_Pos                0                                                       /*!< NT_CAP2 CAP1: VALUE Position            */
#define NT_CAP2_CAP1_VALUE_Msk                (0xffffffffUL << NT_CAP2_CAP1_VALUE_Pos)                /*!< NT_CAP2 CAP1: VALUE Mask                */

/* --------------------------------  NT_CAP2_CAP2  -------------------------------- */
#define NT_CAP2_CAP2_VALUE_Pos                0                                                       /*!< NT_CAP2 CAP2: VALUE Position            */
#define NT_CAP2_CAP2_VALUE_Msk                (0xffffffffUL << NT_CAP2_CAP2_VALUE_Pos)                /*!< NT_CAP2 CAP2: VALUE Mask                */

/* --------------------------------  NT_CAP2_CAP3  -------------------------------- */
#define NT_CAP2_CAP3_VALUE_Pos                0                                                       /*!< NT_CAP2 CAP3: VALUE Position            */
#define NT_CAP2_CAP3_VALUE_Msk                (0xffffffffUL << NT_CAP2_CAP3_VALUE_Pos)                /*!< NT_CAP2 CAP3: VALUE Mask                */

/* -------------------------------  NT_CAP2_ECCTL0  ------------------------------- */
#define NT_CAP2_ECCTL0_CAP0_POL_Pos           0                                                       /*!< NT_CAP2 ECCTL0: CAP0_POL Position       */
#define NT_CAP2_ECCTL0_CAP0_POL_Msk           (0x01UL << NT_CAP2_ECCTL0_CAP0_POL_Pos)                 /*!< NT_CAP2 ECCTL0: CAP0_POL Mask           */
#define NT_CAP2_ECCTL0_CTR_RST0_Pos           1                                                       /*!< NT_CAP2 ECCTL0: CTR_RST0 Position       */
#define NT_CAP2_ECCTL0_CTR_RST0_Msk           (0x01UL << NT_CAP2_ECCTL0_CTR_RST0_Pos)                 /*!< NT_CAP2 ECCTL0: CTR_RST0 Mask           */
#define NT_CAP2_ECCTL0_CAP1_POL_Pos           2                                                       /*!< NT_CAP2 ECCTL0: CAP1_POL Position       */
#define NT_CAP2_ECCTL0_CAP1_POL_Msk           (0x01UL << NT_CAP2_ECCTL0_CAP1_POL_Pos)                 /*!< NT_CAP2 ECCTL0: CAP1_POL Mask           */
#define NT_CAP2_ECCTL0_CTR_RST1_Pos           3                                                       /*!< NT_CAP2 ECCTL0: CTR_RST1 Position       */
#define NT_CAP2_ECCTL0_CTR_RST1_Msk           (0x01UL << NT_CAP2_ECCTL0_CTR_RST1_Pos)                 /*!< NT_CAP2 ECCTL0: CTR_RST1 Mask           */
#define NT_CAP2_ECCTL0_CAP2_POL_Pos           4                                                       /*!< NT_CAP2 ECCTL0: CAP2_POL Position       */
#define NT_CAP2_ECCTL0_CAP2_POL_Msk           (0x01UL << NT_CAP2_ECCTL0_CAP2_POL_Pos)                 /*!< NT_CAP2 ECCTL0: CAP2_POL Mask           */
#define NT_CAP2_ECCTL0_CTR_RST2_Pos           5                                                       /*!< NT_CAP2 ECCTL0: CTR_RST2 Position       */
#define NT_CAP2_ECCTL0_CTR_RST2_Msk           (0x01UL << NT_CAP2_ECCTL0_CTR_RST2_Pos)                 /*!< NT_CAP2 ECCTL0: CTR_RST2 Mask           */
#define NT_CAP2_ECCTL0_CAP3_POL_Pos           6                                                       /*!< NT_CAP2 ECCTL0: CAP3_POL Position       */
#define NT_CAP2_ECCTL0_CAP3_POL_Msk           (0x01UL << NT_CAP2_ECCTL0_CAP3_POL_Pos)                 /*!< NT_CAP2 ECCTL0: CAP3_POL Mask           */
#define NT_CAP2_ECCTL0_CTR_RST3_Pos           7                                                       /*!< NT_CAP2 ECCTL0: CTR_RST3 Position       */
#define NT_CAP2_ECCTL0_CTR_RST3_Msk           (0x01UL << NT_CAP2_ECCTL0_CTR_RST3_Pos)                 /*!< NT_CAP2 ECCTL0: CTR_RST3 Mask           */
#define NT_CAP2_ECCTL0_CAPLDEN_Pos            8                                                       /*!< NT_CAP2 ECCTL0: CAPLDEN Position        */
#define NT_CAP2_ECCTL0_CAPLDEN_Msk            (0x01UL << NT_CAP2_ECCTL0_CAPLDEN_Pos)                  /*!< NT_CAP2 ECCTL0: CAPLDEN Mask            */
#define NT_CAP2_ECCTL0_PRESCALE_Pos           9                                                       /*!< NT_CAP2 ECCTL0: PRESCALE Position       */
#define NT_CAP2_ECCTL0_PRESCALE_Msk           (0x1fUL << NT_CAP2_ECCTL0_PRESCALE_Pos)                 /*!< NT_CAP2 ECCTL0: PRESCALE Mask           */
#define NT_CAP2_ECCTL0_FREE_SOFT_Pos          14                                                      /*!< NT_CAP2 ECCTL0: FREE_SOFT Position      */
#define NT_CAP2_ECCTL0_FREE_SOFT_Msk          (0x03UL << NT_CAP2_ECCTL0_FREE_SOFT_Pos)                /*!< NT_CAP2 ECCTL0: FREE_SOFT Mask          */

/* -------------------------------  NT_CAP2_ECCTL1  ------------------------------- */
#define NT_CAP2_ECCTL1_SWSYNC_Pos             0                                                       /*!< NT_CAP2 ECCTL1: SWSYNC Position         */
#define NT_CAP2_ECCTL1_SWSYNC_Msk             (0x01UL << NT_CAP2_ECCTL1_SWSYNC_Pos)                   /*!< NT_CAP2 ECCTL1: SWSYNC Mask             */
#define NT_CAP2_ECCTL1_CAP_APWM_Pos           1                                                       /*!< NT_CAP2 ECCTL1: CAP_APWM Position       */
#define NT_CAP2_ECCTL1_CAP_APWM_Msk           (0x01UL << NT_CAP2_ECCTL1_CAP_APWM_Pos)                 /*!< NT_CAP2 ECCTL1: CAP_APWM Mask           */
#define NT_CAP2_ECCTL1_APWM_POL_Pos           2                                                       /*!< NT_CAP2 ECCTL1: APWM_POL Position       */
#define NT_CAP2_ECCTL1_APWM_POL_Msk           (0x01UL << NT_CAP2_ECCTL1_APWM_POL_Pos)                 /*!< NT_CAP2 ECCTL1: APWM_POL Mask           */
#define NT_CAP2_ECCTL1_CONT_ONESHT_Pos        8                                                       /*!< NT_CAP2 ECCTL1: CONT_ONESHT Position    */
#define NT_CAP2_ECCTL1_CONT_ONESHT_Msk        (0x01UL << NT_CAP2_ECCTL1_CONT_ONESHT_Pos)              /*!< NT_CAP2 ECCTL1: CONT_ONESHT Mask        */
#define NT_CAP2_ECCTL1_STOP_WRAP_Pos          9                                                       /*!< NT_CAP2 ECCTL1: STOP_WRAP Position      */
#define NT_CAP2_ECCTL1_STOP_WRAP_Msk          (0x03UL << NT_CAP2_ECCTL1_STOP_WRAP_Pos)                /*!< NT_CAP2 ECCTL1: STOP_WRAP Mask          */
#define NT_CAP2_ECCTL1_REARM_Pos              11                                                      /*!< NT_CAP2 ECCTL1: REARM Position          */
#define NT_CAP2_ECCTL1_REARM_Msk              (0x01UL << NT_CAP2_ECCTL1_REARM_Pos)                    /*!< NT_CAP2 ECCTL1: REARM Mask              */
#define NT_CAP2_ECCTL1_TSCTRSTOP_Pos          12                                                      /*!< NT_CAP2 ECCTL1: TSCTRSTOP Position      */
#define NT_CAP2_ECCTL1_TSCTRSTOP_Msk          (0x01UL << NT_CAP2_ECCTL1_TSCTRSTOP_Pos)                /*!< NT_CAP2 ECCTL1: TSCTRSTOP Mask          */
#define NT_CAP2_ECCTL1_SYNCI_EN_Pos           13                                                      /*!< NT_CAP2 ECCTL1: SYNCI_EN Position       */
#define NT_CAP2_ECCTL1_SYNCI_EN_Msk           (0x01UL << NT_CAP2_ECCTL1_SYNCI_EN_Pos)                 /*!< NT_CAP2 ECCTL1: SYNCI_EN Mask           */
#define NT_CAP2_ECCTL1_SYNCO_SEL_Pos          14                                                      /*!< NT_CAP2 ECCTL1: SYNCO_SEL Position      */
#define NT_CAP2_ECCTL1_SYNCO_SEL_Msk          (0x03UL << NT_CAP2_ECCTL1_SYNCO_SEL_Pos)                /*!< NT_CAP2 ECCTL1: SYNCO_SEL Mask          */

/* -------------------------------  NT_CAP2_ECEINT  ------------------------------- */
#define NT_CAP2_ECEINT_CEVT0_Pos              1                                                       /*!< NT_CAP2 ECEINT: CEVT0 Position          */
#define NT_CAP2_ECEINT_CEVT0_Msk              (0x01UL << NT_CAP2_ECEINT_CEVT0_Pos)                    /*!< NT_CAP2 ECEINT: CEVT0 Mask              */
#define NT_CAP2_ECEINT_CEVT1_Pos              2                                                       /*!< NT_CAP2 ECEINT: CEVT1 Position          */
#define NT_CAP2_ECEINT_CEVT1_Msk              (0x01UL << NT_CAP2_ECEINT_CEVT1_Pos)                    /*!< NT_CAP2 ECEINT: CEVT1 Mask              */
#define NT_CAP2_ECEINT_CEVT2_Pos              3                                                       /*!< NT_CAP2 ECEINT: CEVT2 Position          */
#define NT_CAP2_ECEINT_CEVT2_Msk              (0x01UL << NT_CAP2_ECEINT_CEVT2_Pos)                    /*!< NT_CAP2 ECEINT: CEVT2 Mask              */
#define NT_CAP2_ECEINT_CEVT3_Pos              4                                                       /*!< NT_CAP2 ECEINT: CEVT3 Position          */
#define NT_CAP2_ECEINT_CEVT3_Msk              (0x01UL << NT_CAP2_ECEINT_CEVT3_Pos)                    /*!< NT_CAP2 ECEINT: CEVT3 Mask              */
#define NT_CAP2_ECEINT_CTR_OVF_Pos            5                                                       /*!< NT_CAP2 ECEINT: CTR_OVF Position        */
#define NT_CAP2_ECEINT_CTR_OVF_Msk            (0x01UL << NT_CAP2_ECEINT_CTR_OVF_Pos)                  /*!< NT_CAP2 ECEINT: CTR_OVF Mask            */
#define NT_CAP2_ECEINT_CTR_PRD_Pos            6                                                       /*!< NT_CAP2 ECEINT: CTR_PRD Position        */
#define NT_CAP2_ECEINT_CTR_PRD_Msk            (0x01UL << NT_CAP2_ECEINT_CTR_PRD_Pos)                  /*!< NT_CAP2 ECEINT: CTR_PRD Mask            */
#define NT_CAP2_ECEINT_CTR_CMP_Pos            7                                                       /*!< NT_CAP2 ECEINT: CTR_CMP Position        */
#define NT_CAP2_ECEINT_CTR_CMP_Msk            (0x01UL << NT_CAP2_ECEINT_CTR_CMP_Pos)                  /*!< NT_CAP2 ECEINT: CTR_CMP Mask            */

/* --------------------------------  NT_CAP2_ECFLG  ------------------------------- */
#define NT_CAP2_ECFLG_INT_Pos                 0                                                       /*!< NT_CAP2 ECFLG: INT Position             */
#define NT_CAP2_ECFLG_INT_Msk                 (0x01UL << NT_CAP2_ECFLG_INT_Pos)                       /*!< NT_CAP2 ECFLG: INT Mask                 */
#define NT_CAP2_ECFLG_CEVT0_Pos               1                                                       /*!< NT_CAP2 ECFLG: CEVT0 Position           */
#define NT_CAP2_ECFLG_CEVT0_Msk               (0x01UL << NT_CAP2_ECFLG_CEVT0_Pos)                     /*!< NT_CAP2 ECFLG: CEVT0 Mask               */
#define NT_CAP2_ECFLG_CEVT1_Pos               2                                                       /*!< NT_CAP2 ECFLG: CEVT1 Position           */
#define NT_CAP2_ECFLG_CEVT1_Msk               (0x01UL << NT_CAP2_ECFLG_CEVT1_Pos)                     /*!< NT_CAP2 ECFLG: CEVT1 Mask               */
#define NT_CAP2_ECFLG_CEVT2_Pos               3                                                       /*!< NT_CAP2 ECFLG: CEVT2 Position           */
#define NT_CAP2_ECFLG_CEVT2_Msk               (0x01UL << NT_CAP2_ECFLG_CEVT2_Pos)                     /*!< NT_CAP2 ECFLG: CEVT2 Mask               */
#define NT_CAP2_ECFLG_CEVT3_Pos               4                                                       /*!< NT_CAP2 ECFLG: CEVT3 Position           */
#define NT_CAP2_ECFLG_CEVT3_Msk               (0x01UL << NT_CAP2_ECFLG_CEVT3_Pos)                     /*!< NT_CAP2 ECFLG: CEVT3 Mask               */
#define NT_CAP2_ECFLG_CTR_OVF_Pos             5                                                       /*!< NT_CAP2 ECFLG: CTR_OVF Position         */
#define NT_CAP2_ECFLG_CTR_OVF_Msk             (0x01UL << NT_CAP2_ECFLG_CTR_OVF_Pos)                   /*!< NT_CAP2 ECFLG: CTR_OVF Mask             */
#define NT_CAP2_ECFLG_CTR_PRD_Pos             6                                                       /*!< NT_CAP2 ECFLG: CTR_PRD Position         */
#define NT_CAP2_ECFLG_CTR_PRD_Msk             (0x01UL << NT_CAP2_ECFLG_CTR_PRD_Pos)                   /*!< NT_CAP2 ECFLG: CTR_PRD Mask             */
#define NT_CAP2_ECFLG_CTR_CMP_Pos             7                                                       /*!< NT_CAP2 ECFLG: CTR_CMP Position         */
#define NT_CAP2_ECFLG_CTR_CMP_Msk             (0x01UL << NT_CAP2_ECFLG_CTR_CMP_Pos)                   /*!< NT_CAP2 ECFLG: CTR_CMP Mask             */

/* --------------------------------  NT_CAP2_ECCLR  ------------------------------- */
#define NT_CAP2_ECCLR_INT_Pos                 0                                                       /*!< NT_CAP2 ECCLR: INT Position             */
#define NT_CAP2_ECCLR_INT_Msk                 (0x01UL << NT_CAP2_ECCLR_INT_Pos)                       /*!< NT_CAP2 ECCLR: INT Mask                 */
#define NT_CAP2_ECCLR_CEVT0_Pos               1                                                       /*!< NT_CAP2 ECCLR: CEVT0 Position           */
#define NT_CAP2_ECCLR_CEVT0_Msk               (0x01UL << NT_CAP2_ECCLR_CEVT0_Pos)                     /*!< NT_CAP2 ECCLR: CEVT0 Mask               */
#define NT_CAP2_ECCLR_CEVT1_Pos               2                                                       /*!< NT_CAP2 ECCLR: CEVT1 Position           */
#define NT_CAP2_ECCLR_CEVT1_Msk               (0x01UL << NT_CAP2_ECCLR_CEVT1_Pos)                     /*!< NT_CAP2 ECCLR: CEVT1 Mask               */
#define NT_CAP2_ECCLR_CEVT2_Pos               3                                                       /*!< NT_CAP2 ECCLR: CEVT2 Position           */
#define NT_CAP2_ECCLR_CEVT2_Msk               (0x01UL << NT_CAP2_ECCLR_CEVT2_Pos)                     /*!< NT_CAP2 ECCLR: CEVT2 Mask               */
#define NT_CAP2_ECCLR_CEVT3_Pos               4                                                       /*!< NT_CAP2 ECCLR: CEVT3 Position           */
#define NT_CAP2_ECCLR_CEVT3_Msk               (0x01UL << NT_CAP2_ECCLR_CEVT3_Pos)                     /*!< NT_CAP2 ECCLR: CEVT3 Mask               */
#define NT_CAP2_ECCLR_CTR_OVF_Pos             5                                                       /*!< NT_CAP2 ECCLR: CTR_OVF Position         */
#define NT_CAP2_ECCLR_CTR_OVF_Msk             (0x01UL << NT_CAP2_ECCLR_CTR_OVF_Pos)                   /*!< NT_CAP2 ECCLR: CTR_OVF Mask             */
#define NT_CAP2_ECCLR_CTR_PRD_Pos             6                                                       /*!< NT_CAP2 ECCLR: CTR_PRD Position         */
#define NT_CAP2_ECCLR_CTR_PRD_Msk             (0x01UL << NT_CAP2_ECCLR_CTR_PRD_Pos)                   /*!< NT_CAP2 ECCLR: CTR_PRD Mask             */
#define NT_CAP2_ECCLR_CTR_CMP_Pos             7                                                       /*!< NT_CAP2 ECCLR: CTR_CMP Position         */
#define NT_CAP2_ECCLR_CTR_CMP_Msk             (0x01UL << NT_CAP2_ECCLR_CTR_CMP_Pos)                   /*!< NT_CAP2 ECCLR: CTR_CMP Mask             */

/* --------------------------------  NT_CAP2_ECFRC  ------------------------------- */
#define NT_CAP2_ECFRC_CEVT0_Pos               1                                                       /*!< NT_CAP2 ECFRC: CEVT0 Position           */
#define NT_CAP2_ECFRC_CEVT0_Msk               (0x01UL << NT_CAP2_ECFRC_CEVT0_Pos)                     /*!< NT_CAP2 ECFRC: CEVT0 Mask               */
#define NT_CAP2_ECFRC_CEVT1_Pos               2                                                       /*!< NT_CAP2 ECFRC: CEVT1 Position           */
#define NT_CAP2_ECFRC_CEVT1_Msk               (0x01UL << NT_CAP2_ECFRC_CEVT1_Pos)                     /*!< NT_CAP2 ECFRC: CEVT1 Mask               */
#define NT_CAP2_ECFRC_CEVT2_Pos               3                                                       /*!< NT_CAP2 ECFRC: CEVT2 Position           */
#define NT_CAP2_ECFRC_CEVT2_Msk               (0x01UL << NT_CAP2_ECFRC_CEVT2_Pos)                     /*!< NT_CAP2 ECFRC: CEVT2 Mask               */
#define NT_CAP2_ECFRC_CEVT3_Pos               4                                                       /*!< NT_CAP2 ECFRC: CEVT3 Position           */
#define NT_CAP2_ECFRC_CEVT3_Msk               (0x01UL << NT_CAP2_ECFRC_CEVT3_Pos)                     /*!< NT_CAP2 ECFRC: CEVT3 Mask               */
#define NT_CAP2_ECFRC_CTR_OVF_Pos             5                                                       /*!< NT_CAP2 ECFRC: CTR_OVF Position         */
#define NT_CAP2_ECFRC_CTR_OVF_Msk             (0x01UL << NT_CAP2_ECFRC_CTR_OVF_Pos)                   /*!< NT_CAP2 ECFRC: CTR_OVF Mask             */
#define NT_CAP2_ECFRC_CTR_PRD_Pos             6                                                       /*!< NT_CAP2 ECFRC: CTR_PRD Position         */
#define NT_CAP2_ECFRC_CTR_PRD_Msk             (0x01UL << NT_CAP2_ECFRC_CTR_PRD_Pos)                   /*!< NT_CAP2 ECFRC: CTR_PRD Mask             */
#define NT_CAP2_ECFRC_CTR_CMP_Pos             7                                                       /*!< NT_CAP2 ECFRC: CTR_CMP Position         */
#define NT_CAP2_ECFRC_CTR_CMP_Msk             (0x01UL << NT_CAP2_ECFRC_CTR_CMP_Pos)                   /*!< NT_CAP2 ECFRC: CTR_CMP Mask             */

/* --------------------------------  NT_CAP2_PEINT  ------------------------------- */
#define NT_CAP2_PEINT_PEINT_Pos               0                                                       /*!< NT_CAP2 PEINT: PEINT Position           */
#define NT_CAP2_PEINT_PEINT_Msk               (0x01UL << NT_CAP2_PEINT_PEINT_Pos)                     /*!< NT_CAP2 PEINT: PEINT Mask               */


/* ================================================================================ */
/* ================        struct 'NT_CAP3' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_CAP3_TSCTR  ------------------------------- */
#define NT_CAP3_TSCTR_VALUE_Pos               0                                                       /*!< NT_CAP3 TSCTR: VALUE Position           */
#define NT_CAP3_TSCTR_VALUE_Msk               (0xffffffffUL << NT_CAP3_TSCTR_VALUE_Pos)               /*!< NT_CAP3 TSCTR: VALUE Mask               */

/* -------------------------------  NT_CAP3_CTRPHS  ------------------------------- */
#define NT_CAP3_CTRPHS_VALUE_Pos              0                                                       /*!< NT_CAP3 CTRPHS: VALUE Position          */
#define NT_CAP3_CTRPHS_VALUE_Msk              (0xffffffffUL << NT_CAP3_CTRPHS_VALUE_Pos)              /*!< NT_CAP3 CTRPHS: VALUE Mask              */

/* --------------------------------  NT_CAP3_CAP0  -------------------------------- */
#define NT_CAP3_CAP0_VALUE_Pos                0                                                       /*!< NT_CAP3 CAP0: VALUE Position            */
#define NT_CAP3_CAP0_VALUE_Msk                (0xffffffffUL << NT_CAP3_CAP0_VALUE_Pos)                /*!< NT_CAP3 CAP0: VALUE Mask                */

/* --------------------------------  NT_CAP3_CAP1  -------------------------------- */
#define NT_CAP3_CAP1_VALUE_Pos                0                                                       /*!< NT_CAP3 CAP1: VALUE Position            */
#define NT_CAP3_CAP1_VALUE_Msk                (0xffffffffUL << NT_CAP3_CAP1_VALUE_Pos)                /*!< NT_CAP3 CAP1: VALUE Mask                */

/* --------------------------------  NT_CAP3_CAP2  -------------------------------- */
#define NT_CAP3_CAP2_VALUE_Pos                0                                                       /*!< NT_CAP3 CAP2: VALUE Position            */
#define NT_CAP3_CAP2_VALUE_Msk                (0xffffffffUL << NT_CAP3_CAP2_VALUE_Pos)                /*!< NT_CAP3 CAP2: VALUE Mask                */

/* --------------------------------  NT_CAP3_CAP3  -------------------------------- */
#define NT_CAP3_CAP3_VALUE_Pos                0                                                       /*!< NT_CAP3 CAP3: VALUE Position            */
#define NT_CAP3_CAP3_VALUE_Msk                (0xffffffffUL << NT_CAP3_CAP3_VALUE_Pos)                /*!< NT_CAP3 CAP3: VALUE Mask                */

/* -------------------------------  NT_CAP3_ECCTL0  ------------------------------- */
#define NT_CAP3_ECCTL0_CAP0_POL_Pos           0                                                       /*!< NT_CAP3 ECCTL0: CAP0_POL Position       */
#define NT_CAP3_ECCTL0_CAP0_POL_Msk           (0x01UL << NT_CAP3_ECCTL0_CAP0_POL_Pos)                 /*!< NT_CAP3 ECCTL0: CAP0_POL Mask           */
#define NT_CAP3_ECCTL0_CTR_RST0_Pos           1                                                       /*!< NT_CAP3 ECCTL0: CTR_RST0 Position       */
#define NT_CAP3_ECCTL0_CTR_RST0_Msk           (0x01UL << NT_CAP3_ECCTL0_CTR_RST0_Pos)                 /*!< NT_CAP3 ECCTL0: CTR_RST0 Mask           */
#define NT_CAP3_ECCTL0_CAP1_POL_Pos           2                                                       /*!< NT_CAP3 ECCTL0: CAP1_POL Position       */
#define NT_CAP3_ECCTL0_CAP1_POL_Msk           (0x01UL << NT_CAP3_ECCTL0_CAP1_POL_Pos)                 /*!< NT_CAP3 ECCTL0: CAP1_POL Mask           */
#define NT_CAP3_ECCTL0_CTR_RST1_Pos           3                                                       /*!< NT_CAP3 ECCTL0: CTR_RST1 Position       */
#define NT_CAP3_ECCTL0_CTR_RST1_Msk           (0x01UL << NT_CAP3_ECCTL0_CTR_RST1_Pos)                 /*!< NT_CAP3 ECCTL0: CTR_RST1 Mask           */
#define NT_CAP3_ECCTL0_CAP2_POL_Pos           4                                                       /*!< NT_CAP3 ECCTL0: CAP2_POL Position       */
#define NT_CAP3_ECCTL0_CAP2_POL_Msk           (0x01UL << NT_CAP3_ECCTL0_CAP2_POL_Pos)                 /*!< NT_CAP3 ECCTL0: CAP2_POL Mask           */
#define NT_CAP3_ECCTL0_CTR_RST2_Pos           5                                                       /*!< NT_CAP3 ECCTL0: CTR_RST2 Position       */
#define NT_CAP3_ECCTL0_CTR_RST2_Msk           (0x01UL << NT_CAP3_ECCTL0_CTR_RST2_Pos)                 /*!< NT_CAP3 ECCTL0: CTR_RST2 Mask           */
#define NT_CAP3_ECCTL0_CAP3_POL_Pos           6                                                       /*!< NT_CAP3 ECCTL0: CAP3_POL Position       */
#define NT_CAP3_ECCTL0_CAP3_POL_Msk           (0x01UL << NT_CAP3_ECCTL0_CAP3_POL_Pos)                 /*!< NT_CAP3 ECCTL0: CAP3_POL Mask           */
#define NT_CAP3_ECCTL0_CTR_RST3_Pos           7                                                       /*!< NT_CAP3 ECCTL0: CTR_RST3 Position       */
#define NT_CAP3_ECCTL0_CTR_RST3_Msk           (0x01UL << NT_CAP3_ECCTL0_CTR_RST3_Pos)                 /*!< NT_CAP3 ECCTL0: CTR_RST3 Mask           */
#define NT_CAP3_ECCTL0_CAPLDEN_Pos            8                                                       /*!< NT_CAP3 ECCTL0: CAPLDEN Position        */
#define NT_CAP3_ECCTL0_CAPLDEN_Msk            (0x01UL << NT_CAP3_ECCTL0_CAPLDEN_Pos)                  /*!< NT_CAP3 ECCTL0: CAPLDEN Mask            */
#define NT_CAP3_ECCTL0_PRESCALE_Pos           9                                                       /*!< NT_CAP3 ECCTL0: PRESCALE Position       */
#define NT_CAP3_ECCTL0_PRESCALE_Msk           (0x1fUL << NT_CAP3_ECCTL0_PRESCALE_Pos)                 /*!< NT_CAP3 ECCTL0: PRESCALE Mask           */
#define NT_CAP3_ECCTL0_FREE_SOFT_Pos          14                                                      /*!< NT_CAP3 ECCTL0: FREE_SOFT Position      */
#define NT_CAP3_ECCTL0_FREE_SOFT_Msk          (0x03UL << NT_CAP3_ECCTL0_FREE_SOFT_Pos)                /*!< NT_CAP3 ECCTL0: FREE_SOFT Mask          */

/* -------------------------------  NT_CAP3_ECCTL1  ------------------------------- */
#define NT_CAP3_ECCTL1_SWSYNC_Pos             0                                                       /*!< NT_CAP3 ECCTL1: SWSYNC Position         */
#define NT_CAP3_ECCTL1_SWSYNC_Msk             (0x01UL << NT_CAP3_ECCTL1_SWSYNC_Pos)                   /*!< NT_CAP3 ECCTL1: SWSYNC Mask             */
#define NT_CAP3_ECCTL1_CAP_APWM_Pos           1                                                       /*!< NT_CAP3 ECCTL1: CAP_APWM Position       */
#define NT_CAP3_ECCTL1_CAP_APWM_Msk           (0x01UL << NT_CAP3_ECCTL1_CAP_APWM_Pos)                 /*!< NT_CAP3 ECCTL1: CAP_APWM Mask           */
#define NT_CAP3_ECCTL1_APWM_POL_Pos           2                                                       /*!< NT_CAP3 ECCTL1: APWM_POL Position       */
#define NT_CAP3_ECCTL1_APWM_POL_Msk           (0x01UL << NT_CAP3_ECCTL1_APWM_POL_Pos)                 /*!< NT_CAP3 ECCTL1: APWM_POL Mask           */
#define NT_CAP3_ECCTL1_CONT_ONESHT_Pos        8                                                       /*!< NT_CAP3 ECCTL1: CONT_ONESHT Position    */
#define NT_CAP3_ECCTL1_CONT_ONESHT_Msk        (0x01UL << NT_CAP3_ECCTL1_CONT_ONESHT_Pos)              /*!< NT_CAP3 ECCTL1: CONT_ONESHT Mask        */
#define NT_CAP3_ECCTL1_STOP_WRAP_Pos          9                                                       /*!< NT_CAP3 ECCTL1: STOP_WRAP Position      */
#define NT_CAP3_ECCTL1_STOP_WRAP_Msk          (0x03UL << NT_CAP3_ECCTL1_STOP_WRAP_Pos)                /*!< NT_CAP3 ECCTL1: STOP_WRAP Mask          */
#define NT_CAP3_ECCTL1_REARM_Pos              11                                                      /*!< NT_CAP3 ECCTL1: REARM Position          */
#define NT_CAP3_ECCTL1_REARM_Msk              (0x01UL << NT_CAP3_ECCTL1_REARM_Pos)                    /*!< NT_CAP3 ECCTL1: REARM Mask              */
#define NT_CAP3_ECCTL1_TSCTRSTOP_Pos          12                                                      /*!< NT_CAP3 ECCTL1: TSCTRSTOP Position      */
#define NT_CAP3_ECCTL1_TSCTRSTOP_Msk          (0x01UL << NT_CAP3_ECCTL1_TSCTRSTOP_Pos)                /*!< NT_CAP3 ECCTL1: TSCTRSTOP Mask          */
#define NT_CAP3_ECCTL1_SYNCI_EN_Pos           13                                                      /*!< NT_CAP3 ECCTL1: SYNCI_EN Position       */
#define NT_CAP3_ECCTL1_SYNCI_EN_Msk           (0x01UL << NT_CAP3_ECCTL1_SYNCI_EN_Pos)                 /*!< NT_CAP3 ECCTL1: SYNCI_EN Mask           */
#define NT_CAP3_ECCTL1_SYNCO_SEL_Pos          14                                                      /*!< NT_CAP3 ECCTL1: SYNCO_SEL Position      */
#define NT_CAP3_ECCTL1_SYNCO_SEL_Msk          (0x03UL << NT_CAP3_ECCTL1_SYNCO_SEL_Pos)                /*!< NT_CAP3 ECCTL1: SYNCO_SEL Mask          */

/* -------------------------------  NT_CAP3_ECEINT  ------------------------------- */
#define NT_CAP3_ECEINT_CEVT0_Pos              1                                                       /*!< NT_CAP3 ECEINT: CEVT0 Position          */
#define NT_CAP3_ECEINT_CEVT0_Msk              (0x01UL << NT_CAP3_ECEINT_CEVT0_Pos)                    /*!< NT_CAP3 ECEINT: CEVT0 Mask              */
#define NT_CAP3_ECEINT_CEVT1_Pos              2                                                       /*!< NT_CAP3 ECEINT: CEVT1 Position          */
#define NT_CAP3_ECEINT_CEVT1_Msk              (0x01UL << NT_CAP3_ECEINT_CEVT1_Pos)                    /*!< NT_CAP3 ECEINT: CEVT1 Mask              */
#define NT_CAP3_ECEINT_CEVT2_Pos              3                                                       /*!< NT_CAP3 ECEINT: CEVT2 Position          */
#define NT_CAP3_ECEINT_CEVT2_Msk              (0x01UL << NT_CAP3_ECEINT_CEVT2_Pos)                    /*!< NT_CAP3 ECEINT: CEVT2 Mask              */
#define NT_CAP3_ECEINT_CEVT3_Pos              4                                                       /*!< NT_CAP3 ECEINT: CEVT3 Position          */
#define NT_CAP3_ECEINT_CEVT3_Msk              (0x01UL << NT_CAP3_ECEINT_CEVT3_Pos)                    /*!< NT_CAP3 ECEINT: CEVT3 Mask              */
#define NT_CAP3_ECEINT_CTR_OVF_Pos            5                                                       /*!< NT_CAP3 ECEINT: CTR_OVF Position        */
#define NT_CAP3_ECEINT_CTR_OVF_Msk            (0x01UL << NT_CAP3_ECEINT_CTR_OVF_Pos)                  /*!< NT_CAP3 ECEINT: CTR_OVF Mask            */
#define NT_CAP3_ECEINT_CTR_PRD_Pos            6                                                       /*!< NT_CAP3 ECEINT: CTR_PRD Position        */
#define NT_CAP3_ECEINT_CTR_PRD_Msk            (0x01UL << NT_CAP3_ECEINT_CTR_PRD_Pos)                  /*!< NT_CAP3 ECEINT: CTR_PRD Mask            */
#define NT_CAP3_ECEINT_CTR_CMP_Pos            7                                                       /*!< NT_CAP3 ECEINT: CTR_CMP Position        */
#define NT_CAP3_ECEINT_CTR_CMP_Msk            (0x01UL << NT_CAP3_ECEINT_CTR_CMP_Pos)                  /*!< NT_CAP3 ECEINT: CTR_CMP Mask            */

/* --------------------------------  NT_CAP3_ECFLG  ------------------------------- */
#define NT_CAP3_ECFLG_INT_Pos                 0                                                       /*!< NT_CAP3 ECFLG: INT Position             */
#define NT_CAP3_ECFLG_INT_Msk                 (0x01UL << NT_CAP3_ECFLG_INT_Pos)                       /*!< NT_CAP3 ECFLG: INT Mask                 */
#define NT_CAP3_ECFLG_CEVT0_Pos               1                                                       /*!< NT_CAP3 ECFLG: CEVT0 Position           */
#define NT_CAP3_ECFLG_CEVT0_Msk               (0x01UL << NT_CAP3_ECFLG_CEVT0_Pos)                     /*!< NT_CAP3 ECFLG: CEVT0 Mask               */
#define NT_CAP3_ECFLG_CEVT1_Pos               2                                                       /*!< NT_CAP3 ECFLG: CEVT1 Position           */
#define NT_CAP3_ECFLG_CEVT1_Msk               (0x01UL << NT_CAP3_ECFLG_CEVT1_Pos)                     /*!< NT_CAP3 ECFLG: CEVT1 Mask               */
#define NT_CAP3_ECFLG_CEVT2_Pos               3                                                       /*!< NT_CAP3 ECFLG: CEVT2 Position           */
#define NT_CAP3_ECFLG_CEVT2_Msk               (0x01UL << NT_CAP3_ECFLG_CEVT2_Pos)                     /*!< NT_CAP3 ECFLG: CEVT2 Mask               */
#define NT_CAP3_ECFLG_CEVT3_Pos               4                                                       /*!< NT_CAP3 ECFLG: CEVT3 Position           */
#define NT_CAP3_ECFLG_CEVT3_Msk               (0x01UL << NT_CAP3_ECFLG_CEVT3_Pos)                     /*!< NT_CAP3 ECFLG: CEVT3 Mask               */
#define NT_CAP3_ECFLG_CTR_OVF_Pos             5                                                       /*!< NT_CAP3 ECFLG: CTR_OVF Position         */
#define NT_CAP3_ECFLG_CTR_OVF_Msk             (0x01UL << NT_CAP3_ECFLG_CTR_OVF_Pos)                   /*!< NT_CAP3 ECFLG: CTR_OVF Mask             */
#define NT_CAP3_ECFLG_CTR_PRD_Pos             6                                                       /*!< NT_CAP3 ECFLG: CTR_PRD Position         */
#define NT_CAP3_ECFLG_CTR_PRD_Msk             (0x01UL << NT_CAP3_ECFLG_CTR_PRD_Pos)                   /*!< NT_CAP3 ECFLG: CTR_PRD Mask             */
#define NT_CAP3_ECFLG_CTR_CMP_Pos             7                                                       /*!< NT_CAP3 ECFLG: CTR_CMP Position         */
#define NT_CAP3_ECFLG_CTR_CMP_Msk             (0x01UL << NT_CAP3_ECFLG_CTR_CMP_Pos)                   /*!< NT_CAP3 ECFLG: CTR_CMP Mask             */

/* --------------------------------  NT_CAP3_ECCLR  ------------------------------- */
#define NT_CAP3_ECCLR_INT_Pos                 0                                                       /*!< NT_CAP3 ECCLR: INT Position             */
#define NT_CAP3_ECCLR_INT_Msk                 (0x01UL << NT_CAP3_ECCLR_INT_Pos)                       /*!< NT_CAP3 ECCLR: INT Mask                 */
#define NT_CAP3_ECCLR_CEVT0_Pos               1                                                       /*!< NT_CAP3 ECCLR: CEVT0 Position           */
#define NT_CAP3_ECCLR_CEVT0_Msk               (0x01UL << NT_CAP3_ECCLR_CEVT0_Pos)                     /*!< NT_CAP3 ECCLR: CEVT0 Mask               */
#define NT_CAP3_ECCLR_CEVT1_Pos               2                                                       /*!< NT_CAP3 ECCLR: CEVT1 Position           */
#define NT_CAP3_ECCLR_CEVT1_Msk               (0x01UL << NT_CAP3_ECCLR_CEVT1_Pos)                     /*!< NT_CAP3 ECCLR: CEVT1 Mask               */
#define NT_CAP3_ECCLR_CEVT2_Pos               3                                                       /*!< NT_CAP3 ECCLR: CEVT2 Position           */
#define NT_CAP3_ECCLR_CEVT2_Msk               (0x01UL << NT_CAP3_ECCLR_CEVT2_Pos)                     /*!< NT_CAP3 ECCLR: CEVT2 Mask               */
#define NT_CAP3_ECCLR_CEVT3_Pos               4                                                       /*!< NT_CAP3 ECCLR: CEVT3 Position           */
#define NT_CAP3_ECCLR_CEVT3_Msk               (0x01UL << NT_CAP3_ECCLR_CEVT3_Pos)                     /*!< NT_CAP3 ECCLR: CEVT3 Mask               */
#define NT_CAP3_ECCLR_CTR_OVF_Pos             5                                                       /*!< NT_CAP3 ECCLR: CTR_OVF Position         */
#define NT_CAP3_ECCLR_CTR_OVF_Msk             (0x01UL << NT_CAP3_ECCLR_CTR_OVF_Pos)                   /*!< NT_CAP3 ECCLR: CTR_OVF Mask             */
#define NT_CAP3_ECCLR_CTR_PRD_Pos             6                                                       /*!< NT_CAP3 ECCLR: CTR_PRD Position         */
#define NT_CAP3_ECCLR_CTR_PRD_Msk             (0x01UL << NT_CAP3_ECCLR_CTR_PRD_Pos)                   /*!< NT_CAP3 ECCLR: CTR_PRD Mask             */
#define NT_CAP3_ECCLR_CTR_CMP_Pos             7                                                       /*!< NT_CAP3 ECCLR: CTR_CMP Position         */
#define NT_CAP3_ECCLR_CTR_CMP_Msk             (0x01UL << NT_CAP3_ECCLR_CTR_CMP_Pos)                   /*!< NT_CAP3 ECCLR: CTR_CMP Mask             */

/* --------------------------------  NT_CAP3_ECFRC  ------------------------------- */
#define NT_CAP3_ECFRC_CEVT0_Pos               1                                                       /*!< NT_CAP3 ECFRC: CEVT0 Position           */
#define NT_CAP3_ECFRC_CEVT0_Msk               (0x01UL << NT_CAP3_ECFRC_CEVT0_Pos)                     /*!< NT_CAP3 ECFRC: CEVT0 Mask               */
#define NT_CAP3_ECFRC_CEVT1_Pos               2                                                       /*!< NT_CAP3 ECFRC: CEVT1 Position           */
#define NT_CAP3_ECFRC_CEVT1_Msk               (0x01UL << NT_CAP3_ECFRC_CEVT1_Pos)                     /*!< NT_CAP3 ECFRC: CEVT1 Mask               */
#define NT_CAP3_ECFRC_CEVT2_Pos               3                                                       /*!< NT_CAP3 ECFRC: CEVT2 Position           */
#define NT_CAP3_ECFRC_CEVT2_Msk               (0x01UL << NT_CAP3_ECFRC_CEVT2_Pos)                     /*!< NT_CAP3 ECFRC: CEVT2 Mask               */
#define NT_CAP3_ECFRC_CEVT3_Pos               4                                                       /*!< NT_CAP3 ECFRC: CEVT3 Position           */
#define NT_CAP3_ECFRC_CEVT3_Msk               (0x01UL << NT_CAP3_ECFRC_CEVT3_Pos)                     /*!< NT_CAP3 ECFRC: CEVT3 Mask               */
#define NT_CAP3_ECFRC_CTR_OVF_Pos             5                                                       /*!< NT_CAP3 ECFRC: CTR_OVF Position         */
#define NT_CAP3_ECFRC_CTR_OVF_Msk             (0x01UL << NT_CAP3_ECFRC_CTR_OVF_Pos)                   /*!< NT_CAP3 ECFRC: CTR_OVF Mask             */
#define NT_CAP3_ECFRC_CTR_PRD_Pos             6                                                       /*!< NT_CAP3 ECFRC: CTR_PRD Position         */
#define NT_CAP3_ECFRC_CTR_PRD_Msk             (0x01UL << NT_CAP3_ECFRC_CTR_PRD_Pos)                   /*!< NT_CAP3 ECFRC: CTR_PRD Mask             */
#define NT_CAP3_ECFRC_CTR_CMP_Pos             7                                                       /*!< NT_CAP3 ECFRC: CTR_CMP Position         */
#define NT_CAP3_ECFRC_CTR_CMP_Msk             (0x01UL << NT_CAP3_ECFRC_CTR_CMP_Pos)                   /*!< NT_CAP3 ECFRC: CTR_CMP Mask             */

/* --------------------------------  NT_CAP3_PEINT  ------------------------------- */
#define NT_CAP3_PEINT_PEINT_Pos               0                                                       /*!< NT_CAP3 PEINT: PEINT Position           */
#define NT_CAP3_PEINT_PEINT_Msk               (0x01UL << NT_CAP3_PEINT_PEINT_Pos)                     /*!< NT_CAP3 PEINT: PEINT Mask               */


/* ================================================================================ */
/* ================        struct 'NT_CAP4' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_CAP4_TSCTR  ------------------------------- */
#define NT_CAP4_TSCTR_VALUE_Pos               0                                                       /*!< NT_CAP4 TSCTR: VALUE Position           */
#define NT_CAP4_TSCTR_VALUE_Msk               (0xffffffffUL << NT_CAP4_TSCTR_VALUE_Pos)               /*!< NT_CAP4 TSCTR: VALUE Mask               */

/* -------------------------------  NT_CAP4_CTRPHS  ------------------------------- */
#define NT_CAP4_CTRPHS_VALUE_Pos              0                                                       /*!< NT_CAP4 CTRPHS: VALUE Position          */
#define NT_CAP4_CTRPHS_VALUE_Msk              (0xffffffffUL << NT_CAP4_CTRPHS_VALUE_Pos)              /*!< NT_CAP4 CTRPHS: VALUE Mask              */

/* --------------------------------  NT_CAP4_CAP0  -------------------------------- */
#define NT_CAP4_CAP0_VALUE_Pos                0                                                       /*!< NT_CAP4 CAP0: VALUE Position            */
#define NT_CAP4_CAP0_VALUE_Msk                (0xffffffffUL << NT_CAP4_CAP0_VALUE_Pos)                /*!< NT_CAP4 CAP0: VALUE Mask                */

/* --------------------------------  NT_CAP4_CAP1  -------------------------------- */
#define NT_CAP4_CAP1_VALUE_Pos                0                                                       /*!< NT_CAP4 CAP1: VALUE Position            */
#define NT_CAP4_CAP1_VALUE_Msk                (0xffffffffUL << NT_CAP4_CAP1_VALUE_Pos)                /*!< NT_CAP4 CAP1: VALUE Mask                */

/* --------------------------------  NT_CAP4_CAP2  -------------------------------- */
#define NT_CAP4_CAP2_VALUE_Pos                0                                                       /*!< NT_CAP4 CAP2: VALUE Position            */
#define NT_CAP4_CAP2_VALUE_Msk                (0xffffffffUL << NT_CAP4_CAP2_VALUE_Pos)                /*!< NT_CAP4 CAP2: VALUE Mask                */

/* --------------------------------  NT_CAP4_CAP3  -------------------------------- */
#define NT_CAP4_CAP3_VALUE_Pos                0                                                       /*!< NT_CAP4 CAP3: VALUE Position            */
#define NT_CAP4_CAP3_VALUE_Msk                (0xffffffffUL << NT_CAP4_CAP3_VALUE_Pos)                /*!< NT_CAP4 CAP3: VALUE Mask                */

/* -------------------------------  NT_CAP4_ECCTL0  ------------------------------- */
#define NT_CAP4_ECCTL0_CAP0_POL_Pos           0                                                       /*!< NT_CAP4 ECCTL0: CAP0_POL Position       */
#define NT_CAP4_ECCTL0_CAP0_POL_Msk           (0x01UL << NT_CAP4_ECCTL0_CAP0_POL_Pos)                 /*!< NT_CAP4 ECCTL0: CAP0_POL Mask           */
#define NT_CAP4_ECCTL0_CTR_RST0_Pos           1                                                       /*!< NT_CAP4 ECCTL0: CTR_RST0 Position       */
#define NT_CAP4_ECCTL0_CTR_RST0_Msk           (0x01UL << NT_CAP4_ECCTL0_CTR_RST0_Pos)                 /*!< NT_CAP4 ECCTL0: CTR_RST0 Mask           */
#define NT_CAP4_ECCTL0_CAP1_POL_Pos           2                                                       /*!< NT_CAP4 ECCTL0: CAP1_POL Position       */
#define NT_CAP4_ECCTL0_CAP1_POL_Msk           (0x01UL << NT_CAP4_ECCTL0_CAP1_POL_Pos)                 /*!< NT_CAP4 ECCTL0: CAP1_POL Mask           */
#define NT_CAP4_ECCTL0_CTR_RST1_Pos           3                                                       /*!< NT_CAP4 ECCTL0: CTR_RST1 Position       */
#define NT_CAP4_ECCTL0_CTR_RST1_Msk           (0x01UL << NT_CAP4_ECCTL0_CTR_RST1_Pos)                 /*!< NT_CAP4 ECCTL0: CTR_RST1 Mask           */
#define NT_CAP4_ECCTL0_CAP2_POL_Pos           4                                                       /*!< NT_CAP4 ECCTL0: CAP2_POL Position       */
#define NT_CAP4_ECCTL0_CAP2_POL_Msk           (0x01UL << NT_CAP4_ECCTL0_CAP2_POL_Pos)                 /*!< NT_CAP4 ECCTL0: CAP2_POL Mask           */
#define NT_CAP4_ECCTL0_CTR_RST2_Pos           5                                                       /*!< NT_CAP4 ECCTL0: CTR_RST2 Position       */
#define NT_CAP4_ECCTL0_CTR_RST2_Msk           (0x01UL << NT_CAP4_ECCTL0_CTR_RST2_Pos)                 /*!< NT_CAP4 ECCTL0: CTR_RST2 Mask           */
#define NT_CAP4_ECCTL0_CAP3_POL_Pos           6                                                       /*!< NT_CAP4 ECCTL0: CAP3_POL Position       */
#define NT_CAP4_ECCTL0_CAP3_POL_Msk           (0x01UL << NT_CAP4_ECCTL0_CAP3_POL_Pos)                 /*!< NT_CAP4 ECCTL0: CAP3_POL Mask           */
#define NT_CAP4_ECCTL0_CTR_RST3_Pos           7                                                       /*!< NT_CAP4 ECCTL0: CTR_RST3 Position       */
#define NT_CAP4_ECCTL0_CTR_RST3_Msk           (0x01UL << NT_CAP4_ECCTL0_CTR_RST3_Pos)                 /*!< NT_CAP4 ECCTL0: CTR_RST3 Mask           */
#define NT_CAP4_ECCTL0_CAPLDEN_Pos            8                                                       /*!< NT_CAP4 ECCTL0: CAPLDEN Position        */
#define NT_CAP4_ECCTL0_CAPLDEN_Msk            (0x01UL << NT_CAP4_ECCTL0_CAPLDEN_Pos)                  /*!< NT_CAP4 ECCTL0: CAPLDEN Mask            */
#define NT_CAP4_ECCTL0_PRESCALE_Pos           9                                                       /*!< NT_CAP4 ECCTL0: PRESCALE Position       */
#define NT_CAP4_ECCTL0_PRESCALE_Msk           (0x1fUL << NT_CAP4_ECCTL0_PRESCALE_Pos)                 /*!< NT_CAP4 ECCTL0: PRESCALE Mask           */
#define NT_CAP4_ECCTL0_FREE_SOFT_Pos          14                                                      /*!< NT_CAP4 ECCTL0: FREE_SOFT Position      */
#define NT_CAP4_ECCTL0_FREE_SOFT_Msk          (0x03UL << NT_CAP4_ECCTL0_FREE_SOFT_Pos)                /*!< NT_CAP4 ECCTL0: FREE_SOFT Mask          */

/* -------------------------------  NT_CAP4_ECCTL1  ------------------------------- */
#define NT_CAP4_ECCTL1_SWSYNC_Pos             0                                                       /*!< NT_CAP4 ECCTL1: SWSYNC Position         */
#define NT_CAP4_ECCTL1_SWSYNC_Msk             (0x01UL << NT_CAP4_ECCTL1_SWSYNC_Pos)                   /*!< NT_CAP4 ECCTL1: SWSYNC Mask             */
#define NT_CAP4_ECCTL1_CAP_APWM_Pos           1                                                       /*!< NT_CAP4 ECCTL1: CAP_APWM Position       */
#define NT_CAP4_ECCTL1_CAP_APWM_Msk           (0x01UL << NT_CAP4_ECCTL1_CAP_APWM_Pos)                 /*!< NT_CAP4 ECCTL1: CAP_APWM Mask           */
#define NT_CAP4_ECCTL1_APWM_POL_Pos           2                                                       /*!< NT_CAP4 ECCTL1: APWM_POL Position       */
#define NT_CAP4_ECCTL1_APWM_POL_Msk           (0x01UL << NT_CAP4_ECCTL1_APWM_POL_Pos)                 /*!< NT_CAP4 ECCTL1: APWM_POL Mask           */
#define NT_CAP4_ECCTL1_CONT_ONESHT_Pos        8                                                       /*!< NT_CAP4 ECCTL1: CONT_ONESHT Position    */
#define NT_CAP4_ECCTL1_CONT_ONESHT_Msk        (0x01UL << NT_CAP4_ECCTL1_CONT_ONESHT_Pos)              /*!< NT_CAP4 ECCTL1: CONT_ONESHT Mask        */
#define NT_CAP4_ECCTL1_STOP_WRAP_Pos          9                                                       /*!< NT_CAP4 ECCTL1: STOP_WRAP Position      */
#define NT_CAP4_ECCTL1_STOP_WRAP_Msk          (0x03UL << NT_CAP4_ECCTL1_STOP_WRAP_Pos)                /*!< NT_CAP4 ECCTL1: STOP_WRAP Mask          */
#define NT_CAP4_ECCTL1_REARM_Pos              11                                                      /*!< NT_CAP4 ECCTL1: REARM Position          */
#define NT_CAP4_ECCTL1_REARM_Msk              (0x01UL << NT_CAP4_ECCTL1_REARM_Pos)                    /*!< NT_CAP4 ECCTL1: REARM Mask              */
#define NT_CAP4_ECCTL1_TSCTRSTOP_Pos          12                                                      /*!< NT_CAP4 ECCTL1: TSCTRSTOP Position      */
#define NT_CAP4_ECCTL1_TSCTRSTOP_Msk          (0x01UL << NT_CAP4_ECCTL1_TSCTRSTOP_Pos)                /*!< NT_CAP4 ECCTL1: TSCTRSTOP Mask          */
#define NT_CAP4_ECCTL1_SYNCI_EN_Pos           13                                                      /*!< NT_CAP4 ECCTL1: SYNCI_EN Position       */
#define NT_CAP4_ECCTL1_SYNCI_EN_Msk           (0x01UL << NT_CAP4_ECCTL1_SYNCI_EN_Pos)                 /*!< NT_CAP4 ECCTL1: SYNCI_EN Mask           */
#define NT_CAP4_ECCTL1_SYNCO_SEL_Pos          14                                                      /*!< NT_CAP4 ECCTL1: SYNCO_SEL Position      */
#define NT_CAP4_ECCTL1_SYNCO_SEL_Msk          (0x03UL << NT_CAP4_ECCTL1_SYNCO_SEL_Pos)                /*!< NT_CAP4 ECCTL1: SYNCO_SEL Mask          */

/* -------------------------------  NT_CAP4_ECEINT  ------------------------------- */
#define NT_CAP4_ECEINT_CEVT0_Pos              1                                                       /*!< NT_CAP4 ECEINT: CEVT0 Position          */
#define NT_CAP4_ECEINT_CEVT0_Msk              (0x01UL << NT_CAP4_ECEINT_CEVT0_Pos)                    /*!< NT_CAP4 ECEINT: CEVT0 Mask              */
#define NT_CAP4_ECEINT_CEVT1_Pos              2                                                       /*!< NT_CAP4 ECEINT: CEVT1 Position          */
#define NT_CAP4_ECEINT_CEVT1_Msk              (0x01UL << NT_CAP4_ECEINT_CEVT1_Pos)                    /*!< NT_CAP4 ECEINT: CEVT1 Mask              */
#define NT_CAP4_ECEINT_CEVT2_Pos              3                                                       /*!< NT_CAP4 ECEINT: CEVT2 Position          */
#define NT_CAP4_ECEINT_CEVT2_Msk              (0x01UL << NT_CAP4_ECEINT_CEVT2_Pos)                    /*!< NT_CAP4 ECEINT: CEVT2 Mask              */
#define NT_CAP4_ECEINT_CEVT3_Pos              4                                                       /*!< NT_CAP4 ECEINT: CEVT3 Position          */
#define NT_CAP4_ECEINT_CEVT3_Msk              (0x01UL << NT_CAP4_ECEINT_CEVT3_Pos)                    /*!< NT_CAP4 ECEINT: CEVT3 Mask              */
#define NT_CAP4_ECEINT_CTR_OVF_Pos            5                                                       /*!< NT_CAP4 ECEINT: CTR_OVF Position        */
#define NT_CAP4_ECEINT_CTR_OVF_Msk            (0x01UL << NT_CAP4_ECEINT_CTR_OVF_Pos)                  /*!< NT_CAP4 ECEINT: CTR_OVF Mask            */
#define NT_CAP4_ECEINT_CTR_PRD_Pos            6                                                       /*!< NT_CAP4 ECEINT: CTR_PRD Position        */
#define NT_CAP4_ECEINT_CTR_PRD_Msk            (0x01UL << NT_CAP4_ECEINT_CTR_PRD_Pos)                  /*!< NT_CAP4 ECEINT: CTR_PRD Mask            */
#define NT_CAP4_ECEINT_CTR_CMP_Pos            7                                                       /*!< NT_CAP4 ECEINT: CTR_CMP Position        */
#define NT_CAP4_ECEINT_CTR_CMP_Msk            (0x01UL << NT_CAP4_ECEINT_CTR_CMP_Pos)                  /*!< NT_CAP4 ECEINT: CTR_CMP Mask            */

/* --------------------------------  NT_CAP4_ECFLG  ------------------------------- */
#define NT_CAP4_ECFLG_INT_Pos                 0                                                       /*!< NT_CAP4 ECFLG: INT Position             */
#define NT_CAP4_ECFLG_INT_Msk                 (0x01UL << NT_CAP4_ECFLG_INT_Pos)                       /*!< NT_CAP4 ECFLG: INT Mask                 */
#define NT_CAP4_ECFLG_CEVT0_Pos               1                                                       /*!< NT_CAP4 ECFLG: CEVT0 Position           */
#define NT_CAP4_ECFLG_CEVT0_Msk               (0x01UL << NT_CAP4_ECFLG_CEVT0_Pos)                     /*!< NT_CAP4 ECFLG: CEVT0 Mask               */
#define NT_CAP4_ECFLG_CEVT1_Pos               2                                                       /*!< NT_CAP4 ECFLG: CEVT1 Position           */
#define NT_CAP4_ECFLG_CEVT1_Msk               (0x01UL << NT_CAP4_ECFLG_CEVT1_Pos)                     /*!< NT_CAP4 ECFLG: CEVT1 Mask               */
#define NT_CAP4_ECFLG_CEVT2_Pos               3                                                       /*!< NT_CAP4 ECFLG: CEVT2 Position           */
#define NT_CAP4_ECFLG_CEVT2_Msk               (0x01UL << NT_CAP4_ECFLG_CEVT2_Pos)                     /*!< NT_CAP4 ECFLG: CEVT2 Mask               */
#define NT_CAP4_ECFLG_CEVT3_Pos               4                                                       /*!< NT_CAP4 ECFLG: CEVT3 Position           */
#define NT_CAP4_ECFLG_CEVT3_Msk               (0x01UL << NT_CAP4_ECFLG_CEVT3_Pos)                     /*!< NT_CAP4 ECFLG: CEVT3 Mask               */
#define NT_CAP4_ECFLG_CTR_OVF_Pos             5                                                       /*!< NT_CAP4 ECFLG: CTR_OVF Position         */
#define NT_CAP4_ECFLG_CTR_OVF_Msk             (0x01UL << NT_CAP4_ECFLG_CTR_OVF_Pos)                   /*!< NT_CAP4 ECFLG: CTR_OVF Mask             */
#define NT_CAP4_ECFLG_CTR_PRD_Pos             6                                                       /*!< NT_CAP4 ECFLG: CTR_PRD Position         */
#define NT_CAP4_ECFLG_CTR_PRD_Msk             (0x01UL << NT_CAP4_ECFLG_CTR_PRD_Pos)                   /*!< NT_CAP4 ECFLG: CTR_PRD Mask             */
#define NT_CAP4_ECFLG_CTR_CMP_Pos             7                                                       /*!< NT_CAP4 ECFLG: CTR_CMP Position         */
#define NT_CAP4_ECFLG_CTR_CMP_Msk             (0x01UL << NT_CAP4_ECFLG_CTR_CMP_Pos)                   /*!< NT_CAP4 ECFLG: CTR_CMP Mask             */

/* --------------------------------  NT_CAP4_ECCLR  ------------------------------- */
#define NT_CAP4_ECCLR_INT_Pos                 0                                                       /*!< NT_CAP4 ECCLR: INT Position             */
#define NT_CAP4_ECCLR_INT_Msk                 (0x01UL << NT_CAP4_ECCLR_INT_Pos)                       /*!< NT_CAP4 ECCLR: INT Mask                 */
#define NT_CAP4_ECCLR_CEVT0_Pos               1                                                       /*!< NT_CAP4 ECCLR: CEVT0 Position           */
#define NT_CAP4_ECCLR_CEVT0_Msk               (0x01UL << NT_CAP4_ECCLR_CEVT0_Pos)                     /*!< NT_CAP4 ECCLR: CEVT0 Mask               */
#define NT_CAP4_ECCLR_CEVT1_Pos               2                                                       /*!< NT_CAP4 ECCLR: CEVT1 Position           */
#define NT_CAP4_ECCLR_CEVT1_Msk               (0x01UL << NT_CAP4_ECCLR_CEVT1_Pos)                     /*!< NT_CAP4 ECCLR: CEVT1 Mask               */
#define NT_CAP4_ECCLR_CEVT2_Pos               3                                                       /*!< NT_CAP4 ECCLR: CEVT2 Position           */
#define NT_CAP4_ECCLR_CEVT2_Msk               (0x01UL << NT_CAP4_ECCLR_CEVT2_Pos)                     /*!< NT_CAP4 ECCLR: CEVT2 Mask               */
#define NT_CAP4_ECCLR_CEVT3_Pos               4                                                       /*!< NT_CAP4 ECCLR: CEVT3 Position           */
#define NT_CAP4_ECCLR_CEVT3_Msk               (0x01UL << NT_CAP4_ECCLR_CEVT3_Pos)                     /*!< NT_CAP4 ECCLR: CEVT3 Mask               */
#define NT_CAP4_ECCLR_CTR_OVF_Pos             5                                                       /*!< NT_CAP4 ECCLR: CTR_OVF Position         */
#define NT_CAP4_ECCLR_CTR_OVF_Msk             (0x01UL << NT_CAP4_ECCLR_CTR_OVF_Pos)                   /*!< NT_CAP4 ECCLR: CTR_OVF Mask             */
#define NT_CAP4_ECCLR_CTR_PRD_Pos             6                                                       /*!< NT_CAP4 ECCLR: CTR_PRD Position         */
#define NT_CAP4_ECCLR_CTR_PRD_Msk             (0x01UL << NT_CAP4_ECCLR_CTR_PRD_Pos)                   /*!< NT_CAP4 ECCLR: CTR_PRD Mask             */
#define NT_CAP4_ECCLR_CTR_CMP_Pos             7                                                       /*!< NT_CAP4 ECCLR: CTR_CMP Position         */
#define NT_CAP4_ECCLR_CTR_CMP_Msk             (0x01UL << NT_CAP4_ECCLR_CTR_CMP_Pos)                   /*!< NT_CAP4 ECCLR: CTR_CMP Mask             */

/* --------------------------------  NT_CAP4_ECFRC  ------------------------------- */
#define NT_CAP4_ECFRC_CEVT0_Pos               1                                                       /*!< NT_CAP4 ECFRC: CEVT0 Position           */
#define NT_CAP4_ECFRC_CEVT0_Msk               (0x01UL << NT_CAP4_ECFRC_CEVT0_Pos)                     /*!< NT_CAP4 ECFRC: CEVT0 Mask               */
#define NT_CAP4_ECFRC_CEVT1_Pos               2                                                       /*!< NT_CAP4 ECFRC: CEVT1 Position           */
#define NT_CAP4_ECFRC_CEVT1_Msk               (0x01UL << NT_CAP4_ECFRC_CEVT1_Pos)                     /*!< NT_CAP4 ECFRC: CEVT1 Mask               */
#define NT_CAP4_ECFRC_CEVT2_Pos               3                                                       /*!< NT_CAP4 ECFRC: CEVT2 Position           */
#define NT_CAP4_ECFRC_CEVT2_Msk               (0x01UL << NT_CAP4_ECFRC_CEVT2_Pos)                     /*!< NT_CAP4 ECFRC: CEVT2 Mask               */
#define NT_CAP4_ECFRC_CEVT3_Pos               4                                                       /*!< NT_CAP4 ECFRC: CEVT3 Position           */
#define NT_CAP4_ECFRC_CEVT3_Msk               (0x01UL << NT_CAP4_ECFRC_CEVT3_Pos)                     /*!< NT_CAP4 ECFRC: CEVT3 Mask               */
#define NT_CAP4_ECFRC_CTR_OVF_Pos             5                                                       /*!< NT_CAP4 ECFRC: CTR_OVF Position         */
#define NT_CAP4_ECFRC_CTR_OVF_Msk             (0x01UL << NT_CAP4_ECFRC_CTR_OVF_Pos)                   /*!< NT_CAP4 ECFRC: CTR_OVF Mask             */
#define NT_CAP4_ECFRC_CTR_PRD_Pos             6                                                       /*!< NT_CAP4 ECFRC: CTR_PRD Position         */
#define NT_CAP4_ECFRC_CTR_PRD_Msk             (0x01UL << NT_CAP4_ECFRC_CTR_PRD_Pos)                   /*!< NT_CAP4 ECFRC: CTR_PRD Mask             */
#define NT_CAP4_ECFRC_CTR_CMP_Pos             7                                                       /*!< NT_CAP4 ECFRC: CTR_CMP Position         */
#define NT_CAP4_ECFRC_CTR_CMP_Msk             (0x01UL << NT_CAP4_ECFRC_CTR_CMP_Pos)                   /*!< NT_CAP4 ECFRC: CTR_CMP Mask             */

/* --------------------------------  NT_CAP4_PEINT  ------------------------------- */
#define NT_CAP4_PEINT_PEINT_Pos               0                                                       /*!< NT_CAP4 PEINT: PEINT Position           */
#define NT_CAP4_PEINT_PEINT_Msk               (0x01UL << NT_CAP4_PEINT_PEINT_Pos)                     /*!< NT_CAP4 PEINT: PEINT Mask               */


/* ================================================================================ */
/* ================        struct 'NT_CAP5' Position & Mask        ================ */
/* ================================================================================ */


/* --------------------------------  NT_CAP5_TSCTR  ------------------------------- */
#define NT_CAP5_TSCTR_VALUE_Pos               0                                                       /*!< NT_CAP5 TSCTR: VALUE Position           */
#define NT_CAP5_TSCTR_VALUE_Msk               (0xffffffffUL << NT_CAP5_TSCTR_VALUE_Pos)               /*!< NT_CAP5 TSCTR: VALUE Mask               */

/* -------------------------------  NT_CAP5_CTRPHS  ------------------------------- */
#define NT_CAP5_CTRPHS_VALUE_Pos              0                                                       /*!< NT_CAP5 CTRPHS: VALUE Position          */
#define NT_CAP5_CTRPHS_VALUE_Msk              (0xffffffffUL << NT_CAP5_CTRPHS_VALUE_Pos)              /*!< NT_CAP5 CTRPHS: VALUE Mask              */

/* --------------------------------  NT_CAP5_CAP0  -------------------------------- */
#define NT_CAP5_CAP0_VALUE_Pos                0                                                       /*!< NT_CAP5 CAP0: VALUE Position            */
#define NT_CAP5_CAP0_VALUE_Msk                (0xffffffffUL << NT_CAP5_CAP0_VALUE_Pos)                /*!< NT_CAP5 CAP0: VALUE Mask                */

/* --------------------------------  NT_CAP5_CAP1  -------------------------------- */
#define NT_CAP5_CAP1_VALUE_Pos                0                                                       /*!< NT_CAP5 CAP1: VALUE Position            */
#define NT_CAP5_CAP1_VALUE_Msk                (0xffffffffUL << NT_CAP5_CAP1_VALUE_Pos)                /*!< NT_CAP5 CAP1: VALUE Mask                */

/* --------------------------------  NT_CAP5_CAP2  -------------------------------- */
#define NT_CAP5_CAP2_VALUE_Pos                0                                                       /*!< NT_CAP5 CAP2: VALUE Position            */
#define NT_CAP5_CAP2_VALUE_Msk                (0xffffffffUL << NT_CAP5_CAP2_VALUE_Pos)                /*!< NT_CAP5 CAP2: VALUE Mask                */

/* --------------------------------  NT_CAP5_CAP3  -------------------------------- */
#define NT_CAP5_CAP3_VALUE_Pos                0                                                       /*!< NT_CAP5 CAP3: VALUE Position            */
#define NT_CAP5_CAP3_VALUE_Msk                (0xffffffffUL << NT_CAP5_CAP3_VALUE_Pos)                /*!< NT_CAP5 CAP3: VALUE Mask                */

/* -------------------------------  NT_CAP5_ECCTL0  ------------------------------- */
#define NT_CAP5_ECCTL0_CAP0_POL_Pos           0                                                       /*!< NT_CAP5 ECCTL0: CAP0_POL Position       */
#define NT_CAP5_ECCTL0_CAP0_POL_Msk           (0x01UL << NT_CAP5_ECCTL0_CAP0_POL_Pos)                 /*!< NT_CAP5 ECCTL0: CAP0_POL Mask           */
#define NT_CAP5_ECCTL0_CTR_RST0_Pos           1                                                       /*!< NT_CAP5 ECCTL0: CTR_RST0 Position       */
#define NT_CAP5_ECCTL0_CTR_RST0_Msk           (0x01UL << NT_CAP5_ECCTL0_CTR_RST0_Pos)                 /*!< NT_CAP5 ECCTL0: CTR_RST0 Mask           */
#define NT_CAP5_ECCTL0_CAP1_POL_Pos           2                                                       /*!< NT_CAP5 ECCTL0: CAP1_POL Position       */
#define NT_CAP5_ECCTL0_CAP1_POL_Msk           (0x01UL << NT_CAP5_ECCTL0_CAP1_POL_Pos)                 /*!< NT_CAP5 ECCTL0: CAP1_POL Mask           */
#define NT_CAP5_ECCTL0_CTR_RST1_Pos           3                                                       /*!< NT_CAP5 ECCTL0: CTR_RST1 Position       */
#define NT_CAP5_ECCTL0_CTR_RST1_Msk           (0x01UL << NT_CAP5_ECCTL0_CTR_RST1_Pos)                 /*!< NT_CAP5 ECCTL0: CTR_RST1 Mask           */
#define NT_CAP5_ECCTL0_CAP2_POL_Pos           4                                                       /*!< NT_CAP5 ECCTL0: CAP2_POL Position       */
#define NT_CAP5_ECCTL0_CAP2_POL_Msk           (0x01UL << NT_CAP5_ECCTL0_CAP2_POL_Pos)                 /*!< NT_CAP5 ECCTL0: CAP2_POL Mask           */
#define NT_CAP5_ECCTL0_CTR_RST2_Pos           5                                                       /*!< NT_CAP5 ECCTL0: CTR_RST2 Position       */
#define NT_CAP5_ECCTL0_CTR_RST2_Msk           (0x01UL << NT_CAP5_ECCTL0_CTR_RST2_Pos)                 /*!< NT_CAP5 ECCTL0: CTR_RST2 Mask           */
#define NT_CAP5_ECCTL0_CAP3_POL_Pos           6                                                       /*!< NT_CAP5 ECCTL0: CAP3_POL Position       */
#define NT_CAP5_ECCTL0_CAP3_POL_Msk           (0x01UL << NT_CAP5_ECCTL0_CAP3_POL_Pos)                 /*!< NT_CAP5 ECCTL0: CAP3_POL Mask           */
#define NT_CAP5_ECCTL0_CTR_RST3_Pos           7                                                       /*!< NT_CAP5 ECCTL0: CTR_RST3 Position       */
#define NT_CAP5_ECCTL0_CTR_RST3_Msk           (0x01UL << NT_CAP5_ECCTL0_CTR_RST3_Pos)                 /*!< NT_CAP5 ECCTL0: CTR_RST3 Mask           */
#define NT_CAP5_ECCTL0_CAPLDEN_Pos            8                                                       /*!< NT_CAP5 ECCTL0: CAPLDEN Position        */
#define NT_CAP5_ECCTL0_CAPLDEN_Msk            (0x01UL << NT_CAP5_ECCTL0_CAPLDEN_Pos)                  /*!< NT_CAP5 ECCTL0: CAPLDEN Mask            */
#define NT_CAP5_ECCTL0_PRESCALE_Pos           9                                                       /*!< NT_CAP5 ECCTL0: PRESCALE Position       */
#define NT_CAP5_ECCTL0_PRESCALE_Msk           (0x1fUL << NT_CAP5_ECCTL0_PRESCALE_Pos)                 /*!< NT_CAP5 ECCTL0: PRESCALE Mask           */
#define NT_CAP5_ECCTL0_FREE_SOFT_Pos          14                                                      /*!< NT_CAP5 ECCTL0: FREE_SOFT Position      */
#define NT_CAP5_ECCTL0_FREE_SOFT_Msk          (0x03UL << NT_CAP5_ECCTL0_FREE_SOFT_Pos)                /*!< NT_CAP5 ECCTL0: FREE_SOFT Mask          */

/* -------------------------------  NT_CAP5_ECCTL1  ------------------------------- */
#define NT_CAP5_ECCTL1_SWSYNC_Pos             0                                                       /*!< NT_CAP5 ECCTL1: SWSYNC Position         */
#define NT_CAP5_ECCTL1_SWSYNC_Msk             (0x01UL << NT_CAP5_ECCTL1_SWSYNC_Pos)                   /*!< NT_CAP5 ECCTL1: SWSYNC Mask             */
#define NT_CAP5_ECCTL1_CAP_APWM_Pos           1                                                       /*!< NT_CAP5 ECCTL1: CAP_APWM Position       */
#define NT_CAP5_ECCTL1_CAP_APWM_Msk           (0x01UL << NT_CAP5_ECCTL1_CAP_APWM_Pos)                 /*!< NT_CAP5 ECCTL1: CAP_APWM Mask           */
#define NT_CAP5_ECCTL1_APWM_POL_Pos           2                                                       /*!< NT_CAP5 ECCTL1: APWM_POL Position       */
#define NT_CAP5_ECCTL1_APWM_POL_Msk           (0x01UL << NT_CAP5_ECCTL1_APWM_POL_Pos)                 /*!< NT_CAP5 ECCTL1: APWM_POL Mask           */
#define NT_CAP5_ECCTL1_CONT_ONESHT_Pos        8                                                       /*!< NT_CAP5 ECCTL1: CONT_ONESHT Position    */
#define NT_CAP5_ECCTL1_CONT_ONESHT_Msk        (0x01UL << NT_CAP5_ECCTL1_CONT_ONESHT_Pos)              /*!< NT_CAP5 ECCTL1: CONT_ONESHT Mask        */
#define NT_CAP5_ECCTL1_STOP_WRAP_Pos          9                                                       /*!< NT_CAP5 ECCTL1: STOP_WRAP Position      */
#define NT_CAP5_ECCTL1_STOP_WRAP_Msk          (0x03UL << NT_CAP5_ECCTL1_STOP_WRAP_Pos)                /*!< NT_CAP5 ECCTL1: STOP_WRAP Mask          */
#define NT_CAP5_ECCTL1_REARM_Pos              11                                                      /*!< NT_CAP5 ECCTL1: REARM Position          */
#define NT_CAP5_ECCTL1_REARM_Msk              (0x01UL << NT_CAP5_ECCTL1_REARM_Pos)                    /*!< NT_CAP5 ECCTL1: REARM Mask              */
#define NT_CAP5_ECCTL1_TSCTRSTOP_Pos          12                                                      /*!< NT_CAP5 ECCTL1: TSCTRSTOP Position      */
#define NT_CAP5_ECCTL1_TSCTRSTOP_Msk          (0x01UL << NT_CAP5_ECCTL1_TSCTRSTOP_Pos)                /*!< NT_CAP5 ECCTL1: TSCTRSTOP Mask          */
#define NT_CAP5_ECCTL1_SYNCI_EN_Pos           13                                                      /*!< NT_CAP5 ECCTL1: SYNCI_EN Position       */
#define NT_CAP5_ECCTL1_SYNCI_EN_Msk           (0x01UL << NT_CAP5_ECCTL1_SYNCI_EN_Pos)                 /*!< NT_CAP5 ECCTL1: SYNCI_EN Mask           */
#define NT_CAP5_ECCTL1_SYNCO_SEL_Pos          14                                                      /*!< NT_CAP5 ECCTL1: SYNCO_SEL Position      */
#define NT_CAP5_ECCTL1_SYNCO_SEL_Msk          (0x03UL << NT_CAP5_ECCTL1_SYNCO_SEL_Pos)                /*!< NT_CAP5 ECCTL1: SYNCO_SEL Mask          */

/* -------------------------------  NT_CAP5_ECEINT  ------------------------------- */
#define NT_CAP5_ECEINT_CEVT0_Pos              1                                                       /*!< NT_CAP5 ECEINT: CEVT0 Position          */
#define NT_CAP5_ECEINT_CEVT0_Msk              (0x01UL << NT_CAP5_ECEINT_CEVT0_Pos)                    /*!< NT_CAP5 ECEINT: CEVT0 Mask              */
#define NT_CAP5_ECEINT_CEVT1_Pos              2                                                       /*!< NT_CAP5 ECEINT: CEVT1 Position          */
#define NT_CAP5_ECEINT_CEVT1_Msk              (0x01UL << NT_CAP5_ECEINT_CEVT1_Pos)                    /*!< NT_CAP5 ECEINT: CEVT1 Mask              */
#define NT_CAP5_ECEINT_CEVT2_Pos              3                                                       /*!< NT_CAP5 ECEINT: CEVT2 Position          */
#define NT_CAP5_ECEINT_CEVT2_Msk              (0x01UL << NT_CAP5_ECEINT_CEVT2_Pos)                    /*!< NT_CAP5 ECEINT: CEVT2 Mask              */
#define NT_CAP5_ECEINT_CEVT3_Pos              4                                                       /*!< NT_CAP5 ECEINT: CEVT3 Position          */
#define NT_CAP5_ECEINT_CEVT3_Msk              (0x01UL << NT_CAP5_ECEINT_CEVT3_Pos)                    /*!< NT_CAP5 ECEINT: CEVT3 Mask              */
#define NT_CAP5_ECEINT_CTR_OVF_Pos            5                                                       /*!< NT_CAP5 ECEINT: CTR_OVF Position        */
#define NT_CAP5_ECEINT_CTR_OVF_Msk            (0x01UL << NT_CAP5_ECEINT_CTR_OVF_Pos)                  /*!< NT_CAP5 ECEINT: CTR_OVF Mask            */
#define NT_CAP5_ECEINT_CTR_PRD_Pos            6                                                       /*!< NT_CAP5 ECEINT: CTR_PRD Position        */
#define NT_CAP5_ECEINT_CTR_PRD_Msk            (0x01UL << NT_CAP5_ECEINT_CTR_PRD_Pos)                  /*!< NT_CAP5 ECEINT: CTR_PRD Mask            */
#define NT_CAP5_ECEINT_CTR_CMP_Pos            7                                                       /*!< NT_CAP5 ECEINT: CTR_CMP Position        */
#define NT_CAP5_ECEINT_CTR_CMP_Msk            (0x01UL << NT_CAP5_ECEINT_CTR_CMP_Pos)                  /*!< NT_CAP5 ECEINT: CTR_CMP Mask            */

/* --------------------------------  NT_CAP5_ECFLG  ------------------------------- */
#define NT_CAP5_ECFLG_INT_Pos                 0                                                       /*!< NT_CAP5 ECFLG: INT Position             */
#define NT_CAP5_ECFLG_INT_Msk                 (0x01UL << NT_CAP5_ECFLG_INT_Pos)                       /*!< NT_CAP5 ECFLG: INT Mask                 */
#define NT_CAP5_ECFLG_CEVT0_Pos               1                                                       /*!< NT_CAP5 ECFLG: CEVT0 Position           */
#define NT_CAP5_ECFLG_CEVT0_Msk               (0x01UL << NT_CAP5_ECFLG_CEVT0_Pos)                     /*!< NT_CAP5 ECFLG: CEVT0 Mask               */
#define NT_CAP5_ECFLG_CEVT1_Pos               2                                                       /*!< NT_CAP5 ECFLG: CEVT1 Position           */
#define NT_CAP5_ECFLG_CEVT1_Msk               (0x01UL << NT_CAP5_ECFLG_CEVT1_Pos)                     /*!< NT_CAP5 ECFLG: CEVT1 Mask               */
#define NT_CAP5_ECFLG_CEVT2_Pos               3                                                       /*!< NT_CAP5 ECFLG: CEVT2 Position           */
#define NT_CAP5_ECFLG_CEVT2_Msk               (0x01UL << NT_CAP5_ECFLG_CEVT2_Pos)                     /*!< NT_CAP5 ECFLG: CEVT2 Mask               */
#define NT_CAP5_ECFLG_CEVT3_Pos               4                                                       /*!< NT_CAP5 ECFLG: CEVT3 Position           */
#define NT_CAP5_ECFLG_CEVT3_Msk               (0x01UL << NT_CAP5_ECFLG_CEVT3_Pos)                     /*!< NT_CAP5 ECFLG: CEVT3 Mask               */
#define NT_CAP5_ECFLG_CTR_OVF_Pos             5                                                       /*!< NT_CAP5 ECFLG: CTR_OVF Position         */
#define NT_CAP5_ECFLG_CTR_OVF_Msk             (0x01UL << NT_CAP5_ECFLG_CTR_OVF_Pos)                   /*!< NT_CAP5 ECFLG: CTR_OVF Mask             */
#define NT_CAP5_ECFLG_CTR_PRD_Pos             6                                                       /*!< NT_CAP5 ECFLG: CTR_PRD Position         */
#define NT_CAP5_ECFLG_CTR_PRD_Msk             (0x01UL << NT_CAP5_ECFLG_CTR_PRD_Pos)                   /*!< NT_CAP5 ECFLG: CTR_PRD Mask             */
#define NT_CAP5_ECFLG_CTR_CMP_Pos             7                                                       /*!< NT_CAP5 ECFLG: CTR_CMP Position         */
#define NT_CAP5_ECFLG_CTR_CMP_Msk             (0x01UL << NT_CAP5_ECFLG_CTR_CMP_Pos)                   /*!< NT_CAP5 ECFLG: CTR_CMP Mask             */

/* --------------------------------  NT_CAP5_ECCLR  ------------------------------- */
#define NT_CAP5_ECCLR_INT_Pos                 0                                                       /*!< NT_CAP5 ECCLR: INT Position             */
#define NT_CAP5_ECCLR_INT_Msk                 (0x01UL << NT_CAP5_ECCLR_INT_Pos)                       /*!< NT_CAP5 ECCLR: INT Mask                 */
#define NT_CAP5_ECCLR_CEVT0_Pos               1                                                       /*!< NT_CAP5 ECCLR: CEVT0 Position           */
#define NT_CAP5_ECCLR_CEVT0_Msk               (0x01UL << NT_CAP5_ECCLR_CEVT0_Pos)                     /*!< NT_CAP5 ECCLR: CEVT0 Mask               */
#define NT_CAP5_ECCLR_CEVT1_Pos               2                                                       /*!< NT_CAP5 ECCLR: CEVT1 Position           */
#define NT_CAP5_ECCLR_CEVT1_Msk               (0x01UL << NT_CAP5_ECCLR_CEVT1_Pos)                     /*!< NT_CAP5 ECCLR: CEVT1 Mask               */
#define NT_CAP5_ECCLR_CEVT2_Pos               3                                                       /*!< NT_CAP5 ECCLR: CEVT2 Position           */
#define NT_CAP5_ECCLR_CEVT2_Msk               (0x01UL << NT_CAP5_ECCLR_CEVT2_Pos)                     /*!< NT_CAP5 ECCLR: CEVT2 Mask               */
#define NT_CAP5_ECCLR_CEVT3_Pos               4                                                       /*!< NT_CAP5 ECCLR: CEVT3 Position           */
#define NT_CAP5_ECCLR_CEVT3_Msk               (0x01UL << NT_CAP5_ECCLR_CEVT3_Pos)                     /*!< NT_CAP5 ECCLR: CEVT3 Mask               */
#define NT_CAP5_ECCLR_CTR_OVF_Pos             5                                                       /*!< NT_CAP5 ECCLR: CTR_OVF Position         */
#define NT_CAP5_ECCLR_CTR_OVF_Msk             (0x01UL << NT_CAP5_ECCLR_CTR_OVF_Pos)                   /*!< NT_CAP5 ECCLR: CTR_OVF Mask             */
#define NT_CAP5_ECCLR_CTR_PRD_Pos             6                                                       /*!< NT_CAP5 ECCLR: CTR_PRD Position         */
#define NT_CAP5_ECCLR_CTR_PRD_Msk             (0x01UL << NT_CAP5_ECCLR_CTR_PRD_Pos)                   /*!< NT_CAP5 ECCLR: CTR_PRD Mask             */
#define NT_CAP5_ECCLR_CTR_CMP_Pos             7                                                       /*!< NT_CAP5 ECCLR: CTR_CMP Position         */
#define NT_CAP5_ECCLR_CTR_CMP_Msk             (0x01UL << NT_CAP5_ECCLR_CTR_CMP_Pos)                   /*!< NT_CAP5 ECCLR: CTR_CMP Mask             */

/* --------------------------------  NT_CAP5_ECFRC  ------------------------------- */
#define NT_CAP5_ECFRC_CEVT0_Pos               1                                                       /*!< NT_CAP5 ECFRC: CEVT0 Position           */
#define NT_CAP5_ECFRC_CEVT0_Msk               (0x01UL << NT_CAP5_ECFRC_CEVT0_Pos)                     /*!< NT_CAP5 ECFRC: CEVT0 Mask               */
#define NT_CAP5_ECFRC_CEVT1_Pos               2                                                       /*!< NT_CAP5 ECFRC: CEVT1 Position           */
#define NT_CAP5_ECFRC_CEVT1_Msk               (0x01UL << NT_CAP5_ECFRC_CEVT1_Pos)                     /*!< NT_CAP5 ECFRC: CEVT1 Mask               */
#define NT_CAP5_ECFRC_CEVT2_Pos               3                                                       /*!< NT_CAP5 ECFRC: CEVT2 Position           */
#define NT_CAP5_ECFRC_CEVT2_Msk               (0x01UL << NT_CAP5_ECFRC_CEVT2_Pos)                     /*!< NT_CAP5 ECFRC: CEVT2 Mask               */
#define NT_CAP5_ECFRC_CEVT3_Pos               4                                                       /*!< NT_CAP5 ECFRC: CEVT3 Position           */
#define NT_CAP5_ECFRC_CEVT3_Msk               (0x01UL << NT_CAP5_ECFRC_CEVT3_Pos)                     /*!< NT_CAP5 ECFRC: CEVT3 Mask               */
#define NT_CAP5_ECFRC_CTR_OVF_Pos             5                                                       /*!< NT_CAP5 ECFRC: CTR_OVF Position         */
#define NT_CAP5_ECFRC_CTR_OVF_Msk             (0x01UL << NT_CAP5_ECFRC_CTR_OVF_Pos)                   /*!< NT_CAP5 ECFRC: CTR_OVF Mask             */
#define NT_CAP5_ECFRC_CTR_PRD_Pos             6                                                       /*!< NT_CAP5 ECFRC: CTR_PRD Position         */
#define NT_CAP5_ECFRC_CTR_PRD_Msk             (0x01UL << NT_CAP5_ECFRC_CTR_PRD_Pos)                   /*!< NT_CAP5 ECFRC: CTR_PRD Mask             */
#define NT_CAP5_ECFRC_CTR_CMP_Pos             7                                                       /*!< NT_CAP5 ECFRC: CTR_CMP Position         */
#define NT_CAP5_ECFRC_CTR_CMP_Msk             (0x01UL << NT_CAP5_ECFRC_CTR_CMP_Pos)                   /*!< NT_CAP5 ECFRC: CTR_CMP Mask             */

/* --------------------------------  NT_CAP5_PEINT  ------------------------------- */
#define NT_CAP5_PEINT_PEINT_Pos               0                                                       /*!< NT_CAP5 PEINT: PEINT Position           */
#define NT_CAP5_PEINT_PEINT_Msk               (0x01UL << NT_CAP5_PEINT_PEINT_Pos)                     /*!< NT_CAP5 PEINT: PEINT Mask               */


/* ================================================================================ */
/* ================        struct 'NT_QEP0' Position & Mask        ================ */
/* ================================================================================ */


/* -------------------------------  NT_QEP0_QPOSCNT  ------------------------------ */
#define NT_QEP0_QPOSCNT_QPOSCNT_Pos           0                                                       /*!< NT_QEP0 QPOSCNT: QPOSCNT Position       */
#define NT_QEP0_QPOSCNT_QPOSCNT_Msk           (0xffffffffUL << NT_QEP0_QPOSCNT_QPOSCNT_Pos)           /*!< NT_QEP0 QPOSCNT: QPOSCNT Mask           */

/* ------------------------------  NT_QEP0_QPOSINIT  ------------------------------ */
#define NT_QEP0_QPOSINIT_QPOSINIT_Pos         0                                                       /*!< NT_QEP0 QPOSINIT: QPOSINIT Position     */
#define NT_QEP0_QPOSINIT_QPOSINIT_Msk         (0xffffffffUL << NT_QEP0_QPOSINIT_QPOSINIT_Pos)         /*!< NT_QEP0 QPOSINIT: QPOSINIT Mask         */

/* -------------------------------  NT_QEP0_QPOSMAX  ------------------------------ */
#define NT_QEP0_QPOSMAX_QPOSMAX_Pos           0                                                       /*!< NT_QEP0 QPOSMAX: QPOSMAX Position       */
#define NT_QEP0_QPOSMAX_QPOSMAX_Msk           (0xffffffffUL << NT_QEP0_QPOSMAX_QPOSMAX_Pos)           /*!< NT_QEP0 QPOSMAX: QPOSMAX Mask           */

/* -------------------------------  NT_QEP0_QPOSCMP  ------------------------------ */
#define NT_QEP0_QPOSCMP_QPOSCMP_Pos           0                                                       /*!< NT_QEP0 QPOSCMP: QPOSCMP Position       */
#define NT_QEP0_QPOSCMP_QPOSCMP_Msk           (0xffffffffUL << NT_QEP0_QPOSCMP_QPOSCMP_Pos)           /*!< NT_QEP0 QPOSCMP: QPOSCMP Mask           */

/* ------------------------------  NT_QEP0_QPOSILAT  ------------------------------ */
#define NT_QEP0_QPOSILAT_QPOSILAT_Pos         0                                                       /*!< NT_QEP0 QPOSILAT: QPOSILAT Position     */
#define NT_QEP0_QPOSILAT_QPOSILAT_Msk         (0xffffffffUL << NT_QEP0_QPOSILAT_QPOSILAT_Pos)         /*!< NT_QEP0 QPOSILAT: QPOSILAT Mask         */

/* ------------------------------  NT_QEP0_QPOSSLAT  ------------------------------ */
#define NT_QEP0_QPOSSLAT_QPOSSLAT_Pos         0                                                       /*!< NT_QEP0 QPOSSLAT: QPOSSLAT Position     */
#define NT_QEP0_QPOSSLAT_QPOSSLAT_Msk         (0xffffffffUL << NT_QEP0_QPOSSLAT_QPOSSLAT_Pos)         /*!< NT_QEP0 QPOSSLAT: QPOSSLAT Mask         */

/* -------------------------------  NT_QEP0_QPOSLAT  ------------------------------ */
#define NT_QEP0_QPOSLAT_QPOSLAT_Pos           0                                                       /*!< NT_QEP0 QPOSLAT: QPOSLAT Position       */
#define NT_QEP0_QPOSLAT_QPOSLAT_Msk           (0xffffffffUL << NT_QEP0_QPOSLAT_QPOSLAT_Pos)           /*!< NT_QEP0 QPOSLAT: QPOSLAT Mask           */

/* --------------------------------  NT_QEP0_QUTMR  ------------------------------- */
#define NT_QEP0_QUTMR_QUTMR_Pos               0                                                       /*!< NT_QEP0 QUTMR: QUTMR Position           */
#define NT_QEP0_QUTMR_QUTMR_Msk               (0xffffffffUL << NT_QEP0_QUTMR_QUTMR_Pos)               /*!< NT_QEP0 QUTMR: QUTMR Mask               */

/* --------------------------------  NT_QEP0_QUPRD  ------------------------------- */
#define NT_QEP0_QUPRD_QUPRD_Pos               0                                                       /*!< NT_QEP0 QUPRD: QUPRD Position           */
#define NT_QEP0_QUPRD_QUPRD_Msk               (0xffffffffUL << NT_QEP0_QUPRD_QUPRD_Pos)               /*!< NT_QEP0 QUPRD: QUPRD Mask               */

/* -------------------------------  NT_QEP0_QWDTMR  ------------------------------- */
#define NT_QEP0_QWDTMR_QWDTMR_Pos             0                                                       /*!< NT_QEP0 QWDTMR: QWDTMR Position         */
#define NT_QEP0_QWDTMR_QWDTMR_Msk             (0xffffffffUL << NT_QEP0_QWDTMR_QWDTMR_Pos)             /*!< NT_QEP0 QWDTMR: QWDTMR Mask             */

/* -------------------------------  NT_QEP0_QWDPRD  ------------------------------- */
#define NT_QEP0_QWDPRD_QWDPRD_Pos             0                                                       /*!< NT_QEP0 QWDPRD: QWDPRD Position         */
#define NT_QEP0_QWDPRD_QWDPRD_Msk             (0xffffffffUL << NT_QEP0_QWDPRD_QWDPRD_Pos)             /*!< NT_QEP0 QWDPRD: QWDPRD Mask             */

/* -------------------------------  NT_QEP0_QDECCTL  ------------------------------ */
#define NT_QEP0_QDECCTL_QSP_Pos               5                                                       /*!< NT_QEP0 QDECCTL: QSP Position           */
#define NT_QEP0_QDECCTL_QSP_Msk               (0x01UL << NT_QEP0_QDECCTL_QSP_Pos)                     /*!< NT_QEP0 QDECCTL: QSP Mask               */
#define NT_QEP0_QDECCTL_QIP_Pos               6                                                       /*!< NT_QEP0 QDECCTL: QIP Position           */
#define NT_QEP0_QDECCTL_QIP_Msk               (0x01UL << NT_QEP0_QDECCTL_QIP_Pos)                     /*!< NT_QEP0 QDECCTL: QIP Mask               */
#define NT_QEP0_QDECCTL_QBP_Pos               7                                                       /*!< NT_QEP0 QDECCTL: QBP Position           */
#define NT_QEP0_QDECCTL_QBP_Msk               (0x01UL << NT_QEP0_QDECCTL_QBP_Pos)                     /*!< NT_QEP0 QDECCTL: QBP Mask               */
#define NT_QEP0_QDECCTL_QAP_Pos               8                                                       /*!< NT_QEP0 QDECCTL: QAP Position           */
#define NT_QEP0_QDECCTL_QAP_Msk               (0x01UL << NT_QEP0_QDECCTL_QAP_Pos)                     /*!< NT_QEP0 QDECCTL: QAP Mask               */
#define NT_QEP0_QDECCTL_IGATE_Pos             9                                                       /*!< NT_QEP0 QDECCTL: IGATE Position         */
#define NT_QEP0_QDECCTL_IGATE_Msk             (0x01UL << NT_QEP0_QDECCTL_IGATE_Pos)                   /*!< NT_QEP0 QDECCTL: IGATE Mask             */
#define NT_QEP0_QDECCTL_SWAP_Pos              10                                                      /*!< NT_QEP0 QDECCTL: SWAP Position          */
#define NT_QEP0_QDECCTL_SWAP_Msk              (0x01UL << NT_QEP0_QDECCTL_SWAP_Pos)                    /*!< NT_QEP0 QDECCTL: SWAP Mask              */
#define NT_QEP0_QDECCTL_XCR_Pos               11                                                      /*!< NT_QEP0 QDECCTL: XCR Position           */
#define NT_QEP0_QDECCTL_XCR_Msk               (0x01UL << NT_QEP0_QDECCTL_XCR_Pos)                     /*!< NT_QEP0 QDECCTL: XCR Mask               */
#define NT_QEP0_QDECCTL_SPSEL_Pos             12                                                      /*!< NT_QEP0 QDECCTL: SPSEL Position         */
#define NT_QEP0_QDECCTL_SPSEL_Msk             (0x01UL << NT_QEP0_QDECCTL_SPSEL_Pos)                   /*!< NT_QEP0 QDECCTL: SPSEL Mask             */
#define NT_QEP0_QDECCTL_SOEN_Pos              13                                                      /*!< NT_QEP0 QDECCTL: SOEN Position          */
#define NT_QEP0_QDECCTL_SOEN_Msk              (0x01UL << NT_QEP0_QDECCTL_SOEN_Pos)                    /*!< NT_QEP0 QDECCTL: SOEN Mask              */
#define NT_QEP0_QDECCTL_QSRC_Pos              14                                                      /*!< NT_QEP0 QDECCTL: QSRC Position          */
#define NT_QEP0_QDECCTL_QSRC_Msk              (0x03UL << NT_QEP0_QDECCTL_QSRC_Pos)                    /*!< NT_QEP0 QDECCTL: QSRC Mask              */

/* -------------------------------  NT_QEP0_QEPCTL  ------------------------------- */
#define NT_QEP0_QEPCTL_WDE_Pos                0                                                       /*!< NT_QEP0 QEPCTL: WDE Position            */
#define NT_QEP0_QEPCTL_WDE_Msk                (0x01UL << NT_QEP0_QEPCTL_WDE_Pos)                      /*!< NT_QEP0 QEPCTL: WDE Mask                */
#define NT_QEP0_QEPCTL_UTE_Pos                1                                                       /*!< NT_QEP0 QEPCTL: UTE Position            */
#define NT_QEP0_QEPCTL_UTE_Msk                (0x01UL << NT_QEP0_QEPCTL_UTE_Pos)                      /*!< NT_QEP0 QEPCTL: UTE Mask                */
#define NT_QEP0_QEPCTL_QCLM_Pos               2                                                       /*!< NT_QEP0 QEPCTL: QCLM Position           */
#define NT_QEP0_QEPCTL_QCLM_Msk               (0x01UL << NT_QEP0_QEPCTL_QCLM_Pos)                     /*!< NT_QEP0 QEPCTL: QCLM Mask               */
#define NT_QEP0_QEPCTL_QPEN_Pos               3                                                       /*!< NT_QEP0 QEPCTL: QPEN Position           */
#define NT_QEP0_QEPCTL_QPEN_Msk               (0x01UL << NT_QEP0_QEPCTL_QPEN_Pos)                     /*!< NT_QEP0 QEPCTL: QPEN Mask               */
#define NT_QEP0_QEPCTL_IEL_Pos                4                                                       /*!< NT_QEP0 QEPCTL: IEL Position            */
#define NT_QEP0_QEPCTL_IEL_Msk                (0x03UL << NT_QEP0_QEPCTL_IEL_Pos)                      /*!< NT_QEP0 QEPCTL: IEL Mask                */
#define NT_QEP0_QEPCTL_SEL_Pos                6                                                       /*!< NT_QEP0 QEPCTL: SEL Position            */
#define NT_QEP0_QEPCTL_SEL_Msk                (0x01UL << NT_QEP0_QEPCTL_SEL_Pos)                      /*!< NT_QEP0 QEPCTL: SEL Mask                */
#define NT_QEP0_QEPCTL_SWI_Pos                7                                                       /*!< NT_QEP0 QEPCTL: SWI Position            */
#define NT_QEP0_QEPCTL_SWI_Msk                (0x01UL << NT_QEP0_QEPCTL_SWI_Pos)                      /*!< NT_QEP0 QEPCTL: SWI Mask                */
#define NT_QEP0_QEPCTL_IEI_Pos                8                                                       /*!< NT_QEP0 QEPCTL: IEI Position            */
#define NT_QEP0_QEPCTL_IEI_Msk                (0x03UL << NT_QEP0_QEPCTL_IEI_Pos)                      /*!< NT_QEP0 QEPCTL: IEI Mask                */
#define NT_QEP0_QEPCTL_SEI_Pos                10                                                      /*!< NT_QEP0 QEPCTL: SEI Position            */
#define NT_QEP0_QEPCTL_SEI_Msk                (0x03UL << NT_QEP0_QEPCTL_SEI_Pos)                      /*!< NT_QEP0 QEPCTL: SEI Mask                */
#define NT_QEP0_QEPCTL_PCRM_Pos               12                                                      /*!< NT_QEP0 QEPCTL: PCRM Position           */
#define NT_QEP0_QEPCTL_PCRM_Msk               (0x03UL << NT_QEP0_QEPCTL_PCRM_Pos)                     /*!< NT_QEP0 QEPCTL: PCRM Mask               */
#define NT_QEP0_QEPCTL_FREE_SOFT_Pos          14                                                      /*!< NT_QEP0 QEPCTL: FREE_SOFT Position      */
#define NT_QEP0_QEPCTL_FREE_SOFT_Msk          (0x03UL << NT_QEP0_QEPCTL_FREE_SOFT_Pos)                /*!< NT_QEP0 QEPCTL: FREE_SOFT Mask          */

/* -------------------------------  NT_QEP0_QCAPCTL  ------------------------------ */
#define NT_QEP0_QCAPCTL_UPPS_Pos              0                                                       /*!< NT_QEP0 QCAPCTL: UPPS Position          */
#define NT_QEP0_QCAPCTL_UPPS_Msk              (0x0fUL << NT_QEP0_QCAPCTL_UPPS_Pos)                    /*!< NT_QEP0 QCAPCTL: UPPS Mask              */
#define NT_QEP0_QCAPCTL_CCPS_Pos              4                                                       /*!< NT_QEP0 QCAPCTL: CCPS Position          */
#define NT_QEP0_QCAPCTL_CCPS_Msk              (0x07UL << NT_QEP0_QCAPCTL_CCPS_Pos)                    /*!< NT_QEP0 QCAPCTL: CCPS Mask              */
#define NT_QEP0_QCAPCTL_SELEVENT_Pos          7                                                       /*!< NT_QEP0 QCAPCTL: SELEVENT Position      */
#define NT_QEP0_QCAPCTL_SELEVENT_Msk          (0x01UL << NT_QEP0_QCAPCTL_SELEVENT_Pos)                /*!< NT_QEP0 QCAPCTL: SELEVENT Mask          */
#define NT_QEP0_QCAPCTL_CEN_Pos               15                                                      /*!< NT_QEP0 QCAPCTL: CEN Position           */
#define NT_QEP0_QCAPCTL_CEN_Msk               (0x01UL << NT_QEP0_QCAPCTL_CEN_Pos)                     /*!< NT_QEP0 QCAPCTL: CEN Mask               */

/* -------------------------------  NT_QEP0_QPOSCTL  ------------------------------ */
#define NT_QEP0_QPOSCTL_PCSPW_Pos             0                                                       /*!< NT_QEP0 QPOSCTL: PCSPW Position         */
#define NT_QEP0_QPOSCTL_PCSPW_Msk             (0x00000fffUL << NT_QEP0_QPOSCTL_PCSPW_Pos)             /*!< NT_QEP0 QPOSCTL: PCSPW Mask             */
#define NT_QEP0_QPOSCTL_PCE_Pos               12                                                      /*!< NT_QEP0 QPOSCTL: PCE Position           */
#define NT_QEP0_QPOSCTL_PCE_Msk               (0x01UL << NT_QEP0_QPOSCTL_PCE_Pos)                     /*!< NT_QEP0 QPOSCTL: PCE Mask               */
#define NT_QEP0_QPOSCTL_PCPOL_Pos             13                                                      /*!< NT_QEP0 QPOSCTL: PCPOL Position         */
#define NT_QEP0_QPOSCTL_PCPOL_Msk             (0x01UL << NT_QEP0_QPOSCTL_PCPOL_Pos)                   /*!< NT_QEP0 QPOSCTL: PCPOL Mask             */
#define NT_QEP0_QPOSCTL_PCLOAD_Pos            14                                                      /*!< NT_QEP0 QPOSCTL: PCLOAD Position        */
#define NT_QEP0_QPOSCTL_PCLOAD_Msk            (0x01UL << NT_QEP0_QPOSCTL_PCLOAD_Pos)                  /*!< NT_QEP0 QPOSCTL: PCLOAD Mask            */
#define NT_QEP0_QPOSCTL_PCSHDW_Pos            15                                                      /*!< NT_QEP0 QPOSCTL: PCSHDW Position        */
#define NT_QEP0_QPOSCTL_PCSHDW_Msk            (0x01UL << NT_QEP0_QPOSCTL_PCSHDW_Pos)                  /*!< NT_QEP0 QPOSCTL: PCSHDW Mask            */

/* --------------------------------  NT_QEP0_QEINT  ------------------------------- */
#define NT_QEP0_QEINT_PCE_Pos                 1                                                       /*!< NT_QEP0 QEINT: PCE Position             */
#define NT_QEP0_QEINT_PCE_Msk                 (0x01UL << NT_QEP0_QEINT_PCE_Pos)                       /*!< NT_QEP0 QEINT: PCE Mask                 */
#define NT_QEP0_QEINT_QPE_Pos                 2                                                       /*!< NT_QEP0 QEINT: QPE Position             */
#define NT_QEP0_QEINT_QPE_Msk                 (0x01UL << NT_QEP0_QEINT_QPE_Pos)                       /*!< NT_QEP0 QEINT: QPE Mask                 */
#define NT_QEP0_QEINT_QDC_Pos                 3                                                       /*!< NT_QEP0 QEINT: QDC Position             */
#define NT_QEP0_QEINT_QDC_Msk                 (0x01UL << NT_QEP0_QEINT_QDC_Pos)                       /*!< NT_QEP0 QEINT: QDC Mask                 */
#define NT_QEP0_QEINT_WTO_Pos                 4                                                       /*!< NT_QEP0 QEINT: WTO Position             */
#define NT_QEP0_QEINT_WTO_Msk                 (0x01UL << NT_QEP0_QEINT_WTO_Pos)                       /*!< NT_QEP0 QEINT: WTO Mask                 */
#define NT_QEP0_QEINT_PCU_Pos                 5                                                       /*!< NT_QEP0 QEINT: PCU Position             */
#define NT_QEP0_QEINT_PCU_Msk                 (0x01UL << NT_QEP0_QEINT_PCU_Pos)                       /*!< NT_QEP0 QEINT: PCU Mask                 */
#define NT_QEP0_QEINT_PCO_Pos                 6                                                       /*!< NT_QEP0 QEINT: PCO Position             */
#define NT_QEP0_QEINT_PCO_Msk                 (0x01UL << NT_QEP0_QEINT_PCO_Pos)                       /*!< NT_QEP0 QEINT: PCO Mask                 */
#define NT_QEP0_QEINT_PCR_Pos                 7                                                       /*!< NT_QEP0 QEINT: PCR Position             */
#define NT_QEP0_QEINT_PCR_Msk                 (0x01UL << NT_QEP0_QEINT_PCR_Pos)                       /*!< NT_QEP0 QEINT: PCR Mask                 */
#define NT_QEP0_QEINT_PCM_Pos                 8                                                       /*!< NT_QEP0 QEINT: PCM Position             */
#define NT_QEP0_QEINT_PCM_Msk                 (0x01UL << NT_QEP0_QEINT_PCM_Pos)                       /*!< NT_QEP0 QEINT: PCM Mask                 */
#define NT_QEP0_QEINT_SEL_Pos                 9                                                       /*!< NT_QEP0 QEINT: SEL Position             */
#define NT_QEP0_QEINT_SEL_Msk                 (0x01UL << NT_QEP0_QEINT_SEL_Pos)                       /*!< NT_QEP0 QEINT: SEL Mask                 */
#define NT_QEP0_QEINT_IEL_Pos                 10                                                      /*!< NT_QEP0 QEINT: IEL Position             */
#define NT_QEP0_QEINT_IEL_Msk                 (0x01UL << NT_QEP0_QEINT_IEL_Pos)                       /*!< NT_QEP0 QEINT: IEL Mask                 */
#define NT_QEP0_QEINT_UTO_Pos                 11                                                      /*!< NT_QEP0 QEINT: UTO Position             */
#define NT_QEP0_QEINT_UTO_Msk                 (0x01UL << NT_QEP0_QEINT_UTO_Pos)                       /*!< NT_QEP0 QEINT: UTO Mask                 */

/* --------------------------------  NT_QEP0_QFLG  -------------------------------- */
#define NT_QEP0_QFLG_INT_Pos                  0                                                       /*!< NT_QEP0 QFLG: INT Position              */
#define NT_QEP0_QFLG_INT_Msk                  (0x01UL << NT_QEP0_QFLG_INT_Pos)                        /*!< NT_QEP0 QFLG: INT Mask                  */
#define NT_QEP0_QFLG_PCE_Pos                  1                                                       /*!< NT_QEP0 QFLG: PCE Position              */
#define NT_QEP0_QFLG_PCE_Msk                  (0x01UL << NT_QEP0_QFLG_PCE_Pos)                        /*!< NT_QEP0 QFLG: PCE Mask                  */
#define NT_QEP0_QFLG_QPE_Pos                  2                                                       /*!< NT_QEP0 QFLG: QPE Position              */
#define NT_QEP0_QFLG_QPE_Msk                  (0x01UL << NT_QEP0_QFLG_QPE_Pos)                        /*!< NT_QEP0 QFLG: QPE Mask                  */
#define NT_QEP0_QFLG_QDC_Pos                  3                                                       /*!< NT_QEP0 QFLG: QDC Position              */
#define NT_QEP0_QFLG_QDC_Msk                  (0x01UL << NT_QEP0_QFLG_QDC_Pos)                        /*!< NT_QEP0 QFLG: QDC Mask                  */
#define NT_QEP0_QFLG_WTO_Pos                  4                                                       /*!< NT_QEP0 QFLG: WTO Position              */
#define NT_QEP0_QFLG_WTO_Msk                  (0x01UL << NT_QEP0_QFLG_WTO_Pos)                        /*!< NT_QEP0 QFLG: WTO Mask                  */
#define NT_QEP0_QFLG_PCU_Pos                  5                                                       /*!< NT_QEP0 QFLG: PCU Position              */
#define NT_QEP0_QFLG_PCU_Msk                  (0x01UL << NT_QEP0_QFLG_PCU_Pos)                        /*!< NT_QEP0 QFLG: PCU Mask                  */
#define NT_QEP0_QFLG_PCO_Pos                  6                                                       /*!< NT_QEP0 QFLG: PCO Position              */
#define NT_QEP0_QFLG_PCO_Msk                  (0x01UL << NT_QEP0_QFLG_PCO_Pos)                        /*!< NT_QEP0 QFLG: PCO Mask                  */
#define NT_QEP0_QFLG_PCR_Pos                  7                                                       /*!< NT_QEP0 QFLG: PCR Position              */
#define NT_QEP0_QFLG_PCR_Msk                  (0x01UL << NT_QEP0_QFLG_PCR_Pos)                        /*!< NT_QEP0 QFLG: PCR Mask                  */
#define NT_QEP0_QFLG_PCM_Pos                  8                                                       /*!< NT_QEP0 QFLG: PCM Position              */
#define NT_QEP0_QFLG_PCM_Msk                  (0x01UL << NT_QEP0_QFLG_PCM_Pos)                        /*!< NT_QEP0 QFLG: PCM Mask                  */
#define NT_QEP0_QFLG_SEL_Pos                  9                                                       /*!< NT_QEP0 QFLG: SEL Position              */
#define NT_QEP0_QFLG_SEL_Msk                  (0x01UL << NT_QEP0_QFLG_SEL_Pos)                        /*!< NT_QEP0 QFLG: SEL Mask                  */
#define NT_QEP0_QFLG_IEL_Pos                  10                                                      /*!< NT_QEP0 QFLG: IEL Position              */
#define NT_QEP0_QFLG_IEL_Msk                  (0x01UL << NT_QEP0_QFLG_IEL_Pos)                        /*!< NT_QEP0 QFLG: IEL Mask                  */
#define NT_QEP0_QFLG_UTO_Pos                  11                                                      /*!< NT_QEP0 QFLG: UTO Position              */
#define NT_QEP0_QFLG_UTO_Msk                  (0x01UL << NT_QEP0_QFLG_UTO_Pos)                        /*!< NT_QEP0 QFLG: UTO Mask                  */

/* --------------------------------  NT_QEP0_QCLR  -------------------------------- */
#define NT_QEP0_QCLR_INT_Pos                  0                                                       /*!< NT_QEP0 QCLR: INT Position              */
#define NT_QEP0_QCLR_INT_Msk                  (0x01UL << NT_QEP0_QCLR_INT_Pos)                        /*!< NT_QEP0 QCLR: INT Mask                  */
#define NT_QEP0_QCLR_PCE_Pos                  1                                                       /*!< NT_QEP0 QCLR: PCE Position              */
#define NT_QEP0_QCLR_PCE_Msk                  (0x01UL << NT_QEP0_QCLR_PCE_Pos)                        /*!< NT_QEP0 QCLR: PCE Mask                  */
#define NT_QEP0_QCLR_QPE_Pos                  2                                                       /*!< NT_QEP0 QCLR: QPE Position              */
#define NT_QEP0_QCLR_QPE_Msk                  (0x01UL << NT_QEP0_QCLR_QPE_Pos)                        /*!< NT_QEP0 QCLR: QPE Mask                  */
#define NT_QEP0_QCLR_QDC_Pos                  3                                                       /*!< NT_QEP0 QCLR: QDC Position              */
#define NT_QEP0_QCLR_QDC_Msk                  (0x01UL << NT_QEP0_QCLR_QDC_Pos)                        /*!< NT_QEP0 QCLR: QDC Mask                  */
#define NT_QEP0_QCLR_WTO_Pos                  4                                                       /*!< NT_QEP0 QCLR: WTO Position              */
#define NT_QEP0_QCLR_WTO_Msk                  (0x01UL << NT_QEP0_QCLR_WTO_Pos)                        /*!< NT_QEP0 QCLR: WTO Mask                  */
#define NT_QEP0_QCLR_PCU_Pos                  5                                                       /*!< NT_QEP0 QCLR: PCU Position              */
#define NT_QEP0_QCLR_PCU_Msk                  (0x01UL << NT_QEP0_QCLR_PCU_Pos)                        /*!< NT_QEP0 QCLR: PCU Mask                  */
#define NT_QEP0_QCLR_PCO_Pos                  6                                                       /*!< NT_QEP0 QCLR: PCO Position              */
#define NT_QEP0_QCLR_PCO_Msk                  (0x01UL << NT_QEP0_QCLR_PCO_Pos)                        /*!< NT_QEP0 QCLR: PCO Mask                  */
#define NT_QEP0_QCLR_PCR_Pos                  7                                                       /*!< NT_QEP0 QCLR: PCR Position              */
#define NT_QEP0_QCLR_PCR_Msk                  (0x01UL << NT_QEP0_QCLR_PCR_Pos)                        /*!< NT_QEP0 QCLR: PCR Mask                  */
#define NT_QEP0_QCLR_PCM_Pos                  8                                                       /*!< NT_QEP0 QCLR: PCM Position              */
#define NT_QEP0_QCLR_PCM_Msk                  (0x01UL << NT_QEP0_QCLR_PCM_Pos)                        /*!< NT_QEP0 QCLR: PCM Mask                  */
#define NT_QEP0_QCLR_SEL_Pos                  9                                                       /*!< NT_QEP0 QCLR: SEL Position              */
#define NT_QEP0_QCLR_SEL_Msk                  (0x01UL << NT_QEP0_QCLR_SEL_Pos)                        /*!< NT_QEP0 QCLR: SEL Mask                  */
#define NT_QEP0_QCLR_IEL_Pos                  10                                                      /*!< NT_QEP0 QCLR: IEL Position              */
#define NT_QEP0_QCLR_IEL_Msk                  (0x01UL << NT_QEP0_QCLR_IEL_Pos)                        /*!< NT_QEP0 QCLR: IEL Mask                  */
#define NT_QEP0_QCLR_UTO_Pos                  11                                                      /*!< NT_QEP0 QCLR: UTO Position              */
#define NT_QEP0_QCLR_UTO_Msk                  (0x01UL << NT_QEP0_QCLR_UTO_Pos)                        /*!< NT_QEP0 QCLR: UTO Mask                  */

/* --------------------------------  NT_QEP0_QFRC  -------------------------------- */
#define NT_QEP0_QFRC_PCE_Pos                  1                                                       /*!< NT_QEP0 QFRC: PCE Position              */
#define NT_QEP0_QFRC_PCE_Msk                  (0x01UL << NT_QEP0_QFRC_PCE_Pos)                        /*!< NT_QEP0 QFRC: PCE Mask                  */
#define NT_QEP0_QFRC_QPE_Pos                  2                                                       /*!< NT_QEP0 QFRC: QPE Position              */
#define NT_QEP0_QFRC_QPE_Msk                  (0x01UL << NT_QEP0_QFRC_QPE_Pos)                        /*!< NT_QEP0 QFRC: QPE Mask                  */
#define NT_QEP0_QFRC_QDC_Pos                  3                                                       /*!< NT_QEP0 QFRC: QDC Position              */
#define NT_QEP0_QFRC_QDC_Msk                  (0x01UL << NT_QEP0_QFRC_QDC_Pos)                        /*!< NT_QEP0 QFRC: QDC Mask                  */
#define NT_QEP0_QFRC_WTO_Pos                  4                                                       /*!< NT_QEP0 QFRC: WTO Position              */
#define NT_QEP0_QFRC_WTO_Msk                  (0x01UL << NT_QEP0_QFRC_WTO_Pos)                        /*!< NT_QEP0 QFRC: WTO Mask                  */
#define NT_QEP0_QFRC_PCU_Pos                  5                                                       /*!< NT_QEP0 QFRC: PCU Position              */
#define NT_QEP0_QFRC_PCU_Msk                  (0x01UL << NT_QEP0_QFRC_PCU_Pos)                        /*!< NT_QEP0 QFRC: PCU Mask                  */
#define NT_QEP0_QFRC_PCO_Pos                  6                                                       /*!< NT_QEP0 QFRC: PCO Position              */
#define NT_QEP0_QFRC_PCO_Msk                  (0x01UL << NT_QEP0_QFRC_PCO_Pos)                        /*!< NT_QEP0 QFRC: PCO Mask                  */
#define NT_QEP0_QFRC_PCR_Pos                  7                                                       /*!< NT_QEP0 QFRC: PCR Position              */
#define NT_QEP0_QFRC_PCR_Msk                  (0x01UL << NT_QEP0_QFRC_PCR_Pos)                        /*!< NT_QEP0 QFRC: PCR Mask                  */
#define NT_QEP0_QFRC_PCM_Pos                  8                                                       /*!< NT_QEP0 QFRC: PCM Position              */
#define NT_QEP0_QFRC_PCM_Msk                  (0x01UL << NT_QEP0_QFRC_PCM_Pos)                        /*!< NT_QEP0 QFRC: PCM Mask                  */
#define NT_QEP0_QFRC_SEL_Pos                  9                                                       /*!< NT_QEP0 QFRC: SEL Position              */
#define NT_QEP0_QFRC_SEL_Msk                  (0x01UL << NT_QEP0_QFRC_SEL_Pos)                        /*!< NT_QEP0 QFRC: SEL Mask                  */
#define NT_QEP0_QFRC_IEL_Pos                  10                                                      /*!< NT_QEP0 QFRC: IEL Position              */
#define NT_QEP0_QFRC_IEL_Msk                  (0x01UL << NT_QEP0_QFRC_IEL_Pos)                        /*!< NT_QEP0 QFRC: IEL Mask                  */
#define NT_QEP0_QFRC_UTO_Pos                  11                                                      /*!< NT_QEP0 QFRC: UTO Position              */
#define NT_QEP0_QFRC_UTO_Msk                  (0x01UL << NT_QEP0_QFRC_UTO_Pos)                        /*!< NT_QEP0 QFRC: UTO Mask                  */

/* -------------------------------  NT_QEP0_QEPSTS  ------------------------------- */
#define NT_QEP0_QEPSTS_PCEF_Pos               0                                                       /*!< NT_QEP0 QEPSTS: PCEF Position           */
#define NT_QEP0_QEPSTS_PCEF_Msk               (0x01UL << NT_QEP0_QEPSTS_PCEF_Pos)                     /*!< NT_QEP0 QEPSTS: PCEF Mask               */
#define NT_QEP0_QEPSTS_FIMF_Pos               1                                                       /*!< NT_QEP0 QEPSTS: FIMF Position           */
#define NT_QEP0_QEPSTS_FIMF_Msk               (0x01UL << NT_QEP0_QEPSTS_FIMF_Pos)                     /*!< NT_QEP0 QEPSTS: FIMF Mask               */
#define NT_QEP0_QEPSTS_CDEF_Pos               2                                                       /*!< NT_QEP0 QEPSTS: CDEF Position           */
#define NT_QEP0_QEPSTS_CDEF_Msk               (0x01UL << NT_QEP0_QEPSTS_CDEF_Pos)                     /*!< NT_QEP0 QEPSTS: CDEF Mask               */
#define NT_QEP0_QEPSTS_COEF_Pos               3                                                       /*!< NT_QEP0 QEPSTS: COEF Position           */
#define NT_QEP0_QEPSTS_COEF_Msk               (0x01UL << NT_QEP0_QEPSTS_COEF_Pos)                     /*!< NT_QEP0 QEPSTS: COEF Mask               */
#define NT_QEP0_QEPSTS_QDLF_Pos               4                                                       /*!< NT_QEP0 QEPSTS: QDLF Position           */
#define NT_QEP0_QEPSTS_QDLF_Msk               (0x01UL << NT_QEP0_QEPSTS_QDLF_Pos)                     /*!< NT_QEP0 QEPSTS: QDLF Mask               */
#define NT_QEP0_QEPSTS_QDF_Pos                5                                                       /*!< NT_QEP0 QEPSTS: QDF Position            */
#define NT_QEP0_QEPSTS_QDF_Msk                (0x01UL << NT_QEP0_QEPSTS_QDF_Pos)                      /*!< NT_QEP0 QEPSTS: QDF Mask                */
#define NT_QEP0_QEPSTS_FIDF_Pos               6                                                       /*!< NT_QEP0 QEPSTS: FIDF Position           */
#define NT_QEP0_QEPSTS_FIDF_Msk               (0x01UL << NT_QEP0_QEPSTS_FIDF_Pos)                     /*!< NT_QEP0 QEPSTS: FIDF Mask               */
#define NT_QEP0_QEPSTS_UPEVNT_Pos             7                                                       /*!< NT_QEP0 QEPSTS: UPEVNT Position         */
#define NT_QEP0_QEPSTS_UPEVNT_Msk             (0x01UL << NT_QEP0_QEPSTS_UPEVNT_Pos)                   /*!< NT_QEP0 QEPSTS: UPEVNT Mask             */

/* --------------------------------  NT_QEP0_QCTMR  ------------------------------- */
#define NT_QEP0_QCTMR_QCTMR_Pos               0                                                       /*!< NT_QEP0 QCTMR: QCTMR Position           */
#define NT_QEP0_QCTMR_QCTMR_Msk               (0xffffffffUL << NT_QEP0_QCTMR_QCTMR_Pos)               /*!< NT_QEP0 QCTMR: QCTMR Mask               */

/* --------------------------------  NT_QEP0_QCPRD  ------------------------------- */
#define NT_QEP0_QCPRD_QCPRD_Pos               0                                                       /*!< NT_QEP0 QCPRD: QCPRD Position           */
#define NT_QEP0_QCPRD_QCPRD_Msk               (0xffffffffUL << NT_QEP0_QCPRD_QCPRD_Pos)               /*!< NT_QEP0 QCPRD: QCPRD Mask               */

/* ------------------------------  NT_QEP0_QCTMRLAT  ------------------------------ */
#define NT_QEP0_QCTMRLAT_QCTMRLAT_Pos         0                                                       /*!< NT_QEP0 QCTMRLAT: QCTMRLAT Position     */
#define NT_QEP0_QCTMRLAT_QCTMRLAT_Msk         (0xffffffffUL << NT_QEP0_QCTMRLAT_QCTMRLAT_Pos)         /*!< NT_QEP0 QCTMRLAT: QCTMRLAT Mask         */

/* ------------------------------  NT_QEP0_QCPRDLAT  ------------------------------ */
#define NT_QEP0_QCPRDLAT_QCPRDLAT_Pos         0                                                       /*!< NT_QEP0 QCPRDLAT: QCPRDLAT Position     */
#define NT_QEP0_QCPRDLAT_QCPRDLAT_Msk         (0xffffffffUL << NT_QEP0_QCPRDLAT_QCPRDLAT_Pos)         /*!< NT_QEP0 QCPRDLAT: QCPRDLAT Mask         */

/* -------------------------------  NT_QEP0_INTCLR  ------------------------------- */
#define NT_QEP0_INTCLR_INT_Pos                0                                                       /*!< NT_QEP0 INTCLR: INT Position            */
#define NT_QEP0_INTCLR_INT_Msk                (0x01UL << NT_QEP0_INTCLR_INT_Pos)                      /*!< NT_QEP0 INTCLR: INT Mask                */


/* ================================================================================ */
/* ================        struct 'NT_QEP1' Position & Mask        ================ */
/* ================================================================================ */


/* -------------------------------  NT_QEP1_QPOSCNT  ------------------------------ */
#define NT_QEP1_QPOSCNT_QPOSCNT_Pos           0                                                       /*!< NT_QEP1 QPOSCNT: QPOSCNT Position       */
#define NT_QEP1_QPOSCNT_QPOSCNT_Msk           (0xffffffffUL << NT_QEP1_QPOSCNT_QPOSCNT_Pos)           /*!< NT_QEP1 QPOSCNT: QPOSCNT Mask           */

/* ------------------------------  NT_QEP1_QPOSINIT  ------------------------------ */
#define NT_QEP1_QPOSINIT_QPOSINIT_Pos         0                                                       /*!< NT_QEP1 QPOSINIT: QPOSINIT Position     */
#define NT_QEP1_QPOSINIT_QPOSINIT_Msk         (0xffffffffUL << NT_QEP1_QPOSINIT_QPOSINIT_Pos)         /*!< NT_QEP1 QPOSINIT: QPOSINIT Mask         */

/* -------------------------------  NT_QEP1_QPOSMAX  ------------------------------ */
#define NT_QEP1_QPOSMAX_QPOSMAX_Pos           0                                                       /*!< NT_QEP1 QPOSMAX: QPOSMAX Position       */
#define NT_QEP1_QPOSMAX_QPOSMAX_Msk           (0xffffffffUL << NT_QEP1_QPOSMAX_QPOSMAX_Pos)           /*!< NT_QEP1 QPOSMAX: QPOSMAX Mask           */

/* -------------------------------  NT_QEP1_QPOSCMP  ------------------------------ */
#define NT_QEP1_QPOSCMP_QPOSCMP_Pos           0                                                       /*!< NT_QEP1 QPOSCMP: QPOSCMP Position       */
#define NT_QEP1_QPOSCMP_QPOSCMP_Msk           (0xffffffffUL << NT_QEP1_QPOSCMP_QPOSCMP_Pos)           /*!< NT_QEP1 QPOSCMP: QPOSCMP Mask           */

/* ------------------------------  NT_QEP1_QPOSILAT  ------------------------------ */
#define NT_QEP1_QPOSILAT_QPOSILAT_Pos         0                                                       /*!< NT_QEP1 QPOSILAT: QPOSILAT Position     */
#define NT_QEP1_QPOSILAT_QPOSILAT_Msk         (0xffffffffUL << NT_QEP1_QPOSILAT_QPOSILAT_Pos)         /*!< NT_QEP1 QPOSILAT: QPOSILAT Mask         */

/* ------------------------------  NT_QEP1_QPOSSLAT  ------------------------------ */
#define NT_QEP1_QPOSSLAT_QPOSSLAT_Pos         0                                                       /*!< NT_QEP1 QPOSSLAT: QPOSSLAT Position     */
#define NT_QEP1_QPOSSLAT_QPOSSLAT_Msk         (0xffffffffUL << NT_QEP1_QPOSSLAT_QPOSSLAT_Pos)         /*!< NT_QEP1 QPOSSLAT: QPOSSLAT Mask         */

/* -------------------------------  NT_QEP1_QPOSLAT  ------------------------------ */
#define NT_QEP1_QPOSLAT_QPOSLAT_Pos           0                                                       /*!< NT_QEP1 QPOSLAT: QPOSLAT Position       */
#define NT_QEP1_QPOSLAT_QPOSLAT_Msk           (0xffffffffUL << NT_QEP1_QPOSLAT_QPOSLAT_Pos)           /*!< NT_QEP1 QPOSLAT: QPOSLAT Mask           */

/* --------------------------------  NT_QEP1_QUTMR  ------------------------------- */
#define NT_QEP1_QUTMR_QUTMR_Pos               0                                                       /*!< NT_QEP1 QUTMR: QUTMR Position           */
#define NT_QEP1_QUTMR_QUTMR_Msk               (0xffffffffUL << NT_QEP1_QUTMR_QUTMR_Pos)               /*!< NT_QEP1 QUTMR: QUTMR Mask               */

/* --------------------------------  NT_QEP1_QUPRD  ------------------------------- */
#define NT_QEP1_QUPRD_QUPRD_Pos               0                                                       /*!< NT_QEP1 QUPRD: QUPRD Position           */
#define NT_QEP1_QUPRD_QUPRD_Msk               (0xffffffffUL << NT_QEP1_QUPRD_QUPRD_Pos)               /*!< NT_QEP1 QUPRD: QUPRD Mask               */

/* -------------------------------  NT_QEP1_QWDTMR  ------------------------------- */
#define NT_QEP1_QWDTMR_QWDTMR_Pos             0                                                       /*!< NT_QEP1 QWDTMR: QWDTMR Position         */
#define NT_QEP1_QWDTMR_QWDTMR_Msk             (0xffffffffUL << NT_QEP1_QWDTMR_QWDTMR_Pos)             /*!< NT_QEP1 QWDTMR: QWDTMR Mask             */

/* -------------------------------  NT_QEP1_QWDPRD  ------------------------------- */
#define NT_QEP1_QWDPRD_QWDPRD_Pos             0                                                       /*!< NT_QEP1 QWDPRD: QWDPRD Position         */
#define NT_QEP1_QWDPRD_QWDPRD_Msk             (0xffffffffUL << NT_QEP1_QWDPRD_QWDPRD_Pos)             /*!< NT_QEP1 QWDPRD: QWDPRD Mask             */

/* -------------------------------  NT_QEP1_QDECCTL  ------------------------------ */
#define NT_QEP1_QDECCTL_QSP_Pos               5                                                       /*!< NT_QEP1 QDECCTL: QSP Position           */
#define NT_QEP1_QDECCTL_QSP_Msk               (0x01UL << NT_QEP1_QDECCTL_QSP_Pos)                     /*!< NT_QEP1 QDECCTL: QSP Mask               */
#define NT_QEP1_QDECCTL_QIP_Pos               6                                                       /*!< NT_QEP1 QDECCTL: QIP Position           */
#define NT_QEP1_QDECCTL_QIP_Msk               (0x01UL << NT_QEP1_QDECCTL_QIP_Pos)                     /*!< NT_QEP1 QDECCTL: QIP Mask               */
#define NT_QEP1_QDECCTL_QBP_Pos               7                                                       /*!< NT_QEP1 QDECCTL: QBP Position           */
#define NT_QEP1_QDECCTL_QBP_Msk               (0x01UL << NT_QEP1_QDECCTL_QBP_Pos)                     /*!< NT_QEP1 QDECCTL: QBP Mask               */
#define NT_QEP1_QDECCTL_QAP_Pos               8                                                       /*!< NT_QEP1 QDECCTL: QAP Position           */
#define NT_QEP1_QDECCTL_QAP_Msk               (0x01UL << NT_QEP1_QDECCTL_QAP_Pos)                     /*!< NT_QEP1 QDECCTL: QAP Mask               */
#define NT_QEP1_QDECCTL_IGATE_Pos             9                                                       /*!< NT_QEP1 QDECCTL: IGATE Position         */
#define NT_QEP1_QDECCTL_IGATE_Msk             (0x01UL << NT_QEP1_QDECCTL_IGATE_Pos)                   /*!< NT_QEP1 QDECCTL: IGATE Mask             */
#define NT_QEP1_QDECCTL_SWAP_Pos              10                                                      /*!< NT_QEP1 QDECCTL: SWAP Position          */
#define NT_QEP1_QDECCTL_SWAP_Msk              (0x01UL << NT_QEP1_QDECCTL_SWAP_Pos)                    /*!< NT_QEP1 QDECCTL: SWAP Mask              */
#define NT_QEP1_QDECCTL_XCR_Pos               11                                                      /*!< NT_QEP1 QDECCTL: XCR Position           */
#define NT_QEP1_QDECCTL_XCR_Msk               (0x01UL << NT_QEP1_QDECCTL_XCR_Pos)                     /*!< NT_QEP1 QDECCTL: XCR Mask               */
#define NT_QEP1_QDECCTL_SPSEL_Pos             12                                                      /*!< NT_QEP1 QDECCTL: SPSEL Position         */
#define NT_QEP1_QDECCTL_SPSEL_Msk             (0x01UL << NT_QEP1_QDECCTL_SPSEL_Pos)                   /*!< NT_QEP1 QDECCTL: SPSEL Mask             */
#define NT_QEP1_QDECCTL_SOEN_Pos              13                                                      /*!< NT_QEP1 QDECCTL: SOEN Position          */
#define NT_QEP1_QDECCTL_SOEN_Msk              (0x01UL << NT_QEP1_QDECCTL_SOEN_Pos)                    /*!< NT_QEP1 QDECCTL: SOEN Mask              */
#define NT_QEP1_QDECCTL_QSRC_Pos              14                                                      /*!< NT_QEP1 QDECCTL: QSRC Position          */
#define NT_QEP1_QDECCTL_QSRC_Msk              (0x03UL << NT_QEP1_QDECCTL_QSRC_Pos)                    /*!< NT_QEP1 QDECCTL: QSRC Mask              */

/* -------------------------------  NT_QEP1_QEPCTL  ------------------------------- */
#define NT_QEP1_QEPCTL_WDE_Pos                0                                                       /*!< NT_QEP1 QEPCTL: WDE Position            */
#define NT_QEP1_QEPCTL_WDE_Msk                (0x01UL << NT_QEP1_QEPCTL_WDE_Pos)                      /*!< NT_QEP1 QEPCTL: WDE Mask                */
#define NT_QEP1_QEPCTL_UTE_Pos                1                                                       /*!< NT_QEP1 QEPCTL: UTE Position            */
#define NT_QEP1_QEPCTL_UTE_Msk                (0x01UL << NT_QEP1_QEPCTL_UTE_Pos)                      /*!< NT_QEP1 QEPCTL: UTE Mask                */
#define NT_QEP1_QEPCTL_QCLM_Pos               2                                                       /*!< NT_QEP1 QEPCTL: QCLM Position           */
#define NT_QEP1_QEPCTL_QCLM_Msk               (0x01UL << NT_QEP1_QEPCTL_QCLM_Pos)                     /*!< NT_QEP1 QEPCTL: QCLM Mask               */
#define NT_QEP1_QEPCTL_QPEN_Pos               3                                                       /*!< NT_QEP1 QEPCTL: QPEN Position           */
#define NT_QEP1_QEPCTL_QPEN_Msk               (0x01UL << NT_QEP1_QEPCTL_QPEN_Pos)                     /*!< NT_QEP1 QEPCTL: QPEN Mask               */
#define NT_QEP1_QEPCTL_IEL_Pos                4                                                       /*!< NT_QEP1 QEPCTL: IEL Position            */
#define NT_QEP1_QEPCTL_IEL_Msk                (0x03UL << NT_QEP1_QEPCTL_IEL_Pos)                      /*!< NT_QEP1 QEPCTL: IEL Mask                */
#define NT_QEP1_QEPCTL_SEL_Pos                6                                                       /*!< NT_QEP1 QEPCTL: SEL Position            */
#define NT_QEP1_QEPCTL_SEL_Msk                (0x01UL << NT_QEP1_QEPCTL_SEL_Pos)                      /*!< NT_QEP1 QEPCTL: SEL Mask                */
#define NT_QEP1_QEPCTL_SWI_Pos                7                                                       /*!< NT_QEP1 QEPCTL: SWI Position            */
#define NT_QEP1_QEPCTL_SWI_Msk                (0x01UL << NT_QEP1_QEPCTL_SWI_Pos)                      /*!< NT_QEP1 QEPCTL: SWI Mask                */
#define NT_QEP1_QEPCTL_IEI_Pos                8                                                       /*!< NT_QEP1 QEPCTL: IEI Position            */
#define NT_QEP1_QEPCTL_IEI_Msk                (0x03UL << NT_QEP1_QEPCTL_IEI_Pos)                      /*!< NT_QEP1 QEPCTL: IEI Mask                */
#define NT_QEP1_QEPCTL_SEI_Pos                10                                                      /*!< NT_QEP1 QEPCTL: SEI Position            */
#define NT_QEP1_QEPCTL_SEI_Msk                (0x03UL << NT_QEP1_QEPCTL_SEI_Pos)                      /*!< NT_QEP1 QEPCTL: SEI Mask                */
#define NT_QEP1_QEPCTL_PCRM_Pos               12                                                      /*!< NT_QEP1 QEPCTL: PCRM Position           */
#define NT_QEP1_QEPCTL_PCRM_Msk               (0x03UL << NT_QEP1_QEPCTL_PCRM_Pos)                     /*!< NT_QEP1 QEPCTL: PCRM Mask               */
#define NT_QEP1_QEPCTL_FREE_SOFT_Pos          14                                                      /*!< NT_QEP1 QEPCTL: FREE_SOFT Position      */
#define NT_QEP1_QEPCTL_FREE_SOFT_Msk          (0x03UL << NT_QEP1_QEPCTL_FREE_SOFT_Pos)                /*!< NT_QEP1 QEPCTL: FREE_SOFT Mask          */

/* -------------------------------  NT_QEP1_QCAPCTL  ------------------------------ */
#define NT_QEP1_QCAPCTL_UPPS_Pos              0                                                       /*!< NT_QEP1 QCAPCTL: UPPS Position          */
#define NT_QEP1_QCAPCTL_UPPS_Msk              (0x0fUL << NT_QEP1_QCAPCTL_UPPS_Pos)                    /*!< NT_QEP1 QCAPCTL: UPPS Mask              */
#define NT_QEP1_QCAPCTL_CCPS_Pos              4                                                       /*!< NT_QEP1 QCAPCTL: CCPS Position          */
#define NT_QEP1_QCAPCTL_CCPS_Msk              (0x07UL << NT_QEP1_QCAPCTL_CCPS_Pos)                    /*!< NT_QEP1 QCAPCTL: CCPS Mask              */
#define NT_QEP1_QCAPCTL_SELEVENT_Pos          7                                                       /*!< NT_QEP1 QCAPCTL: SELEVENT Position      */
#define NT_QEP1_QCAPCTL_SELEVENT_Msk          (0x01UL << NT_QEP1_QCAPCTL_SELEVENT_Pos)                /*!< NT_QEP1 QCAPCTL: SELEVENT Mask          */
#define NT_QEP1_QCAPCTL_CEN_Pos               15                                                      /*!< NT_QEP1 QCAPCTL: CEN Position           */
#define NT_QEP1_QCAPCTL_CEN_Msk               (0x01UL << NT_QEP1_QCAPCTL_CEN_Pos)                     /*!< NT_QEP1 QCAPCTL: CEN Mask               */

/* -------------------------------  NT_QEP1_QPOSCTL  ------------------------------ */
#define NT_QEP1_QPOSCTL_PCSPW_Pos             0                                                       /*!< NT_QEP1 QPOSCTL: PCSPW Position         */
#define NT_QEP1_QPOSCTL_PCSPW_Msk             (0x00000fffUL << NT_QEP1_QPOSCTL_PCSPW_Pos)             /*!< NT_QEP1 QPOSCTL: PCSPW Mask             */
#define NT_QEP1_QPOSCTL_PCE_Pos               12                                                      /*!< NT_QEP1 QPOSCTL: PCE Position           */
#define NT_QEP1_QPOSCTL_PCE_Msk               (0x01UL << NT_QEP1_QPOSCTL_PCE_Pos)                     /*!< NT_QEP1 QPOSCTL: PCE Mask               */
#define NT_QEP1_QPOSCTL_PCPOL_Pos             13                                                      /*!< NT_QEP1 QPOSCTL: PCPOL Position         */
#define NT_QEP1_QPOSCTL_PCPOL_Msk             (0x01UL << NT_QEP1_QPOSCTL_PCPOL_Pos)                   /*!< NT_QEP1 QPOSCTL: PCPOL Mask             */
#define NT_QEP1_QPOSCTL_PCLOAD_Pos            14                                                      /*!< NT_QEP1 QPOSCTL: PCLOAD Position        */
#define NT_QEP1_QPOSCTL_PCLOAD_Msk            (0x01UL << NT_QEP1_QPOSCTL_PCLOAD_Pos)                  /*!< NT_QEP1 QPOSCTL: PCLOAD Mask            */
#define NT_QEP1_QPOSCTL_PCSHDW_Pos            15                                                      /*!< NT_QEP1 QPOSCTL: PCSHDW Position        */
#define NT_QEP1_QPOSCTL_PCSHDW_Msk            (0x01UL << NT_QEP1_QPOSCTL_PCSHDW_Pos)                  /*!< NT_QEP1 QPOSCTL: PCSHDW Mask            */

/* --------------------------------  NT_QEP1_QEINT  ------------------------------- */
#define NT_QEP1_QEINT_PCE_Pos                 1                                                       /*!< NT_QEP1 QEINT: PCE Position             */
#define NT_QEP1_QEINT_PCE_Msk                 (0x01UL << NT_QEP1_QEINT_PCE_Pos)                       /*!< NT_QEP1 QEINT: PCE Mask                 */
#define NT_QEP1_QEINT_QPE_Pos                 2                                                       /*!< NT_QEP1 QEINT: QPE Position             */
#define NT_QEP1_QEINT_QPE_Msk                 (0x01UL << NT_QEP1_QEINT_QPE_Pos)                       /*!< NT_QEP1 QEINT: QPE Mask                 */
#define NT_QEP1_QEINT_QDC_Pos                 3                                                       /*!< NT_QEP1 QEINT: QDC Position             */
#define NT_QEP1_QEINT_QDC_Msk                 (0x01UL << NT_QEP1_QEINT_QDC_Pos)                       /*!< NT_QEP1 QEINT: QDC Mask                 */
#define NT_QEP1_QEINT_WTO_Pos                 4                                                       /*!< NT_QEP1 QEINT: WTO Position             */
#define NT_QEP1_QEINT_WTO_Msk                 (0x01UL << NT_QEP1_QEINT_WTO_Pos)                       /*!< NT_QEP1 QEINT: WTO Mask                 */
#define NT_QEP1_QEINT_PCU_Pos                 5                                                       /*!< NT_QEP1 QEINT: PCU Position             */
#define NT_QEP1_QEINT_PCU_Msk                 (0x01UL << NT_QEP1_QEINT_PCU_Pos)                       /*!< NT_QEP1 QEINT: PCU Mask                 */
#define NT_QEP1_QEINT_PCO_Pos                 6                                                       /*!< NT_QEP1 QEINT: PCO Position             */
#define NT_QEP1_QEINT_PCO_Msk                 (0x01UL << NT_QEP1_QEINT_PCO_Pos)                       /*!< NT_QEP1 QEINT: PCO Mask                 */
#define NT_QEP1_QEINT_PCR_Pos                 7                                                       /*!< NT_QEP1 QEINT: PCR Position             */
#define NT_QEP1_QEINT_PCR_Msk                 (0x01UL << NT_QEP1_QEINT_PCR_Pos)                       /*!< NT_QEP1 QEINT: PCR Mask                 */
#define NT_QEP1_QEINT_PCM_Pos                 8                                                       /*!< NT_QEP1 QEINT: PCM Position             */
#define NT_QEP1_QEINT_PCM_Msk                 (0x01UL << NT_QEP1_QEINT_PCM_Pos)                       /*!< NT_QEP1 QEINT: PCM Mask                 */
#define NT_QEP1_QEINT_SEL_Pos                 9                                                       /*!< NT_QEP1 QEINT: SEL Position             */
#define NT_QEP1_QEINT_SEL_Msk                 (0x01UL << NT_QEP1_QEINT_SEL_Pos)                       /*!< NT_QEP1 QEINT: SEL Mask                 */
#define NT_QEP1_QEINT_IEL_Pos                 10                                                      /*!< NT_QEP1 QEINT: IEL Position             */
#define NT_QEP1_QEINT_IEL_Msk                 (0x01UL << NT_QEP1_QEINT_IEL_Pos)                       /*!< NT_QEP1 QEINT: IEL Mask                 */
#define NT_QEP1_QEINT_UTO_Pos                 11                                                      /*!< NT_QEP1 QEINT: UTO Position             */
#define NT_QEP1_QEINT_UTO_Msk                 (0x01UL << NT_QEP1_QEINT_UTO_Pos)                       /*!< NT_QEP1 QEINT: UTO Mask                 */

/* --------------------------------  NT_QEP1_QFLG  -------------------------------- */
#define NT_QEP1_QFLG_INT_Pos                  0                                                       /*!< NT_QEP1 QFLG: INT Position              */
#define NT_QEP1_QFLG_INT_Msk                  (0x01UL << NT_QEP1_QFLG_INT_Pos)                        /*!< NT_QEP1 QFLG: INT Mask                  */
#define NT_QEP1_QFLG_PCE_Pos                  1                                                       /*!< NT_QEP1 QFLG: PCE Position              */
#define NT_QEP1_QFLG_PCE_Msk                  (0x01UL << NT_QEP1_QFLG_PCE_Pos)                        /*!< NT_QEP1 QFLG: PCE Mask                  */
#define NT_QEP1_QFLG_QPE_Pos                  2                                                       /*!< NT_QEP1 QFLG: QPE Position              */
#define NT_QEP1_QFLG_QPE_Msk                  (0x01UL << NT_QEP1_QFLG_QPE_Pos)                        /*!< NT_QEP1 QFLG: QPE Mask                  */
#define NT_QEP1_QFLG_QDC_Pos                  3                                                       /*!< NT_QEP1 QFLG: QDC Position              */
#define NT_QEP1_QFLG_QDC_Msk                  (0x01UL << NT_QEP1_QFLG_QDC_Pos)                        /*!< NT_QEP1 QFLG: QDC Mask                  */
#define NT_QEP1_QFLG_WTO_Pos                  4                                                       /*!< NT_QEP1 QFLG: WTO Position              */
#define NT_QEP1_QFLG_WTO_Msk                  (0x01UL << NT_QEP1_QFLG_WTO_Pos)                        /*!< NT_QEP1 QFLG: WTO Mask                  */
#define NT_QEP1_QFLG_PCU_Pos                  5                                                       /*!< NT_QEP1 QFLG: PCU Position              */
#define NT_QEP1_QFLG_PCU_Msk                  (0x01UL << NT_QEP1_QFLG_PCU_Pos)                        /*!< NT_QEP1 QFLG: PCU Mask                  */
#define NT_QEP1_QFLG_PCO_Pos                  6                                                       /*!< NT_QEP1 QFLG: PCO Position              */
#define NT_QEP1_QFLG_PCO_Msk                  (0x01UL << NT_QEP1_QFLG_PCO_Pos)                        /*!< NT_QEP1 QFLG: PCO Mask                  */
#define NT_QEP1_QFLG_PCR_Pos                  7                                                       /*!< NT_QEP1 QFLG: PCR Position              */
#define NT_QEP1_QFLG_PCR_Msk                  (0x01UL << NT_QEP1_QFLG_PCR_Pos)                        /*!< NT_QEP1 QFLG: PCR Mask                  */
#define NT_QEP1_QFLG_PCM_Pos                  8                                                       /*!< NT_QEP1 QFLG: PCM Position              */
#define NT_QEP1_QFLG_PCM_Msk                  (0x01UL << NT_QEP1_QFLG_PCM_Pos)                        /*!< NT_QEP1 QFLG: PCM Mask                  */
#define NT_QEP1_QFLG_SEL_Pos                  9                                                       /*!< NT_QEP1 QFLG: SEL Position              */
#define NT_QEP1_QFLG_SEL_Msk                  (0x01UL << NT_QEP1_QFLG_SEL_Pos)                        /*!< NT_QEP1 QFLG: SEL Mask                  */
#define NT_QEP1_QFLG_IEL_Pos                  10                                                      /*!< NT_QEP1 QFLG: IEL Position              */
#define NT_QEP1_QFLG_IEL_Msk                  (0x01UL << NT_QEP1_QFLG_IEL_Pos)                        /*!< NT_QEP1 QFLG: IEL Mask                  */
#define NT_QEP1_QFLG_UTO_Pos                  11                                                      /*!< NT_QEP1 QFLG: UTO Position              */
#define NT_QEP1_QFLG_UTO_Msk                  (0x01UL << NT_QEP1_QFLG_UTO_Pos)                        /*!< NT_QEP1 QFLG: UTO Mask                  */

/* --------------------------------  NT_QEP1_QCLR  -------------------------------- */
#define NT_QEP1_QCLR_INT_Pos                  0                                                       /*!< NT_QEP1 QCLR: INT Position              */
#define NT_QEP1_QCLR_INT_Msk                  (0x01UL << NT_QEP1_QCLR_INT_Pos)                        /*!< NT_QEP1 QCLR: INT Mask                  */
#define NT_QEP1_QCLR_PCE_Pos                  1                                                       /*!< NT_QEP1 QCLR: PCE Position              */
#define NT_QEP1_QCLR_PCE_Msk                  (0x01UL << NT_QEP1_QCLR_PCE_Pos)                        /*!< NT_QEP1 QCLR: PCE Mask                  */
#define NT_QEP1_QCLR_QPE_Pos                  2                                                       /*!< NT_QEP1 QCLR: QPE Position              */
#define NT_QEP1_QCLR_QPE_Msk                  (0x01UL << NT_QEP1_QCLR_QPE_Pos)                        /*!< NT_QEP1 QCLR: QPE Mask                  */
#define NT_QEP1_QCLR_QDC_Pos                  3                                                       /*!< NT_QEP1 QCLR: QDC Position              */
#define NT_QEP1_QCLR_QDC_Msk                  (0x01UL << NT_QEP1_QCLR_QDC_Pos)                        /*!< NT_QEP1 QCLR: QDC Mask                  */
#define NT_QEP1_QCLR_WTO_Pos                  4                                                       /*!< NT_QEP1 QCLR: WTO Position              */
#define NT_QEP1_QCLR_WTO_Msk                  (0x01UL << NT_QEP1_QCLR_WTO_Pos)                        /*!< NT_QEP1 QCLR: WTO Mask                  */
#define NT_QEP1_QCLR_PCU_Pos                  5                                                       /*!< NT_QEP1 QCLR: PCU Position              */
#define NT_QEP1_QCLR_PCU_Msk                  (0x01UL << NT_QEP1_QCLR_PCU_Pos)                        /*!< NT_QEP1 QCLR: PCU Mask                  */
#define NT_QEP1_QCLR_PCO_Pos                  6                                                       /*!< NT_QEP1 QCLR: PCO Position              */
#define NT_QEP1_QCLR_PCO_Msk                  (0x01UL << NT_QEP1_QCLR_PCO_Pos)                        /*!< NT_QEP1 QCLR: PCO Mask                  */
#define NT_QEP1_QCLR_PCR_Pos                  7                                                       /*!< NT_QEP1 QCLR: PCR Position              */
#define NT_QEP1_QCLR_PCR_Msk                  (0x01UL << NT_QEP1_QCLR_PCR_Pos)                        /*!< NT_QEP1 QCLR: PCR Mask                  */
#define NT_QEP1_QCLR_PCM_Pos                  8                                                       /*!< NT_QEP1 QCLR: PCM Position              */
#define NT_QEP1_QCLR_PCM_Msk                  (0x01UL << NT_QEP1_QCLR_PCM_Pos)                        /*!< NT_QEP1 QCLR: PCM Mask                  */
#define NT_QEP1_QCLR_SEL_Pos                  9                                                       /*!< NT_QEP1 QCLR: SEL Position              */
#define NT_QEP1_QCLR_SEL_Msk                  (0x01UL << NT_QEP1_QCLR_SEL_Pos)                        /*!< NT_QEP1 QCLR: SEL Mask                  */
#define NT_QEP1_QCLR_IEL_Pos                  10                                                      /*!< NT_QEP1 QCLR: IEL Position              */
#define NT_QEP1_QCLR_IEL_Msk                  (0x01UL << NT_QEP1_QCLR_IEL_Pos)                        /*!< NT_QEP1 QCLR: IEL Mask                  */
#define NT_QEP1_QCLR_UTO_Pos                  11                                                      /*!< NT_QEP1 QCLR: UTO Position              */
#define NT_QEP1_QCLR_UTO_Msk                  (0x01UL << NT_QEP1_QCLR_UTO_Pos)                        /*!< NT_QEP1 QCLR: UTO Mask                  */

/* --------------------------------  NT_QEP1_QFRC  -------------------------------- */
#define NT_QEP1_QFRC_PCE_Pos                  1                                                       /*!< NT_QEP1 QFRC: PCE Position              */
#define NT_QEP1_QFRC_PCE_Msk                  (0x01UL << NT_QEP1_QFRC_PCE_Pos)                        /*!< NT_QEP1 QFRC: PCE Mask                  */
#define NT_QEP1_QFRC_QPE_Pos                  2                                                       /*!< NT_QEP1 QFRC: QPE Position              */
#define NT_QEP1_QFRC_QPE_Msk                  (0x01UL << NT_QEP1_QFRC_QPE_Pos)                        /*!< NT_QEP1 QFRC: QPE Mask                  */
#define NT_QEP1_QFRC_QDC_Pos                  3                                                       /*!< NT_QEP1 QFRC: QDC Position              */
#define NT_QEP1_QFRC_QDC_Msk                  (0x01UL << NT_QEP1_QFRC_QDC_Pos)                        /*!< NT_QEP1 QFRC: QDC Mask                  */
#define NT_QEP1_QFRC_WTO_Pos                  4                                                       /*!< NT_QEP1 QFRC: WTO Position              */
#define NT_QEP1_QFRC_WTO_Msk                  (0x01UL << NT_QEP1_QFRC_WTO_Pos)                        /*!< NT_QEP1 QFRC: WTO Mask                  */
#define NT_QEP1_QFRC_PCU_Pos                  5                                                       /*!< NT_QEP1 QFRC: PCU Position              */
#define NT_QEP1_QFRC_PCU_Msk                  (0x01UL << NT_QEP1_QFRC_PCU_Pos)                        /*!< NT_QEP1 QFRC: PCU Mask                  */
#define NT_QEP1_QFRC_PCO_Pos                  6                                                       /*!< NT_QEP1 QFRC: PCO Position              */
#define NT_QEP1_QFRC_PCO_Msk                  (0x01UL << NT_QEP1_QFRC_PCO_Pos)                        /*!< NT_QEP1 QFRC: PCO Mask                  */
#define NT_QEP1_QFRC_PCR_Pos                  7                                                       /*!< NT_QEP1 QFRC: PCR Position              */
#define NT_QEP1_QFRC_PCR_Msk                  (0x01UL << NT_QEP1_QFRC_PCR_Pos)                        /*!< NT_QEP1 QFRC: PCR Mask                  */
#define NT_QEP1_QFRC_PCM_Pos                  8                                                       /*!< NT_QEP1 QFRC: PCM Position              */
#define NT_QEP1_QFRC_PCM_Msk                  (0x01UL << NT_QEP1_QFRC_PCM_Pos)                        /*!< NT_QEP1 QFRC: PCM Mask                  */
#define NT_QEP1_QFRC_SEL_Pos                  9                                                       /*!< NT_QEP1 QFRC: SEL Position              */
#define NT_QEP1_QFRC_SEL_Msk                  (0x01UL << NT_QEP1_QFRC_SEL_Pos)                        /*!< NT_QEP1 QFRC: SEL Mask                  */
#define NT_QEP1_QFRC_IEL_Pos                  10                                                      /*!< NT_QEP1 QFRC: IEL Position              */
#define NT_QEP1_QFRC_IEL_Msk                  (0x01UL << NT_QEP1_QFRC_IEL_Pos)                        /*!< NT_QEP1 QFRC: IEL Mask                  */
#define NT_QEP1_QFRC_UTO_Pos                  11                                                      /*!< NT_QEP1 QFRC: UTO Position              */
#define NT_QEP1_QFRC_UTO_Msk                  (0x01UL << NT_QEP1_QFRC_UTO_Pos)                        /*!< NT_QEP1 QFRC: UTO Mask                  */

/* -------------------------------  NT_QEP1_QEPSTS  ------------------------------- */
#define NT_QEP1_QEPSTS_PCEF_Pos               0                                                       /*!< NT_QEP1 QEPSTS: PCEF Position           */
#define NT_QEP1_QEPSTS_PCEF_Msk               (0x01UL << NT_QEP1_QEPSTS_PCEF_Pos)                     /*!< NT_QEP1 QEPSTS: PCEF Mask               */
#define NT_QEP1_QEPSTS_FIMF_Pos               1                                                       /*!< NT_QEP1 QEPSTS: FIMF Position           */
#define NT_QEP1_QEPSTS_FIMF_Msk               (0x01UL << NT_QEP1_QEPSTS_FIMF_Pos)                     /*!< NT_QEP1 QEPSTS: FIMF Mask               */
#define NT_QEP1_QEPSTS_CDEF_Pos               2                                                       /*!< NT_QEP1 QEPSTS: CDEF Position           */
#define NT_QEP1_QEPSTS_CDEF_Msk               (0x01UL << NT_QEP1_QEPSTS_CDEF_Pos)                     /*!< NT_QEP1 QEPSTS: CDEF Mask               */
#define NT_QEP1_QEPSTS_COEF_Pos               3                                                       /*!< NT_QEP1 QEPSTS: COEF Position           */
#define NT_QEP1_QEPSTS_COEF_Msk               (0x01UL << NT_QEP1_QEPSTS_COEF_Pos)                     /*!< NT_QEP1 QEPSTS: COEF Mask               */
#define NT_QEP1_QEPSTS_QDLF_Pos               4                                                       /*!< NT_QEP1 QEPSTS: QDLF Position           */
#define NT_QEP1_QEPSTS_QDLF_Msk               (0x01UL << NT_QEP1_QEPSTS_QDLF_Pos)                     /*!< NT_QEP1 QEPSTS: QDLF Mask               */
#define NT_QEP1_QEPSTS_QDF_Pos                5                                                       /*!< NT_QEP1 QEPSTS: QDF Position            */
#define NT_QEP1_QEPSTS_QDF_Msk                (0x01UL << NT_QEP1_QEPSTS_QDF_Pos)                      /*!< NT_QEP1 QEPSTS: QDF Mask                */
#define NT_QEP1_QEPSTS_FIDF_Pos               6                                                       /*!< NT_QEP1 QEPSTS: FIDF Position           */
#define NT_QEP1_QEPSTS_FIDF_Msk               (0x01UL << NT_QEP1_QEPSTS_FIDF_Pos)                     /*!< NT_QEP1 QEPSTS: FIDF Mask               */
#define NT_QEP1_QEPSTS_UPEVNT_Pos             7                                                       /*!< NT_QEP1 QEPSTS: UPEVNT Position         */
#define NT_QEP1_QEPSTS_UPEVNT_Msk             (0x01UL << NT_QEP1_QEPSTS_UPEVNT_Pos)                   /*!< NT_QEP1 QEPSTS: UPEVNT Mask             */

/* --------------------------------  NT_QEP1_QCTMR  ------------------------------- */
#define NT_QEP1_QCTMR_QCTMR_Pos               0                                                       /*!< NT_QEP1 QCTMR: QCTMR Position           */
#define NT_QEP1_QCTMR_QCTMR_Msk               (0xffffffffUL << NT_QEP1_QCTMR_QCTMR_Pos)               /*!< NT_QEP1 QCTMR: QCTMR Mask               */

/* --------------------------------  NT_QEP1_QCPRD  ------------------------------- */
#define NT_QEP1_QCPRD_QCPRD_Pos               0                                                       /*!< NT_QEP1 QCPRD: QCPRD Position           */
#define NT_QEP1_QCPRD_QCPRD_Msk               (0xffffffffUL << NT_QEP1_QCPRD_QCPRD_Pos)               /*!< NT_QEP1 QCPRD: QCPRD Mask               */

/* ------------------------------  NT_QEP1_QCTMRLAT  ------------------------------ */
#define NT_QEP1_QCTMRLAT_QCTMRLAT_Pos         0                                                       /*!< NT_QEP1 QCTMRLAT: QCTMRLAT Position     */
#define NT_QEP1_QCTMRLAT_QCTMRLAT_Msk         (0xffffffffUL << NT_QEP1_QCTMRLAT_QCTMRLAT_Pos)         /*!< NT_QEP1 QCTMRLAT: QCTMRLAT Mask         */

/* ------------------------------  NT_QEP1_QCPRDLAT  ------------------------------ */
#define NT_QEP1_QCPRDLAT_QCPRDLAT_Pos         0                                                       /*!< NT_QEP1 QCPRDLAT: QCPRDLAT Position     */
#define NT_QEP1_QCPRDLAT_QCPRDLAT_Msk         (0xffffffffUL << NT_QEP1_QCPRDLAT_QCPRDLAT_Pos)         /*!< NT_QEP1 QCPRDLAT: QCPRDLAT Mask         */

/* -------------------------------  NT_QEP1_INTCLR  ------------------------------- */
#define NT_QEP1_INTCLR_INT_Pos                0                                                       /*!< NT_QEP1 INTCLR: INT Position            */
#define NT_QEP1_INTCLR_INT_Msk                (0x01UL << NT_QEP1_INTCLR_INT_Pos)                      /*!< NT_QEP1 INTCLR: INT Mask                */


/* ================================================================================ */
/* ================      struct 'NT_BOOTFLASH' Position & Mask     ================ */
/* ================================================================================ */


/* ------------------------------  NT_BOOTFLASH_FMA  ------------------------------ */
#define NT_BOOTFLASH_FMA_ADDR_Pos             0                                                       /*!< NT_BOOTFLASH FMA: ADDR Position         */
#define NT_BOOTFLASH_FMA_ADDR_Msk             (0x000fffffUL << NT_BOOTFLASH_FMA_ADDR_Pos)             /*!< NT_BOOTFLASH FMA: ADDR Mask             */

/* ------------------------------  NT_BOOTFLASH_FMD0  ----------------------------- */
#define NT_BOOTFLASH_FMD0_DATA0_Pos           0                                                       /*!< NT_BOOTFLASH FMD0: DATA0 Position       */
#define NT_BOOTFLASH_FMD0_DATA0_Msk           (0xffffffffUL << NT_BOOTFLASH_FMD0_DATA0_Pos)           /*!< NT_BOOTFLASH FMD0: DATA0 Mask           */

/* ------------------------------  NT_BOOTFLASH_FMC  ------------------------------ */
#define NT_BOOTFLASH_FMC_WRITE_Pos            0                                                       /*!< NT_BOOTFLASH FMC: WRITE Position        */
#define NT_BOOTFLASH_FMC_WRITE_Msk            (0x01UL << NT_BOOTFLASH_FMC_WRITE_Pos)                  /*!< NT_BOOTFLASH FMC: WRITE Mask            */
#define NT_BOOTFLASH_FMC_PAGE_ERASE_Pos       1                                                       /*!< NT_BOOTFLASH FMC: PAGE_ERASE Position   */
#define NT_BOOTFLASH_FMC_PAGE_ERASE_Msk       (0x01UL << NT_BOOTFLASH_FMC_PAGE_ERASE_Pos)             /*!< NT_BOOTFLASH FMC: PAGE_ERASE Mask       */
#define NT_BOOTFLASH_FMC_FULL_ERASE_Pos       2                                                       /*!< NT_BOOTFLASH FMC: FULL_ERASE Position   */
#define NT_BOOTFLASH_FMC_FULL_ERASE_Msk       (0x01UL << NT_BOOTFLASH_FMC_FULL_ERASE_Pos)             /*!< NT_BOOTFLASH FMC: FULL_ERASE Mask       */
#define NT_BOOTFLASH_FMC_WRITE_IFB_Pos        4                                                       /*!< NT_BOOTFLASH FMC: WRITE_IFB Position    */
#define NT_BOOTFLASH_FMC_WRITE_IFB_Msk        (0x01UL << NT_BOOTFLASH_FMC_WRITE_IFB_Pos)              /*!< NT_BOOTFLASH FMC: WRITE_IFB Mask        */
#define NT_BOOTFLASH_FMC_PAGEERASE_IFB_Pos    5                                                       /*!< NT_BOOTFLASH FMC: PAGEERASE_IFB Position */
#define NT_BOOTFLASH_FMC_PAGEERASE_IFB_Msk    (0x01UL << NT_BOOTFLASH_FMC_PAGEERASE_IFB_Pos)          /*!< NT_BOOTFLASH FMC: PAGEERASE_IFB Mask    */
#define NT_BOOTFLASH_FMC_MAGIC_KEY_Pos        16                                                      /*!< NT_BOOTFLASH FMC: MAGIC_KEY Position    */
#define NT_BOOTFLASH_FMC_MAGIC_KEY_Msk        (0x0000ffffUL << NT_BOOTFLASH_FMC_MAGIC_KEY_Pos)        /*!< NT_BOOTFLASH FMC: MAGIC_KEY Mask        */

/* ------------------------------  NT_BOOTFLASH_FCIS  ----------------------------- */
#define NT_BOOTFLASH_FCIS_OP_CMLT_Pos         0                                                       /*!< NT_BOOTFLASH FCIS: OP_CMLT Position     */
#define NT_BOOTFLASH_FCIS_OP_CMLT_Msk         (0x01UL << NT_BOOTFLASH_FCIS_OP_CMLT_Pos)               /*!< NT_BOOTFLASH FCIS: OP_CMLT Mask         */
#define NT_BOOTFLASH_FCIS_OP_ERROR_Pos        1                                                       /*!< NT_BOOTFLASH FCIS: OP_ERROR Position    */
#define NT_BOOTFLASH_FCIS_OP_ERROR_Msk        (0x01UL << NT_BOOTFLASH_FCIS_OP_ERROR_Pos)              /*!< NT_BOOTFLASH FCIS: OP_ERROR Mask        */

/* ------------------------------  NT_BOOTFLASH_FCIM  ----------------------------- */
#define NT_BOOTFLASH_FCIM_MASK_OPCMLT_Pos     0                                                       /*!< NT_BOOTFLASH FCIM: MASK_OPCMLT Position */
#define NT_BOOTFLASH_FCIM_MASK_OPCMLT_Msk     (0x01UL << NT_BOOTFLASH_FCIM_MASK_OPCMLT_Pos)           /*!< NT_BOOTFLASH FCIM: MASK_OPCMLT Mask     */

/* ------------------------------  NT_BOOTFLASH_FCIC  ----------------------------- */
#define NT_BOOTFLASH_FCIC_CLR_OPCMLT_Pos      0                                                       /*!< NT_BOOTFLASH FCIC: CLR_OPCMLT Position  */
#define NT_BOOTFLASH_FCIC_CLR_OPCMLT_Msk      (0x01UL << NT_BOOTFLASH_FCIC_CLR_OPCMLT_Pos)            /*!< NT_BOOTFLASH FCIC: CLR_OPCMLT Mask      */
#define NT_BOOTFLASH_FCIC_CLR_OPERROR_Pos     1                                                       /*!< NT_BOOTFLASH FCIC: CLR_OPERROR Position */
#define NT_BOOTFLASH_FCIC_CLR_OPERROR_Msk     (0x01UL << NT_BOOTFLASH_FCIC_CLR_OPERROR_Pos)           /*!< NT_BOOTFLASH FCIC: CLR_OPERROR Mask     */

/* ------------------------------  NT_BOOTFLASH_FMD1  ----------------------------- */
#define NT_BOOTFLASH_FMD1_DATA1_Pos           0                                                       /*!< NT_BOOTFLASH FMD1: DATA1 Position       */
#define NT_BOOTFLASH_FMD1_DATA1_Msk           (0xffffffffUL << NT_BOOTFLASH_FMD1_DATA1_Pos)           /*!< NT_BOOTFLASH FMD1: DATA1 Mask           */

/* ------------------------------  NT_BOOTFLASH_FMD2  ----------------------------- */
#define NT_BOOTFLASH_FMD2_DATA2_Pos           0                                                       /*!< NT_BOOTFLASH FMD2: DATA2 Position       */
#define NT_BOOTFLASH_FMD2_DATA2_Msk           (0xffffffffUL << NT_BOOTFLASH_FMD2_DATA2_Pos)           /*!< NT_BOOTFLASH FMD2: DATA2 Mask           */

/* ------------------------------  NT_BOOTFLASH_FMD3  ----------------------------- */
#define NT_BOOTFLASH_FMD3_DATA3_Pos           0                                                       /*!< NT_BOOTFLASH FMD3: DATA3 Position       */
#define NT_BOOTFLASH_FMD3_DATA3_Msk           (0xffffffffUL << NT_BOOTFLASH_FMD3_DATA3_Pos)           /*!< NT_BOOTFLASH FMD3: DATA3 Mask           */

/* -----------------------------  NT_BOOTFLASH_T_ACC  ----------------------------- */
#define NT_BOOTFLASH_T_ACC_T_ACC_Pos          0                                                       /*!< NT_BOOTFLASH T_ACC: T_ACC Position      */
#define NT_BOOTFLASH_T_ACC_T_ACC_Msk          (0xffffffffUL << NT_BOOTFLASH_T_ACC_T_ACC_Pos)          /*!< NT_BOOTFLASH T_ACC: T_ACC Mask          */

/* -----------------------------  NT_BOOTFLASH_T_NVS  ----------------------------- */
#define NT_BOOTFLASH_T_NVS_T_NVS_Pos          0                                                       /*!< NT_BOOTFLASH T_NVS: T_NVS Position      */
#define NT_BOOTFLASH_T_NVS_T_NVS_Msk          (0xffffffffUL << NT_BOOTFLASH_T_NVS_T_NVS_Pos)          /*!< NT_BOOTFLASH T_NVS: T_NVS Mask          */

/* -----------------------------  NT_BOOTFLASH_T_NVH  ----------------------------- */
#define NT_BOOTFLASH_T_NVH_T_NVH_Pos          0                                                       /*!< NT_BOOTFLASH T_NVH: T_NVH Position      */
#define NT_BOOTFLASH_T_NVH_T_NVH_Msk          (0xffffffffUL << NT_BOOTFLASH_T_NVH_T_NVH_Pos)          /*!< NT_BOOTFLASH T_NVH: T_NVH Mask          */

/* -----------------------------  NT_BOOTFLASH_T_RCV  ----------------------------- */
#define NT_BOOTFLASH_T_RCV_T_RCV_Pos          0                                                       /*!< NT_BOOTFLASH T_RCV: T_RCV Position      */
#define NT_BOOTFLASH_T_RCV_T_RCV_Msk          (0xffffffffUL << NT_BOOTFLASH_T_RCV_T_RCV_Pos)          /*!< NT_BOOTFLASH T_RCV: T_RCV Mask          */

/* -----------------------------  NT_BOOTFLASH_T_PGS  ----------------------------- */
#define NT_BOOTFLASH_T_PGS_T_PGS_Pos          0                                                       /*!< NT_BOOTFLASH T_PGS: T_PGS Position      */
#define NT_BOOTFLASH_T_PGS_T_PGS_Msk          (0xffffffffUL << NT_BOOTFLASH_T_PGS_T_PGS_Pos)          /*!< NT_BOOTFLASH T_PGS: T_PGS Mask          */

/* -----------------------------  NT_BOOTFLASH_T_PROG  ---------------------------- */
#define NT_BOOTFLASH_T_PROG_T_PROG_Pos        0                                                       /*!< NT_BOOTFLASH T_PROG: T_PROG Position    */
#define NT_BOOTFLASH_T_PROG_T_PROG_Msk        (0xffffffffUL << NT_BOOTFLASH_T_PROG_T_PROG_Pos)        /*!< NT_BOOTFLASH T_PROG: T_PROG Mask        */

/* -----------------------------  NT_BOOTFLASH_T_PGH  ----------------------------- */
#define NT_BOOTFLASH_T_PGH_T_PGH_Pos          0                                                       /*!< NT_BOOTFLASH T_PGH: T_PGH Position      */
#define NT_BOOTFLASH_T_PGH_T_PGH_Msk          (0xffffffffUL << NT_BOOTFLASH_T_PGH_T_PGH_Pos)          /*!< NT_BOOTFLASH T_PGH: T_PGH Mask          */

/* ----------------------------  NT_BOOTFLASH_T_ERASE  ---------------------------- */
#define NT_BOOTFLASH_T_ERASE_T_ERASE_Pos      0                                                       /*!< NT_BOOTFLASH T_ERASE: T_ERASE Position  */
#define NT_BOOTFLASH_T_ERASE_T_ERASE_Msk      (0xffffffffUL << NT_BOOTFLASH_T_ERASE_T_ERASE_Pos)      /*!< NT_BOOTFLASH T_ERASE: T_ERASE Mask      */

/* ------------------------------  NT_BOOTFLASH_T_ME  ----------------------------- */
#define NT_BOOTFLASH_T_ME_T_ME_Pos            0                                                       /*!< NT_BOOTFLASH T_ME: T_ME Position        */
#define NT_BOOTFLASH_T_ME_T_ME_Msk            (0xffffffffUL << NT_BOOTFLASH_T_ME_T_ME_Pos)            /*!< NT_BOOTFLASH T_ME: T_ME Mask            */

/* -----------------------------  NT_BOOTFLASH_T_NVH1  ---------------------------- */
#define NT_BOOTFLASH_T_NVH1_T_NVH1_Pos        0                                                       /*!< NT_BOOTFLASH T_NVH1: T_NVH1 Position    */
#define NT_BOOTFLASH_T_NVH1_T_NVH1_Msk        (0xffffffffUL << NT_BOOTFLASH_T_NVH1_T_NVH1_Pos)        /*!< NT_BOOTFLASH T_NVH1: T_NVH1 Mask        */


/* ================================================================================ */
/* ================        struct 'NT_UART0' Position & Mask       ================ */
/* ================================================================================ */


/* ---------------------------------  NT_UART0_DR  -------------------------------- */
#define NT_UART0_DR_DATA_Pos                  0                                                       /*!< NT_UART0 DR: DATA Position              */
#define NT_UART0_DR_DATA_Msk                  (0x000000ffUL << NT_UART0_DR_DATA_Pos)                  /*!< NT_UART0 DR: DATA Mask                  */
#define NT_UART0_DR_FE_Pos                    8                                                       /*!< NT_UART0 DR: FE Position                */
#define NT_UART0_DR_FE_Msk                    (0x01UL << NT_UART0_DR_FE_Pos)                          /*!< NT_UART0 DR: FE Mask                    */
#define NT_UART0_DR_PE_Pos                    9                                                       /*!< NT_UART0 DR: PE Position                */
#define NT_UART0_DR_PE_Msk                    (0x01UL << NT_UART0_DR_PE_Pos)                          /*!< NT_UART0 DR: PE Mask                    */
#define NT_UART0_DR_BE_Pos                    10                                                      /*!< NT_UART0 DR: BE Position                */
#define NT_UART0_DR_BE_Msk                    (0x01UL << NT_UART0_DR_BE_Pos)                          /*!< NT_UART0 DR: BE Mask                    */
#define NT_UART0_DR_OE_Pos                    11                                                      /*!< NT_UART0 DR: OE Position                */
#define NT_UART0_DR_OE_Msk                    (0x01UL << NT_UART0_DR_OE_Pos)                          /*!< NT_UART0 DR: OE Mask                    */

/* ------------------------------  NT_UART0_RSR_ECR  ------------------------------ */
#define NT_UART0_RSR_ECR_FE_Pos               0                                                       /*!< NT_UART0 RSR_ECR: FE Position           */
#define NT_UART0_RSR_ECR_FE_Msk               (0x01UL << NT_UART0_RSR_ECR_FE_Pos)                     /*!< NT_UART0 RSR_ECR: FE Mask               */
#define NT_UART0_RSR_ECR_PE_Pos               1                                                       /*!< NT_UART0 RSR_ECR: PE Position           */
#define NT_UART0_RSR_ECR_PE_Msk               (0x01UL << NT_UART0_RSR_ECR_PE_Pos)                     /*!< NT_UART0 RSR_ECR: PE Mask               */
#define NT_UART0_RSR_ECR_BE_Pos               2                                                       /*!< NT_UART0 RSR_ECR: BE Position           */
#define NT_UART0_RSR_ECR_BE_Msk               (0x01UL << NT_UART0_RSR_ECR_BE_Pos)                     /*!< NT_UART0 RSR_ECR: BE Mask               */
#define NT_UART0_RSR_ECR_OE_Pos               3                                                       /*!< NT_UART0 RSR_ECR: OE Position           */
#define NT_UART0_RSR_ECR_OE_Msk               (0x01UL << NT_UART0_RSR_ECR_OE_Pos)                     /*!< NT_UART0 RSR_ECR: OE Mask               */

/* ---------------------------------  NT_UART0_FR  -------------------------------- */
#define NT_UART0_FR_CTS_Pos                   0                                                       /*!< NT_UART0 FR: CTS Position               */
#define NT_UART0_FR_CTS_Msk                   (0x01UL << NT_UART0_FR_CTS_Pos)                         /*!< NT_UART0 FR: CTS Mask                   */
#define NT_UART0_FR_DSR_Pos                   1                                                       /*!< NT_UART0 FR: DSR Position               */
#define NT_UART0_FR_DSR_Msk                   (0x01UL << NT_UART0_FR_DSR_Pos)                         /*!< NT_UART0 FR: DSR Mask                   */
#define NT_UART0_FR_DCD_Pos                   2                                                       /*!< NT_UART0 FR: DCD Position               */
#define NT_UART0_FR_DCD_Msk                   (0x01UL << NT_UART0_FR_DCD_Pos)                         /*!< NT_UART0 FR: DCD Mask                   */
#define NT_UART0_FR_BUSY_Pos                  3                                                       /*!< NT_UART0 FR: BUSY Position              */
#define NT_UART0_FR_BUSY_Msk                  (0x01UL << NT_UART0_FR_BUSY_Pos)                        /*!< NT_UART0 FR: BUSY Mask                  */
#define NT_UART0_FR_RXFE_Pos                  4                                                       /*!< NT_UART0 FR: RXFE Position              */
#define NT_UART0_FR_RXFE_Msk                  (0x01UL << NT_UART0_FR_RXFE_Pos)                        /*!< NT_UART0 FR: RXFE Mask                  */
#define NT_UART0_FR_TXFF_Pos                  5                                                       /*!< NT_UART0 FR: TXFF Position              */
#define NT_UART0_FR_TXFF_Msk                  (0x01UL << NT_UART0_FR_TXFF_Pos)                        /*!< NT_UART0 FR: TXFF Mask                  */
#define NT_UART0_FR_RXFF_Pos                  6                                                       /*!< NT_UART0 FR: RXFF Position              */
#define NT_UART0_FR_RXFF_Msk                  (0x01UL << NT_UART0_FR_RXFF_Pos)                        /*!< NT_UART0 FR: RXFF Mask                  */
#define NT_UART0_FR_TXFE_Pos                  7                                                       /*!< NT_UART0 FR: TXFE Position              */
#define NT_UART0_FR_TXFE_Msk                  (0x01UL << NT_UART0_FR_TXFE_Pos)                        /*!< NT_UART0 FR: TXFE Mask                  */
#define NT_UART0_FR_RI_Pos                    8                                                       /*!< NT_UART0 FR: RI Position                */
#define NT_UART0_FR_RI_Msk                    (0x01UL << NT_UART0_FR_RI_Pos)                          /*!< NT_UART0 FR: RI Mask                    */

/* --------------------------------  NT_UART0_IBRD  ------------------------------- */
#define NT_UART0_IBRD_BAUD_DIVINT_Pos         0                                                       /*!< NT_UART0 IBRD: BAUD_DIVINT Position     */
#define NT_UART0_IBRD_BAUD_DIVINT_Msk         (0x0000ffffUL << NT_UART0_IBRD_BAUD_DIVINT_Pos)         /*!< NT_UART0 IBRD: BAUD_DIVINT Mask         */

/* --------------------------------  NT_UART0_FBRD  ------------------------------- */
#define NT_UART0_FBRD_BAUD_DIVFRAC_Pos        0                                                       /*!< NT_UART0 FBRD: BAUD_DIVFRAC Position    */
#define NT_UART0_FBRD_BAUD_DIVFRAC_Msk        (0x3fUL << NT_UART0_FBRD_BAUD_DIVFRAC_Pos)              /*!< NT_UART0 FBRD: BAUD_DIVFRAC Mask        */

/* -------------------------------  NT_UART0_LCR_H  ------------------------------- */
#define NT_UART0_LCR_H_BRK_Pos                0                                                       /*!< NT_UART0 LCR_H: BRK Position            */
#define NT_UART0_LCR_H_BRK_Msk                (0x01UL << NT_UART0_LCR_H_BRK_Pos)                      /*!< NT_UART0 LCR_H: BRK Mask                */
#define NT_UART0_LCR_H_PEN_Pos                1                                                       /*!< NT_UART0 LCR_H: PEN Position            */
#define NT_UART0_LCR_H_PEN_Msk                (0x01UL << NT_UART0_LCR_H_PEN_Pos)                      /*!< NT_UART0 LCR_H: PEN Mask                */
#define NT_UART0_LCR_H_EPS_Pos                2                                                       /*!< NT_UART0 LCR_H: EPS Position            */
#define NT_UART0_LCR_H_EPS_Msk                (0x01UL << NT_UART0_LCR_H_EPS_Pos)                      /*!< NT_UART0 LCR_H: EPS Mask                */
#define NT_UART0_LCR_H_STP2_Pos               3                                                       /*!< NT_UART0 LCR_H: STP2 Position           */
#define NT_UART0_LCR_H_STP2_Msk               (0x01UL << NT_UART0_LCR_H_STP2_Pos)                     /*!< NT_UART0 LCR_H: STP2 Mask               */
#define NT_UART0_LCR_H_FEN_Pos                4                                                       /*!< NT_UART0 LCR_H: FEN Position            */
#define NT_UART0_LCR_H_FEN_Msk                (0x01UL << NT_UART0_LCR_H_FEN_Pos)                      /*!< NT_UART0 LCR_H: FEN Mask                */
#define NT_UART0_LCR_H_WLEN_Pos               5                                                       /*!< NT_UART0 LCR_H: WLEN Position           */
#define NT_UART0_LCR_H_WLEN_Msk               (0x03UL << NT_UART0_LCR_H_WLEN_Pos)                     /*!< NT_UART0 LCR_H: WLEN Mask               */
#define NT_UART0_LCR_H_SPS_Pos                7                                                       /*!< NT_UART0 LCR_H: SPS Position            */
#define NT_UART0_LCR_H_SPS_Msk                (0x01UL << NT_UART0_LCR_H_SPS_Pos)                      /*!< NT_UART0 LCR_H: SPS Mask                */

/* ---------------------------------  NT_UART0_CR  -------------------------------- */
#define NT_UART0_CR_UARTEN_Pos                0                                                       /*!< NT_UART0 CR: UARTEN Position            */
#define NT_UART0_CR_UARTEN_Msk                (0x01UL << NT_UART0_CR_UARTEN_Pos)                      /*!< NT_UART0 CR: UARTEN Mask                */
#define NT_UART0_CR_TXE_Pos                   8                                                       /*!< NT_UART0 CR: TXE Position               */
#define NT_UART0_CR_TXE_Msk                   (0x01UL << NT_UART0_CR_TXE_Pos)                         /*!< NT_UART0 CR: TXE Mask                   */
#define NT_UART0_CR_RXE_Pos                   9                                                       /*!< NT_UART0 CR: RXE Position               */
#define NT_UART0_CR_RXE_Msk                   (0x01UL << NT_UART0_CR_RXE_Pos)                         /*!< NT_UART0 CR: RXE Mask                   */
#define NT_UART0_CR_DTR_Pos                   10                                                      /*!< NT_UART0 CR: DTR Position               */
#define NT_UART0_CR_DTR_Msk                   (0x01UL << NT_UART0_CR_DTR_Pos)                         /*!< NT_UART0 CR: DTR Mask                   */
#define NT_UART0_CR_RTS_Pos                   11                                                      /*!< NT_UART0 CR: RTS Position               */
#define NT_UART0_CR_RTS_Msk                   (0x01UL << NT_UART0_CR_RTS_Pos)                         /*!< NT_UART0 CR: RTS Mask                   */
#define NT_UART0_CR_OUT1_Pos                  12                                                      /*!< NT_UART0 CR: OUT1 Position              */
#define NT_UART0_CR_OUT1_Msk                  (0x01UL << NT_UART0_CR_OUT1_Pos)                        /*!< NT_UART0 CR: OUT1 Mask                  */
#define NT_UART0_CR_OUT2_Pos                  13                                                      /*!< NT_UART0 CR: OUT2 Position              */
#define NT_UART0_CR_OUT2_Msk                  (0x01UL << NT_UART0_CR_OUT2_Pos)                        /*!< NT_UART0 CR: OUT2 Mask                  */
#define NT_UART0_CR_RTSEN_Pos                 14                                                      /*!< NT_UART0 CR: RTSEN Position             */
#define NT_UART0_CR_RTSEN_Msk                 (0x01UL << NT_UART0_CR_RTSEN_Pos)                       /*!< NT_UART0 CR: RTSEN Mask                 */
#define NT_UART0_CR_CTSEN_Pos                 15                                                      /*!< NT_UART0 CR: CTSEN Position             */
#define NT_UART0_CR_CTSEN_Msk                 (0x01UL << NT_UART0_CR_CTSEN_Pos)                       /*!< NT_UART0 CR: CTSEN Mask                 */

/* --------------------------------  NT_UART0_IFLS  ------------------------------- */
#define NT_UART0_IFLS_TXIFLSEL_Pos            0                                                       /*!< NT_UART0 IFLS: TXIFLSEL Position        */
#define NT_UART0_IFLS_TXIFLSEL_Msk            (0x07UL << NT_UART0_IFLS_TXIFLSEL_Pos)                  /*!< NT_UART0 IFLS: TXIFLSEL Mask            */
#define NT_UART0_IFLS_RXIFLSEL_Pos            3                                                       /*!< NT_UART0 IFLS: RXIFLSEL Position        */
#define NT_UART0_IFLS_RXIFLSEL_Msk            (0x07UL << NT_UART0_IFLS_RXIFLSEL_Pos)                  /*!< NT_UART0 IFLS: RXIFLSEL Mask            */

/* --------------------------------  NT_UART0_IMSC  ------------------------------- */
#define NT_UART0_IMSC_RIMIM_Pos               0                                                       /*!< NT_UART0 IMSC: RIMIM Position           */
#define NT_UART0_IMSC_RIMIM_Msk               (0x01UL << NT_UART0_IMSC_RIMIM_Pos)                     /*!< NT_UART0 IMSC: RIMIM Mask               */
#define NT_UART0_IMSC_CTSMIM_Pos              1                                                       /*!< NT_UART0 IMSC: CTSMIM Position          */
#define NT_UART0_IMSC_CTSMIM_Msk              (0x01UL << NT_UART0_IMSC_CTSMIM_Pos)                    /*!< NT_UART0 IMSC: CTSMIM Mask              */
#define NT_UART0_IMSC_DCDMIM_Pos              2                                                       /*!< NT_UART0 IMSC: DCDMIM Position          */
#define NT_UART0_IMSC_DCDMIM_Msk              (0x01UL << NT_UART0_IMSC_DCDMIM_Pos)                    /*!< NT_UART0 IMSC: DCDMIM Mask              */
#define NT_UART0_IMSC_DSRMIM_Pos              3                                                       /*!< NT_UART0 IMSC: DSRMIM Position          */
#define NT_UART0_IMSC_DSRMIM_Msk              (0x01UL << NT_UART0_IMSC_DSRMIM_Pos)                    /*!< NT_UART0 IMSC: DSRMIM Mask              */
#define NT_UART0_IMSC_RXIM_Pos                4                                                       /*!< NT_UART0 IMSC: RXIM Position            */
#define NT_UART0_IMSC_RXIM_Msk                (0x01UL << NT_UART0_IMSC_RXIM_Pos)                      /*!< NT_UART0 IMSC: RXIM Mask                */
#define NT_UART0_IMSC_TXIM_Pos                5                                                       /*!< NT_UART0 IMSC: TXIM Position            */
#define NT_UART0_IMSC_TXIM_Msk                (0x01UL << NT_UART0_IMSC_TXIM_Pos)                      /*!< NT_UART0 IMSC: TXIM Mask                */
#define NT_UART0_IMSC_RTIM_Pos                6                                                       /*!< NT_UART0 IMSC: RTIM Position            */
#define NT_UART0_IMSC_RTIM_Msk                (0x01UL << NT_UART0_IMSC_RTIM_Pos)                      /*!< NT_UART0 IMSC: RTIM Mask                */
#define NT_UART0_IMSC_FEIM_Pos                7                                                       /*!< NT_UART0 IMSC: FEIM Position            */
#define NT_UART0_IMSC_FEIM_Msk                (0x01UL << NT_UART0_IMSC_FEIM_Pos)                      /*!< NT_UART0 IMSC: FEIM Mask                */
#define NT_UART0_IMSC_PEIM_Pos                8                                                       /*!< NT_UART0 IMSC: PEIM Position            */
#define NT_UART0_IMSC_PEIM_Msk                (0x01UL << NT_UART0_IMSC_PEIM_Pos)                      /*!< NT_UART0 IMSC: PEIM Mask                */
#define NT_UART0_IMSC_BEIM_Pos                9                                                       /*!< NT_UART0 IMSC: BEIM Position            */
#define NT_UART0_IMSC_BEIM_Msk                (0x01UL << NT_UART0_IMSC_BEIM_Pos)                      /*!< NT_UART0 IMSC: BEIM Mask                */
#define NT_UART0_IMSC_OEIM_Pos                10                                                      /*!< NT_UART0 IMSC: OEIM Position            */
#define NT_UART0_IMSC_OEIM_Msk                (0x01UL << NT_UART0_IMSC_OEIM_Pos)                      /*!< NT_UART0 IMSC: OEIM Mask                */

/* --------------------------------  NT_UART0_RIS  -------------------------------- */
#define NT_UART0_RIS_RIRMIS_Pos               0                                                       /*!< NT_UART0 RIS: RIRMIS Position           */
#define NT_UART0_RIS_RIRMIS_Msk               (0x01UL << NT_UART0_RIS_RIRMIS_Pos)                     /*!< NT_UART0 RIS: RIRMIS Mask               */
#define NT_UART0_RIS_CTSRMIS_Pos              1                                                       /*!< NT_UART0 RIS: CTSRMIS Position          */
#define NT_UART0_RIS_CTSRMIS_Msk              (0x01UL << NT_UART0_RIS_CTSRMIS_Pos)                    /*!< NT_UART0 RIS: CTSRMIS Mask              */
#define NT_UART0_RIS_DCDRMIS_Pos              2                                                       /*!< NT_UART0 RIS: DCDRMIS Position          */
#define NT_UART0_RIS_DCDRMIS_Msk              (0x01UL << NT_UART0_RIS_DCDRMIS_Pos)                    /*!< NT_UART0 RIS: DCDRMIS Mask              */
#define NT_UART0_RIS_DSRRMIS_Pos              3                                                       /*!< NT_UART0 RIS: DSRRMIS Position          */
#define NT_UART0_RIS_DSRRMIS_Msk              (0x01UL << NT_UART0_RIS_DSRRMIS_Pos)                    /*!< NT_UART0 RIS: DSRRMIS Mask              */
#define NT_UART0_RIS_RXRIS_Pos                4                                                       /*!< NT_UART0 RIS: RXRIS Position            */
#define NT_UART0_RIS_RXRIS_Msk                (0x01UL << NT_UART0_RIS_RXRIS_Pos)                      /*!< NT_UART0 RIS: RXRIS Mask                */
#define NT_UART0_RIS_TXRIS_Pos                5                                                       /*!< NT_UART0 RIS: TXRIS Position            */
#define NT_UART0_RIS_TXRIS_Msk                (0x01UL << NT_UART0_RIS_TXRIS_Pos)                      /*!< NT_UART0 RIS: TXRIS Mask                */
#define NT_UART0_RIS_RTRIS_Pos                6                                                       /*!< NT_UART0 RIS: RTRIS Position            */
#define NT_UART0_RIS_RTRIS_Msk                (0x01UL << NT_UART0_RIS_RTRIS_Pos)                      /*!< NT_UART0 RIS: RTRIS Mask                */
#define NT_UART0_RIS_FERIS_Pos                7                                                       /*!< NT_UART0 RIS: FERIS Position            */
#define NT_UART0_RIS_FERIS_Msk                (0x01UL << NT_UART0_RIS_FERIS_Pos)                      /*!< NT_UART0 RIS: FERIS Mask                */
#define NT_UART0_RIS_PERIS_Pos                8                                                       /*!< NT_UART0 RIS: PERIS Position            */
#define NT_UART0_RIS_PERIS_Msk                (0x01UL << NT_UART0_RIS_PERIS_Pos)                      /*!< NT_UART0 RIS: PERIS Mask                */
#define NT_UART0_RIS_BERIS_Pos                9                                                       /*!< NT_UART0 RIS: BERIS Position            */
#define NT_UART0_RIS_BERIS_Msk                (0x01UL << NT_UART0_RIS_BERIS_Pos)                      /*!< NT_UART0 RIS: BERIS Mask                */
#define NT_UART0_RIS_OERIS_Pos                10                                                      /*!< NT_UART0 RIS: OERIS Position            */
#define NT_UART0_RIS_OERIS_Msk                (0x01UL << NT_UART0_RIS_OERIS_Pos)                      /*!< NT_UART0 RIS: OERIS Mask                */

/* --------------------------------  NT_UART0_MIS  -------------------------------- */
#define NT_UART0_MIS_RIMMIS_Pos               0                                                       /*!< NT_UART0 MIS: RIMMIS Position           */
#define NT_UART0_MIS_RIMMIS_Msk               (0x01UL << NT_UART0_MIS_RIMMIS_Pos)                     /*!< NT_UART0 MIS: RIMMIS Mask               */
#define NT_UART0_MIS_CTSMMIS_Pos              1                                                       /*!< NT_UART0 MIS: CTSMMIS Position          */
#define NT_UART0_MIS_CTSMMIS_Msk              (0x01UL << NT_UART0_MIS_CTSMMIS_Pos)                    /*!< NT_UART0 MIS: CTSMMIS Mask              */
#define NT_UART0_MIS_DCDMMIS_Pos              2                                                       /*!< NT_UART0 MIS: DCDMMIS Position          */
#define NT_UART0_MIS_DCDMMIS_Msk              (0x01UL << NT_UART0_MIS_DCDMMIS_Pos)                    /*!< NT_UART0 MIS: DCDMMIS Mask              */
#define NT_UART0_MIS_DSRMMIS_Pos              3                                                       /*!< NT_UART0 MIS: DSRMMIS Position          */
#define NT_UART0_MIS_DSRMMIS_Msk              (0x01UL << NT_UART0_MIS_DSRMMIS_Pos)                    /*!< NT_UART0 MIS: DSRMMIS Mask              */
#define NT_UART0_MIS_RXMIS_Pos                4                                                       /*!< NT_UART0 MIS: RXMIS Position            */
#define NT_UART0_MIS_RXMIS_Msk                (0x01UL << NT_UART0_MIS_RXMIS_Pos)                      /*!< NT_UART0 MIS: RXMIS Mask                */
#define NT_UART0_MIS_TXMIS_Pos                5                                                       /*!< NT_UART0 MIS: TXMIS Position            */
#define NT_UART0_MIS_TXMIS_Msk                (0x01UL << NT_UART0_MIS_TXMIS_Pos)                      /*!< NT_UART0 MIS: TXMIS Mask                */
#define NT_UART0_MIS_RTMIS_Pos                6                                                       /*!< NT_UART0 MIS: RTMIS Position            */
#define NT_UART0_MIS_RTMIS_Msk                (0x01UL << NT_UART0_MIS_RTMIS_Pos)                      /*!< NT_UART0 MIS: RTMIS Mask                */
#define NT_UART0_MIS_FEMIS_Pos                7                                                       /*!< NT_UART0 MIS: FEMIS Position            */
#define NT_UART0_MIS_FEMIS_Msk                (0x01UL << NT_UART0_MIS_FEMIS_Pos)                      /*!< NT_UART0 MIS: FEMIS Mask                */
#define NT_UART0_MIS_PEMIS_Pos                8                                                       /*!< NT_UART0 MIS: PEMIS Position            */
#define NT_UART0_MIS_PEMIS_Msk                (0x01UL << NT_UART0_MIS_PEMIS_Pos)                      /*!< NT_UART0 MIS: PEMIS Mask                */
#define NT_UART0_MIS_BEMIS_Pos                9                                                       /*!< NT_UART0 MIS: BEMIS Position            */
#define NT_UART0_MIS_BEMIS_Msk                (0x01UL << NT_UART0_MIS_BEMIS_Pos)                      /*!< NT_UART0 MIS: BEMIS Mask                */
#define NT_UART0_MIS_OEMIS_Pos                10                                                      /*!< NT_UART0 MIS: OEMIS Position            */
#define NT_UART0_MIS_OEMIS_Msk                (0x01UL << NT_UART0_MIS_OEMIS_Pos)                      /*!< NT_UART0 MIS: OEMIS Mask                */

/* --------------------------------  NT_UART0_ICR  -------------------------------- */
#define NT_UART0_ICR_RIMIC_Pos                0                                                       /*!< NT_UART0 ICR: RIMIC Position            */
#define NT_UART0_ICR_RIMIC_Msk                (0x01UL << NT_UART0_ICR_RIMIC_Pos)                      /*!< NT_UART0 ICR: RIMIC Mask                */
#define NT_UART0_ICR_CTSMIC_Pos               1                                                       /*!< NT_UART0 ICR: CTSMIC Position           */
#define NT_UART0_ICR_CTSMIC_Msk               (0x01UL << NT_UART0_ICR_CTSMIC_Pos)                     /*!< NT_UART0 ICR: CTSMIC Mask               */
#define NT_UART0_ICR_DCDMIC_Pos               2                                                       /*!< NT_UART0 ICR: DCDMIC Position           */
#define NT_UART0_ICR_DCDMIC_Msk               (0x01UL << NT_UART0_ICR_DCDMIC_Pos)                     /*!< NT_UART0 ICR: DCDMIC Mask               */
#define NT_UART0_ICR_DSRMIC_Pos               3                                                       /*!< NT_UART0 ICR: DSRMIC Position           */
#define NT_UART0_ICR_DSRMIC_Msk               (0x01UL << NT_UART0_ICR_DSRMIC_Pos)                     /*!< NT_UART0 ICR: DSRMIC Mask               */
#define NT_UART0_ICR_RXIC_Pos                 4                                                       /*!< NT_UART0 ICR: RXIC Position             */
#define NT_UART0_ICR_RXIC_Msk                 (0x01UL << NT_UART0_ICR_RXIC_Pos)                       /*!< NT_UART0 ICR: RXIC Mask                 */
#define NT_UART0_ICR_TXIC_Pos                 5                                                       /*!< NT_UART0 ICR: TXIC Position             */
#define NT_UART0_ICR_TXIC_Msk                 (0x01UL << NT_UART0_ICR_TXIC_Pos)                       /*!< NT_UART0 ICR: TXIC Mask                 */
#define NT_UART0_ICR_RTIC_Pos                 6                                                       /*!< NT_UART0 ICR: RTIC Position             */
#define NT_UART0_ICR_RTIC_Msk                 (0x01UL << NT_UART0_ICR_RTIC_Pos)                       /*!< NT_UART0 ICR: RTIC Mask                 */
#define NT_UART0_ICR_FEIC_Pos                 7                                                       /*!< NT_UART0 ICR: FEIC Position             */
#define NT_UART0_ICR_FEIC_Msk                 (0x01UL << NT_UART0_ICR_FEIC_Pos)                       /*!< NT_UART0 ICR: FEIC Mask                 */
#define NT_UART0_ICR_PEIC_Pos                 8                                                       /*!< NT_UART0 ICR: PEIC Position             */
#define NT_UART0_ICR_PEIC_Msk                 (0x01UL << NT_UART0_ICR_PEIC_Pos)                       /*!< NT_UART0 ICR: PEIC Mask                 */
#define NT_UART0_ICR_BEIC_Pos                 9                                                       /*!< NT_UART0 ICR: BEIC Position             */
#define NT_UART0_ICR_BEIC_Msk                 (0x01UL << NT_UART0_ICR_BEIC_Pos)                       /*!< NT_UART0 ICR: BEIC Mask                 */
#define NT_UART0_ICR_OEIC_Pos                 10                                                      /*!< NT_UART0 ICR: OEIC Position             */
#define NT_UART0_ICR_OEIC_Msk                 (0x01UL << NT_UART0_ICR_OEIC_Pos)                       /*!< NT_UART0 ICR: OEIC Mask                 */

/* -------------------------------  NT_UART0_DMACR  ------------------------------- */
#define NT_UART0_DMACR_RXDMAE_Pos             0                                                       /*!< NT_UART0 DMACR: RXDMAE Position         */
#define NT_UART0_DMACR_RXDMAE_Msk             (0x01UL << NT_UART0_DMACR_RXDMAE_Pos)                   /*!< NT_UART0 DMACR: RXDMAE Mask             */
#define NT_UART0_DMACR_TXDMAE_Pos             1                                                       /*!< NT_UART0 DMACR: TXDMAE Position         */
#define NT_UART0_DMACR_TXDMAE_Msk             (0x01UL << NT_UART0_DMACR_TXDMAE_Pos)                   /*!< NT_UART0 DMACR: TXDMAE Mask             */
#define NT_UART0_DMACR_DMAONERR_Pos           2                                                       /*!< NT_UART0 DMACR: DMAONERR Position       */
#define NT_UART0_DMACR_DMAONERR_Msk           (0x01UL << NT_UART0_DMACR_DMAONERR_Pos)                 /*!< NT_UART0 DMACR: DMAONERR Mask           */


/* ================================================================================ */
/* ================        struct 'NT_UART1' Position & Mask       ================ */
/* ================================================================================ */


/* ---------------------------------  NT_UART1_DR  -------------------------------- */
#define NT_UART1_DR_DATA_Pos                  0                                                       /*!< NT_UART1 DR: DATA Position              */
#define NT_UART1_DR_DATA_Msk                  (0x000000ffUL << NT_UART1_DR_DATA_Pos)                  /*!< NT_UART1 DR: DATA Mask                  */
#define NT_UART1_DR_FE_Pos                    8                                                       /*!< NT_UART1 DR: FE Position                */
#define NT_UART1_DR_FE_Msk                    (0x01UL << NT_UART1_DR_FE_Pos)                          /*!< NT_UART1 DR: FE Mask                    */
#define NT_UART1_DR_PE_Pos                    9                                                       /*!< NT_UART1 DR: PE Position                */
#define NT_UART1_DR_PE_Msk                    (0x01UL << NT_UART1_DR_PE_Pos)                          /*!< NT_UART1 DR: PE Mask                    */
#define NT_UART1_DR_BE_Pos                    10                                                      /*!< NT_UART1 DR: BE Position                */
#define NT_UART1_DR_BE_Msk                    (0x01UL << NT_UART1_DR_BE_Pos)                          /*!< NT_UART1 DR: BE Mask                    */
#define NT_UART1_DR_OE_Pos                    11                                                      /*!< NT_UART1 DR: OE Position                */
#define NT_UART1_DR_OE_Msk                    (0x01UL << NT_UART1_DR_OE_Pos)                          /*!< NT_UART1 DR: OE Mask                    */

/* ------------------------------  NT_UART1_RSR_ECR  ------------------------------ */
#define NT_UART1_RSR_ECR_FE_Pos               0                                                       /*!< NT_UART1 RSR_ECR: FE Position           */
#define NT_UART1_RSR_ECR_FE_Msk               (0x01UL << NT_UART1_RSR_ECR_FE_Pos)                     /*!< NT_UART1 RSR_ECR: FE Mask               */
#define NT_UART1_RSR_ECR_PE_Pos               1                                                       /*!< NT_UART1 RSR_ECR: PE Position           */
#define NT_UART1_RSR_ECR_PE_Msk               (0x01UL << NT_UART1_RSR_ECR_PE_Pos)                     /*!< NT_UART1 RSR_ECR: PE Mask               */
#define NT_UART1_RSR_ECR_BE_Pos               2                                                       /*!< NT_UART1 RSR_ECR: BE Position           */
#define NT_UART1_RSR_ECR_BE_Msk               (0x01UL << NT_UART1_RSR_ECR_BE_Pos)                     /*!< NT_UART1 RSR_ECR: BE Mask               */
#define NT_UART1_RSR_ECR_OE_Pos               3                                                       /*!< NT_UART1 RSR_ECR: OE Position           */
#define NT_UART1_RSR_ECR_OE_Msk               (0x01UL << NT_UART1_RSR_ECR_OE_Pos)                     /*!< NT_UART1 RSR_ECR: OE Mask               */

/* ---------------------------------  NT_UART1_FR  -------------------------------- */
#define NT_UART1_FR_CTS_Pos                   0                                                       /*!< NT_UART1 FR: CTS Position               */
#define NT_UART1_FR_CTS_Msk                   (0x01UL << NT_UART1_FR_CTS_Pos)                         /*!< NT_UART1 FR: CTS Mask                   */
#define NT_UART1_FR_DSR_Pos                   1                                                       /*!< NT_UART1 FR: DSR Position               */
#define NT_UART1_FR_DSR_Msk                   (0x01UL << NT_UART1_FR_DSR_Pos)                         /*!< NT_UART1 FR: DSR Mask                   */
#define NT_UART1_FR_DCD_Pos                   2                                                       /*!< NT_UART1 FR: DCD Position               */
#define NT_UART1_FR_DCD_Msk                   (0x01UL << NT_UART1_FR_DCD_Pos)                         /*!< NT_UART1 FR: DCD Mask                   */
#define NT_UART1_FR_BUSY_Pos                  3                                                       /*!< NT_UART1 FR: BUSY Position              */
#define NT_UART1_FR_BUSY_Msk                  (0x01UL << NT_UART1_FR_BUSY_Pos)                        /*!< NT_UART1 FR: BUSY Mask                  */
#define NT_UART1_FR_RXFE_Pos                  4                                                       /*!< NT_UART1 FR: RXFE Position              */
#define NT_UART1_FR_RXFE_Msk                  (0x01UL << NT_UART1_FR_RXFE_Pos)                        /*!< NT_UART1 FR: RXFE Mask                  */
#define NT_UART1_FR_TXFF_Pos                  5                                                       /*!< NT_UART1 FR: TXFF Position              */
#define NT_UART1_FR_TXFF_Msk                  (0x01UL << NT_UART1_FR_TXFF_Pos)                        /*!< NT_UART1 FR: TXFF Mask                  */
#define NT_UART1_FR_RXFF_Pos                  6                                                       /*!< NT_UART1 FR: RXFF Position              */
#define NT_UART1_FR_RXFF_Msk                  (0x01UL << NT_UART1_FR_RXFF_Pos)                        /*!< NT_UART1 FR: RXFF Mask                  */
#define NT_UART1_FR_TXFE_Pos                  7                                                       /*!< NT_UART1 FR: TXFE Position              */
#define NT_UART1_FR_TXFE_Msk                  (0x01UL << NT_UART1_FR_TXFE_Pos)                        /*!< NT_UART1 FR: TXFE Mask                  */
#define NT_UART1_FR_RI_Pos                    8                                                       /*!< NT_UART1 FR: RI Position                */
#define NT_UART1_FR_RI_Msk                    (0x01UL << NT_UART1_FR_RI_Pos)                          /*!< NT_UART1 FR: RI Mask                    */

/* --------------------------------  NT_UART1_IBRD  ------------------------------- */
#define NT_UART1_IBRD_BAUD_DIVINT_Pos         0                                                       /*!< NT_UART1 IBRD: BAUD_DIVINT Position     */
#define NT_UART1_IBRD_BAUD_DIVINT_Msk         (0x0000ffffUL << NT_UART1_IBRD_BAUD_DIVINT_Pos)         /*!< NT_UART1 IBRD: BAUD_DIVINT Mask         */

/* --------------------------------  NT_UART1_FBRD  ------------------------------- */
#define NT_UART1_FBRD_BAUD_DIVFRAC_Pos        0                                                       /*!< NT_UART1 FBRD: BAUD_DIVFRAC Position    */
#define NT_UART1_FBRD_BAUD_DIVFRAC_Msk        (0x3fUL << NT_UART1_FBRD_BAUD_DIVFRAC_Pos)              /*!< NT_UART1 FBRD: BAUD_DIVFRAC Mask        */

/* -------------------------------  NT_UART1_LCR_H  ------------------------------- */
#define NT_UART1_LCR_H_BRK_Pos                0                                                       /*!< NT_UART1 LCR_H: BRK Position            */
#define NT_UART1_LCR_H_BRK_Msk                (0x01UL << NT_UART1_LCR_H_BRK_Pos)                      /*!< NT_UART1 LCR_H: BRK Mask                */
#define NT_UART1_LCR_H_PEN_Pos                1                                                       /*!< NT_UART1 LCR_H: PEN Position            */
#define NT_UART1_LCR_H_PEN_Msk                (0x01UL << NT_UART1_LCR_H_PEN_Pos)                      /*!< NT_UART1 LCR_H: PEN Mask                */
#define NT_UART1_LCR_H_EPS_Pos                2                                                       /*!< NT_UART1 LCR_H: EPS Position            */
#define NT_UART1_LCR_H_EPS_Msk                (0x01UL << NT_UART1_LCR_H_EPS_Pos)                      /*!< NT_UART1 LCR_H: EPS Mask                */
#define NT_UART1_LCR_H_STP2_Pos               3                                                       /*!< NT_UART1 LCR_H: STP2 Position           */
#define NT_UART1_LCR_H_STP2_Msk               (0x01UL << NT_UART1_LCR_H_STP2_Pos)                     /*!< NT_UART1 LCR_H: STP2 Mask               */
#define NT_UART1_LCR_H_FEN_Pos                4                                                       /*!< NT_UART1 LCR_H: FEN Position            */
#define NT_UART1_LCR_H_FEN_Msk                (0x01UL << NT_UART1_LCR_H_FEN_Pos)                      /*!< NT_UART1 LCR_H: FEN Mask                */
#define NT_UART1_LCR_H_WLEN_Pos               5                                                       /*!< NT_UART1 LCR_H: WLEN Position           */
#define NT_UART1_LCR_H_WLEN_Msk               (0x03UL << NT_UART1_LCR_H_WLEN_Pos)                     /*!< NT_UART1 LCR_H: WLEN Mask               */
#define NT_UART1_LCR_H_SPS_Pos                7                                                       /*!< NT_UART1 LCR_H: SPS Position            */
#define NT_UART1_LCR_H_SPS_Msk                (0x01UL << NT_UART1_LCR_H_SPS_Pos)                      /*!< NT_UART1 LCR_H: SPS Mask                */

/* ---------------------------------  NT_UART1_CR  -------------------------------- */
#define NT_UART1_CR_UARTEN_Pos                0                                                       /*!< NT_UART1 CR: UARTEN Position            */
#define NT_UART1_CR_UARTEN_Msk                (0x01UL << NT_UART1_CR_UARTEN_Pos)                      /*!< NT_UART1 CR: UARTEN Mask                */
#define NT_UART1_CR_TXE_Pos                   8                                                       /*!< NT_UART1 CR: TXE Position               */
#define NT_UART1_CR_TXE_Msk                   (0x01UL << NT_UART1_CR_TXE_Pos)                         /*!< NT_UART1 CR: TXE Mask                   */
#define NT_UART1_CR_RXE_Pos                   9                                                       /*!< NT_UART1 CR: RXE Position               */
#define NT_UART1_CR_RXE_Msk                   (0x01UL << NT_UART1_CR_RXE_Pos)                         /*!< NT_UART1 CR: RXE Mask                   */
#define NT_UART1_CR_DTR_Pos                   10                                                      /*!< NT_UART1 CR: DTR Position               */
#define NT_UART1_CR_DTR_Msk                   (0x01UL << NT_UART1_CR_DTR_Pos)                         /*!< NT_UART1 CR: DTR Mask                   */
#define NT_UART1_CR_RTS_Pos                   11                                                      /*!< NT_UART1 CR: RTS Position               */
#define NT_UART1_CR_RTS_Msk                   (0x01UL << NT_UART1_CR_RTS_Pos)                         /*!< NT_UART1 CR: RTS Mask                   */
#define NT_UART1_CR_OUT1_Pos                  12                                                      /*!< NT_UART1 CR: OUT1 Position              */
#define NT_UART1_CR_OUT1_Msk                  (0x01UL << NT_UART1_CR_OUT1_Pos)                        /*!< NT_UART1 CR: OUT1 Mask                  */
#define NT_UART1_CR_OUT2_Pos                  13                                                      /*!< NT_UART1 CR: OUT2 Position              */
#define NT_UART1_CR_OUT2_Msk                  (0x01UL << NT_UART1_CR_OUT2_Pos)                        /*!< NT_UART1 CR: OUT2 Mask                  */
#define NT_UART1_CR_RTSEN_Pos                 14                                                      /*!< NT_UART1 CR: RTSEN Position             */
#define NT_UART1_CR_RTSEN_Msk                 (0x01UL << NT_UART1_CR_RTSEN_Pos)                       /*!< NT_UART1 CR: RTSEN Mask                 */
#define NT_UART1_CR_CTSEN_Pos                 15                                                      /*!< NT_UART1 CR: CTSEN Position             */
#define NT_UART1_CR_CTSEN_Msk                 (0x01UL << NT_UART1_CR_CTSEN_Pos)                       /*!< NT_UART1 CR: CTSEN Mask                 */

/* --------------------------------  NT_UART1_IFLS  ------------------------------- */
#define NT_UART1_IFLS_TXIFLSEL_Pos            0                                                       /*!< NT_UART1 IFLS: TXIFLSEL Position        */
#define NT_UART1_IFLS_TXIFLSEL_Msk            (0x07UL << NT_UART1_IFLS_TXIFLSEL_Pos)                  /*!< NT_UART1 IFLS: TXIFLSEL Mask            */
#define NT_UART1_IFLS_RXIFLSEL_Pos            3                                                       /*!< NT_UART1 IFLS: RXIFLSEL Position        */
#define NT_UART1_IFLS_RXIFLSEL_Msk            (0x07UL << NT_UART1_IFLS_RXIFLSEL_Pos)                  /*!< NT_UART1 IFLS: RXIFLSEL Mask            */

/* --------------------------------  NT_UART1_IMSC  ------------------------------- */
#define NT_UART1_IMSC_RIMIM_Pos               0                                                       /*!< NT_UART1 IMSC: RIMIM Position           */
#define NT_UART1_IMSC_RIMIM_Msk               (0x01UL << NT_UART1_IMSC_RIMIM_Pos)                     /*!< NT_UART1 IMSC: RIMIM Mask               */
#define NT_UART1_IMSC_CTSMIM_Pos              1                                                       /*!< NT_UART1 IMSC: CTSMIM Position          */
#define NT_UART1_IMSC_CTSMIM_Msk              (0x01UL << NT_UART1_IMSC_CTSMIM_Pos)                    /*!< NT_UART1 IMSC: CTSMIM Mask              */
#define NT_UART1_IMSC_DCDMIM_Pos              2                                                       /*!< NT_UART1 IMSC: DCDMIM Position          */
#define NT_UART1_IMSC_DCDMIM_Msk              (0x01UL << NT_UART1_IMSC_DCDMIM_Pos)                    /*!< NT_UART1 IMSC: DCDMIM Mask              */
#define NT_UART1_IMSC_DSRMIM_Pos              3                                                       /*!< NT_UART1 IMSC: DSRMIM Position          */
#define NT_UART1_IMSC_DSRMIM_Msk              (0x01UL << NT_UART1_IMSC_DSRMIM_Pos)                    /*!< NT_UART1 IMSC: DSRMIM Mask              */
#define NT_UART1_IMSC_RXIM_Pos                4                                                       /*!< NT_UART1 IMSC: RXIM Position            */
#define NT_UART1_IMSC_RXIM_Msk                (0x01UL << NT_UART1_IMSC_RXIM_Pos)                      /*!< NT_UART1 IMSC: RXIM Mask                */
#define NT_UART1_IMSC_TXIM_Pos                5                                                       /*!< NT_UART1 IMSC: TXIM Position            */
#define NT_UART1_IMSC_TXIM_Msk                (0x01UL << NT_UART1_IMSC_TXIM_Pos)                      /*!< NT_UART1 IMSC: TXIM Mask                */
#define NT_UART1_IMSC_RTIM_Pos                6                                                       /*!< NT_UART1 IMSC: RTIM Position            */
#define NT_UART1_IMSC_RTIM_Msk                (0x01UL << NT_UART1_IMSC_RTIM_Pos)                      /*!< NT_UART1 IMSC: RTIM Mask                */
#define NT_UART1_IMSC_FEIM_Pos                7                                                       /*!< NT_UART1 IMSC: FEIM Position            */
#define NT_UART1_IMSC_FEIM_Msk                (0x01UL << NT_UART1_IMSC_FEIM_Pos)                      /*!< NT_UART1 IMSC: FEIM Mask                */
#define NT_UART1_IMSC_PEIM_Pos                8                                                       /*!< NT_UART1 IMSC: PEIM Position            */
#define NT_UART1_IMSC_PEIM_Msk                (0x01UL << NT_UART1_IMSC_PEIM_Pos)                      /*!< NT_UART1 IMSC: PEIM Mask                */
#define NT_UART1_IMSC_BEIM_Pos                9                                                       /*!< NT_UART1 IMSC: BEIM Position            */
#define NT_UART1_IMSC_BEIM_Msk                (0x01UL << NT_UART1_IMSC_BEIM_Pos)                      /*!< NT_UART1 IMSC: BEIM Mask                */
#define NT_UART1_IMSC_OEIM_Pos                10                                                      /*!< NT_UART1 IMSC: OEIM Position            */
#define NT_UART1_IMSC_OEIM_Msk                (0x01UL << NT_UART1_IMSC_OEIM_Pos)                      /*!< NT_UART1 IMSC: OEIM Mask                */

/* --------------------------------  NT_UART1_RIS  -------------------------------- */
#define NT_UART1_RIS_RIRMIS_Pos               0                                                       /*!< NT_UART1 RIS: RIRMIS Position           */
#define NT_UART1_RIS_RIRMIS_Msk               (0x01UL << NT_UART1_RIS_RIRMIS_Pos)                     /*!< NT_UART1 RIS: RIRMIS Mask               */
#define NT_UART1_RIS_CTSRMIS_Pos              1                                                       /*!< NT_UART1 RIS: CTSRMIS Position          */
#define NT_UART1_RIS_CTSRMIS_Msk              (0x01UL << NT_UART1_RIS_CTSRMIS_Pos)                    /*!< NT_UART1 RIS: CTSRMIS Mask              */
#define NT_UART1_RIS_DCDRMIS_Pos              2                                                       /*!< NT_UART1 RIS: DCDRMIS Position          */
#define NT_UART1_RIS_DCDRMIS_Msk              (0x01UL << NT_UART1_RIS_DCDRMIS_Pos)                    /*!< NT_UART1 RIS: DCDRMIS Mask              */
#define NT_UART1_RIS_DSRRMIS_Pos              3                                                       /*!< NT_UART1 RIS: DSRRMIS Position          */
#define NT_UART1_RIS_DSRRMIS_Msk              (0x01UL << NT_UART1_RIS_DSRRMIS_Pos)                    /*!< NT_UART1 RIS: DSRRMIS Mask              */
#define NT_UART1_RIS_RXRIS_Pos                4                                                       /*!< NT_UART1 RIS: RXRIS Position            */
#define NT_UART1_RIS_RXRIS_Msk                (0x01UL << NT_UART1_RIS_RXRIS_Pos)                      /*!< NT_UART1 RIS: RXRIS Mask                */
#define NT_UART1_RIS_TXRIS_Pos                5                                                       /*!< NT_UART1 RIS: TXRIS Position            */
#define NT_UART1_RIS_TXRIS_Msk                (0x01UL << NT_UART1_RIS_TXRIS_Pos)                      /*!< NT_UART1 RIS: TXRIS Mask                */
#define NT_UART1_RIS_RTRIS_Pos                6                                                       /*!< NT_UART1 RIS: RTRIS Position            */
#define NT_UART1_RIS_RTRIS_Msk                (0x01UL << NT_UART1_RIS_RTRIS_Pos)                      /*!< NT_UART1 RIS: RTRIS Mask                */
#define NT_UART1_RIS_FERIS_Pos                7                                                       /*!< NT_UART1 RIS: FERIS Position            */
#define NT_UART1_RIS_FERIS_Msk                (0x01UL << NT_UART1_RIS_FERIS_Pos)                      /*!< NT_UART1 RIS: FERIS Mask                */
#define NT_UART1_RIS_PERIS_Pos                8                                                       /*!< NT_UART1 RIS: PERIS Position            */
#define NT_UART1_RIS_PERIS_Msk                (0x01UL << NT_UART1_RIS_PERIS_Pos)                      /*!< NT_UART1 RIS: PERIS Mask                */
#define NT_UART1_RIS_BERIS_Pos                9                                                       /*!< NT_UART1 RIS: BERIS Position            */
#define NT_UART1_RIS_BERIS_Msk                (0x01UL << NT_UART1_RIS_BERIS_Pos)                      /*!< NT_UART1 RIS: BERIS Mask                */
#define NT_UART1_RIS_OERIS_Pos                10                                                      /*!< NT_UART1 RIS: OERIS Position            */
#define NT_UART1_RIS_OERIS_Msk                (0x01UL << NT_UART1_RIS_OERIS_Pos)                      /*!< NT_UART1 RIS: OERIS Mask                */

/* --------------------------------  NT_UART1_MIS  -------------------------------- */
#define NT_UART1_MIS_RIMMIS_Pos               0                                                       /*!< NT_UART1 MIS: RIMMIS Position           */
#define NT_UART1_MIS_RIMMIS_Msk               (0x01UL << NT_UART1_MIS_RIMMIS_Pos)                     /*!< NT_UART1 MIS: RIMMIS Mask               */
#define NT_UART1_MIS_CTSMMIS_Pos              1                                                       /*!< NT_UART1 MIS: CTSMMIS Position          */
#define NT_UART1_MIS_CTSMMIS_Msk              (0x01UL << NT_UART1_MIS_CTSMMIS_Pos)                    /*!< NT_UART1 MIS: CTSMMIS Mask              */
#define NT_UART1_MIS_DCDMMIS_Pos              2                                                       /*!< NT_UART1 MIS: DCDMMIS Position          */
#define NT_UART1_MIS_DCDMMIS_Msk              (0x01UL << NT_UART1_MIS_DCDMMIS_Pos)                    /*!< NT_UART1 MIS: DCDMMIS Mask              */
#define NT_UART1_MIS_DSRMMIS_Pos              3                                                       /*!< NT_UART1 MIS: DSRMMIS Position          */
#define NT_UART1_MIS_DSRMMIS_Msk              (0x01UL << NT_UART1_MIS_DSRMMIS_Pos)                    /*!< NT_UART1 MIS: DSRMMIS Mask              */
#define NT_UART1_MIS_RXMIS_Pos                4                                                       /*!< NT_UART1 MIS: RXMIS Position            */
#define NT_UART1_MIS_RXMIS_Msk                (0x01UL << NT_UART1_MIS_RXMIS_Pos)                      /*!< NT_UART1 MIS: RXMIS Mask                */
#define NT_UART1_MIS_TXMIS_Pos                5                                                       /*!< NT_UART1 MIS: TXMIS Position            */
#define NT_UART1_MIS_TXMIS_Msk                (0x01UL << NT_UART1_MIS_TXMIS_Pos)                      /*!< NT_UART1 MIS: TXMIS Mask                */
#define NT_UART1_MIS_RTMIS_Pos                6                                                       /*!< NT_UART1 MIS: RTMIS Position            */
#define NT_UART1_MIS_RTMIS_Msk                (0x01UL << NT_UART1_MIS_RTMIS_Pos)                      /*!< NT_UART1 MIS: RTMIS Mask                */
#define NT_UART1_MIS_FEMIS_Pos                7                                                       /*!< NT_UART1 MIS: FEMIS Position            */
#define NT_UART1_MIS_FEMIS_Msk                (0x01UL << NT_UART1_MIS_FEMIS_Pos)                      /*!< NT_UART1 MIS: FEMIS Mask                */
#define NT_UART1_MIS_PEMIS_Pos                8                                                       /*!< NT_UART1 MIS: PEMIS Position            */
#define NT_UART1_MIS_PEMIS_Msk                (0x01UL << NT_UART1_MIS_PEMIS_Pos)                      /*!< NT_UART1 MIS: PEMIS Mask                */
#define NT_UART1_MIS_BEMIS_Pos                9                                                       /*!< NT_UART1 MIS: BEMIS Position            */
#define NT_UART1_MIS_BEMIS_Msk                (0x01UL << NT_UART1_MIS_BEMIS_Pos)                      /*!< NT_UART1 MIS: BEMIS Mask                */
#define NT_UART1_MIS_OEMIS_Pos                10                                                      /*!< NT_UART1 MIS: OEMIS Position            */
#define NT_UART1_MIS_OEMIS_Msk                (0x01UL << NT_UART1_MIS_OEMIS_Pos)                      /*!< NT_UART1 MIS: OEMIS Mask                */

/* --------------------------------  NT_UART1_ICR  -------------------------------- */
#define NT_UART1_ICR_RIMIC_Pos                0                                                       /*!< NT_UART1 ICR: RIMIC Position            */
#define NT_UART1_ICR_RIMIC_Msk                (0x01UL << NT_UART1_ICR_RIMIC_Pos)                      /*!< NT_UART1 ICR: RIMIC Mask                */
#define NT_UART1_ICR_CTSMIC_Pos               1                                                       /*!< NT_UART1 ICR: CTSMIC Position           */
#define NT_UART1_ICR_CTSMIC_Msk               (0x01UL << NT_UART1_ICR_CTSMIC_Pos)                     /*!< NT_UART1 ICR: CTSMIC Mask               */
#define NT_UART1_ICR_DCDMIC_Pos               2                                                       /*!< NT_UART1 ICR: DCDMIC Position           */
#define NT_UART1_ICR_DCDMIC_Msk               (0x01UL << NT_UART1_ICR_DCDMIC_Pos)                     /*!< NT_UART1 ICR: DCDMIC Mask               */
#define NT_UART1_ICR_DSRMIC_Pos               3                                                       /*!< NT_UART1 ICR: DSRMIC Position           */
#define NT_UART1_ICR_DSRMIC_Msk               (0x01UL << NT_UART1_ICR_DSRMIC_Pos)                     /*!< NT_UART1 ICR: DSRMIC Mask               */
#define NT_UART1_ICR_RXIC_Pos                 4                                                       /*!< NT_UART1 ICR: RXIC Position             */
#define NT_UART1_ICR_RXIC_Msk                 (0x01UL << NT_UART1_ICR_RXIC_Pos)                       /*!< NT_UART1 ICR: RXIC Mask                 */
#define NT_UART1_ICR_TXIC_Pos                 5                                                       /*!< NT_UART1 ICR: TXIC Position             */
#define NT_UART1_ICR_TXIC_Msk                 (0x01UL << NT_UART1_ICR_TXIC_Pos)                       /*!< NT_UART1 ICR: TXIC Mask                 */
#define NT_UART1_ICR_RTIC_Pos                 6                                                       /*!< NT_UART1 ICR: RTIC Position             */
#define NT_UART1_ICR_RTIC_Msk                 (0x01UL << NT_UART1_ICR_RTIC_Pos)                       /*!< NT_UART1 ICR: RTIC Mask                 */
#define NT_UART1_ICR_FEIC_Pos                 7                                                       /*!< NT_UART1 ICR: FEIC Position             */
#define NT_UART1_ICR_FEIC_Msk                 (0x01UL << NT_UART1_ICR_FEIC_Pos)                       /*!< NT_UART1 ICR: FEIC Mask                 */
#define NT_UART1_ICR_PEIC_Pos                 8                                                       /*!< NT_UART1 ICR: PEIC Position             */
#define NT_UART1_ICR_PEIC_Msk                 (0x01UL << NT_UART1_ICR_PEIC_Pos)                       /*!< NT_UART1 ICR: PEIC Mask                 */
#define NT_UART1_ICR_BEIC_Pos                 9                                                       /*!< NT_UART1 ICR: BEIC Position             */
#define NT_UART1_ICR_BEIC_Msk                 (0x01UL << NT_UART1_ICR_BEIC_Pos)                       /*!< NT_UART1 ICR: BEIC Mask                 */
#define NT_UART1_ICR_OEIC_Pos                 10                                                      /*!< NT_UART1 ICR: OEIC Position             */
#define NT_UART1_ICR_OEIC_Msk                 (0x01UL << NT_UART1_ICR_OEIC_Pos)                       /*!< NT_UART1 ICR: OEIC Mask                 */

/* -------------------------------  NT_UART1_DMACR  ------------------------------- */
#define NT_UART1_DMACR_RXDMAE_Pos             0                                                       /*!< NT_UART1 DMACR: RXDMAE Position         */
#define NT_UART1_DMACR_RXDMAE_Msk             (0x01UL << NT_UART1_DMACR_RXDMAE_Pos)                   /*!< NT_UART1 DMACR: RXDMAE Mask             */
#define NT_UART1_DMACR_TXDMAE_Pos             1                                                       /*!< NT_UART1 DMACR: TXDMAE Position         */
#define NT_UART1_DMACR_TXDMAE_Msk             (0x01UL << NT_UART1_DMACR_TXDMAE_Pos)                   /*!< NT_UART1 DMACR: TXDMAE Mask             */
#define NT_UART1_DMACR_DMAONERR_Pos           2                                                       /*!< NT_UART1 DMACR: DMAONERR Position       */
#define NT_UART1_DMACR_DMAONERR_Msk           (0x01UL << NT_UART1_DMACR_DMAONERR_Pos)                 /*!< NT_UART1 DMACR: DMAONERR Mask           */


/* ================================================================================ */
/* ================        struct 'NT_UART2' Position & Mask       ================ */
/* ================================================================================ */


/* ---------------------------------  NT_UART2_DR  -------------------------------- */
#define NT_UART2_DR_DATA_Pos                  0                                                       /*!< NT_UART2 DR: DATA Position              */
#define NT_UART2_DR_DATA_Msk                  (0x000000ffUL << NT_UART2_DR_DATA_Pos)                  /*!< NT_UART2 DR: DATA Mask                  */
#define NT_UART2_DR_FE_Pos                    8                                                       /*!< NT_UART2 DR: FE Position                */
#define NT_UART2_DR_FE_Msk                    (0x01UL << NT_UART2_DR_FE_Pos)                          /*!< NT_UART2 DR: FE Mask                    */
#define NT_UART2_DR_PE_Pos                    9                                                       /*!< NT_UART2 DR: PE Position                */
#define NT_UART2_DR_PE_Msk                    (0x01UL << NT_UART2_DR_PE_Pos)                          /*!< NT_UART2 DR: PE Mask                    */
#define NT_UART2_DR_BE_Pos                    10                                                      /*!< NT_UART2 DR: BE Position                */
#define NT_UART2_DR_BE_Msk                    (0x01UL << NT_UART2_DR_BE_Pos)                          /*!< NT_UART2 DR: BE Mask                    */
#define NT_UART2_DR_OE_Pos                    11                                                      /*!< NT_UART2 DR: OE Position                */
#define NT_UART2_DR_OE_Msk                    (0x01UL << NT_UART2_DR_OE_Pos)                          /*!< NT_UART2 DR: OE Mask                    */

/* ------------------------------  NT_UART2_RSR_ECR  ------------------------------ */
#define NT_UART2_RSR_ECR_FE_Pos               0                                                       /*!< NT_UART2 RSR_ECR: FE Position           */
#define NT_UART2_RSR_ECR_FE_Msk               (0x01UL << NT_UART2_RSR_ECR_FE_Pos)                     /*!< NT_UART2 RSR_ECR: FE Mask               */
#define NT_UART2_RSR_ECR_PE_Pos               1                                                       /*!< NT_UART2 RSR_ECR: PE Position           */
#define NT_UART2_RSR_ECR_PE_Msk               (0x01UL << NT_UART2_RSR_ECR_PE_Pos)                     /*!< NT_UART2 RSR_ECR: PE Mask               */
#define NT_UART2_RSR_ECR_BE_Pos               2                                                       /*!< NT_UART2 RSR_ECR: BE Position           */
#define NT_UART2_RSR_ECR_BE_Msk               (0x01UL << NT_UART2_RSR_ECR_BE_Pos)                     /*!< NT_UART2 RSR_ECR: BE Mask               */
#define NT_UART2_RSR_ECR_OE_Pos               3                                                       /*!< NT_UART2 RSR_ECR: OE Position           */
#define NT_UART2_RSR_ECR_OE_Msk               (0x01UL << NT_UART2_RSR_ECR_OE_Pos)                     /*!< NT_UART2 RSR_ECR: OE Mask               */

/* ---------------------------------  NT_UART2_FR  -------------------------------- */
#define NT_UART2_FR_CTS_Pos                   0                                                       /*!< NT_UART2 FR: CTS Position               */
#define NT_UART2_FR_CTS_Msk                   (0x01UL << NT_UART2_FR_CTS_Pos)                         /*!< NT_UART2 FR: CTS Mask                   */
#define NT_UART2_FR_DSR_Pos                   1                                                       /*!< NT_UART2 FR: DSR Position               */
#define NT_UART2_FR_DSR_Msk                   (0x01UL << NT_UART2_FR_DSR_Pos)                         /*!< NT_UART2 FR: DSR Mask                   */
#define NT_UART2_FR_DCD_Pos                   2                                                       /*!< NT_UART2 FR: DCD Position               */
#define NT_UART2_FR_DCD_Msk                   (0x01UL << NT_UART2_FR_DCD_Pos)                         /*!< NT_UART2 FR: DCD Mask                   */
#define NT_UART2_FR_BUSY_Pos                  3                                                       /*!< NT_UART2 FR: BUSY Position              */
#define NT_UART2_FR_BUSY_Msk                  (0x01UL << NT_UART2_FR_BUSY_Pos)                        /*!< NT_UART2 FR: BUSY Mask                  */
#define NT_UART2_FR_RXFE_Pos                  4                                                       /*!< NT_UART2 FR: RXFE Position              */
#define NT_UART2_FR_RXFE_Msk                  (0x01UL << NT_UART2_FR_RXFE_Pos)                        /*!< NT_UART2 FR: RXFE Mask                  */
#define NT_UART2_FR_TXFF_Pos                  5                                                       /*!< NT_UART2 FR: TXFF Position              */
#define NT_UART2_FR_TXFF_Msk                  (0x01UL << NT_UART2_FR_TXFF_Pos)                        /*!< NT_UART2 FR: TXFF Mask                  */
#define NT_UART2_FR_RXFF_Pos                  6                                                       /*!< NT_UART2 FR: RXFF Position              */
#define NT_UART2_FR_RXFF_Msk                  (0x01UL << NT_UART2_FR_RXFF_Pos)                        /*!< NT_UART2 FR: RXFF Mask                  */
#define NT_UART2_FR_TXFE_Pos                  7                                                       /*!< NT_UART2 FR: TXFE Position              */
#define NT_UART2_FR_TXFE_Msk                  (0x01UL << NT_UART2_FR_TXFE_Pos)                        /*!< NT_UART2 FR: TXFE Mask                  */
#define NT_UART2_FR_RI_Pos                    8                                                       /*!< NT_UART2 FR: RI Position                */
#define NT_UART2_FR_RI_Msk                    (0x01UL << NT_UART2_FR_RI_Pos)                          /*!< NT_UART2 FR: RI Mask                    */

/* --------------------------------  NT_UART2_IBRD  ------------------------------- */
#define NT_UART2_IBRD_BAUD_DIVINT_Pos         0                                                       /*!< NT_UART2 IBRD: BAUD_DIVINT Position     */
#define NT_UART2_IBRD_BAUD_DIVINT_Msk         (0x0000ffffUL << NT_UART2_IBRD_BAUD_DIVINT_Pos)         /*!< NT_UART2 IBRD: BAUD_DIVINT Mask         */

/* --------------------------------  NT_UART2_FBRD  ------------------------------- */
#define NT_UART2_FBRD_BAUD_DIVFRAC_Pos        0                                                       /*!< NT_UART2 FBRD: BAUD_DIVFRAC Position    */
#define NT_UART2_FBRD_BAUD_DIVFRAC_Msk        (0x3fUL << NT_UART2_FBRD_BAUD_DIVFRAC_Pos)              /*!< NT_UART2 FBRD: BAUD_DIVFRAC Mask        */

/* -------------------------------  NT_UART2_LCR_H  ------------------------------- */
#define NT_UART2_LCR_H_BRK_Pos                0                                                       /*!< NT_UART2 LCR_H: BRK Position            */
#define NT_UART2_LCR_H_BRK_Msk                (0x01UL << NT_UART2_LCR_H_BRK_Pos)                      /*!< NT_UART2 LCR_H: BRK Mask                */
#define NT_UART2_LCR_H_PEN_Pos                1                                                       /*!< NT_UART2 LCR_H: PEN Position            */
#define NT_UART2_LCR_H_PEN_Msk                (0x01UL << NT_UART2_LCR_H_PEN_Pos)                      /*!< NT_UART2 LCR_H: PEN Mask                */
#define NT_UART2_LCR_H_EPS_Pos                2                                                       /*!< NT_UART2 LCR_H: EPS Position            */
#define NT_UART2_LCR_H_EPS_Msk                (0x01UL << NT_UART2_LCR_H_EPS_Pos)                      /*!< NT_UART2 LCR_H: EPS Mask                */
#define NT_UART2_LCR_H_STP2_Pos               3                                                       /*!< NT_UART2 LCR_H: STP2 Position           */
#define NT_UART2_LCR_H_STP2_Msk               (0x01UL << NT_UART2_LCR_H_STP2_Pos)                     /*!< NT_UART2 LCR_H: STP2 Mask               */
#define NT_UART2_LCR_H_FEN_Pos                4                                                       /*!< NT_UART2 LCR_H: FEN Position            */
#define NT_UART2_LCR_H_FEN_Msk                (0x01UL << NT_UART2_LCR_H_FEN_Pos)                      /*!< NT_UART2 LCR_H: FEN Mask                */
#define NT_UART2_LCR_H_WLEN_Pos               5                                                       /*!< NT_UART2 LCR_H: WLEN Position           */
#define NT_UART2_LCR_H_WLEN_Msk               (0x03UL << NT_UART2_LCR_H_WLEN_Pos)                     /*!< NT_UART2 LCR_H: WLEN Mask               */
#define NT_UART2_LCR_H_SPS_Pos                7                                                       /*!< NT_UART2 LCR_H: SPS Position            */
#define NT_UART2_LCR_H_SPS_Msk                (0x01UL << NT_UART2_LCR_H_SPS_Pos)                      /*!< NT_UART2 LCR_H: SPS Mask                */

/* ---------------------------------  NT_UART2_CR  -------------------------------- */
#define NT_UART2_CR_UARTEN_Pos                0                                                       /*!< NT_UART2 CR: UARTEN Position            */
#define NT_UART2_CR_UARTEN_Msk                (0x01UL << NT_UART2_CR_UARTEN_Pos)                      /*!< NT_UART2 CR: UARTEN Mask                */
#define NT_UART2_CR_TXE_Pos                   8                                                       /*!< NT_UART2 CR: TXE Position               */
#define NT_UART2_CR_TXE_Msk                   (0x01UL << NT_UART2_CR_TXE_Pos)                         /*!< NT_UART2 CR: TXE Mask                   */
#define NT_UART2_CR_RXE_Pos                   9                                                       /*!< NT_UART2 CR: RXE Position               */
#define NT_UART2_CR_RXE_Msk                   (0x01UL << NT_UART2_CR_RXE_Pos)                         /*!< NT_UART2 CR: RXE Mask                   */
#define NT_UART2_CR_DTR_Pos                   10                                                      /*!< NT_UART2 CR: DTR Position               */
#define NT_UART2_CR_DTR_Msk                   (0x01UL << NT_UART2_CR_DTR_Pos)                         /*!< NT_UART2 CR: DTR Mask                   */
#define NT_UART2_CR_RTS_Pos                   11                                                      /*!< NT_UART2 CR: RTS Position               */
#define NT_UART2_CR_RTS_Msk                   (0x01UL << NT_UART2_CR_RTS_Pos)                         /*!< NT_UART2 CR: RTS Mask                   */
#define NT_UART2_CR_OUT1_Pos                  12                                                      /*!< NT_UART2 CR: OUT1 Position              */
#define NT_UART2_CR_OUT1_Msk                  (0x01UL << NT_UART2_CR_OUT1_Pos)                        /*!< NT_UART2 CR: OUT1 Mask                  */
#define NT_UART2_CR_OUT2_Pos                  13                                                      /*!< NT_UART2 CR: OUT2 Position              */
#define NT_UART2_CR_OUT2_Msk                  (0x01UL << NT_UART2_CR_OUT2_Pos)                        /*!< NT_UART2 CR: OUT2 Mask                  */
#define NT_UART2_CR_RTSEN_Pos                 14                                                      /*!< NT_UART2 CR: RTSEN Position             */
#define NT_UART2_CR_RTSEN_Msk                 (0x01UL << NT_UART2_CR_RTSEN_Pos)                       /*!< NT_UART2 CR: RTSEN Mask                 */
#define NT_UART2_CR_CTSEN_Pos                 15                                                      /*!< NT_UART2 CR: CTSEN Position             */
#define NT_UART2_CR_CTSEN_Msk                 (0x01UL << NT_UART2_CR_CTSEN_Pos)                       /*!< NT_UART2 CR: CTSEN Mask                 */

/* --------------------------------  NT_UART2_IFLS  ------------------------------- */
#define NT_UART2_IFLS_TXIFLSEL_Pos            0                                                       /*!< NT_UART2 IFLS: TXIFLSEL Position        */
#define NT_UART2_IFLS_TXIFLSEL_Msk            (0x07UL << NT_UART2_IFLS_TXIFLSEL_Pos)                  /*!< NT_UART2 IFLS: TXIFLSEL Mask            */
#define NT_UART2_IFLS_RXIFLSEL_Pos            3                                                       /*!< NT_UART2 IFLS: RXIFLSEL Position        */
#define NT_UART2_IFLS_RXIFLSEL_Msk            (0x07UL << NT_UART2_IFLS_RXIFLSEL_Pos)                  /*!< NT_UART2 IFLS: RXIFLSEL Mask            */

/* --------------------------------  NT_UART2_IMSC  ------------------------------- */
#define NT_UART2_IMSC_RIMIM_Pos               0                                                       /*!< NT_UART2 IMSC: RIMIM Position           */
#define NT_UART2_IMSC_RIMIM_Msk               (0x01UL << NT_UART2_IMSC_RIMIM_Pos)                     /*!< NT_UART2 IMSC: RIMIM Mask               */
#define NT_UART2_IMSC_CTSMIM_Pos              1                                                       /*!< NT_UART2 IMSC: CTSMIM Position          */
#define NT_UART2_IMSC_CTSMIM_Msk              (0x01UL << NT_UART2_IMSC_CTSMIM_Pos)                    /*!< NT_UART2 IMSC: CTSMIM Mask              */
#define NT_UART2_IMSC_DCDMIM_Pos              2                                                       /*!< NT_UART2 IMSC: DCDMIM Position          */
#define NT_UART2_IMSC_DCDMIM_Msk              (0x01UL << NT_UART2_IMSC_DCDMIM_Pos)                    /*!< NT_UART2 IMSC: DCDMIM Mask              */
#define NT_UART2_IMSC_DSRMIM_Pos              3                                                       /*!< NT_UART2 IMSC: DSRMIM Position          */
#define NT_UART2_IMSC_DSRMIM_Msk              (0x01UL << NT_UART2_IMSC_DSRMIM_Pos)                    /*!< NT_UART2 IMSC: DSRMIM Mask              */
#define NT_UART2_IMSC_RXIM_Pos                4                                                       /*!< NT_UART2 IMSC: RXIM Position            */
#define NT_UART2_IMSC_RXIM_Msk                (0x01UL << NT_UART2_IMSC_RXIM_Pos)                      /*!< NT_UART2 IMSC: RXIM Mask                */
#define NT_UART2_IMSC_TXIM_Pos                5                                                       /*!< NT_UART2 IMSC: TXIM Position            */
#define NT_UART2_IMSC_TXIM_Msk                (0x01UL << NT_UART2_IMSC_TXIM_Pos)                      /*!< NT_UART2 IMSC: TXIM Mask                */
#define NT_UART2_IMSC_RTIM_Pos                6                                                       /*!< NT_UART2 IMSC: RTIM Position            */
#define NT_UART2_IMSC_RTIM_Msk                (0x01UL << NT_UART2_IMSC_RTIM_Pos)                      /*!< NT_UART2 IMSC: RTIM Mask                */
#define NT_UART2_IMSC_FEIM_Pos                7                                                       /*!< NT_UART2 IMSC: FEIM Position            */
#define NT_UART2_IMSC_FEIM_Msk                (0x01UL << NT_UART2_IMSC_FEIM_Pos)                      /*!< NT_UART2 IMSC: FEIM Mask                */
#define NT_UART2_IMSC_PEIM_Pos                8                                                       /*!< NT_UART2 IMSC: PEIM Position            */
#define NT_UART2_IMSC_PEIM_Msk                (0x01UL << NT_UART2_IMSC_PEIM_Pos)                      /*!< NT_UART2 IMSC: PEIM Mask                */
#define NT_UART2_IMSC_BEIM_Pos                9                                                       /*!< NT_UART2 IMSC: BEIM Position            */
#define NT_UART2_IMSC_BEIM_Msk                (0x01UL << NT_UART2_IMSC_BEIM_Pos)                      /*!< NT_UART2 IMSC: BEIM Mask                */
#define NT_UART2_IMSC_OEIM_Pos                10                                                      /*!< NT_UART2 IMSC: OEIM Position            */
#define NT_UART2_IMSC_OEIM_Msk                (0x01UL << NT_UART2_IMSC_OEIM_Pos)                      /*!< NT_UART2 IMSC: OEIM Mask                */

/* --------------------------------  NT_UART2_RIS  -------------------------------- */
#define NT_UART2_RIS_RIRMIS_Pos               0                                                       /*!< NT_UART2 RIS: RIRMIS Position           */
#define NT_UART2_RIS_RIRMIS_Msk               (0x01UL << NT_UART2_RIS_RIRMIS_Pos)                     /*!< NT_UART2 RIS: RIRMIS Mask               */
#define NT_UART2_RIS_CTSRMIS_Pos              1                                                       /*!< NT_UART2 RIS: CTSRMIS Position          */
#define NT_UART2_RIS_CTSRMIS_Msk              (0x01UL << NT_UART2_RIS_CTSRMIS_Pos)                    /*!< NT_UART2 RIS: CTSRMIS Mask              */
#define NT_UART2_RIS_DCDRMIS_Pos              2                                                       /*!< NT_UART2 RIS: DCDRMIS Position          */
#define NT_UART2_RIS_DCDRMIS_Msk              (0x01UL << NT_UART2_RIS_DCDRMIS_Pos)                    /*!< NT_UART2 RIS: DCDRMIS Mask              */
#define NT_UART2_RIS_DSRRMIS_Pos              3                                                       /*!< NT_UART2 RIS: DSRRMIS Position          */
#define NT_UART2_RIS_DSRRMIS_Msk              (0x01UL << NT_UART2_RIS_DSRRMIS_Pos)                    /*!< NT_UART2 RIS: DSRRMIS Mask              */
#define NT_UART2_RIS_RXRIS_Pos                4                                                       /*!< NT_UART2 RIS: RXRIS Position            */
#define NT_UART2_RIS_RXRIS_Msk                (0x01UL << NT_UART2_RIS_RXRIS_Pos)                      /*!< NT_UART2 RIS: RXRIS Mask                */
#define NT_UART2_RIS_TXRIS_Pos                5                                                       /*!< NT_UART2 RIS: TXRIS Position            */
#define NT_UART2_RIS_TXRIS_Msk                (0x01UL << NT_UART2_RIS_TXRIS_Pos)                      /*!< NT_UART2 RIS: TXRIS Mask                */
#define NT_UART2_RIS_RTRIS_Pos                6                                                       /*!< NT_UART2 RIS: RTRIS Position            */
#define NT_UART2_RIS_RTRIS_Msk                (0x01UL << NT_UART2_RIS_RTRIS_Pos)                      /*!< NT_UART2 RIS: RTRIS Mask                */
#define NT_UART2_RIS_FERIS_Pos                7                                                       /*!< NT_UART2 RIS: FERIS Position            */
#define NT_UART2_RIS_FERIS_Msk                (0x01UL << NT_UART2_RIS_FERIS_Pos)                      /*!< NT_UART2 RIS: FERIS Mask                */
#define NT_UART2_RIS_PERIS_Pos                8                                                       /*!< NT_UART2 RIS: PERIS Position            */
#define NT_UART2_RIS_PERIS_Msk                (0x01UL << NT_UART2_RIS_PERIS_Pos)                      /*!< NT_UART2 RIS: PERIS Mask                */
#define NT_UART2_RIS_BERIS_Pos                9                                                       /*!< NT_UART2 RIS: BERIS Position            */
#define NT_UART2_RIS_BERIS_Msk                (0x01UL << NT_UART2_RIS_BERIS_Pos)                      /*!< NT_UART2 RIS: BERIS Mask                */
#define NT_UART2_RIS_OERIS_Pos                10                                                      /*!< NT_UART2 RIS: OERIS Position            */
#define NT_UART2_RIS_OERIS_Msk                (0x01UL << NT_UART2_RIS_OERIS_Pos)                      /*!< NT_UART2 RIS: OERIS Mask                */

/* --------------------------------  NT_UART2_MIS  -------------------------------- */
#define NT_UART2_MIS_RIMMIS_Pos               0                                                       /*!< NT_UART2 MIS: RIMMIS Position           */
#define NT_UART2_MIS_RIMMIS_Msk               (0x01UL << NT_UART2_MIS_RIMMIS_Pos)                     /*!< NT_UART2 MIS: RIMMIS Mask               */
#define NT_UART2_MIS_CTSMMIS_Pos              1                                                       /*!< NT_UART2 MIS: CTSMMIS Position          */
#define NT_UART2_MIS_CTSMMIS_Msk              (0x01UL << NT_UART2_MIS_CTSMMIS_Pos)                    /*!< NT_UART2 MIS: CTSMMIS Mask              */
#define NT_UART2_MIS_DCDMMIS_Pos              2                                                       /*!< NT_UART2 MIS: DCDMMIS Position          */
#define NT_UART2_MIS_DCDMMIS_Msk              (0x01UL << NT_UART2_MIS_DCDMMIS_Pos)                    /*!< NT_UART2 MIS: DCDMMIS Mask              */
#define NT_UART2_MIS_DSRMMIS_Pos              3                                                       /*!< NT_UART2 MIS: DSRMMIS Position          */
#define NT_UART2_MIS_DSRMMIS_Msk              (0x01UL << NT_UART2_MIS_DSRMMIS_Pos)                    /*!< NT_UART2 MIS: DSRMMIS Mask              */
#define NT_UART2_MIS_RXMIS_Pos                4                                                       /*!< NT_UART2 MIS: RXMIS Position            */
#define NT_UART2_MIS_RXMIS_Msk                (0x01UL << NT_UART2_MIS_RXMIS_Pos)                      /*!< NT_UART2 MIS: RXMIS Mask                */
#define NT_UART2_MIS_TXMIS_Pos                5                                                       /*!< NT_UART2 MIS: TXMIS Position            */
#define NT_UART2_MIS_TXMIS_Msk                (0x01UL << NT_UART2_MIS_TXMIS_Pos)                      /*!< NT_UART2 MIS: TXMIS Mask                */
#define NT_UART2_MIS_RTMIS_Pos                6                                                       /*!< NT_UART2 MIS: RTMIS Position            */
#define NT_UART2_MIS_RTMIS_Msk                (0x01UL << NT_UART2_MIS_RTMIS_Pos)                      /*!< NT_UART2 MIS: RTMIS Mask                */
#define NT_UART2_MIS_FEMIS_Pos                7                                                       /*!< NT_UART2 MIS: FEMIS Position            */
#define NT_UART2_MIS_FEMIS_Msk                (0x01UL << NT_UART2_MIS_FEMIS_Pos)                      /*!< NT_UART2 MIS: FEMIS Mask                */
#define NT_UART2_MIS_PEMIS_Pos                8                                                       /*!< NT_UART2 MIS: PEMIS Position            */
#define NT_UART2_MIS_PEMIS_Msk                (0x01UL << NT_UART2_MIS_PEMIS_Pos)                      /*!< NT_UART2 MIS: PEMIS Mask                */
#define NT_UART2_MIS_BEMIS_Pos                9                                                       /*!< NT_UART2 MIS: BEMIS Position            */
#define NT_UART2_MIS_BEMIS_Msk                (0x01UL << NT_UART2_MIS_BEMIS_Pos)                      /*!< NT_UART2 MIS: BEMIS Mask                */
#define NT_UART2_MIS_OEMIS_Pos                10                                                      /*!< NT_UART2 MIS: OEMIS Position            */
#define NT_UART2_MIS_OEMIS_Msk                (0x01UL << NT_UART2_MIS_OEMIS_Pos)                      /*!< NT_UART2 MIS: OEMIS Mask                */

/* --------------------------------  NT_UART2_ICR  -------------------------------- */
#define NT_UART2_ICR_RIMIC_Pos                0                                                       /*!< NT_UART2 ICR: RIMIC Position            */
#define NT_UART2_ICR_RIMIC_Msk                (0x01UL << NT_UART2_ICR_RIMIC_Pos)                      /*!< NT_UART2 ICR: RIMIC Mask                */
#define NT_UART2_ICR_CTSMIC_Pos               1                                                       /*!< NT_UART2 ICR: CTSMIC Position           */
#define NT_UART2_ICR_CTSMIC_Msk               (0x01UL << NT_UART2_ICR_CTSMIC_Pos)                     /*!< NT_UART2 ICR: CTSMIC Mask               */
#define NT_UART2_ICR_DCDMIC_Pos               2                                                       /*!< NT_UART2 ICR: DCDMIC Position           */
#define NT_UART2_ICR_DCDMIC_Msk               (0x01UL << NT_UART2_ICR_DCDMIC_Pos)                     /*!< NT_UART2 ICR: DCDMIC Mask               */
#define NT_UART2_ICR_DSRMIC_Pos               3                                                       /*!< NT_UART2 ICR: DSRMIC Position           */
#define NT_UART2_ICR_DSRMIC_Msk               (0x01UL << NT_UART2_ICR_DSRMIC_Pos)                     /*!< NT_UART2 ICR: DSRMIC Mask               */
#define NT_UART2_ICR_RXIC_Pos                 4                                                       /*!< NT_UART2 ICR: RXIC Position             */
#define NT_UART2_ICR_RXIC_Msk                 (0x01UL << NT_UART2_ICR_RXIC_Pos)                       /*!< NT_UART2 ICR: RXIC Mask                 */
#define NT_UART2_ICR_TXIC_Pos                 5                                                       /*!< NT_UART2 ICR: TXIC Position             */
#define NT_UART2_ICR_TXIC_Msk                 (0x01UL << NT_UART2_ICR_TXIC_Pos)                       /*!< NT_UART2 ICR: TXIC Mask                 */
#define NT_UART2_ICR_RTIC_Pos                 6                                                       /*!< NT_UART2 ICR: RTIC Position             */
#define NT_UART2_ICR_RTIC_Msk                 (0x01UL << NT_UART2_ICR_RTIC_Pos)                       /*!< NT_UART2 ICR: RTIC Mask                 */
#define NT_UART2_ICR_FEIC_Pos                 7                                                       /*!< NT_UART2 ICR: FEIC Position             */
#define NT_UART2_ICR_FEIC_Msk                 (0x01UL << NT_UART2_ICR_FEIC_Pos)                       /*!< NT_UART2 ICR: FEIC Mask                 */
#define NT_UART2_ICR_PEIC_Pos                 8                                                       /*!< NT_UART2 ICR: PEIC Position             */
#define NT_UART2_ICR_PEIC_Msk                 (0x01UL << NT_UART2_ICR_PEIC_Pos)                       /*!< NT_UART2 ICR: PEIC Mask                 */
#define NT_UART2_ICR_BEIC_Pos                 9                                                       /*!< NT_UART2 ICR: BEIC Position             */
#define NT_UART2_ICR_BEIC_Msk                 (0x01UL << NT_UART2_ICR_BEIC_Pos)                       /*!< NT_UART2 ICR: BEIC Mask                 */
#define NT_UART2_ICR_OEIC_Pos                 10                                                      /*!< NT_UART2 ICR: OEIC Position             */
#define NT_UART2_ICR_OEIC_Msk                 (0x01UL << NT_UART2_ICR_OEIC_Pos)                       /*!< NT_UART2 ICR: OEIC Mask                 */

/* -------------------------------  NT_UART2_DMACR  ------------------------------- */
#define NT_UART2_DMACR_RXDMAE_Pos             0                                                       /*!< NT_UART2 DMACR: RXDMAE Position         */
#define NT_UART2_DMACR_RXDMAE_Msk             (0x01UL << NT_UART2_DMACR_RXDMAE_Pos)                   /*!< NT_UART2 DMACR: RXDMAE Mask             */
#define NT_UART2_DMACR_TXDMAE_Pos             1                                                       /*!< NT_UART2 DMACR: TXDMAE Position         */
#define NT_UART2_DMACR_TXDMAE_Msk             (0x01UL << NT_UART2_DMACR_TXDMAE_Pos)                   /*!< NT_UART2 DMACR: TXDMAE Mask             */
#define NT_UART2_DMACR_DMAONERR_Pos           2                                                       /*!< NT_UART2 DMACR: DMAONERR Position       */
#define NT_UART2_DMACR_DMAONERR_Msk           (0x01UL << NT_UART2_DMACR_DMAONERR_Pos)                 /*!< NT_UART2 DMACR: DMAONERR Mask           */


/* ================================================================================ */
/* ================        struct 'NT_UART3' Position & Mask       ================ */
/* ================================================================================ */


/* ---------------------------------  NT_UART3_DR  -------------------------------- */
#define NT_UART3_DR_DATA_Pos                  0                                                       /*!< NT_UART3 DR: DATA Position              */
#define NT_UART3_DR_DATA_Msk                  (0x000000ffUL << NT_UART3_DR_DATA_Pos)                  /*!< NT_UART3 DR: DATA Mask                  */
#define NT_UART3_DR_FE_Pos                    8                                                       /*!< NT_UART3 DR: FE Position                */
#define NT_UART3_DR_FE_Msk                    (0x01UL << NT_UART3_DR_FE_Pos)                          /*!< NT_UART3 DR: FE Mask                    */
#define NT_UART3_DR_PE_Pos                    9                                                       /*!< NT_UART3 DR: PE Position                */
#define NT_UART3_DR_PE_Msk                    (0x01UL << NT_UART3_DR_PE_Pos)                          /*!< NT_UART3 DR: PE Mask                    */
#define NT_UART3_DR_BE_Pos                    10                                                      /*!< NT_UART3 DR: BE Position                */
#define NT_UART3_DR_BE_Msk                    (0x01UL << NT_UART3_DR_BE_Pos)                          /*!< NT_UART3 DR: BE Mask                    */
#define NT_UART3_DR_OE_Pos                    11                                                      /*!< NT_UART3 DR: OE Position                */
#define NT_UART3_DR_OE_Msk                    (0x01UL << NT_UART3_DR_OE_Pos)                          /*!< NT_UART3 DR: OE Mask                    */

/* ------------------------------  NT_UART3_RSR_ECR  ------------------------------ */
#define NT_UART3_RSR_ECR_FE_Pos               0                                                       /*!< NT_UART3 RSR_ECR: FE Position           */
#define NT_UART3_RSR_ECR_FE_Msk               (0x01UL << NT_UART3_RSR_ECR_FE_Pos)                     /*!< NT_UART3 RSR_ECR: FE Mask               */
#define NT_UART3_RSR_ECR_PE_Pos               1                                                       /*!< NT_UART3 RSR_ECR: PE Position           */
#define NT_UART3_RSR_ECR_PE_Msk               (0x01UL << NT_UART3_RSR_ECR_PE_Pos)                     /*!< NT_UART3 RSR_ECR: PE Mask               */
#define NT_UART3_RSR_ECR_BE_Pos               2                                                       /*!< NT_UART3 RSR_ECR: BE Position           */
#define NT_UART3_RSR_ECR_BE_Msk               (0x01UL << NT_UART3_RSR_ECR_BE_Pos)                     /*!< NT_UART3 RSR_ECR: BE Mask               */
#define NT_UART3_RSR_ECR_OE_Pos               3                                                       /*!< NT_UART3 RSR_ECR: OE Position           */
#define NT_UART3_RSR_ECR_OE_Msk               (0x01UL << NT_UART3_RSR_ECR_OE_Pos)                     /*!< NT_UART3 RSR_ECR: OE Mask               */

/* ---------------------------------  NT_UART3_FR  -------------------------------- */
#define NT_UART3_FR_CTS_Pos                   0                                                       /*!< NT_UART3 FR: CTS Position               */
#define NT_UART3_FR_CTS_Msk                   (0x01UL << NT_UART3_FR_CTS_Pos)                         /*!< NT_UART3 FR: CTS Mask                   */
#define NT_UART3_FR_DSR_Pos                   1                                                       /*!< NT_UART3 FR: DSR Position               */
#define NT_UART3_FR_DSR_Msk                   (0x01UL << NT_UART3_FR_DSR_Pos)                         /*!< NT_UART3 FR: DSR Mask                   */
#define NT_UART3_FR_DCD_Pos                   2                                                       /*!< NT_UART3 FR: DCD Position               */
#define NT_UART3_FR_DCD_Msk                   (0x01UL << NT_UART3_FR_DCD_Pos)                         /*!< NT_UART3 FR: DCD Mask                   */
#define NT_UART3_FR_BUSY_Pos                  3                                                       /*!< NT_UART3 FR: BUSY Position              */
#define NT_UART3_FR_BUSY_Msk                  (0x01UL << NT_UART3_FR_BUSY_Pos)                        /*!< NT_UART3 FR: BUSY Mask                  */
#define NT_UART3_FR_RXFE_Pos                  4                                                       /*!< NT_UART3 FR: RXFE Position              */
#define NT_UART3_FR_RXFE_Msk                  (0x01UL << NT_UART3_FR_RXFE_Pos)                        /*!< NT_UART3 FR: RXFE Mask                  */
#define NT_UART3_FR_TXFF_Pos                  5                                                       /*!< NT_UART3 FR: TXFF Position              */
#define NT_UART3_FR_TXFF_Msk                  (0x01UL << NT_UART3_FR_TXFF_Pos)                        /*!< NT_UART3 FR: TXFF Mask                  */
#define NT_UART3_FR_RXFF_Pos                  6                                                       /*!< NT_UART3 FR: RXFF Position              */
#define NT_UART3_FR_RXFF_Msk                  (0x01UL << NT_UART3_FR_RXFF_Pos)                        /*!< NT_UART3 FR: RXFF Mask                  */
#define NT_UART3_FR_TXFE_Pos                  7                                                       /*!< NT_UART3 FR: TXFE Position              */
#define NT_UART3_FR_TXFE_Msk                  (0x01UL << NT_UART3_FR_TXFE_Pos)                        /*!< NT_UART3 FR: TXFE Mask                  */
#define NT_UART3_FR_RI_Pos                    8                                                       /*!< NT_UART3 FR: RI Position                */
#define NT_UART3_FR_RI_Msk                    (0x01UL << NT_UART3_FR_RI_Pos)                          /*!< NT_UART3 FR: RI Mask                    */

/* --------------------------------  NT_UART3_IBRD  ------------------------------- */
#define NT_UART3_IBRD_BAUD_DIVINT_Pos         0                                                       /*!< NT_UART3 IBRD: BAUD_DIVINT Position     */
#define NT_UART3_IBRD_BAUD_DIVINT_Msk         (0x0000ffffUL << NT_UART3_IBRD_BAUD_DIVINT_Pos)         /*!< NT_UART3 IBRD: BAUD_DIVINT Mask         */

/* --------------------------------  NT_UART3_FBRD  ------------------------------- */
#define NT_UART3_FBRD_BAUD_DIVFRAC_Pos        0                                                       /*!< NT_UART3 FBRD: BAUD_DIVFRAC Position    */
#define NT_UART3_FBRD_BAUD_DIVFRAC_Msk        (0x3fUL << NT_UART3_FBRD_BAUD_DIVFRAC_Pos)              /*!< NT_UART3 FBRD: BAUD_DIVFRAC Mask        */

/* -------------------------------  NT_UART3_LCR_H  ------------------------------- */
#define NT_UART3_LCR_H_BRK_Pos                0                                                       /*!< NT_UART3 LCR_H: BRK Position            */
#define NT_UART3_LCR_H_BRK_Msk                (0x01UL << NT_UART3_LCR_H_BRK_Pos)                      /*!< NT_UART3 LCR_H: BRK Mask                */
#define NT_UART3_LCR_H_PEN_Pos                1                                                       /*!< NT_UART3 LCR_H: PEN Position            */
#define NT_UART3_LCR_H_PEN_Msk                (0x01UL << NT_UART3_LCR_H_PEN_Pos)                      /*!< NT_UART3 LCR_H: PEN Mask                */
#define NT_UART3_LCR_H_EPS_Pos                2                                                       /*!< NT_UART3 LCR_H: EPS Position            */
#define NT_UART3_LCR_H_EPS_Msk                (0x01UL << NT_UART3_LCR_H_EPS_Pos)                      /*!< NT_UART3 LCR_H: EPS Mask                */
#define NT_UART3_LCR_H_STP2_Pos               3                                                       /*!< NT_UART3 LCR_H: STP2 Position           */
#define NT_UART3_LCR_H_STP2_Msk               (0x01UL << NT_UART3_LCR_H_STP2_Pos)                     /*!< NT_UART3 LCR_H: STP2 Mask               */
#define NT_UART3_LCR_H_FEN_Pos                4                                                       /*!< NT_UART3 LCR_H: FEN Position            */
#define NT_UART3_LCR_H_FEN_Msk                (0x01UL << NT_UART3_LCR_H_FEN_Pos)                      /*!< NT_UART3 LCR_H: FEN Mask                */
#define NT_UART3_LCR_H_WLEN_Pos               5                                                       /*!< NT_UART3 LCR_H: WLEN Position           */
#define NT_UART3_LCR_H_WLEN_Msk               (0x03UL << NT_UART3_LCR_H_WLEN_Pos)                     /*!< NT_UART3 LCR_H: WLEN Mask               */
#define NT_UART3_LCR_H_SPS_Pos                7                                                       /*!< NT_UART3 LCR_H: SPS Position            */
#define NT_UART3_LCR_H_SPS_Msk                (0x01UL << NT_UART3_LCR_H_SPS_Pos)                      /*!< NT_UART3 LCR_H: SPS Mask                */

/* ---------------------------------  NT_UART3_CR  -------------------------------- */
#define NT_UART3_CR_UARTEN_Pos                0                                                       /*!< NT_UART3 CR: UARTEN Position            */
#define NT_UART3_CR_UARTEN_Msk                (0x01UL << NT_UART3_CR_UARTEN_Pos)                      /*!< NT_UART3 CR: UARTEN Mask                */
#define NT_UART3_CR_TXE_Pos                   8                                                       /*!< NT_UART3 CR: TXE Position               */
#define NT_UART3_CR_TXE_Msk                   (0x01UL << NT_UART3_CR_TXE_Pos)                         /*!< NT_UART3 CR: TXE Mask                   */
#define NT_UART3_CR_RXE_Pos                   9                                                       /*!< NT_UART3 CR: RXE Position               */
#define NT_UART3_CR_RXE_Msk                   (0x01UL << NT_UART3_CR_RXE_Pos)                         /*!< NT_UART3 CR: RXE Mask                   */
#define NT_UART3_CR_DTR_Pos                   10                                                      /*!< NT_UART3 CR: DTR Position               */
#define NT_UART3_CR_DTR_Msk                   (0x01UL << NT_UART3_CR_DTR_Pos)                         /*!< NT_UART3 CR: DTR Mask                   */
#define NT_UART3_CR_RTS_Pos                   11                                                      /*!< NT_UART3 CR: RTS Position               */
#define NT_UART3_CR_RTS_Msk                   (0x01UL << NT_UART3_CR_RTS_Pos)                         /*!< NT_UART3 CR: RTS Mask                   */
#define NT_UART3_CR_OUT1_Pos                  12                                                      /*!< NT_UART3 CR: OUT1 Position              */
#define NT_UART3_CR_OUT1_Msk                  (0x01UL << NT_UART3_CR_OUT1_Pos)                        /*!< NT_UART3 CR: OUT1 Mask                  */
#define NT_UART3_CR_OUT2_Pos                  13                                                      /*!< NT_UART3 CR: OUT2 Position              */
#define NT_UART3_CR_OUT2_Msk                  (0x01UL << NT_UART3_CR_OUT2_Pos)                        /*!< NT_UART3 CR: OUT2 Mask                  */
#define NT_UART3_CR_RTSEN_Pos                 14                                                      /*!< NT_UART3 CR: RTSEN Position             */
#define NT_UART3_CR_RTSEN_Msk                 (0x01UL << NT_UART3_CR_RTSEN_Pos)                       /*!< NT_UART3 CR: RTSEN Mask                 */
#define NT_UART3_CR_CTSEN_Pos                 15                                                      /*!< NT_UART3 CR: CTSEN Position             */
#define NT_UART3_CR_CTSEN_Msk                 (0x01UL << NT_UART3_CR_CTSEN_Pos)                       /*!< NT_UART3 CR: CTSEN Mask                 */

/* --------------------------------  NT_UART3_IFLS  ------------------------------- */
#define NT_UART3_IFLS_TXIFLSEL_Pos            0                                                       /*!< NT_UART3 IFLS: TXIFLSEL Position        */
#define NT_UART3_IFLS_TXIFLSEL_Msk            (0x07UL << NT_UART3_IFLS_TXIFLSEL_Pos)                  /*!< NT_UART3 IFLS: TXIFLSEL Mask            */
#define NT_UART3_IFLS_RXIFLSEL_Pos            3                                                       /*!< NT_UART3 IFLS: RXIFLSEL Position        */
#define NT_UART3_IFLS_RXIFLSEL_Msk            (0x07UL << NT_UART3_IFLS_RXIFLSEL_Pos)                  /*!< NT_UART3 IFLS: RXIFLSEL Mask            */

/* --------------------------------  NT_UART3_IMSC  ------------------------------- */
#define NT_UART3_IMSC_RIMIM_Pos               0                                                       /*!< NT_UART3 IMSC: RIMIM Position           */
#define NT_UART3_IMSC_RIMIM_Msk               (0x01UL << NT_UART3_IMSC_RIMIM_Pos)                     /*!< NT_UART3 IMSC: RIMIM Mask               */
#define NT_UART3_IMSC_CTSMIM_Pos              1                                                       /*!< NT_UART3 IMSC: CTSMIM Position          */
#define NT_UART3_IMSC_CTSMIM_Msk              (0x01UL << NT_UART3_IMSC_CTSMIM_Pos)                    /*!< NT_UART3 IMSC: CTSMIM Mask              */
#define NT_UART3_IMSC_DCDMIM_Pos              2                                                       /*!< NT_UART3 IMSC: DCDMIM Position          */
#define NT_UART3_IMSC_DCDMIM_Msk              (0x01UL << NT_UART3_IMSC_DCDMIM_Pos)                    /*!< NT_UART3 IMSC: DCDMIM Mask              */
#define NT_UART3_IMSC_DSRMIM_Pos              3                                                       /*!< NT_UART3 IMSC: DSRMIM Position          */
#define NT_UART3_IMSC_DSRMIM_Msk              (0x01UL << NT_UART3_IMSC_DSRMIM_Pos)                    /*!< NT_UART3 IMSC: DSRMIM Mask              */
#define NT_UART3_IMSC_RXIM_Pos                4                                                       /*!< NT_UART3 IMSC: RXIM Position            */
#define NT_UART3_IMSC_RXIM_Msk                (0x01UL << NT_UART3_IMSC_RXIM_Pos)                      /*!< NT_UART3 IMSC: RXIM Mask                */
#define NT_UART3_IMSC_TXIM_Pos                5                                                       /*!< NT_UART3 IMSC: TXIM Position            */
#define NT_UART3_IMSC_TXIM_Msk                (0x01UL << NT_UART3_IMSC_TXIM_Pos)                      /*!< NT_UART3 IMSC: TXIM Mask                */
#define NT_UART3_IMSC_RTIM_Pos                6                                                       /*!< NT_UART3 IMSC: RTIM Position            */
#define NT_UART3_IMSC_RTIM_Msk                (0x01UL << NT_UART3_IMSC_RTIM_Pos)                      /*!< NT_UART3 IMSC: RTIM Mask                */
#define NT_UART3_IMSC_FEIM_Pos                7                                                       /*!< NT_UART3 IMSC: FEIM Position            */
#define NT_UART3_IMSC_FEIM_Msk                (0x01UL << NT_UART3_IMSC_FEIM_Pos)                      /*!< NT_UART3 IMSC: FEIM Mask                */
#define NT_UART3_IMSC_PEIM_Pos                8                                                       /*!< NT_UART3 IMSC: PEIM Position            */
#define NT_UART3_IMSC_PEIM_Msk                (0x01UL << NT_UART3_IMSC_PEIM_Pos)                      /*!< NT_UART3 IMSC: PEIM Mask                */
#define NT_UART3_IMSC_BEIM_Pos                9                                                       /*!< NT_UART3 IMSC: BEIM Position            */
#define NT_UART3_IMSC_BEIM_Msk                (0x01UL << NT_UART3_IMSC_BEIM_Pos)                      /*!< NT_UART3 IMSC: BEIM Mask                */
#define NT_UART3_IMSC_OEIM_Pos                10                                                      /*!< NT_UART3 IMSC: OEIM Position            */
#define NT_UART3_IMSC_OEIM_Msk                (0x01UL << NT_UART3_IMSC_OEIM_Pos)                      /*!< NT_UART3 IMSC: OEIM Mask                */

/* --------------------------------  NT_UART3_RIS  -------------------------------- */
#define NT_UART3_RIS_RIRMIS_Pos               0                                                       /*!< NT_UART3 RIS: RIRMIS Position           */
#define NT_UART3_RIS_RIRMIS_Msk               (0x01UL << NT_UART3_RIS_RIRMIS_Pos)                     /*!< NT_UART3 RIS: RIRMIS Mask               */
#define NT_UART3_RIS_CTSRMIS_Pos              1                                                       /*!< NT_UART3 RIS: CTSRMIS Position          */
#define NT_UART3_RIS_CTSRMIS_Msk              (0x01UL << NT_UART3_RIS_CTSRMIS_Pos)                    /*!< NT_UART3 RIS: CTSRMIS Mask              */
#define NT_UART3_RIS_DCDRMIS_Pos              2                                                       /*!< NT_UART3 RIS: DCDRMIS Position          */
#define NT_UART3_RIS_DCDRMIS_Msk              (0x01UL << NT_UART3_RIS_DCDRMIS_Pos)                    /*!< NT_UART3 RIS: DCDRMIS Mask              */
#define NT_UART3_RIS_DSRRMIS_Pos              3                                                       /*!< NT_UART3 RIS: DSRRMIS Position          */
#define NT_UART3_RIS_DSRRMIS_Msk              (0x01UL << NT_UART3_RIS_DSRRMIS_Pos)                    /*!< NT_UART3 RIS: DSRRMIS Mask              */
#define NT_UART3_RIS_RXRIS_Pos                4                                                       /*!< NT_UART3 RIS: RXRIS Position            */
#define NT_UART3_RIS_RXRIS_Msk                (0x01UL << NT_UART3_RIS_RXRIS_Pos)                      /*!< NT_UART3 RIS: RXRIS Mask                */
#define NT_UART3_RIS_TXRIS_Pos                5                                                       /*!< NT_UART3 RIS: TXRIS Position            */
#define NT_UART3_RIS_TXRIS_Msk                (0x01UL << NT_UART3_RIS_TXRIS_Pos)                      /*!< NT_UART3 RIS: TXRIS Mask                */
#define NT_UART3_RIS_RTRIS_Pos                6                                                       /*!< NT_UART3 RIS: RTRIS Position            */
#define NT_UART3_RIS_RTRIS_Msk                (0x01UL << NT_UART3_RIS_RTRIS_Pos)                      /*!< NT_UART3 RIS: RTRIS Mask                */
#define NT_UART3_RIS_FERIS_Pos                7                                                       /*!< NT_UART3 RIS: FERIS Position            */
#define NT_UART3_RIS_FERIS_Msk                (0x01UL << NT_UART3_RIS_FERIS_Pos)                      /*!< NT_UART3 RIS: FERIS Mask                */
#define NT_UART3_RIS_PERIS_Pos                8                                                       /*!< NT_UART3 RIS: PERIS Position            */
#define NT_UART3_RIS_PERIS_Msk                (0x01UL << NT_UART3_RIS_PERIS_Pos)                      /*!< NT_UART3 RIS: PERIS Mask                */
#define NT_UART3_RIS_BERIS_Pos                9                                                       /*!< NT_UART3 RIS: BERIS Position            */
#define NT_UART3_RIS_BERIS_Msk                (0x01UL << NT_UART3_RIS_BERIS_Pos)                      /*!< NT_UART3 RIS: BERIS Mask                */
#define NT_UART3_RIS_OERIS_Pos                10                                                      /*!< NT_UART3 RIS: OERIS Position            */
#define NT_UART3_RIS_OERIS_Msk                (0x01UL << NT_UART3_RIS_OERIS_Pos)                      /*!< NT_UART3 RIS: OERIS Mask                */

/* --------------------------------  NT_UART3_MIS  -------------------------------- */
#define NT_UART3_MIS_RIMMIS_Pos               0                                                       /*!< NT_UART3 MIS: RIMMIS Position           */
#define NT_UART3_MIS_RIMMIS_Msk               (0x01UL << NT_UART3_MIS_RIMMIS_Pos)                     /*!< NT_UART3 MIS: RIMMIS Mask               */
#define NT_UART3_MIS_CTSMMIS_Pos              1                                                       /*!< NT_UART3 MIS: CTSMMIS Position          */
#define NT_UART3_MIS_CTSMMIS_Msk              (0x01UL << NT_UART3_MIS_CTSMMIS_Pos)                    /*!< NT_UART3 MIS: CTSMMIS Mask              */
#define NT_UART3_MIS_DCDMMIS_Pos              2                                                       /*!< NT_UART3 MIS: DCDMMIS Position          */
#define NT_UART3_MIS_DCDMMIS_Msk              (0x01UL << NT_UART3_MIS_DCDMMIS_Pos)                    /*!< NT_UART3 MIS: DCDMMIS Mask              */
#define NT_UART3_MIS_DSRMMIS_Pos              3                                                       /*!< NT_UART3 MIS: DSRMMIS Position          */
#define NT_UART3_MIS_DSRMMIS_Msk              (0x01UL << NT_UART3_MIS_DSRMMIS_Pos)                    /*!< NT_UART3 MIS: DSRMMIS Mask              */
#define NT_UART3_MIS_RXMIS_Pos                4                                                       /*!< NT_UART3 MIS: RXMIS Position            */
#define NT_UART3_MIS_RXMIS_Msk                (0x01UL << NT_UART3_MIS_RXMIS_Pos)                      /*!< NT_UART3 MIS: RXMIS Mask                */
#define NT_UART3_MIS_TXMIS_Pos                5                                                       /*!< NT_UART3 MIS: TXMIS Position            */
#define NT_UART3_MIS_TXMIS_Msk                (0x01UL << NT_UART3_MIS_TXMIS_Pos)                      /*!< NT_UART3 MIS: TXMIS Mask                */
#define NT_UART3_MIS_RTMIS_Pos                6                                                       /*!< NT_UART3 MIS: RTMIS Position            */
#define NT_UART3_MIS_RTMIS_Msk                (0x01UL << NT_UART3_MIS_RTMIS_Pos)                      /*!< NT_UART3 MIS: RTMIS Mask                */
#define NT_UART3_MIS_FEMIS_Pos                7                                                       /*!< NT_UART3 MIS: FEMIS Position            */
#define NT_UART3_MIS_FEMIS_Msk                (0x01UL << NT_UART3_MIS_FEMIS_Pos)                      /*!< NT_UART3 MIS: FEMIS Mask                */
#define NT_UART3_MIS_PEMIS_Pos                8                                                       /*!< NT_UART3 MIS: PEMIS Position            */
#define NT_UART3_MIS_PEMIS_Msk                (0x01UL << NT_UART3_MIS_PEMIS_Pos)                      /*!< NT_UART3 MIS: PEMIS Mask                */
#define NT_UART3_MIS_BEMIS_Pos                9                                                       /*!< NT_UART3 MIS: BEMIS Position            */
#define NT_UART3_MIS_BEMIS_Msk                (0x01UL << NT_UART3_MIS_BEMIS_Pos)                      /*!< NT_UART3 MIS: BEMIS Mask                */
#define NT_UART3_MIS_OEMIS_Pos                10                                                      /*!< NT_UART3 MIS: OEMIS Position            */
#define NT_UART3_MIS_OEMIS_Msk                (0x01UL << NT_UART3_MIS_OEMIS_Pos)                      /*!< NT_UART3 MIS: OEMIS Mask                */

/* --------------------------------  NT_UART3_ICR  -------------------------------- */
#define NT_UART3_ICR_RIMIC_Pos                0                                                       /*!< NT_UART3 ICR: RIMIC Position            */
#define NT_UART3_ICR_RIMIC_Msk                (0x01UL << NT_UART3_ICR_RIMIC_Pos)                      /*!< NT_UART3 ICR: RIMIC Mask                */
#define NT_UART3_ICR_CTSMIC_Pos               1                                                       /*!< NT_UART3 ICR: CTSMIC Position           */
#define NT_UART3_ICR_CTSMIC_Msk               (0x01UL << NT_UART3_ICR_CTSMIC_Pos)                     /*!< NT_UART3 ICR: CTSMIC Mask               */
#define NT_UART3_ICR_DCDMIC_Pos               2                                                       /*!< NT_UART3 ICR: DCDMIC Position           */
#define NT_UART3_ICR_DCDMIC_Msk               (0x01UL << NT_UART3_ICR_DCDMIC_Pos)                     /*!< NT_UART3 ICR: DCDMIC Mask               */
#define NT_UART3_ICR_DSRMIC_Pos               3                                                       /*!< NT_UART3 ICR: DSRMIC Position           */
#define NT_UART3_ICR_DSRMIC_Msk               (0x01UL << NT_UART3_ICR_DSRMIC_Pos)                     /*!< NT_UART3 ICR: DSRMIC Mask               */
#define NT_UART3_ICR_RXIC_Pos                 4                                                       /*!< NT_UART3 ICR: RXIC Position             */
#define NT_UART3_ICR_RXIC_Msk                 (0x01UL << NT_UART3_ICR_RXIC_Pos)                       /*!< NT_UART3 ICR: RXIC Mask                 */
#define NT_UART3_ICR_TXIC_Pos                 5                                                       /*!< NT_UART3 ICR: TXIC Position             */
#define NT_UART3_ICR_TXIC_Msk                 (0x01UL << NT_UART3_ICR_TXIC_Pos)                       /*!< NT_UART3 ICR: TXIC Mask                 */
#define NT_UART3_ICR_RTIC_Pos                 6                                                       /*!< NT_UART3 ICR: RTIC Position             */
#define NT_UART3_ICR_RTIC_Msk                 (0x01UL << NT_UART3_ICR_RTIC_Pos)                       /*!< NT_UART3 ICR: RTIC Mask                 */
#define NT_UART3_ICR_FEIC_Pos                 7                                                       /*!< NT_UART3 ICR: FEIC Position             */
#define NT_UART3_ICR_FEIC_Msk                 (0x01UL << NT_UART3_ICR_FEIC_Pos)                       /*!< NT_UART3 ICR: FEIC Mask                 */
#define NT_UART3_ICR_PEIC_Pos                 8                                                       /*!< NT_UART3 ICR: PEIC Position             */
#define NT_UART3_ICR_PEIC_Msk                 (0x01UL << NT_UART3_ICR_PEIC_Pos)                       /*!< NT_UART3 ICR: PEIC Mask                 */
#define NT_UART3_ICR_BEIC_Pos                 9                                                       /*!< NT_UART3 ICR: BEIC Position             */
#define NT_UART3_ICR_BEIC_Msk                 (0x01UL << NT_UART3_ICR_BEIC_Pos)                       /*!< NT_UART3 ICR: BEIC Mask                 */
#define NT_UART3_ICR_OEIC_Pos                 10                                                      /*!< NT_UART3 ICR: OEIC Position             */
#define NT_UART3_ICR_OEIC_Msk                 (0x01UL << NT_UART3_ICR_OEIC_Pos)                       /*!< NT_UART3 ICR: OEIC Mask                 */

/* -------------------------------  NT_UART3_DMACR  ------------------------------- */
#define NT_UART3_DMACR_RXDMAE_Pos             0                                                       /*!< NT_UART3 DMACR: RXDMAE Position         */
#define NT_UART3_DMACR_RXDMAE_Msk             (0x01UL << NT_UART3_DMACR_RXDMAE_Pos)                   /*!< NT_UART3 DMACR: RXDMAE Mask             */
#define NT_UART3_DMACR_TXDMAE_Pos             1                                                       /*!< NT_UART3 DMACR: TXDMAE Position         */
#define NT_UART3_DMACR_TXDMAE_Msk             (0x01UL << NT_UART3_DMACR_TXDMAE_Pos)                   /*!< NT_UART3 DMACR: TXDMAE Mask             */
#define NT_UART3_DMACR_DMAONERR_Pos           2                                                       /*!< NT_UART3 DMACR: DMAONERR Position       */
#define NT_UART3_DMACR_DMAONERR_Msk           (0x01UL << NT_UART3_DMACR_DMAONERR_Pos)                 /*!< NT_UART3 DMACR: DMAONERR Mask           */


/* ================================================================================ */
/* ================         struct 'NT_CMP' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  NT_CMP_MIS  --------------------------------- */
#define NT_CMP_MIS_IN0_Pos                    0                                                       /*!< NT_CMP MIS: IN0 Position                */
#define NT_CMP_MIS_IN0_Msk                    (0x01UL << NT_CMP_MIS_IN0_Pos)                          /*!< NT_CMP MIS: IN0 Mask                    */
#define NT_CMP_MIS_IN1_Pos                    1                                                       /*!< NT_CMP MIS: IN1 Position                */
#define NT_CMP_MIS_IN1_Msk                    (0x01UL << NT_CMP_MIS_IN1_Pos)                          /*!< NT_CMP MIS: IN1 Mask                    */
#define NT_CMP_MIS_IN2_Pos                    2                                                       /*!< NT_CMP MIS: IN2 Position                */
#define NT_CMP_MIS_IN2_Msk                    (0x01UL << NT_CMP_MIS_IN2_Pos)                          /*!< NT_CMP MIS: IN2 Mask                    */
#define NT_CMP_MIS_INT0_Pos                   16                                                      /*!< NT_CMP MIS: INT0 Position               */
#define NT_CMP_MIS_INT0_Msk                   (0x01UL << NT_CMP_MIS_INT0_Pos)                         /*!< NT_CMP MIS: INT0 Mask                   */
#define NT_CMP_MIS_INT1_Pos                   17                                                      /*!< NT_CMP MIS: INT1 Position               */
#define NT_CMP_MIS_INT1_Msk                   (0x01UL << NT_CMP_MIS_INT1_Pos)                         /*!< NT_CMP MIS: INT1 Mask                   */
#define NT_CMP_MIS_INT2_Pos                   18                                                      /*!< NT_CMP MIS: INT2 Position               */
#define NT_CMP_MIS_INT2_Msk                   (0x01UL << NT_CMP_MIS_INT2_Pos)                         /*!< NT_CMP MIS: INT2 Mask                   */

/* ---------------------------------  NT_CMP_RIS  --------------------------------- */
#define NT_CMP_RIS_IN0_Pos                    0                                                       /*!< NT_CMP RIS: IN0 Position                */
#define NT_CMP_RIS_IN0_Msk                    (0x01UL << NT_CMP_RIS_IN0_Pos)                          /*!< NT_CMP RIS: IN0 Mask                    */
#define NT_CMP_RIS_IN1_Pos                    1                                                       /*!< NT_CMP RIS: IN1 Position                */
#define NT_CMP_RIS_IN1_Msk                    (0x01UL << NT_CMP_RIS_IN1_Pos)                          /*!< NT_CMP RIS: IN1 Mask                    */
#define NT_CMP_RIS_IN2_Pos                    2                                                       /*!< NT_CMP RIS: IN2 Position                */
#define NT_CMP_RIS_IN2_Msk                    (0x01UL << NT_CMP_RIS_IN2_Pos)                          /*!< NT_CMP RIS: IN2 Mask                    */

/* --------------------------------  NT_CMP_INTEN  -------------------------------- */
#define NT_CMP_INTEN_IN0_Pos                  0                                                       /*!< NT_CMP INTEN: IN0 Position              */
#define NT_CMP_INTEN_IN0_Msk                  (0x01UL << NT_CMP_INTEN_IN0_Pos)                        /*!< NT_CMP INTEN: IN0 Mask                  */
#define NT_CMP_INTEN_IN1_Pos                  1                                                       /*!< NT_CMP INTEN: IN1 Position              */
#define NT_CMP_INTEN_IN1_Msk                  (0x01UL << NT_CMP_INTEN_IN1_Pos)                        /*!< NT_CMP INTEN: IN1 Mask                  */
#define NT_CMP_INTEN_IN2_Pos                  2                                                       /*!< NT_CMP INTEN: IN2 Position              */
#define NT_CMP_INTEN_IN2_Msk                  (0x01UL << NT_CMP_INTEN_IN2_Pos)                        /*!< NT_CMP INTEN: IN2 Mask                  */

/* -------------------------------  NT_CMP_REFCTL0  ------------------------------- */
#define NT_CMP_REFCTL0_VREF_Pos               0                                                       /*!< NT_CMP REFCTL0: VREF Position           */
#define NT_CMP_REFCTL0_VREF_Msk               (0x0fUL << NT_CMP_REFCTL0_VREF_Pos)                     /*!< NT_CMP REFCTL0: VREF Mask               */
#define NT_CMP_REFCTL0_RNG_Pos                8                                                       /*!< NT_CMP REFCTL0: RNG Position            */
#define NT_CMP_REFCTL0_RNG_Msk                (0x01UL << NT_CMP_REFCTL0_RNG_Pos)                      /*!< NT_CMP REFCTL0: RNG Mask                */
#define NT_CMP_REFCTL0_EN_Pos                 9                                                       /*!< NT_CMP REFCTL0: EN Position             */
#define NT_CMP_REFCTL0_EN_Msk                 (0x01UL << NT_CMP_REFCTL0_EN_Pos)                       /*!< NT_CMP REFCTL0: EN Mask                 */

/* -------------------------------  NT_CMP_REFCTL1  ------------------------------- */
#define NT_CMP_REFCTL1_VREF_Pos               0                                                       /*!< NT_CMP REFCTL1: VREF Position           */
#define NT_CMP_REFCTL1_VREF_Msk               (0x0fUL << NT_CMP_REFCTL1_VREF_Pos)                     /*!< NT_CMP REFCTL1: VREF Mask               */
#define NT_CMP_REFCTL1_RNG_Pos                8                                                       /*!< NT_CMP REFCTL1: RNG Position            */
#define NT_CMP_REFCTL1_RNG_Msk                (0x01UL << NT_CMP_REFCTL1_RNG_Pos)                      /*!< NT_CMP REFCTL1: RNG Mask                */
#define NT_CMP_REFCTL1_EN_Pos                 9                                                       /*!< NT_CMP REFCTL1: EN Position             */
#define NT_CMP_REFCTL1_EN_Msk                 (0x01UL << NT_CMP_REFCTL1_EN_Pos)                       /*!< NT_CMP REFCTL1: EN Mask                 */

/* -------------------------------  NT_CMP_REFCTL2  ------------------------------- */
#define NT_CMP_REFCTL2_VREF_Pos               0                                                       /*!< NT_CMP REFCTL2: VREF Position           */
#define NT_CMP_REFCTL2_VREF_Msk               (0x0fUL << NT_CMP_REFCTL2_VREF_Pos)                     /*!< NT_CMP REFCTL2: VREF Mask               */
#define NT_CMP_REFCTL2_RNG_Pos                8                                                       /*!< NT_CMP REFCTL2: RNG Position            */
#define NT_CMP_REFCTL2_RNG_Msk                (0x01UL << NT_CMP_REFCTL2_RNG_Pos)                      /*!< NT_CMP REFCTL2: RNG Mask                */
#define NT_CMP_REFCTL2_EN_Pos                 9                                                       /*!< NT_CMP REFCTL2: EN Position             */
#define NT_CMP_REFCTL2_EN_Msk                 (0x01UL << NT_CMP_REFCTL2_EN_Pos)                       /*!< NT_CMP REFCTL2: EN Mask                 */

/* --------------------------------  NT_CMP_STAT0  -------------------------------- */
#define NT_CMP_STAT0_OVAL_Pos                 1                                                       /*!< NT_CMP STAT0: OVAL Position             */
#define NT_CMP_STAT0_OVAL_Msk                 (0x01UL << NT_CMP_STAT0_OVAL_Pos)                       /*!< NT_CMP STAT0: OVAL Mask                 */

/* ---------------------------------  NT_CMP_CTL0  -------------------------------- */
#define NT_CMP_CTL0_CEN_Pos                   0                                                       /*!< NT_CMP CTL0: CEN Position               */
#define NT_CMP_CTL0_CEN_Msk                   (0x01UL << NT_CMP_CTL0_CEN_Pos)                         /*!< NT_CMP CTL0: CEN Mask                   */
#define NT_CMP_CTL0_CINV_Pos                  1                                                       /*!< NT_CMP CTL0: CINV Position              */
#define NT_CMP_CTL0_CINV_Msk                  (0x01UL << NT_CMP_CTL0_CINV_Pos)                        /*!< NT_CMP CTL0: CINV Mask                  */
#define NT_CMP_CTL0_ISEN_Pos                  2                                                       /*!< NT_CMP CTL0: ISEN Position              */
#define NT_CMP_CTL0_ISEN_Msk                  (0x03UL << NT_CMP_CTL0_ISEN_Pos)                        /*!< NT_CMP CTL0: ISEN Mask                  */
#define NT_CMP_CTL0_ISVAL_Pos                 4                                                       /*!< NT_CMP CTL0: ISVAL Position             */
#define NT_CMP_CTL0_ISVAL_Msk                 (0x01UL << NT_CMP_CTL0_ISVAL_Pos)                       /*!< NT_CMP CTL0: ISVAL Mask                 */
#define NT_CMP_CTL0_TSEN_Pos                  5                                                       /*!< NT_CMP CTL0: TSEN Position              */
#define NT_CMP_CTL0_TSEN_Msk                  (0x03UL << NT_CMP_CTL0_TSEN_Pos)                        /*!< NT_CMP CTL0: TSEN Mask                  */
#define NT_CMP_CTL0_TSVAL_Pos                 7                                                       /*!< NT_CMP CTL0: TSVAL Position             */
#define NT_CMP_CTL0_TSVAL_Msk                 (0x01UL << NT_CMP_CTL0_TSVAL_Pos)                       /*!< NT_CMP CTL0: TSVAL Mask                 */
#define NT_CMP_CTL0_ASRCP_Pos                 8                                                       /*!< NT_CMP CTL0: ASRCP Position             */
#define NT_CMP_CTL0_ASRCP_Msk                 (0x03UL << NT_CMP_CTL0_ASRCP_Pos)                       /*!< NT_CMP CTL0: ASRCP Mask                 */
#define NT_CMP_CTL0_TOEN_Pos                  10                                                      /*!< NT_CMP CTL0: TOEN Position              */
#define NT_CMP_CTL0_TOEN_Msk                  (0x01UL << NT_CMP_CTL0_TOEN_Pos)                        /*!< NT_CMP CTL0: TOEN Mask                  */

/* --------------------------------  NT_CMP_STAT1  -------------------------------- */
#define NT_CMP_STAT1_OVAL_Pos                 1                                                       /*!< NT_CMP STAT1: OVAL Position             */
#define NT_CMP_STAT1_OVAL_Msk                 (0x01UL << NT_CMP_STAT1_OVAL_Pos)                       /*!< NT_CMP STAT1: OVAL Mask                 */

/* ---------------------------------  NT_CMP_CTL1  -------------------------------- */
#define NT_CMP_CTL1_CEN_Pos                   0                                                       /*!< NT_CMP CTL1: CEN Position               */
#define NT_CMP_CTL1_CEN_Msk                   (0x01UL << NT_CMP_CTL1_CEN_Pos)                         /*!< NT_CMP CTL1: CEN Mask                   */
#define NT_CMP_CTL1_CINV_Pos                  1                                                       /*!< NT_CMP CTL1: CINV Position              */
#define NT_CMP_CTL1_CINV_Msk                  (0x01UL << NT_CMP_CTL1_CINV_Pos)                        /*!< NT_CMP CTL1: CINV Mask                  */
#define NT_CMP_CTL1_ISEN_Pos                  2                                                       /*!< NT_CMP CTL1: ISEN Position              */
#define NT_CMP_CTL1_ISEN_Msk                  (0x03UL << NT_CMP_CTL1_ISEN_Pos)                        /*!< NT_CMP CTL1: ISEN Mask                  */
#define NT_CMP_CTL1_ISVAL_Pos                 4                                                       /*!< NT_CMP CTL1: ISVAL Position             */
#define NT_CMP_CTL1_ISVAL_Msk                 (0x01UL << NT_CMP_CTL1_ISVAL_Pos)                       /*!< NT_CMP CTL1: ISVAL Mask                 */
#define NT_CMP_CTL1_TSEN_Pos                  5                                                       /*!< NT_CMP CTL1: TSEN Position              */
#define NT_CMP_CTL1_TSEN_Msk                  (0x03UL << NT_CMP_CTL1_TSEN_Pos)                        /*!< NT_CMP CTL1: TSEN Mask                  */
#define NT_CMP_CTL1_TSVAL_Pos                 7                                                       /*!< NT_CMP CTL1: TSVAL Position             */
#define NT_CMP_CTL1_TSVAL_Msk                 (0x01UL << NT_CMP_CTL1_TSVAL_Pos)                       /*!< NT_CMP CTL1: TSVAL Mask                 */
#define NT_CMP_CTL1_ASRCP_Pos                 8                                                       /*!< NT_CMP CTL1: ASRCP Position             */
#define NT_CMP_CTL1_ASRCP_Msk                 (0x03UL << NT_CMP_CTL1_ASRCP_Pos)                       /*!< NT_CMP CTL1: ASRCP Mask                 */
#define NT_CMP_CTL1_TOEN_Pos                  10                                                      /*!< NT_CMP CTL1: TOEN Position              */
#define NT_CMP_CTL1_TOEN_Msk                  (0x01UL << NT_CMP_CTL1_TOEN_Pos)                        /*!< NT_CMP CTL1: TOEN Mask                  */

/* --------------------------------  NT_CMP_STAT2  -------------------------------- */
#define NT_CMP_STAT2_OVAL_Pos                 1                                                       /*!< NT_CMP STAT2: OVAL Position             */
#define NT_CMP_STAT2_OVAL_Msk                 (0x01UL << NT_CMP_STAT2_OVAL_Pos)                       /*!< NT_CMP STAT2: OVAL Mask                 */

/* ---------------------------------  NT_CMP_CTL2  -------------------------------- */
#define NT_CMP_CTL2_CEN_Pos                   0                                                       /*!< NT_CMP CTL2: CEN Position               */
#define NT_CMP_CTL2_CEN_Msk                   (0x01UL << NT_CMP_CTL2_CEN_Pos)                         /*!< NT_CMP CTL2: CEN Mask                   */
#define NT_CMP_CTL2_CINV_Pos                  1                                                       /*!< NT_CMP CTL2: CINV Position              */
#define NT_CMP_CTL2_CINV_Msk                  (0x01UL << NT_CMP_CTL2_CINV_Pos)                        /*!< NT_CMP CTL2: CINV Mask                  */
#define NT_CMP_CTL2_ISEN_Pos                  2                                                       /*!< NT_CMP CTL2: ISEN Position              */
#define NT_CMP_CTL2_ISEN_Msk                  (0x03UL << NT_CMP_CTL2_ISEN_Pos)                        /*!< NT_CMP CTL2: ISEN Mask                  */
#define NT_CMP_CTL2_ISVAL_Pos                 4                                                       /*!< NT_CMP CTL2: ISVAL Position             */
#define NT_CMP_CTL2_ISVAL_Msk                 (0x01UL << NT_CMP_CTL2_ISVAL_Pos)                       /*!< NT_CMP CTL2: ISVAL Mask                 */
#define NT_CMP_CTL2_TSEN_Pos                  5                                                       /*!< NT_CMP CTL2: TSEN Position              */
#define NT_CMP_CTL2_TSEN_Msk                  (0x03UL << NT_CMP_CTL2_TSEN_Pos)                        /*!< NT_CMP CTL2: TSEN Mask                  */
#define NT_CMP_CTL2_TSVAL_Pos                 7                                                       /*!< NT_CMP CTL2: TSVAL Position             */
#define NT_CMP_CTL2_TSVAL_Msk                 (0x01UL << NT_CMP_CTL2_TSVAL_Pos)                       /*!< NT_CMP CTL2: TSVAL Mask                 */
#define NT_CMP_CTL2_ASRCP_Pos                 8                                                       /*!< NT_CMP CTL2: ASRCP Position             */
#define NT_CMP_CTL2_ASRCP_Msk                 (0x03UL << NT_CMP_CTL2_ASRCP_Pos)                       /*!< NT_CMP CTL2: ASRCP Mask                 */
#define NT_CMP_CTL2_TOEN_Pos                  10                                                      /*!< NT_CMP CTL2: TOEN Position              */
#define NT_CMP_CTL2_TOEN_Msk                  (0x01UL << NT_CMP_CTL2_TOEN_Pos)                        /*!< NT_CMP CTL2: TOEN Mask                  */

/* --------------------------------  NT_CMP_POWER  -------------------------------- */
#define NT_CMP_POWER_PWU_Pos                  0                                                       /*!< NT_CMP POWER: PWU Position              */
#define NT_CMP_POWER_PWU_Msk                  (0x01UL << NT_CMP_POWER_PWU_Pos)                        /*!< NT_CMP POWER: PWU Mask                  */


/* ================================================================================ */
/* ================        struct 'NT_SPI0' Position & Mask        ================ */
/* ================================================================================ */


/* -------------------------------  NT_SPI0_SPI_CR0  ------------------------------ */
#define NT_SPI0_SPI_CR0_DSS_Pos               0                                                       /*!< NT_SPI0 SPI_CR0: DSS Position           */
#define NT_SPI0_SPI_CR0_DSS_Msk               (0x0fUL << NT_SPI0_SPI_CR0_DSS_Pos)                     /*!< NT_SPI0 SPI_CR0: DSS Mask               */
#define NT_SPI0_SPI_CR0_FRF_Pos               4                                                       /*!< NT_SPI0 SPI_CR0: FRF Position           */
#define NT_SPI0_SPI_CR0_FRF_Msk               (0x03UL << NT_SPI0_SPI_CR0_FRF_Pos)                     /*!< NT_SPI0 SPI_CR0: FRF Mask               */
#define NT_SPI0_SPI_CR0_SPO_Pos               6                                                       /*!< NT_SPI0 SPI_CR0: SPO Position           */
#define NT_SPI0_SPI_CR0_SPO_Msk               (0x01UL << NT_SPI0_SPI_CR0_SPO_Pos)                     /*!< NT_SPI0 SPI_CR0: SPO Mask               */
#define NT_SPI0_SPI_CR0_SPH_Pos               7                                                       /*!< NT_SPI0 SPI_CR0: SPH Position           */
#define NT_SPI0_SPI_CR0_SPH_Msk               (0x01UL << NT_SPI0_SPI_CR0_SPH_Pos)                     /*!< NT_SPI0 SPI_CR0: SPH Mask               */
#define NT_SPI0_SPI_CR0_SCR_Pos               8                                                       /*!< NT_SPI0 SPI_CR0: SCR Position           */
#define NT_SPI0_SPI_CR0_SCR_Msk               (0x000000ffUL << NT_SPI0_SPI_CR0_SCR_Pos)               /*!< NT_SPI0 SPI_CR0: SCR Mask               */

/* -------------------------------  NT_SPI0_SPI_CR1  ------------------------------ */
#define NT_SPI0_SPI_CR1_SSE_Pos               1                                                       /*!< NT_SPI0 SPI_CR1: SSE Position           */
#define NT_SPI0_SPI_CR1_SSE_Msk               (0x01UL << NT_SPI0_SPI_CR1_SSE_Pos)                     /*!< NT_SPI0 SPI_CR1: SSE Mask               */
#define NT_SPI0_SPI_CR1_MS_Pos                2                                                       /*!< NT_SPI0 SPI_CR1: MS Position            */
#define NT_SPI0_SPI_CR1_MS_Msk                (0x01UL << NT_SPI0_SPI_CR1_MS_Pos)                      /*!< NT_SPI0 SPI_CR1: MS Mask                */
#define NT_SPI0_SPI_CR1_SOD_Pos               3                                                       /*!< NT_SPI0 SPI_CR1: SOD Position           */
#define NT_SPI0_SPI_CR1_SOD_Msk               (0x01UL << NT_SPI0_SPI_CR1_SOD_Pos)                     /*!< NT_SPI0 SPI_CR1: SOD Mask               */

/* -------------------------------  NT_SPI0_SPI_DR  ------------------------------- */
#define NT_SPI0_SPI_DR_DATA_Pos               0                                                       /*!< NT_SPI0 SPI_DR: DATA Position           */
#define NT_SPI0_SPI_DR_DATA_Msk               (0x0000ffffUL << NT_SPI0_SPI_DR_DATA_Pos)               /*!< NT_SPI0 SPI_DR: DATA Mask               */

/* -------------------------------  NT_SPI0_SPI_SR  ------------------------------- */
#define NT_SPI0_SPI_SR_TFE_Pos                0                                                       /*!< NT_SPI0 SPI_SR: TFE Position            */
#define NT_SPI0_SPI_SR_TFE_Msk                (0x01UL << NT_SPI0_SPI_SR_TFE_Pos)                      /*!< NT_SPI0 SPI_SR: TFE Mask                */
#define NT_SPI0_SPI_SR_TNF_Pos                1                                                       /*!< NT_SPI0 SPI_SR: TNF Position            */
#define NT_SPI0_SPI_SR_TNF_Msk                (0x01UL << NT_SPI0_SPI_SR_TNF_Pos)                      /*!< NT_SPI0 SPI_SR: TNF Mask                */
#define NT_SPI0_SPI_SR_RNE_Pos                2                                                       /*!< NT_SPI0 SPI_SR: RNE Position            */
#define NT_SPI0_SPI_SR_RNE_Msk                (0x01UL << NT_SPI0_SPI_SR_RNE_Pos)                      /*!< NT_SPI0 SPI_SR: RNE Mask                */
#define NT_SPI0_SPI_SR_RFF_Pos                3                                                       /*!< NT_SPI0 SPI_SR: RFF Position            */
#define NT_SPI0_SPI_SR_RFF_Msk                (0x01UL << NT_SPI0_SPI_SR_RFF_Pos)                      /*!< NT_SPI0 SPI_SR: RFF Mask                */
#define NT_SPI0_SPI_SR_BSY_Pos                4                                                       /*!< NT_SPI0 SPI_SR: BSY Position            */
#define NT_SPI0_SPI_SR_BSY_Msk                (0x01UL << NT_SPI0_SPI_SR_BSY_Pos)                      /*!< NT_SPI0 SPI_SR: BSY Mask                */

/* ------------------------------  NT_SPI0_SPI_CPSR  ------------------------------ */
#define NT_SPI0_SPI_CPSR_CPSDVSR_Pos          0                                                       /*!< NT_SPI0 SPI_CPSR: CPSDVSR Position      */
#define NT_SPI0_SPI_CPSR_CPSDVSR_Msk          (0x000000ffUL << NT_SPI0_SPI_CPSR_CPSDVSR_Pos)          /*!< NT_SPI0 SPI_CPSR: CPSDVSR Mask          */

/* ------------------------------  NT_SPI0_SPI_IMSC  ------------------------------ */
#define NT_SPI0_SPI_IMSC_RORIM_Pos            0                                                       /*!< NT_SPI0 SPI_IMSC: RORIM Position        */
#define NT_SPI0_SPI_IMSC_RORIM_Msk            (0x01UL << NT_SPI0_SPI_IMSC_RORIM_Pos)                  /*!< NT_SPI0 SPI_IMSC: RORIM Mask            */
#define NT_SPI0_SPI_IMSC_RTIM_Pos             1                                                       /*!< NT_SPI0 SPI_IMSC: RTIM Position         */
#define NT_SPI0_SPI_IMSC_RTIM_Msk             (0x01UL << NT_SPI0_SPI_IMSC_RTIM_Pos)                   /*!< NT_SPI0 SPI_IMSC: RTIM Mask             */
#define NT_SPI0_SPI_IMSC_RXIM_Pos             2                                                       /*!< NT_SPI0 SPI_IMSC: RXIM Position         */
#define NT_SPI0_SPI_IMSC_RXIM_Msk             (0x01UL << NT_SPI0_SPI_IMSC_RXIM_Pos)                   /*!< NT_SPI0 SPI_IMSC: RXIM Mask             */
#define NT_SPI0_SPI_IMSC_TXIM_Pos             3                                                       /*!< NT_SPI0 SPI_IMSC: TXIM Position         */
#define NT_SPI0_SPI_IMSC_TXIM_Msk             (0x01UL << NT_SPI0_SPI_IMSC_TXIM_Pos)                   /*!< NT_SPI0 SPI_IMSC: TXIM Mask             */

/* -------------------------------  NT_SPI0_SPI_RIS  ------------------------------ */
#define NT_SPI0_SPI_RIS_RORRIS_Pos            0                                                       /*!< NT_SPI0 SPI_RIS: RORRIS Position        */
#define NT_SPI0_SPI_RIS_RORRIS_Msk            (0x01UL << NT_SPI0_SPI_RIS_RORRIS_Pos)                  /*!< NT_SPI0 SPI_RIS: RORRIS Mask            */
#define NT_SPI0_SPI_RIS_RTRIS_Pos             1                                                       /*!< NT_SPI0 SPI_RIS: RTRIS Position         */
#define NT_SPI0_SPI_RIS_RTRIS_Msk             (0x01UL << NT_SPI0_SPI_RIS_RTRIS_Pos)                   /*!< NT_SPI0 SPI_RIS: RTRIS Mask             */
#define NT_SPI0_SPI_RIS_RXRIS_Pos             2                                                       /*!< NT_SPI0 SPI_RIS: RXRIS Position         */
#define NT_SPI0_SPI_RIS_RXRIS_Msk             (0x01UL << NT_SPI0_SPI_RIS_RXRIS_Pos)                   /*!< NT_SPI0 SPI_RIS: RXRIS Mask             */
#define NT_SPI0_SPI_RIS_TXRIS_Pos             3                                                       /*!< NT_SPI0 SPI_RIS: TXRIS Position         */
#define NT_SPI0_SPI_RIS_TXRIS_Msk             (0x01UL << NT_SPI0_SPI_RIS_TXRIS_Pos)                   /*!< NT_SPI0 SPI_RIS: TXRIS Mask             */

/* -------------------------------  NT_SPI0_SPI_MIS  ------------------------------ */
#define NT_SPI0_SPI_MIS_RORRIS_Pos            0                                                       /*!< NT_SPI0 SPI_MIS: RORRIS Position        */
#define NT_SPI0_SPI_MIS_RORRIS_Msk            (0x01UL << NT_SPI0_SPI_MIS_RORRIS_Pos)                  /*!< NT_SPI0 SPI_MIS: RORRIS Mask            */
#define NT_SPI0_SPI_MIS_RTRIS_Pos             1                                                       /*!< NT_SPI0 SPI_MIS: RTRIS Position         */
#define NT_SPI0_SPI_MIS_RTRIS_Msk             (0x01UL << NT_SPI0_SPI_MIS_RTRIS_Pos)                   /*!< NT_SPI0 SPI_MIS: RTRIS Mask             */
#define NT_SPI0_SPI_MIS_RXRIS_Pos             2                                                       /*!< NT_SPI0 SPI_MIS: RXRIS Position         */
#define NT_SPI0_SPI_MIS_RXRIS_Msk             (0x01UL << NT_SPI0_SPI_MIS_RXRIS_Pos)                   /*!< NT_SPI0 SPI_MIS: RXRIS Mask             */
#define NT_SPI0_SPI_MIS_TXRIS_Pos             3                                                       /*!< NT_SPI0 SPI_MIS: TXRIS Position         */
#define NT_SPI0_SPI_MIS_TXRIS_Msk             (0x01UL << NT_SPI0_SPI_MIS_TXRIS_Pos)                   /*!< NT_SPI0 SPI_MIS: TXRIS Mask             */

/* -------------------------------  NT_SPI0_SPI_ICR  ------------------------------ */
#define NT_SPI0_SPI_ICR_RORIC_Pos             0                                                       /*!< NT_SPI0 SPI_ICR: RORIC Position         */
#define NT_SPI0_SPI_ICR_RORIC_Msk             (0x01UL << NT_SPI0_SPI_ICR_RORIC_Pos)                   /*!< NT_SPI0 SPI_ICR: RORIC Mask             */
#define NT_SPI0_SPI_ICR_RTIC_Pos              1                                                       /*!< NT_SPI0 SPI_ICR: RTIC Position          */
#define NT_SPI0_SPI_ICR_RTIC_Msk              (0x01UL << NT_SPI0_SPI_ICR_RTIC_Pos)                    /*!< NT_SPI0 SPI_ICR: RTIC Mask              */

/* ------------------------------  NT_SPI0_SPI_DMACR  ----------------------------- */
#define NT_SPI0_SPI_DMACR_RXDMAE_Pos          0                                                       /*!< NT_SPI0 SPI_DMACR: RXDMAE Position      */
#define NT_SPI0_SPI_DMACR_RXDMAE_Msk          (0x01UL << NT_SPI0_SPI_DMACR_RXDMAE_Pos)                /*!< NT_SPI0 SPI_DMACR: RXDMAE Mask          */
#define NT_SPI0_SPI_DMACR_TXDMAE_Pos          1                                                       /*!< NT_SPI0 SPI_DMACR: TXDMAE Position      */
#define NT_SPI0_SPI_DMACR_TXDMAE_Msk          (0x01UL << NT_SPI0_SPI_DMACR_TXDMAE_Pos)                /*!< NT_SPI0 SPI_DMACR: TXDMAE Mask          */


/* ================================================================================ */
/* ================        struct 'NT_SPI1' Position & Mask        ================ */
/* ================================================================================ */


/* -------------------------------  NT_SPI1_SPI_CR0  ------------------------------ */
#define NT_SPI1_SPI_CR0_DSS_Pos               0                                                       /*!< NT_SPI1 SPI_CR0: DSS Position           */
#define NT_SPI1_SPI_CR0_DSS_Msk               (0x0fUL << NT_SPI1_SPI_CR0_DSS_Pos)                     /*!< NT_SPI1 SPI_CR0: DSS Mask               */
#define NT_SPI1_SPI_CR0_FRF_Pos               4                                                       /*!< NT_SPI1 SPI_CR0: FRF Position           */
#define NT_SPI1_SPI_CR0_FRF_Msk               (0x03UL << NT_SPI1_SPI_CR0_FRF_Pos)                     /*!< NT_SPI1 SPI_CR0: FRF Mask               */
#define NT_SPI1_SPI_CR0_SPO_Pos               6                                                       /*!< NT_SPI1 SPI_CR0: SPO Position           */
#define NT_SPI1_SPI_CR0_SPO_Msk               (0x01UL << NT_SPI1_SPI_CR0_SPO_Pos)                     /*!< NT_SPI1 SPI_CR0: SPO Mask               */
#define NT_SPI1_SPI_CR0_SPH_Pos               7                                                       /*!< NT_SPI1 SPI_CR0: SPH Position           */
#define NT_SPI1_SPI_CR0_SPH_Msk               (0x01UL << NT_SPI1_SPI_CR0_SPH_Pos)                     /*!< NT_SPI1 SPI_CR0: SPH Mask               */
#define NT_SPI1_SPI_CR0_SCR_Pos               8                                                       /*!< NT_SPI1 SPI_CR0: SCR Position           */
#define NT_SPI1_SPI_CR0_SCR_Msk               (0x000000ffUL << NT_SPI1_SPI_CR0_SCR_Pos)               /*!< NT_SPI1 SPI_CR0: SCR Mask               */

/* -------------------------------  NT_SPI1_SPI_CR1  ------------------------------ */
#define NT_SPI1_SPI_CR1_SSE_Pos               1                                                       /*!< NT_SPI1 SPI_CR1: SSE Position           */
#define NT_SPI1_SPI_CR1_SSE_Msk               (0x01UL << NT_SPI1_SPI_CR1_SSE_Pos)                     /*!< NT_SPI1 SPI_CR1: SSE Mask               */
#define NT_SPI1_SPI_CR1_MS_Pos                2                                                       /*!< NT_SPI1 SPI_CR1: MS Position            */
#define NT_SPI1_SPI_CR1_MS_Msk                (0x01UL << NT_SPI1_SPI_CR1_MS_Pos)                      /*!< NT_SPI1 SPI_CR1: MS Mask                */
#define NT_SPI1_SPI_CR1_SOD_Pos               3                                                       /*!< NT_SPI1 SPI_CR1: SOD Position           */
#define NT_SPI1_SPI_CR1_SOD_Msk               (0x01UL << NT_SPI1_SPI_CR1_SOD_Pos)                     /*!< NT_SPI1 SPI_CR1: SOD Mask               */

/* -------------------------------  NT_SPI1_SPI_DR  ------------------------------- */
#define NT_SPI1_SPI_DR_DATA_Pos               0                                                       /*!< NT_SPI1 SPI_DR: DATA Position           */
#define NT_SPI1_SPI_DR_DATA_Msk               (0x0000ffffUL << NT_SPI1_SPI_DR_DATA_Pos)               /*!< NT_SPI1 SPI_DR: DATA Mask               */

/* -------------------------------  NT_SPI1_SPI_SR  ------------------------------- */
#define NT_SPI1_SPI_SR_TFE_Pos                0                                                       /*!< NT_SPI1 SPI_SR: TFE Position            */
#define NT_SPI1_SPI_SR_TFE_Msk                (0x01UL << NT_SPI1_SPI_SR_TFE_Pos)                      /*!< NT_SPI1 SPI_SR: TFE Mask                */
#define NT_SPI1_SPI_SR_TNF_Pos                1                                                       /*!< NT_SPI1 SPI_SR: TNF Position            */
#define NT_SPI1_SPI_SR_TNF_Msk                (0x01UL << NT_SPI1_SPI_SR_TNF_Pos)                      /*!< NT_SPI1 SPI_SR: TNF Mask                */
#define NT_SPI1_SPI_SR_RNE_Pos                2                                                       /*!< NT_SPI1 SPI_SR: RNE Position            */
#define NT_SPI1_SPI_SR_RNE_Msk                (0x01UL << NT_SPI1_SPI_SR_RNE_Pos)                      /*!< NT_SPI1 SPI_SR: RNE Mask                */
#define NT_SPI1_SPI_SR_RFF_Pos                3                                                       /*!< NT_SPI1 SPI_SR: RFF Position            */
#define NT_SPI1_SPI_SR_RFF_Msk                (0x01UL << NT_SPI1_SPI_SR_RFF_Pos)                      /*!< NT_SPI1 SPI_SR: RFF Mask                */
#define NT_SPI1_SPI_SR_BSY_Pos                4                                                       /*!< NT_SPI1 SPI_SR: BSY Position            */
#define NT_SPI1_SPI_SR_BSY_Msk                (0x01UL << NT_SPI1_SPI_SR_BSY_Pos)                      /*!< NT_SPI1 SPI_SR: BSY Mask                */

/* ------------------------------  NT_SPI1_SPI_CPSR  ------------------------------ */
#define NT_SPI1_SPI_CPSR_CPSDVSR_Pos          0                                                       /*!< NT_SPI1 SPI_CPSR: CPSDVSR Position      */
#define NT_SPI1_SPI_CPSR_CPSDVSR_Msk          (0x000000ffUL << NT_SPI1_SPI_CPSR_CPSDVSR_Pos)          /*!< NT_SPI1 SPI_CPSR: CPSDVSR Mask          */

/* ------------------------------  NT_SPI1_SPI_IMSC  ------------------------------ */
#define NT_SPI1_SPI_IMSC_RORIM_Pos            0                                                       /*!< NT_SPI1 SPI_IMSC: RORIM Position        */
#define NT_SPI1_SPI_IMSC_RORIM_Msk            (0x01UL << NT_SPI1_SPI_IMSC_RORIM_Pos)                  /*!< NT_SPI1 SPI_IMSC: RORIM Mask            */
#define NT_SPI1_SPI_IMSC_RTIM_Pos             1                                                       /*!< NT_SPI1 SPI_IMSC: RTIM Position         */
#define NT_SPI1_SPI_IMSC_RTIM_Msk             (0x01UL << NT_SPI1_SPI_IMSC_RTIM_Pos)                   /*!< NT_SPI1 SPI_IMSC: RTIM Mask             */
#define NT_SPI1_SPI_IMSC_RXIM_Pos             2                                                       /*!< NT_SPI1 SPI_IMSC: RXIM Position         */
#define NT_SPI1_SPI_IMSC_RXIM_Msk             (0x01UL << NT_SPI1_SPI_IMSC_RXIM_Pos)                   /*!< NT_SPI1 SPI_IMSC: RXIM Mask             */
#define NT_SPI1_SPI_IMSC_TXIM_Pos             3                                                       /*!< NT_SPI1 SPI_IMSC: TXIM Position         */
#define NT_SPI1_SPI_IMSC_TXIM_Msk             (0x01UL << NT_SPI1_SPI_IMSC_TXIM_Pos)                   /*!< NT_SPI1 SPI_IMSC: TXIM Mask             */

/* -------------------------------  NT_SPI1_SPI_RIS  ------------------------------ */
#define NT_SPI1_SPI_RIS_RORRIS_Pos            0                                                       /*!< NT_SPI1 SPI_RIS: RORRIS Position        */
#define NT_SPI1_SPI_RIS_RORRIS_Msk            (0x01UL << NT_SPI1_SPI_RIS_RORRIS_Pos)                  /*!< NT_SPI1 SPI_RIS: RORRIS Mask            */
#define NT_SPI1_SPI_RIS_RTRIS_Pos             1                                                       /*!< NT_SPI1 SPI_RIS: RTRIS Position         */
#define NT_SPI1_SPI_RIS_RTRIS_Msk             (0x01UL << NT_SPI1_SPI_RIS_RTRIS_Pos)                   /*!< NT_SPI1 SPI_RIS: RTRIS Mask             */
#define NT_SPI1_SPI_RIS_RXRIS_Pos             2                                                       /*!< NT_SPI1 SPI_RIS: RXRIS Position         */
#define NT_SPI1_SPI_RIS_RXRIS_Msk             (0x01UL << NT_SPI1_SPI_RIS_RXRIS_Pos)                   /*!< NT_SPI1 SPI_RIS: RXRIS Mask             */
#define NT_SPI1_SPI_RIS_TXRIS_Pos             3                                                       /*!< NT_SPI1 SPI_RIS: TXRIS Position         */
#define NT_SPI1_SPI_RIS_TXRIS_Msk             (0x01UL << NT_SPI1_SPI_RIS_TXRIS_Pos)                   /*!< NT_SPI1 SPI_RIS: TXRIS Mask             */

/* -------------------------------  NT_SPI1_SPI_MIS  ------------------------------ */
#define NT_SPI1_SPI_MIS_RORRIS_Pos            0                                                       /*!< NT_SPI1 SPI_MIS: RORRIS Position        */
#define NT_SPI1_SPI_MIS_RORRIS_Msk            (0x01UL << NT_SPI1_SPI_MIS_RORRIS_Pos)                  /*!< NT_SPI1 SPI_MIS: RORRIS Mask            */
#define NT_SPI1_SPI_MIS_RTRIS_Pos             1                                                       /*!< NT_SPI1 SPI_MIS: RTRIS Position         */
#define NT_SPI1_SPI_MIS_RTRIS_Msk             (0x01UL << NT_SPI1_SPI_MIS_RTRIS_Pos)                   /*!< NT_SPI1 SPI_MIS: RTRIS Mask             */
#define NT_SPI1_SPI_MIS_RXRIS_Pos             2                                                       /*!< NT_SPI1 SPI_MIS: RXRIS Position         */
#define NT_SPI1_SPI_MIS_RXRIS_Msk             (0x01UL << NT_SPI1_SPI_MIS_RXRIS_Pos)                   /*!< NT_SPI1 SPI_MIS: RXRIS Mask             */
#define NT_SPI1_SPI_MIS_TXRIS_Pos             3                                                       /*!< NT_SPI1 SPI_MIS: TXRIS Position         */
#define NT_SPI1_SPI_MIS_TXRIS_Msk             (0x01UL << NT_SPI1_SPI_MIS_TXRIS_Pos)                   /*!< NT_SPI1 SPI_MIS: TXRIS Mask             */

/* -------------------------------  NT_SPI1_SPI_ICR  ------------------------------ */
#define NT_SPI1_SPI_ICR_RORIC_Pos             0                                                       /*!< NT_SPI1 SPI_ICR: RORIC Position         */
#define NT_SPI1_SPI_ICR_RORIC_Msk             (0x01UL << NT_SPI1_SPI_ICR_RORIC_Pos)                   /*!< NT_SPI1 SPI_ICR: RORIC Mask             */
#define NT_SPI1_SPI_ICR_RTIC_Pos              1                                                       /*!< NT_SPI1 SPI_ICR: RTIC Position          */
#define NT_SPI1_SPI_ICR_RTIC_Msk              (0x01UL << NT_SPI1_SPI_ICR_RTIC_Pos)                    /*!< NT_SPI1 SPI_ICR: RTIC Mask              */

/* ------------------------------  NT_SPI1_SPI_DMACR  ----------------------------- */
#define NT_SPI1_SPI_DMACR_RXDMAE_Pos          0                                                       /*!< NT_SPI1 SPI_DMACR: RXDMAE Position      */
#define NT_SPI1_SPI_DMACR_RXDMAE_Msk          (0x01UL << NT_SPI1_SPI_DMACR_RXDMAE_Pos)                /*!< NT_SPI1 SPI_DMACR: RXDMAE Mask          */
#define NT_SPI1_SPI_DMACR_TXDMAE_Pos          1                                                       /*!< NT_SPI1 SPI_DMACR: TXDMAE Position      */
#define NT_SPI1_SPI_DMACR_TXDMAE_Msk          (0x01UL << NT_SPI1_SPI_DMACR_TXDMAE_Pos)                /*!< NT_SPI1 SPI_DMACR: TXDMAE Mask          */


/* ================================================================================ */
/* ================        struct 'NT_SPI2' Position & Mask        ================ */
/* ================================================================================ */


/* -------------------------------  NT_SPI2_SPI_CR0  ------------------------------ */
#define NT_SPI2_SPI_CR0_DSS_Pos               0                                                       /*!< NT_SPI2 SPI_CR0: DSS Position           */
#define NT_SPI2_SPI_CR0_DSS_Msk               (0x0fUL << NT_SPI2_SPI_CR0_DSS_Pos)                     /*!< NT_SPI2 SPI_CR0: DSS Mask               */
#define NT_SPI2_SPI_CR0_FRF_Pos               4                                                       /*!< NT_SPI2 SPI_CR0: FRF Position           */
#define NT_SPI2_SPI_CR0_FRF_Msk               (0x03UL << NT_SPI2_SPI_CR0_FRF_Pos)                     /*!< NT_SPI2 SPI_CR0: FRF Mask               */
#define NT_SPI2_SPI_CR0_SPO_Pos               6                                                       /*!< NT_SPI2 SPI_CR0: SPO Position           */
#define NT_SPI2_SPI_CR0_SPO_Msk               (0x01UL << NT_SPI2_SPI_CR0_SPO_Pos)                     /*!< NT_SPI2 SPI_CR0: SPO Mask               */
#define NT_SPI2_SPI_CR0_SPH_Pos               7                                                       /*!< NT_SPI2 SPI_CR0: SPH Position           */
#define NT_SPI2_SPI_CR0_SPH_Msk               (0x01UL << NT_SPI2_SPI_CR0_SPH_Pos)                     /*!< NT_SPI2 SPI_CR0: SPH Mask               */
#define NT_SPI2_SPI_CR0_SCR_Pos               8                                                       /*!< NT_SPI2 SPI_CR0: SCR Position           */
#define NT_SPI2_SPI_CR0_SCR_Msk               (0x000000ffUL << NT_SPI2_SPI_CR0_SCR_Pos)               /*!< NT_SPI2 SPI_CR0: SCR Mask               */

/* -------------------------------  NT_SPI2_SPI_CR1  ------------------------------ */
#define NT_SPI2_SPI_CR1_SSE_Pos               1                                                       /*!< NT_SPI2 SPI_CR1: SSE Position           */
#define NT_SPI2_SPI_CR1_SSE_Msk               (0x01UL << NT_SPI2_SPI_CR1_SSE_Pos)                     /*!< NT_SPI2 SPI_CR1: SSE Mask               */
#define NT_SPI2_SPI_CR1_MS_Pos                2                                                       /*!< NT_SPI2 SPI_CR1: MS Position            */
#define NT_SPI2_SPI_CR1_MS_Msk                (0x01UL << NT_SPI2_SPI_CR1_MS_Pos)                      /*!< NT_SPI2 SPI_CR1: MS Mask                */
#define NT_SPI2_SPI_CR1_SOD_Pos               3                                                       /*!< NT_SPI2 SPI_CR1: SOD Position           */
#define NT_SPI2_SPI_CR1_SOD_Msk               (0x01UL << NT_SPI2_SPI_CR1_SOD_Pos)                     /*!< NT_SPI2 SPI_CR1: SOD Mask               */

/* -------------------------------  NT_SPI2_SPI_DR  ------------------------------- */
#define NT_SPI2_SPI_DR_DATA_Pos               0                                                       /*!< NT_SPI2 SPI_DR: DATA Position           */
#define NT_SPI2_SPI_DR_DATA_Msk               (0x0000ffffUL << NT_SPI2_SPI_DR_DATA_Pos)               /*!< NT_SPI2 SPI_DR: DATA Mask               */

/* -------------------------------  NT_SPI2_SPI_SR  ------------------------------- */
#define NT_SPI2_SPI_SR_TFE_Pos                0                                                       /*!< NT_SPI2 SPI_SR: TFE Position            */
#define NT_SPI2_SPI_SR_TFE_Msk                (0x01UL << NT_SPI2_SPI_SR_TFE_Pos)                      /*!< NT_SPI2 SPI_SR: TFE Mask                */
#define NT_SPI2_SPI_SR_TNF_Pos                1                                                       /*!< NT_SPI2 SPI_SR: TNF Position            */
#define NT_SPI2_SPI_SR_TNF_Msk                (0x01UL << NT_SPI2_SPI_SR_TNF_Pos)                      /*!< NT_SPI2 SPI_SR: TNF Mask                */
#define NT_SPI2_SPI_SR_RNE_Pos                2                                                       /*!< NT_SPI2 SPI_SR: RNE Position            */
#define NT_SPI2_SPI_SR_RNE_Msk                (0x01UL << NT_SPI2_SPI_SR_RNE_Pos)                      /*!< NT_SPI2 SPI_SR: RNE Mask                */
#define NT_SPI2_SPI_SR_RFF_Pos                3                                                       /*!< NT_SPI2 SPI_SR: RFF Position            */
#define NT_SPI2_SPI_SR_RFF_Msk                (0x01UL << NT_SPI2_SPI_SR_RFF_Pos)                      /*!< NT_SPI2 SPI_SR: RFF Mask                */
#define NT_SPI2_SPI_SR_BSY_Pos                4                                                       /*!< NT_SPI2 SPI_SR: BSY Position            */
#define NT_SPI2_SPI_SR_BSY_Msk                (0x01UL << NT_SPI2_SPI_SR_BSY_Pos)                      /*!< NT_SPI2 SPI_SR: BSY Mask                */

/* ------------------------------  NT_SPI2_SPI_CPSR  ------------------------------ */
#define NT_SPI2_SPI_CPSR_CPSDVSR_Pos          0                                                       /*!< NT_SPI2 SPI_CPSR: CPSDVSR Position      */
#define NT_SPI2_SPI_CPSR_CPSDVSR_Msk          (0x000000ffUL << NT_SPI2_SPI_CPSR_CPSDVSR_Pos)          /*!< NT_SPI2 SPI_CPSR: CPSDVSR Mask          */

/* ------------------------------  NT_SPI2_SPI_IMSC  ------------------------------ */
#define NT_SPI2_SPI_IMSC_RORIM_Pos            0                                                       /*!< NT_SPI2 SPI_IMSC: RORIM Position        */
#define NT_SPI2_SPI_IMSC_RORIM_Msk            (0x01UL << NT_SPI2_SPI_IMSC_RORIM_Pos)                  /*!< NT_SPI2 SPI_IMSC: RORIM Mask            */
#define NT_SPI2_SPI_IMSC_RTIM_Pos             1                                                       /*!< NT_SPI2 SPI_IMSC: RTIM Position         */
#define NT_SPI2_SPI_IMSC_RTIM_Msk             (0x01UL << NT_SPI2_SPI_IMSC_RTIM_Pos)                   /*!< NT_SPI2 SPI_IMSC: RTIM Mask             */
#define NT_SPI2_SPI_IMSC_RXIM_Pos             2                                                       /*!< NT_SPI2 SPI_IMSC: RXIM Position         */
#define NT_SPI2_SPI_IMSC_RXIM_Msk             (0x01UL << NT_SPI2_SPI_IMSC_RXIM_Pos)                   /*!< NT_SPI2 SPI_IMSC: RXIM Mask             */
#define NT_SPI2_SPI_IMSC_TXIM_Pos             3                                                       /*!< NT_SPI2 SPI_IMSC: TXIM Position         */
#define NT_SPI2_SPI_IMSC_TXIM_Msk             (0x01UL << NT_SPI2_SPI_IMSC_TXIM_Pos)                   /*!< NT_SPI2 SPI_IMSC: TXIM Mask             */

/* -------------------------------  NT_SPI2_SPI_RIS  ------------------------------ */
#define NT_SPI2_SPI_RIS_RORRIS_Pos            0                                                       /*!< NT_SPI2 SPI_RIS: RORRIS Position        */
#define NT_SPI2_SPI_RIS_RORRIS_Msk            (0x01UL << NT_SPI2_SPI_RIS_RORRIS_Pos)                  /*!< NT_SPI2 SPI_RIS: RORRIS Mask            */
#define NT_SPI2_SPI_RIS_RTRIS_Pos             1                                                       /*!< NT_SPI2 SPI_RIS: RTRIS Position         */
#define NT_SPI2_SPI_RIS_RTRIS_Msk             (0x01UL << NT_SPI2_SPI_RIS_RTRIS_Pos)                   /*!< NT_SPI2 SPI_RIS: RTRIS Mask             */
#define NT_SPI2_SPI_RIS_RXRIS_Pos             2                                                       /*!< NT_SPI2 SPI_RIS: RXRIS Position         */
#define NT_SPI2_SPI_RIS_RXRIS_Msk             (0x01UL << NT_SPI2_SPI_RIS_RXRIS_Pos)                   /*!< NT_SPI2 SPI_RIS: RXRIS Mask             */
#define NT_SPI2_SPI_RIS_TXRIS_Pos             3                                                       /*!< NT_SPI2 SPI_RIS: TXRIS Position         */
#define NT_SPI2_SPI_RIS_TXRIS_Msk             (0x01UL << NT_SPI2_SPI_RIS_TXRIS_Pos)                   /*!< NT_SPI2 SPI_RIS: TXRIS Mask             */

/* -------------------------------  NT_SPI2_SPI_MIS  ------------------------------ */
#define NT_SPI2_SPI_MIS_RORRIS_Pos            0                                                       /*!< NT_SPI2 SPI_MIS: RORRIS Position        */
#define NT_SPI2_SPI_MIS_RORRIS_Msk            (0x01UL << NT_SPI2_SPI_MIS_RORRIS_Pos)                  /*!< NT_SPI2 SPI_MIS: RORRIS Mask            */
#define NT_SPI2_SPI_MIS_RTRIS_Pos             1                                                       /*!< NT_SPI2 SPI_MIS: RTRIS Position         */
#define NT_SPI2_SPI_MIS_RTRIS_Msk             (0x01UL << NT_SPI2_SPI_MIS_RTRIS_Pos)                   /*!< NT_SPI2 SPI_MIS: RTRIS Mask             */
#define NT_SPI2_SPI_MIS_RXRIS_Pos             2                                                       /*!< NT_SPI2 SPI_MIS: RXRIS Position         */
#define NT_SPI2_SPI_MIS_RXRIS_Msk             (0x01UL << NT_SPI2_SPI_MIS_RXRIS_Pos)                   /*!< NT_SPI2 SPI_MIS: RXRIS Mask             */
#define NT_SPI2_SPI_MIS_TXRIS_Pos             3                                                       /*!< NT_SPI2 SPI_MIS: TXRIS Position         */
#define NT_SPI2_SPI_MIS_TXRIS_Msk             (0x01UL << NT_SPI2_SPI_MIS_TXRIS_Pos)                   /*!< NT_SPI2 SPI_MIS: TXRIS Mask             */

/* -------------------------------  NT_SPI2_SPI_ICR  ------------------------------ */
#define NT_SPI2_SPI_ICR_RORIC_Pos             0                                                       /*!< NT_SPI2 SPI_ICR: RORIC Position         */
#define NT_SPI2_SPI_ICR_RORIC_Msk             (0x01UL << NT_SPI2_SPI_ICR_RORIC_Pos)                   /*!< NT_SPI2 SPI_ICR: RORIC Mask             */
#define NT_SPI2_SPI_ICR_RTIC_Pos              1                                                       /*!< NT_SPI2 SPI_ICR: RTIC Position          */
#define NT_SPI2_SPI_ICR_RTIC_Msk              (0x01UL << NT_SPI2_SPI_ICR_RTIC_Pos)                    /*!< NT_SPI2 SPI_ICR: RTIC Mask              */

/* ------------------------------  NT_SPI2_SPI_DMACR  ----------------------------- */
#define NT_SPI2_SPI_DMACR_RXDMAE_Pos          0                                                       /*!< NT_SPI2 SPI_DMACR: RXDMAE Position      */
#define NT_SPI2_SPI_DMACR_RXDMAE_Msk          (0x01UL << NT_SPI2_SPI_DMACR_RXDMAE_Pos)                /*!< NT_SPI2 SPI_DMACR: RXDMAE Mask          */
#define NT_SPI2_SPI_DMACR_TXDMAE_Pos          1                                                       /*!< NT_SPI2 SPI_DMACR: TXDMAE Position      */
#define NT_SPI2_SPI_DMACR_TXDMAE_Msk          (0x01UL << NT_SPI2_SPI_DMACR_TXDMAE_Pos)                /*!< NT_SPI2 SPI_DMACR: TXDMAE Mask          */


/* ================================================================================ */
/* ================        struct 'NT_SPI3' Position & Mask        ================ */
/* ================================================================================ */


/* -------------------------------  NT_SPI3_SPI_CR0  ------------------------------ */
#define NT_SPI3_SPI_CR0_DSS_Pos               0                                                       /*!< NT_SPI3 SPI_CR0: DSS Position           */
#define NT_SPI3_SPI_CR0_DSS_Msk               (0x0fUL << NT_SPI3_SPI_CR0_DSS_Pos)                     /*!< NT_SPI3 SPI_CR0: DSS Mask               */
#define NT_SPI3_SPI_CR0_FRF_Pos               4                                                       /*!< NT_SPI3 SPI_CR0: FRF Position           */
#define NT_SPI3_SPI_CR0_FRF_Msk               (0x03UL << NT_SPI3_SPI_CR0_FRF_Pos)                     /*!< NT_SPI3 SPI_CR0: FRF Mask               */
#define NT_SPI3_SPI_CR0_SPO_Pos               6                                                       /*!< NT_SPI3 SPI_CR0: SPO Position           */
#define NT_SPI3_SPI_CR0_SPO_Msk               (0x01UL << NT_SPI3_SPI_CR0_SPO_Pos)                     /*!< NT_SPI3 SPI_CR0: SPO Mask               */
#define NT_SPI3_SPI_CR0_SPH_Pos               7                                                       /*!< NT_SPI3 SPI_CR0: SPH Position           */
#define NT_SPI3_SPI_CR0_SPH_Msk               (0x01UL << NT_SPI3_SPI_CR0_SPH_Pos)                     /*!< NT_SPI3 SPI_CR0: SPH Mask               */
#define NT_SPI3_SPI_CR0_SCR_Pos               8                                                       /*!< NT_SPI3 SPI_CR0: SCR Position           */
#define NT_SPI3_SPI_CR0_SCR_Msk               (0x000000ffUL << NT_SPI3_SPI_CR0_SCR_Pos)               /*!< NT_SPI3 SPI_CR0: SCR Mask               */

/* -------------------------------  NT_SPI3_SPI_CR1  ------------------------------ */
#define NT_SPI3_SPI_CR1_SSE_Pos               1                                                       /*!< NT_SPI3 SPI_CR1: SSE Position           */
#define NT_SPI3_SPI_CR1_SSE_Msk               (0x01UL << NT_SPI3_SPI_CR1_SSE_Pos)                     /*!< NT_SPI3 SPI_CR1: SSE Mask               */
#define NT_SPI3_SPI_CR1_MS_Pos                2                                                       /*!< NT_SPI3 SPI_CR1: MS Position            */
#define NT_SPI3_SPI_CR1_MS_Msk                (0x01UL << NT_SPI3_SPI_CR1_MS_Pos)                      /*!< NT_SPI3 SPI_CR1: MS Mask                */
#define NT_SPI3_SPI_CR1_SOD_Pos               3                                                       /*!< NT_SPI3 SPI_CR1: SOD Position           */
#define NT_SPI3_SPI_CR1_SOD_Msk               (0x01UL << NT_SPI3_SPI_CR1_SOD_Pos)                     /*!< NT_SPI3 SPI_CR1: SOD Mask               */

/* -------------------------------  NT_SPI3_SPI_DR  ------------------------------- */
#define NT_SPI3_SPI_DR_DATA_Pos               0                                                       /*!< NT_SPI3 SPI_DR: DATA Position           */
#define NT_SPI3_SPI_DR_DATA_Msk               (0x0000ffffUL << NT_SPI3_SPI_DR_DATA_Pos)               /*!< NT_SPI3 SPI_DR: DATA Mask               */

/* -------------------------------  NT_SPI3_SPI_SR  ------------------------------- */
#define NT_SPI3_SPI_SR_TFE_Pos                0                                                       /*!< NT_SPI3 SPI_SR: TFE Position            */
#define NT_SPI3_SPI_SR_TFE_Msk                (0x01UL << NT_SPI3_SPI_SR_TFE_Pos)                      /*!< NT_SPI3 SPI_SR: TFE Mask                */
#define NT_SPI3_SPI_SR_TNF_Pos                1                                                       /*!< NT_SPI3 SPI_SR: TNF Position            */
#define NT_SPI3_SPI_SR_TNF_Msk                (0x01UL << NT_SPI3_SPI_SR_TNF_Pos)                      /*!< NT_SPI3 SPI_SR: TNF Mask                */
#define NT_SPI3_SPI_SR_RNE_Pos                2                                                       /*!< NT_SPI3 SPI_SR: RNE Position            */
#define NT_SPI3_SPI_SR_RNE_Msk                (0x01UL << NT_SPI3_SPI_SR_RNE_Pos)                      /*!< NT_SPI3 SPI_SR: RNE Mask                */
#define NT_SPI3_SPI_SR_RFF_Pos                3                                                       /*!< NT_SPI3 SPI_SR: RFF Position            */
#define NT_SPI3_SPI_SR_RFF_Msk                (0x01UL << NT_SPI3_SPI_SR_RFF_Pos)                      /*!< NT_SPI3 SPI_SR: RFF Mask                */
#define NT_SPI3_SPI_SR_BSY_Pos                4                                                       /*!< NT_SPI3 SPI_SR: BSY Position            */
#define NT_SPI3_SPI_SR_BSY_Msk                (0x01UL << NT_SPI3_SPI_SR_BSY_Pos)                      /*!< NT_SPI3 SPI_SR: BSY Mask                */

/* ------------------------------  NT_SPI3_SPI_CPSR  ------------------------------ */
#define NT_SPI3_SPI_CPSR_CPSDVSR_Pos          0                                                       /*!< NT_SPI3 SPI_CPSR: CPSDVSR Position      */
#define NT_SPI3_SPI_CPSR_CPSDVSR_Msk          (0x000000ffUL << NT_SPI3_SPI_CPSR_CPSDVSR_Pos)          /*!< NT_SPI3 SPI_CPSR: CPSDVSR Mask          */

/* ------------------------------  NT_SPI3_SPI_IMSC  ------------------------------ */
#define NT_SPI3_SPI_IMSC_RORIM_Pos            0                                                       /*!< NT_SPI3 SPI_IMSC: RORIM Position        */
#define NT_SPI3_SPI_IMSC_RORIM_Msk            (0x01UL << NT_SPI3_SPI_IMSC_RORIM_Pos)                  /*!< NT_SPI3 SPI_IMSC: RORIM Mask            */
#define NT_SPI3_SPI_IMSC_RTIM_Pos             1                                                       /*!< NT_SPI3 SPI_IMSC: RTIM Position         */
#define NT_SPI3_SPI_IMSC_RTIM_Msk             (0x01UL << NT_SPI3_SPI_IMSC_RTIM_Pos)                   /*!< NT_SPI3 SPI_IMSC: RTIM Mask             */
#define NT_SPI3_SPI_IMSC_RXIM_Pos             2                                                       /*!< NT_SPI3 SPI_IMSC: RXIM Position         */
#define NT_SPI3_SPI_IMSC_RXIM_Msk             (0x01UL << NT_SPI3_SPI_IMSC_RXIM_Pos)                   /*!< NT_SPI3 SPI_IMSC: RXIM Mask             */
#define NT_SPI3_SPI_IMSC_TXIM_Pos             3                                                       /*!< NT_SPI3 SPI_IMSC: TXIM Position         */
#define NT_SPI3_SPI_IMSC_TXIM_Msk             (0x01UL << NT_SPI3_SPI_IMSC_TXIM_Pos)                   /*!< NT_SPI3 SPI_IMSC: TXIM Mask             */

/* -------------------------------  NT_SPI3_SPI_RIS  ------------------------------ */
#define NT_SPI3_SPI_RIS_RORRIS_Pos            0                                                       /*!< NT_SPI3 SPI_RIS: RORRIS Position        */
#define NT_SPI3_SPI_RIS_RORRIS_Msk            (0x01UL << NT_SPI3_SPI_RIS_RORRIS_Pos)                  /*!< NT_SPI3 SPI_RIS: RORRIS Mask            */
#define NT_SPI3_SPI_RIS_RTRIS_Pos             1                                                       /*!< NT_SPI3 SPI_RIS: RTRIS Position         */
#define NT_SPI3_SPI_RIS_RTRIS_Msk             (0x01UL << NT_SPI3_SPI_RIS_RTRIS_Pos)                   /*!< NT_SPI3 SPI_RIS: RTRIS Mask             */
#define NT_SPI3_SPI_RIS_RXRIS_Pos             2                                                       /*!< NT_SPI3 SPI_RIS: RXRIS Position         */
#define NT_SPI3_SPI_RIS_RXRIS_Msk             (0x01UL << NT_SPI3_SPI_RIS_RXRIS_Pos)                   /*!< NT_SPI3 SPI_RIS: RXRIS Mask             */
#define NT_SPI3_SPI_RIS_TXRIS_Pos             3                                                       /*!< NT_SPI3 SPI_RIS: TXRIS Position         */
#define NT_SPI3_SPI_RIS_TXRIS_Msk             (0x01UL << NT_SPI3_SPI_RIS_TXRIS_Pos)                   /*!< NT_SPI3 SPI_RIS: TXRIS Mask             */

/* -------------------------------  NT_SPI3_SPI_MIS  ------------------------------ */
#define NT_SPI3_SPI_MIS_RORRIS_Pos            0                                                       /*!< NT_SPI3 SPI_MIS: RORRIS Position        */
#define NT_SPI3_SPI_MIS_RORRIS_Msk            (0x01UL << NT_SPI3_SPI_MIS_RORRIS_Pos)                  /*!< NT_SPI3 SPI_MIS: RORRIS Mask            */
#define NT_SPI3_SPI_MIS_RTRIS_Pos             1                                                       /*!< NT_SPI3 SPI_MIS: RTRIS Position         */
#define NT_SPI3_SPI_MIS_RTRIS_Msk             (0x01UL << NT_SPI3_SPI_MIS_RTRIS_Pos)                   /*!< NT_SPI3 SPI_MIS: RTRIS Mask             */
#define NT_SPI3_SPI_MIS_RXRIS_Pos             2                                                       /*!< NT_SPI3 SPI_MIS: RXRIS Position         */
#define NT_SPI3_SPI_MIS_RXRIS_Msk             (0x01UL << NT_SPI3_SPI_MIS_RXRIS_Pos)                   /*!< NT_SPI3 SPI_MIS: RXRIS Mask             */
#define NT_SPI3_SPI_MIS_TXRIS_Pos             3                                                       /*!< NT_SPI3 SPI_MIS: TXRIS Position         */
#define NT_SPI3_SPI_MIS_TXRIS_Msk             (0x01UL << NT_SPI3_SPI_MIS_TXRIS_Pos)                   /*!< NT_SPI3 SPI_MIS: TXRIS Mask             */

/* -------------------------------  NT_SPI3_SPI_ICR  ------------------------------ */
#define NT_SPI3_SPI_ICR_RORIC_Pos             0                                                       /*!< NT_SPI3 SPI_ICR: RORIC Position         */
#define NT_SPI3_SPI_ICR_RORIC_Msk             (0x01UL << NT_SPI3_SPI_ICR_RORIC_Pos)                   /*!< NT_SPI3 SPI_ICR: RORIC Mask             */
#define NT_SPI3_SPI_ICR_RTIC_Pos              1                                                       /*!< NT_SPI3 SPI_ICR: RTIC Position          */
#define NT_SPI3_SPI_ICR_RTIC_Msk              (0x01UL << NT_SPI3_SPI_ICR_RTIC_Pos)                    /*!< NT_SPI3 SPI_ICR: RTIC Mask              */

/* ------------------------------  NT_SPI3_SPI_DMACR  ----------------------------- */
#define NT_SPI3_SPI_DMACR_RXDMAE_Pos          0                                                       /*!< NT_SPI3 SPI_DMACR: RXDMAE Position      */
#define NT_SPI3_SPI_DMACR_RXDMAE_Msk          (0x01UL << NT_SPI3_SPI_DMACR_RXDMAE_Pos)                /*!< NT_SPI3 SPI_DMACR: RXDMAE Mask          */
#define NT_SPI3_SPI_DMACR_TXDMAE_Pos          1                                                       /*!< NT_SPI3 SPI_DMACR: TXDMAE Position      */
#define NT_SPI3_SPI_DMACR_TXDMAE_Msk          (0x01UL << NT_SPI3_SPI_DMACR_TXDMAE_Pos)                /*!< NT_SPI3 SPI_DMACR: TXDMAE Mask          */


/* ================================================================================ */
/* ================      struct 'NT_USERFLASH' Position & Mask     ================ */
/* ================================================================================ */


/* ------------------------------  NT_USERFLASH_FMA  ------------------------------ */
#define NT_USERFLASH_FMA_ADDR_Pos             0                                                       /*!< NT_USERFLASH FMA: ADDR Position         */
#define NT_USERFLASH_FMA_ADDR_Msk             (0x0000ffffUL << NT_USERFLASH_FMA_ADDR_Pos)             /*!< NT_USERFLASH FMA: ADDR Mask             */

/* ------------------------------  NT_USERFLASH_FMD  ------------------------------ */
#define NT_USERFLASH_FMD_DATA_Pos             0                                                       /*!< NT_USERFLASH FMD: DATA Position         */
#define NT_USERFLASH_FMD_DATA_Msk             (0x000000ffUL << NT_USERFLASH_FMD_DATA_Pos)             /*!< NT_USERFLASH FMD: DATA Mask             */

/* ------------------------------  NT_USERFLASH_FMC  ------------------------------ */
#define NT_USERFLASH_FMC_WRITE_Pos            0                                                       /*!< NT_USERFLASH FMC: WRITE Position        */
#define NT_USERFLASH_FMC_WRITE_Msk            (0x01UL << NT_USERFLASH_FMC_WRITE_Pos)                  /*!< NT_USERFLASH FMC: WRITE Mask            */
#define NT_USERFLASH_FMC_PAGE_ERASE_Pos       1                                                       /*!< NT_USERFLASH FMC: PAGE_ERASE Position   */
#define NT_USERFLASH_FMC_PAGE_ERASE_Msk       (0x01UL << NT_USERFLASH_FMC_PAGE_ERASE_Pos)             /*!< NT_USERFLASH FMC: PAGE_ERASE Mask       */
#define NT_USERFLASH_FMC_FULL_ERASE_Pos       2                                                       /*!< NT_USERFLASH FMC: FULL_ERASE Position   */
#define NT_USERFLASH_FMC_FULL_ERASE_Msk       (0x01UL << NT_USERFLASH_FMC_FULL_ERASE_Pos)             /*!< NT_USERFLASH FMC: FULL_ERASE Mask       */
#define NT_USERFLASH_FMC_READ_Pos             3                                                       /*!< NT_USERFLASH FMC: READ Position         */
#define NT_USERFLASH_FMC_READ_Msk             (0x01UL << NT_USERFLASH_FMC_READ_Pos)                   /*!< NT_USERFLASH FMC: READ Mask             */
#define NT_USERFLASH_FMC_WRITE_IFB_Pos        4                                                       /*!< NT_USERFLASH FMC: WRITE_IFB Position    */
#define NT_USERFLASH_FMC_WRITE_IFB_Msk        (0x01UL << NT_USERFLASH_FMC_WRITE_IFB_Pos)              /*!< NT_USERFLASH FMC: WRITE_IFB Mask        */
#define NT_USERFLASH_FMC_PAGEERASE_IFB_Pos    5                                                       /*!< NT_USERFLASH FMC: PAGEERASE_IFB Position */
#define NT_USERFLASH_FMC_PAGEERASE_IFB_Msk    (0x01UL << NT_USERFLASH_FMC_PAGEERASE_IFB_Pos)          /*!< NT_USERFLASH FMC: PAGEERASE_IFB Mask    */
#define NT_USERFLASH_FMC_READ_IFB_Pos         6                                                       /*!< NT_USERFLASH FMC: READ_IFB Position     */
#define NT_USERFLASH_FMC_READ_IFB_Msk         (0x01UL << NT_USERFLASH_FMC_READ_IFB_Pos)               /*!< NT_USERFLASH FMC: READ_IFB Mask         */
#define NT_USERFLASH_FMC_MAGIC_KEY_Pos        16                                                      /*!< NT_USERFLASH FMC: MAGIC_KEY Position    */
#define NT_USERFLASH_FMC_MAGIC_KEY_Msk        (0x0000ffffUL << NT_USERFLASH_FMC_MAGIC_KEY_Pos)        /*!< NT_USERFLASH FMC: MAGIC_KEY Mask        */

/* ------------------------------  NT_USERFLASH_FCIS  ----------------------------- */
#define NT_USERFLASH_FCIS_OP_CMLT_Pos         0                                                       /*!< NT_USERFLASH FCIS: OP_CMLT Position     */
#define NT_USERFLASH_FCIS_OP_CMLT_Msk         (0x01UL << NT_USERFLASH_FCIS_OP_CMLT_Pos)               /*!< NT_USERFLASH FCIS: OP_CMLT Mask         */
#define NT_USERFLASH_FCIS_OP_ERROR_Pos        1                                                       /*!< NT_USERFLASH FCIS: OP_ERROR Position    */
#define NT_USERFLASH_FCIS_OP_ERROR_Msk        (0x01UL << NT_USERFLASH_FCIS_OP_ERROR_Pos)              /*!< NT_USERFLASH FCIS: OP_ERROR Mask        */

/* ------------------------------  NT_USERFLASH_FCIM  ----------------------------- */
#define NT_USERFLASH_FCIM_MASK_OPCMLT_Pos     0                                                       /*!< NT_USERFLASH FCIM: MASK_OPCMLT Position */
#define NT_USERFLASH_FCIM_MASK_OPCMLT_Msk     (0x01UL << NT_USERFLASH_FCIM_MASK_OPCMLT_Pos)           /*!< NT_USERFLASH FCIM: MASK_OPCMLT Mask     */

/* ------------------------------  NT_USERFLASH_FCIC  ----------------------------- */
#define NT_USERFLASH_FCIC_CLR_OPCMLT_Pos      0                                                       /*!< NT_USERFLASH FCIC: CLR_OPCMLT Position  */
#define NT_USERFLASH_FCIC_CLR_OPCMLT_Msk      (0x01UL << NT_USERFLASH_FCIC_CLR_OPCMLT_Pos)            /*!< NT_USERFLASH FCIC: CLR_OPCMLT Mask      */
#define NT_USERFLASH_FCIC_CLR_OPERROR_Pos     1                                                       /*!< NT_USERFLASH FCIC: CLR_OPERROR Position */
#define NT_USERFLASH_FCIC_CLR_OPERROR_Msk     (0x01UL << NT_USERFLASH_FCIC_CLR_OPERROR_Pos)           /*!< NT_USERFLASH FCIC: CLR_OPERROR Mask     */

/* -----------------------------  NT_USERFLASH_T_ACC  ----------------------------- */
#define NT_USERFLASH_T_ACC_T_ACC_Pos          0                                                       /*!< NT_USERFLASH T_ACC: T_ACC Position      */
#define NT_USERFLASH_T_ACC_T_ACC_Msk          (0xffffffffUL << NT_USERFLASH_T_ACC_T_ACC_Pos)          /*!< NT_USERFLASH T_ACC: T_ACC Mask          */

/* -----------------------------  NT_USERFLASH_T_NVS  ----------------------------- */
#define NT_USERFLASH_T_NVS_T_NVS_Pos          0                                                       /*!< NT_USERFLASH T_NVS: T_NVS Position      */
#define NT_USERFLASH_T_NVS_T_NVS_Msk          (0xffffffffUL << NT_USERFLASH_T_NVS_T_NVS_Pos)          /*!< NT_USERFLASH T_NVS: T_NVS Mask          */

/* -----------------------------  NT_USERFLASH_T_NVH  ----------------------------- */
#define NT_USERFLASH_T_NVH_T_NVH_Pos          0                                                       /*!< NT_USERFLASH T_NVH: T_NVH Position      */
#define NT_USERFLASH_T_NVH_T_NVH_Msk          (0xffffffffUL << NT_USERFLASH_T_NVH_T_NVH_Pos)          /*!< NT_USERFLASH T_NVH: T_NVH Mask          */

/* -----------------------------  NT_USERFLASH_T_RCV  ----------------------------- */
#define NT_USERFLASH_T_RCV_T_RCV_Pos          0                                                       /*!< NT_USERFLASH T_RCV: T_RCV Position      */
#define NT_USERFLASH_T_RCV_T_RCV_Msk          (0xffffffffUL << NT_USERFLASH_T_RCV_T_RCV_Pos)          /*!< NT_USERFLASH T_RCV: T_RCV Mask          */

/* -----------------------------  NT_USERFLASH_T_PGS  ----------------------------- */
#define NT_USERFLASH_T_PGS_T_PGS_Pos          0                                                       /*!< NT_USERFLASH T_PGS: T_PGS Position      */
#define NT_USERFLASH_T_PGS_T_PGS_Msk          (0xffffffffUL << NT_USERFLASH_T_PGS_T_PGS_Pos)          /*!< NT_USERFLASH T_PGS: T_PGS Mask          */

/* -----------------------------  NT_USERFLASH_T_PROG  ---------------------------- */
#define NT_USERFLASH_T_PROG_T_PROG_Pos        0                                                       /*!< NT_USERFLASH T_PROG: T_PROG Position    */
#define NT_USERFLASH_T_PROG_T_PROG_Msk        (0xffffffffUL << NT_USERFLASH_T_PROG_T_PROG_Pos)        /*!< NT_USERFLASH T_PROG: T_PROG Mask        */

/* -----------------------------  NT_USERFLASH_T_PGH  ----------------------------- */
#define NT_USERFLASH_T_PGH_T_PGH_Pos          0                                                       /*!< NT_USERFLASH T_PGH: T_PGH Position      */
#define NT_USERFLASH_T_PGH_T_PGH_Msk          (0xffffffffUL << NT_USERFLASH_T_PGH_T_PGH_Pos)          /*!< NT_USERFLASH T_PGH: T_PGH Mask          */

/* ----------------------------  NT_USERFLASH_T_ERASE  ---------------------------- */
#define NT_USERFLASH_T_ERASE_T_ERASE_Pos      0                                                       /*!< NT_USERFLASH T_ERASE: T_ERASE Position  */
#define NT_USERFLASH_T_ERASE_T_ERASE_Msk      (0xffffffffUL << NT_USERFLASH_T_ERASE_T_ERASE_Pos)      /*!< NT_USERFLASH T_ERASE: T_ERASE Mask      */

/* ------------------------------  NT_USERFLASH_T_ME  ----------------------------- */
#define NT_USERFLASH_T_ME_T_ME_Pos            0                                                       /*!< NT_USERFLASH T_ME: T_ME Position        */
#define NT_USERFLASH_T_ME_T_ME_Msk            (0xffffffffUL << NT_USERFLASH_T_ME_T_ME_Pos)            /*!< NT_USERFLASH T_ME: T_ME Mask            */

/* -----------------------------  NT_USERFLASH_T_NVH1  ---------------------------- */
#define NT_USERFLASH_T_NVH1_T_NVH1_Pos        0                                                       /*!< NT_USERFLASH T_NVH1: T_NVH1 Position    */
#define NT_USERFLASH_T_NVH1_T_NVH1_Msk        (0xffffffffUL << NT_USERFLASH_T_NVH1_T_NVH1_Pos)        /*!< NT_USERFLASH T_NVH1: T_NVH1 Mask        */


/* ================================================================================ */
/* ================         struct 'NT_RTC' Position & Mask        ================ */
/* ================================================================================ */


/* -------------------------------  NT_RTC_PSECONDS  ------------------------------ */
#define NT_RTC_PSECONDS_PART_SEC_Pos          0                                                       /*!< NT_RTC PSECONDS: PART_SEC Position      */
#define NT_RTC_PSECONDS_PART_SEC_Msk          (0x000003ffUL << NT_RTC_PSECONDS_PART_SEC_Pos)          /*!< NT_RTC PSECONDS: PART_SEC Mask          */

/* --------------------------------  NT_RTC_SECOND  ------------------------------- */
#define NT_RTC_SECOND_SECOND_Pos              0                                                       /*!< NT_RTC SECOND: SECOND Position          */
#define NT_RTC_SECOND_SECOND_Msk              (0x7fUL << NT_RTC_SECOND_SECOND_Pos)                    /*!< NT_RTC SECOND: SECOND Mask              */

/* --------------------------------  NT_RTC_MINUTE  ------------------------------- */
#define NT_RTC_MINUTE_MINUTE_Pos              0                                                       /*!< NT_RTC MINUTE: MINUTE Position          */
#define NT_RTC_MINUTE_MINUTE_Msk              (0x7fUL << NT_RTC_MINUTE_MINUTE_Pos)                    /*!< NT_RTC MINUTE: MINUTE Mask              */

/* ---------------------------------  NT_RTC_HOUR  -------------------------------- */
#define NT_RTC_HOUR_HOUR_Pos                  0                                                       /*!< NT_RTC HOUR: HOUR Position              */
#define NT_RTC_HOUR_HOUR_Msk                  (0x3fUL << NT_RTC_HOUR_HOUR_Pos)                        /*!< NT_RTC HOUR: HOUR Mask                  */

/* ---------------------------------  NT_RTC_WDAY  -------------------------------- */
#define NT_RTC_WDAY_DAYWEEK_Pos               0                                                       /*!< NT_RTC WDAY: DAYWEEK Position           */
#define NT_RTC_WDAY_DAYWEEK_Msk               (0x07UL << NT_RTC_WDAY_DAYWEEK_Pos)                     /*!< NT_RTC WDAY: DAYWEEK Mask               */

/* ---------------------------------  NT_RTC_DAY  --------------------------------- */
#define NT_RTC_DAY_DAY_Pos                    0                                                       /*!< NT_RTC DAY: DAY Position                */
#define NT_RTC_DAY_DAY_Msk                    (0x3fUL << NT_RTC_DAY_DAY_Pos)                          /*!< NT_RTC DAY: DAY Mask                    */

/* --------------------------------  NT_RTC_MONTH  -------------------------------- */
#define NT_RTC_MONTH_MONTH_Pos                0                                                       /*!< NT_RTC MONTH: MONTH Position            */
#define NT_RTC_MONTH_MONTH_Msk                (0x1fUL << NT_RTC_MONTH_MONTH_Pos)                      /*!< NT_RTC MONTH: MONTH Mask                */

/* ---------------------------------  NT_RTC_YEAR  -------------------------------- */
#define NT_RTC_YEAR_YEAR_Pos                  0                                                       /*!< NT_RTC YEAR: YEAR Position              */
#define NT_RTC_YEAR_YEAR_Msk                  (0x000000ffUL << NT_RTC_YEAR_YEAR_Pos)                  /*!< NT_RTC YEAR: YEAR Mask                  */

/* ---------------------------------  NT_RTC_SHDW  -------------------------------- */
#define NT_RTC_SHDW_UPDTEN_Pos                7                                                       /*!< NT_RTC SHDW: UPDTEN Position            */
#define NT_RTC_SHDW_UPDTEN_Msk                (0x01UL << NT_RTC_SHDW_UPDTEN_Pos)                      /*!< NT_RTC SHDW: UPDTEN Mask                */

/* ---------------------------------  NT_RTC_TIME  -------------------------------- */
#define NT_RTC_TIME_SPLIT_SEC_Pos             0                                                       /*!< NT_RTC TIME: SPLIT_SEC Position         */
#define NT_RTC_TIME_SPLIT_SEC_Msk             (0x000003ffUL << NT_RTC_TIME_SPLIT_SEC_Pos)             /*!< NT_RTC TIME: SPLIT_SEC Mask             */
#define NT_RTC_TIME_SECOND_Pos                10                                                      /*!< NT_RTC TIME: SECOND Position            */
#define NT_RTC_TIME_SECOND_Msk                (0x7fUL << NT_RTC_TIME_SECOND_Pos)                      /*!< NT_RTC TIME: SECOND Mask                */
#define NT_RTC_TIME_MINUTE_Pos                17                                                      /*!< NT_RTC TIME: MINUTE Position            */
#define NT_RTC_TIME_MINUTE_Msk                (0x7fUL << NT_RTC_TIME_MINUTE_Pos)                      /*!< NT_RTC TIME: MINUTE Mask                */
#define NT_RTC_TIME_HOUR_Pos                  24                                                      /*!< NT_RTC TIME: HOUR Position              */
#define NT_RTC_TIME_HOUR_Msk                  (0x3fUL << NT_RTC_TIME_HOUR_Pos)                        /*!< NT_RTC TIME: HOUR Mask                  */



/* ================================================================================ */
/* ================              Peripheral memory map             ================ */
/* ================================================================================ */

#define NT_ADC_BASE                     0x80000000UL
#define NT_GPIOA_BASE                   0x80010000UL
#define NT_GPIOB_BASE                   0x80011000UL
#define NT_GPIOC_BASE                   0x80012000UL
#define NT_GPIOD_BASE                   0x80013000UL
#define NT_GPIOE_BASE                   0x80014000UL
#define NT_GPIOF_BASE                   0x80015000UL
#define NT_GPIOG_BASE                   0x80016000UL
#define NT_GPIOH_BASE                   0x80017000UL
#define NT_COMMON_REG_BASE              0x80030000UL
#define NT_CAN_BASE                     0x80070000UL
#define NT_ETHERNET_BASE                0x80080000UL
#define NT_USBHost_BASE                 0x80090000UL
#define NT_USBDevice_BASE               0x80090000UL
#define NT_USBOTG_BASE                  0x80090704UL
#define NT_WDT_BASE                     0xA0000000UL
#define NT_I2C0_BASE                    0xA0001000UL
#define NT_I2C1_BASE                    0xA0002000UL
#define NT_TIMER0_BASE                  0xA0003000UL
#define NT_TIMER1_BASE                  0xA0004000UL
#define NT_TIMER2_BASE                  0xA0005000UL
#define NT_DMA_BASE                     0xA0006000UL
#define NT_PWM0_BASE                    0xA000B000UL
#define NT_PWM1_BASE                    0xA000C000UL
#define NT_PWM2_BASE                    0xA000D000UL
#define NT_PWM3_BASE                    0xA000E000UL
#define NT_PWM4_BASE                    0xA000F000UL
#define NT_PWM5_BASE                    0xA0010000UL
#define NT_PWM6_BASE                    0xA0011000UL
#define NT_PWM7_BASE                    0xA0012000UL
#define NT_PWM8_BASE                    0xA0013000UL
#define NT_CAP0_BASE                    0xA0014000UL
#define NT_CAP1_BASE                    0xA0015000UL
#define NT_CAP2_BASE                    0xA0016000UL
#define NT_CAP3_BASE                    0xA0017000UL
#define NT_CAP4_BASE                    0xA0018000UL
#define NT_CAP5_BASE                    0xA0019000UL
#define NT_QEP0_BASE                    0xA001A000UL
#define NT_QEP1_BASE                    0xA001B000UL
#define NT_BOOTFLASH_BASE               0xA001C000UL
#define NT_UART0_BASE                   0xA0007000UL
#define NT_UART1_BASE                   0xA0008000UL
#define NT_UART2_BASE                   0xA0009000UL
#define NT_UART3_BASE                   0xA000A000UL
#define NT_CMP_BASE                     0xA001D000UL
#define NT_SPI0_BASE                    0xA001E000UL
#define NT_SPI1_BASE                    0xA001F000UL
#define NT_SPI2_BASE                    0xA0020000UL
#define NT_SPI3_BASE                    0xA0021000UL
#define NT_USERFLASH_BASE               0xA0022000UL
#define NT_RTC_BASE                     0xA0023000UL


/* ================================================================================ */
/* ================             Peripheral declaration             ================ */
/* ================================================================================ */

#define NT_ADC                          ((NT_ADC_Type             *) NT_ADC_BASE)
#define NT_GPIOA                        ((NT_GPIOA_Type           *) NT_GPIOA_BASE)
#define NT_GPIOB                        ((NT_GPIOA_Type           *) NT_GPIOB_BASE)
#define NT_GPIOC                        ((NT_GPIOA_Type           *) NT_GPIOC_BASE)
#define NT_GPIOD                        ((NT_GPIOA_Type           *) NT_GPIOD_BASE)
#define NT_GPIOE                        ((NT_GPIOA_Type           *) NT_GPIOE_BASE)
#define NT_GPIOF                        ((NT_GPIOA_Type           *) NT_GPIOF_BASE)
#define NT_GPIOG                        ((NT_GPIOA_Type           *) NT_GPIOG_BASE)
#define NT_GPIOH                        ((NT_GPIOA_Type           *) NT_GPIOH_BASE)
#define NT_COMMON_REG                   ((NT_COMMON_REG_Type      *) NT_COMMON_REG_BASE)
#define NT_CAN                          ((NT_CAN_Type             *) NT_CAN_BASE)
#define NT_ETHERNET                     ((NT_ETHERNET_Type        *) NT_ETHERNET_BASE)
#define NT_USBHost                      ((NT_USBHost_Type         *) NT_USBHost_BASE)
#define NT_USBDevice                    ((NT_USBDevice_Type       *) NT_USBDevice_BASE)
#define NT_USBOTG                       ((NT_USBOTG_Type          *) NT_USBOTG_BASE)
#define NT_WDT                          ((NT_WDT_Type             *) NT_WDT_BASE)
#define NT_I2C0                         ((NT_I2C0_Type            *) NT_I2C0_BASE)
#define NT_I2C1                         ((NT_I2C0_Type            *) NT_I2C1_BASE)
#define NT_TIMER0                       ((NT_TIMER0_Type          *) NT_TIMER0_BASE)
#define NT_TIMER1                       ((NT_TIMER0_Type          *) NT_TIMER1_BASE)
#define NT_TIMER2                       ((NT_TIMER0_Type          *) NT_TIMER2_BASE)
#define NT_DMA                          ((NT_DMA_Type             *) NT_DMA_BASE)
#define NT_PWM0                         ((NT_PWM0_Type            *) NT_PWM0_BASE)
#define NT_PWM1                         ((NT_PWM0_Type            *) NT_PWM1_BASE)
#define NT_PWM2                         ((NT_PWM0_Type            *) NT_PWM2_BASE)
#define NT_PWM3                         ((NT_PWM0_Type            *) NT_PWM3_BASE)
#define NT_PWM4                         ((NT_PWM0_Type            *) NT_PWM4_BASE)
#define NT_PWM5                         ((NT_PWM0_Type            *) NT_PWM5_BASE)
#define NT_PWM6                         ((NT_PWM0_Type            *) NT_PWM6_BASE)
#define NT_PWM7                         ((NT_PWM0_Type            *) NT_PWM7_BASE)
#define NT_PWM8                         ((NT_PWM0_Type            *) NT_PWM8_BASE)
#define NT_CAP0                         ((NT_CAP0_Type            *) NT_CAP0_BASE)
#define NT_CAP1                         ((NT_CAP0_Type            *) NT_CAP1_BASE)
#define NT_CAP2                         ((NT_CAP0_Type            *) NT_CAP2_BASE)
#define NT_CAP3                         ((NT_CAP0_Type            *) NT_CAP3_BASE)
#define NT_CAP4                         ((NT_CAP0_Type            *) NT_CAP4_BASE)
#define NT_CAP5                         ((NT_CAP0_Type            *) NT_CAP5_BASE)
#define NT_QEP0                         ((NT_QEP0_Type            *) NT_QEP0_BASE)
#define NT_QEP1                         ((NT_QEP0_Type            *) NT_QEP1_BASE)
#define NT_BOOTFLASH                    ((NT_BOOTFLASH_Type       *) NT_BOOTFLASH_BASE)
#define NT_UART0                        ((NT_UART0_Type           *) NT_UART0_BASE)
#define NT_UART1                        ((NT_UART0_Type           *) NT_UART1_BASE)
#define NT_UART2                        ((NT_UART0_Type           *) NT_UART2_BASE)
#define NT_UART3                        ((NT_UART0_Type           *) NT_UART3_BASE)
#define NT_CMP                          ((NT_CMP_Type             *) NT_CMP_BASE)
#define NT_SPI0                         ((NT_SPI0_Type            *) NT_SPI0_BASE)
#define NT_SPI1                         ((NT_SPI0_Type            *) NT_SPI1_BASE)
#define NT_SPI2                         ((NT_SPI0_Type            *) NT_SPI2_BASE)
#define NT_SPI3                         ((NT_SPI0_Type            *) NT_SPI3_BASE)
#define NT_USERFLASH                    ((NT_USERFLASH_Type       *) NT_USERFLASH_BASE)
#define NT_RTC                          ((NT_RTC_Type             *) NT_RTC_BASE)


/** @} */ /* End of group Device_Peripheral_Registers */
/** @} */ /* End of group K1921BK01T */
/** @} */ /* End of group NIIET */

#ifdef __cplusplus
}
#endif


#endif  /* K1921BK01T_H */

